smalltalk.addClass("Object",nil,nil,"Kernel")
smalltalk.addClass("Smalltalk",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Behavior",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Class",smalltalk.Behavior,nil,"Kernel")
smalltalk.addClass("Metaclass",smalltalk.Behavior,["instanceClass"],"Kernel")
smalltalk.addClass("CompiledMethod",smalltalk.Object,["classField"],"Kernel")
smalltalk.addClass("Number",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("BlockClosure",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Boolean",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("DateTime",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("UndefinedObject",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Collection",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("SequenceableCollection",smalltalk.Collection,nil,"Kernel")
smalltalk.addClass("String",smalltalk.SequenceableCollection,nil,"Kernel")
smalltalk.addClass("Array",smalltalk.SequenceableCollection,nil,"Kernel")
smalltalk.addClass("ArrayedContents",smalltalk.SequenceableCollection,["contents"],"Kernel")
smalltalk.addClass("ComposedAssociations",smalltalk.ArrayedContents,nil,"Kernel")
smalltalk.addClass("ComposedObjects",smalltalk.ArrayedContents,["species"],"Kernel")
smalltalk.addClass("Interval",smalltalk.Collection,["start","end","step","value"],"Kernel")
smalltalk.addClass("Set",smalltalk.Collection,["contents"],"Kernel")
smalltalk.addClass("HashedSet",smalltalk.Set,["hash"],"Kernel")
smalltalk.addClass("KeyedCollection",smalltalk.Collection,nil,"Kernel")
smalltalk.addClass("Dictionary",smalltalk.KeyedCollection,["keys","values"],"Kernel")
smalltalk.addClass("PoolDictionary",smalltalk.KeyedCollection,["hash","size"],"Kernel")
smalltalk.addClass("RegularExpression",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Exception",smalltalk.Object,["messageText"],"Kernel")
smalltalk.addClass("Error",smalltalk.Exception,nil,"Kernel")
smalltalk.addClass("MessageNotUnderstood",smalltalk.Error,["message","receiver"],"Kernel")
smalltalk.addClass("Association",smalltalk.Object,["key","value"],"Kernel")
smalltalk.addClass("ClassBuilder",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Stream",smalltalk.Object,["collection","position","readLimit"],"Kernel")
smalltalk.addClass("StringStream",smalltalk.Stream,nil,"Kernel")
smalltalk.addClass("StringWriteStream",smalltalk.Stream,nil,"Kernel")
smalltalk.addClass("Random",smalltalk.Object,nil,"Kernel")
smalltalk.addClass("Point",smalltalk.Object,["x","y"],"Kernel")
smalltalk.addClass("Rectangle",smalltalk.Object,["leftTop","rightBottom"],"Kernel")
smalltalk.addClass("EvaluableAction",smalltalk.Object,nil,"Kernel")
setattr(smalltalk.EvaluableAction,"$comment","""
	Action model, evaluable and composable actions are implemented to support evaluations.
""")
smalltalk.addClass("Message",smalltalk.EvaluableAction,["selector","arguments","receiver"],"Kernel")
smalltalk.addClass("LinkMessage",smalltalk.Message,["resultAction"],"Kernel")
setattr(smalltalk.LinkMessage,"$comment","""
	Implement evaluation cascading argument evaluations.""")
smalltalk.addClass("ActionSequence",smalltalk.Object,["contents"],"Kernel")
smalltalk.addClass("EventManager",smalltalk.Object,["handlers"],"Kernel")
setattr(smalltalk.EventManager,"$comment","""
	Event system, properties and change/update/release mechanism.
	We hook $properties and $handlers internal properties to manage properties and events at Object level.
	EventManager instances implement events handler as pure instance variable.
""")
smalltalk.setVarNames(smalltalk.EventManager.__class__,smalltalk.newArray(["eventsTriggered"]))
smalltalk.addClass("S8Encoder",smalltalk.EventManager,["compiler"],"Compiler-Encoding")
smalltalk.addClass("OptimizingEncoder",smalltalk.S8Encoder,["optimizationMap","knownOptimizations","inlines"],"Compiler-Encoding")
smalltalk.setVarNames(smalltalk.OptimizingEncoder.__class__,smalltalk.newArray(["inlines"]))
smalltalk.addClass("NativeEncoder",smalltalk.OptimizingEncoder,["stream","startOffset","nestedBlocks","earlyReturn","functionName"],"Compiler-Encoding")
smalltalk.addClass("JSEncoder",smalltalk.NativeEncoder,nil,"JS")
smalltalk.addClass("PythonEncoder",smalltalk.NativeEncoder,["indentation","blocks","scopes"],"Python")
smalltalk.addClass("Compiler",smalltalk.EventManager,["currentClass","selector","encoder","unknownVariables","tempVariables","transformers","useTemplates"],"Compiler")
smalltalk.addClass("SourceCodeParser",smalltalk.EventManager,nil,"Compiler-Parsing")
smalltalk.addClass("SmalltalkParser",smalltalk.SourceCodeParser,nil,"Compiler-Parsing")
smalltalk.addClass("MethodReferences",smalltalk.EventManager,["rootClasses","results"],"Tools-references")
smalltalk.addClass("SystemManager",smalltalk.EventManager,nil,"Snapshot")
setattr(smalltalk.SystemManager,"$classVariableNames","Current")
smalltalk.addClass("SystemChangesManager",smalltalk.EventManager,["systemChanges"],"SystemServer")
smalltalk.addClass("SystemServer",smalltalk.SystemChangesManager,["server","port","methodReferences","cache"],"SystemServer")
smalltalk.setVarNames(smalltalk.SystemServer.__class__,smalltalk.newArray(["current","silent","platform","port"]))
smalltalk.addClass("TestServer",smalltalk.EventManager,["host","port","server","requestHandler"],"pyServer")
smalltalk.addClass("CompilerNode",smalltalk.Object,["nodes","start","end","annotations","client"],"Compiler-Nodes")
smalltalk.addClass("MethodNode",smalltalk.CompilerNode,["selector","arguments","source"],"Compiler-Nodes")
smalltalk.addClass("SendNode",smalltalk.CompilerNode,["selector","arguments","receiver","action"],"Compiler-Nodes")
smalltalk.addClass("ScopedNode",smalltalk.CompilerNode,nil,"Compiler-Nodes")
smalltalk.addClass("CascadeNode",smalltalk.ScopedNode,["receiver"],"Compiler-Nodes")
smalltalk.addClass("BlockNode",smalltalk.ScopedNode,["parameters"],"Compiler-Nodes")
smalltalk.addClass("SequenceNode",smalltalk.ScopedNode,["temps"],"Compiler-Nodes")
smalltalk.addClass("BlockSequenceNode",smalltalk.SequenceNode,nil,"Compiler-Nodes")
smalltalk.addClass("ExtendedSequenceNode",smalltalk.SequenceNode,["directives"],"Compiler-Nodes")
smalltalk.addClass("AssignmentNode",smalltalk.CompilerNode,["left","right"],"Compiler-Nodes")
smalltalk.addClass("ReturnNode",smalltalk.CompilerNode,["exitBlock"],"Compiler-Nodes")
smalltalk.addClass("ValueNode",smalltalk.CompilerNode,["value","binding"],"Compiler-Nodes")
smalltalk.addClass("VariableNode",smalltalk.ValueNode,["indices"],"Compiler-Nodes")
smalltalk.addClass("GlobalReferenceNode",smalltalk.VariableNode,nil,"Compiler-Nodes")
smalltalk.addClass("NoReceiverNode",smalltalk.VariableNode,nil,"Compiler-Nodes")
smalltalk.addClass("AlienNode",smalltalk.VariableNode,nil,"Compiler-Nodes")
smalltalk.addClass("InlineNode",smalltalk.CompilerNode,["sources"],"Compiler-Nodes")
smalltalk.addClass("DirectiveNode",smalltalk.CompilerNode,nil,"Compiler-Nodes")
smalltalk.addClass("JSDirectiveNode",smalltalk.DirectiveNode,["code","protected"],"Compiler-Nodes")
smalltalk.addClass("InlineOptimizationNode",smalltalk.DirectiveNode,["args","remove"],"Compiler-Nodes")
smalltalk.addClass("PPFailure",smalltalk.Object,["position","reason"],"Compiler-Parsing")
smalltalk.addClass("PPParser",smalltalk.Object,["memo"],"Compiler-Parsing")
smalltalk.addClass("PPEOFParser",smalltalk.PPParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPAnyParser",smalltalk.PPParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPEpsilonParser",smalltalk.PPParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPStringParser",smalltalk.PPParser,["string"],"Compiler-Parsing")
smalltalk.addClass("PPStStringParser",smalltalk.PPParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPCharacterParser",smalltalk.PPParser,["regexp","theString"],"Compiler-Parsing")
setattr(smalltalk.PPCharacterParser,"$classVariableNames","RegExpCache")
smalltalk.addClass("PPListParser",smalltalk.PPParser,["parsers"],"Compiler-Parsing")
smalltalk.addClass("PPSequenceParser",smalltalk.PPListParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPChoiceParser",smalltalk.PPListParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPDelegateParser",smalltalk.PPParser,["parser"],"Compiler-Parsing")
smalltalk.addClass("PPAndParser",smalltalk.PPDelegateParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPNotParser",smalltalk.PPAndParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPActionParser",smalltalk.PPDelegateParser,["block"],"Compiler-Parsing")
smalltalk.addClass("PPFlattenParser",smalltalk.PPDelegateParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPSourceParser",smalltalk.PPDelegateParser,nil,"Compiler-Parsing")
smalltalk.addClass("PPRepeatingParser",smalltalk.PPDelegateParser,["min"],"Compiler-Parsing")
smalltalk.addClass("PPInlineParser",smalltalk.PPParser,["terminator"],"Compiler-Parsing")
smalltalk.addClass("FileInReader",smalltalk.Object,nil,"Tools-fileIn")
setattr(smalltalk.FileInReader,"$comment","""
	Perform sequential reading from aStream in chunk format.
	Instances implement #scanFrom: message, advancing aStream upto next reader instantiation chunk.""")
smalltalk.addClass("ChunkReader",smalltalk.FileInReader,["actionBlock","terminationBlock"],"Tools-fileIn")
setattr(smalltalk.ChunkReader,"$comment","""
	Pluggable FileInReader.
	actionBlock is evaluated with input stream as argument.
	Read chunks until empty chunk, terminationBlock is nil or evaluates to true.""")
smalltalk.addClass("ClassCategoryReader",smalltalk.FileInReader,["class","category","stamp"],"Tools-fileIn")
smalltalk.addClass("ClassCommentReader",smalltalk.FileInReader,["class"],"Tools-fileIn")
smalltalk.addClass("SkipFileInReader",smalltalk.FileInReader,["limit"],"Tools-fileIn")
smalltalk.addClass("AssociationsReader",smalltalk.FileInReader,nil,"Tools-fileIn")
smalltalk.addClass("PoolDictionaryReader",smalltalk.AssociationsReader,["scope"],"Tools-fileIn")
smalltalk.addClass("NativeReader",smalltalk.AssociationsReader,["object"],"Tools-fileIn")
smalltalk.addClass("Exporter",smalltalk.Object,["encoder"],"Tools-fileOut")
smalltalk.addClass("APIBuilder",smalltalk.Object,["parents","token","bound"],"Builders")
smalltalk.setVarNames(smalltalk.APIBuilder.__class__,smalltalk.newArray(["default","saveBuilders"]))
smalltalk.addClass("Snapshot",smalltalk.Object,nil,"Snapshot")
setattr(smalltalk.Snapshot,"$comment","""
	Dump a binary representation of this S8 system onto an image (String).
	The default implementation export full/runnable images containing boot sections.
	The subclasses can refine behavior to select/customize exports and format.
	@2011-2018 Alejandro Reimondo aleReimondo@smalltalking.net""")
smalltalk.addClass("Transcript",smalltalk.Object,["streams"],"Transcript")
setattr(smalltalk.Transcript,"$comment","""
	Implement Transcript streamming.
	This implementation emmit output delegating onto stream instances.
	The streams must understand #cr and #nextPutAll:
""")
setattr(smalltalk.Transcript,"$classVariableNames","Current")
smalltalk.addClass("NativeObject",smalltalk.Object,["handle"],"Natives")
setattr(smalltalk.NativeObject,"$comment","""
	Wrapper to native object.
	@2011 Alejandro F. Reimondo
	aleReimondo@smalltalking.net
""")
smalltalk.addClass("NativeHandle",smalltalk.NativeObject,nil,"Natives")
setattr(smalltalk.NativeHandle,"$comment","""
	Wrapper for native objects.
	@2018 Alejandro F. Reimondo
	aleReimondo@smalltalking.net
""")
smalltalk.addClass("JS",smalltalk.NativeHandle,nil,"JS")
setattr(smalltalk.JS,"$comment","""
	Implementation of wrappers to native Javascript objects.
	@2011 Alejandro F. Reimondo
	aleReimondo@smalltalking.net""")
smalltalk.addClass("Python",smalltalk.NativeHandle,nil,"Python")
smalltalk.addClass("NativeLibraryObject",smalltalk.NativeObject,nil,"JS")
setattr(smalltalk.NativeLibraryObject,"$comment","""
	Abstract wrapper to javascript external library.
	@2012 Alejandro Reimondo - aleReimondo@smalltalking.net
""")
setattr(smalltalk.NativeLibraryObject,"$classVariableNames","BindingListeners")
smalltalk.addClass("Json",smalltalk.Object,nil,"pyServer")

smalltalk.bind(smalltalk.Object.__class__,"eventsTriggered",0
,smalltalk.__f__("""(self):
	#Object class>>#eventsTriggered
	return self.constructEventsTriggered() 
""","Object_class_eventsTriggered")
,"events","""eventsTriggered
	" Return all the events managed by instances of the receiver. "

	^self constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.Object.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#Object class>>#constructEventsTriggered
	return smalltalk.newArray(["changed"]) 
""","Object_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver.
	The default implementation return support for MVC change/update mechanism.
	This method can be refined by the subclasses to extend event support.
	"

	^#( #changed )""",nil)
smalltalk.bind(smalltalk.Object.__class__,"canTriggerEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object class>>#canTriggerEvent:
	return self.eventsTriggered().includes_(selector) 
""","Object_class_canTriggerEvent_")
,"events","""canTriggerEvent: selector
	" Return true if instances of the receiver can trigger event."

	^self eventsTriggered includes: selector """,nil)
smalltalk.bind(smalltalk.Object.__class__,"test_SuperInstanceSend",0
,smalltalk.__f__("""(self):
	#Object class>>#test_SuperInstanceSend
	return (smalltalk.Object).__class__ 
""","Object_class_test_SuperInstanceSend")
,"_tests_","""test_SuperInstanceSend	"
	PythonEncoder export: Object class>>#test_SuperInstanceSend
	"
	^Object class """,nil)
smalltalk.bind(smalltalk.Object,"print:",0
,smalltalk.__f__("""(self,aString):
	#Object>>#print:
	__0__=smalltalk.newContext()
	__0__.aBlock=nil
	__0__.aBlock=smalltalk.basic_at_(smalltalk.Object,smalltalk.String("printBlock")) 
	if smalltalk.b(smalltalk.isNil_(__0__.aBlock)):
		print(aString) 
	else:
		__0__.aBlock.value_(aString) 
	 
	return self 
""","Object_print_")
,"printing","""print: aString
	" Output aString to output device. "

	| aBlock |
	aBlock := Object basicAt: #printBlock.
	aBlock isNil
		ifTrue: [ # #print: aString ]
		ifFalse: [ aBlock value: aString ]""",nil)
smalltalk.bind(smalltalk.Object,"fileIn:",0
,smalltalk.__f__("""(self,fileName):
	#Object>>#fileIn:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('fileIn("'),fileName),smalltalk.String('")'))) 
	return fileIn(fileName) 
""","Object_fileIn_")
,"Python-fileIn","""fileIn: fileName
	" FileIn contents of file at fileName. "

	self note: 'fileIn("', fileName, '")'.
	^# #fileIn: fileName""",nil)
smalltalk.bind(smalltalk.Object,"fileInJS:",0
,smalltalk.__f__("""(self,fileName):
	#Object>>#fileInJS:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('fileInJS("'),fileName),smalltalk.String('")'))) 
	return fileInJS(fileName) 
""","Object_fileInJS_")
,"Python-fileIn","""fileInJS: fileName
	" Load native code from file at fileName. "

	self note: 'fileInJS("', fileName, '")'.
	^# #fileInJS: fileName""",nil)
smalltalk.bind(smalltalk.Object,"smalltalk",0
,smalltalk.__f__("""(self):
	#Object>>#smalltalk
	def __blk1__():
		return smalltalk.Smalltalk.current() 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$smalltalk"),smalltalk.blk(__blk1__,0)) 
""","Object_smalltalk")
,"system","""smalltalk
	" Private - Return the hosting context of the receiver.
	The smalltalk host is used for evaluations in the receiver. "

	^self basicAt: '$smalltalk' ifAbsent: [ Smalltalk current ]""",nil)
smalltalk.bind(smalltalk.Object,"nativeLanguage",0
,smalltalk.__f__("""(self):
	#Object>>#nativeLanguage
	def __blk1__():
		return smalltalk.String("js") 
	return smalltalk.basic_at_ifAbsent_(self.smalltalk(),smalltalk.String("$nativeLanguage"),smalltalk.blk(__blk1__,0)) 
""","Object_nativeLanguage")
,"environment","""nativeLanguage
	" Private - Return the native language of the host. "

	^self smalltalk
		basicAt: '$nativeLanguage'
		ifAbsent: [ #js ]""",nil)
smalltalk.bind(smalltalk.Object,"halt",0
,smalltalk.__f__("""(self):
	#Object>>#halt
	import pdb; pdb.set_trace() 
	return self 
""","Object_halt")
,"debug","""halt
	" Private - Halt execution entering debugger. "

	{''js'debugger'}""",nil)
smalltalk.bind(smalltalk.Object,"note:",0
,smalltalk.__f__("""(self,aString):
	#Object>>#note:
	self.print_(smalltalk.asString_(aString).asComment()) 
	return self 
""","Object_note_")
,"development","""note: aString
	" Print a note (aString) to the user. "

	self print: aString asString asComment""",nil)
smalltalk.bind(smalltalk.Object,"notImplementedYet",0
,smalltalk.__f__("""(self):
	#Object>>#notImplementedYet
	self.error_(smalltalk.String("Not implemented. Yet").halt()) 
	return self 
""","Object_notImplementedYet")
,"development","""notImplementedYet
	" Private - Halt execution and/or generate an error reporting implementation incomplete. "

	self error: 'Not implemented. Yet' halt""",nil)
smalltalk.bind(smalltalk.Object,"notImplementedYet:",0
,smalltalk.__f__("""(self,aSelector):
	#Object>>#notImplementedYet:
	self.error_(smalltalk.object_comma_(aSelector.asLiteral(),smalltalk.String(" Not implemented. Yet").halt())) 
	return self 
""","Object_notImplementedYet_")
,"development","""notImplementedYet: aSelector
	" Private - Halt execution and/or generate an error reporting implementation incomplete. "

	self error: aSelector asLiteral ,' Not implemented. Yet' halt""",nil)
smalltalk.bind(smalltalk.Object,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#Object>>#=
	return smalltalk.b_(self is anObject) 
""","Object__eq")
,"comparing","""= anObject
	" Return true if the receiver is equal to argument. "

	^self == anObject""",nil)
smalltalk.bind(smalltalk.Object,"~=","_no_eq"
,smalltalk.__f__("""(self,anObject):
	#Object>>#~=
	return smalltalk.b_(smalltalk.isObject_equalTo_(self,anObject) is smalltalk.false) 
""","Object__no_eq")
,"comparing","""~= anObject
	" Return true if the receiver is not equal to anObject. "

	^(self = anObject) == false""",nil)
smalltalk.bind(smalltalk.Object,"initialize",0
,smalltalk.__f__("""(self):
	#Object>>#initialize
	return self 
""","Object_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver.
	The default implementation do nothing.
	This method can be refined by subclasses to support creation time initialization of collaborators.
	\"""",nil)
smalltalk.bind(smalltalk.Object,"yourself",0
,smalltalk.__f__("""(self):
	#Object>>#yourself
	return self 
""","Object_yourself")
,"identity","""yourself
	" Return the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Object,"species",0
,smalltalk.__f__("""(self):
	#Object>>#species
	return (self).__class__ 
""","Object_species")
,"species","""species
	" Return the species to instantiate objects like the receiver. "

	^self class """,nil)
smalltalk.bind(smalltalk.Object,"class","_8class"
,smalltalk.__f__("""(self):
	#Object>>#class
	def __blk1__():
		return self.klass() 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$klass"),smalltalk.blk(__blk1__,0)) 
""","Object__8class")
,"accessing","""class
	" Return the class of the receiver. "

	^self basicAt: '$klass' ifAbsent: [ self klass ]""",nil)
smalltalk.bind(smalltalk.Object,"size",0
,smalltalk.__f__("""(self):
	#Object>>#size
	return smalltalk.Number(0) 
""","Object_size")
,"accessing","""size
	" Return the size of the receiver.
	The default implementation return zero.
	This method can be refined by subclasses to support indexed access.
	"

	^0""",nil)
smalltalk.bind(smalltalk.Object,"copy",0
,smalltalk.__f__("""(self):
	#Object>>#copy
	return self.shallowCopy() 
""","Object_copy")
,"copying","""copy
	" Return a copy of the receiver. "

	^self shallowCopy""",nil)
smalltalk.bind(smalltalk.Object,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Object>>#shallowCopy
	__0__=smalltalk.newContext()
	def __blk1__(instVarName):
		return smalltalk.basic_at_put_(__0__.result,smalltalk.object_comma_(smalltalk.String("@"),instVarName),smalltalk.basic_at_(self,smalltalk.object_comma_(smalltalk.String("@"),instVarName))) 
	__0__.result=nil
	__0__.result=(self).__class__.basicNew() 
	(self).__class__.allInstVarNamesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Object_shallowCopy")
,"copying","""shallowCopy
	" Return a deep copy of the receiver. "

	| result |
	result := self class basicNew.
	self class allInstVarNamesDo: [:instVarName|
		result	basicAt: $@,instVarName
			put: (self basicAt: $@,instVarName)
	].
	^result""",nil)
smalltalk.bind(smalltalk.Object,"deepCopyOf:",0
,smalltalk.__f__("""(self,what):
	#Object>>#deepCopyOf:
	if smalltalk.b(smalltalk.isNil_(what)):
		return what 
	 
	if smalltalk.b(self.isObject_(what)):
		return what.deepCopy() 
	 
	return what 
""","Object_deepCopyOf_")
,"copying","""deepCopyOf: what
	" Private - Return a deep copy of what. "

	what isNil ifTrue: [ ^what ].
	(self isObject: what) ifTrue: [ ^what deepCopy ].
	^what""",nil)
smalltalk.bind(smalltalk.Object,"deepCopy",0
,smalltalk.__f__("""(self):
	#Object>>#deepCopy
	__0__=smalltalk.newContext()
	def __blk1__(iv):
		__0__.value=self.deepCopyOf_(smalltalk.basic_at_(self,smalltalk.object_comma_(smalltalk.String("@"),iv))) 
		return smalltalk.basic_at_put_(__0__.result,smalltalk.object_comma_(smalltalk.String("@"),iv),__0__.value) 
	__0__.result=nil
	__0__.value=nil
	__0__.result=(self).__class__.basicNew() 
	(self).__class__.allInstVarNamesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Object_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	| result value |
	result := self class basicNew.
	self class allInstVarNamesDo: [:iv|
		value := self deepCopyOf: (self basicAt: $@,iv).
		result basicAt: $@,iv put: value
	].
	^result""",nil)
smalltalk.bind(smalltalk.Object,"->","_minus_gt"
,smalltalk.__f__("""(self,anObject):
	#Object>>#->
	return smalltalk.Association.key_value_(self,anObject) 
""","Object__minus_gt")
,"converting","""-> anObject
	" Return an association of the receiver to anObject. "

	^Association key: self value: anObject""",nil)
smalltalk.bind(smalltalk.Object,"asString",0
,smalltalk.__f__("""(self):
	#Object>>#asString
	return smalltalk.printString_(self) 
""","Object_asString")
,"converting","""asString
	" Return the receiver represented as String. "

	^self printString""",nil)
smalltalk.bind(smalltalk.Object,"toString",0
,smalltalk.__f__("""(self):
	#Object>>#toString
	if self.__class__ == smalltalk.String or self.__class__ == smalltalk.Number: return smalltalk.stObject().toString(self) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("{st:a"),(self).__class__.name()),smalltalk.String("}")) 
""","Object_toString")
,"converting","""toString
	" Return the receiver as a String. "

	{'self'}."macro hook"
	^'{st:a',self class name,$}""",nil)
smalltalk.bind(smalltalk.Object,"toString:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#toString:
	if smalltalk.b(smalltalk.isNil_(anObject)):
		return smalltalk.String("nil") 
	 
	if smalltalk.b(self.isObject_(anObject)):
		return smalltalk.to_String(anObject) 
	 
	return smalltalk.String(str(anObject)) 
""","Object_toString_")
,"converting","""toString: anObject
	" Return anObject converted to a String. "

	anObject isNil ifTrue: [ ^#nil ].
	(self isObject: anObject) ifTrue: [ ^anObject toString ].
	^{''js'""+anObject'}""",nil)
smalltalk.bind(smalltalk.Object,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Object>>#asNative:
	return smalltalk.asString_(self) 
""","Object_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver in target language lang.
	The default implementation return the receiver as a String.
	This method must be refined by subclasses implementing native literal representation.
	"

	^self asString""",nil)
smalltalk.bind(smalltalk.Object,"asNative",0
,smalltalk.__f__("""(self):
	#Object>>#asNative
	return self.asNative_(self.nativeLanguage()) 
""","Object_asNative")
,"converting","""asNative
	" Return the native representation of the receiver.
	The default implementation return the receiver as a String.
	This method must be refined by subclasses implementing native literal representation.
	"

	^self asNative: self nativeLanguage""",nil)
smalltalk.bind(smalltalk.Object,"asJSON",0
,smalltalk.__f__("""(self):
	#Object>>#asJSON
	__0__=smalltalk.newContext()
	__0__.json=nil
	__0__.json=smalltalk.Smalltalk.nativeObjectAt_(smalltalk.String("JSON")) 
	return __0__.json.stringify(self.asJSONObject()) 
""","Object_asJSON")
,"json","""asJSON
	" Return the JSON representation of the receiver. "

	| json |
	json := Smalltalk nativeObjectAt: #JSON.
	^json #stringify: self asJSONObject""",nil)
smalltalk.bind(smalltalk.Object,"escapedCode",0
,smalltalk.__f__("""(self):
	#Object>>#escapedCode
	return self.asNative() 
""","Object_escapedCode")
,"converting","""escapedCode
	" Return the code to reproduce receiver from code. "

	^self asNative""",nil)
smalltalk.bind(smalltalk.Object,"perform:",0
,smalltalk.__f__("""(self,aSymbol):
	#Object>>#perform:
	return self.perform_withArguments_(aSymbol,smalltalk.newArray([])) 
""","Object_perform_")
,"perform","""perform: aSymbol
	" Return the result of sending message aSymbol to the receiver. "

	^self perform: aSymbol withArguments: #()""",nil)
smalltalk.bind(smalltalk.Object,"perform:with:",0
,smalltalk.__f__("""(self,aSymbol,argument):
	#Object>>#perform:with:
	return self.perform_withArguments_(aSymbol,smalltalk.Array.with_(argument)) 
""","Object_perform_with_")
,"perform","""perform: aSymbol with: argument
	" Return the result of sending message aSymbol to the receiver. "

	^self perform: aSymbol withArguments: (Array with: argument)""",nil)
smalltalk.bind(smalltalk.Object,"perform:withArguments:",0
,smalltalk.__f__("""(self,aSymbol,aCollection):
	#Object>>#perform:withArguments:
	return self.basicPerform_withArguments_(aSymbol.asSelector(),aCollection.asArray()) 
""","Object_perform_withArguments_")
,"perform","""perform: aSymbol withArguments: aCollection
	" Return the result of sending message aSymbol to the receiver. "

"	Warning: To do NOT check arguments size is a feature
		if we do strict matching U8 tools will break because they are using the feature.
	aSymbol numberOfArguments = aCollection size ifFalse: [
		^self error: 'Invalid arguments size'
	].
"	^self basicPerform: aSymbol asSelector withArguments: aCollection asArray""",nil)
smalltalk.bind(smalltalk.Object,"isObject:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#isObject:
	return smalltalk.b_(smalltalk.isObject(anObject)) 
	return self 
""","Object_isObject_")
,"testing","""isObject: anObject
	" Return true if anObject is a smalltalk object.
	Return false if the object is a native object.
	"

	{''js'return (anObject==0 || anObject && anObject.$klass)?true:false'}""",nil)
smalltalk.bind(smalltalk.Object,"isNumber:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#isNumber:
	def __blk1__():
		return anObject.isNumber() 
	return smalltalk.boolean_and_(self.isObject_(anObject),smalltalk.blk(__blk1__,0)) 
""","Object_isNumber_")
,"testing","""isNumber: anObject
	" Return true if anObject is a number. "

	^(self isObject: anObject) and: [ anObject isNumber ]""",nil)
smalltalk.bind(smalltalk.Object,"basicAt:",0
,smalltalk.__f__("""(self,aString):
	#Object>>#basicAt:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=smalltalk.asObject_(self[smalltalk.handleOf(aString)]) 
	if smalltalk.b(smalltalk.isNil_(__0__.result)):
		return nil 
	 
	return __0__.result 
""","Object_basicAt_")
,"accessing","""basicAt: aString
	" Return the property of the receiver known as aString (or nil). "

	| result |
	result := self[aString].
	result isNil ifTrue: [ ^nil ].
	^result""",nil)
smalltalk.bind(smalltalk.Object,"basicAt:ifAbsent:",0
,smalltalk.__f__("""(self,aString,aBlock):
	#Object>>#basicAt:ifAbsent:
	def __blk1__():
		return aBlock.value() 
	return smalltalk.ifUndefined_do_(smalltalk.asObject_(self[smalltalk.handleOf(aString)]),smalltalk.blk(__blk1__,0)) 
""","Object_basicAt_ifAbsent_")
,"accessing","""basicAt: aString ifAbsent: aBlock
	" Return the property of the receiver known as aString (or the result of evaluating aBlock). "

	^self[aString] ifUndefined: [ aBlock value ]""",nil)
smalltalk.bind(smalltalk.Object,"basicAt:ifAbsentPut:",0
,smalltalk.__f__("""(self,aString,aBlock):
	#Object>>#basicAt:ifAbsentPut:
	def __blk1__():
		return smalltalk.basic_at_put_(self,aString,aBlock.value()) 
	return smalltalk.basic_at_ifAbsent_(self,aString,smalltalk.blk(__blk1__,0)) 
""","Object_basicAt_ifAbsentPut_")
,"accessing","""basicAt: aString ifAbsentPut: aBlock
	" Return the property of the receiver known as aString (or set it with the result of evaluating aBlock). "

	^self basicAt: aString ifAbsent: [ self basicAt: aString put: aBlock value ]""",nil)
smalltalk.bind(smalltalk.Object,"instVarAt:",0
,smalltalk.__f__("""(self,instVarName):
	#Object>>#instVarAt:
	if smalltalk.b(self.isNumber_(instVarName)):
		return self.instVarAt_((self).__class__.allInstVarNames().at_(instVarName)) 
	 
	return smalltalk.basic_at_(self,smalltalk.object_comma_(smalltalk.String("@"),instVarName)) 
""","Object_instVarAt_")
,"accessing","""instVarAt: instVarName
	" Return the internal collaborator of the receiver known as instVarName. "

	(self isNumber: instVarName) ifTrue: [
		^self instVarAt: (self class allInstVarNames at: instVarName)
	].
	^self basicAt: $@ ,instVarName""",nil)
smalltalk.bind(smalltalk.Object,"instVarAt:put:",0
,smalltalk.__f__("""(self,instVarName,anObject):
	#Object>>#instVarAt:put:
	if smalltalk.b(self.isNumber_(instVarName)):
		return self.instVarAt_put_((self).__class__.allInstVarNames().at_(instVarName),anObject) 
	 
	return smalltalk.basic_at_put_(self,smalltalk.object_comma_(smalltalk.String("@"),instVarName),anObject) 
""","Object_instVarAt_put_")
,"accessing","""instVarAt: instVarName put: anObject
	" Set the internal collaborator of the receiver known as instVarName to anObject. "

	(self isNumber: instVarName) ifTrue: [
		^self instVarAt: (self class allInstVarNames at: instVarName) put: anObject
	].
	^self basicAt: $@ ,instVarName put: anObject""",nil)
smalltalk.bind(smalltalk.Object,"basicAt:put:",0
,smalltalk.__f__("""(self,aString,anObject):
	#Object>>#basicAt:put:
	self[smalltalk.handleOf(aString)]=anObject
	return self[smalltalk.handleOf(aString)] 
""","Object_basicAt_put_")
,"accessing","""basicAt: aString put: anObject
	" Set the property of the receiver known as aString. "

	^self[aString] := anObject""",nil)
smalltalk.bind(smalltalk.Object,"error:",0
,smalltalk.__f__("""(self,aString):
	#Object>>#error:
	return smalltalk.Error.signal_(aString) 
""","Object_error_")
,"error","""error: aString
	" Return the result of managing error(aString) in the receiver. "

	^Error signal: aString""",nil)
smalltalk.bind(smalltalk.Object,"subclassResponsibility",0
,smalltalk.__f__("""(self):
	#Object>>#subclassResponsibility
	return self.subclassResponsibility_(nil) 
""","Object_subclassResponsibility")
,"error","""subclassResponsibility
	" Private - The concrete implementation on the receiver is not complete. "

	^self subclassResponsibility: nil""",nil)
smalltalk.bind(smalltalk.Object,"implementedBySubclass",0
,smalltalk.__f__("""(self):
	#Object>>#implementedBySubclass
	return self.subclassResponsibility() 
""","Object_implementedBySubclass")
,"error","""implementedBySubclass
	" Private - The concrete implementation on the receiver is not complete. "

	^self subclassResponsibility""",nil)
smalltalk.bind(smalltalk.Object,"shouldNotImplement",0
,smalltalk.__f__("""(self):
	#Object>>#shouldNotImplement
	return self.shouldNotImplement_(nil) 
""","Object_shouldNotImplement")
,"error","""shouldNotImplement
	" The receiver received a message that is not expected. "

	^self shouldNotImplement: nil""",nil)
smalltalk.bind(smalltalk.Object,"invalidMessage",0
,smalltalk.__f__("""(self):
	#Object>>#invalidMessage
	return self.invalidMessage_(nil) 
""","Object_invalidMessage")
,"error","""invalidMessage
	" The receiver received a message that is invalid (not expected for this object). "

	^self invalidMessage: nil""",nil)
smalltalk.bind(smalltalk.Object,"subclassResponsibility:",0
,smalltalk.__f__("""(self,aSelector):
	#Object>>#subclassResponsibility:
	def __blk1__():
		return smalltalk.String(" ") 
	def __blk2__():
		return smalltalk.object_comma_(smalltalk.String(" #"),aSelector) 
	return self.halt().error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Implementation of"),smalltalk.if_true_false_(smalltalk.isNil_(aSelector),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))),smalltalk.String(" is a responsibility of the subclass(")),(self).__class__.name()),smalltalk.String(")."))) 
""","Object_subclassResponsibility_")
,"error","""subclassResponsibility: aSelector
	" Private - The concrete implementation on the receiver is not complete. "

	^self halt error:
		 'Implementation of'
		,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])
		,' is a responsibility of the subclass(',self class name,').'""",nil)
smalltalk.bind(smalltalk.Object,"implementedBySubclass:",0
,smalltalk.__f__("""(self,aSelector):
	#Object>>#implementedBySubclass:
	return self.subclassResponsibility_(aSelector) 
""","Object_implementedBySubclass_")
,"error","""implementedBySubclass: aSelector
	" Private - The concrete implementation on the receiver is not complete. "

	^self subclassResponsibility: aSelector""",nil)
smalltalk.bind(smalltalk.Object,"shouldNotImplement:",0
,smalltalk.__f__("""(self,aSelector):
	#Object>>#shouldNotImplement:
	def __blk1__():
		return smalltalk.String(" ") 
	def __blk2__():
		return smalltalk.object_comma_(smalltalk.String(" #"),aSelector) 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Message"),smalltalk.if_true_false_(smalltalk.isNil_(aSelector),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))),smalltalk.String(" should not be implemented for instances of ")),(self).__class__.name())) 
""","Object_shouldNotImplement_")
,"error","""shouldNotImplement: aSelector
	" The receiver received a message that is not expected. "

	^self error:
		 'Message'
		,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])
		,' should not be implemented for instances of ', self class name""",nil)
smalltalk.bind(smalltalk.Object,"invalidMessage:",0
,smalltalk.__f__("""(self,aSelector):
	#Object>>#invalidMessage:
	def __blk1__():
		return smalltalk.String(" ") 
	def __blk2__():
		return smalltalk.object_comma_(smalltalk.String(" #"),aSelector) 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Message"),smalltalk.if_true_false_(smalltalk.isNil_(aSelector),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))),smalltalk.String(" should not be sent to instances of ")),(self).__class__.name())) 
""","Object_invalidMessage_")
,"error","""invalidMessage: aSelector
	" The receiver received a message that is invalid (not expected for this object). "

	^self error: 
		 'Message'
		,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])
		,' should not be sent to instances of ', self class name""",nil)
smalltalk.bind(smalltalk.Object,"smalltalkErrorOf:",0
,smalltalk.__f__("""(self,aNativeException):
	#Object>>#smalltalkErrorOf:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.messageText_(smalltalk.b_(smalltalk.asObject_(aNativeException.description) or smalltalk.asObject_(aNativeException.message))) 
		_s8_rec.nativeException_(aNativeException) 
		return _s8_rec.yourself() 
	__0__.result=nil
	if smalltalk.b(self.isObject_(aNativeException)):
		if smalltalk.b(smalltalk.is_kindOf_(aNativeException,(smalltalk.Exception))):
			return aNativeException 
		 
		return smalltalk.Error.new().messageText_(aNativeException) 
	 
	__0__.result=smalltalk.basic_at_(aNativeException,smalltalk.String("smalltalkError")) 
	if smalltalk.b(smalltalk.notNil_(__0__.result)):
		return __0__.result 
	 
	return __blk1__(smalltalk.Error.new()) 
""","Object_smalltalkErrorOf_")
,"private","""smalltalkErrorOf: aNativeException
	" Private, Internal - Return anException associated with a native exception. "

	| result |
	(self isObject: aNativeException) ifTrue: [
		(aNativeException isKindOf: Exception) ifTrue: [ ^aNativeException ].
		^Error new messageText: aNativeException
	].
	result := aNativeException basicAt: #smalltalkError.
	result notNil ifTrue: [ ^result ].
	^Error new
		messageText: aNativeException#description || aNativeException#message;
		nativeException: aNativeException;
		yourself""",nil)
smalltalk.bind(smalltalk.Object,"inspect",0
,smalltalk.__f__("""(self):
	#Object>>#inspect
	return self.basicInspect() 
""","Object_inspect")
,"inspection","""inspect
	" Open an inspector on the receiver. "

	^self basicInspect""",nil)
smalltalk.bind(smalltalk.Object,"basicInspect",0
,smalltalk.__f__("""(self):
	#Object>>#basicInspect
	if smalltalk.b(self.smalltalk().includesKey_(smalltalk.String("NativeHandle"))):
		return self.print_(smalltalk.NativeHandle._at_gt(self)) 
	 
	return self 
""","Object_basicInspect")
,"inspection","""basicInspect
	" Private - Open an inspector on the receiver. "

	(self smalltalk includesKey: #NativeHandle) ifTrue: [ "print native representation"
		^self print: NativeHandle @> self
	].
	^self""",nil)
smalltalk.bind(smalltalk.Object,"printString",0
,smalltalk.__f__("""(self):
	#Object>>#printString
	return smalltalk.object_comma_(smalltalk.String("a "),(self).__class__.name()) 
""","Object_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^'a ', self class name""",nil)
smalltalk.bind(smalltalk.Object,"isKindOf:",0
,smalltalk.__f__("""(self,aClass):
	#Object>>#isKindOf:
	return (self).__class__.inheritsFrom_(aClass) 
""","Object_isKindOf_")
,"testing","""isKindOf: aClass
	" Return true if the receiver is kind of aClass. "

	^self class inheritsFrom: aClass""",nil)
smalltalk.bind(smalltalk.Object,"isMemberOf:",0
,smalltalk.__f__("""(self,aClass):
	#Object>>#isMemberOf:
	return smalltalk.b_((self).__class__ is aClass) 
""","Object_isMemberOf_")
,"testing","""isMemberOf: aClass
	" Return true if the receiver is member of aClass. "

	^self class == aClass""",nil)
smalltalk.bind(smalltalk.Object,"ifNil:",0
,smalltalk.__f__("""(self,aBlock):
	#Object>>#ifNil:
	return self 
""","Object_ifNil_")
,"testing","""ifNil: aBlock
	" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). "

	^self""",nil)
smalltalk.bind(smalltalk.Object,"ifNil:ifNotNil:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Object>>#ifNil:ifNotNil:
	return anotherBlock.value() 
""","Object_ifNil_ifNotNil_")
,"testing","""ifNil: aBlock ifNotNil: anotherBlock
	" Return the result of evaluating aBlock if the receiver is nil or the result of evaluating anotherBlock (if not nil). "

	^anotherBlock value""",nil)
smalltalk.bind(smalltalk.Object,"ifNotNil:",0
,smalltalk.__f__("""(self,aBlock):
	#Object>>#ifNotNil:
	return aBlock.value() 
""","Object_ifNotNil_")
,"testing","""ifNotNil: aBlock
	" Return the result of evaluating aBlock if the receiver is not nil, or nil if it is nil. "

	^aBlock value""",nil)
smalltalk.bind(smalltalk.Object,"ifNotNil:ifNil:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Object>>#ifNotNil:ifNil:
	return aBlock.value() 
""","Object_ifNotNil_ifNil_")
,"testing","""ifNotNil: aBlock ifNil: anotherBlock
	" Return the result of evaluating aBlock if the receiver is not nil, or the result of evaluating anotherBlock if it is nil. "

	^aBlock value""",nil)
smalltalk.bind(smalltalk.Object,"isNil",0
,smalltalk.__f__("""(self):
	#Object>>#isNil
	return smalltalk.false 
""","Object_isNil")
,"testing","""isNil
	" Return true if the receiver is nil. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"notNil",0
,smalltalk.__f__("""(self):
	#Object>>#notNil
	return smalltalk.booleanNot_(smalltalk.isNil_(self)) 
""","Object_notNil")
,"testing","""notNil
	" Return true if the receiver is not nil. "

	^self isNil not""",nil)
smalltalk.bind(smalltalk.Object,"isClass",0
,smalltalk.__f__("""(self):
	#Object>>#isClass
	return smalltalk.false 
""","Object_isClass")
,"testing","""isClass
	" Return true if the receiver is a Class. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isMetaclass",0
,smalltalk.__f__("""(self):
	#Object>>#isMetaclass
	return smalltalk.false 
""","Object_isMetaclass")
,"testing","""isMetaclass
	" Return true if the receiver is a metaclass. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isNumber",0
,smalltalk.__f__("""(self):
	#Object>>#isNumber
	return smalltalk.false 
""","Object_isNumber")
,"testing","""isNumber
	" Return true if the receiver is a Number. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isString",0
,smalltalk.__f__("""(self):
	#Object>>#isString
	return smalltalk.false 
""","Object_isString")
,"testing","""isString
	" Return true if the receiver is a String. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isArray",0
,smalltalk.__f__("""(self):
	#Object>>#isArray
	return smalltalk.false 
""","Object_isArray")
,"testing","""isArray
	" Return true if the receiver is an Array. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isValuable",0
,smalltalk.__f__("""(self):
	#Object>>#isValuable
	return smalltalk.false 
""","Object_isValuable")
,"testing","""isValuable
	" Return true if the receiver can be evaluated. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"typeOf:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#typeOf:
	return smalltalk.String(type(anObject).__name__) 
""","Object_typeOf_")
,"native","""typeOf: anObject
	" Return the (native) type of anObject. "

	^{''js'typeof anObject'}""",nil)
smalltalk.bind(smalltalk.Object,"callableOf:",0
,smalltalk.__f__("""(self,aBlock):
	#Object>>#callableOf:
	def __blk1__(x,y,z):
		return aBlock.value_value_value_(x,y,z) 
	if True:
		return smalltalk.handleOf(aBlock)
	 
	if smalltalk.b(smalltalk.isNil_(aBlock)):
		return aBlock 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.typeOf_(aBlock),smalltalk.String("function"))):
		return aBlock 
	 
	return smalltalk.blk(__blk1__,3) 
""","Object_callableOf_")
,"native","""callableOf: aBlock
	" Return a (native) callable object for evaluating aBlock. "

	{'self' s8' ^aBlock '}.
	aBlock isNil ifTrue: [ ^aBlock ].
	(self typeOf: aBlock) = #function ifTrue: [ ^aBlock ].
	^[:x :y :z| aBlock value: x value: y value: z ] """,nil)
smalltalk.bind(smalltalk.Object,"methodFor:",0
,smalltalk.__f__("""(self,aSymbol):
	#Object>>#methodFor:
	return (self).__class__._gt_gt_gt(aSymbol) 
""","Object_methodFor_")
,"messages","""methodFor: aSymbol 
	" Return the method implementing aSymbol (or nil). "

	^self class >>> aSymbol""",nil)
smalltalk.bind(smalltalk.Object,"respondsTo:",0
,smalltalk.__f__("""(self,aSymbol):
	#Object>>#respondsTo:
	return smalltalk.notNil_(self.methodFor_(aSymbol)) 
""","Object_respondsTo_")
,"messages","""respondsTo: aSymbol 
	" Return true if the receiver respond to message aSymbol. "

	^(self methodFor: aSymbol) notNil""",nil)
smalltalk.bind(smalltalk.Object,"basicDelete:",0
,smalltalk.__f__("""(self,aString):
	#Object>>#basicDelete:
	key = smalltalk.handleOf(aString)
	try:
		del self[key]
	except TypeError:
		delattr(self,key)
	 
	return self 
""","Object_basicDelete_")
,"accessing","""basicDelete: aString
	" Private - Basic implementation of deletion of property aString of the receiver. "

	{''js'delete self[aString]'}""",nil)
smalltalk.bind(smalltalk.Object,"doesNotUnderstand:",0
,smalltalk.__f__("""(self,aMessage):
	#Object>>#doesNotUnderstand:
	def __blk1__(_s8_rec):
		_s8_rec.receiver_(self) 
		_s8_rec.message_(aMessage) 
		return _s8_rec.signal() 
	return __blk1__(smalltalk.MessageNotUnderstood.new()) 
""","Object_doesNotUnderstand_")
,"dnu","""doesNotUnderstand: aMessage
	" Private - Basic implementation of a message sent and not understood by the receiver. "

	^MessageNotUnderstood new
		receiver: self;
		message: aMessage;
		signal""",nil)
smalltalk.bind(smalltalk.Object,"dnu:withArguments:",0
,smalltalk.__f__("""(self,selector,anArray):
	#Object>>#dnu:withArguments:
	return self.doesNotUnderstand_(smalltalk.Message.selector_arguments_(selector,anArray)) 
""","Object_dnu_withArguments_")
,"dnu","""dnu: selector withArguments: anArray
	" Private - Basic implementation of a message sent and not understood by the receiver. "

	^self doesNotUnderstand: (Message selector: selector arguments: anArray)""",nil)
smalltalk.bind(smalltalk.Object,"basicPerform:withArguments:",0
,smalltalk.__f__("""(self,jsSelector,anArray):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#basicPerform:withArguments:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.dnu_withArguments_(jsSelector.asStSelector(),anArray)) 
		__0__.fn=nil
		__0__.fn=smalltalk.basic_at_ifAbsent_(self,jsSelector,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.fn(*smalltalk.arguments_toCall_(list(smalltalk.handleOf(anArray)),__0__.fn))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_basicPerform_withArguments_")
,"private","""basicPerform: jsSelector withArguments: anArray
	" Private - Basic implementation of #perform... "

	| fn |
	fn := self basicAt: jsSelector ifAbsent: [
		^self dnu: jsSelector asStSelector withArguments: anArray
	].
	^{''js'fn.apply(self,anArray)'}""",nil)
smalltalk.bind(smalltalk.Object,"json",0
,smalltalk.__f__("""(self):
	#Object>>#json
	return self.asJSONObject() 
""","Object_json")
,"json","""json
	" Return the receiver as a hash object. "

	^self asJSONObject""",nil)
smalltalk.bind(smalltalk.Object,"asJson:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#asJson:
	def __blk1__():
		return anObject.json() 
	def __blk2__():
		return anObject 
	if smalltalk.b(smalltalk.isNil_(anObject)):
		return nil.json() 
	 
	return smalltalk.if_true_false_(self.isObject_(anObject),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Object_asJson_")
,"json","""asJson: anObject
	" Return anObject as a hash object. "

	anObject isNil ifTrue: [ ^nil json ].
	^(self isObject: anObject)
		ifTrue: [ anObject json ]
		ifFalse: [ anObject ]""",nil)
smalltalk.bind(smalltalk.Object,"asJSONObject",0
,smalltalk.__f__("""(self):
	#Object>>#asJSONObject
	__0__=smalltalk.newContext()
	def __blk1__(field,value):
		def __blk2__():
			return self.jsonExportNil() 
		def __blk3__():
			return smalltalk.basic_at_put_(__0__.result,field,self.asJson_(value)) 
		return smalltalk.if_true_false_(smalltalk.boolean_or_(smalltalk.notNil_(value),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),nil) 
	__0__.result=nil
	__0__.result=smalltalk.newHash() 
	self.jsonFieldsDo_ignoring_(smalltalk.blk(__blk1__,2),self.jsonHiddenNames()) 
	return __0__.result 
""","Object_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	| result |
	result := {''js'{}'}.
	self	jsonFieldsDo: [:field :value|
		(value notNil or: [ self jsonExportNil ]) ifTrue: [
			result basicAt: field put: (self asJson: value)
		].
	]	ignoring: self jsonHiddenNames.
	^result""",nil)
smalltalk.bind(smalltalk.Object,"jsonHiddenNames",0
,smalltalk.__f__("""(self):
	#Object>>#jsonHiddenNames
	return smalltalk.newArray([]) 
""","Object_jsonHiddenNames")
,"converting","""jsonHiddenNames
	" Private - Return the names of the fields to skip when mapping the receiver to JSON structure. "

	^#()""",nil)
smalltalk.bind(smalltalk.Object,"jsonFieldsDo:ignoring:",0
,smalltalk.__f__("""(self,aBlock,ignored):
	#Object>>#jsonFieldsDo:ignoring:
	def __blk1__(each):
		def __blk2__():
			return ignored.includes_(each) 
		def __blk3__():
			return aBlock.value_value_(each,self.instVarAt_(each)) 
		return smalltalk.if_true_false_(smalltalk.boolean_and_(smalltalk.notNil_(ignored),smalltalk.blk(__blk2__,0)),nil,smalltalk.blk(__blk3__,0)) 
	return (self).__class__.allInstVarNamesDo_(smalltalk.blk(__blk1__,1)) 
""","Object_jsonFieldsDo_ignoring_")
,"converting","""jsonFieldsDo: aBlock ignoring: ignored
	" Private - Evaluates a(TwoArguments)Block with the fields to map the receiver to JSON structure. "

	^self class allInstVarNamesDo: [:each|
		(ignored notNil and: [ ignored includes: each ]) ifFalse: [
			aBlock value: each value: (self instVarAt: each)
		].
	]""",nil)
smalltalk.bind(smalltalk.Object,"jsonExportNil",0
,smalltalk.__f__("""(self):
	#Object>>#jsonExportNil
	return smalltalk.false 
""","Object_jsonExportNil")
,"converting","""jsonExportNil
	" Private - Return true if the receiver export nil values. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"mustBeBoolean",0
,smalltalk.__f__("""(self):
	#Object>>#mustBeBoolean
	return self.error_(smalltalk.String("Must be boolean.")) 
""","Object_mustBeBoolean")
,"testing","""mustBeBoolean
	" Signal an error if the receiver is not a Boolean. "

	^self error: 'Must be boolean.'""",nil)
smalltalk.bind(smalltalk.Object,"isBoolean",0
,smalltalk.__f__("""(self):
	#Object>>#isBoolean
	return smalltalk.false 
""","Object_isBoolean")
,"testing","""isBoolean
	" Return true if the receiver is a boolean. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"mustBeNumber",0
,smalltalk.__f__("""(self):
	#Object>>#mustBeNumber
	return self.error_(smalltalk.String("Must be a Number")) 
""","Object_mustBeNumber")
,"testing","""mustBeNumber
	" Signal an error if the receiver is not a Number. "

	^self error: 'Must be a Number'""",nil)
smalltalk.bind(smalltalk.Object,"asLiteral",0
,smalltalk.__f__("""(self):
	#Object>>#asLiteral
	return smalltalk.printString_(self) 
""","Object_asLiteral")
,"converting","""asLiteral
	" Return the receiver in literal notation. "

	^self printString""",nil)
smalltalk.bind(smalltalk.Object,"isCharacter",0
,smalltalk.__f__("""(self):
	#Object>>#isCharacter
	return smalltalk.false 
""","Object_isCharacter")
,"testing","""isCharacter
	" Return true if the receiver is a character. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isAssociation",0
,smalltalk.__f__("""(self):
	#Object>>#isAssociation
	return smalltalk.false 
""","Object_isAssociation")
,"testing","""isAssociation
	" Return true if the receiver is anAssociation. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isDictionary",0
,smalltalk.__f__("""(self):
	#Object>>#isDictionary
	return smalltalk.false 
""","Object_isDictionary")
,"testing","""isDictionary
	" Return true if the receiver is a dictionary. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isRectangle",0
,smalltalk.__f__("""(self):
	#Object>>#isRectangle
	return smalltalk.false 
""","Object_isRectangle")
,"testing","""isRectangle
	" Return true if receiver is a Rectangle. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"isMessage",0
,smalltalk.__f__("""(self):
	#Object>>#isMessage
	return smalltalk.false 
""","Object_isMessage")
,"testing","""isMessage
	" Return true if the receiver is a message. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"argumentCount",0
,smalltalk.__f__("""(self):
	#Object>>#argumentCount
	return smalltalk.Number(0) 
""","Object_argumentCount")
,"evaluating","""argumentCount
	" Return the number of arguments of the receiver. "

	^0""",nil)
smalltalk.bind(smalltalk.Object,"numberOfArguments",0
,smalltalk.__f__("""(self):
	#Object>>#numberOfArguments
	return self.argumentCount() 
""","Object_numberOfArguments")
,"evaluating","""numberOfArguments
	" Return the number of arguments of the receiver. "

	^self argumentCount""",nil)
smalltalk.bind(smalltalk.Object,"evaluate",0
,smalltalk.__f__("""(self):
	#Object>>#evaluate
	return self 
""","Object_evaluate")
,"evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Object,"evaluateDeferred",0
,smalltalk.__f__("""(self):
	#Object>>#evaluateDeferred
	def __blk1__():
		return self.evaluate() 
	smalltalk.blk(__blk1__,0).valueDeferred() 
	return self 
""","Object_evaluateDeferred")
,"evaluating","""evaluateDeferred
	" Evaluating the receiver deferred in time.
	Return the receiver. "

	[ self evaluate ] valueDeferred.""",nil)
smalltalk.bind(smalltalk.Object,"evaluateWithArguments:",0
,smalltalk.__f__("""(self,anArray):
	#Object>>#evaluateWithArguments:
	return self 
""","Object_evaluateWithArguments_")
,"evaluating","""evaluateWithArguments: anArray
	" Return the result of evaluating the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Object,"evaluateWith:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#evaluateWith:
	return self.evaluateWithArguments_(smalltalk.Array.with_(anObject)) 
""","Object_evaluateWith_")
,"evaluating","""evaluateWith: anObject
	" Return the result of evaluating the receiver. "

	^self evaluateWithArguments: (Array with: anObject)""",nil)
smalltalk.bind(smalltalk.Object,"logEvaluate:",0
,smalltalk.__f__("""(self,source):
	#Object>>#logEvaluate:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.evaluate() 
	smalltalk.SystemManager.log_(source) 
	return __0__.result 
""","Object_logEvaluate_")
,"evaluating","""logEvaluate: source
	" Return the result of evaluating the receiver.
	Log the source expression as reference of evaluation.
	"

	| result |
	result := self evaluate.
	SystemManager log: source.
	^result""",nil)
smalltalk.bind(smalltalk.Object,"asActionSequence",0
,smalltalk.__f__("""(self):
	#Object>>#asActionSequence
	return smalltalk.ActionSequence.with_(self) 
""","Object_asActionSequence")
,"converting","""asActionSequence
	" Return an ActionSequence from the receiver. "

	^ActionSequence with: self""",nil)
smalltalk.bind(smalltalk.Object,"eventTable",0
,smalltalk.__f__("""(self):
	#Object>>#eventTable
	def __blk1__():
		return self.eventTableCreate() 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("@handlers"),smalltalk.blk(__blk1__,0)) 
""","Object_eventTable")
,"events","""eventTable
	" Private - Return the mapping event names to actions of the receiver. "

	^self basicAt: '@handlers' ifAbsent: [ self eventTableCreate ]""",nil)
smalltalk.bind(smalltalk.Object,"eventTableForEdit",0
,smalltalk.__f__("""(self):
	#Object>>#eventTableForEdit
	def __blk1__():
		return smalltalk.basic_at_put_(self,smalltalk.String("@handlers"),self.eventTableCreate()) 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("@handlers"),smalltalk.blk(__blk1__,0)) 
""","Object_eventTableForEdit")
,"events","""eventTableForEdit
	" Private - Return the mapping event names to actions of the receiver.
	Set the internal map if not present.
	"

	^self basicAt: '@handlers' ifAbsent: [
		self basicAt: '@handlers' put: self eventTableCreate
	]""",nil)
smalltalk.bind(smalltalk.Object,"releaseEventTable",0
,smalltalk.__f__("""(self):
	#Object>>#releaseEventTable
	self.basicDelete_(smalltalk.String("@handlers")) 
	return self 
""","Object_releaseEventTable")
,"events","""releaseEventTable
	" Private - Release the event table. "

	self basicDelete: '@handlers'""",nil)
smalltalk.bind(smalltalk.Object,"release",0
,smalltalk.__f__("""(self):
	#Object>>#release
	self.releaseEventTable() 
	return self 
""","Object_release")
,"release","""release
	" Release the receiver. "

	self releaseEventTable """,nil)
smalltalk.bind(smalltalk.Object,"eventTableCreate",0
,smalltalk.__f__("""(self):
	#Object>>#eventTableCreate
	return smalltalk.PoolDictionary.new() 
""","Object_eventTableCreate")
,"events","""eventTableCreate
	" Private - Return a new mapping for the receiver. "

	^PoolDictionary new""",nil)
smalltalk.bind(smalltalk.Object,"canTriggerEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object>>#canTriggerEvent:
	return (self).__class__.canTriggerEvent_(selector) 
""","Object_canTriggerEvent_")
,"events","""canTriggerEvent: selector
	" Return true if the receiver can trigger event."

	^self class canTriggerEvent: selector """,nil)
smalltalk.bind(smalltalk.Object,"invalidEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object>>#invalidEvent:
	return self 
""","Object_invalidEvent_")
,"events","""invalidEvent: selector
	" Private - Notify the situation where an unknown event is registered.
	Default implementation ignore error during unknown event registration.
	"

	^self
"DEBUG-	^self note: self class name,' invalidEvent: ' ,selector asLiteral \"""",nil)
smalltalk.bind(smalltalk.Object,"when:evaluate:",0
,smalltalk.__f__("""(self,selector,anAction):
	#Object>>#when:evaluate:
	__0__=smalltalk.newContext()
	__0__.actions=nil
	if not smalltalk.b(self.canTriggerEvent_(selector)):
		self.invalidEvent_(selector) 
	 
	__0__.actions=self.actionListForEvent_(selector) 
	if smalltalk.b(__0__.actions.includes_(anAction)):
		return self 
	 
	self.setActionList_forEvent_(__0__.actions.copyWith_(anAction),selector) 
	return self 
""","Object_when_evaluate_")
,"events","""when: selector evaluate: anAction
	" Register anAction to the be evaluated when the receiver triggers the event. "

	| actions |
	(self canTriggerEvent: selector) ifFalse: [ self invalidEvent: selector ].
	actions := self actionListForEvent: selector.
	(actions includes: anAction) ifTrue: [ ^self ].
	self
		setActionList: (actions copyWith: anAction)
		forEvent: selector""",nil)
smalltalk.bind(smalltalk.Object,"actionListForEvent:",0
,smalltalk.__f__("""(self,selector):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#actionListForEvent:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.ActionSequence.new()) 
		__0__.result=nil
		__0__.result=self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result.asActionSequence()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_actionListForEvent_")
,"events","""actionListForEvent: selector
	" Private - Return a collection of actions to evaluate when the event is triggered. "

	| result |
	result := self eventTable at: selector ifAbsent: [ ^ActionSequence new ].
	^result asActionSequence""",nil)
smalltalk.bind(smalltalk.Object,"setActionList:forEvent:",0
,smalltalk.__f__("""(self,actionSequence,selector):
	#Object>>#setActionList:forEvent:
	__0__=smalltalk.newContext()
	__0__.action=nil
	__0__.action=actionSequence.asActionSequence().reduced() 
	if smalltalk.b(smalltalk.isNil_(__0__.action)):
		return self.removeActionsForEvent_(selector) 
	 
	self.eventTableForEdit().at_put_(selector,__0__.action) 
	return self 
""","Object_setActionList_forEvent_")
,"events","""setActionList: actionSequence forEvent: selector
	" Private - Set the list of actions to evaluate when the event is triggered by the receiver. "

	| action |
	action := actionSequence asActionSequence reduced.
	action isNil ifTrue: [ ^self removeActionsForEvent: selector ].
	self eventTableForEdit at: selector put: action """,nil)
smalltalk.bind(smalltalk.Object,"removeActionsSatisfying:forEvent:",0
,smalltalk.__f__("""(self,aBlock,selector):
	#Object>>#removeActionsSatisfying:forEvent:
	self.setActionList_forEvent_(self.actionListForEvent_(selector).asArray().reject_(aBlock),selector) 
	return self 
""","Object_removeActionsSatisfying_forEvent_")
,"events","""removeActionsSatisfying: aBlock forEvent: selector
	" Private - Remove all actions for the event that evaluates aBlock to true."

	self
		setActionList: ((self actionListForEvent: selector) asArray reject: aBlock)
		forEvent: selector """,nil)
smalltalk.bind(smalltalk.Object,"removeActionsWithReceiver:forEvent:",0
,smalltalk.__f__("""(self,anObject,selector):
	#Object>>#removeActionsWithReceiver:forEvent:
	def __blk1__(each):
		def __blk2__():
			return smalltalk.b_(each.receiver() is anObject) 
		return smalltalk.boolean_and_(smalltalk.responds_to_(each,(smalltalk.String("receiver"))),smalltalk.blk(__blk2__,0)) 
	self.removeActionsSatisfying_forEvent_(smalltalk.blk(__blk1__,1),selector) 
	return self 
""","Object_removeActionsWithReceiver_forEvent_")
,"events","""removeActionsWithReceiver: anObject forEvent: selector
	" Remove all actions for the event in the receiver's event table which have anObject as receiver. "

	self
		removeActionsSatisfying: [:each| (each respondsTo: #receiver) and: [ each receiver == anObject ] ]
		forEvent: selector """,nil)
smalltalk.bind(smalltalk.Object,"removeAction:forEvent:",0
,smalltalk.__f__("""(self,anAction,selector):
	#Object>>#removeAction:forEvent:
	def __blk1__(each):
		return smalltalk.isObject_equalTo_(each,anAction) 
	self.removeActionsSatisfying_forEvent_(smalltalk.blk(__blk1__,1),selector) 
	return self 
""","Object_removeAction_forEvent_")
,"events","""removeAction: anAction forEvent: selector
	" Remove anAction for the event in the receiver's event table which have anObject as receiver. "

	self
		removeActionsSatisfying: [:each| each = anAction ]
		forEvent: selector """,nil)
smalltalk.bind(smalltalk.Object,"when:do:",0
,smalltalk.__f__("""(self,selector,aBlock):
	#Object>>#when:do:
	self.when_evaluate_(selector,aBlock) 
	return self 
""","Object_when_do_")
,"events","""when: selector do: aBlock
	" Evaluate aBlock when the receiver triggers the event. "

	self when: selector evaluate: aBlock""",nil)
smalltalk.bind(smalltalk.Object,"when:send:to:withArguments:",0
,smalltalk.__f__("""(self,selector,message,anObject,array):
	#Object>>#when:send:to:withArguments:
	self.when_evaluate_(selector,smalltalk.LinkMessage.receiver_selector_arguments_(anObject,message,array)) 
	return self 
""","Object_when_send_to_withArguments_")
,"events","""when: selector send: message to: anObject withArguments: array
	" Send the message when the receiver triggers the event. "

	self
		when: selector
		evaluate: (LinkMessage
			receiver: anObject
			selector: message
			arguments: array)""",nil)
smalltalk.bind(smalltalk.Object,"when:send:to:",0
,smalltalk.__f__("""(self,selector,message,anObject):
	#Object>>#when:send:to:
	self.when_evaluate_(selector,smalltalk.Message.receiver_selector_arguments_(anObject,message,smalltalk.Array.new_(message.argumentCount()))) 
	return self 
""","Object_when_send_to_")
,"events","""when: selector send: message to: anObject
	" Send the message when the receiver triggers the event. "

	self
		when: selector
		evaluate: (Message
			receiver: anObject selector: message
			arguments: (Array new: message argumentCount))""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,aBlock):
	#Object>>#triggerEvent:ifNotHandled:
	def __blk1__():
		return aBlock 
	return self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0)).evaluate() 
""","Object_triggerEvent_ifNotHandled_")
,"events","""triggerEvent: selector ifNotHandled: aBlock
	" Trigger the event.
	If the event is not handled, return the value of evaluating aBlock,
        or the value returned by the most recently defined event handler.
	"

	^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluate""",nil)
smalltalk.bind(smalltalk.Object,"actionForEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object>>#actionForEvent:
	def __blk1__():
		return nil 
	return self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0)) 
""","Object_actionForEvent_")
,"events","""actionForEvent: selector
	" Return the action to evaluate when the event is triggered by the receiver (or nil). "

	^self eventTable at: selector ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object>>#triggerEvent:
	return self.actionForEvent_(selector).evaluate() 
""","Object_triggerEvent_")
,"events","""triggerEvent: selector
	" Return the result of triggering the event. "

	^(self actionForEvent: selector) evaluate""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:withArguments:",0
,smalltalk.__f__("""(self,selector,array):
	#Object>>#triggerEvent:withArguments:
	return self.actionForEvent_(selector).evaluateWithArguments_(array) 
""","Object_triggerEvent_withArguments_")
,"events","""triggerEvent: selector withArguments: array
	" Return the result of triggering the event. "

	^(self actionForEvent: selector) evaluateWithArguments: array""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:with:",0
,smalltalk.__f__("""(self,selector,anObject):
	#Object>>#triggerEvent:with:
	return self.triggerEvent_withArguments_(selector,smalltalk.Array.with_(anObject)) 
""","Object_triggerEvent_with_")
,"events","""triggerEvent: selector with: anObject
	" Return the result of triggering the event. "

	^self triggerEvent: selector withArguments: (Array with: anObject)""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:with:with:",0
,smalltalk.__f__("""(self,selector,anObject,anotherObject):
	#Object>>#triggerEvent:with:with:
	return self.triggerEvent_withArguments_(selector,smalltalk.Array.with_with_(anObject,anotherObject)) 
""","Object_triggerEvent_with_with_")
,"events","""triggerEvent: selector with: anObject with: anotherObject
	" Return the result of triggering the event. "

	^self triggerEvent: selector withArguments: (Array with: anObject with: anotherObject)""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:withArguments:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,array,aBlock):
	#Object>>#triggerEvent:withArguments:ifNotHandled:
	def __blk1__():
		return aBlock 
	return self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0)).evaluateWithArguments_(array) 
""","Object_triggerEvent_withArguments_ifNotHandled_")
,"events","""triggerEvent: selector withArguments: array ifNotHandled: aBlock
	" Return the result of triggering the event with the arguments.
	If the event is not handled, return the value of evaluating aBlock,
	or the value returned by the most recently defined event handler action.
	"

	^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluateWithArguments: array""",nil)
smalltalk.bind(smalltalk.Object,"triggerEvent:with:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,anObject,aBlock):
	#Object>>#triggerEvent:with:ifNotHandled:
	return self.triggerEvent_withArguments_ifNotHandled_(selector,smalltalk.Array.with_(anObject),aBlock) 
""","Object_triggerEvent_with_ifNotHandled_")
,"events","""triggerEvent: selector with: anObject ifNotHandled: aBlock
	" Return the result of triggering the event with anObject. "

	^self triggerEvent: selector withArguments: (Array with: anObject) ifNotHandled: aBlock""",nil)
smalltalk.bind(smalltalk.Object,"hasActionForEvent:",0
,smalltalk.__f__("""(self,selector):
	#Object>>#hasActionForEvent:
	return self.eventTable().includesKey_(selector) 
""","Object_hasActionForEvent_")
,"events","""hasActionForEvent: selector
	" Return true if the receiver has an action registered for the event. "

	^self eventTable includesKey: selector """,nil)
smalltalk.bind(smalltalk.Object,"eventsHandled",0
,smalltalk.__f__("""(self):
	#Object>>#eventsHandled
	return self.eventTable().keys() 
""","Object_eventsHandled")
,"events","""eventsHandled
	" Return the events for which there are actions registered in the receiver. "

	^self eventTable keys""",nil)
smalltalk.bind(smalltalk.Object,"removeAllActionsWithReceiver:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#removeAllActionsWithReceiver:
	def __blk1__(each):
		return self.removeActionsWithReceiver_forEvent_(anObject,each) 
	self.eventTable().keys().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Object_removeAllActionsWithReceiver_")
,"events","""removeAllActionsWithReceiver: anObject
	" Remove all actions for all events in the receiver's event table with anObject as receiver. "

	self eventTable keys do: [:each|self removeActionsWithReceiver: anObject forEvent: each ]""",nil)
smalltalk.bind(smalltalk.Object,"removeActionsForEvent:",0
,smalltalk.__f__("""(self,selector):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#removeActionsForEvent:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self) 
		__0__.actions=nil
		__0__.actions=self.eventTable() 
		__0__.actions.removeKey_ifAbsent_(selector,smalltalk.blk(__blk1__,0)) 
		if smalltalk.b(__0__.actions.isEmpty()):
			self.releaseEventTable() 
		 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_removeActionsForEvent_")
,"events","""removeActionsForEvent: selector
	" Remove all actions for the event. "

	| actions |
	actions := self eventTable.
	actions removeKey: selector ifAbsent: [ ^self ].
	actions isEmpty ifTrue: [ self releaseEventTable ].""",nil)
smalltalk.bind(smalltalk.Object,"addDependent:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#addDependent:
	self.when_send_to_(smalltalk.String("changed"),smalltalk.String("update"),anObject) 
	return self 
""","Object_addDependent_")
,"changes","""addDependent: anObject
	" Make anObject dependent of the receiver. "

	self when: #changed send: #update to: anObject""",nil)
smalltalk.bind(smalltalk.Object,"changed",0
,smalltalk.__f__("""(self):
	#Object>>#changed
	self.triggerEvent_(smalltalk.String("changed")) 
	return self 
""","Object_changed")
,"changes","""changed
	" Update the dependents of the receiver. "

	self triggerEvent: #changed""",nil)
smalltalk.bind(smalltalk.Object,"updateEvent:selector:arguments:",0
,smalltalk.__f__("""(self,selector,message,array):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#updateEvent:selector:arguments:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.action=nil
		__0__.action=self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0)) 
		__0__.action.asActionSequence().evaluateWithSelector_withArguments_(message,array) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_updateEvent_selector_arguments_")
,"changes","""updateEvent: selector selector: message arguments: array
	" Private - Trigger the event with the message selector and the arguments. "

	| action |
	action := self eventTable at: selector ifAbsent: [ ^nil ].
	action asActionSequence
		evaluateWithSelector: message
		withArguments: array """,nil)
smalltalk.bind(smalltalk.Object,"changed:",0
,smalltalk.__f__("""(self,aspect):
	#Object>>#changed:
	self.updateEvent_selector_arguments_(smalltalk.String("changed"),smalltalk.String("update:"),smalltalk.Array.with_(aspect)) 
	return self 
""","Object_changed_")
,"changes","""changed: aspect
	" Update the dependents on aspect of the receiver. "

	self	updateEvent: #changed selector: #update:
		arguments: (Array with: aspect)""",nil)
smalltalk.bind(smalltalk.Object,"changed:with:",0
,smalltalk.__f__("""(self,aspect,anObject):
	#Object>>#changed:with:
	self.updateEvent_selector_arguments_(smalltalk.String("changed"),smalltalk.String("update:with:"),smalltalk.Array.with_with_(aspect,anObject)) 
	return self 
""","Object_changed_with_")
,"changes","""changed: aspect with: anObject
	" Update the dependents on aspect of the receiver. "

	self	updateEvent: #changed selector: #update:with:
		arguments: (Array with: aspect with: anObject)""",nil)
smalltalk.bind(smalltalk.Object,"changed:with:with:",0
,smalltalk.__f__("""(self,aspect,anObject,anotherObject):
	#Object>>#changed:with:with:
	self.updateEvent_selector_arguments_(smalltalk.String("changed"),smalltalk.String("update:with:with:"),smalltalk.Array.with_with_with_(aspect,anObject,anotherObject)) 
	return self 
""","Object_changed_with_with_")
,"changes","""changed: aspect with: anObject with: anotherObject
	" Update the dependents on aspect of the receiver. "

	self	updateEvent: #changed selector: #update:with:with:
		arguments: (Array with: aspect with: anObject with: anotherObject)""",nil)
smalltalk.bind(smalltalk.Object,"dependents",0
,smalltalk.__f__("""(self):
	#Object>>#dependents
	def __blk1__(each):
		return each.receiver() 
	return self.actionListForEvent_(smalltalk.String("changed")).collect_(smalltalk.blk(__blk1__,1)) 
""","Object_dependents")
,"changes","""dependents
	" Return the dependents of the receiver. "

	^(self actionListForEvent: #changed) collect: [:each | each receiver ]""",nil)
smalltalk.bind(smalltalk.Object,"update:with:",0
,smalltalk.__f__("""(self,anObject,anotherObject):
	#Object>>#update:with:
	return self 
""","Object_update_with_")
,"changes","""update: anObject with: anotherObject
	" Update the receiver.
	Default implementation do nothing.
	This method must be refined by subclasses to support change/update protocoll.
	\"""",nil)
smalltalk.bind(smalltalk.Object,"update:",0
,smalltalk.__f__("""(self,anObject):
	#Object>>#update:
	return self 
""","Object_update_")
,"changes","""update: anObject
	" Update the receiver.
	Default implementation do nothing.
	This method must be refined by subclasses to support change/update protocoll.
	\"""",nil)
smalltalk.bind(smalltalk.Object,"printingWith:do:",0
,smalltalk.__f__("""(self,printBlock,aBlock):
	#Object>>#printingWith:do:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.old=smalltalk.Smalltalk.install_as_(printBlock,smalltalk.String("print")) 
		__0__.result=aBlock.value()
		return __0__.result 
	def __blk2__():
		return smalltalk.Smalltalk.install_as_(__0__.old,smalltalk.String("print")) 
	__0__.old=nil
	__0__.result=nil
	smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
	return __0__.result 
""","Object_printingWith_do_")
,"printing","""printingWith: printBlock do: aBlock
	" Return the result of evaluating aBlock, redirecting output to printBlock. "

	| old result |
	[	old := Smalltalk install: printBlock as: #print.
		result := aBlock value.
	] ensure: [ Smalltalk install: old as: #print ].
	^result""",nil)
smalltalk.bind(smalltalk.Object,"isParseFailure",0
,smalltalk.__f__("""(self):
	#Object>>#isParseFailure
	return smalltalk.false 
""","Object_isParseFailure")
,"Compiler-testing","""isParseFailure
	" Return true if the receiver is a parse failure. "

	^false""",nil)
smalltalk.bind(smalltalk.Object,"asParser",0
,smalltalk.__f__("""(self):
	#Object>>#asParser
	return self.subclassResponsibility_(smalltalk.String("asParser")) 
""","Object_asParser")
,"Compiler-converting","""asParser
	" Return a parser on the receiver. "

	^self subclassResponsibility: #asParser""",nil)
smalltalk.bind(smalltalk.Object,"ifUndefined:",0
,smalltalk.__f__("""(self,aBlock):
	#Object>>#ifUndefined:
	return self 
""","Object_ifUndefined_")
,"Compiler-inlines","""ifUndefined: aBlock
	" Return the receiver or the result of evaluating aBlock if it is undefined.
	Notes:	-this message is inlined by compiler (it is not sent)
		-aBlock is evaluated ONLY in case of undefined.
	"

	^self""",nil)
smalltalk.bind(smalltalk.Object,"orNil",0
,smalltalk.__f__("""(self):
	#Object>>#orNil
	return self 
""","Object_orNil")
,"Compiler-inlines","""orNil
	" Return the receiver or nil.
	Notes:	-this message is inlined by compiler (it is not sent)
		-nil, null and undefined returns nil.
	"

	^self""",nil)
smalltalk.bind(smalltalk.Object,"accept:",0
,smalltalk.__f__("""(self,what):
	#Object>>#accept:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("[bug] "),smalltalk.asString_(self)),smalltalk.String(" accept: ")),what.halt())) 
	return self.error_(smalltalk.String("#accept: out of control.")) 
""","Object_accept_")
,"Compiler-parser-bug","""accept: what
	" Private - Report buggy send by compiler. "

	self note: '[bug] ' ,self asString ,' accept: ' ,what halt.
	^self error: '#accept: out of control.'""",nil)
smalltalk.bind(smalltalk.Object,"compilerSupport",0
,smalltalk.__f__("""(self):
	#Object>>#compilerSupport
	return self.smalltalk().compilerSupport() 
""","Object_compilerSupport")
,"Compiler-accessing","""compilerSupport
	" Return the compiler of the receiver "

	^self smalltalk compilerSupport""",nil)
smalltalk.bind(smalltalk.Object,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#Object>>#scanFrom:
	__0__=smalltalk.newContext()
	__0__.chunk=nil
	__0__.chunk=aStream.nextChunk() 
	if smalltalk.b(__0__.chunk.isEmpty()):
		return nil 
	 
	return __0__.chunk.evaluateIn_(self) 
""","Object_scanFrom_")
,"Tools-fileIn","""scanFrom: aStream
	" FileIn - Return the result of evaluating the next chunk of data from aStream.
	The method can be refined by chunk readers to support custom fileIn features.
	Must return the next reader to use for reading remaining contents from aStream.
	"

	| chunk |
	chunk := aStream nextChunk.
	chunk isEmpty ifTrue: [ ^nil ].
	^chunk evaluateIn: self""",nil)
smalltalk.bind(smalltalk.Object,"javascriptCodeFollows",0
,smalltalk.__f__("""(self):
	#Object>>#javascriptCodeFollows
	return self.nativeCodeFollows() 
""","Object_javascriptCodeFollows")
,"Tools-fileIn","""javascriptCodeFollows
	" Obsolete - use #nativeCodeFollows"

	^self nativeCodeFollows""",nil)
smalltalk.bind(smalltalk.Object,"nativeCodeFollows",0
,smalltalk.__f__("""(self):
	#Object>>#nativeCodeFollows
	return smalltalk.ChunkReader.native() 
""","Object_nativeCodeFollows")
,"Tools-fileIn","""nativeCodeFollows
	" FileIn - FileIn native code on current stream.
	Consume stream contents upto end of stream evaluating the contents as native code.
	"

	^ChunkReader native""",nil)
smalltalk.bind(smalltalk.Object,"cancelFileIn",0
,smalltalk.__f__("""(self):
	#Object>>#cancelFileIn
	return self.ignoreFileInUpTo_(nil) 
""","Object_cancelFileIn")
,"Tools-fileIn","""cancelFileIn
	" FileIn - Cancel fileIn on current stream. "

	^self ignoreFileInUpTo: nil""",nil)
smalltalk.bind(smalltalk.Object,"ignoreFileInUpTo:",0
,smalltalk.__f__("""(self,aToken):
	#Object>>#ignoreFileInUpTo:
	return smalltalk.SkipFileInReader.upTo_(aToken) 
""","Object_ignoreFileInUpTo_")
,"Tools-fileIn","""ignoreFileInUpTo: aToken
	" FileIn - Ignore fileIn on current stream upto token. "

	^SkipFileInReader upTo: aToken""",nil)
smalltalk.bind(smalltalk.Object,"==","_eq_eq"
,smalltalk.__f__("""(self,anObject):
	#Object>>#==
	return smalltalk.b_(anObject is self) 
""","Object__eq_eq")
,"Tools-comparing","""== anObject
	^anObject == self""",nil)
smalltalk.bind(smalltalk.Object,"~~","_no_no"
,smalltalk.__f__("""(self,anObject):
	#Object>>#~~
	return smalltalk.b_(smalltalk.b_(self is anObject) is smalltalk.false) 
""","Object__no_no")
,"Tools-comparing","""~~ anObject
	^(self == anObject) == false""",nil)
smalltalk.bind(smalltalk.Object,"isFile:olderThan:",0
,smalltalk.__f__("""(self,fileName,referenceFileName):
	#Object>>#isFile:olderThan:
	if smalltalk.b(smalltalk.isNil_(smalltalk.basic_at_(smalltalk.Smalltalk._8global(),smalltalk.String("isFileOlderThan")))):
		return smalltalk.false 
	 
	return isFileOlderThan(fileName,referenceFileName) 
""","Object_isFile_olderThan_")
,"Builders-emmiting","""isFile: fileName olderThan: referenceFileName
	" Private - Return true if the file at pathName is older than file at referenceFileName. "

	(Smalltalk global basicAt: #isFileOlderThan) isNil ifTrue: [ ^false ].
	^# #isFileOlderThan: fileName with: referenceFileName""",nil)
smalltalk.bind(smalltalk.Object,"emmit:startingWith:",0
,smalltalk.__f__("""(self,fileName,initial):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#emmit:startingWith:
		__0__=smalltalk.newContext()
		def __blk1__():
			def __blk2__(what):
				def __blk3__(_s8_rec):
					_s8_rec.cr() 
					return _s8_rec.nextPutAll_(__0__.text) 
				__0__.text=smalltalk.object_comma_(smalltalk.String(""),what) 
				return __blk3__(__0__.output) 
			def __blk4__():
				return self.fileIn_(fileName) 
			def __blk5__():
				return __0__.text.outputToFile_(__0__.nativeFileName) 
			self.printingWith_do_(smalltalk.blk(__blk2__,1),smalltalk.blk(__blk4__,0)) 
			__0__.text=__0__.output.contents() 
			return smalltalk.if_true_false_(__0__.text.size()._gt(smalltalk.Number(0)),smalltalk.blk(__blk5__,0),nil) 
		def __blk6__(ex):
			__1__=smalltalk.newContext()
			def __blk7__(_s8_rec):
				_s8_rec.cr() 
				return _s8_rec.nextPutAll_(__1__.reason) 
			__1__.reason=nil
			__1__.reason=smalltalk.to_String(ex) 
			__blk7__(__0__.output).contents().outputToFile_(smalltalk.object_comma_(fileName,smalltalk.String(".error.txt"))) 
			self.print_(__1__.reason) 
			return smalltalk.raise_result_(_s8Ret_,__1__.reason) 
		__0__.output=nil
		__0__.nativeFileName=nil
		__0__.text=nil
		__0__.nativeFileName=smalltalk.object_comma_(smalltalk.object_comma_(fileName,smalltalk.String(".")),smalltalk.String.nativeFileExtension()) 
		if smalltalk.b(self.isFile_olderThan_(fileName,__0__.nativeFileName)):
			self.fileInJS_(__0__.nativeFileName) 
			smalltalk.raise_result_(_s8Ret_,fileContents(__0__.nativeFileName)) 
		 
		__0__.output=smalltalk.String("").writeStream() 
		if smalltalk.b(smalltalk.notNil_(initial)):
			__0__.output.nextPutAll_(initial) 
		 
		self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("emmit('"),fileName),smalltalk.String("')"))) 
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk6__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.text) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_emmit_startingWith_")
,"Builders-emmiting","""emmit: fileName startingWith: initial
	" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. "

	| output nativeFileName text |
	nativeFileName := fileName ,$. ,String nativeFileExtension.
	(self isFile: fileName olderThan: nativeFileName) ifTrue: [
		self fileInJS: nativeFileName.
		^# #fileContents: nativeFileName
	].
	output := '' writeStream.
	initial notNil ifTrue: [ output nextPutAll: initial ].
	self note: 'emmit(''' ,fileName ,''')'.
[	self	printingWith: [:what|
			text := '' ,what.
			output cr; nextPutAll: text
		] do: [ self fileIn: fileName ].
	text := output contents.
	text size > 0 ifTrue: [ text outputToFile: nativeFileName ].
]	on: Exception do: [:ex| | reason |
	reason := ex toString.
	(output cr; nextPutAll: reason) contents outputToFile: fileName ,'.error.txt'.
	self print: reason.
	^reason
].	^text""",nil)
smalltalk.bind(smalltalk.Object,"emmit:",0
,smalltalk.__f__("""(self,fileName):
	#Object>>#emmit:
	if not smalltalk.b(fileName.isString()):
		return fileName.asArray().emmit() 
	 
	return self.emmit_startingWith_(fileName,nil) 
""","Object_emmit_")
,"Builders-emmiting","""emmit: fileName
	" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. "

	fileName isString ifFalse: [ ^fileName asArray emmit ].
	^self emmit: fileName startingWith: nil """,nil)
smalltalk.bind(smalltalk.Object,"asJS",0
,smalltalk.__f__("""(self):
	#Object>>#asJS
	return smalltalk.NativeHandle.support()._at(self) 
""","Object_asJS")
,"Natives-converting","""asJS
	" Convert the receiver to JS instance (for reflection). "

	^NativeHandle support @ self""",nil)
smalltalk.bind(smalltalk.Object,"asNativeHandle",0
,smalltalk.__f__("""(self):
	#Object>>#asNativeHandle
	return smalltalk.NativeHandle.support()._at(self) 
""","Object_asNativeHandle")
,"Natives-converting","""asNativeHandle
	" Convert the receiver to NativeHandle instance (for reflection). "

	^NativeHandle support @ self""",nil)
smalltalk.bind(smalltalk.Object,"handleOf:",0
,smalltalk.__f__("""(self,nativeObject):
	#Object>>#handleOf:
	def __blk1__():
		def __blk2__():
			return smalltalk.notNil_(smalltalk.asObject_(nativeObject.handle)) 
		def __blk3__():
			return nativeObject.handle() 
		def __blk4__():
			return nativeObject 
		return smalltalk.if_true_false_(smalltalk.boolean_and_(self.isObject_(nativeObject),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
	def __blk5__():
		return smalltalk.NativeObject.undefined() 
	return smalltalk.if_true_false_(smalltalk.notNil_(nativeObject),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk5__,0)) 
""","Object_handleOf_")
,"Natives-converting","""handleOf: nativeObject
	" Private - Return the handle of nativeObject (or the nativeObject). "

	^nativeObject notNil ifTrue: [
		((self isObject: nativeObject)
		and: [ nativeObject[#handle] notNil ])
		ifTrue: [ nativeObject handle ]
		ifFalse: [ nativeObject ]
	] ifFalse: [ NativeObject undefined ]""",nil)
smalltalk.bind(smalltalk.Object,"asPython",0
,smalltalk.__f__("""(self):
	#Object>>#asPython
	return smalltalk.asString_(self) 
""","Object_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver.
	The default implementation return the receiver as a String.
	This method must be refined by subclasses implementing native literal representation.
	"

	^self asString """,nil)
smalltalk.bind(smalltalk.Object,"asPythonContents",0
,smalltalk.__f__("""(self):
	#Object>>#asPythonContents
	return self.asPython() 
""","Object_asPythonContents")
,"Python-py","""asPythonContents
	" Return the native representation of the receiver in contents of aCollection. "

	^self asPython """,nil)
smalltalk.bind(smalltalk.Object,"__tostring",0
,smalltalk.__f__("""(self):
	#Object>>#__tostring
	return smalltalk.to_String(self) 
""","Object___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Object,"running:",0
,smalltalk.__f__("""(self,aTitle):
	#Object>>#running:
	print(aTitle) 
	return smalltalk.true 
""","Object_running_")
,"_tests_","""running: aTitle
	" Test - Notify we are running test aTitle. "

	# #print: aTitle.
	^true """,nil)
smalltalk.bind(smalltalk.Object,"__test",0
,smalltalk.__f__("""(self):
	#Object>>#__test
	return smalltalk.isObject_equalTo_(smalltalk.is_kindOf_(smalltalk.Number(5)._at(smalltalk.Number(3)),(nil)),smalltalk.false) 
""","Object___test")
,"_tests_","""__test	"
	PythonEncoder export: Object>>#__test
	"

	^(5@3 isKindOf: nil) = false """,nil)
smalltalk.bind(smalltalk.Object,"test_CaptureStack",0
,smalltalk.__f__("""(self):
	#Object>>#test_CaptureStack
	def __blk1__():
		return self.error_(smalltalk.String("Intentional error")) 
	def __blk2__(ex):
		return smalltalk.Smalltalk.at_put_(smalltalk.String("Captured"),ex) 
	smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,1)) 
	return smalltalk.true 
""","Object_test_CaptureStack")
,"_tests_","""test_CaptureStack
	[ self error: 'Intentional error'
	] on: Exception do: [:ex|
		Smalltalk at: #Captured put: ex
	].
	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_HashedSet",0
,smalltalk.__f__("""(self):
	#Object>>#test_HashedSet
	__0__=smalltalk.newContext()
	__0__.array=nil
	__0__.test=nil
	__0__.array=smalltalk.newArray(["1","2","new","point","window","toString","valueOf","nil","last"]) 
	__0__.test=smalltalk.HashedSet.withAll_(__0__.array) 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.test.size(),__0__.array.size())):
		return self.testError_(smalltalk.String("Wrong size")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.test.asArray().sorted().asLiteral(),__0__.array.sorted().asLiteral())):
		return self.testError_(smalltalk.String("Invalid contents")) 
	 
	if smalltalk.b(__0__.test.includes_(smalltalk.String("missing"))):
		return self.testError_(smalltalk.String("Includes #missing")) 
	 
	if not smalltalk.b(__0__.test.includes_(smalltalk.String("toString"))):
		return self.testError_(smalltalk.String("#toString is missing")) 
	 
	return smalltalk.true 
""","Object_test_HashedSet")
,"_tests_","""test_HashedSet
	| array test |
	array := #(#1 #2 new point window toString valueOf #nil last).
	test := HashedSet withAll: array.

	test size = array size ifFalse: [ ^self testError: 'Wrong size' ].
	test asArray sorted asLiteral = array sorted asLiteral ifFalse: [ ^self testError: 'Invalid contents' ].

	(test includes: #missing) ifTrue: [ ^self testError: 'Includes #missing' ].
	(test includes: #toString) ifFalse: [ ^self testError: '#toString is missing' ].

	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_Pool",0
,smalltalk.__f__("""(self):
	#Object>>#test_Pool
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.test.at_put_(smalltalk.to_String(each),each) 
	__0__.array=nil
	__0__.test=nil
	__0__.array=smalltalk.newArray(["1","2","new","point","window","toString","valueOf","nil","last"]) 
	__0__.test=smalltalk.PoolDictionary.new() 
	__0__.array.do_(smalltalk.blk(__blk1__,1)) 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.test.size(),__0__.array.size())):
		return self.testError_(smalltalk.String("Wrong size")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.test.values().asArray().sorted().asLiteral(),__0__.array.sorted().asLiteral())):
		return self.testError_(smalltalk.String("Invalid contents")) 
	 
	if smalltalk.b(__0__.test.includesKey_(smalltalk.String("missing"))):
		return self.testError_(smalltalk.String("Includes #missing")) 
	 
	if not smalltalk.b(__0__.test.includesKey_(smalltalk.String("toString"))):
		return self.testError_(smalltalk.String("#toString is missing")) 
	 
	return smalltalk.true 
""","Object_test_Pool")
,"_tests_","""test_Pool
	| array test |
	array := #(#1 #2 new point window toString valueOf #nil last).
	test := PoolDictionary new.
	array do: [:each| test at: each toString put: each ].

	test size = array size ifFalse: [ ^self testError: 'Wrong size' ].
	test values asArray sorted asLiteral = array sorted asLiteral ifFalse: [ ^self testError: 'Invalid contents' ].
 
	(test includesKey: #missing) ifTrue: [ ^self testError: 'Includes #missing' ].
	(test includesKey: #toString) ifFalse: [ ^self testError: '#toString is missing' ].

	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_Point",0
,smalltalk.__f__("""(self):
	#Object>>#test_Point
	__0__=smalltalk.newContext()
	__0__.p=nil
	__0__.c=nil
	__0__.p=smalltalk.Number(5)._at(smalltalk.Number(5)) 
	__0__.c=__0__.p.copy().x_(smalltalk.Number(10)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.p.x(),smalltalk.Number(10))):
		return self.testError_(smalltalk.String("Wrong value in (p) x")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.c.x(),smalltalk.Number(10))):
		return self.testError_(smalltalk.String("Wrong value in (c) x")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(smalltalk.Number(5)._at(smalltalk.Number(5)),__0__.p)):
		return self.testError_(smalltalk.String("Wrong point, must be 5@5")) 
	 
	return smalltalk.true 
""","Object_test_Point")
,"_tests_","""test_Point
	| p c |
	p := 5@5.
	c := p copy x: 10.
	p x = 10 ifTrue: [ ^self testError: 'Wrong value in (p) x'].
	c x = 10 ifFalse: [ ^self testError: 'Wrong value in (c) x'].
	5 @ 5 = p ifFalse: [ ^self testError: 'Wrong point, must be 5@5' ].
	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_Rectangle",0
,smalltalk.__f__("""(self):
	#Object>>#test_Rectangle
	__0__=smalltalk.newContext()
	__0__.t=nil
	__0__.c=nil
	__0__.t=smalltalk.Number(5)._at(smalltalk.Number(5)).extent_(smalltalk.Number(10)._at(smalltalk.Number(10))) 
	__0__.c=__0__.t.copy().leftTop_(smalltalk.Number(10)._at(smalltalk.Number(10))) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.t.leftTop().x(),smalltalk.Number(10))):
		return self.testError_(smalltalk.String("Wrong t")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.c.leftTop().x(),smalltalk.Number(10))):
		return self.testError_(smalltalk.String("Wrong c")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(smalltalk.Number(5)._at(smalltalk.Number(5))._plus(smalltalk.Number(5)),__0__.c.leftTop())):
		return self.testError_(smalltalk.String("Wrong leftTop")) 
	 
	return smalltalk.true 
""","Object_test_Rectangle")
,"_tests_","""test_Rectangle
	| t c |
	t := 5@5 extent: 10@10.
	c := t copy leftTop: 10@10.
	t leftTop x = 10 ifTrue: [ ^self testError: 'Wrong t'].
	c leftTop x = 10 ifFalse: [ ^self testError: 'Wrong c'].
	5 @ 5 + 5 = c leftTop ifFalse: [ ^self testError: 'Wrong leftTop' ].
	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_RecursiveCallToBlock",0
,smalltalk.__f__("""(self):
	#Object>>#test_RecursiveCallToBlock
	__0__=smalltalk.newContext()
	def __blk1__(i,max):
		self.print_(smalltalk.object_comma_(smalltalk.String(">"),i)) 
		if smalltalk.b(i._lt(max)):
			__0__.aBlock.value_value_(i._plus(smalltalk.Number(1)),max) 
		 
		return self.print_(smalltalk.object_comma_(smalltalk.String("<"),i)) 
	def __blk2__(count):
		self.print_(smalltalk.object_comma_(smalltalk.String("max = "),count)) 
		return __0__.aBlock.value_value_(smalltalk.Number(1),count) 
	__0__.aBlock=nil
	__0__.aBlock=smalltalk.blk(__blk1__,2) 
	smalltalk.Number(1).to_by_do_(smalltalk.Number(100),smalltalk.Number(20),smalltalk.blk(__blk2__,1)) 
	return smalltalk.true 
""","Object_test_RecursiveCallToBlock")
,"_tests_","""test_RecursiveCallToBlock
	| aBlock |
	aBlock := [:i :max|
		self print: $> ,i.
		i < max ifTrue: [ aBlock value: i + 1 value: max ].
		self print: $< ,i.
	].
	1 to: 100 by: 20 do: [:count|
		self print: 'max = ',count.
		aBlock value: 1 value: count
	].

	^true""",nil)
smalltalk.bind(smalltalk.Object,"test_Early",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#test_Early
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.false 
		def __blk2__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		__0__.blk1=nil
		__0__.blk2=nil
		__0__.blk1=smalltalk.blk(__blk1__,0) 
		if smalltalk.b(__0__.blk1.value()):
			smalltalk.raise_result_(_s8Ret_,self.testError_(smalltalk.String("Should not happen"))) 
		 
		__0__.blk2=smalltalk.blk(__blk2__,0) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.booleanNot_(__0__.blk2.value())) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_test_Early")
,"_tests_","""test_Early	"
	PythonEncoder export: Object>>#test_Early
	"
	| blk1 blk2 |
	blk1 := [ false ].
	blk1 value ifTrue: [ ^self testError: 'Should not happen' ].
	blk2 := [ ^true ].
	^blk2 value not""",nil)
smalltalk.bind(smalltalk.Object,"test_Inject",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#test_Inject
		__0__=smalltalk.newContext()
		def __blk1__(pool,key):
			__1__=smalltalk.newContext()
			__1__.x=nil
			__1__.x=pool._at(key) 
			if smalltalk.b(smalltalk.isNil_(__1__.x)):
				smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			 
			return __1__.x 
		__0__.result=nil
		__0__.result=smalltalk.newArray(["Boolean",1]).inject_into_(smalltalk.Smalltalk.current(),smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_test_Inject")
,"_tests_","""test_Inject	"
	PythonEncoder export: Object>>#test_Inject
	"
	| result |
	result := #(Boolean 1) inject: Smalltalk current into: [:pool :key| | x |
		x := pool @ key.
		x isNil ifTrue: [ ^false ].
		x
	].
	^result""",nil)
smalltalk.bind(smalltalk.Object,"test_InjectSimple",0
,smalltalk.__f__("""(self):
	#Object>>#test_InjectSimple
	def __blk1__(pool,key):
		return pool._at(key) 
	return smalltalk.newArray(["Boolean",1]).inject_into_(smalltalk.Smalltalk.current(),smalltalk.blk(__blk1__,2)) 
""","Object_test_InjectSimple")
,"_tests_","""test_InjectSimple	"
	PythonEncoder export: Object>>#test_InjectSimple
	"
	^#(Boolean 1) inject: Smalltalk current into: [:pool :key| pool @ key ] """,nil)
smalltalk.bind(smalltalk.Object,"test_SuperInstanceSend",0
,smalltalk.__f__("""(self):
	#Object>>#test_SuperInstanceSend
	return smalltalk.Object 
""","Object_test_SuperInstanceSend")
,"_tests_","""test_SuperInstanceSend	"
	PythonEncoder export: Object>>#test_SuperInstanceSend
	"
	^Object """,nil)
smalltalk.bind(smalltalk.Object,"test_SuperSendClass",0
,smalltalk.__f__("""(self):
	#Object>>#test_SuperSendClass
	return (self).__class__ 
""","Object_test_SuperSendClass")
,"_tests_","""test_SuperSendClass	"
	PythonEncoder export: Object>>#test_SuperSendClass
	"
	^self class """,nil)
smalltalk.bind(smalltalk.Object,"test_strSize",0
,smalltalk.__f__('''(self):
	#Object>>#test_strSize
	return smalltalk.isObject_equalTo_(smalltalk.String("""1
	2
	3""").size(),smalltalk.Number(5)) 
''',"Object_test_strSize")
,"_tests_","""test_strSize
	^'1
2
3' size = 5""",nil)
smalltalk.bind(smalltalk.Object,"test_streamLines",0
,smalltalk.__f__('''(self):
	#Object>>#test_streamLines
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("""1
	2
	3""").stream() 
	return smalltalk.isObject_equalTo_(smalltalk.Array.with_with_with_(__0__.stream.nextLine(),__0__.stream.nextLine(),__0__.stream.nextLine()),smalltalk.newArray(["1","2","3"])) 
''',"Object_test_streamLines")
,"_tests_","""test_streamLines	"
	PythonEncoder export: Object>>#test_streamLines	
	"
	| stream |
	stream := '1
2
3' stream.
	^(Array	with: stream nextLine
		with: stream nextLine
		with: stream nextLine) = #( #1 #2 #3 )""",nil)
smalltalk.bind(smalltalk.Object,"test_ws",0
,smalltalk.__f__("""(self):
	#Object>>#test_ws
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.ws=nil
	__0__.stream=smalltalk.String("sample |x|x:= ((((((12 - 3)))))). self note: x ").stream() 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.stream.size(),smalltalk.Number(47))):
		self.note_(smalltalk.String("Invalid stream size")) 
		return smalltalk.false 
	 
	__0__.ws=smalltalk.SmalltalkParser.new().methodParserParts().first() 
	__0__.stream.position_(smalltalk.Number(28)) 
	return smalltalk.isObject_equalTo_(__0__.ws.parse_(__0__.stream),smalltalk.newArray([" "])) 
""","Object_test_ws")
,"_tests_","""test_ws	"
	PythonEncoder export: Object>>#test_ws	
	"
	| stream ws |
	stream := 'sample |x|x:= ((((((12 - 3)))))). self note: x ' stream.
	stream size = 47 ifFalse: [
		self note: 'Invalid stream size'.
		^false
	].
	ws := SmalltalkParser new methodParserParts first.
	stream position: 28.
	^(ws parse: stream) = #(' ')""",nil)
smalltalk.bind(smalltalk.Object,"test1",0
,smalltalk.__f__("""(self):
	#Object>>#test1
	return self.running_(smalltalk.String("[60] superSends on class side")) 
""","Object_test1")
,"_tests_","""test1
	" 
	PythonEncoder export: Object>>#test1
	^self running: '[60] superSends on class side'
	 "

	^self running: '[60] superSends on class side'""",nil)
smalltalk.bind(smalltalk.Object,"test2",0
,smalltalk.__f__("""(self):
	#Object>>#test2
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.ok=smalltalk.isObject_equalTo_(smalltalk.Number(7)._plus(smalltalk.Number(3)),smalltalk.Point.sample())
		return __0__.ok 
	def __blk2__(ex):
		return self.note_(ex.description()) 
	__0__.ok=nil
	__0__.ok=smalltalk.false 
	smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,1)) 
	return __0__.ok 
""","Object_test2")
,"_tests_","""test2
	" 
	PythonEncoder export: Object>>#test2
	|ok| ok := false. [ ok := 7 + 3 = Point sample ] on: Exception do: [:ex| self note: ex description ]. ^ok
	 "

	|ok| ok := false. [ ok := 7 + 3 = Point sample ] on: Exception do: [:ex| self note: ex description ]. ^ok""",nil)
smalltalk.bind(smalltalk.Object,"test3",0
,smalltalk.__f__("""(self):
	#Object>>#test3
	return self.running_(smalltalk.String("fileMeIn.st tests")) 
""","Object_test3")
,"_tests_","""test3
	" 
	PythonEncoder export: Object>>#test3
	^self running: 'fileMeIn.st tests'
	 "

	^self running: 'fileMeIn.st tests'""",nil)
smalltalk.bind(smalltalk.Object,"test4",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#Object>>#test4
		def __blk1__():
			return smalltalk.String("fileMeIn.st").fileContents().fileIn() 
		def __blk2__(ex):
			self.note_(ex) 
			return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Error,smalltalk.blk(__blk2__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Object_test4")
,"_tests_","""test4
	" 
	PythonEncoder export: Object>>#test4
	[ 'fileMeIn.st' fileContents fileIn ] on: Error do: [:ex| self note: ex. ^false ]. ^true
	 "

	[ 'fileMeIn.st' fileContents fileIn ] on: Error do: [:ex| self note: ex. ^false ]. ^true""",nil)
smalltalk.bind(smalltalk.Object,"test5",0
,smalltalk.__f__("""(self):
	#Object>>#test5
	return self.running_(smalltalk.String("---done-----------------------------------")) 
""","Object_test5")
,"_tests_","""test5
	" 
	PythonEncoder export: Object>>#test5
	^self running: '---done-----------------------------------'
	 "

	^self running: '---done-----------------------------------'""",nil)
smalltalk.bind(smalltalk.Object,"test6",0
,smalltalk.__f__("""(self):
	#Object>>#test6
	return self.running_(smalltalk.String("End of tests0-----------------------------")) 
""","Object_test6")
,"_tests_","""test6
	" 
	PythonEncoder export: Object>>#test6
	^self running: 'End of tests0-----------------------------'
	 "

	^self running: 'End of tests0-----------------------------'""",nil)
smalltalk.bind(smalltalk.Object,"test7",0
,smalltalk.__f__("""(self):
	#Object>>#test7
	return smalltalk.isObject_equalTo_(smalltalk.String("finished").last(),smalltalk.String("d")) 
""","Object_test7")
,"_tests_","""test7
	" 
	PythonEncoder export: Object>>#test7
	^#finished last = $d
	 "

	^#finished last = $d""",nil)
smalltalk.bind(smalltalk.Object,"testAll",0
,smalltalk.__f__("""(self):
	#Object>>#testAll
	print(smalltalk.String("test #1 - ^self running: '[60] superSends on class side'")) 
	if not smalltalk.b(self.test1()):
		print(smalltalk.String("	Failed test #1").asParameter()) 
	 
	print(smalltalk.String("test #2 - |ok| ok := false. [ ok := 7 + 3 = Point sample ] on: Exception do: [:ex| self note: ex description ]. ^ok")) 
	if not smalltalk.b(self.test2()):
		print(smalltalk.String("	Failed test #2").asParameter()) 
	 
	print(smalltalk.String("test #3 - ^self running: 'fileMeIn.st tests'")) 
	if not smalltalk.b(self.test3()):
		print(smalltalk.String("	Failed test #3").asParameter()) 
	 
	print(smalltalk.String("test #4 - [ 'fileMeIn.st' fileContents fileIn ] on: Error do: [:ex| self note: ex. ^false ]. ^true")) 
	if not smalltalk.b(self.test4()):
		print(smalltalk.String("	Failed test #4").asParameter()) 
	 
	print(smalltalk.String("test #5 - ^self running: '---done-----------------------------------'")) 
	if not smalltalk.b(self.test5()):
		print(smalltalk.String("	Failed test #5").asParameter()) 
	 
	print(smalltalk.String("test #6 - ^self running: 'End of tests0-----------------------------'")) 
	if not smalltalk.b(self.test6()):
		print(smalltalk.String("	Failed test #6").asParameter()) 
	 
	print(smalltalk.String("test #7 - ^#finished last = $d")) 
	if not smalltalk.b(self.test7()):
		print(smalltalk.String("	Failed test #7").asParameter()) 
	 
	return self 
""","Object_testAll")
,"_tests_","""testAll
	" 
	PythonEncoder export: Object>>#testAll
	 "

	
	# #print: 'test #1 - ^self running: ''[60] superSends on class side'''.
	self test1 ifFalse: [ # #print: '	Failed test #1' asParameter ].
	# #print: 'test #2 - |ok| ok := false. [ ok := 7 + 3 = Point sample ] on: Exception do: [:ex| self note: ex description ]. ^ok'.
	self test2 ifFalse: [ # #print: '	Failed test #2' asParameter ].
	# #print: 'test #3 - ^self running: ''fileMeIn.st tests'''.
	self test3 ifFalse: [ # #print: '	Failed test #3' asParameter ].
	# #print: 'test #4 - [ ''fileMeIn.st'' fileContents fileIn ] on: Error do: [:ex| self note: ex. ^false ]. ^true'.
	self test4 ifFalse: [ # #print: '	Failed test #4' asParameter ].
	# #print: 'test #5 - ^self running: ''---done-----------------------------------'''.
	self test5 ifFalse: [ # #print: '	Failed test #5' asParameter ].
	# #print: 'test #6 - ^self running: ''End of tests0-----------------------------'''.
	self test6 ifFalse: [ # #print: '	Failed test #6' asParameter ].
	# #print: 'test #7 - ^#finished last = $d'.
	self test7 ifFalse: [ # #print: '	Failed test #7' asParameter ].""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"current",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#current
	return smalltalk 
""","Smalltalk_class_current")
,"accessing","""current
	" Return the current instance of the receiver. "

	^#{smalltalk} """,nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"at:ifAbsent:",0
,smalltalk.__f__("""(self,aGlobalName,aBlock):
	#Smalltalk class>>#at:ifAbsent:
	return smalltalk.basic_at_ifAbsent_(self.current(),aGlobalName,aBlock) 
""","Smalltalk_class_at_ifAbsent_")
,"accessing","""at: aGlobalName ifAbsent: aBlock
	" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock. "

	^self current basicAt: aGlobalName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"includesKey:",0
,smalltalk.__f__("""(self,aGlobalName):
	#Smalltalk class>>#includesKey:
	return self.current().includesKey_(aGlobalName) 
""","Smalltalk_class_includesKey_")
,"testing","""includesKey: aGlobalName
	" Return true if the global aGlobalName is defined in the receiver. "

	^self current includesKey: aGlobalName""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"at:",0
,smalltalk.__f__("""(self,aGlobalName):
	#Smalltalk class>>#at:
	def __blk1__():
		return nil 
	return smalltalk.basic_at_ifAbsent_(self.current(),aGlobalName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_class_at_")
,"accessing","""at: aGlobalName
	" Return the global known as aGlobalName in the receiver (or nil). "

	^self current basicAt: aGlobalName ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"at:put:",0
,smalltalk.__f__("""(self,aGlobalName,anObject):
	#Smalltalk class>>#at:put:
	return smalltalk.basic_at_put_(self.current(),aGlobalName,anObject) 
""","Smalltalk_class_at_put_")
,"accessing","""at: aGlobalName put: anObject
	" Set the global known as aGlobalName in the receiver top anObject. "

	^self current basicAt: aGlobalName put: anObject""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"at:ifAbsentPut:",0
,smalltalk.__f__("""(self,aGlobalName,aBlock):
	#Smalltalk class>>#at:ifAbsentPut:
	def __blk1__():
		return self.at_put_(aGlobalName,aBlock.value()) 
	return self.at_ifAbsent_(aGlobalName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_class_at_ifAbsentPut_")
,"accessing","""at: aGlobalName ifAbsentPut: aBlock
	" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.
	Set the global to return value if was absent.
	"

	^self at: aGlobalName ifAbsent: [
		self at: aGlobalName put: aBlock value
	]""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"removeKey:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#Smalltalk class>>#removeKey:ifAbsent:
	return self.current().removeKey_ifAbsent_(aKey,aBlock) 
""","Smalltalk_class_removeKey_ifAbsent_")
,"removing","""removeKey: aKey ifAbsent: aBlock
	" Remove the binding at aKey. "

	^self current removeKey: aKey ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"@","_at"
,smalltalk.__f__("""(self,aGlobalName):
	_s8Ret_=smalltalk.newContext()
	try:
		#Smalltalk class>>#@
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.Array.new()) 
		__0__.binding=nil
		__0__.binding=self.at_ifAbsent_(aGlobalName,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.Array.with_(__0__.binding)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Smalltalk_class__at")
,"accessing","""@ aGlobalName
	" Return a collection with the objects bound to aGlobalName (or an empty collection if global is not defined).
	It is used in expressions like:
		Smalltalk @ #MyGlobal do: [:global| ... ]
	"

	| binding |
	binding := self at: aGlobalName ifAbsent: [ ^Array new ].
	^Array with: binding""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"definePool:with:",0
,smalltalk.__f__("""(self,poolName,tuples):
	#Smalltalk class>>#definePool:with:
	return self.current().definePool_with_(poolName,tuples) 
""","Smalltalk_class_definePool_with_")
,"accessing","""definePool: poolName with: tuples
	" Define the pool dictionary. "

	^self current definePool: poolName with: tuples""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"poolDictionary:ifAbsent:",0
,smalltalk.__f__("""(self,aPoolName,aBlock):
	#Smalltalk class>>#poolDictionary:ifAbsent:
	return self.current().poolDictionary_ifAbsent_(aPoolName,aBlock) 
""","Smalltalk_class_poolDictionary_ifAbsent_")
,"accessing","""poolDictionary: aPoolName ifAbsent: aBlock
	" Return the pool dictionary named aPoolName or the result of evaluating aBlock. "

	^self current poolDictionary: aPoolName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"objectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk class>>#objectAt:ifAbsent:
	return self.current().objectAt_ifAbsent_(aName,aBlock) 
""","Smalltalk_class_objectAt_ifAbsent_")
,"accessing","""objectAt: aName ifAbsent: aBlock
	" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). "

	^self current objectAt: aName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"jsObjectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk class>>#jsObjectAt:ifAbsent:
	self.note_(smalltalk.object_comma_(smalltalk.String("OBSOLETE"),smalltalk.String(" - jsObjectAt:ifAbsent: "))) 
	return self.current().nativeObjectAt_ifAbsent_(aName,aBlock) 
""","Smalltalk_class_jsObjectAt_ifAbsent_")
,"accessing","""jsObjectAt: aName ifAbsent: aBlock
	" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). "

self note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.
	^self current nativeObjectAt: aName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"jsObjectAt:",0
,smalltalk.__f__("""(self,aName):
	#Smalltalk class>>#jsObjectAt:
	def __blk1__():
		return self.error_(smalltalk.object_comma_(smalltalk.String("Undefined "),aName)) 
	self.note_(smalltalk.object_comma_(smalltalk.String("OBSOLETE"),smalltalk.String(" - jsObjectAt: "))) 
	return self.nativeObjectAt_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_class_jsObjectAt_")
,"accessing","""jsObjectAt: aName
	" OBSOLETE - Return the (global) object at aName. "

self note: #OBSOLETE ,' - jsObjectAt: '.
	^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"nativeObjectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk class>>#nativeObjectAt:ifAbsent:
	return self.current().nativeObjectAt_ifAbsent_(aName,aBlock) 
""","Smalltalk_class_nativeObjectAt_ifAbsent_")
,"accessing","""nativeObjectAt: aName ifAbsent: aBlock
	" Return the (global) object at aName or the result of evaluating aBlock (if undefined). "

	^self current nativeObjectAt: aName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"nativeObjectAt:",0
,smalltalk.__f__("""(self,aName):
	#Smalltalk class>>#nativeObjectAt:
	def __blk1__():
		return self.error_(smalltalk.object_comma_(smalltalk.String("Undefined "),aName)) 
	return self.nativeObjectAt_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_class_nativeObjectAt_")
,"accessing","""nativeObjectAt: aName
	" Return the (global) object at aName. "

	^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"global","_8global"
,smalltalk.__f__("""(self):
	#Smalltalk class>>#global
	return globals() 
""","Smalltalk_class__8global")
,"accessing","""global
	" Return the global context object. "

	^{''js'(function(){return this;}).call(null)'}""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"install:as:",0
,smalltalk.__f__("""(self,aBlockClosure,functionName):
	#Smalltalk class>>#install:as:
	__0__=smalltalk.newContext()
	__0__.old=nil
	__0__.old=smalltalk.basic_at_(self._8global(),functionName) 
	smalltalk.basic_at_put_(self._8global(),functionName,aBlockClosure) 
	return __0__.old 
""","Smalltalk_class_install_as_")
,"installing","""install: aBlockClosure as: functionName
	" Install the aBlockClosure as a function in global scope. "

	| old |
	old := self global basicAt: functionName.
	self global basicAt: functionName put: aBlockClosure.
	^old""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"classes",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#classes
	return self.current().classes() 
""","Smalltalk_class_classes")
,"accessing","""classes
	" Return the classes defined in current instance. "

	^self current classes""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"rootClasses",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#rootClasses
	return self.current().rootClasses() 
""","Smalltalk_class_rootClasses")
,"accessing","""rootClasses
	" Return the collection of topLevel classes in the receiver. "

	^self current rootClasses""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"implementorsOf:",0
,smalltalk.__f__("""(self,aSymbol):
	#Smalltalk class>>#implementorsOf:
	return self.current().implementorsOf_(aSymbol) 
""","Smalltalk_class_implementorsOf_")
,"tools","""implementorsOf: aSymbol
	" Return the implementors of aSymbol. "

	^self current implementorsOf: aSymbol""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"isRunningOn:",0
,smalltalk.__f__("""(self,lang):
	#Smalltalk class>>#isRunningOn:
	return smalltalk.isObject_equalTo_(self.nativeLanguage(),lang) 
""","Smalltalk_class_isRunningOn_")
,"environment","""isRunningOn: lang
	" Private - Return true when running hosted by native lang execution environment. "

	^self nativeLanguage = lang""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"gc",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#gc
	if True:
		import gc
		return gc.collect()
	 
	return smalltalk.false 
""","Smalltalk_class_gc")
,"tools","""gc
	" Collect garbage. "

	{''js'if(typeof gc!="undefined"){gc(); return true}'}.
	^false""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"allMethodsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Smalltalk class>>#allMethodsDo:
	def __blk1__(each):
		each.methodsDo_(aBlock) 
		return (each).__class__.methodsDo_(aBlock) 
	self.classes().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Smalltalk_class_allMethodsDo_")
,"iterating","""allMethodsDo: aBlock
	" Evaluates aBlock for all the methods in the current instance. "

	self classes do: [:each|
		each methodsDo: aBlock.
		each class methodsDo: aBlock.
	]""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"allSelectorsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Smalltalk class>>#allSelectorsDo:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__1__=smalltalk.newContext()
		def __blk2__():
			if smalltalk.b(smalltalk.notNil_(aBlock)):
				aBlock.value_(__1__.selector) 
			 
			return __0__.found.add_(__1__.selector) 
		__1__.selector=nil
		__1__.selector=each.selector() 
		return smalltalk.if_true_false_(__0__.found.includes_(__1__.selector),nil,smalltalk.blk(__blk2__,0)) 
	__0__.found=nil
	__0__.found=smalltalk.HashedSet.new() 
	self.allMethodsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.found 
""","Smalltalk_class_allSelectorsDo_")
,"iterating","""allSelectorsDo: aBlock
	" Evaluates aBlock for all the selectors defined in the current instance. "

	| found |
	found := HashedSet new.
	self allMethodsDo: [:each| | selector |
		selector := each selector.
		(found includes: selector) ifFalse: [
			aBlock notNil ifTrue: [
				aBlock value: selector
			].
			found add: selector.
		]
	].
	^found""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"allSelectors",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#allSelectors
	return self.allSelectorsDo_(nil).sorted() 
""","Smalltalk_class_allSelectors")
,"iterating","""allSelectors
	" Return all the selectors (sorted) defined in the current instance. "

	^(self allSelectorsDo: nil) sorted""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"bindingsFor:",0
,smalltalk.__f__("""(self,aScope):
	#Smalltalk class>>#bindingsFor:
	return smalltalk.PoolDictionaryReader.new().scope_(aScope) 
""","Smalltalk_class_bindingsFor_")
,"Tools-variables","""bindingsFor: aScope
	" FileIn - Return a reader to fileIn bindings in a (global) scope.
	aScope can be a string or a dictionary.
	In case of aScope been a String, it will be considered a PoolDictionaryName
	See PoolDictionaryReader>>#scanFrom:
	"

	^PoolDictionaryReader new scope: aScope""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"sendersOf:",0
,smalltalk.__f__("""(self,selector):
	#Smalltalk class>>#sendersOf:
	return self.current().sendersOf_(selector) 
""","Smalltalk_class_sendersOf_")
,"Tools-query","""sendersOf: selector
	" Return the senders of message selector. "

	^self current sendersOf: selector""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"saveImageAs:",0
,smalltalk.__f__("""(self,fileName):
	#Smalltalk class>>#saveImageAs:
	self.current().saveImageAs_(fileName) 
	return self 
""","Smalltalk_class_saveImageAs_")
,"Snapshot-snapshot","""saveImageAs: fileName
	" Dump the image contents onto file at fileName. "

	self current saveImageAs: fileName""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"saveImage",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#saveImage
	self.current().saveImage() 
	return self 
""","Smalltalk_class_saveImage")
,"Snapshot-snapshot","""saveImage
	" Dump the image contents onto image file. "

	self current saveImage""",nil)
smalltalk.bind(smalltalk.Smalltalk.__class__,"exit",0
,smalltalk.__f__("""(self):
	#Smalltalk class>>#exit
	self.current().exit() 
	return self 
""","Smalltalk_class_exit")
,"Snapshot-exiting","""exit
	" Exit to OS system. "

	
	self current exit""",nil)
smalltalk.bind(smalltalk.Smalltalk,"globalAt:",0
,smalltalk.__f__("""(self,aKey):
	#Smalltalk>>#globalAt:
	return smalltalk.basic_at_(self,aKey) 
""","Smalltalk_globalAt_")
,"accessing","""globalAt: aKey
	" Return the global at aKey (or nil). "

	^self basicAt: aKey""",nil)
smalltalk.bind(smalltalk.Smalltalk,"globalAt:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#Smalltalk>>#globalAt:ifAbsent:
	return smalltalk.basic_at_ifAbsent_(self,aKey,aBlock) 
""","Smalltalk_globalAt_ifAbsent_")
,"accessing","""globalAt: aKey ifAbsent: aBlock
	" Return the global at aKey (or the result of evaluating aBlock). "

	^self basicAt: aKey ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"rootClasses",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#rootClasses
	def __blk1__(each):
		return smalltalk.isNil_(each.superclass()) 
	return self.classes().select_(smalltalk.blk(__blk1__,1)) 
""","Smalltalk_rootClasses")
,"accessing","""rootClasses
	" Return the collection of topLevel classes in the receiver. "

	^self classes select: [:each| each superclass isNil ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"at:",0
,smalltalk.__f__("""(self,aGlobalName):
	#Smalltalk>>#at:
	def __blk1__():
		return nil 
	return smalltalk.basic_at_ifAbsent_(self,aGlobalName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_at_")
,"accessing","""at: aGlobalName
	" Return the global known as aGlobalName in the receiver (or nil). "

	^self basicAt: aGlobalName ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"at:ifAbsent:",0
,smalltalk.__f__("""(self,aGlobalName,aBlock):
	#Smalltalk>>#at:ifAbsent:
	return smalltalk.basic_at_ifAbsent_(self,aGlobalName,aBlock) 
""","Smalltalk_at_ifAbsent_")
,"accessing","""at: aGlobalName ifAbsent: aBlock
	" Return the value at aKey or the result of evaluating aBlock. "

	^self basicAt: aGlobalName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"at:ifAbsentPut:",0
,smalltalk.__f__("""(self,aGlobalName,aBlock):
	#Smalltalk>>#at:ifAbsentPut:
	return self.basicAt_ifAbsentPut_(aGlobalName,aBlock) 
""","Smalltalk_at_ifAbsentPut_")
,"accessing","""at: aGlobalName ifAbsentPut: aBlock
	" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.
	Set the global to return value if was absent.
	"

	^self basicAt: aGlobalName ifAbsentPut: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"at:put:",0
,smalltalk.__f__("""(self,aGlobalName,anObject):
	#Smalltalk>>#at:put:
	return smalltalk.basic_at_put_(self,aGlobalName,anObject) 
""","Smalltalk_at_put_")
,"accessing","""at: aGlobalName put: anObject
	" Set the global known as aGlobalName in the receiver top anObject. "

	^self basicAt: aGlobalName put: anObject""",nil)
smalltalk.bind(smalltalk.Smalltalk,"includesKey:",0
,smalltalk.__f__("""(self,aGlobalName):
	#Smalltalk>>#includesKey:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.none 
	__0__.none=nil
	__0__.none=StObject(nil) 
	return smalltalk.booleanNot_(smalltalk.b_(smalltalk.basic_at_ifAbsent_(self,aGlobalName,smalltalk.blk(__blk1__,0)) is __0__.none)) 
""","Smalltalk_includesKey_")
,"testing","""includesKey: aGlobalName
	" Return true if the global aGlobalName is defined in the receiver. "

	| none |
	none := {''js'undefined'}.
	^((self
		basicAt: aGlobalName ifAbsent: [none])
		== none) not""",nil)
smalltalk.bind(smalltalk.Smalltalk,"implementorsOf:",0
,smalltalk.__f__("""(self,aSymbol):
	#Smalltalk>>#implementorsOf:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.addAll_(each.implementorsOf_(aSymbol)) 
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	self.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Smalltalk_implementorsOf_")
,"accessing","""implementorsOf: aSymbol
	" Return the implementors of aSymbol. "

	| result |
	result := #().
	self rootClasses do: [:each|
		result addAll: (each implementorsOf: aSymbol)
	].
	^result""",nil)
smalltalk.bind(smalltalk.Smalltalk,"objectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk>>#objectAt:ifAbsent:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result 
	__0__.result=nil
	__0__.result=self.nativeObjectAt_ifAbsent_(aName,aBlock) 
	return smalltalk.if_true_false_(smalltalk.notNil_(smalltalk.asObject_(__0__.result.yourself)),smalltalk.blk(__blk1__,0),nil) 
""","Smalltalk_objectAt_ifAbsent_")
,"accessing","""objectAt: aName ifAbsent: aBlock
	" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). "

	| result |
	result := self nativeObjectAt: aName ifAbsent: aBlock.
	^result#yourself notNil ifTrue: [ result ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"jsObjectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk>>#jsObjectAt:ifAbsent:
	self.note_(smalltalk.object_comma_(smalltalk.String("OBSOLETE"),smalltalk.String(" - jsObjectAt:ifAbsent: "))) 
	return self.nativeObjectAt_ifAbsent_(aName,aBlock) 
""","Smalltalk_jsObjectAt_ifAbsent_")
,"accessing","""jsObjectAt: aName ifAbsent: aBlock
	" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). "

self note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.
	^self nativeObjectAt: aName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"jsObjectAt:",0
,smalltalk.__f__("""(self,aName):
	#Smalltalk>>#jsObjectAt:
	def __blk1__():
		return self.error_(smalltalk.object_comma_(smalltalk.String("Undefined "),aName)) 
	self.note_(smalltalk.object_comma_(smalltalk.String("OBSOLETE"),smalltalk.String(" - jsObjectAt: "))) 
	return self.nativeObjectAt_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_jsObjectAt_")
,"accessing","""jsObjectAt: aName
	" OBSOLETE - Return the (global) object at aName. "

self note: #OBSOLETE ,' - jsObjectAt: '.
	^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"nativeObjectAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	#Smalltalk>>#nativeObjectAt:ifAbsent:
	return smalltalk.basic_at_ifAbsent_(smalltalk.Smalltalk._8global(),aName,aBlock) 
""","Smalltalk_nativeObjectAt_ifAbsent_")
,"accessing","""nativeObjectAt: aName ifAbsent: aBlock
	" Return the (global) object at aName or the result of evaluating aBlock (if undefined). "

	^Smalltalk global basicAt: aName ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"nativeObjectAt:",0
,smalltalk.__f__("""(self,aName):
	#Smalltalk>>#nativeObjectAt:
	def __blk1__():
		return self.error_(smalltalk.object_comma_(smalltalk.String("Undefined "),aName)) 
	return self.nativeObjectAt_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_nativeObjectAt_")
,"accessing","""nativeObjectAt: aName
	" Return the (global) object at aName. "

	^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"removeKey:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#Smalltalk>>#removeKey:ifAbsent:
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,aBlock.value()) 
		smalltalk.basic_at_ifAbsent_(self,aKey,smalltalk.blk(__blk1__,0)) 
		self.basicDelete_(aKey) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Smalltalk_removeKey_ifAbsent_")
,"removing","""removeKey: aKey ifAbsent: aBlock
	" Remove the binding at aKey. "

	self basicAt: aKey ifAbsent: [ ^aBlock value ].
	self basicDelete: aKey""",nil)
smalltalk.bind(smalltalk.Smalltalk,"definePool:",0
,smalltalk.__f__("""(self,poolName):
	#Smalltalk>>#definePool:
	return self.definePool_with_(poolName,smalltalk.Array.new()) 
""","Smalltalk_definePool_")
,"accessing","""definePool: poolName
	" Define the pool dictionary (if it is not defined yet). "

	^self definePool: poolName with: Array new""",nil)
smalltalk.bind(smalltalk.Smalltalk,"poolDictionary:ifAbsent:",0
,smalltalk.__f__("""(self,aPoolName,aBlock):
	#Smalltalk>>#poolDictionary:ifAbsent:
	def __blk1__():
		return aBlock.value() 
	return smalltalk.basic_at_ifAbsent_(self,aPoolName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_poolDictionary_ifAbsent_")
,"accessing","""poolDictionary: aPoolName ifAbsent: aBlock
	" Return the pool dictionary named aPoolName or the result of evaluating aBlock. "

	^self basicAt: aPoolName ifAbsent: [ aBlock value ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"poolDictionary:",0
,smalltalk.__f__("""(self,aPoolName):
	#Smalltalk>>#poolDictionary:
	def __blk1__():
		return self.definePool_(aPoolName) 
	return self.poolDictionary_ifAbsent_(aPoolName,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_poolDictionary_")
,"accessing","""poolDictionary: aPoolName
	" Return the pool dictionary named aPoolName. "

	^self poolDictionary: aPoolName ifAbsent: [
		"self error: 'Missing Pool dictionary: ',aPoolName. "
		self definePool: aPoolName
	]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"printDefinePool:with:",0
,smalltalk.__f__("""(self,poolName,tuples):
	#Smalltalk>>#printDefinePool:with:
	def __blk1__(tuple):
		def __blk2__():
			return self.print_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("	["),smalltalk.printString_(tuple.first())),smalltalk.String(",")),tuple.last().asNative()),smalltalk.String("],"))) 
		def __blk3__():
			return self.print_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("	"),tuple.asNative()),smalltalk.String(","))) 
		return smalltalk.if_true_false_(tuple.isArray(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	self.print_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk.definePool_with_("'),poolName),smalltalk.String('",['))) 
	tuples.do_(smalltalk.blk(__blk1__,1)) 
	self.print_(smalltalk.String("	]);")) 
	return self 
""","Smalltalk_printDefinePool_with_")
,"compiling","""printDefinePool: poolName with: tuples
	" DEBUG - Dump definition of the pool dictionary. "

	self print: 'smalltalk.definePool_with_("',poolName,'",['.
	tuples do: [:tuple|
		tuple isArray ifTrue: [
			self print: '	[',tuple first printString,',',tuple last asNative,'],'
		] ifFalse: [
			self print: '	',tuple asNative ,','
		]
	].
	self print: '	]);'.""",nil)
smalltalk.bind(smalltalk.Smalltalk,"definePool:with:",0
,smalltalk.__f__("""(self,poolName,tuples):
	#Smalltalk>>#definePool:with:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.basic_at_put_(self,poolName,smalltalk.PoolDictionary.new()) 
	def __blk2__(each):
		def __blk3__():
			def __blk4__():
				__0__.offset=each.last()._plus(smalltalk.Number(1))
				return __0__.offset 
			__0__.dictionary.at_put_(each.first(),each.last()) 
			return smalltalk.if_true_false_(each.last().isNumber(),smalltalk.blk(__blk4__,0),nil) 
		def __blk5__():
			def __blk6__():
				__0__.offset=each
				return __0__.offset 
			def __blk7__():
				__0__.dictionary.at_put_(each,__0__.offset) 
				__0__.offset=__0__.offset._plus(smalltalk.Number(1))
				return __0__.offset 
			return smalltalk.if_true_false_(each.isNumber(),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk7__,0)) 
		return smalltalk.if_true_false_(each.isArray(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk5__,0)) 
	__0__.dictionary=nil
	__0__.offset=nil
	__0__.dictionary=smalltalk.basic_at_ifAbsent_(self,poolName,smalltalk.blk(__blk1__,0)) 
	__0__.offset=smalltalk.Number(0) 
	tuples.do_(smalltalk.blk(__blk2__,1)) 
	return __0__.dictionary 
""","Smalltalk_definePool_with_")
,"compiling","""definePool: poolName with: tuples
	" Define the pool dictionary. "

	| dictionary offset |
	dictionary := self basicAt: poolName ifAbsent: [
		self basicAt: poolName put: PoolDictionary new
	].
	offset := 0.
	tuples do: [:each|
		each isArray ifTrue: [
			dictionary at: each first put: each last.
			each last isNumber ifTrue: [ offset := each last + 1 ].
		] ifFalse: [
			each isNumber ifTrue: [ offset := each ]
			ifFalse: [
				dictionary at: each put: offset.
				offset := offset + 1.
			]
		]
	].
	^dictionary""",nil)
smalltalk.bind(smalltalk.Smalltalk,"state",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#state
	return smalltalk.basic_at_(self,smalltalk.String("$state")) 
""","Smalltalk_state")
,"accessing","""state
	" Return the state of the receiver (or nil). "

	^self basicAt: '$state'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"state:",0
,smalltalk.__f__("""(self,aState):
	#Smalltalk>>#state:
	smalltalk.basic_at_put_(self,smalltalk.String("$state"),aState) 
	return self 
""","Smalltalk_state_")
,"accessing","""state: aState
	" Set the state of the receiver. "

	self basicAt: '$state' put: aState""",nil)
smalltalk.bind(smalltalk.Smalltalk,"withState:do:",0
,smalltalk.__f__("""(self,aState,aBlock):
	#Smalltalk>>#withState:do:
	__0__=smalltalk.newContext()
	def __blk1__():
		self.state_(aState) 
		return aBlock.value() 
	def __blk2__():
		return self.state_(__0__.old) 
	__0__.old=nil
	__0__.old=self.state() 
	return smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
""","Smalltalk_withState_do_")
,"accessing","""withState: aState do: aBlock
	" Set the state of the receiver to aState during execution of aBlock. "

	| old |
	old := self state.
	^[	self state: aState.
		aBlock value
	] ensure: [
		self state: old
	]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"@","_at"
,smalltalk.__f__("""(self,keyOrPath):
	_s8Ret_=smalltalk.newContext()
	try:
		#Smalltalk>>#@
		__0__=smalltalk.newContext()
		def __blk1__(pool,key):
			__1__=smalltalk.newContext()
			__1__.value=nil
			__1__.value=pool._at(key)
			if smalltalk.b(smalltalk.isNil_((__1__.value))):
				smalltalk.raise_result_(_s8Ret_,nil) 
			 
			return __1__.value 
		__0__.result=nil
		if not smalltalk.b(keyOrPath.isArray()):
			def __blk2__():
				nil 
			smalltalk.raise_result_(_s8Ret_,(self).__class__.at_ifAbsent_(keyOrPath,smalltalk.blk(__blk2__,0))) 
		 
		__0__.result=keyOrPath.inject_into_(self,smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Smalltalk__at")
,"accessing","""@ keyOrPath
	" Return the result of accessing the receiver at key or path (or nil). "

	| result |
	keyOrPath isArray ifFalse: [ ^self class at: keyOrPath ifAbsent: [] ].
	result := keyOrPath inject: self into: [:pool :key | | value |
		(value := pool @ key) isNil ifTrue: [ ^nil ].
		value
	].
	^result""",nil)
smalltalk.bind(smalltalk.Smalltalk,"eval:",0
,smalltalk.__f__('''(self,anExpression):
	#Smalltalk>>#eval:
	return smalltalk.__f__("""():
		"""+smalltalk.handleOf(anExpression))()
	 
	return self 
''',"Smalltalk_eval_")
,"eval","""eval: anExpression
	" Return the result of evaluating a native expression in global context. "

	{''js'return eval(anExpression)'}""",nil)
smalltalk.bind(smalltalk.Smalltalk,"eval:as:",0
,smalltalk.__f__("""(self,anExpression,aState):
	#Smalltalk>>#eval:as:
	def __blk1__():
		return self.eval_(anExpression) 
	return self.withState_do_(aState,smalltalk.blk(__blk1__,0)) 
""","Smalltalk_eval_as_")
,"eval","""eval: anExpression as: aState
	" Return the result of evaluating a native expression in global context.
	The state of the system change to state while evaluating the expression.
	"

	^self withState: aState do: [ self eval: anExpression ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"capture:with:",0
,smalltalk.__f__("""(self,keyOrPath,aBlock):
	#Smalltalk>>#capture:with:
	if smalltalk.b(smalltalk.isNil_(aBlock)):
		def __blk1__(result):
			return result 
		return self.capture_with_(keyOrPath,smalltalk.blk(__blk1__,1)) 
	 
	if smalltalk.b(smalltalk.isNil_(keyOrPath)):
		return aBlock.evaluateWith_(nil) 
	 
	if not smalltalk.b(keyOrPath.isString()):
		return self._at(keyOrPath) 
	 
	if smalltalk.b(keyOrPath.startsWith_(smalltalk.String("!"))):
		return aBlock.evaluateWith_(keyOrPath.fileIn()) 
	 
	if smalltalk.b(keyOrPath.startsWith_(smalltalk.String("@"))):
		return self._at(keyOrPath.asArrayOfSubstringsSeparatedBy_(smalltalk.String("@"))) 
	 
	if smalltalk.b(keyOrPath.startsWith_(smalltalk.String("."))):
		return self._at(keyOrPath.asArrayOfSubstringsSeparatedBy_(smalltalk.String("."))) 
	 
	if not smalltalk.b(smalltalk.responds_to_(self,(keyOrPath))):
		return aBlock.evaluateWith_(nil) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(keyOrPath.argumentCount(),smalltalk.Number(1))):
		return self.perform_with_(keyOrPath,aBlock) 
	 
	return aBlock.evaluateWith_(self.perform_(keyOrPath)) 
""","Smalltalk_capture_with_")
,"tools","""capture: keyOrPath with: aBlock
	" Capture keyOrPath of the receiver and evaluate aBlock.
	Default action will try to capture the object found and (potentially) evaluate aBlock with the result. "

	aBlock isNil ifTrue: [ ^self capture: keyOrPath with: [:result | result ] ].
	keyOrPath isNil ifTrue: [ ^aBlock evaluateWith: nil ].
	keyOrPath isString ifFalse: [ ^self @ keyOrPath ].
	(keyOrPath startsWith: $!) ifTrue: [ ^aBlock evaluateWith: keyOrPath fileIn ].
	(keyOrPath startsWith: $@) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $@) ].
	(keyOrPath startsWith: $.) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $.) ].
	(self respondsTo: keyOrPath) ifFalse: [ ^aBlock evaluateWith: nil ].
	keyOrPath argumentCount = 1 ifTrue: [ ^self perform: keyOrPath with: aBlock ].
	^aBlock evaluateWith: (self perform: keyOrPath)""",nil)
smalltalk.bind(smalltalk.Smalltalk,"removeSources",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#removeSources
	def __blk1__(each):
		return each.removeSources() 
	self.classes().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Smalltalk_removeSources")
,"tools","""removeSources
	" Remove all development sources of the receiver. "

	self classes do: [:each | each removeSources ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"readJSON:",0
,smalltalk.__f__("""(self,anObject):
	#Smalltalk>>#readJSON:
	return self.readJSObject(anObject) 
""","Smalltalk_readJSON_")
,"json","""readJSON: anObject
	" Return an object read from JSON map object anObject. "

	^self #readJSObject: anObject""",nil)
smalltalk.bind(smalltalk.Smalltalk,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#shallowCopy
	return self 
""","Smalltalk_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Smalltalk,"deepCopy",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#deepCopy
	return self 
""","Smalltalk_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Smalltalk,"recompileAll",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#recompileAll
	def __blk1__(each):
		return each.recompile() 
	self.classes().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Smalltalk_recompileAll")
,"Compiler-compiling","""recompileAll
	" Recompile all classes in the receiver. "

	self classes do: [:each | each recompile ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"compilerSupport",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#compilerSupport
	return smalltalk.Compiler 
""","Smalltalk_compilerSupport")
,"Compiler-accessing","""compilerSupport
	" Return the compiler support for the receiver. "

	^Compiler""",nil)
smalltalk.bind(smalltalk.Smalltalk,"fileInCode:",0
,smalltalk.__f__("""(self,code):
	#Smalltalk>>#fileInCode:
	def __blk1__():
		return code.stream().fileIn() 
	return smalltalk.if_true_false_(smalltalk.notNil_(code),smalltalk.blk(__blk1__,0),nil) 
""","Smalltalk_fileInCode_")
,"Tools-fileIn","""fileInCode: code
	" FileIn the code into the receiver. "

	^code notNil ifTrue: [ code stream fileIn ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"methodReferences",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#methodReferences
	return smalltalk.MethodReferences.new() 
""","Smalltalk_methodReferences")
,"Tools-accessing","""methodReferences
	" Return the methodReferences tool of the receiver. "

	^MethodReferences new""",nil)
smalltalk.bind(smalltalk.Smalltalk,"sendersOf:",0
,smalltalk.__f__("""(self,selector):
	#Smalltalk>>#sendersOf:
	return self.methodReferences().sendersOf_(selector) 
""","Smalltalk_sendersOf_")
,"Tools-query","""sendersOf: selector
	" Return the senders of message selector. "

	^self methodReferences sendersOf: selector""",nil)
smalltalk.bind(smalltalk.Smalltalk,"implementorsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Smalltalk>>#implementorsDo:
	def __blk1__(each):
		return each.implementorsDo_(aBlock) 
	return self.classes().do_(smalltalk.blk(__blk1__,1)) 
""","Smalltalk_implementorsDo_")
,"Tools-iterating","""implementorsDo: aBlock
	" Evaluates aBlock for each implementor in the receiver. "

	^self classes do: [:each| each implementorsDo: aBlock ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"implementors",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#implementors
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	self.implementorsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Smalltalk_implementors")
,"Tools-implementors","""implementors
	" Return a collection with all implementors in the receiver. "

	| result |
	result := #().
	self implementorsDo: [:each| result add: each].
	^result""",nil)
smalltalk.bind(smalltalk.Smalltalk,"exit",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#exit
	def __blk1__(each):
		return each.aboutToExit_(self) 
	self.classes().do_(smalltalk.blk(__blk1__,1)) 
	quit() 
	return self 
""","Smalltalk_exit")
,"Snapshot-exiting","""exit
	" Exit to OS system. "

	self classes do: [:each| each aboutToExit: self ].
	# quit""",nil)
smalltalk.bind(smalltalk.Smalltalk,"product",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#product
	return smalltalk.String("S8") 
""","Smalltalk_product")
,"Snapshot-accessing","""product
	" Private - Return the name of the system. "

	^#S8""",nil)
smalltalk.bind(smalltalk.Smalltalk,"description",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#description
	return smalltalk.String('A modern Smalltalk environment running on the "invisible machine".') 
""","Smalltalk_description")
,"Snapshot-accessing","""description
	" Return the description of the receiver. "

	^'A modern Smalltalk environment running on the "invisible machine".'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"licenseComment",0
,smalltalk.__f__('''(self):
	#Smalltalk>>#licenseComment
	return smalltalk.String("""
	The text you are reading here is the residue of something that has run before.
	Keep the system running with responsibility. Smalltalk is not the words,
	 nor any definition, nor it current contents...
	Smalltalk include your feelings when you see it running.
	Smalltalk is what happens when time flows and you "are" here.
	Stop reading/writing code (thinking you are outside the system),
	 change your world with resposibility, one object at a time, with your hands,
	 during all your life, in family.
	""") 
''',"Smalltalk_licenseComment")
,"Snapshot-license","""licenseComment
	" Private - Comment note about license of this product. "

	^'
The text you are reading here is the residue of something that has run before.
Keep the system running with responsibility. Smalltalk is not the words,
 nor any definition, nor it current contents...
Smalltalk include your feelings when you see it running.
Smalltalk is what happens when time flows and you "are" here.
Stop reading/writing code (thinking you are outside the system),
 change your world with resposibility, one object at a time, with your hands,
 during all your life, in family.
'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"licenseTerms",0
,smalltalk.__f__('''(self):
	#Smalltalk>>#licenseTerms
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.product(),smalltalk.String(" - ")),self.description()),smalltalk.String("""
	""")),self.licenseMoreHolders()),smalltalk.String("""
	""")),self.licenseHolders()),smalltalk.String("""
	Permission is hereby granted, free of charge, to any person obtaining
	 a copy of this software and associated documentation files (the "Software"),
	 to deal in the Software without restriction, including without limitation
	 the rights to use, copy, modify, merge, publish, distribute, sublicense,
	 and/or sell copies of the Software, and to permit persons to whom the
	 Software is furnished to do so, subject to the following conditions:
	
	The above copyright notice and this permission notice shall be included
	 in all copies or substantial portions of the Software.
	
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
	 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
	 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
	 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
	 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
	 OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	
	""")),self.licenseComment()) 
''',"Smalltalk_licenseTerms")
,"Snapshot-license","""licenseTerms
	" Private - Return the license terms to use this system. "

	^self product ,' - ' ,self description ,'
' ,self licenseMoreHolders ,'
' ,self licenseHolders ,'
Permission is hereby granted, free of charge, to any person obtaining
 a copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute, sublicense,
 and/or sell copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

' ,self licenseComment""",nil)
smalltalk.bind(smalltalk.Smalltalk,"licenseYear",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#licenseYear
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.year=smalltalk.to_String(smalltalk.DateTime.today().year())
		return __0__.year 
	def __blk2__():
		__0__.year=smalltalk.String("today")
		return __0__.year 
	__0__.year=nil
	smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,0)) 
	return __0__.year 
""","Smalltalk_licenseYear")
,"Snapshot-license","""licenseYear
	" Private - Return the year license information. "

	| year |
	[ year := DateTime today year toString
	] on: Exception do: [ year := #today ].
	^year""",nil)
smalltalk.bind(smalltalk.Smalltalk,"licenseMoreHolders",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#licenseMoreHolders
	return smalltalk.String("") 
""","Smalltalk_licenseMoreHolders")
,"Snapshot-license","""licenseMoreHolders
	" Private - Return additional license holders information. "

	^''""",nil)
smalltalk.bind(smalltalk.Smalltalk,"licenseHolders",0
,smalltalk.__f__('''(self):
	#Smalltalk>>#licenseHolders
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Copyright (C) "),smalltalk.asString_(self.licenseYear())),smalltalk.String(" ")),smalltalk.String("""Alejandro F. Reimondo <aleReimondo@smalltalking.net>
	
	Parts of source code written for Jtalk (Sept 2011),
	Copyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>
	Copyright (C) 2011 Jtalk contributors
		David Graham <dgraham@iphouse.com>
		Goran Krampe <goran@krampe.se>
	Also code and ideas from Clamato (http://clamato.net), written by Avi Byrant.
	The PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.
	And people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.
	""")) 
''',"Smalltalk_licenseHolders")
,"Snapshot-license","""licenseHolders
	" Private - Return the license holders information. "

	^'Copyright (C) '
	,self licenseYear asString ,' '
	,'Alejandro F. Reimondo <aleReimondo@smalltalking.net>

Parts of source code written for Jtalk (Sept 2011),
Copyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>
Copyright (C) 2011 Jtalk contributors
	David Graham <dgraham@iphouse.com>
	Goran Krampe <goran@krampe.se>
Also code and ideas from Clamato (http://clamato.net), written by Avi Byrant.
The PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.
And people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.
'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"globalsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Smalltalk>>#globalsDo:
	return self.globalsDo(aBlock) 
""","Smalltalk_globalsDo_")
,"Snapshot-evaluating","""globalsDo: aBlock
	" Private - Evaluates aBlock for each globals defined in the receiver. "

	^self #globalsDo: aBlock""",nil)
smalltalk.bind(smalltalk.Smalltalk,"globalsDo:separatedBy:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Smalltalk>>#globalsDo:separatedBy:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		if smalltalk.b(__0__.first):
			__0__.first=smalltalk.false 
		else:
			anotherBlock.value() 
		 
		return aBlock.value_(each) 
	__0__.first=nil
	__0__.first=smalltalk.true 
	return self.globalsDo(smalltalk.blk(__blk1__,1)) 
""","Smalltalk_globalsDo_separatedBy_")
,"Snapshot-evaluating","""globalsDo: aBlock separatedBy: anotherBlock
	" Private - Evaluates aBlock for each globals defined in the receiver. "

	| first | first := true.
	^self #globalsDo: [:each|
	    first
		ifTrue: [ first := false ]
		ifFalse: [ anotherBlock value ].
	    aBlock value: each
	]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"saveImageOn:",0
,smalltalk.__f__("""(self,stream):
	#Smalltalk>>#saveImageOn:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.licenseTerms().asComment()) 
		return _s8_rec.cr() 
	def __blk2__(each):
		return smalltalk.isNil_(each.superclass()) 
	def __blk3__(total,each):
		total.addAll_(each.withAllSubclasses()) 
		return total 
	def __blk4__(each):
		return each.aboutToSaveImage_on_(self,stream) 
	def __blk5__(each):
		return smalltalk.notNil_(each) 
	def __blk6__(_s8_rec):
		_s8_rec.cr() 
		_s8_rec.nextPutAll_(smalltalk.String("Smalltalk Classes.").asComment()) 
		return _s8_rec.cr() 
	def __blk7__(_s8_rec):
		_s8_rec.cr() 
		return _s8_rec.nextPutAll_(smalltalk.String("Smalltalk Globals set-up.").asComment()) 
	def __blk8__(key):
		def __blk9__(_s8_rec):
			_s8_rec.cr() 
			return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),key),smalltalk.String("=")),__0__.exporter.exportObject_(smalltalk.basic_at_(self,key)))) 
		return __blk9__(stream) 
	def __blk10__(each):
		return each.imageSaved_on_(self,stream) 
	__0__.exporter=nil
	__0__.allClasses=nil
	__blk1__(stream) 
	__0__.allClasses=self.classes().select_(smalltalk.blk(__blk2__,1)).inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk3__,2)).collect_(smalltalk.blk(__blk4__,1)).select_(smalltalk.blk(__blk5__,1)) 
	__0__.exporter=smalltalk.Exporter.new() 
	__blk6__(stream) 
	__0__.exporter.exportClasses_on_(__0__.allClasses,stream) 
	__blk7__(stream) 
	self.globalsDo_(smalltalk.blk(__blk8__,1)) 
	__0__.allClasses.do_(smalltalk.blk(__blk10__,1)) 
	return self 
""","Smalltalk_saveImageOn_")
,"Snapshot-writing","""saveImageOn: stream
	" Dump the receiver's contents onto stream. "

	| exporter allClasses |
	stream nextPutAll: self licenseTerms asComment; cr.
	allClasses := (((self classes
		select: [:each| each superclass isNil ])
		inject: #() into: [:total :each| total addAll: each withAllSubclasses. total ])
		collect: [:each| each aboutToSaveImage: self on: stream ])
		select: [:each| each notNil ].
	exporter := Exporter new.
"	stream nextPutAll: 'Smalltalk Globals (pre)definition.' asComment; cr.
	self
		globalsDo: [:key| stream nextPutAll: 'smalltalk.',key ]
		separatedBy: [ stream nextPutAll: ' , ' ].
	stream nextPutAll: '=nil'; cr.
"	stream cr; nextPutAll: 'Smalltalk Classes.' asComment; cr.
	exporter exportClasses: allClasses on: stream.
	stream cr; nextPutAll: 'Smalltalk Globals set-up.' asComment.
	self globalsDo: [:key|
		stream cr; nextPutAll: 'smalltalk.',key,'='
			,(exporter exportObject: (self basicAt: key))
	].
	allClasses do: [:each| each imageSaved: self on: stream ].""",nil)
smalltalk.bind(smalltalk.Smalltalk,"imageContents",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#imageContents
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.saveImageOn_(__0__.stream) 
	return __0__.stream.contents() 
""","Smalltalk_imageContents")
,"Snapshot-contents","""imageContents
	" Return a dump of the system contents. "

	| stream |
	stream := String new writeStream.
	self saveImageOn: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Smalltalk,"snapshot",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#snapshot
	return smalltalk.Snapshot.contents() 
""","Smalltalk_snapshot")
,"Snapshot-contents","""snapshot
	" Return a system snapshot. "

	^Snapshot contents""",nil)
smalltalk.bind(smalltalk.Smalltalk,"imageFileName",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#imageFileName
	return smalltalk.basic_at_(self,smalltalk.String("$imageFileName")) 
""","Smalltalk_imageFileName")
,"Snapshot-fileName","""imageFileName
	" Return the image file name. "

	^self basicAt: '$imageFileName'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"imageFileName:",0
,smalltalk.__f__("""(self,fileName):
	#Smalltalk>>#imageFileName:
	return smalltalk.basic_at_put_(self,smalltalk.String("$imageFileName"),fileName) 
""","Smalltalk_imageFileName_")
,"Snapshot-fileName","""imageFileName: fileName
	" Set the image file name. "

	^self basicAt: '$imageFileName' put: fileName""",nil)
smalltalk.bind(smalltalk.Smalltalk,"saveImage",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#saveImage
	self.saveImageAs_(self.imageFileName()) 
	return self 
""","Smalltalk_saveImage")
,"Snapshot-save","""saveImage
	" Dump the image contents onto default image file. "

	self saveImageAs: self imageFileName""",nil)
smalltalk.bind(smalltalk.Smalltalk,"saveImageAs:",0
,smalltalk.__f__("""(self,fileName):
	#Smalltalk>>#saveImageAs:
	def __blk1__(each):
		return each.removeFromSystem() 
	smalltalk.String.doItSelector().implementors().do_(smalltalk.blk(__blk1__,1)) 
	self.imageContents().outputToFile_(fileName) 
	self.imageFileName_(fileName) 
	return self 
""","Smalltalk_saveImageAs_")
,"Snapshot-save","""saveImageAs: fileName
	" Dump the image contents onto file at fileName. "

	String doItSelector implementors do: [:each| each removeFromSystem ].
	self imageContents outputToFile: fileName.
	self imageFileName: fileName.""",nil)
smalltalk.bind(smalltalk.Smalltalk,"launch",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#launch
	def __blk1__(each):
		return each.launch() 
	def __blk2__():
		nil 
	self.classes().do_(smalltalk.blk(__blk1__,1)) 
	return smalltalk.Smalltalk.at_ifAbsent_(smalltalk.String("LaunchExpression"),smalltalk.blk(__blk2__,0)).evaluate() 
""","Smalltalk_launch")
,"Snapshot-startup","""launch
	" The system has been launched and start execution.
	The default action is to propagate #launch to current classes and evaluate #LaunchExpression.
	"

	self classes do: [:each| each launch ].
	^(Smalltalk at: #LaunchExpression ifAbsent: []) evaluate""",nil)
smalltalk.bind(smalltalk.Smalltalk,"buildString",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#buildString
	return smalltalk.String("Thu Aug 12 2021 15:58:04 GMT-0300") 
""","Smalltalk_buildString")
,"version","""buildString
	" Return the birth information of this system. "

	^'Thu Aug 12 2021 15:58:04 GMT-0300'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"defaultWorkspaceList",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#defaultWorkspaceList
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("WorkspaceList"))):
		__0__.result.addAll_(smalltalk.Smalltalk.at_(smalltalk.String("WorkspaceList"))) 
	 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("U8"))):
		__0__.result.addAll_(smalltalk.U8.commonExpressions()) 
	 
	return __0__.result 
""","Smalltalk_defaultWorkspaceList")
,"platform-tools","""defaultWorkspaceList
	" Private - Return the (captured) workspace list of the receiver.
	Return an array of tuples; each tuple is anArray of the form
		#( title code )
	where:
		title is aString to be shown as a title of the workspace page.
		code is the text to be shown as contents of workspace page.
	"

	| result |
	result := #().
	(Smalltalk includesKey: #WorkspaceList) ifTrue: [
		result addAll: (Smalltalk at: #WorkspaceList)
	].
	(Smalltalk includesKey: #U8) ifTrue: [
		result addAll: U8 commonExpressions
	].
	^result""",nil)
smalltalk.bind(smalltalk.Smalltalk,"workspaceList",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#workspaceList
	return self.defaultWorkspaceList() 
""","Smalltalk_workspaceList")
,"platform-tools","""workspaceList
	" Return the (captured) workspace list of the receiver. "

	^self defaultWorkspaceList""",nil)
smalltalk.bind(smalltalk.Smalltalk,"defaultAppList",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#defaultAppList
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("AppList"))):
		__0__.result.addAll_(smalltalk.Smalltalk.at_(smalltalk.String("AppList"))) 
	 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("U8Configuration"))):
		__0__.result.addAll_(smalltalk.U8Configuration.appList()) 
	 
	__0__.result.addAll_(self.allClassMethodsList_(smalltalk.newArray(["sample","samples"]))) 
	return __0__.result 
""","Smalltalk_defaultAppList")
,"platform-tools","""defaultAppList
	" Private - Return the (captured) apps of the receiver.
	Return an array of tuples; each tuple is anArray of the form
		#( title comment code )
	where:
		title is aString that can include an icon name inside brackets.
		comment is aString with short description of the app.
		code is the code to evaluate to open the app.
	"

	| result |
	result := #().
	(Smalltalk includesKey: #AppList) ifTrue: [
		result addAll: (Smalltalk at: #AppList)
	].
	(Smalltalk includesKey: #U8Configuration) ifTrue: [
		result addAll: U8Configuration appList
	].
	result addAll: (self allClassMethodsList: #(sample samples)).
	^result""",nil)
smalltalk.bind(smalltalk.Smalltalk,"appList",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#appList
	return self.defaultAppList() 
""","Smalltalk_appList")
,"platform-tools","""appList
	" Return the (captured) apps of the receiver. "

	^self defaultAppList""",nil)
smalltalk.bind(smalltalk.Smalltalk,"allClassMethodsList:",0
,smalltalk.__f__("""(self,choices):
	#Smalltalk>>#allClassMethodsList:
	__0__=smalltalk.newContext()
	def __blk1__(cls):
		def __blk2__(mth):
			__2__=smalltalk.newContext()
			def __blk3__():
				def __blk4__():
					return choices.includes_(mth.selector()) 
				def __blk5__():
					__2__.comment=mth.comment() 
					return smalltalk.booleanNot_(smalltalk.asString_(__2__.comment).upTo_(smalltalk.String("-")).asLowercase().includes_(smalltalk.String("private"))) 
				return smalltalk.boolean_and_(smalltalk.boolean_or_(choices.includes_(mth.category()),smalltalk.blk(__blk4__,0)),smalltalk.blk(__blk5__,0)) 
			def __blk6__():
				__3__=smalltalk.newContext()
				__3__.title=nil
				__3__.code=nil
				__3__.title=__3__.code=smalltalk.object_comma_(smalltalk.object_comma_(cls.name(),smalltalk.String(" ")),mth.selector()) 
				return __0__.result.add_(smalltalk.Array.with_with_with_(__3__.title,__2__.comment.upTo_(smalltalk.String(".")),__3__.code)) 
			__2__.comment=nil
			return smalltalk.if_true_false_(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(mth.selector().argumentCount(),smalltalk.Number(0)),smalltalk.blk(__blk3__,0)),smalltalk.blk(__blk6__,0),nil) 
		return (cls).__class__.methodsDo_(smalltalk.blk(__blk2__,1)) 
	def __blk7__(a,b):
		return a.first()._lt(b.first()) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	smalltalk.Smalltalk.classes().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result.sorted_(smalltalk.blk(__blk7__,2)) 
""","Smalltalk_allClassMethodsList_")
,"platform-tools","""allClassMethodsList: choices
	" Private - Return the list of all (class) methods in the receiver matching choices. "

	| result |
	result := Array new.
	Smalltalk classes do: [:cls|
		cls class methodsDo: [:mth| | comment |
			(mth selector argumentCount = 0 and: [
			((choices includes: mth category) or: [
			  choices includes: mth selector
			]) and: [ comment := mth comment.
			 ((comment asString upTo: $-) asLowercase includes: #private) not
			]]) ifTrue: [ | title code |
				title := code := cls name ,$  ,mth selector.
				result add: (Array
					with: title with: (comment upTo: $.)
					with: code)
			].
		].
	].
	^result sorted: [:a :b| a first < b first ]""",nil)
smalltalk.bind(smalltalk.Smalltalk,"exampleList",0
,smalltalk.__f__("""(self):
	#Smalltalk>>#exampleList
	return self.allClassMethodsList_(smalltalk.newArray(["example"])) 
""","Smalltalk_exampleList")
,"platform-tools","""exampleList
	" Return the (captured) examples of the receiver. "

	^self allClassMethodsList: #(example)""",nil)
smalltalk.bind(smalltalk.Smalltalk,"screen:",0
,smalltalk.__f__("""(self,aBlock):
	#Smalltalk>>#screen:
	return smalltalk.String("S8 system running in as console application") 
""","Smalltalk_screen_")
,"platform-tools","""screen: aBlock
	" Return the (captured) screen of the receiver. "

	^'S8 system running in as console application'""",nil)
smalltalk.bind(smalltalk.Smalltalk,"fileContentsAt:",0
,smalltalk.__f__("""(self,pathName):
	#Smalltalk>>#fileContentsAt:
	return pathName.fileContents() 
""","Smalltalk_fileContentsAt_")
,"platform-tools","""fileContentsAt: pathName
	" Return the contents of file at pathName (or nil). "

	^pathName fileContents""",nil)
smalltalk.bind(smalltalk.Smalltalk,"output:toFile:",0
,smalltalk.__f__("""(self,aString,pathName):
	#Smalltalk>>#output:toFile:
	return aString.outputToFile_(pathName) 
""","Smalltalk_output_toFile_")
,"platform-tools","""output: aString toFile: pathName
	" Save aString onto a file at pathName. "

	^aString outputToFile: pathName""",nil)
smalltalk.bind(smalltalk.Smalltalk,"append:toFile:",0
,smalltalk.__f__("""(self,aString,pathName):
	#Smalltalk>>#append:toFile:
	return aString.appendToFile_(pathName) 
""","Smalltalk_append_toFile_")
,"platform-tools","""append: aString toFile: pathName
	" Append aString onto a file contents at pathName. "

	^aString appendToFile: pathName""",nil)
smalltalk.bind(smalltalk.Behavior,"new",0
,smalltalk.__f__("""(self):
	#Behavior>>#new
	return self.basicNew().initialize() 
""","Behavior_new")
,"instantiation","""new
	" Return an instance of the receiver. "

	^self basicNew initialize""",nil)
smalltalk.bind(smalltalk.Behavior,"new:",0
,smalltalk.__f__("""(self,size):
	#Behavior>>#new:
	return self.basicNew_(size) 
""","Behavior_new_")
,"instantiation","""new: size
	" Return an instance of the receiver of specified size. "

	^self basicNew: size""",nil)
smalltalk.bind(smalltalk.Behavior,"basicNew:",0
,smalltalk.__f__("""(self,size):
	#Behavior>>#basicNew:
	return self.invalidMessage_(smalltalk.String("basicNew:")) 
""","Behavior_basicNew_")
,"instantiation","""basicNew: size
	" Return an instance of the receiver of specified size. "

	^self invalidMessage: #basicNew:""",nil)
smalltalk.bind(smalltalk.Behavior,"basicNew",0
,smalltalk.__f__("""(self):
	#Behavior>>#basicNew
	return self(nil) 
""","Behavior_basicNew")
,"instantiation","""basicNew
	" Return a new (non-initialized) instance of the receiver. "

	^{''js'new self.$fn()'}""",nil)
smalltalk.bind(smalltalk.Behavior,"name",0
,smalltalk.__f__("""(self):
	#Behavior>>#name
	return smalltalk.basic_at_(self,smalltalk.String("$className")) 
""","Behavior_name")
,"accessing","""name
	" Return the name of the receiver. "

	^self basicAt: '$className'""",nil)
smalltalk.bind(smalltalk.Behavior,"superclass",0
,smalltalk.__f__("""(self):
	#Behavior>>#superclass
	return smalltalk.basic_at_(self,smalltalk.String("$superclass")) 
""","Behavior_superclass")
,"accessing","""superclass
	" Return the superclass of the receiver. "

	^self basicAt: '$superclass'""",nil)
smalltalk.bind(smalltalk.Behavior,"subclasses",0
,smalltalk.__f__("""(self):
	#Behavior>>#subclasses
	return self.smalltalk().subclasses(self) 
""","Behavior_subclasses")
,"accessing","""subclasses
	" Return the subclasses of the receiver. "

	^self smalltalk #subclasses: self""",nil)
smalltalk.bind(smalltalk.Behavior,"allSubclasses",0
,smalltalk.__f__("""(self):
	#Behavior>>#allSubclasses
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.allSubclassesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_allSubclasses")
,"testing","""allSubclasses
	" Return all the subclasses of the receiver. "

	| result |
	result := Array new.
	self allSubclassesDo: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"allSubclassesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#allSubclassesDo:
	self.smalltalk().allSubclassesDo(self,aBlock) 
	return self 
""","Behavior_allSubclassesDo_")
,"testing","""allSubclassesDo: aBlock
	" Evaluates aBlock with all the subclasses of the receiver. "

	self smalltalk #allSubclassesDo: self value: aBlock""",nil)
smalltalk.bind(smalltalk.Behavior,"withAllSubclassesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#withAllSubclassesDo:
	aBlock.value_(self) 
	self.allSubclassesDo_(aBlock) 
	return self 
""","Behavior_withAllSubclassesDo_")
,"testing","""withAllSubclassesDo: aBlock
	" Evaluates aBlock with the receiver and all the subclasses. "

	aBlock value: self.
	self allSubclassesDo: aBlock""",nil)
smalltalk.bind(smalltalk.Behavior,"withAllSubclasses",0
,smalltalk.__f__("""(self):
	#Behavior>>#withAllSubclasses
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.with_(self) 
	self.allSubclassesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_withAllSubclasses")
,"accessing","""withAllSubclasses
	" Return a collection with the receiver and all subclasses. "

	| result |
	result := Array with: self.
	self allSubclassesDo: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"allSuperclassesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#allSuperclassesDo:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.notNil_(__0__.current) 
	__0__.current=nil
	__0__.current=self.superclass() 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		aBlock.value_(__0__.current) 
		__0__.current=__0__.current.superclass() 
	 
	return self 
""","Behavior_allSuperclassesDo_")
,"accessing","""allSuperclassesDo: aBlock
	" Evaluate aBlock with the superclasses of the receiver.
	The superclasses are walked in inverse hierarchical order, i.e class Object is last.
	"

	| current |
	current := self superclass.
	[ current notNil ] whileTrue: [
	        aBlock value: current.
		current := current superclass.
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"withAllSuperclassesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#withAllSuperclassesDo:
	aBlock.value_(self) 
	return self.allSuperclassesDo_(aBlock) 
""","Behavior_withAllSuperclassesDo_")
,"accessing","""withAllSuperclassesDo: aBlock
	" Evaluate aBlock with the receiver and it's superclasses.
	The superclasses are walked in inverse hierarchical order, i.e class Object is last.
	"

	aBlock value: self.
	^self allSuperclassesDo: aBlock""",nil)
smalltalk.bind(smalltalk.Behavior,"withAllSuperclasses",0
,smalltalk.__f__("""(self):
	#Behavior>>#withAllSuperclasses
	return smalltalk.object_comma_(smalltalk.Array.with_(self),self.allSuperclasses()) 
""","Behavior_withAllSuperclasses")
,"accessing","""withAllSuperclasses
	" Return a collection with the receiver and all superclasses. "

	^(Array with: self) , self allSuperclasses""",nil)
smalltalk.bind(smalltalk.Behavior,"allSuperclasses",0
,smalltalk.__f__("""(self):
	#Behavior>>#allSuperclasses
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.allSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_allSuperclasses")
,"accessing","""allSuperclasses
	" Return a collection of all the superclasses of the receiver.
	The superclasses are in inverse hierarchical order, i.e class Object is last.
	"

	| result |
	result := Array new.
	self allSuperclassesDo: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"inheritsFrom:",0
,smalltalk.__f__("""(self,aClass):
	_s8Ret_=smalltalk.newContext()
	try:
		#Behavior>>#inheritsFrom:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(smalltalk.b_(aClass is each),smalltalk.blk(__blk2__,0),nil) 
		if smalltalk.b(smalltalk.b_(self is aClass)):
			smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		 
		self.allSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Behavior_inheritsFrom_")
,"testing","""inheritsFrom: aClass
	" Return true if the receiver inherits from aClass. "

	self == aClass ifTrue: [ ^true ].
	self allSuperclassesDo: [:each|
		aClass == each ifTrue: [ ^true ]
	].
	^false""",nil)
smalltalk.bind(smalltalk.Behavior,"fn",0
,smalltalk.__f__("""(self):
	#Behavior>>#fn
	if True:
		return smalltalk.fn_Of(self)
	 
	return smalltalk.basic_at_(self,smalltalk.String("$fn")) 
""","Behavior_fn")
,"accessing","""fn
	" Private - Return the internal function of the receiver (or nil). "

	{'self'}."macro hook"
	^self basicAt: '$fn' """,nil)
smalltalk.bind(smalltalk.Behavior,"prototype",0
,smalltalk.__f__("""(self):
	#Behavior>>#prototype
	if True:
		return smalltalk.prototype_Of(self)
	 
	return smalltalk.basic_at_(self.fn(),smalltalk.String("prototype")) 
""","Behavior_prototype")
,"accessing","""prototype
	" Private - Return the prototype of the receiver (or nil). "

	{'self'}."macro hook"
	^self fn basicAt: #prototype """,nil)
smalltalk.bind(smalltalk.Behavior,"privateMethods",0
,smalltalk.__f__("""(self):
	#Behavior>>#privateMethods
	if True:
		return smalltalk.methods_Of(self)
	 
	return smalltalk.basic_at_(self.prototype(),smalltalk.String("$methods")) 
""","Behavior_privateMethods")
,"accessing","""privateMethods
	" Private, Internal - Return all the methods defined by the receiver. "

	{'self'}."macro hook"
	^self prototype basicAt: '$methods' """,nil)
smalltalk.bind(smalltalk.Behavior,"constructorName",0
,smalltalk.__f__("""(self):
	#Behavior>>#constructorName
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.fn=nil
	__0__.fn=self.fn() 
	__0__.result=smalltalk.basic_at_(__0__.fn,smalltalk.String("name")) 
	if smalltalk.b(smalltalk.notNil_(__0__.result)):
		if smalltalk.b(__0__.result.isEmpty()):
			return nil 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.result,smalltalk.String("$s8Constructor"))):
			return nil 
		 
		return __0__.result 
	 
	__0__.result=smalltalk.to_String(__0__.fn).upTo_(smalltalk.String("(")).asArrayOfSubstrings() 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.result.size(),smalltalk.Number(2))):
		return nil 
	 
	return __0__.result.last() 
""","Behavior_constructorName")
,"accessing","""constructorName
	" Private - Return the name of the constructor of the receiver (or nil). "

	| result fn |
	fn := self fn.
	result := fn basicAt: #name.
	result notNil ifTrue: [
		result isEmpty ifTrue: [ ^nil ].
		result = '$s8Constructor' ifTrue: [ ^nil ].
		^result
	].
	result := (fn toString upTo: $() asArrayOfSubstrings.
	result size = 2 ifFalse: [ ^nil ].
	^result last""",nil)
smalltalk.bind(smalltalk.Behavior,"methodDictionary",0
,smalltalk.__f__("""(self):
	#Behavior>>#methodDictionary
	return smalltalk.PoolDictionary._at_at(self.privateMethods()) 
""","Behavior_methodDictionary")
,"accessing","""methodDictionary
	" Return a (pool)dictionary with the methods implemented by the receiver. "

	^PoolDictionary @@ self privateMethods """,nil)
smalltalk.bind(smalltalk.Behavior,"methodsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#methodsDo:
	def __blk1__(mth):
		return aBlock.value_(mth) 
	self.methodDictionary().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_methodsDo_")
,"accessing","""methodsDo: aBlock
	" Evaluates aBlock for all the methods defined by the receiver. "

	self methodDictionary do: [:mth| aBlock value: mth ]""",nil)
smalltalk.bind(smalltalk.Behavior,"compiledMethods",0
,smalltalk.__f__("""(self):
	#Behavior>>#compiledMethods
	return self.methodDictionary().values() 
""","Behavior_compiledMethods")
,"accessing","""compiledMethods
	" Return a collection with all the methods defined by the receiver. "

	^self methodDictionary values""",nil)
smalltalk.bind(smalltalk.Behavior,"selectorsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#selectorsDo:
	return self.methodDictionary().keys().do_(aBlock) 
""","Behavior_selectorsDo_")
,"accessing","""selectorsDo: aBlock
	" Evaluate aBlock for all the selectors implemented by the receiver. "

	^self methodDictionary keys do: aBlock """,nil)
smalltalk.bind(smalltalk.Behavior,"selectors",0
,smalltalk.__f__("""(self):
	#Behavior>>#selectors
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.selectorsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_selectors")
,"accessing","""selectors
	" Return the selectors implemented by the receiver. "

	| result |
	result := Array new.
	self selectorsDo: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"categorizedSelectors",0
,smalltalk.__f__("""(self):
	#Behavior>>#categorizedSelectors
	__0__=smalltalk.newContext()
	def __blk1__(mth):
		__1__=smalltalk.newContext()
		def __blk2__():
			return smalltalk.Array.new() 
		__1__.category=nil
		__1__.category=mth.category() 
		if smalltalk.b(smalltalk.isNil_(__1__.category)):
			__1__.category=smalltalk.String("undefined") 
		 
		return __0__.pool.at_ifAbsentPut_(__1__.category,smalltalk.blk(__blk2__,0)).add_(mth.selector()) 
	def __blk3__(key):
		return smalltalk.Array.with_with_(key,__0__.pool.at_(key).sorted()) 
	__0__.pool=nil
	__0__.pool=smalltalk.PoolDictionary.new() 
	self.methodsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.pool.keys().sorted().collect_(smalltalk.blk(__blk3__,1)) 
""","Behavior_categorizedSelectors")
,"accessing","""categorizedSelectors
	" Return the selectors classified by category. "

	| pool |
	pool := PoolDictionary new.
	self methodsDo: [:mth| | category |
		category := mth category.
		category isNil ifTrue: [ category := #undefined ].
		(pool at: category ifAbsentPut: [Array new]) add: mth selector
	].
	^pool keys sorted collect: [:key|
		Array with: key with: (pool at: key) sorted
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"implements:",0
,smalltalk.__f__("""(self,aSymbol):
	#Behavior>>#implements:
	return self.methodDictionary().includesKey_(aSymbol) 
""","Behavior_implements_")
,"testing","""implements: aSymbol
	" Return true if the receiver implements message aSymbol. "

	^self methodDictionary includesKey: aSymbol """,nil)
smalltalk.bind(smalltalk.Behavior,"compiledMethodAt:",0
,smalltalk.__f__("""(self,aSymbol):
	#Behavior>>#compiledMethodAt:
	def __blk1__():
		nil 
	return self.methodDictionary().at_ifAbsent_(aSymbol,smalltalk.blk(__blk1__,0)) 
""","Behavior_compiledMethodAt_")
,"accessing","""compiledMethodAt: aSymbol
	" Return the compiled method at aSymbol implemented by the receiver (or nil). "

	^self methodDictionary at: aSymbol ifAbsent: [] """,nil)
smalltalk.bind(smalltalk.Behavior,">>","_gt_gt"
,smalltalk.__f__("""(self,aSymbol):
	#Behavior>>#>>
	return self.compiledMethodAt_(aSymbol) 
""","Behavior__gt_gt")
,"accessing",""">> aSymbol
	" Return the method at aSymbol (or nil if not implemented by the receiver). "

	^self compiledMethodAt: aSymbol""",nil)
smalltalk.bind(smalltalk.Behavior,">>>","_gt_gt_gt"
,smalltalk.__f__("""(self,aSymbol):
	#Behavior>>#>>>
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.notNil_(self.superclass()) 
	__0__.result=nil
	__0__.result=self.compiledMethodAt_(aSymbol) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.isNil_(__0__.result),smalltalk.blk(__blk1__,0))):
		return self.superclass()._gt_gt_gt(aSymbol) 
	 
	return __0__.result 
""","Behavior__gt_gt_gt")
,"accessing",""">>> aSymbol
	" Return the method at aSymbol searching up in receiver's hierarchy (or nil if not implemented by the receiver nor its superclasses). "

	| result |
	result := self compiledMethodAt: aSymbol.
	(result isNil and: [self superclass notNil]) ifTrue: [
		^self superclass >>> aSymbol
	].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"instVarNames",0
,smalltalk.__f__("""(self):
	#Behavior>>#instVarNames
	return smalltalk.basic_at_(self,smalltalk.String("$iVarNames")) 
""","Behavior_instVarNames")
,"accessing","""instVarNames
	" Return the instance variable names of the receiver. "

	^self basicAt: '$iVarNames'""",nil)
smalltalk.bind(smalltalk.Behavior,"allInstVarNames",0
,smalltalk.__f__("""(self):
	#Behavior>>#allInstVarNames
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=smalltalk.object_comma_(each.instVarNames(),__0__.result)
		return __0__.result 
	__0__.result=nil
	__0__.result=self.instVarNames() 
	self.allSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_allInstVarNames")
,"accessing","""allInstVarNames
	" Return all of the instance variable names defined in the receiver and its superclasses. "

	| result |
	result := self instVarNames.
	self allSuperclassesDo: [ :each | result := each instVarNames , result ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"instanceVariableNames",0
,smalltalk.__f__("""(self):
	#Behavior>>#instanceVariableNames
	return smalltalk.basic_at_(self,smalltalk.String("$iVarNames")) 
""","Behavior_instanceVariableNames")
,"accessing","""instanceVariableNames
	" Return the instance variable names defined by the receiver. "

	^self basicAt: '$iVarNames'""",nil)
smalltalk.bind(smalltalk.Behavior,"propertyNames",0
,smalltalk.__f__("""(self):
	#Behavior>>#propertyNames
	def __blk1__():
		return smalltalk.Array.new() 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$propertyNames"),smalltalk.blk(__blk1__,0)) 
""","Behavior_propertyNames")
,"accessing","""propertyNames
	" Return the property names of the receiver. "

	^self basicAt: '$propertyNames' ifAbsent: [ Array new ]""",nil)
smalltalk.bind(smalltalk.Behavior,"propertyNames:",0
,smalltalk.__f__("""(self,anArray):
	#Behavior>>#propertyNames:
	if smalltalk.b(smalltalk.isNil_(anArray)):
		return self.basicDelete_(smalltalk.String("$propertyNames")) 
	 
	return smalltalk.basic_at_put_(self,smalltalk.String("$propertyNames"),anArray) 
""","Behavior_propertyNames_")
,"accessing","""propertyNames: anArray
	" Set the property names of the receiver. "

	anArray isNil ifTrue: [ ^self basicDelete: '$propertyNames' ].
	^self basicAt: '$propertyNames' put: anArray""",nil)
smalltalk.bind(smalltalk.Behavior,"allPropertyNamesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#allPropertyNamesDo:
	def __blk1__(each):
		return each.propertyNames().do_(aBlock) 
	self.propertyNames().do_(aBlock) 
	self.allSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_allPropertyNamesDo_")
,"accessing","""allPropertyNamesDo: aBlock
	" Evaluates aBlock for the property names defined in the receiver and its superclasses. "

	self propertyNames do: aBlock.
	self allSuperclassesDo: [ :each | each propertyNames do: aBlock ].""",nil)
smalltalk.bind(smalltalk.Behavior,"allInstVarNamesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#allInstVarNamesDo:
	def __blk1__(each):
		return each.instVarNames().do_(aBlock) 
	self.instVarNames().do_(aBlock) 
	self.allSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_allInstVarNamesDo_")
,"accessing","""allInstVarNamesDo: aBlock
	" Evaluates aBlock for the instance variable names defined in the receiver and its superclasses. "

	self instVarNames do: aBlock.
	self allSuperclassesDo: [ :each | each instVarNames do: aBlock ].""",nil)
smalltalk.bind(smalltalk.Behavior,"comment",0
,smalltalk.__f__("""(self):
	#Behavior>>#comment
	def __blk1__():
		return smalltalk.String("") 
	return smalltalk.basic_at_ifAbsent_(self.instanceClass(),smalltalk.String("$comment"),smalltalk.blk(__blk1__,0)) 
""","Behavior_comment")
,"accessing","""comment
	" Return the comment of the receiver. "

	^self instanceClass basicAt: '$comment' ifAbsent: [ '' ]""",nil)
smalltalk.bind(smalltalk.Behavior,"comment:",0
,smalltalk.__f__("""(self,aString):
	#Behavior>>#comment:
	smalltalk.basic_at_put_(self.instanceClass(),smalltalk.String("$comment"),aString) 
	return self 
""","Behavior_comment_")
,"accessing","""comment: aString
	" Set the comment of the receiver. "

	self instanceClass basicAt: '$comment' put: aString""",nil)
smalltalk.bind(smalltalk.Behavior,"removeSources",0
,smalltalk.__f__("""(self):
	#Behavior>>#removeSources
	self.instanceClass().removeSources() 
	return self 
""","Behavior_removeSources")
,"tools","""removeSources
	" Remove all development sources of the receiver. "

	self instanceClass removeSources""",nil)
smalltalk.bind(smalltalk.Behavior,"poolDictionaryNames",0
,smalltalk.__f__("""(self):
	#Behavior>>#poolDictionaryNames
	return self.instanceClass().poolDictionaryNames() 
""","Behavior_poolDictionaryNames")
,"accessing","""poolDictionaryNames
	" Return the shared pool names of the receiver. "

	^self instanceClass poolDictionaryNames""",nil)
smalltalk.bind(smalltalk.Behavior,"sharedPoolsAndNamesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#sharedPoolsAndNamesDo:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__(aName):
			def __blk3__():
				return nil 
			def __blk4__():
				return aBlock.value_value_(aName,__0__.pool) 
			__0__.pool=smalltalk.Smalltalk.poolDictionary_ifAbsent_(aName,smalltalk.blk(__blk3__,0)) 
			return smalltalk.if_true_false_(smalltalk.notNil_(__0__.pool),smalltalk.blk(__blk4__,0),nil) 
		return each.poolDictionaryNames().do_(smalltalk.blk(__blk2__,1)) 
	__0__.pool=nil
	self.instanceClass().withAllSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_sharedPoolsAndNamesDo_")
,"accessing","""sharedPoolsAndNamesDo: aBlock
	" Execute aBlock for the pool dictionaries known by the receiver. "

	| pool |
	self instanceClass withAllSuperclassesDo: [:each|
		each poolDictionaryNames do: [:aName|
			pool := Smalltalk poolDictionary: aName ifAbsent: [ nil ].
			pool notNil ifTrue: [ aBlock value: aName value: pool ]
		].
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"sharedPoolsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#sharedPoolsDo:
	def __blk1__(aName,aPool):
		return aBlock.value_(aPool) 
	self.sharedPoolsAndNamesDo_(smalltalk.blk(__blk1__,2)) 
	return self 
""","Behavior_sharedPoolsDo_")
,"accessing","""sharedPoolsDo: aBlock
	" Execute aBlock for the pool dictionaries known by the receiver. "

	self sharedPoolsAndNamesDo: [:aName :aPool| aBlock value: aPool ]""",nil)
smalltalk.bind(smalltalk.Behavior,"classVariablesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#classVariablesDo:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			def __blk3__(assoc):
				return aBlock.value_(assoc) 
			return __0__.bindings.associationsDo_(smalltalk.blk(__blk3__,1)) 
		__0__.bindings=each.classVariables() 
		return smalltalk.if_true_false_(smalltalk.notNil_(__0__.bindings),smalltalk.blk(__blk2__,0),nil) 
	__0__.bindings=nil
	return self.instanceClass().withAllSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
""","Behavior_classVariablesDo_")
,"accessing","""classVariablesDo: aBlock
	" Execute aBlock for the classVariables bindings known by the receiver. "

	| bindings |
	^self instanceClass withAllSuperclassesDo: [:each|
		bindings := each classVariables.
		bindings notNil ifTrue: [
			bindings associationsDo: [:assoc| aBlock value: assoc ]
		]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"classVariableNamesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#classVariableNamesDo:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			def __blk3__(aName):
				return aBlock.value_(aName) 
			return __0__.bindings.keysDo_(smalltalk.blk(__blk3__,1)) 
		__0__.bindings=each.classVariables() 
		return smalltalk.if_true_false_(smalltalk.notNil_(__0__.bindings),smalltalk.blk(__blk2__,0),nil) 
	__0__.bindings=nil
	return self.instanceClass().withAllSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
""","Behavior_classVariableNamesDo_")
,"accessing","""classVariableNamesDo: aBlock
	" Execute aBlock for the classVariable names known by the receiver. "

	| bindings |
	^self instanceClass withAllSuperclassesDo: [:each|
		bindings := each classVariables.
		bindings notNil ifTrue: [
			bindings keysDo: [:aName| aBlock value: aName ]
		]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"classVariableAt:put:",0
,smalltalk.__f__("""(self,aName,anObject):
	#Behavior>>#classVariableAt:put:
	return self.instanceClass().classVariables().at_put_(aName,anObject) 
""","Behavior_classVariableAt_put_")
,"accessing","""classVariableAt: aName put: anObject
	" Set the classVariable of the receiver to anObject. "

	^self instanceClass classVariables at: aName put: anObject""",nil)
smalltalk.bind(smalltalk.Behavior,"classVariableAt:ifAbsent:",0
,smalltalk.__f__("""(self,aName,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#Behavior>>#classVariableAt:ifAbsent:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				def __blk3__():
					return smalltalk.raise_result_(_s8Ret_,__0__.bindings.at_(aName)) 
				return smalltalk.if_true_false_(__0__.bindings.includesKey_(aName),smalltalk.blk(__blk3__,0),nil) 
			__0__.bindings=each.classVariables() 
			return smalltalk.if_true_false_(smalltalk.notNil_(__0__.bindings),smalltalk.blk(__blk2__,0),nil) 
		__0__.bindings=nil
		self.instanceClass().withAllSuperclassesDo_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.evaluate()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Behavior_classVariableAt_ifAbsent_")
,"accessing","""classVariableAt: aName ifAbsent: aBlock
	" Return the value of classVariable named aName. "

	| bindings |
	self instanceClass withAllSuperclassesDo: [:each|
		bindings := each classVariables.
		bindings notNil ifTrue: [
			(bindings includesKey: aName) ifTrue: [
				^bindings at: aName
			]
		]
	].
	^aBlock evaluate""",nil)
smalltalk.bind(smalltalk.Behavior,"classVariableAt:",0
,smalltalk.__f__("""(self,aName):
	#Behavior>>#classVariableAt:
	def __blk1__():
		return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Undefined class variable "),aName),smalltalk.String(" in ")),self.name())) 
	return self.classVariableAt_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
""","Behavior_classVariableAt_")
,"accessing","""classVariableAt: aName
	" Return the value of classVariable named aName or generates an error. "

	^self classVariableAt: aName ifAbsent: [
		self error: 'Undefined class variable ',aName ,' in ' ,self name
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"pool:variableAt:put:",0
,smalltalk.__f__("""(self,poolName,aName,anObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#Behavior>>#pool:variableAt:put:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Undefined pool variable "),poolName),smalltalk.String(" in ")),self.name()))) 
		__0__.pool=nil
		__0__.pool=smalltalk.Smalltalk.poolDictionary_ifAbsent_(poolName,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.pool.at_put_(aName,anObject)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Behavior_pool_variableAt_put_")
,"accessing","""pool: poolName variableAt: aName put: anObject
	" Set the pool Variable of the receiver to anObject. "

	| pool |
	pool := Smalltalk
		poolDictionary: poolName
		ifAbsent: [ ^self error: 'Undefined pool variable ',poolName ,' in ' ,self name ].
	^pool at: aName put: anObject""",nil)
smalltalk.bind(smalltalk.Behavior,"loadRequirementsInto:",0
,smalltalk.__f__("""(self,aCollection):
	#Behavior>>#loadRequirementsInto:
	return self 
""","Behavior_loadRequirementsInto_")
,"loading","""loadRequirementsInto: aCollection
	" Add the requirements to load the receiver from sources to aCollection.
	Default action do nothing, this method can be refined by the subclasses.
	"

	^self""",nil)
smalltalk.bind(smalltalk.Behavior,"removeSelectors:",0
,smalltalk.__f__("""(self,aCollection):
	#Behavior>>#removeSelectors:
	def __blk1__(each):
		return self.removeSelector_(each) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_removeSelectors_")
,"methods","""removeSelectors: aCollection
	" Remove the methods for messages in aCollection, implemented by the receiver. "

	aCollection do: [:each| self removeSelector: each ]""",nil)
smalltalk.bind(smalltalk.Behavior,"removeCompiledMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#Behavior>>#removeCompiledMethod:
	self.smalltalk().removeMethod(self,aMethod) 
	return self 
""","Behavior_removeCompiledMethod_")
,"private","""removeCompiledMethod: aMethod
	" Remove aMethod from the receiver. "

	self smalltalk #removeMethod: self method: aMethod""",nil)
smalltalk.bind(smalltalk.Behavior,"missingImplementorFor:",0
,smalltalk.__f__("""(self,jsSelector):
	#Behavior>>#missingImplementorFor:
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Missing implementor for "),jsSelector.asStSelector().asLiteral()),smalltalk.String(" in ")),self.name())) 
""","Behavior_missingImplementorFor_")
,"private","""missingImplementorFor: jsSelector
	" Private - Handle the situation where there is no implementor for jsSelector.
	This can happen when there is no implementation for jsSelector and the message
	 has been dispatched through a superSend.
	"

	^self error: 'Missing implementor for '
		, jsSelector asStSelector asLiteral
		,' in ',self name""",nil)
smalltalk.bind(smalltalk.Behavior,"removeSelector:",0
,smalltalk.__f__("""(self,aSelector):
	#Behavior>>#removeSelector:
	__0__=smalltalk.newContext()
	__0__.method=nil
	__0__.method=self.compiledMethodAt_(aSelector) 
	if smalltalk.b(smalltalk.notNil_(__0__.method)):
		self.removeCompiledMethod_(__0__.method) 
	 
	return self 
""","Behavior_removeSelector_")
,"methods","""removeSelector: aSelector
	" Remove the method for message aSelector implemented by the receiver. "

	| method |
	method := self compiledMethodAt: aSelector.
	method notNil ifTrue: [ self removeCompiledMethod: method ].""",nil)
smalltalk.bind(smalltalk.Behavior,"removeFromSystem",0
,smalltalk.__f__("""(self):
	#Behavior>>#removeFromSystem
	return self.instanceClass().removeFromSystem() 
""","Behavior_removeFromSystem")
,"remove","""removeFromSystem
	" Remove the receiver from system. "

	^self instanceClass removeFromSystem """,nil)
smalltalk.bind(smalltalk.Behavior,"implementorsOf:",0
,smalltalk.__f__("""(self,aSymbol):
	#Behavior>>#implementorsOf:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__1__=smalltalk.newContext()
		def __blk2__():
			return __0__.result.add_(__1__.method) 
		__1__.method=nil
		__1__.method=each._gt_gt(aSymbol) 
		if smalltalk.b(smalltalk.notNil_(__1__.method)):
			__0__.result.add_(__1__.method) 
		 
		__1__.method=(each).__class__._gt_gt(aSymbol) 
		return smalltalk.if_true_false_(smalltalk.notNil_(__1__.method),smalltalk.blk(__blk2__,0),nil) 
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	self.withAllSubclassesDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_implementorsOf_")
,"testing","""implementorsOf: aSymbol
	" Return the implementors of aSymbol in the receiver and its subclasses. "

	| result |
	result := #().
	self withAllSubclassesDo: [:each | | method |
		method := each >> aSymbol.
		method notNil ifTrue: [ result add: method ].
		method := each class >> aSymbol.
		method notNil ifTrue: [ result add: method ].
	].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"asJSONObject",0
,smalltalk.__f__("""(self):
	#Behavior>>#asJSONObject
	return self 
""","Behavior_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self""",nil)
smalltalk.bind(smalltalk.Behavior,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Behavior>>#shallowCopy
	return self 
""","Behavior_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Behavior,"deepCopy",0
,smalltalk.__f__("""(self):
	#Behavior>>#deepCopy
	return self 
""","Behavior_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Behavior,"toString",0
,smalltalk.__f__("""(self):
	#Behavior>>#toString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("{st:"),self.name()),smalltalk.String("}")) 
""","Behavior_toString")
,"converting","""toString
	" Return the receiver as a String. "

	^'{st:',self name,$}""",nil)
smalltalk.bind(smalltalk.Behavior,"aboutToAdd:",0
,smalltalk.__f__("""(self,aMethod):
	#Behavior>>#aboutToAdd:
	smalltalk.APIBuilder.register_(aMethod) 
	return self 
""","Behavior_aboutToAdd_")
,"private","""aboutToAdd: aMethod
	" Private - Prepare aMethod to be added onto the receiver. "

	APIBuilder register: aMethod. """,nil)
smalltalk.bind(smalltalk.Behavior,"canAdd:method:",0
,smalltalk.__f__("""(self,isDoIt,aMethod):
	_s8Ret_=smalltalk.newContext()
	try:
		#Behavior>>#canAdd:method:
		def __blk1__():
			return smalltalk.OverwriteMethods 
		if not smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(smalltalk.OverwriteMethods),smalltalk.blk(__blk1__,0))):
			def __blk2__():
				def __blk3__():
					def __blk4__():
						def __blk5__():
							return smalltalk.notNil_(smalltalk.Exporter) 
						return smalltalk.boolean_and_(smalltalk.DumpOverwritenMethods,smalltalk.blk(__blk5__,0)) 
					if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(smalltalk.DumpOverwritenMethods),smalltalk.blk(__blk4__,0))):
						self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("? "),self.name()),smalltalk.String(">>#")),aMethod.selector())) 
						self.print_(smalltalk.Exporter.new().export_method_(self,aMethod)) 
					else:
						self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("-Overwrite Conflict- "),self.name()),smalltalk.String(">>#")),aMethod.selector())) 
					 
					return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
				return smalltalk.if_true_false_(isDoIt,nil,smalltalk.blk(__blk3__,0)) 
			smalltalk.if_true_false_(self.implements_(aMethod.selector()),smalltalk.blk(__blk2__,0),nil) 
		 
		self.aboutToAdd_(aMethod) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Behavior_canAdd_method_")
,"private","""canAdd: isDoIt method: aMethod
	" Private - Returns true if aMethod be added onto the receiver. "

	(OverwriteMethods notNil and: [ OverwriteMethods ]) ifFalse: [
		(self implements: aMethod selector) ifTrue: [
			isDoIt ifFalse: [
				(DumpOverwritenMethods notNil
				and: [ DumpOverwritenMethods
				and: [ Exporter notNil ]]) ifTrue: [
					self note: '? ',self name,'>>#',aMethod selector.
					self print: (Exporter new export: self method: aMethod).
				] ifFalse: [
					self note: '-Overwrite Conflict- ',self name,'>>#',aMethod selector.
				].
				^false
			].
		].
	].
	self aboutToAdd: aMethod.
	^true """,nil)
smalltalk.bind(smalltalk.Behavior,"basicAddCompiledMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#Behavior>>#basicAddCompiledMethod:
	self.smalltalk().addMethod(aMethod.selector().asSelector(),aMethod,self) 
	return self 
""","Behavior_basicAddCompiledMethod_")
,"private","""basicAddCompiledMethod: aMethod
	" Private - Register aMethod onto the receiver. "

	self smalltalk
		#addMethod: aMethod selector asSelector
		method: aMethod to: self""",nil)
smalltalk.bind(smalltalk.Behavior,"addCompiledMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#Behavior>>#addCompiledMethod:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.booleanNot_(__0__.isDoIt) 
	__0__.isDoIt=nil
	__0__.isDoIt=smalltalk.isObject_equalTo_(aMethod.selector(),smalltalk.String.doItSelector()) 
	if not smalltalk.b(self.canAdd_method_(__0__.isDoIt,aMethod)):
		return nil 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(smalltalk.Exporter),smalltalk.blk(__blk1__,0))):
		self.print_(smalltalk.Exporter.new().export_method_(self,aMethod)) 
	 
	return self.basicAddCompiledMethod_(aMethod) 
""","Behavior_addCompiledMethod_")
,"methods","""addCompiledMethod: aMethod
	" Add the compiled method, if appropiate, and register the method in recent methods. "

	| isDoIt |
	isDoIt := aMethod selector = String doItSelector.
	(self canAdd: isDoIt method: aMethod) ifFalse: [ ^nil ].
	(Exporter notNil and: [ isDoIt not ]) ifTrue: [
" DEBUG -	self note: self name,'>>#',aMethod selector."
		self print: (Exporter new export: self method: aMethod).
	].
	^self basicAddCompiledMethod: aMethod""",nil)
smalltalk.bind(smalltalk.Behavior,"collection",0
,smalltalk.__f__("""(self):
	#Behavior>>#collection
	def __blk1__(_s8_rec):
		_s8_rec.species_(self) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.ComposedObjects.new()) 
""","Behavior_collection")
,"composing","""collection
	" Return a collection to compose instances of the receiver. "

	^ComposedObjects new
		species: self;
		yourself""",nil)
smalltalk.bind(smalltalk.Behavior,"codeFor:accessing:",0
,smalltalk.__f__("""(self,anEncoder,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#Behavior>>#codeFor:accessing:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,anEncoder.codeToAccessInstanceVariable_in_(__0__.aName,aNode)) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.aName,each),smalltalk.blk(__blk2__,0),nil) 
		def __blk3__(each):
			def __blk4__():
				return smalltalk.raise_result_(_s8Ret_,anEncoder.codeToAccessProperty_in_(__0__.aName,aNode)) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.aName,each),smalltalk.blk(__blk4__,0),nil) 
		__0__.aName=nil
		__0__.aName=aNode.value() 
		self.allInstVarNamesDo_(smalltalk.blk(__blk1__,1)) 
		self.allPropertyNamesDo_(smalltalk.blk(__blk3__,1)) 
		smalltalk.raise_result_(_s8Ret_,nil) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Behavior_codeFor_accessing_")
,"Compiler-generation","""codeFor: anEncoder accessing: aNode
	" Return the code to access variable in aNode (aVariableNode).
	Return nil if the code to access variable can't be generated.
	The default implementation return code to access instance variables.
	"

	| aName |
	aName := aNode value.
	self allInstVarNamesDo: [:each|
		aName = each ifTrue: [
			^anEncoder codeToAccessInstanceVariable: aName in: aNode
		].
	].
	self allPropertyNamesDo: [:each|
		aName = each ifTrue: [
			^anEncoder codeToAccessProperty: aName in: aNode
		].
	].
	^nil""",nil)
smalltalk.bind(smalltalk.Behavior,"compiler",0
,smalltalk.__f__("""(self):
	#Behavior>>#compiler
	return self.compilerSupport().for_(self) 
""","Behavior_compiler")
,"Compiler-compiling","""compiler
	" Return a compiler for receiver's source code. "

	^self compilerSupport for: self""",nil)
smalltalk.bind(smalltalk.Behavior,"recompile",0
,smalltalk.__f__("""(self):
	#Behavior>>#recompile
	self.compiler().recompile_(self) 
	return self 
""","Behavior_recompile")
,"Compiler-compiling","""recompile
	" Recompile all the methods of the receiver. "

	self compiler recompile: self""",nil)
smalltalk.bind(smalltalk.Behavior,"recompileAll",0
,smalltalk.__f__("""(self):
	#Behavior>>#recompileAll
	def __blk1__(each):
		return each.recompile() 
	self.instanceClass().withAllSubclassesDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_recompileAll")
,"Compiler-compiling","""recompileAll
	" Recompile all the methods of the receiver and its subclasses.	"

	self instanceClass withAllSubclassesDo: [:each| each recompile ]""",nil)
smalltalk.bind(smalltalk.Behavior,"recompile:",0
,smalltalk.__f__("""(self,what):
	#Behavior>>#recompile:
	def __blk1__(selector):
		return self._gt_gt(selector).recompile() 
	if smalltalk.b(what.isString()):
		return self.recompile_(smalltalk.Array.with_(what)) 
	 
	what.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_recompile_")
,"Compiler-compiling","""recompile: what
	" Recompile the method(s) at selector(s) of the receiver.	"

	what isString ifTrue: [ ^self recompile: (Array with: what) ].
	what do: [:selector| (self >> selector) recompile ]""",nil)
smalltalk.bind(smalltalk.Behavior,"templateFrom:doing:on:",0
,smalltalk.__f__("""(self,host,aBlock,methodBlock):
	#Behavior>>#templateFrom:doing:on:
	__0__=smalltalk.newContext()
	def __blk1__():
		nil 
	def __blk2__():
		return smalltalk.is_kindOf_(host,(smalltalk.CompiledMethod)) 
	def __blk3__():
		def __blk4__():
			return methodBlock.value_(__0__.template) 
		def __blk5__():
			return __0__.template 
		__0__.template=__0__.template.deepCopy() 
		if smalltalk.b(smalltalk.notNil_(aBlock)):
			__0__.template.do_(aBlock) 
		 
		return smalltalk.if_true_false_(smalltalk.notNil_(methodBlock),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
	__0__.template=nil
	if smalltalk.b(smalltalk.isNil_(host)):
		return nil 
	 
	__0__.template=smalltalk.basic_at_ifAbsent_(host,smalltalk.String("s8Template"),smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.isNil_(__0__.template),smalltalk.blk(__blk2__,0))):
		def __blk6__(_s8_rec):
			_s8_rec.useTemplates_(smalltalk.false) 
			_s8_rec.currentClass_(host.classField()) 
			return _s8_rec.parseMethod_(host.source()) 
		__0__.template=__blk6__(smalltalk.Compiler.new()) 
		smalltalk.basic_at_put_(host,smalltalk.String("s8Template"),__0__.template) 
	 
	return smalltalk.if_true_false_(smalltalk.notNil_(__0__.template),smalltalk.blk(__blk3__,0),nil) 
""","Behavior_templateFrom_doing_on_")
,"Compiler-templates","""templateFrom: host doing: aBlock on: methodBlock
	" Return the result of collecting mutations in template cached in host (or nil). "

	| template |
	host isNil ifTrue: [ ^nil ].
	template := host basicAt: #s8Template ifAbsent: [].
	(template isNil and: [host isKindOf: CompiledMethod]) ifTrue: [
		template := Compiler new
			useTemplates: false;
			currentClass: host classField;
			parseMethod: host source.
		host basicAt: #s8Template put: template.
	].
	^template notNil ifTrue: [
		template := template deepCopy.
		aBlock notNil ifTrue: [ template do: aBlock ].
		methodBlock notNil
			ifTrue: [ methodBlock value: template ]
			ifFalse: [ template ]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"templateFrom:with:",0
,smalltalk.__f__("""(self,host,methodBlock):
	#Behavior>>#templateFrom:with:
	return self.templateFrom_doing_on_(host,nil,methodBlock) 
""","Behavior_templateFrom_with_")
,"Compiler-templates","""templateFrom: host with: methodBlock
	" Return the template cached in host (or nil). "

	^self templateFrom: host doing: nil on: methodBlock""",nil)
smalltalk.bind(smalltalk.Behavior,"methodsFor:",0
,smalltalk.__f__("""(self,aString):
	#Behavior>>#methodsFor:
	return smalltalk.ClassCategoryReader.new().class_category_(self,aString) 
""","Behavior_methodsFor_")
,"Tools-fileIn","""methodsFor: aString
	" FileIn - Return a chunk reader to fileIn methods onto the receiver. "

	^ClassCategoryReader new class: self category: aString""",nil)
smalltalk.bind(smalltalk.Behavior,"methodsFor:stamp:",0
,smalltalk.__f__("""(self,aString,stamp):
	#Behavior>>#methodsFor:stamp:
	return smalltalk.ClassCategoryReader.new().class_category_stamp_(self,aString,stamp) 
""","Behavior_methodsFor_stamp_")
,"Tools-fileIn","""methodsFor: aString stamp: stamp
	" FileIn - Return a chunk reader to fileIn methods onto the receiver. "

	^ClassCategoryReader new class: self category: aString stamp: stamp""",nil)
smalltalk.bind(smalltalk.Behavior,"methods",0
,smalltalk.__f__("""(self):
	#Behavior>>#methods
	return self.methodsFor_(smalltalk.String("unclassified")) 
""","Behavior_methods")
,"Tools-fileIn","""methods
	" FileIn - Return a chunk reader to fileIn methods onto the receiver. "

	^self methodsFor: #unclassified """,nil)
smalltalk.bind(smalltalk.Behavior,"commentStamp",0
,smalltalk.__f__("""(self):
	#Behavior>>#commentStamp
	return smalltalk.ClassCommentReader.new().class_(self) 
""","Behavior_commentStamp")
,"Tools-fileIn","""commentStamp
	" Return a comment reader for the receiver. "

	^ClassCommentReader new class: self""",nil)
smalltalk.bind(smalltalk.Behavior,"fileOut",0
,smalltalk.__f__("""(self):
	#Behavior>>#fileOut
	return smalltalk.Exporter.fileOut_(self.instanceClass()) 
""","Behavior_fileOut")
,"Tools-fileOut","""fileOut
	" Return fileOut definition and code of a class. "

	^Exporter fileOut: self instanceClass""",nil)
smalltalk.bind(smalltalk.Behavior,"export",0
,smalltalk.__f__("""(self):
	#Behavior>>#export
	return smalltalk.Exporter.export_(self.instanceClass()) 
""","Behavior_export")
,"Tools-export","""export
	" Return the result of exporting definition and source code of a class. "

	^Exporter export: self instanceClass""",nil)
smalltalk.bind(smalltalk.Behavior,"references",0
,smalltalk.__f__("""(self):
	#Behavior>>#references
	__0__=smalltalk.newContext()
	def __blk1__(mth):
		__1__=smalltalk.newContext()
		def __blk2__(key):
			def __blk3__():
				return smalltalk.HashedSet.new() 
			return __0__.result.at_ifAbsentPut_(key,smalltalk.blk(__blk3__,0)).addAll_(__1__.refs.at_(key)) 
		__1__.refs=nil
		__1__.refs=mth.references() 
		return __1__.refs.keys().do_(smalltalk.blk(__blk2__,1)) 
	def __blk4__(each):
		return each.asArray() 
	__0__.result=nil
	__0__.result=smalltalk.PoolDictionary.new() 
	self.methodsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result.collect_(smalltalk.blk(__blk4__,1)) 
""","Behavior_references")
,"Tools-references","""references
	" Return all the references in the receiver. "

	| result |
	result := PoolDictionary new.
	self methodsDo: [:mth| | refs |
		refs := mth references.
		refs keys do: [:key|
			(result at: key ifAbsentPut: [HashedSet new])
				addAll: (refs at: key)
		]
	].
	^result collect: [:each| each asArray ]""",nil)
smalltalk.bind(smalltalk.Behavior,"messagesSent",0
,smalltalk.__f__("""(self):
	#Behavior>>#messagesSent
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.addAll_(each.messages()) 
	def __blk2__(each):
		return __0__.result.addAll_(each.messages()) 
	__0__.result=nil
	__0__.cls=nil
	__0__.result=smalltalk.HashedSet.new() 
	__0__.cls=self.instanceClass() 
	__0__.cls.methodsDo_(smalltalk.blk(__blk1__,1)) 
	(__0__.cls).__class__.methodsDo_(smalltalk.blk(__blk2__,1)) 
	return __0__.result 
""","Behavior_messagesSent")
,"Tools-messages","""messagesSent
	" Return the messages sent by the receiver. "

	| result cls |
	result := HashedSet new.
	cls := self instanceClass.
	cls methodsDo: [:each| result addAll: each messages ].
	cls class methodsDo: [:each| result addAll: each messages ].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"allMessagesSent",0
,smalltalk.__f__("""(self):
	#Behavior>>#allMessagesSent
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.addAll_(each.messagesSent()) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	return self.allSubclasses().inject_into_(self.messagesSent(),smalltalk.blk(__blk1__,2)) 
""","Behavior_allMessagesSent")
,"Tools-messages","""allMessagesSent
	" Return the messages sent by the receiver and its subclasses. "

	^self allSubclasses
		inject: self messagesSent
		into: [:total :each| total addAll: each messagesSent; yourself ]""",nil)
smalltalk.bind(smalltalk.Behavior,"implementedMessages",0
,smalltalk.__f__("""(self):
	#Behavior>>#implementedMessages
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.cls=nil
	__0__.result=smalltalk.HashedSet.new() 
	__0__.cls=self.instanceClass() 
	__0__.result.addAll_(__0__.cls.selectors()) 
	__0__.result.addAll_((__0__.cls).__class__.selectors()) 
	return __0__.result 
""","Behavior_implementedMessages")
,"Tools-messages","""implementedMessages
	" Return the messages implemented by the receiver. "

	| result cls |
	result := HashedSet new.
	cls := self instanceClass.
	result addAll: cls selectors.
	result addAll: cls class selectors.
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"allImplementedMessages",0
,smalltalk.__f__("""(self):
	#Behavior>>#allImplementedMessages
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.addAll_(each.implementedMessages()) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	return self.allSubclasses().inject_into_(self.implementedMessages(),smalltalk.blk(__blk1__,2)) 
""","Behavior_allImplementedMessages")
,"Tools-messages","""allImplementedMessages
	" Return the messages implemented by the receiver and its subclasses. "

	^self allSubclasses
		inject: self implementedMessages
		into: [:total :each| total addAll: each implementedMessages; yourself ]""",nil)
smalltalk.bind(smalltalk.Behavior,"implementorsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Behavior>>#implementorsDo:
	__0__=smalltalk.newContext()
	__0__.cls=nil
	__0__.cls=self.instanceClass() 
	(__0__.cls).__class__.methodsDo_(aBlock) 
	__0__.cls.methodsDo_(aBlock) 
	return self 
""","Behavior_implementorsDo_")
,"Tools-iterating","""implementorsDo: aBlock
	" Evaluates aBlock for each implementor in the receiver. "

	| cls |
	cls := self instanceClass.
	cls class methodsDo: aBlock.
	cls methodsDo: aBlock.""",nil)
smalltalk.bind(smalltalk.Behavior,"implementors",0
,smalltalk.__f__("""(self):
	#Behavior>>#implementors
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.newArray([]) 
	self.implementorsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Behavior_implementors")
,"Tools-implementors","""implementors
	" Return a collection with all implementors in the receiver. "

	| result |
	result := #().
	self implementorsDo: [:each| result add: each].
	^result""",nil)
smalltalk.bind(smalltalk.Behavior,"implement:comment:as:category:",0
,smalltalk.__f__('''(self,messageHeader,aComment,sourceCode,aCategory):
	#Behavior>>#implement:comment:as:category:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String(" methods") 
	def __blk2__():
		return smalltalk.object_comma_(smalltalk.String(" methodsFor: "),aCategory.asLiteral()) 
	def __blk3__():
		return smalltalk.String("") 
	def __blk4__():
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("""
		" """),aComment),smalltalk.String(' "')) 
	def __blk5__(_s8_rec):
		_s8_rec.fileIn() 
		return _s8_rec.yourself() 
	__0__.code=nil
	__0__.code=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("! "),self.name()),smalltalk.if_true_false_(smalltalk.isNil_(aCategory),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))),smalltalk.String(""" !
	""")),messageHeader),smalltalk.if_true_false_(smalltalk.isNil_(aComment),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0))),smalltalk.String("""
	
		""")),sourceCode),smalltalk.String("""! !
	
	""")) 
	return __blk5__(__0__.code) 
''',"Behavior_implement_comment_as_category_")
,"Builders-implementing","""implement: messageHeader
	comment: aComment
	as: sourceCode
	category: aCategory
	" Private - Implement a method in the receiver.
	Note: sourceCode must be the source code in chunk format.
	"

	| code |
	code := '! ',self name,
		(aCategory isNil
			ifTrue: [ ' methods' ]
			ifFalse: [ ' methodsFor: ', aCategory asLiteral ])
,' !
',messageHeader, (aComment isNil ifTrue: [ '' ] ifFalse: ['
	" ', aComment, ' "']),'

	',sourceCode ,'! !

'.	^code fileIn; yourself""",nil)
smalltalk.bind(smalltalk.Behavior,"implement:comment:as:",0
,smalltalk.__f__("""(self,messageHeader,aComment,sourceCode):
	#Behavior>>#implement:comment:as:
	return self.implement_comment_as_category_(messageHeader,aComment,sourceCode,nil) 
""","Behavior_implement_comment_as_")
,"Builders-implementing","""implement: messageHeader comment: aComment as: sourceCode
	" Private - Implement a method in the receiver. "

	^self
		implement: messageHeader
		comment: aComment
		as: sourceCode
		category: nil""",nil)
smalltalk.bind(smalltalk.Behavior,"implement:as:",0
,smalltalk.__f__("""(self,messageHeader,sourceCode):
	#Behavior>>#implement:as:
	return self.implement_comment_as_category_(messageHeader,nil,sourceCode,nil) 
""","Behavior_implement_as_")
,"Builders-implementing","""implement: messageHeader as: sourceCode
	" Private - Implement a method in the receiver. "

	^self
		implement: messageHeader
		comment: nil
		as: sourceCode
		category: nil""",nil)
smalltalk.bind(smalltalk.Behavior,"implement:as:category:",0
,smalltalk.__f__("""(self,messageHeader,sourceCode,aCategory):
	#Behavior>>#implement:as:category:
	return self.implement_comment_as_category_(messageHeader,nil,sourceCode,aCategory) 
""","Behavior_implement_as_category_")
,"Builders-implementing","""implement: messageHeader as: sourceCode category: aCategory
	" Private - Implement a method in the receiver. "

	^self
		implement: messageHeader
		comment: nil
		as: sourceCode
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Behavior,"class:implement:comment:as:category:",0
,smalltalk.__f__("""(self,aClass,message,aComment,sourceCode,aCategory):
	#Behavior>>#class:implement:comment:as:category:
	if smalltalk.b(aClass.isString()):
		return self.class_implement_comment_as_category_(aClass.evaluateIn_(nil),message,aComment,sourceCode,aCategory) 
	 
	return aClass.implement_comment_as_category_(message,aComment,sourceCode,aCategory) 
""","Behavior_class_implement_comment_as_category_")
,"Builders-implementing","""class: aClass implement: message
	comment: aComment as: sourceCode
	category: aCategory
	" Private - Implement a method in aClass. "

	aClass isString ifTrue: [
		^self
			class: (aClass evaluateIn: nil)
			implement: message
			comment: aComment
			as: sourceCode
			category: aCategory
	].
	^aClass
		implement: message
		comment: aComment
		as: sourceCode
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Behavior,"build:doing:",0
,smalltalk.__f__("""(self,token,aBlock):
	#Behavior>>#build:doing:
	return smalltalk.APIBuilder.build_doing_(token,aBlock) 
""","Behavior_build_doing_")
,"Builders-private","""build: token doing: aBlock
	" Process a (build...: spec) definition marking methods generated while evaluating aBlock.
	Return the result of evaluating aBlock. "

	^APIBuilder build: token doing: aBlock""",nil)
smalltalk.bind(smalltalk.Behavior,"buildAPI:",0
,smalltalk.__f__("""(self,specs):
	#Behavior>>#buildAPI:
	def __blk1__(spec):
		def __blk2__():
			return spec.evaluateIn_(self) 
		def __blk3__():
			return self.perform_withArguments_(spec.first(),spec.copyFrom_to_(smalltalk.Number(2),spec.size())) 
		return smalltalk.if_true_false_(spec.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	specs.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Behavior_buildAPI_")
,"Builders-obsolete","""buildAPI: specs
	" Generate code to implement API protocoll defined by specs.
	WARNING: OBSOLETE - this builder generate changes that will not be filedOut to builder code.
	specs must be an array of :
		- string : it will be considered as an evaluable expression to be executed in the context of the receiver.
		- anArray : of #( selector arg1 arg2 arg3 arg4... ) to be performed for code generation/setup of the receiver
			where selector is frequently a build...: selector.
	"

	specs do: [:spec|
		spec isString
		ifTrue: [ spec evaluateIn: self ]
		ifFalse: [
			self	perform: spec first
				withArguments: (spec copyFrom: 2 to: spec size)
		]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"stMessageHeader:",0
,smalltalk.__f__("""(self,msgHeader):
	#Behavior>>#stMessageHeader:
	return msgHeader 
""","Behavior_stMessageHeader_")
,"Builders-private","""stMessageHeader: msgHeader
	" Private - Return a message header string with nice smalltalk looking.
	Default implementation leave the message header as is.
	This method can be refined by subclasses to transform message pattern for better code generation.
	"

	^msgHeader""",nil)
smalltalk.bind(smalltalk.Behavior,"buildAccessor:",0
,smalltalk.__f__("""(self,accessor):
	#Behavior>>#buildAccessor:
	def __blk1__():
		def __blk2__():
			def __blk3__():
				def __blk4__():
					return smalltalk.isObject_equalTo_(accessor.second(),smalltalk.String("initialize")) 
				return smalltalk.boolean_and_(accessor.size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk4__,0)) 
			return smalltalk.boolean_and_(accessor.isArray(),smalltalk.blk(__blk3__,0)) 
		def __blk5__():
			return smalltalk.object_comma_(self.buildGetter_(accessor),self.buildSetter_(accessor)) 
		def __blk6__():
			def __blk7__(tuple):
				return self.implement_comment_as_category_(tuple.first(),tuple.at_(smalltalk.Number(2)),tuple.at_(smalltalk.Number(3)),smalltalk.String("accessing")) 
			return accessor.compose_(smalltalk.blk(__blk7__,1)) 
		return smalltalk.if_true_false_(smalltalk.boolean_or_(accessor.isString(),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
	return self.build_doing_(smalltalk.String("Accessor")._minus_gt(accessor),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildAccessor_")
,"Builders-api","""buildAccessor: accessor
	" Build (instance) method to access native property. "

	^self build: #Accessor -> accessor doing: [
		(accessor isString or: [
			accessor isArray and: [
			accessor size > 1 and: [
			accessor second = #initialize ] ]
		]) ifTrue: [
			(self buildGetter: accessor)
			,(self buildSetter: accessor)
		] ifFalse: [
			accessor compose: [:tuple|
				self implement: tuple first comment: (tuple at: 2)
				      as: (tuple at: 3) category: #accessing
			]
		]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildGetterCode:",0
,smalltalk.__f__("""(self,aSelector):
	#Behavior>>#buildGetterCode:
	return smalltalk.object_comma_(smalltalk.String("^"),aSelector) 
""","Behavior_buildGetterCode_")
,"Builders-private","""buildGetterCode: aSelector
	" Private - Return source code to get aSelector. "

	^'^' ,aSelector""",nil)
smalltalk.bind(smalltalk.Behavior,"buildGetter:",0
,smalltalk.__f__("""(self,spec):
	#Behavior>>#buildGetter:
	def __blk1__():
		def __blk2__():
			def __blk3__():
				return smalltalk.isObject_equalTo_(spec.second(),smalltalk.String("initialize")) 
			return smalltalk.boolean_and_(spec.size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk3__,0)) 
		def __blk4__():
			return self.buildGetter_initialize_(spec.first(),spec.last()) 
		def __blk5__():
			return self.implement_comment_as_category_(self.stMessageHeader_(spec),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),spec),smalltalk.String(" of the receiver.")),self.buildGetterCode_(spec),smalltalk.String("accessing")) 
		return smalltalk.if_true_false_(smalltalk.boolean_and_(spec.isArray(),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
	return self.build_doing_(smalltalk.String("Getter")._minus_gt(spec),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildGetter_")
,"Builders-api","""buildGetter: spec
	" Build method for getter. "

	^self build: #Getter -> spec doing: [
		(spec isArray and: [ spec size > 1 and: [
		 spec second = #initialize ]]) ifTrue: [
			self buildGetter: spec first initialize: spec last
		] ifFalse: [
			self
				implement: (self stMessageHeader: spec)
				comment: 'Return the ' ,spec ,' of the receiver.'
				as: (self buildGetterCode: spec) category: #accessing
		]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildInitialize:with:",0
,smalltalk.__f__("""(self,aSelector,initializer):
	#Behavior>>#buildInitialize:with:
	return self.implement_comment_as_category_(smalltalk.object_comma_(smalltalk.String("initialize"),aSelector.asSmalltalkName_(smalltalk.true)),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Private - Initialize the "),aSelector),smalltalk.String(" of the receiver.")),initializer,smalltalk.String("initialize")) 
""","Behavior_buildInitialize_with_")
,"Builders-private","""buildInitialize: aSelector with: initializer
	" Private - Build method to initialize instance variable aSelector. "

	^self
		implement: #initialize ,(aSelector asSmalltalkName: true)
		comment: 'Private - Initialize the ' ,aSelector ,' of the receiver.'
		as: initializer
		category: #initialize""",nil)
smalltalk.bind(smalltalk.Behavior,"buildGetter:initialize:",0
,smalltalk.__f__('''(self,aSelector,initializer):
	#Behavior>>#buildGetter:initialize:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String("^self implementedBySubclass: #initialize") 
	def __blk2__():
		def __blk3__():
			def __blk4__():
				return initializer.copyFrom_to_(smalltalk.Number(2),initializer.size()) 
			def __blk5__():
				def __blk6__():
					return smalltalk.isObject_equalTo_(initializer.asArrayOfSubstrings().size(),smalltalk.Number(1)) 
				def __blk7__():
					return smalltalk.object_comma_(initializer,smalltalk.String(" new")) 
				def __blk8__():
					return initializer 
				return smalltalk.object_comma_(smalltalk.object_comma_(aSelector,smalltalk.String(" := ")),smalltalk.if_true_false_(smalltalk.boolean_and_(initializer.first().isUppercase(),smalltalk.blk(__blk6__,0)),smalltalk.blk(__blk7__,0),smalltalk.blk(__blk8__,0))) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(initializer.first(),smalltalk.String(".")),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		return smalltalk.if_true_false_(initializer.notEmpty(),smalltalk.blk(__blk3__,0),nil) 
	def __blk9__():
		return self.buildInitialize_with_(aSelector,__0__.code) 
	def __blk10__():
		return smalltalk.String("") 
	__0__.code=nil
	__0__.code=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(initializer,smalltalk.String("initialize")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.if_true_false_(smalltalk.notNil_(__0__.code),smalltalk.blk(__blk9__,0),smalltalk.blk(__blk10__,0)),self.implement_comment_as_category_(self.stMessageHeader_(aSelector),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(aSelector,smalltalk.String(" isNil ifTrue: [ self ")),smalltalk.String("initialize")),aSelector.asSmalltalkName_(smalltalk.true)),smalltalk.String(""" ].
		^""")),aSelector),smalltalk.String("accessing"))) 
''',"Behavior_buildGetter_initialize_")
,"Builders-private","""buildGetter: aSelector initialize: initializer
	" Private - Build method to get instance aSelector w/deferred initialization mode.
	Note: #initializer can be:
		#initialize to generate default/deferred implementation.
		empty string to do NOT generate #initialize... method.
		smalltalk code starting with $. to use that code as method implementation.
		smalltalk expression for asignment (to be used as assignment to instance).
		GlobalName if code do not have blanks and start with uppercase, it will be used as class to instantiate during initialization.
	"

	| code |
	code := initializer = #initialize
	  ifTrue: [ '^self implementedBySubclass: #initialize' ] ifFalse: [
		initializer notEmpty ifTrue: [
			initializer first = $.
			ifTrue: [ initializer copyFrom: 2 to: initializer size ] ifFalse: [
				aSelector ,' := ' ,(
					(initializer first isUppercase and: [ initializer asArrayOfSubstrings size = 1 ])
					ifTrue: [ initializer ,' new' ]
					ifFalse: [ initializer ])
			]
		]
	  ].
	^(code notNil ifTrue: [ self buildInitialize: aSelector with: code ] ifFalse: [ '' ])
	,(self
		implement: (self stMessageHeader: aSelector)
		comment: 'Return the ' ,aSelector ,' of the receiver.'
		as: aSelector,' isNil ifTrue: [ self ' , #initialize ,(aSelector asSmalltalkName: true) ,' ].
	^' ,aSelector category: #accessing)""",nil)
smalltalk.bind(smalltalk.Behavior,"buildSetterCode:",0
,smalltalk.__f__("""(self,aSelector):
	#Behavior>>#buildSetterCode:
	return smalltalk.object_comma_(aSelector,smalltalk.String(" := anObject")) 
""","Behavior_buildSetterCode_")
,"Builders-private","""buildSetterCode: aSelector
	" Private - Return source code to set aSelector. "

	^aSelector ,' := anObject'""",nil)
smalltalk.bind(smalltalk.Behavior,"buildSetter:",0
,smalltalk.__f__("""(self,spec):
	#Behavior>>#buildSetter:
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(spec.second(),smalltalk.String("initialize")) 
		return smalltalk.boolean_and_(spec.size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk2__,0)) 
	def __blk3__():
		return self.implement_comment_as_category_(smalltalk.object_comma_(self.stMessageHeader_(spec),smalltalk.String(": anObject")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Set the "),spec),smalltalk.String(" of the receiver.")),self.buildSetterCode_(spec),smalltalk.String("accessing")) 
	if smalltalk.b(smalltalk.boolean_and_(spec.isArray(),smalltalk.blk(__blk1__,0))):
		return self.buildSetter_(spec.first()) 
	 
	return self.build_doing_(smalltalk.String("Setter")._minus_gt(spec),smalltalk.blk(__blk3__,0)) 
""","Behavior_buildSetter_")
,"Builders-api","""buildSetter: spec
	" Build method for setter. "

	(spec isArray and: [ spec size > 1 and: [
	 spec second = #initialize ]]) ifTrue: [
		^self buildSetter: spec first
	].
	^self build: #Setter -> spec doing: [
		self
			implement: (self stMessageHeader: spec) ,': anObject'
			comment: 'Set the ' ,spec ,' of the receiver.'
			as: (self buildSetterCode: spec)
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildGetters:",0
,smalltalk.__f__("""(self,specs):
	#Behavior>>#buildGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildGetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("Getters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildGetters_")
,"Builders-api","""buildGetters: specs
	" Build methods to get instances. "

	specs isString ifTrue: [ ^self buildGetters: specs asArrayOfSubstrings ].
	^self build: #Getters -> specs doing: [
		specs compose: [:each| self buildGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildSetters:",0
,smalltalk.__f__("""(self,specs):
	#Behavior>>#buildSetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildSetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildSetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("Setters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildSetters_")
,"Builders-api","""buildSetters: specs
	" Build methods to set instances. "

	specs isString ifTrue: [ ^self buildSetters: specs asArrayOfSubstrings ].
	^self build: #Setters -> specs doing: [
		specs compose: [:each| self buildSetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildAccessors:",0
,smalltalk.__f__("""(self,specs):
	#Behavior>>#buildAccessors:
	def __blk1__():
		def __blk2__(each):
			return self.buildAccessor_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildAccessors_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("Accessors")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildAccessors_")
,"Builders-api","""buildAccessors: specs
	" Build methods to access instances. "

	specs isString ifTrue: [ ^self buildAccessors: specs asArrayOfSubstrings ].
	^self build: #Accessors -> specs doing: [
		specs compose: [:each| self buildAccessor: each ]
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildAccessors",0
,smalltalk.__f__("""(self):
	#Behavior>>#buildAccessors
	def __blk1__():
		return self.buildAccessors_(self.instanceVariableNames()) 
	return self.build_doing_(smalltalk.String("Accessors")._minus_gt(smalltalk.newArray([])),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildAccessors")
,"Builders-api","""buildAccessors
	" Private - Build methods to access all instance variables. "

	^self build: #Accessors -> #() doing: [
		self buildAccessors: self instanceVariableNames
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"buildPool:with:",0
,smalltalk.__f__("""(self,poolName,spec):
	#Behavior>>#buildPool:with:
	def __blk1__():
		def __blk2__(_s8_rec):
			_s8_rec.definePool_with_(poolName,spec) 
			_s8_rec.printDefinePool_with_(poolName,spec) 
			return _s8_rec.yourself() 
		return __blk2__(smalltalk.Smalltalk.current()) 
	return self.build_doing_(smalltalk.String("Pool")._minus_gt(spec),smalltalk.blk(__blk1__,0)) 
""","Behavior_buildPool_with_")
,"Builders-api","""buildPool: poolName with: spec
	" Private - Build a PoolDictionary with spec (and log definition in log stream). "

	^self build: #Pool -> spec doing: [
		Smalltalk current
			definePool: poolName with: spec;
			printDefinePool: poolName with: spec;
			yourself
	]""",nil)
smalltalk.bind(smalltalk.Behavior,"__tostring",0
,smalltalk.__f__("""(self):
	#Behavior>>#__tostring
	return smalltalk.to_String(self) 
""","Behavior___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Class.__class__,"categories",0
,smalltalk.__f__("""(self):
	#Class class>>#categories
	def __blk1__(each):
		return each.category() 
	return smalltalk.Smalltalk.classes().collect_(smalltalk.blk(__blk1__,1)).asHashedSet() 
""","Class_class_categories")
,"export","""categories
	" Return a collection with all defined categories. "

	^(Smalltalk classes collect: [:each | each category ]) asHashedSet""",nil)
smalltalk.bind(smalltalk.Class.__class__,"uncategorized",0
,smalltalk.__f__("""(self):
	#Class class>>#uncategorized
	def __blk1__(each):
		return smalltalk.isObject_equalTo_(each.category(),smalltalk.String("unclassified")) 
	return smalltalk.Smalltalk.classes().select_(smalltalk.blk(__blk1__,1)) 
""","Class_class_uncategorized")
,"export","""uncategorized
	" Return a collection with classes without category. "

	^Smalltalk classes select: [:each | each category = #unclassified ]""",nil)
smalltalk.bind(smalltalk.Class,"category",0
,smalltalk.__f__("""(self):
	#Class>>#category
	return smalltalk.basic_at_(self,smalltalk.String("$category")) 
""","Class_category")
,"accessing","""category
	" Return the category of the receiver. "

	^self basicAt: '$category'""",nil)
smalltalk.bind(smalltalk.Class,"category:",0
,smalltalk.__f__("""(self,aString):
	#Class>>#category:
	smalltalk.basic_at_put_(self,smalltalk.String("$category"),aString) 
	return self 
""","Class_category_")
,"accessing","""category: aString
	" Set the category of the receiver. "

	self basicAt: '$category' put: aString""",nil)
smalltalk.bind(smalltalk.Class,"classVariables",0
,smalltalk.__f__("""(self):
	#Class>>#classVariables
	__0__=smalltalk.newContext()
	def __blk1__():
		nil 
	__0__.names=nil
	__0__.names=smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$classVariableNames"),smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.isNil_(__0__.names)):
		return smalltalk.basic_at_(self,smalltalk.String("$classVariables")) 
	 
	self.basicDelete_(smalltalk.String("$classVariableNames")) 
	self.classVariableNames_(__0__.names) 
	return smalltalk.basic_at_(self,smalltalk.String("$classVariables")) 
""","Class_classVariables")
,"accessing","""classVariables
	" Return the class variables of the receiver. "

	| names |
	names := self basicAt: '$classVariableNames' ifAbsent: [].
	names isNil ifTrue: [ ^self basicAt: '$classVariables' ].
	self basicDelete: '$classVariableNames'.
	self classVariableNames: names.
	^self basicAt: '$classVariables'""",nil)
smalltalk.bind(smalltalk.Class,"classVariables:",0
,smalltalk.__f__("""(self,aDictionary):
	#Class>>#classVariables:
	def __blk1__():
		return aDictionary.isEmpty() 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(aDictionary),smalltalk.blk(__blk1__,0))):
		return self.basicDelete_(smalltalk.String("$classVariables")) 
	 
	return smalltalk.basic_at_put_(self,smalltalk.String("$classVariables"),aDictionary) 
""","Class_classVariables_")
,"accessing","""classVariables: aDictionary
	" Set the class variables of the receiver. "

	(aDictionary isNil or: [ aDictionary isEmpty ]) ifTrue: [
		^self basicDelete: '$classVariables'
	].
	^self basicAt: '$classVariables' put: aDictionary""",nil)
smalltalk.bind(smalltalk.Class,"poolDictionaries",0
,smalltalk.__f__("""(self):
	#Class>>#poolDictionaries
	return smalltalk.basic_at_(self,smalltalk.String("$poolDictionaries")) 
""","Class_poolDictionaries")
,"accessing","""poolDictionaries
	" Return the poolDictionaries of the receiver (anArray or nil). "

	^self basicAt: '$poolDictionaries'""",nil)
smalltalk.bind(smalltalk.Class,"poolDictionaries:",0
,smalltalk.__f__("""(self,anArray):
	_s8Ret_=smalltalk.newContext()
	try:
		#Class>>#poolDictionaries:
		if smalltalk.b(smalltalk.notNil_(anArray)):
			def __blk1__():
				return smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.object_comma_(smalltalk.String("Invalid pool dictionary names "),anArray.asLiteral()))) 
			if smalltalk.b(anArray.isEmpty()):
				smalltalk.raise_result_(_s8Ret_,self.poolDictionaries_(nil)) 
			 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(anArray.size(),anArray.asSet().size()),nil,smalltalk.blk(__blk1__,0)) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.basic_at_put_(self,smalltalk.String("$poolDictionaries"),anArray)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Class_poolDictionaries_")
,"accessing","""poolDictionaries: anArray
	" Set the poolDictionaries of the receiver. "

	anArray notNil ifTrue: [
		anArray isEmpty ifTrue: [
			^self poolDictionaries: nil
		].
		anArray size = anArray asSet size ifFalse: [
			^self error: 'Invalid pool dictionary names ' ,anArray asLiteral
		].
	].
	^self basicAt: '$poolDictionaries' put: anArray""",nil)
smalltalk.bind(smalltalk.Class,"classVariableNames",0
,smalltalk.__f__("""(self):
	#Class>>#classVariableNames
	def __blk1__():
		return smalltalk.Array.new() 
	def __blk2__():
		return self.classVariables().keys() 
	return smalltalk.if_true_false_(smalltalk.isNil_(self.classVariables()),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Class_classVariableNames")
,"accessing","""classVariableNames
	" Return the class variable names of the receiver. "

	^self classVariables isNil
		ifTrue: [ Array new ]
		ifFalse: [ self classVariables keys ]""",nil)
smalltalk.bind(smalltalk.Class,"classVariablesString",0
,smalltalk.__f__("""(self):
	#Class>>#classVariablesString
	return self.classVariableNames().join_(smalltalk.String(" ")) 
""","Class_classVariablesString")
,"accessing","""classVariablesString
	" Return the class variable names of the receiver as aString. "

	^self classVariableNames join: ' '""",nil)
smalltalk.bind(smalltalk.Class,"poolDictionaryNames",0
,smalltalk.__f__("""(self):
	#Class>>#poolDictionaryNames
	def __blk1__():
		return smalltalk.Array.new() 
	def __blk2__():
		return self.poolDictionaries() 
	return smalltalk.if_true_false_(smalltalk.isNil_(self.poolDictionaries()),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Class_poolDictionaryNames")
,"accessing","""poolDictionaryNames
	" Return the pool dictionary names of the receiver. "

	^self poolDictionaries isNil
		ifTrue: [ Array new ]
		ifFalse: [ self poolDictionaries ]""",nil)
smalltalk.bind(smalltalk.Class,"poolDictionariesString",0
,smalltalk.__f__("""(self):
	#Class>>#poolDictionariesString
	return self.poolDictionaryNames().join_(smalltalk.String(" ")) 
""","Class_poolDictionariesString")
,"accessing","""poolDictionariesString
	" Return the poolDictionary names of the receiver as aString. "

	^self poolDictionaryNames join: ' '""",nil)
smalltalk.bind(smalltalk.Class,"classVariableNames:",0
,smalltalk.__f__("""(self,classVarNames):
	#Class>>#classVariableNames:
	__0__=smalltalk.newContext()
	def __blk1__():
		return classVarNames.asArrayOfSubstrings() 
	def __blk2__():
		return classVarNames 
	def __blk3__(each):
		def __blk4__():
			return nil 
		return __0__.dictionary.at_put_(each,__0__.old.at_ifAbsent_(each,smalltalk.blk(__blk4__,0))) 
	__0__.names=nil
	__0__.dictionary=nil
	__0__.old=nil
	if smalltalk.b(smalltalk.isNil_(classVarNames)):
		return self.classVariables_(nil) 
	 
	__0__.names=smalltalk.if_true_false_(classVarNames.isString(),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.names.size(),__0__.names.asSet().size())):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid class variable names "),__0__.names.asLiteral())) 
	 
	__0__.dictionary=smalltalk.PoolDictionary.new() 
	__0__.old=self.classVariables() 
	if smalltalk.b(smalltalk.isNil_(__0__.old)):
		__0__.old=__0__.dictionary 
	 
	__0__.names.do_(smalltalk.blk(__blk3__,1)) 
	self.classVariables_(__0__.dictionary) 
	return self 
""","Class_classVariableNames_")
,"accessing","""classVariableNames: classVarNames
	" Set the variable names defined in the receiver. "

	| names dictionary old |
	classVarNames isNil ifTrue: [ ^self classVariables: nil ].
	names := classVarNames isString
		ifTrue: [ classVarNames asArrayOfSubstrings ]
		ifFalse: [ classVarNames ].
	names size = names asSet size ifFalse: [
		^self error: 'Invalid class variable names ' ,names asLiteral
	].
	dictionary := PoolDictionary new.
	old := self classVariables. old isNil ifTrue: [ old := dictionary ].
	names do: [:each|
		dictionary at: each put: (old at: each ifAbsent: [ nil ])
	].
	self classVariables: dictionary.""",nil)
smalltalk.bind(smalltalk.Class,"poolDictionaryNames:",0
,smalltalk.__f__("""(self,poolVarNames):
	#Class>>#poolDictionaryNames:
	def __blk1__():
		return poolVarNames.asArrayOfSubstrings() 
	def __blk2__():
		return poolVarNames 
	self.poolDictionaries_(smalltalk.if_true_false_(poolVarNames.isString(),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
	return self 
""","Class_poolDictionaryNames_")
,"accessing","""poolDictionaryNames: poolVarNames
	" Set the pool dictionary names known to the receiver. "

	self poolDictionaries: (poolVarNames isString
		ifTrue: [ poolVarNames asArrayOfSubstrings ]
		ifFalse: [ poolVarNames ]).""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#subclass:instanceVariableNames:
	return self.subclass_instanceVariableNames_classVariableNames_(aString,aString2,smalltalk.String("")) 
""","Class_subclass_instanceVariableNames_")
,"instantiation","""subclass: aString instanceVariableNames: aString2
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: ''""",nil)
smalltalk.bind(smalltalk.Class,"subclass:category:",0
,smalltalk.__f__("""(self,aString,aCategory):
	#Class>>#subclass:category:
	return self.subclass_instanceVariableNames_category_(aString,smalltalk.String(""),aCategory) 
""","Class_subclass_category_")
,"instantiation","""subclass: aString category: aCategory
	" Create a subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: ''
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:category:",0
,smalltalk.__f__("""(self,aString,aString2,aString3):
	#Class>>#subclass:instanceVariableNames:category:
	return smalltalk.ClassBuilder.new().superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3) 
""","Class_subclass_instanceVariableNames_category_")
,"instantiation","""subclass: aString instanceVariableNames: aString2 category: aString3
	" Create a subclass of the receiver. "

	^ClassBuilder new
		superclass: self
		subclass: aString
		instanceVariableNames: aString2
		category: aString3""",nil)
smalltalk.bind(smalltalk.Class,"isClass",0
,smalltalk.__f__("""(self):
	#Class>>#isClass
	return smalltalk.true 
""","Class_isClass")
,"testing","""isClass
	" Return true if the receiver is a Class. "

	^true""",nil)
smalltalk.bind(smalltalk.Class,"printString",0
,smalltalk.__f__("""(self):
	#Class>>#printString
	return self.name() 
""","Class_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^self name""",nil)
smalltalk.bind(smalltalk.Class,"instanceClass",0
,smalltalk.__f__("""(self):
	#Class>>#instanceClass
	return self 
""","Class_instanceClass")
,"accessing","""instanceClass
	" Return the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Class,"rename:",0
,smalltalk.__f__("""(self,aString):
	#Class>>#rename:
	self.smalltalk().renameClass(self,aString) 
	return self 
""","Class_rename_")
,"renaming","""rename: aString
	" Rename the receiver to aString. "

	self smalltalk #renameClass: self to: aString""",nil)
smalltalk.bind(smalltalk.Class,"removeFromSystem",0
,smalltalk.__f__("""(self):
	#Class>>#removeFromSystem
	def __blk1__(each):
		return each.removeFromSystem() 
	self.subclasses().do_(smalltalk.blk(__blk1__,1)) 
	self.smalltalk().removeClass(self) 
	return smalltalk.true 
""","Class_removeFromSystem")
,"remove","""removeFromSystem
	" Remove the receiver from system. "

	self subclasses do: [:each| each removeFromSystem ].
	self smalltalk #removeClass: self.
	^true""",nil)
smalltalk.bind(smalltalk.Class,"removeSources",0
,smalltalk.__f__("""(self):
	#Class>>#removeSources
	def __blk1__(each):
		return each.removeSources() 
	def __blk2__(each):
		return each.removeSources() 
	def __blk3__(_s8_rec):
		_s8_rec.comment_(smalltalk.String("")) 
		return _s8_rec.category_(smalltalk.String("s8")) 
	(self).__class__.methodsDo_(smalltalk.blk(__blk1__,1)) 
	self.methodsDo_(smalltalk.blk(__blk2__,1)) 
	__blk3__(self) 
	return self 
""","Class_removeSources")
,"tools","""removeSources
	" Remove all development sources of the receiver. "

	self class methodsDo: [:each | each removeSources ].
	self methodsDo: [:each | each removeSources ].
	self comment: ''; category: #s8""",nil)
smalltalk.bind(smalltalk.Class,"variableByteSubclass:classVariableNames:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,classVarNames,poolVarNames):
	#Class>>#variableByteSubclass:classVariableNames:poolDictionaries:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,smalltalk.String(""),classVarNames,poolVarNames) 
""","Class_variableByteSubclass_classVariableNames_poolDictionaries_")
,"instantiation","""variableByteSubclass: aString
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	" Create a new subclass of the receiver. "

"	self note: 'WARNING: ',aString,' defined as variableByteSubclass:...'.
"	^self 
		subclass: aString
		instanceVariableNames: ''
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,poolVarNames):
	#Class>>#variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("WARNING: "),aString),smalltalk.String(" defined as variableSubclass:..."))) 
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,poolVarNames) 
""","Class_variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_")
,"instantiation","""variableSubclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	" Create a new subclass of the receiver. "

	self note: 'WARNING: ',aString,' defined as variableSubclass:...'.
	^self 
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,poolVarNames,aCategory):
	#Class>>#subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
	if smalltalk.b(smalltalk.notNil_(self.smalltalk().globalAt_(aString))):
		self.note_(smalltalk.object_comma_(smalltalk.String("WARNING: class REdefinition for "),aString)) 
	 
	return smalltalk.ClassBuilder.new().superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory) 
""","Class_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	category: aCategory
	" Create a new subclass of the receiver. "

	(self smalltalk globalAt: aString) notNil ifTrue: [
		self note: 'WARNING: class REdefinition for ',aString.
		"^self smalltalk globalAt: aString"
	].

"	self note: 'Creating ',aString."
	^ClassBuilder new
		superclass: self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:category:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,aCategory):
	#Class>>#subclass:instanceVariableNames:classVariableNames:category:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,smalltalk.String(""),aCategory) 
""","Class_subclass_instanceVariableNames_classVariableNames_category_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	category: aCategory
	" Create a new subclass of the receiver. "

	^self subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: ''
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,poolVarNames):
	#Class>>#subclass:instanceVariableNames:classVariableNames:poolDictionaries:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil) 
""","Class_subclass_instanceVariableNames_classVariableNames_poolDictionaries_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames
		category: nil""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:category:",0
,smalltalk.__f__("""(self,aString,aString2,poolVarNames,aCategory):
	#Class>>#subclass:instanceVariableNames:poolDictionaries:category:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,smalltalk.String(""),poolVarNames,aCategory) 
""","Class_subclass_instanceVariableNames_poolDictionaries_category_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	poolDictionaries: poolVarNames
	category: aCategory
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: ''
		poolDictionaries: poolVarNames
		category: aCategory""",nil)
smalltalk.bind(smalltalk.Class,"variableByteSubclass:classVariableNames:",0
,smalltalk.__f__("""(self,aString,classVarNames):
	#Class>>#variableByteSubclass:classVariableNames:
	return self.variableByteSubclass_classVariableNames_poolDictionaries_(aString,classVarNames,smalltalk.String("")) 
""","Class_variableByteSubclass_classVariableNames_")
,"instantiation","""variableByteSubclass: aString classVariableNames: classVarNames
	" Create a new subclass of the receiver. "

	^self
		variableByteSubclass: aString
		classVariableNames: classVarNames
		poolDictionaries: ''""",nil)
smalltalk.bind(smalltalk.Class,"variableByteSubclass:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#variableByteSubclass:poolDictionaries:
	return self.variableByteSubclass_classVariableNames_poolDictionaries_(aString,smalltalk.String(""),aString2) 
""","Class_variableByteSubclass_poolDictionaries_")
,"instantiation","""variableByteSubclass: aString poolDictionaries: aString2
	" Create a new subclass of the receiver. "

	^self
		variableByteSubclass: aString
		classVariableNames: ''
		poolDictionaries: aString2""",nil)
smalltalk.bind(smalltalk.Class,"variableByteSubclass:",0
,smalltalk.__f__("""(self,aString):
	#Class>>#variableByteSubclass:
	return self.variableByteSubclass_classVariableNames_(aString,smalltalk.String("")) 
""","Class_variableByteSubclass_")
,"instantiation","""variableByteSubclass: aString
	" Create a new subclass of the receiver. "

	^self
		variableByteSubclass: aString
		classVariableNames: ''""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames):
	#Class>>#variableSubclass:instanceVariableNames:classVariableNames:
	return self.variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,smalltalk.String("")) 
""","Class_variableSubclass_instanceVariableNames_classVariableNames_")
,"instantiation","""variableSubclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	" Create a new subclass of the receiver. "

	^self 
		variableSubclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: ''""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:instanceVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#variableSubclass:instanceVariableNames:
	return self.variableSubclass_instanceVariableNames_classVariableNames_(aString,aString2,smalltalk.String("")) 
""","Class_variableSubclass_instanceVariableNames_")
,"instantiation","""variableSubclass: aString instanceVariableNames: aString2
	" Create a new subclass of the receiver. "

	^self 
		variableSubclass: aString
		instanceVariableNames: aString2
		classVariableNames: ''""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:classVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#variableSubclass:classVariableNames:
	return self.variableSubclass_instanceVariableNames_classVariableNames_(aString,smalltalk.String(""),aString2) 
""","Class_variableSubclass_classVariableNames_")
,"instantiation","""variableSubclass: aString classVariableNames: aString2
	" Create a new subclass of the receiver. "

	^self 
		variableSubclass: aString
		instanceVariableNames: ''
		classVariableNames: aString2""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#variableSubclass:poolDictionaries:
	return self.variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,smalltalk.String(""),smalltalk.String(""),aString2) 
""","Class_variableSubclass_poolDictionaries_")
,"instantiation","""variableSubclass: aString poolDictionaries: aString2
	" Create a new subclass of the receiver. "

	^self 
		variableSubclass: aString
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: aString2""",nil)
smalltalk.bind(smalltalk.Class,"variableSubclass:",0
,smalltalk.__f__("""(self,aString):
	#Class>>#variableSubclass:
	return self.variableSubclass_instanceVariableNames_(aString,smalltalk.String("")) 
""","Class_variableSubclass_")
,"instantiation","""variableSubclass: aString
	" Create a new subclass of the receiver. "

	^self 
		variableSubclass: aString
		instanceVariableNames: ''""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames):
	#Class>>#subclass:instanceVariableNames:classVariableNames:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,smalltalk.String("")) 
""","Class_subclass_instanceVariableNames_classVariableNames_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: ''""",nil)
smalltalk.bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2,aString3):
	#Class>>#subclass:instanceVariableNames:poolDictionaries:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,smalltalk.String(""),aString3) 
""","Class_subclass_instanceVariableNames_poolDictionaries_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	poolDictionaries: aString3
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: ''
		poolDictionaries: aString3""",nil)
smalltalk.bind(smalltalk.Class,"subclass:classVariableNames:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#subclass:classVariableNames:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,smalltalk.String(""),aString2,smalltalk.String("")) 
""","Class_subclass_classVariableNames_")
,"instantiation","""subclass: aString classVariableNames: aString2
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: ''
		classVariableNames: aString2
		poolDictionaries: ''""",nil)
smalltalk.bind(smalltalk.Class,"subclass:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2):
	#Class>>#subclass:poolDictionaries:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,smalltalk.String(""),smalltalk.String(""),aString2) 
""","Class_subclass_poolDictionaries_")
,"instantiation","""subclass: aString poolDictionaries: aString2
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: aString2""",nil)
smalltalk.bind(smalltalk.Class,"subclass:",0
,smalltalk.__f__("""(self,aString):
	#Class>>#subclass:
	return self.subclass_instanceVariableNames_(aString,smalltalk.String("")) 
""","Class_subclass_")
,"instantiation","""subclass: aString
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: ''""",nil)
smalltalk.bind(smalltalk.Class,"hackDNU",0
,smalltalk.__f__("""(self):
	#Class>>#hackDNU
	__0__=smalltalk.newContext()
	def __blk1__(root):
		def __blk2__(each):
			def __blk3__(_s8_rec):
				_s8_rec.addAll_(each.selectors()) 
				return _s8_rec.addAll_((each).__class__.selectors()) 
			return __blk3__(__0__.all) 
		return root.allSubclasses().do_(smalltalk.blk(__blk2__,1)) 
	def __blk4__(root):
		def __blk5__(each):
			def __blk6__():
				nil 
			return __0__.all.remove_ifAbsent_(each,smalltalk.blk(__blk6__,0)) 
		return root.selectors().do_(smalltalk.blk(__blk5__,1)) 
	def __blk7__(each):
		def __blk8__():
			nil 
		return __0__.all.remove_ifAbsent_(each,smalltalk.blk(__blk8__,0)) 
	def __blk9__(selector):
		__1__=smalltalk.newContext()
		def __blk10__(_s8_rec):
			_s8_rec.selector_(selector) 
			_s8_rec.classField_(self) 
			_s8_rec.category_(smalltalk.String("hackDNU")) 
			return _s8_rec.source_(smalltalk.object_comma_(selector,smalltalk.String("(dnu)"))) 
		__1__.mth=nil
		__1__.mth=smalltalk.CompiledMethod.new() 
		__blk10__(__1__.mth) 
		self.notImplementedYet_(smalltalk.String("Class>>#hackDNU")) 
		return self.basicAddCompiledMethod_(__1__.mth) 
	__0__.all=nil
	__0__.all=smalltalk.HashedSet.new() 
	smalltalk.Smalltalk.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	smalltalk.Smalltalk.rootClasses().do_(smalltalk.blk(__blk4__,1)) 
	smalltalk.newArray(["handleOrNil","start:end:"]).do_(smalltalk.blk(__blk7__,1)) 
	__0__.all.do_(smalltalk.blk(__blk9__,1)) 
	return self 
""","Class_hackDNU")
,"Tools-hacking","""hackDNU
	" Catch DNU condition in the receiver and its subclasses.
	Note: hack will persist until #unhackDNU is sent to the receiver.
	"

	| all |
	all := HashedSet new.
	Smalltalk rootClasses do: [:root|
		root allSubclasses do: [:each|
			all addAll: each selectors; addAll: each class selectors
		].
	].
	Smalltalk rootClasses do: [:root| root selectors do: [:each| all remove: each ifAbsent: []] ].
	#( #handleOrNil #start:end: ) do: [:each| all remove: each ifAbsent: []].
	all do: [:selector| | mth |
		mth := CompiledMethod new.
		mth selector: selector; classField: self; category: #hackDNU; source: selector,'(dnu)'.
		{''js'mth.fn_(function(){
		this.print_("//DNU "+selector);
		this.doesNotUnderstand_(
			smalltalk.Message.receiver_selector_arguments_
				(this,selector,[].slice.call(arguments)))}
		);'}.
		self basicAddCompiledMethod: mth.
	].""",nil)
smalltalk.bind(smalltalk.Class,"unhackDNU",0
,smalltalk.__f__("""(self):
	#Class>>#unhackDNU
	def __blk1__(each):
		return smalltalk.isObject_equalTo_(smalltalk.Object._gt_gt(each).category(),smalltalk.String("hackDNU")) 
	self.removeSelectors_(self.selectors().select_(smalltalk.blk(__blk1__,1))) 
	return self 
""","Class_unhackDNU")
,"Tools-hacking","""unhackDNU
	" Remove Catch DNU hacking on the receiver. "

	self removeSelectors: (self selectors
		select: [:each| (Object >> each) category = #hackDNU ])""",nil)
smalltalk.bind(smalltalk.Class,"hackDNUWhile:",0
,smalltalk.__f__("""(self,aBlock):
	#Class>>#hackDNUWhile:
	__0__=smalltalk.newContext()
	def __blk1__():
		self.hackDNU() 
		__0__.result=aBlock.evaluate()
		return __0__.result 
	def __blk2__():
		return self.unhackDNU() 
	__0__.result=nil
	smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
	return __0__.result 
""","Class_hackDNUWhile_")
,"Tools-hacking","""hackDNUWhile: aBlock
	" Catch DNU hacking on the receiver while evaluating aBlock. "

	| result |
	[	self hackDNU.
		result := aBlock evaluate
	] ensure: [ self unhackDNU ].
	^result""",nil)
smalltalk.bind(smalltalk.Class,"launch",0
,smalltalk.__f__("""(self):
	#Class>>#launch
	return self 
""","Class_launch")
,"Snapshot-startup","""launch
	" Private - The system has been launched and start execution.
	The default action is to do nothing.
	Subclasses can refine this method to execute actions on startup.
	\"""",nil)
smalltalk.bind(smalltalk.Class,"aboutToSaveImage:on:",0
,smalltalk.__f__("""(self,snapshot,stream):
	#Class>>#aboutToSaveImage:on:
	return self 
""","Class_aboutToSaveImage_on_")
,"Snapshot-snapshot","""aboutToSaveImage: snapshot on: stream
	" Private - A system snapshot will be taken, the receiver can prepare the contents to be stored on snapshot.
	Must return the receiver or a replacement to act as the receiver when persisting data.
	The default action return the receiver.
	"

	^self""",nil)
smalltalk.bind(smalltalk.Class,"imageSaved:on:",0
,smalltalk.__f__("""(self,snapshot,stream):
	#Class>>#imageSaved:on:
	return self 
""","Class_imageSaved_on_")
,"Snapshot-snapshot","""imageSaved: snapshot on: stream
	" Private - A system snapshot has been taken, the receiver can emmit code to restore state.
	The default action do nothing.
	This method can be refined by the subclasses.
	\"""",nil)
smalltalk.bind(smalltalk.Class,"aboutToExit:",0
,smalltalk.__f__("""(self,aSystemDictionary):
	#Class>>#aboutToExit:
	return self 
""","Class_aboutToExit_")
,"Snapshot-snapshot","""aboutToExit: aSystemDictionary
	" Private - A system will exit, and the receiver can act executing actions just before exiting.
	The default action do nothing.
	This method can be refined by the subclasses.
	\"""",nil)
smalltalk.bind(smalltalk.Class,"sample",0
,smalltalk.__f__("""(self):
	#Class>>#sample
	return smalltalk.Number(7) 
""","Class_sample")
,"_tests_-super","""sample
	^7""",nil)
smalltalk.bind(smalltalk.Metaclass,"instanceClass",0
,smalltalk.__f__("""(self):
	#Metaclass>>#instanceClass
	return getattr(self,"@instanceClass",nil) 
""","Metaclass_instanceClass")
,"accessing","""instanceClass
	" Return the instance class of receiver. "

	^instanceClass""",nil)
smalltalk.bind(smalltalk.Metaclass,"instanceVariableNames:",0
,smalltalk.__f__("""(self,aString):
	#Metaclass>>#instanceVariableNames:
	smalltalk.ClassBuilder.new().class_instanceVariableNames_(self,aString) 
	return self.instanceVariableNames() 
""","Metaclass_instanceVariableNames_")
,"accessing","""instanceVariableNames: aString
	" Set the instance variable names of the receiver. "

	ClassBuilder new
		class: self
		instanceVariableNames: aString.
	^self instanceVariableNames """,nil)
smalltalk.bind(smalltalk.Metaclass,"isMetaclass",0
,smalltalk.__f__("""(self):
	#Metaclass>>#isMetaclass
	return smalltalk.true 
""","Metaclass_isMetaclass")
,"testing","""isMetaclass
	" Return true if the receiver is a metaclass. "

	^true""",nil)
smalltalk.bind(smalltalk.Metaclass,"printString",0
,smalltalk.__f__("""(self):
	#Metaclass>>#printString
	return smalltalk.object_comma_(self.instanceClass().name(),smalltalk.String(" class")) 
""","Metaclass_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^self instanceClass name, ' class'""",nil)
smalltalk.bind(smalltalk.Metaclass,"poolDictionaries",0
,smalltalk.__f__("""(self):
	#Metaclass>>#poolDictionaries
	return self.instanceClass().poolDictionaries() 
""","Metaclass_poolDictionaries")
,"accessing","""poolDictionaries
	" Return the poolDictionaries of the receiver. "

	^self instanceClass poolDictionaries""",nil)
smalltalk.bind(smalltalk.Metaclass,"classVariables",0
,smalltalk.__f__("""(self):
	#Metaclass>>#classVariables
	return self.instanceClass().classVariables() 
""","Metaclass_classVariables")
,"accessing","""classVariables
	" Return the class variables of the receiver. "

	^self instanceClass classVariables""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"source",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#source
	def __blk1__():
		return smalltalk.String("") 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$source"),smalltalk.blk(__blk1__,0)) 
""","CompiledMethod_source")
,"accessing","""source
	" Return the source code of the receiver. "

	^self basicAt: '$source' ifAbsent: ['']""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"source:",0
,smalltalk.__f__("""(self,aString):
	#CompiledMethod>>#source:
	smalltalk.basic_at_put_(self,smalltalk.String("$source"),aString) 
	return self 
""","CompiledMethod_source_")
,"accessing","""source: aString
	" Set the source code of the receiver. "

	self basicAt: '$source' put: aString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"category",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#category
	def __blk1__():
		return smalltalk.String("") 
	return smalltalk.basic_at_ifAbsent_(self,smalltalk.String("$category"),smalltalk.blk(__blk1__,0)) 
""","CompiledMethod_category")
,"accessing","""category
	" Return the category of the receiver. "

	^self basicAt: '$category' ifAbsent: ['']""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"category:",0
,smalltalk.__f__("""(self,aString):
	#CompiledMethod>>#category:
	smalltalk.basic_at_put_(self,smalltalk.String("$category"),aString) 
	return self 
""","CompiledMethod_category_")
,"accessing","""category: aString
	" Set the category of the receiver. "

	self basicAt: '$category' put: aString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"stamp",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#stamp
	return smalltalk.basic_at_(self,smalltalk.String("$stamp")) 
""","CompiledMethod_stamp")
,"accessing","""stamp
	" Return the stamp of the receiver. "

	^self basicAt: '$stamp'""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"stamp:",0
,smalltalk.__f__("""(self,aString):
	#CompiledMethod>>#stamp:
	smalltalk.basic_at_put_(self,smalltalk.String("$stamp"),aString) 
	return self 
""","CompiledMethod_stamp_")
,"accessing","""stamp: aString
	" Set the stamp of the receiver. "

	self basicAt: '$stamp' put: aString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"selector",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#selector
	return smalltalk.basic_at_(self,smalltalk.String("$selector")) 
""","CompiledMethod_selector")
,"accessing","""selector
	" Return the selector of the receiver. "

	^self basicAt: '$selector'""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"selector:",0
,smalltalk.__f__("""(self,aString):
	#CompiledMethod>>#selector:
	smalltalk.basic_at_put_(self,smalltalk.String("$selector"),aString) 
	return self 
""","CompiledMethod_selector_")
,"accessing","""selector: aString
	" Set the selector of the receiver. "

	self basicAt: '$selector' put: aString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"fn",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#fn
	return smalltalk.basic_at_(self,smalltalk.String("$fn")) 
""","CompiledMethod_fn")
,"accessing","""fn
	" Return the native implementation of the receiver (or nil). "

	^self basicAt: '$fn'""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"fn:",0
,smalltalk.__f__("""(self,aBlock):
	#CompiledMethod>>#fn:
	smalltalk.basic_at_put_(self,smalltalk.String("$fn"),aBlock) 
	return self 
""","CompiledMethod_fn_")
,"accessing","""fn: aBlock
	" Set the native implementation of the receiver. "

	self basicAt: '$fn' put: aBlock""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"asClosure",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#asClosure
	if True:
		return smalltalk.BlockClosure(self.fn())
	 
	return self.fn() 
""","CompiledMethod_asClosure")
,"accessing","""asClosure
	" Private - Return the receiver as a native closure (or nil). "

	{'self'}. "macro hook"
	^self fn""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"compiledSource",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#compiledSource
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.closure.compiledSourceAt_(self) 
	__0__.closure=nil
	__0__.closure=self.asClosure() 
	return smalltalk.if_true_false_(smalltalk.notNil_(__0__.closure),smalltalk.blk(__blk1__,0),nil) 
""","CompiledMethod_compiledSource")
,"accessing","""compiledSource
	" Return the native source code of the receiver (or nil). "

	| closure |
	closure := self asClosure.
	^closure notNil ifTrue: [ closure compiledSourceAt: self ]""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"classField",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#classField
	return getattr(self,"@classField",nil) 
""","CompiledMethod_classField")
,"accessing","""classField
	" Return the implementor of the receiver. "

	^classField""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"classField:",0
,smalltalk.__f__("""(self,aClass):
	#CompiledMethod>>#classField:
	smalltalk.basic_at_put(self,"@classField",aClass) 
	return self 
""","CompiledMethod_classField_")
,"accessing","""classField: aClass
	" Set the implementor of the receiver. "

	classField := aClass""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"generation",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#generation
	return smalltalk.basic_at_(self,smalltalk.String("$generation")) 
""","CompiledMethod_generation")
,"accessing","""generation
	" Return the generation of the receiver. "

	^self basicAt: '$generation'""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"comment",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#comment
	def __blk1__(_s8_rec):
		_s8_rec.upTo_(smalltalk.String('"')) 
		return _s8_rec.upTo_(smalltalk.String('"')) 
	return __blk1__(self.source().stream()).trimBlanks() 
""","CompiledMethod_comment")
,"accessing","""comment
	" Return the comment of the receiver. "

	^(self source stream upTo: $"; upTo: $") trimBlanks""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"toString",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#toString
	def __blk1__():
		return smalltalk.to_String(getattr(self,"@classField",nil)) 
	def __blk2__():
		return getattr(self,"@classField",nil).name() 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@classField",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)),smalltalk.String(">>#")),smalltalk.to_String(self.selector())) 
""","CompiledMethod_toString")
,"printing","""toString
	" Return the receiver as a String. "

	^(classField isNil
		ifTrue: [classField toString]
		ifFalse: [classField name])
		,'>>#' ,self selector toString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"printString",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#printString
	return smalltalk.to_String(self) 
""","CompiledMethod_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"asJSONObject",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#asJSONObject
	return self 
""","CompiledMethod_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"shallowCopy",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#shallowCopy
	return self 
""","CompiledMethod_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"deepCopy",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#deepCopy
	return self 
""","CompiledMethod_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"removeSources",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#removeSources
	def __blk1__(_s8_rec):
		_s8_rec.source_(smalltalk.String("")) 
		_s8_rec.category_(smalltalk.String("s8")) 
		return _s8_rec.builder_(nil) 
	__blk1__(self) 
	return self 
""","CompiledMethod_removeSources")
,"Builders-tools","""removeSources
	" Remove all development sources of the receiver. "

	self source: ''; category: #s8; builder: nil""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"removeFromSystem",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#removeFromSystem
	if smalltalk.b(smalltalk.isObject_equalTo_(self.classField()._gt_gt(self.selector()),self)):
		self.classField().removeSelector_(self.selector()) 
	 
	return smalltalk.true 
""","CompiledMethod_removeFromSystem")
,"remove","""removeFromSystem
	" Remove the receiver from system. "

	self classField >> self selector = self ifTrue: [
		self classField removeSelector: self selector
	].
	^true""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"recompile",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#recompile
	self.classField().compiler().compile_forClass_category_(self.source(),self.classField(),self.category()) 
	return self 
""","CompiledMethod_recompile")
,"Compiler-compiling","""recompile
	" Recompile the source of the receiver and install the new compiled method. "

	self classField compiler
		compile: self source
		forClass: self classField
		category: self category""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"parseNodes",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#parseNodes
	return self.classField().compiler().parseMethod_(self.source()) 
""","CompiledMethod_parseNodes")
,"Compiler-inspecting","""parseNodes
	" Return the result of parsing the source of the receiver. "

	^self classField compiler parseMethod: self source""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"changeCommentWith:",0
,smalltalk.__f__('''(self,aBlock):
	#CompiledMethod>>#changeCommentWith:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String("""
		""") 
	def __blk2__():
		return smalltalk.String("") 
	def __blk3__(_s8_rec):
		_s8_rec.source_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.header,__0__.new),__0__.stream.upToEnd())) 
		return _s8_rec.recompile() 
	__0__.stream=nil
	__0__.header=nil
	__0__.old=nil
	__0__.new=nil
	__0__.nl=nil
	__0__.stream=self.source().stream() 
	__0__.header=smalltalk.SmalltalkParser.new().methodHeaderParser().parse_(__0__.stream) 
	if smalltalk.b(__0__.header.isParseFailure()):
		return smalltalk.false 
	 
	__0__.stream.skipSeparators() 
	__0__.header=__0__.stream.collection().copyFrom_to_(smalltalk.Number(1),__0__.stream.position()) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.stream.peek(),smalltalk.String('"'))):
		__0__.stream.next() 
		__0__.old=__0__.stream.upTo_(smalltalk.String('"')) 
		__0__.new=aBlock.evaluateWith_(__0__.old) 
	else:
		__0__.new=aBlock.evaluateWith_(smalltalk.String("")) 
	 
	if smalltalk.b(smalltalk.isNil_(__0__.new)):
		return smalltalk.false 
	 
	__0__.nl=smalltalk.if_true_false_(smalltalk.isNil_(__0__.old),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	__0__.new=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.nl,smalltalk.String('" ')),__0__.new.trimBlanks()),smalltalk.String(' "')),__0__.nl) 
	__blk3__(self) 
	return self 
''',"CompiledMethod_changeCommentWith_")
,"Compiler-transforms","""changeCommentWith: aBlock
	" Private - Change the comment of the receiver with aBlock.
	aBlock must be a one argument block to be evaluated with current comment.
	aBlock must return the new/empty comment (or nil, to cancel change).
	"

	| stream header old new nl |
	stream := self source stream.
	header := SmalltalkParser new methodHeaderParser parse: stream.
	header isParseFailure ifTrue: [ ^false ].
	stream skipSeparators.
	header := stream collection copyFrom: 1 to: stream position.
	stream peek = $" ifTrue: [
		stream next.
		old := stream upTo: $".
		new := aBlock evaluateWith: old.
	] ifFalse: [
		new := aBlock evaluateWith: ''.
	].
	new isNil ifTrue: [ ^false ].
	nl := old isNil ifTrue: [ '
	' ] ifFalse: [ '' ].
	new := nl ,'" ' ,new trimBlanks ,' "' ,nl.

	self
		source: header ,new ,stream upToEnd;
		recompile""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"tags",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#CompiledMethod>>#tags
		def __blk1__(old):
			def __blk2__(tag):
				return tag.trimBlanks() 
			return smalltalk.raise_result_(_s8Ret_,old.upTo_(smalltalk.String("-")).asArrayOfSubstringsSeparatedBy_(smalltalk.String(",")).collect_(smalltalk.blk(__blk2__,1))) 
		self.changeCommentWith_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.Array.new()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","CompiledMethod_tags")
,"Compiler-tags","""tags
	" Development - Return the tags stored in the receiver's comment. "

	self changeCommentWith: [:old|
		^((old upTo: $-)
			asArrayOfSubstringsSeparatedBy: $,)
			collect: [:tag| tag trimBlanks ]
	].
	^Array new""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"comment:",0
,smalltalk.__f__("""(self,aString):
	#CompiledMethod>>#comment:
	def __blk1__(old):
		return aString 
	return self.changeCommentWith_(smalltalk.blk(__blk1__,1)) 
""","CompiledMethod_comment_")
,"Compiler-accessing","""comment: aString
	" Change the comment in the receiver to aString. "

	^self changeCommentWith: [:old| aString ]""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"messageComment",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#messageComment
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.upTo_(smalltalk.String("-")) 
		return _s8_rec.upToEnd() 
	__0__.line=nil
	__0__.line=self.comment().stream().nextLine() 
	if not smalltalk.b(__0__.line.includes_(smalltalk.String("-"))):
		return __0__.line 
	 
	return __blk1__(__0__.line.stream()).trimBlanks() 
""","CompiledMethod_messageComment")
,"Compiler-accessing","""messageComment
	" Return the comment of the message implemented by the receiver.
	The messageComment is obtained from first line of comment of the receiver.
	Note: it is expected that all the methods implementing the same message in this system have the same messageComment.
	"

	| line |
	line := self comment stream nextLine.
	(line includes: $-) ifFalse: [ ^line ].
	^(line stream upTo: $-; upToEnd) trimBlanks""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"messageComment:",0
,smalltalk.__f__('''(self,aString):
	#CompiledMethod>>#messageComment:
	def __blk1__(old):
		__1__=smalltalk.newContext()
		def __blk2__():
			return smalltalk.String("") 
		def __blk3__():
			return smalltalk.object_comma_(smalltalk.String("""
	"""),__1__.stream.upToEnd()) 
		__1__.line=nil
		__1__.tags=nil
		__1__.stream=nil
		__1__.stream=old.stream() 
		__1__.line=__1__.stream.nextLine() 
		if smalltalk.b(__1__.line.includes_(smalltalk.String("-"))):
			__1__.tags=smalltalk.object_comma_(__1__.line.upTo_(smalltalk.String("-")),smalltalk.String("- ")) 
		else:
			__1__.tags=smalltalk.String("") 
		 
		return smalltalk.object_comma_(smalltalk.object_comma_(__1__.tags,aString),smalltalk.if_true_false_(__1__.stream.atEnd(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))) 
	return self.changeCommentWith_(smalltalk.blk(__blk1__,1)) 
''',"CompiledMethod_messageComment_")
,"Compiler-transforms","""messageComment: aString
	" Set the comment of the message implemented by the receiver. "

	^self changeCommentWith: [:old| | line tags stream |
		stream := old stream.
		line := stream nextLine.
		(line includes: $-) ifTrue: [
			tags := (line upTo: $-) ,'- '
		] ifFalse: [ tags := '' ].
		tags	,aString ,(stream atEnd ifTrue: [''] ifFalse: ['
'			,stream upToEnd])
	]""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"messages",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#messages
	return self.smalltalk().methodReferences().messagesOf_(self) 
""","CompiledMethod_messages")
,"Tools-accessing","""messages
	" Return all the messages that can be sent during execution of the receiver. "

	^self smalltalk methodReferences messagesOf: self""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"globalReferences",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#globalReferences
	return self.smalltalk().methodReferences().globalReferencesOf_(self) 
""","CompiledMethod_globalReferences")
,"Tools-accessing","""globalReferences
	" Return all the global references in the receiver. "

	^self smalltalk methodReferences globalReferencesOf: self""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"references",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#references
	def __blk1__(_s8_rec):
		_s8_rec.at_put_(smalltalk.String("messages"),self.messages()) 
		_s8_rec.at_put_(smalltalk.String("globalReferences"),self.globalReferences()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.PoolDictionary.new()) 
""","CompiledMethod_references")
,"Tools-accessing","""references
	" Return all the references in the receiver. "

	^PoolDictionary new
		at: #messages put: self messages;
		at: #globalReferences put: self globalReferences;
		yourself""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"builder:",0
,smalltalk.__f__("""(self,cookie):
	#CompiledMethod>>#builder:
	smalltalk.basic_at_put_(self,smalltalk.String("$builder"),cookie) 
	return self 
""","CompiledMethod_builder_")
,"Builders-accessing","""builder: cookie
	" Private - Set the builder cookie of the receiver. "

	self basicAt: '$builder' put: cookie""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"builder",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#builder
	return smalltalk.basic_at_(self,smalltalk.String("$builder")) 
""","CompiledMethod_builder")
,"Builders-accessing","""builder
	" Private - Return the builder cookie of the receiver (or nil). "

	^self basicAt: '$builder'""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"__tostring",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#__tostring
	return smalltalk.to_String(self) 
""","CompiledMethod___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.CompiledMethod,"src",0
,smalltalk.__f__("""(self):
	#CompiledMethod>>#src
	return smalltalk.basic_at_(self,smalltalk.String("$nativeSource")) 
""","CompiledMethod_src")
,"debug","""src
	^self basicAt: '$nativeSource' """,nil)
smalltalk.bind(smalltalk.Number.__class__,"pi",0
,smalltalk.__f__("""(self):
	#Number class>>#pi
	return self(smalltalk.math.pi) 
""","Number_class_pi")
,"instantiation","""pi
	" Return the singular value PI. "

	^{''js'Math.PI'}""",nil)
smalltalk.bind(smalltalk.Number.__class__,"readFrom:radix:",0
,smalltalk.__f__("""(self,aStream,radix):
	#Number class>>#readFrom:radix:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			def __blk3__():
				return __0__.char.isUpperCase() 
			return smalltalk.boolean_or_(__0__.char.isDigit(),smalltalk.blk(__blk3__,0)) 
		__0__.char=aStream.peek() 
		return smalltalk.boolean_and_(smalltalk.notNil_(__0__.char),smalltalk.blk(__blk2__,0)) 
	__0__.value=nil
	__0__.char=nil
	__0__.value=smalltalk.Number(0) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		if smalltalk.b(radix._lt(__0__.char.digitValue())):
			return __0__.value 
		 
		__0__.value=__0__.value._star(radix)._plus(__0__.char.digitValue()) 
		aStream.next() 
	 
	return __0__.value 
""","Number_class_readFrom_radix_")
,"converting","""readFrom: aStream radix: radix
	" Private - Read an integer from <aStream> and return it. "

	| value char |
	value := 0.
	[	char := aStream peek.
		char notNil and: [ char isDigit or: [ char isUpperCase ] ]
	] whileTrue: [
		radix <  char digitValue ifTrue: [ ^value ].
		value := value * radix + char digitValue.
		aStream next
	].
	^value""",nil)
smalltalk.bind(smalltalk.Number.__class__,"readFrom:",0
,smalltalk.__f__("""(self,aStream):
	#Number class>>#readFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return __0__.char.isDigit() 
		__0__.char=aStream.peek() 
		return smalltalk.boolean_and_(smalltalk.notNil_(__0__.char),smalltalk.blk(__blk2__,0)) 
	__0__.value=nil
	__0__.char=nil
	__0__.value=smalltalk.Number(0) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__0__.value=__0__.value._star(smalltalk.Number(10))._plus(__0__.char.digitValue()) 
		aStream.next() 
	 
	if not smalltalk.b(smalltalk.b_(__0__.char is smalltalk.String("r"))):
		return __0__.value 
	 
	aStream.next() 
	return self.readFrom_radix_(aStream,__0__.value) 
""","Number_class_readFrom_")
,"converting","""readFrom: aStream
	" Private - Read an integer from <aStream> and return it. "

	| value char |
	value := 0.
	[	char := aStream peek.
		char notNil and: [ char isDigit ]
	] whileTrue: [
		value := value * 10 + char digitValue.
		aStream next
	].
	char == "$r"'r' ifFalse: [ ^value ].
	aStream next. "skip the r"
	^self readFrom: aStream radix: value""",nil)
smalltalk.bind(smalltalk.Number.__class__,"basicNew",0
,smalltalk.__f__("""(self):
	#Number class>>#basicNew
	if True: return self(0) 
	return smalltalk.superReceiver(smalltalk.Number.__class__,self).basicNew() 
""","Number_class_basicNew")
,"Python-instantiation","""basicNew
	" Return an instance of the receiver. "

	{'self'
	py'if True: return self(0)'}.
	^super basicNew""",nil)
smalltalk.bind(smalltalk.Number,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#Number>>#=
	if True: return smalltalk.b_(smalltalk.handleOf(anObject) is smalltalk.handleOf(self)) 
	return self 
""","Number__eq")
,"comparing","""= anObject
    " Return true if the receiver is equal to argument. "

	{''js'
	if (nil.isNil_(anObject)) return false;
	if (!(anObject.isNumber)) return false;
	if (!(anObject.isNumber())) return false;
	if (self == anObject) return true;
	return ((0+self-anObject) == 0)'}""",nil)
smalltalk.bind(smalltalk.Number,"mustBeNumber",0
,smalltalk.__f__("""(self):
	#Number>>#mustBeNumber
	return self 
""","Number_mustBeNumber")
,"testing","""mustBeNumber
	" Signal an error if the receiver is not a Number.
	WARNING: this check impose a severe loss of perfomance (five times slower).
	If you are sure the operation/compare arguments are ok (a number),
	 comment the implementation of this method making the code empty.
	"

	"(# #isNaN: self) ifTrue: [ super mustBeNumber ]\"""",nil)
smalltalk.bind(smalltalk.Number,">","_gt"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#>
	return smalltalk.b_(smalltalk.handleOf(self) > smalltalk.handleOf(aNumber)) 
""","Number__gt")
,"comparing","""> aNumber
	" Return true if the receiver is greater than argument. "

	^{''js'self > aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"<","_lt"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#<
	return smalltalk.b_(smalltalk.handleOf(self) < smalltalk.handleOf(aNumber)) 
""","Number__lt")
,"comparing","""< aNumber
	" Return true if the receiver is smaller than argument. "

	^{''js'self < aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,">=","_gt_eq"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#>=
	return smalltalk.b_(smalltalk.handleOf(self) >= smalltalk.handleOf(aNumber)) 
""","Number__gt_eq")
,"comparing",""">= aNumber
	" Return true if the receiver is greater or equal to argument. "

	^{''js'self >= aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"<=","_lt_eq"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#<=
	return smalltalk.b_(smalltalk.handleOf(self) <= smalltalk.handleOf(aNumber)) 
""","Number__lt_eq")
,"comparing","""<= aNumber
	" Return true if the receiver is smaller or equal to argument. "

	^{''js'self <= aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"+","_plus"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#+
	return smalltalk.Number(smalltalk.handleOf(self) + smalltalk.handleOf(aNumber)) 
""","Number__plus")
,"arithmetic","""+ aNumber
	" Return the result of operation. "

	^{''js'self + aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"-","_minus"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#-
	return smalltalk.Number(smalltalk.handleOf(self) - smalltalk.handleOf(aNumber)) 
""","Number__minus")
,"arithmetic","""- aNumber
	" Return the result of operation. "

	^{''js'self - aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"*","_star"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#*
	return smalltalk.Number(smalltalk.handleOf(self) * smalltalk.handleOf(aNumber.mustBeNumber())) 
""","Number__star")
,"arithmetic","""* aNumber
	" Return the result of operation. "

	^{''js'self * aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"/","_slash"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#/
	return smalltalk.Number(smalltalk.handleOf(self) / smalltalk.handleOf(aNumber)) 
""","Number__slash")
,"arithmetic","""/ aNumber
	" Return the result of operation. "

	^{''js'self / aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"divideByZero",0
,smalltalk.__f__("""(self):
	#Number>>#divideByZero
	return self.error_(smalltalk.String("Divide by Zero")) 
""","Number_divideByZero")
,"signaling","""divideByZero
	" Signal divide by cero attempt. "

	^self error: 'Divide by Zero'""",nil)
smalltalk.bind(smalltalk.Number,"""\\\\""","_bk_bk"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#\\\\\\\\
	aNumber.mustBeNumber() 
	if smalltalk.b(smalltalk.isObject_equalTo_(aNumber,smalltalk.Number(0))):
		self.divideByZero() 
	 
	return self._minus(self._slash_slash(aNumber)._star(aNumber)) 
""","Number__bk_bk_bk_bk")
,"arithmetic","""\\\\\\\\ aNumber
	" Return the result of operation. "

	aNumber mustBeNumber.
	aNumber = 0 ifTrue: [ self divideByZero ].
	^self - (self // aNumber * aNumber)""",nil)
smalltalk.bind(smalltalk.Number,"//","_slash_slash"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#//
	aNumber.mustBeNumber() 
	if smalltalk.b(smalltalk.isObject_equalTo_(aNumber,smalltalk.Number(0))):
		self.divideByZero() 
	 
	return self._slash(aNumber).truncated() 
""","Number__slash_slash")
,"arithmetic","""// aNumber
	" Return the result of operation. "

	aNumber mustBeNumber.
	aNumber = 0 ifTrue: [ self divideByZero ].
	^(self / aNumber) truncated""",nil)
smalltalk.bind(smalltalk.Number,"sin",0
,smalltalk.__f__("""(self):
	#Number>>#sin
	return smalltalk.Number(smalltalk.math.sin(smalltalk.handleOf(self))) 
""","Number_sin")
,"arithmetic","""sin
	" Return the result of operation"

	^{''js'Math.sin(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"cos",0
,smalltalk.__f__("""(self):
	#Number>>#cos
	return smalltalk.Number(smalltalk.math.cos(smalltalk.handleOf(self))) 
""","Number_cos")
,"arithmetic","""cos
	" Return the result of operation"

	^{''js'Math.cos(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"tan",0
,smalltalk.__f__("""(self):
	#Number>>#tan
	return smalltalk.Number(smalltalk.math.tan(smalltalk.handleOf(self))) 
""","Number_tan")
,"arithmetic","""tan
	" Return the result of operation"

	^{''js'Math.tan(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"arcCos",0
,smalltalk.__f__("""(self):
	#Number>>#arcCos
	return smalltalk.Number(smalltalk.math.acos(smalltalk.handleOf(self))) 
""","Number_arcCos")
,"arithmetic","""arcCos
	" Return the result of operation"

	^{''js'Math.acos(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"arcSin",0
,smalltalk.__f__("""(self):
	#Number>>#arcSin
	return smalltalk.Number(smalltalk.math.asin(smalltalk.handleOf(self)))(self) 
""","Number_arcSin")
,"arithmetic","""arcSin
	" Return the result of operation"

	^{''js'Math.asin(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"arcTan",0
,smalltalk.__f__("""(self):
	#Number>>#arcTan
	return smalltalk.Number(smalltalk.math.atan(smalltalk.handleOf(self))) 
""","Number_arcTan")
,"arithmetic","""arcTan
	" Return the result of operation"

	^{''js'Math.atan(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"atan2:",0
,smalltalk.__f__("""(self,aNumber):
	#Number>>#atan2:
	return smalltalk.Number(smalltalk.math.atan2(smalltalk.handleOf(self))) 
""","Number_atan2_")
,"arithmetic","""atan2: aNumber
	" Return the result of operation"

	^{''js'Math.atan2(self,aNumber.mustBeNumber())'}""",nil)
smalltalk.bind(smalltalk.Number,"negated",0
,smalltalk.__f__("""(self):
	#Number>>#negated
	return smalltalk.Number(-1)._star(self) 
""","Number_negated")
,"arithmetic","""negated
	" Return the receiver negated"

	^-1 * self """,nil)
smalltalk.bind(smalltalk.Number,"squared",0
,smalltalk.__f__("""(self):
	#Number>>#squared
	return self._star(self) 
""","Number_squared")
,"arithmetic","""squared
	^self * self """,nil)
smalltalk.bind(smalltalk.Number,"sqrt",0
,smalltalk.__f__("""(self):
	#Number>>#sqrt
	return smalltalk.Number(smalltalk.math.sqrt(smalltalk.handleOf(self))) 
""","Number_sqrt")
,"arithmetic","""sqrt
	" Return the result of operation"

	^{''js'Math.sqrt(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"<<","_lt_lt"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#<<
	return smalltalk.Number(smalltalk.handleOf(self) << smalltalk.handleOf(aNumber)) 
""","Number__lt_lt")
,"arithmetic","""<< aNumber
	" Return the receiver shifted aNumber of bits to the left. "

	^{''js'self << aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,">>","_gt_gt"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#>>
	return smalltalk.Number(smalltalk.handleOf(self) >> smalltalk.handleOf(aNumber)) 
""","Number__gt_gt")
,"arithmetic",""">> aNumber
	" Return the receiver shifted aNumber of bits to the right. "

	^{''js'self >> aNumber.mustBeNumber()'}""",nil)
smalltalk.bind(smalltalk.Number,"bitShift:",0
,smalltalk.__f__("""(self,anInteger):
	#Number>>#bitShift:
	if smalltalk.b(anInteger._lt(smalltalk.Number(0))):
		return self._gt_gt(anInteger.negated()) 
	 
	return self._lt_lt(anInteger) 
""","Number_bitShift_")
,"arithmetic","""bitShift: anInteger
	" Return the receiver shifted left anInteger number of bits if anInteger is positive, or shifted right for anInteger negated number of bits if anInteger is negative."

	anInteger < 0 ifTrue: [ ^self >> anInteger negated ].
	^self << anInteger""",nil)
smalltalk.bind(smalltalk.Number,"raisedTo:",0
,smalltalk.__f__("""(self,aNumber):
	#Number>>#raisedTo:
	def __blk1__():
		return aNumber._gt(smalltalk.Number(0)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(aNumber,smalltalk.Number(0))):
		return smalltalk.Number(1) 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(self,smalltalk.Number(0)),smalltalk.blk(__blk1__,0))):
		return smalltalk.Number(0) 
	 
	return smalltalk.Number(smalltalk.math.pow(smalltalk.handleOf(self),smalltalk.handleOf(aNumber))) 
""","Number_raisedTo_")
,"arithmetic","""raisedTo: aNumber
	" Return the receiver raised to the power of aNumber. "

	aNumber = 0 ifTrue: [ ^1.0 ].
	(self = 0 and: [aNumber > 0]) ifTrue: [ ^0.0 ].
	^{''js'Math.pow(self,aNumber.mustBeNumber())'}""",nil)
smalltalk.bind(smalltalk.Number,"max:",0
,smalltalk.__f__("""(self,aNumber):
	#Number>>#max:
	return smalltalk.Number(max(smalltalk.handleOf(self),smalltalk.handleOf(aNumber))) 
""","Number_max_")
,"arithmetic","""max: aNumber
	" Return the maximum between the receiver and argument. "

	^{''js'Math.max(self,aNumber)'}""",nil)
smalltalk.bind(smalltalk.Number,"min:",0
,smalltalk.__f__("""(self,aNumber):
	#Number>>#min:
	return smalltalk.Number(min(smalltalk.handleOf(self),smalltalk.handleOf(aNumber))) 
""","Number_min_")
,"arithmetic","""min: aNumber
	" Return the minimum between the receiver and argument. "

	^{''js'Math.min(self,aNumber)'}""",nil)
smalltalk.bind(smalltalk.Number,"asNumber",0
,smalltalk.__f__("""(self):
	#Number>>#asNumber
	return self._plus(smalltalk.Number(0)) 
""","Number_asNumber")
,"converting","""asNumber
	" Return the receiver as a Number. "

	^self + 0""",nil)
smalltalk.bind(smalltalk.Number,"abs",0
,smalltalk.__f__("""(self):
	#Number>>#abs
	if smalltalk.b(self._lt(smalltalk.Number(0))):
		return self.negated() 
	 
	return self 
""","Number_abs")
,"converting","""abs
	" Return the absolute value of the receiver. "

	self < 0 ifTrue: [ ^self negated ].
	^self""",nil)
smalltalk.bind(smalltalk.Number,"rounded",0
,smalltalk.__f__("""(self):
	#Number>>#rounded
	return smalltalk.Number(round(smalltalk.handleOf(self))) 
""","Number_rounded")
,"converting","""rounded
	" Return the receiver rounded. "

	^{''js'Math.round(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"truncated",0
,smalltalk.__f__("""(self):
	#Number>>#truncated
	return smalltalk.Number(smalltalk.math.trunc(smalltalk.handleOf(self))) 
""","Number_truncated")
,"converting","""truncated
	" Return the receiver truncated. "

	^{''js'Math.floor(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"asCharacter",0
,smalltalk.__f__("""(self):
	#Number>>#asCharacter
	return smalltalk.String.fromCharCode_(self) 
""","Number_asCharacter")
,"converting","""asCharacter
	" Return the character with the receiver's code. "

	^String fromCharCode: self""",nil)
smalltalk.bind(smalltalk.Number,"to:by:value:",0
,smalltalk.__f__("""(self,aNumber,increment,aBlock):
	#Number>>#to:by:value:
	return smalltalk.Interval.from_to_by_value_(self,aNumber,increment,aBlock) 
""","Number_to_by_value_")
,"iterating","""to: aNumber by: increment value: aBlock
	" Private - Return an iterable to evaluate aBlock on each step of iteration. "

	^Interval from: self to: aNumber by: increment value: aBlock """,nil)
smalltalk.bind(smalltalk.Number,"to:by:",0
,smalltalk.__f__("""(self,end,increment):
	#Number>>#to:by:
	def __blk1__(index,block):
		return block.value_(index) 
	return self.to_by_value_(end,increment,smalltalk.blk(__blk1__,2)) 
""","Number_to_by_")
,"iterating","""to: end by: increment
	" Return an iterable from the receiver to end. "

	^self	to: end by: increment
		value: [:index :block| block value: index ]""",nil)
smalltalk.bind(smalltalk.Number,"to:",0
,smalltalk.__f__("""(self,end):
	#Number>>#to:
	return self.to_by_(end,smalltalk.Number(1)) 
""","Number_to_")
,"iterating","""to: end
	" Return an iterable from the receiver to end. "

	^self to: end by: 1 "to iterate like other smalltalks
		(self <= end ifTrue: [1] ifFalse: [-1])\"""",nil)
smalltalk.bind(smalltalk.Number,"timesRepeat:",0
,smalltalk.__f__("""(self,aBlock):
	#Number>>#timesRepeat:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for i in range(smalltalk.handleOf(self)): aBlock(smalltalk.Number(i+1)) 
	return self 
""","Number_timesRepeat_")
,"enumerating","""timesRepeat: aBlock
	" Evaluates aBlock a number of times given by the receiver.
	Return the receiver.
	"

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=1;i<=self;i++){fn(i);}'
s8'	(1 to: self) do: aBlock'}""",nil)
smalltalk.bind(smalltalk.Number,"to:do:",0
,smalltalk.__f__("""(self,aNumber,aBlock):
	#Number>>#to:do:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for i in range(smalltalk.handleOf(self),smalltalk.handleOf(aNumber)+1): aBlock(smalltalk.Number(i)) 
	return self 
""","Number_to_do_")
,"iterating","""to: aNumber do: aBlock
	" Evaluate aBlock from the receiver to aNumber.
	Return the receiver.
	"

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=self;i<=aNumber;i++){fn(i);}'
s8'	(self to: aNumber) do: aBlock'}""",nil)
smalltalk.bind(smalltalk.Number,"to:by:do:",0
,smalltalk.__f__("""(self,aNumber,increment,aBlock):
	#Number>>#to:by:do:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	incr = smalltalk.handleOf(increment)
	gap = 1 if incr>0 else -1
	for i in range(smalltalk.handleOf(self),smalltalk.handleOf(aNumber)+gap,incr): aBlock(smalltalk.Number(i)) 
	return self 
""","Number_to_by_do_")
,"iterating","""to: aNumber by: increment do: aBlock
	" Evaluate aBlock for the numbers between the receiver and aNumber where each number is the previous number plus increment.
	Return the receiver.
	"

	| fn | fn := self callableOf: aBlock.
	{''
js'	if (increment>0) { for(var i=self;i<=aNumber;i=i+increment){fn(i);} }
	else { for(var i=self;aNumber<=i;i=i+increment){fn(i);} }'
s8'	(self to: aNumber by: increment) consume: aBlock'}""",nil)
smalltalk.bind(smalltalk.Number,"asString",0
,smalltalk.__f__("""(self):
	#Number>>#asString
	return smalltalk.printString_(self) 
""","Number_asString")
,"converting","""asString
	" Return the receiver as a String. "

	^self printString""",nil)
smalltalk.bind(smalltalk.Number,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Number>>#asNative:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("("),smalltalk.printString_(self)),smalltalk.String(")")) 
""","Number_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	^'(', self printString, ')'""",nil)
smalltalk.bind(smalltalk.Number,"printString",0
,smalltalk.__f__("""(self):
	#Number>>#printString
	return smalltalk.String(str(smalltalk.handleOf(self))) 
""","Number_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	^{''js'String(self)'}""",nil)
smalltalk.bind(smalltalk.Number,"toString:",0
,smalltalk.__f__("""(self,radix):
	#Number>>#toString:
	return smalltalk.basen(self,radix) 
""","Number_toString_")
,"printing","""toString: radix
	" Return the ASCII representation of the receiver in base radix. "

	^{''js'self.toString(radix)'}""",nil)
smalltalk.bind(smalltalk.Number,"printPaddedWith:to:base:",0
,smalltalk.__f__("""(self,aCharacter,anInteger,aRadix):
	#Number>>#printPaddedWith:to:base:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result.size()._lt(anInteger) 
	__0__.result=nil
	__0__.result=self.toString_(aRadix) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__0__.result=smalltalk.object_comma_(aCharacter,__0__.result) 
	 
	return __0__.result 
""","Number_printPaddedWith_to_base_")
,"printing","""printPaddedWith: aCharacter to: anInteger base: aRadix
	" Return the ASCII representation of the receiver padded on the left with aCharacter to be at least anInteger characters. "

	| result |
	result := self toString: aRadix.
	[ result size < anInteger ] whileTrue: [
		result := aCharacter ,result
	].
	^result""",nil)
smalltalk.bind(smalltalk.Number,"isNumber",0
,smalltalk.__f__("""(self):
	#Number>>#isNumber
	if True:
		return smalltalk.b_(smalltalk.is_Number(smalltalk.handleOf(self)))
	 
	return self 
""","Number_isNumber")
,"testing","""isNumber
	" Return true if the receiver is a Number. "

	{''js'return isNaN(self).not()'}""",nil)
smalltalk.bind(smalltalk.Number,"atRandom",0
,smalltalk.__f__("""(self):
	#Number>>#atRandom
	return smalltalk.Random.new().next()._star(self).truncated()._plus(smalltalk.Number(1)) 
""","Number_atRandom")
,"converting","""atRandom
	" Return a random integer in the interval from 1 to the receiver. "

	^(Random new next * self) truncated + 1""",nil)
smalltalk.bind(smalltalk.Number,"@","_at"
,smalltalk.__f__("""(self,aNumber):
	#Number>>#@
	def __blk1__():
		return smalltalk.Number(0) 
	def __blk2__():
		return aNumber 
	return smalltalk.Point.x_y_(self,smalltalk.if_true_false_(smalltalk.isNil_(aNumber),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","Number__at")
,"converting","""@ aNumber
	" Return a Point with coordinates given by the receiver and aNumber. "

	^Point x: self y: (aNumber isNil ifTrue: [0] ifFalse: [aNumber])""",nil)
smalltalk.bind(smalltalk.Number,"asPoint",0
,smalltalk.__f__("""(self):
	#Number>>#asPoint
	return smalltalk.Point.x_y_(self,self) 
""","Number_asPoint")
,"converting","""asPoint
	" Return the receiver as a Point. "

	^Point x: self y: self""",nil)
smalltalk.bind(smalltalk.Number,"asJSONObject",0
,smalltalk.__f__("""(self):
	#Number>>#asJSONObject
	return self._plus(smalltalk.Number(0)) 
""","Number_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self + 0
"Note:	we need to normalize result to do not destroy typeof checkings
	Do NOT modify this method if you do not know what you are doing.
	If you remove the + 0 computation, the returned object will return 'object' and not 'number' as result of typeof operation.
\"""",nil)
smalltalk.bind(smalltalk.Number,"between:and:",0
,smalltalk.__f__("""(self,min,max):
	#Number>>#between:and:
	def __blk1__():
		return self._lt_eq(max) 
	return smalltalk.boolean_and_(min._lt_eq(self),smalltalk.blk(__blk1__,0)) 
""","Number_between_and_")
,"testing","""between: min and: max
	" Return true if the receiver is between arguments. "

	^min <= self and: [ self <= max ]""",nil)
smalltalk.bind(smalltalk.Number,"even",0
,smalltalk.__f__("""(self):
	#Number>>#even
	return smalltalk.isObject_equalTo_(self._bk_bk(smalltalk.Number(2)),smalltalk.Number(0)) 
""","Number_even")
,"testing","""even
	" Return true if the receiver is an even number. "

	^self \\\\ 2 = 0""",nil)
smalltalk.bind(smalltalk.Number,"odd",0
,smalltalk.__f__("""(self):
	#Number>>#odd
	return smalltalk.isObject_equalTo_(self._bk_bk(smalltalk.Number(2)),smalltalk.Number(1)) 
""","Number_odd")
,"testing","""odd
	" Return true if the receiver is an odd number. "

	^self \\\\ 2 = 1""",nil)
smalltalk.bind(smalltalk.Number,"clearInterval",0
,smalltalk.__f__("""(self):
	#Number>>#clearInterval
	self.notImplementedYet_(smalltalk.String("clearInterval")) 
	return self 
""","Number_clearInterval")
,"intervals","""clearInterval

	{''js'clearInterval(Number(self))'}""",nil)
smalltalk.bind(smalltalk.Number,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Number>>#shallowCopy
	return self 
""","Number_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Number,"deepCopy",0
,smalltalk.__f__("""(self):
	#Number>>#deepCopy
	return self 
""","Number_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Number,"asPython",0
,smalltalk.__f__("""(self):
	#Number>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.Number("),smalltalk.printString_(self)),smalltalk.String(")")) 
""","Number_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.Number(' ,self printString ,$) """,nil)
smalltalk.bind(smalltalk.Number,"asPythonContents",0
,smalltalk.__f__("""(self):
	#Number>>#asPythonContents
	return smalltalk.printString_(self) 
""","Number_asPythonContents")
,"Python-py","""asPythonContents
	" Return the native representation of the receiver in contents of aCollection. "

	^self printString """,nil)
smalltalk.bind(smalltalk.Number,"s8DoIt",0
,smalltalk.__f__("""(self):
	#Number>>#s8DoIt
	def __blk1__():
		__1__=smalltalk.newContext()
		def __blk2__(each):
			return each.removeFromSystem() 
		def __blk3__():
			return __1__.source.atEnd() 
		def __blk4__():
			def __blk5__():
				return self.print_(smalltalk.object_comma_(smalltalk.String("	"),__1__.source.upTo_(smalltalk.String('"')))) 
			__1__.source.upTo_(__1__.tag) 
			return smalltalk.if_true_false_(__1__.source.atEnd(),nil,smalltalk.blk(__blk5__,0)) 
		__1__.image=nil
		__1__.tag=nil
		__1__.source=nil
		self.note_(smalltalk.String("Exporting the system image")) 
		__1__.image=smalltalk.PythonEncoder.export_(smalltalk.String("all")) 
		smalltalk.String.doItSelector().implementors().do_(smalltalk.blk(__blk2__,1)) 
		__1__.image.outputToFile_(smalltalk.object_comma_(smalltalk.String("../s8.image."),targetLanguage)) 
		self.note_(smalltalk.String("Collecting methods with errors...")) 
		__1__.tag=smalltalk.object_comma_(smalltalk.String("NIY:"),smalltalk.String("#pyMethodBody: ")) 
		self.note_(smalltalk.object_comma_(smalltalk.String("ToDo list for "),__1__.tag)) 
		__1__.source=__1__.image.stream() 
		return smalltalk.whileNot_do_(smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
	return smalltalk.blk(__blk1__,0).value() 
""","Number_s8DoIt")
,"s8DoIt","""s8DoIt ^[| image tag source |
self note: 'Exporting the system image'.
image := PythonEncoder export: #all.
String doItSelector implementors do: [:each| each removeFromSystem ].
image outputToFile: '../s8.image.' ,#{targetLanguage}.

self note: 'Collecting methods with errors...'.
tag := 'NIY:' ,'#pyMethodBody: '.
self note: 'ToDo list for ',tag.
source := image stream.
[source atEnd] whileFalse: [
	source upTo: tag.
	source atEnd ifFalse: [
		self print: '	',(source upTo: $")
	].
].] value""",nil)
smalltalk.bind(smalltalk.BlockClosure.__class__,"hasDeferredSupport",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#BlockClosure class>>#hasDeferredSupport
		def __blk1__():
			return smalltalk.notNil_(setTimeout) 
		def __blk2__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.notNil_(setTimeout)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","BlockClosure_class_hasDeferredSupport")
,"deferredEvaluation","""hasDeferredSupport
	" Return true if the platform can defer instance evaluation. "

	[ #{setTimeout} notNil ] on: Exception do: [ ^false ].
	^#{setTimeout} notNil""",nil)
smalltalk.bind(smalltalk.BlockClosure,"compiledSourceAt:",0
,smalltalk.__f__("""(self,aCompiledMethod):
	#BlockClosure>>#compiledSourceAt:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			nil 
		return smalltalk.basic_at_ifAbsent_(aCompiledMethod,smalltalk.String("$nativeSource"),smalltalk.blk(__blk2__,0)) 
	def __blk3__():
		return self.compiledSource() 
	def __blk4__():
		return __0__.cached 
	__0__.cached=nil
	__0__.cached=smalltalk.if_true_false_(smalltalk.notNil_(aCompiledMethod),smalltalk.blk(__blk1__,0),nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(__0__.cached),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
""","BlockClosure_compiledSourceAt_")
,"accessing","""compiledSourceAt: aCompiledMethod
	" Return the native source code of the receiver. "

	| cached |
	cached := aCompiledMethod notNil ifTrue: [
		aCompiledMethod basicAt: '$nativeSource' ifAbsent: []
	].
	^cached isNil ifTrue: [ self compiledSource ] ifFalse: [ cached ]""",nil)
smalltalk.bind(smalltalk.BlockClosure,"compiledSource",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#compiledSource
	return smalltalk.to_String(self) 
""","BlockClosure_compiledSource")
,"accessing","""compiledSource
	" Return the native source code of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.BlockClosure,"whileTrue:",0
,smalltalk.__f__("""(self,aBlock):
	#BlockClosure>>#whileTrue:
	__0__=smalltalk.newContext()
	def __blk1__():
		aBlock.value() 
		return self.whileTrue_(aBlock) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	while smalltalk.handleOf(self)(): smalltalk.handleOf(aBlock)() 
	return self 
""","BlockClosure_whileTrue_")
,"iterating","""whileTrue: aBlock
	" Evaluate aBlock while the result of evaluating the receiver is true. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	while(self()) {fn()}'
s8'	self value == true ifTrue: [
		aBlock value.
		self whileTrue: aBlock
	]'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"whileFalse:",0
,smalltalk.__f__("""(self,aBlock):
	#BlockClosure>>#whileFalse:
	__0__=smalltalk.newContext()
	def __blk1__():
		aBlock.value() 
		return self.whileFalse_(aBlock) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	while not smalltalk.handleOf(self)(): smalltalk.handleOf(aBlock)() 
	return self 
""","BlockClosure_whileFalse_")
,"iterating","""whileFalse: aBlock
	" Evaluate aBlock while the result of evaluating the receiver is false. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	while(!self()) {fn()}'
s8'	self value == false ifTrue: [
		aBlock value.
		self whileFalse: aBlock
	]'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"whileTrue",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#whileTrue
	def __blk1__():
		nil 
	return self.whileTrue_(smalltalk.blk(__blk1__,0)) 
""","BlockClosure_whileTrue")
,"iterating","""whileTrue
	" Evaluate the receiver while the result is true. "

	^self whileTrue: []""",nil)
smalltalk.bind(smalltalk.BlockClosure,"whileFalse",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#whileFalse
	def __blk1__():
		nil 
	return self.whileFalse_(smalltalk.blk(__blk1__,0)) 
""","BlockClosure_whileFalse")
,"iterating","""whileFalse
	" Evaluate the receiver while the result is false. "

	^self whileFalse: []""",nil)
smalltalk.bind(smalltalk.BlockClosure,"value",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#value
	return self() 
""","BlockClosure_value")
,"evaluating","""value
	" Return the result of evaluating the receiver. "

	^# #self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"value:",0
,smalltalk.__f__("""(self,anObject):
	#BlockClosure>>#value:
	return self(anObject) 
""","BlockClosure_value_")
,"evaluating","""value: anObject
	" Return the result of evaluating the receiver with anObject. "

	^# #self: anObject""",nil)
smalltalk.bind(smalltalk.BlockClosure,"value:value:",0
,smalltalk.__f__("""(self,firstArgument,secondArgument):
	#BlockClosure>>#value:value:
	return self(firstArgument,secondArgument) 
""","BlockClosure_value_value_")
,"evaluating","""value: firstArgument value: secondArgument
	" Return the result of evaluating the receiver with arguments. "

	^# #self: firstArgument value: secondArgument""",nil)
smalltalk.bind(smalltalk.BlockClosure,"value:value:value:",0
,smalltalk.__f__("""(self,firstArgument,secondArgument,thirdArgument):
	#BlockClosure>>#value:value:value:
	return self(firstArgument,secondArgument,thirdArgument) 
""","BlockClosure_value_value_value_")
,"evaluating","""value: firstArgument value: secondArgument value: thirdArgument
	" Return the result of evaluating the receiver with arguments. "

	^# #self: firstArgument value: secondArgument value: thirdArgument""",nil)
smalltalk.bind(smalltalk.BlockClosure,"value:value:value:value:",0
,smalltalk.__f__("""(self,firstArgument,secondArgument,thirdArgument,fourthArgument):
	#BlockClosure>>#value:value:value:value:
	return self(firstArgument,secondArgument,thirdArgument,fourthArgument) 
""","BlockClosure_value_value_value_value_")
,"evaluating","""value: firstArgument value: secondArgument value: thirdArgument value: fourthArgument
	" Return the result of evaluating the receiver with arguments. "

	^# #self: firstArgument value: secondArgument value: thirdArgument value: fourthArgument""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueWithPossibleArguments:",0
,smalltalk.__f__("""(self,array):
	#BlockClosure>>#valueWithPossibleArguments:
	if not smalltalk.b(array.isArray()):
		self.error_(smalltalk.object_comma_(smalltalk.String("Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver="),smalltalk.to_String(self))) 
	 
	return self(*smalltalk.arrayContents(array)) 
""","BlockClosure_valueWithPossibleArguments_")
,"evaluating","""valueWithPossibleArguments: array
	" Return the result of evaluating the receiver with potential arguments. "

	array isArray ifFalse: [
		self error: 'Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver=' ,self toString
	].
	^{''js'self.apply(null,array)'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"exception:matches:",0
,smalltalk.__f__("""(self,anException,type):
	_s8Ret_=smalltalk.newContext()
	try:
		#BlockClosure>>#exception:matches:
		if smalltalk.b(smalltalk.isNil_(type)):
			return smalltalk.true 
		 
		if not smalltalk.b(self.isObject_(type)):
			return smalltalk.isObject_equalTo_(type,anException) 
		 
		if smalltalk.b(type.isClass()):
			return smalltalk.is_kindOf_(anException,(type)) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(type,smalltalk.String("all"))):
			return smalltalk.true 
		 
		if smalltalk.b(type.isArray()):
			def __blk1__(one):
				return self.exception_matches_(anException,one) 
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			type.detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
			smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		 
		if smalltalk.b(type.isString()):
			__1__=smalltalk.newContext()
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			__1__.cls=nil
			__1__.cls=self.smalltalk().at_ifAbsent_(__1__.cls,smalltalk.blk(__blk3__,0)) 
			smalltalk.raise_result_(_s8Ret_,self.exception_matches_(anException,__1__.cls)) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.b_(type.evaluateWith_(anException) is smalltalk.true)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","BlockClosure_exception_matches_")
,"private","""exception: anException matches: type
	" Private - Return true if anException is of specified type. "

	type isNil ifTrue: [ ^true ].
	(self isObject: type) ifFalse: [ ^type = anException ].
	type isClass ifTrue: [ ^anException isKindOf: type ].
	type = #all ifTrue: [ ^true ].
	type isArray ifTrue: [
		type
			detect: [:one| self exception: anException matches: one ]
			ifNone: [ ^false ].
		^true
	].
	type isString ifTrue: [ | cls |
		cls := self smalltalk at: cls ifAbsent: [ ^false ].
		^self exception: anException matches: cls
	].
	^(type evaluateWith: anException) == true """,nil)
smalltalk.bind(smalltalk.BlockClosure,"on:do:",0
,smalltalk.__f__("""(self,type,aBlock):
	#BlockClosure>>#on:do:
	def __blk1__(anException):
		def __blk2__():
			return aBlock.value_(anException) 
		def __blk3__():
			return anException.signal() 
		return smalltalk.if_true_false_(self.exception_matches_(anException,type),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.try_catch_(self,smalltalk.blk(__blk1__,1)) 
""","BlockClosure_on_do_")
,"evaluating","""on: type do: aBlock
	" Return the result of evaluating the receiver catching exceptions of specified type. "

	^self try: self catch: [:anException |
		(self exception: anException matches: type)
		ifTrue: [ aBlock value: anException ]
		ifFalse: [ anException signal ]
	]""",nil)
smalltalk.bind(smalltalk.BlockClosure,"try:catch:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#BlockClosure>>#try:catch:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.ab=nil
	__0__.fn=self.callableOf_(aBlock) 
	__0__.ab=self.callableOf_(anotherBlock) 
	try:
		return aBlock()
	except Exception as e:
		stEx = smalltalk.Exception(e)
		stEx.nativeException_(e)
		stEx.messageText_(str(e))
		return anotherBlock(self.smalltalkErrorOf_(stEx))
	 
	return self 
""","BlockClosure_try_catch_")
,"private","""try: aBlock catch: anotherBlock
	" Private - Try to evaluate aBlock catching exceptions with catchBlock. "

	| fn ab |
	fn := self callableOf: aBlock.
	ab := self callableOf: anotherBlock.
	{''js'
	var result;
	try{ result = fn() } catch(e) {
		result = ab( self.smalltalkErrorOf_(e) )
	};
	return result'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueDeferred:",0
,smalltalk.__f__("""(self,milliseconds):
	#BlockClosure>>#valueDeferred:
	self.valueWithTimeout_(milliseconds) 
	return self 
""","BlockClosure_valueDeferred_")
,"evaluating","""valueDeferred: milliseconds
	" Evaluate the receiver deferred in time.
	Return the receiver.
	"

	self valueWithTimeout: milliseconds""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueDeferred",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#valueDeferred
	self.valueDeferred_(smalltalk.Number(0)) 
	return self 
""","BlockClosure_valueDeferred")
,"evaluating","""valueDeferred
	" Evaluate the receiver deferred in time.
	Return the receiver.
	"

	self valueDeferred: 0""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueWithTimeout:",0
,smalltalk.__f__("""(self,aNumber):
	#BlockClosure>>#valueWithTimeout:
	return smalltalk.value_withTimeout_(self,aNumber) 
""","BlockClosure_valueWithTimeout_")
,"timeout","""valueWithTimeout: aNumber
	" Evaluate the receiver with time out. "

	^{''js'setTimeout(self,aNumber)'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueWithInterval:",0
,smalltalk.__f__("""(self,aNumber):
	#BlockClosure>>#valueWithInterval:
	return smalltalk.value_withInterval_(self,aNumber) 
""","BlockClosure_valueWithInterval_")
,"timeout","""valueWithInterval: aNumber
	" Evaluate the receiver with interval. "

	^{''js'setInterval(self,aNumber)'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"ensure:",0
,smalltalk.__f__("""(self,aBlock):
	#BlockClosure>>#ensure:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	try:
		return self()
	finally:
		aBlock()
	 
	return self 
""","BlockClosure_ensure_")
,"evaluating","""ensure: aBlock
	" Return the result of evaluating the receiver.
	Execute aBlock after the receiver is executed.
	"

	| fn | fn := self callableOf: aBlock.
	{''js'try{return self();} finally {fn();}'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"ifCurtailed:",0
,smalltalk.__f__("""(self,exceptionBlock):
	#BlockClosure>>#ifCurtailed:
	__0__=smalltalk.newContext()
	__0__.curtailed=nil
	__0__.result=nil
	__0__.curtailed=smalltalk.true 
	try:
		result = self()
		curtailed = smalltalk.false
	finally:
		if smalltalk.b(curtailed):
			smalltalk.handleOf(exceptionBlock)()
		
	return result 
	return self 
""","BlockClosure_ifCurtailed_")
,"evaluating","""ifCurtailed: exceptionBlock
	" Return the result of evaluating the receiver.
	If evaluation is limited by exiting before completion, the exception block is evaluated.
	"

	| curtailed result |
	curtailed := true.
	{''js'
	try{	result = self.value();
		curtailed = false;
	} finally {
		if (curtailed) exceptionBlock.value();
	};
	return result'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"argumentCount",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#argumentCount
	return smalltalk.argumentCount_(self) 
""","BlockClosure_argumentCount")
,"evaluating","""argumentCount
	" Return the number of arguments of the receiver. "

	^{''js'self.length'}""",nil)
smalltalk.bind(smalltalk.BlockClosure,"installAs:",0
,smalltalk.__f__("""(self,functionName):
	#BlockClosure>>#installAs:
	return smalltalk.Smalltalk.install_as_(self,functionName) 
""","BlockClosure_installAs_")
,"installing","""installAs: functionName
	" Install the receiver as a function in global scope. "

	^Smalltalk install: self as: functionName""",nil)
smalltalk.bind(smalltalk.BlockClosure,"asJSONObject",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#asJSONObject
	return self 
""","BlockClosure_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"shallowCopy",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#shallowCopy
	return self 
""","BlockClosure_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"deepCopy",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#deepCopy
	return self 
""","BlockClosure_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"isValuable",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#isValuable
	return smalltalk.true 
""","BlockClosure_isValuable")
,"testing","""isValuable
	" Return true if the receiver can be evaluated. "

	^true""",nil)
smalltalk.bind(smalltalk.BlockClosure,"ms",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#ms
	return smalltalk.DateTime.millisecondsToRun_(self) 
""","BlockClosure_ms")
,"accessing","""ms
	" Return the milliseconds taken to evaluate the receiver. "

	^DateTime millisecondsToRun: self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"evaluateFor:",0
,smalltalk.__f__("""(self,anObject):
	#BlockClosure>>#evaluateFor:
	return self(anObject) 
""","BlockClosure_evaluateFor_")
,"evaluating","""evaluateFor: anObject
	" Return the result of evaluating the receiver with anObject. "

	^# #self: anObject""",nil)
smalltalk.bind(smalltalk.BlockClosure,"evaluate",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#evaluate
	return self() 
""","BlockClosure_evaluate")
,"evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	^# #self""",nil)
smalltalk.bind(smalltalk.BlockClosure,"evaluateWithArguments:",0
,smalltalk.__f__("""(self,anArray):
	#BlockClosure>>#evaluateWithArguments:
	return self.valueWithPossibleArguments_(anArray) 
""","BlockClosure_evaluateWithArguments_")
,"evaluating","""evaluateWithArguments: anArray
	" Return the result of evaluating the receiver. "

	^self valueWithPossibleArguments: anArray""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueWithArguments:",0
,smalltalk.__f__("""(self,anArray):
	#BlockClosure>>#valueWithArguments:
	return self.valueWithPossibleArguments_(anArray) 
""","BlockClosure_valueWithArguments_")
,"evaluating","""valueWithArguments: anArray
	" Return the result of evaluating the receiver with arguments. "

	^self valueWithPossibleArguments: anArray""",nil)
smalltalk.bind(smalltalk.BlockClosure,"valueWithDNU",0
,smalltalk.__f__("""(self):
	#BlockClosure>>#valueWithDNU
	return smalltalk.Object.hackDNUWhile_(self) 
""","BlockClosure_valueWithDNU")
,"Tools-hacking","""valueWithDNU
	" Catch DNU hacking while evaluating the receiver. "

	^Object hackDNUWhile: self""",nil)
smalltalk.bind(smalltalk.Boolean.__class__,"@","_at"
,smalltalk.__f__("""(self,aBOOL):
	#Boolean class>>#@
	h=smalltalk.handleOf(aBOOL)
	if h==1 or h==True:
		return smalltalk.true
	 
	return smalltalk.false 
""","Boolean_class__at")
,"Natives-converting","""@ aBOOL
	" Return aBOOL as a Boolean instance. "

	{''js'
	if (aBOOL === true) return true;
	if (aBOOL === 1) return true;
	if ((1 & aBOOL) + 0 == 1) return true'}.
	^false""",nil)
smalltalk.bind(smalltalk.Boolean,"mustBeBoolean",0
,smalltalk.__f__("""(self):
	#Boolean>>#mustBeBoolean
	return self 
""","Boolean_mustBeBoolean")
,"testing","""mustBeBoolean
	" Signal an error if the receiver is not a Boolean. "

	^self""",nil)
smalltalk.bind(smalltalk.Boolean,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#Boolean>>#=
	if smalltalk.b(smalltalk.is_kindOf_(anObject, smalltalk.Boolean)):
		return smalltalk.b_(smalltalk.handleOf(self) == smalltalk.handleOf(anObject))
	if True:
		return smalltalk.b_(smalltalk.handleOf(self) == anObject)
	 
	return self 
""","Boolean__eq")
,"comparing","""= anObject
    " Return true if the receiver is equal to argument. "

	{''js'
	if (nil.isNil_(anObject)) return false;
	if (!(self.$klass === anObject.$klass)) return false;
	return (self.valueOf() == anObject.valueOf())'}""",nil)
smalltalk.bind(smalltalk.Boolean,"ifTrue:ifFalse:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Boolean>>#ifTrue:ifFalse:
	if smalltalk.b(self):
		return smalltalk.handleOf(aBlock)()
	return smalltalk.handleOf(anotherBlock)() 
	return self 
""","Boolean_ifTrue_ifFalse_")
,"control","""ifTrue: aBlock ifFalse: anotherBlock
	" Return the result of evaluating aBlock if the receiver is true, else the result of evaluating anotherBlock. "

	{''js'if(self == true) { return aBlock.value(); } else { return anotherBlock.value(); }'}""",nil)
smalltalk.bind(smalltalk.Boolean,"ifTrue:",0
,smalltalk.__f__("""(self,aBlock):
	#Boolean>>#ifTrue:
	def __blk1__():
		return aBlock.value() 
	def __blk2__():
		nil 
	return smalltalk.if_true_false_(self,smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Boolean_ifTrue_")
,"control","""ifTrue: aBlock
	" Return the result of evaluating aBlock if the receiver is true, else return nil. "

	^self ifTrue: [ aBlock value ] ifFalse: []""",nil)
smalltalk.bind(smalltalk.Boolean,"ifFalse:",0
,smalltalk.__f__("""(self,aBlock):
	#Boolean>>#ifFalse:
	def __blk1__():
		nil 
	def __blk2__():
		return aBlock.value() 
	return smalltalk.if_true_false_(self,smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Boolean_ifFalse_")
,"control","""ifFalse: aBlock
	" Return the result of evaluating aBlock if the receiver is false, else return nil. "

	^self ifTrue: [] ifFalse: [ aBlock value ]""",nil)
smalltalk.bind(smalltalk.Boolean,"ifFalse:ifTrue:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Boolean>>#ifFalse:ifTrue:
	def __blk1__():
		return aBlock.value() 
	return self.ifTrue_ifFalse_(anotherBlock,smalltalk.blk(__blk1__,0)) 
""","Boolean_ifFalse_ifTrue_")
,"control","""ifFalse: aBlock ifTrue: anotherBlock
	" Return the result of evaluating aBlock if the receiver is false, else the result of evaluating anotherBlock. "

	^self ifTrue: anotherBlock ifFalse: [ aBlock value ]""",nil)
smalltalk.bind(smalltalk.Boolean,"and:",0
,smalltalk.__f__("""(self,aBlock):
	#Boolean>>#and:
	def __blk1__():
		return aBlock.value() 
	def __blk2__():
		return smalltalk.false 
	return smalltalk.if_true_false_(self,smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Boolean_and_")
,"control","""and: aBlock
	" Return true if the receiver is true and the result of evaluating aBlock is also true. "

	^self ifTrue: [ aBlock value ] ifFalse: [false]""",nil)
smalltalk.bind(smalltalk.Boolean,"or:",0
,smalltalk.__f__("""(self,aBlock):
	#Boolean>>#or:
	def __blk1__():
		return smalltalk.true 
	def __blk2__():
		return aBlock.value() 
	return smalltalk.if_true_false_(self,smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Boolean_or_")
,"control","""or: aBlock
	" Return true if the receiver is true or the result of evaluating aBlock is true. "

	^self ifTrue: [true] ifFalse: [ aBlock value ]""",nil)
smalltalk.bind(smalltalk.Boolean,"not","_8not"
,smalltalk.__f__("""(self):
	#Boolean>>#not
	return smalltalk.false if smalltalk.handleOf(self) else smalltalk.true 
""","Boolean__8not")
,"control","""not
	" Return true if the receiver is false. "

	^{''js'self == false '}""",nil)
smalltalk.bind(smalltalk.Boolean,"printString",0
,smalltalk.__f__("""(self):
	#Boolean>>#printString
	def __blk1__():
		return smalltalk.String("true") 
	def __blk2__():
		return smalltalk.String("false") 
	return smalltalk.if_true_false_(self,smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Boolean_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^self ifTrue: [ #true ] ifFalse: [ #false ]""",nil)
smalltalk.bind(smalltalk.Boolean,"asJSONObject",0
,smalltalk.__f__("""(self):
	#Boolean>>#asJSONObject
	def __blk1__():
		return smalltalk.true 
	return smalltalk.boolean_and_(self,smalltalk.blk(__blk1__,0)) 
""","Boolean_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self and: [ true ]""",nil)
smalltalk.bind(smalltalk.Boolean,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Boolean>>#shallowCopy
	return self 
""","Boolean_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Boolean,"deepCopy",0
,smalltalk.__f__("""(self):
	#Boolean>>#deepCopy
	return self 
""","Boolean_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Boolean,"isBoolean",0
,smalltalk.__f__("""(self):
	#Boolean>>#isBoolean
	return smalltalk.true 
""","Boolean_isBoolean")
,"testing","""isBoolean
	" Return true if the receiver is a boolean. "

	^true""",nil)
smalltalk.bind(smalltalk.Boolean,"asPython",0
,smalltalk.__f__("""(self):
	#Boolean>>#asPython
	def __blk1__():
		return smalltalk.String("true") 
	def __blk2__():
		return smalltalk.String("false") 
	return smalltalk.object_comma_(smalltalk.String("smalltalk."),smalltalk.if_true_false_(smalltalk.b_(self is smalltalk.true),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","Boolean_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.' ,(self == true
		ifTrue: [#true]
		ifFalse: [#false]) """,nil)
smalltalk.bind(smalltalk.Boolean,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Boolean>>#asNative:
	if smalltalk.b(smalltalk.isObject_equalTo_(lang,smalltalk.String("py"))):
		return self.asPython() 
	 
	return smalltalk.superReceiver(smalltalk.Boolean,self).asNative_(lang) 
""","Boolean_asNative_")
,"Python-py","""asNative: lang
	" Return the native representation of the receiver. "

	lang = #py ifTrue: [ ^self asPython ].
	^super asNative: lang """,nil)
smalltalk.bind(smalltalk.Boolean,"test_ComplexBlock",0
,smalltalk.__f__("""(self):
	#Boolean>>#test_ComplexBlock
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			def __blk3__():
				def __blk4__():
					def __blk5__():
						def __blk6__():
							def __blk7__():
								def __blk8__():
									def __blk9__():
										def __blk10__():
											def __blk11__():
												def __blk12__():
													def __blk13__():
														def __blk14__():
															def __blk15__():
																self.print_(smalltalk.Number(15)) 
																self.print_(smalltalk.String("---------")) 
																return self.print_(smalltalk.Number(-15)) 
															self.print_(smalltalk.Number(14)) 
															smalltalk.blk(__blk15__,0).value() 
															return self.print_(smalltalk.Number(-14)) 
														self.print_(smalltalk.Number(13)) 
														smalltalk.blk(__blk14__,0).value() 
														return self.print_(smalltalk.Number(-13)) 
													self.print_(smalltalk.Number(12)) 
													smalltalk.blk(__blk13__,0).value() 
													return self.print_(smalltalk.Number(-12)) 
												self.print_(smalltalk.Number(11)) 
												smalltalk.blk(__blk12__,0).value() 
												return self.print_(smalltalk.Number(-11)) 
											self.print_(smalltalk.Number(10)) 
											smalltalk.blk(__blk11__,0).value() 
											return self.print_(smalltalk.Number(-10)) 
										self.print_(smalltalk.Number(9)) 
										smalltalk.blk(__blk10__,0).value() 
										return self.print_(smalltalk.Number(-9)) 
									self.print_(smalltalk.Number(8)) 
									smalltalk.blk(__blk9__,0).value() 
									return self.print_(smalltalk.Number(-8)) 
								self.print_(smalltalk.Number(7)) 
								smalltalk.blk(__blk8__,0).value() 
								return self.print_(smalltalk.Number(-7)) 
							self.print_(smalltalk.Number(6)) 
							smalltalk.blk(__blk7__,0).value() 
							return self.print_(smalltalk.Number(-6)) 
						self.print_(smalltalk.Number(5)) 
						smalltalk.blk(__blk6__,0).value() 
						return self.print_(smalltalk.Number(-5)) 
					self.print_(smalltalk.Number(4)) 
					smalltalk.blk(__blk5__,0).value() 
					return self.print_(smalltalk.Number(-4)) 
				self.print_(smalltalk.Number(3)) 
				smalltalk.blk(__blk4__,0).value() 
				return self.print_(smalltalk.Number(-3)) 
			self.print_(smalltalk.Number(2)) 
			smalltalk.blk(__blk3__,0).value() 
			return self.print_(smalltalk.Number(-2)) 
		self.print_(smalltalk.Number(1)) 
		smalltalk.blk(__blk2__,0).value() 
		return self.print_(smalltalk.Number(-1)) 
	__0__.aBlock=nil
	__0__.aBlock=smalltalk.blk(__blk1__,0) 
	return smalltalk.true 
""","Boolean_test_ComplexBlock")
,"_tests_","""test_ComplexBlock
| aBlock |
aBlock := 
[self print: 1.
 [self print: 2.
   [self print: 3.
    [self print: 4.
     [self print: 5.
     [self print: 6.
     [self print: 7.
     [self print: 8.
     [self print: 9.
     [self print: 10.
     [self print: 11.
     [self print: 12.
     [self print: 13.
     [self print: 14.
     [self print: 15.
self print: '---------'.
     self print: -15 ] value.
     self print: -14 ] value.
     self print: -13 ] value.
     self print: -12 ] value.
     self print: -11 ] value.
     self print: -10 ] value.
     self print: -9 ] value.
     self print: -8 ] value.
     self print: -7 ] value.
     self print: -6 ] value.
     self print: -5 ] value.
    self print: -4 ] value.
   self print: -3 ] value.
  self print: -2 ] value.
 self print: -1 ].

	^true""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"new:",0
,smalltalk.__f__("""(self,anObject):
	#DateTime class>>#new:
	iso = smalltalk.handleOf(anObject).replace("/","-")
	if True:
		import datetime
		return self(datetime.fromisoformat(iso))
	 
	return self 
""","DateTime_class_new_")
,"instantiation","""new: anObject
	" Return an instance of the receiver. "

	{''js'return new Date(anObject)'}""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"fromString:",0
,smalltalk.__f__("""(self,aString):
	#DateTime class>>#fromString:
	return self.new_(aString) 
""","DateTime_class_fromString_")
,"instantiation","""fromString: aString
	" Return an instance of the receiver.
	DateTime fromString: '1962/12/15 01:40:00'
	"

	^self new: aString""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"fromSeconds:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime class>>#fromSeconds:
	return self.fromMilliseconds_(aNumber._star(smalltalk.Number(1000))) 
""","DateTime_class_fromSeconds_")
,"instantiation","""fromSeconds: aNumber
	" Return an instance of the receiver. "

	^self fromMilliseconds: aNumber * 1000""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"fromMilliseconds:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime class>>#fromMilliseconds:
	return self.new_(aNumber) 
""","DateTime_class_fromMilliseconds_")
,"instantiation","""fromMilliseconds: aNumber
	" Return an instance of the receiver. "

	^self new: aNumber""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"today",0
,smalltalk.__f__("""(self):
	#DateTime class>>#today
	if True:
		from datetime import date
		return self(date.today())
	 
	return self.new() 
""","DateTime_class_today")
,"instantiation","""today
	" Return an instance of the receiver. "

	{''js'self'}."macro hook"
	^self new""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"now",0
,smalltalk.__f__("""(self):
	#DateTime class>>#now
	if True:
		from datetime import datetime
		return self(datetime.now())
	 
	return self.today() 
""","DateTime_class_now")
,"instantiation","""now
	" Return an instance of the receiver. "

	{''js'self'}."macro hook"
	^self today""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"msNow",0
,smalltalk.__f__("""(self):
	#DateTime class>>#msNow
	if True:
		import time
		return smalltalk.Number(int(time.time_ns() / 1000000))
	 
	return self.new() 
""","DateTime_class_msNow")
,"instantiation","""msNow
	" Private - Return a magnitude to measure milliseconds. "

	{''js'self'}."macro hook"
	^self new""",nil)
smalltalk.bind(smalltalk.DateTime.__class__,"millisecondsToRun:",0
,smalltalk.__f__("""(self,aBlock):
	#DateTime class>>#millisecondsToRun:
	__0__=smalltalk.newContext()
	__0__.start=nil
	__0__.start=self.msNow() 
	aBlock.value() 
	return self.msNow()._minus(__0__.start) 
""","DateTime_class_millisecondsToRun_")
,"instantiation","""millisecondsToRun: aBlock
	" Return the time elapsed during evaluation of aBlock. "

	| start |
	start := self msNow.
	aBlock value.
	^self msNow - start""",nil)
smalltalk.bind(smalltalk.DateTime,"year",0
,smalltalk.__f__("""(self):
	#DateTime>>#year
	return smalltalk.handleOf(self).year 
""","DateTime_year")
,"accessing","""year
	" Return the year of the receiver. "

	^{''js'self.getFullYear()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"month",0
,smalltalk.__f__("""(self):
	#DateTime>>#month
	return smalltalk.handleOf(self).month 
""","DateTime_month")
,"accessing","""month
	" Return the month of the receiver. "

	^{''js'self.getMonth() + 1'}""",nil)
smalltalk.bind(smalltalk.DateTime,"month:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#month:
	self.invalidMessage_(smalltalk.String("month:")) 
	return self 
""","DateTime_month_")
,"accessing","""month: aNumber
	" Set the month of the receiver. "

	{''js'self.setMonth(aNumber - 1)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"day",0
,smalltalk.__f__("""(self):
	#DateTime>>#day
	return smalltalk.handleOf(self).day 
""","DateTime_day")
,"accessing","""day
	" Return the day of the receiver. "

	^{''js'self.getDay() + 1'}""",nil)
smalltalk.bind(smalltalk.DateTime,"dayOfWeek",0
,smalltalk.__f__("""(self):
	#DateTime>>#dayOfWeek
	self.invalidMessage_(smalltalk.String("dayOfWeek")) 
	return self 
""","DateTime_dayOfWeek")
,"accessing","""dayOfWeek
	" Return the day of week of the receiver. "

	self invalidMessage: #dayOfWeek.
"	^{''js'self.getDay() + 1'}\"""",nil)
smalltalk.bind(smalltalk.DateTime,"dayOfWeek:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#dayOfWeek:
	self.invalidMessage_(smalltalk.String("dayOfWeek:")) 
	return self 
""","DateTime_dayOfWeek_")
,"accessing","""dayOfWeek: aNumber
	" Set the day of week of the receiver. "

	self invalidMessage: #dayOfWeek:.
"	{''js'self.setDay(aNumber - 1)'}\"""",nil)
smalltalk.bind(smalltalk.DateTime,"day:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#day:
	self.day = aNumber 
	return self 
""","DateTime_day_")
,"accessing","""day: aNumber
	" Set the day of the receiver. "

	{''js'self.setDay(aNumber - 1)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"year:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#year:
	smalltalk.handleOf(self).year = aNumber 
	return self 
""","DateTime_year_")
,"accessing","""year: aNumber
	" Set the year of the receiver. "

	{''js'self.setFullYear(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"dayOfMonth",0
,smalltalk.__f__("""(self):
	#DateTime>>#dayOfMonth
	return smalltalk.handleOf(self).day 
""","DateTime_dayOfMonth")
,"accessing","""dayOfMonth
	" Return the day of month of the receiver. "

	^{''js'self.getDate()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"dayOfMonth:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#dayOfMonth:
	smalltalk.handleOf(self).day = aNumber 
	return self 
""","DateTime_dayOfMonth_")
,"accessing","""dayOfMonth: aNumber
	" Set the day of month of the receiver. "

	{''js'self.setDate(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asString",0
,smalltalk.__f__("""(self):
	#DateTime>>#asString
	return smalltalk.to_String(self) 
""","DateTime_asString")
,"converting","""asString
	" Return the text representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.DateTime,"printString",0
,smalltalk.__f__("""(self):
	#DateTime>>#printString
	return smalltalk.asString_(self) 
""","DateTime_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	^self asString""",nil)
smalltalk.bind(smalltalk.DateTime,"asMilliseconds",0
,smalltalk.__f__("""(self):
	#DateTime>>#asMilliseconds
	return self.time() 
""","DateTime_asMilliseconds")
,"converting","""asMilliseconds
	" Return the receiver as milliseconds. "

	^self time""",nil)
smalltalk.bind(smalltalk.DateTime,"time",0
,smalltalk.__f__("""(self):
	#DateTime>>#time
	return self.invalidMessage(smalltalk.String("time")) 
""","DateTime_time")
,"accessing","""time
	" Return the time of the receiver. "

	^{''js'self.getTime()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"time:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#time:
	self.invalidMessage(smalltalk.String("time:")) 
	return self 
""","DateTime_time_")
,"accessing","""time: aNumber
	" Set the time of the receiver. "

	{''js'self.setTime(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asDateString",0
,smalltalk.__f__("""(self):
	#DateTime>>#asDateString
	return self.notImplementedYet_(smalltalk.String("asDateString")) 
""","DateTime_asDateString")
,"converting","""asDateString
	" Return the date string of the receiver. "

	^{''js'self.toDateString()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asTimeString",0
,smalltalk.__f__("""(self):
	#DateTime>>#asTimeString
	return self.notImplementedYet_(smalltalk.String("asTimeString")) 
""","DateTime_asTimeString")
,"converting","""asTimeString
	" Return the time string of the receiver. "

	^{''js'self.toTimeString()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asLocaleString",0
,smalltalk.__f__("""(self):
	#DateTime>>#asLocaleString
	return self.notImplementedYet_(smalltalk.String("asLocaleString")) 
""","DateTime_asLocaleString")
,"converting","""asLocaleString
	" Return the locale string of the receiver. "

	^{''js'self.toLocaleString()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asNumber",0
,smalltalk.__f__("""(self):
	#DateTime>>#asNumber
	return self.asMilliseconds() 
""","DateTime_asNumber")
,"converting","""asNumber
	" Return the receiver as a Number. "

	^self asMilliseconds""",nil)
smalltalk.bind(smalltalk.DateTime,"hours:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#hours:
	self.invalidMessage(smalltalk.String("hours:")) 
	return self 
""","DateTime_hours_")
,"accessing","""hours: aNumber
	" Set the hours of the receiver. "

	{''js'self.setHours(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"minutes:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#minutes:
	self.invalidMessage(smalltalk.String("minutes:")) 
	return self 
""","DateTime_minutes_")
,"accessing","""minutes: aNumber
	" Set the minutes of the receiver. "

	{''js'self.setMinutes(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"seconds:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#seconds:
	self.invalidMessage(smalltalk.String("seconds:")) 
	return self 
""","DateTime_seconds_")
,"accessing","""seconds: aNumber
	" Set the seconds of the receiver. "

	{''js'self.setSeconds(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"milliseconds:",0
,smalltalk.__f__("""(self,aNumber):
	#DateTime>>#milliseconds:
	self.invalidMessage(smalltalk.String("milliseconds:")) 
	return self 
""","DateTime_milliseconds_")
,"accessing","""milliseconds: aNumber
	" Set the milliseconds of the receiver. "

	{''js'self.setMilliseconds(aNumber)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"hours",0
,smalltalk.__f__("""(self):
	#DateTime>>#hours
	return self.notImplementedYet_(smalltalk.String("hours")) 
""","DateTime_hours")
,"accessing","""hours
	" Return the hours of the receiver. "

	^{''js'self.getHours()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"minutes",0
,smalltalk.__f__("""(self):
	#DateTime>>#minutes
	return self.notImplementedYet_(smalltalk.String("minutes")) 
""","DateTime_minutes")
,"accessing","""minutes
	" Return the minutes of the receiver. "

	^{''js'self.getMinutes()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"seconds",0
,smalltalk.__f__("""(self):
	#DateTime>>#seconds
	return self.notImplementedYet_(smalltalk.String("seconds")) 
""","DateTime_seconds")
,"accessing","""seconds
	" Return the seconds of the receiver. "

	^{''js'self.getSeconds()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"milliseconds",0
,smalltalk.__f__("""(self):
	#DateTime>>#milliseconds
	return self.notImplementedYet_(smalltalk.String("milliseconds")) 
""","DateTime_milliseconds")
,"accessing","""milliseconds
	" Return the milliseconds of the receiver. "

	^{''js'self.getMilliseconds()'}""",nil)
smalltalk.bind(smalltalk.DateTime,"<","_lt"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#<
	return smalltalk.b_(smalltalk.handleOf(self) < smalltalk.handleOf(aDateTime)) 
""","DateTime__lt")
,"comparing","""< aDateTime
	" Return true if the receiver is smaller than argument. "

	^{''js'self < aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,">","_gt"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#>
	return smalltalk.b_(smalltalk.handleOf(self) > smalltalk.handleOf(aDateTime)) 
""","DateTime__gt")
,"comparing","""> aDateTime
	" Return true if the receiver is greater than argument. "

	^{''js'self > aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,"<=","_lt_eq"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#<=
	return smalltalk.b_(smalltalk.handleOf(self) <= smalltalk.handleOf(aDateTime)) 
""","DateTime__lt_eq")
,"comparing","""<= aDateTime
	" Return true if the receiver is smaller or equal to argument. "

	^{''js'self <= aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,">=","_gt_eq"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#>=
	return smalltalk.b_(smalltalk.handleOf(self) >= smalltalk.handleOf(aDateTime)) 
""","DateTime__gt_eq")
,"comparing",""">= aDateTime
	" Return true if the receiver is greater or equal to argument. "

	^{''js'self >= aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,"-","_minus"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#-
	return self.__class__(smalltalk.handleOf(self) - smalltalk.handleOf(aDateTime)) 
""","DateTime__minus")
,"arithmetic","""- aDateTime
	" Return the result of operation. "

	^{''js'self - aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,"+","_plus"
,smalltalk.__f__("""(self,aDateTime):
	#DateTime>>#+
	return self.__class__(smalltalk.handleOf(self) + smalltalk.handleOf(aDateTime)) 
""","DateTime__plus")
,"arithmetic","""+ aDateTime
	" Return the result of operation. "

	^{''js'self + aDateTime'}""",nil)
smalltalk.bind(smalltalk.DateTime,"isValid",0
,smalltalk.__f__("""(self):
	#DateTime>>#isValid
	return smalltalk.true 
""","DateTime_isValid")
,"testing","""isValid
	" Return true if the receiver is a valid instance. "

	^{''js'isFinite(self)'}""",nil)
smalltalk.bind(smalltalk.DateTime,"asJSONObject",0
,smalltalk.__f__("""(self):
	#DateTime>>#asJSONObject
	return self 
""","DateTime_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self""",nil)
smalltalk.bind(smalltalk.UndefinedObject.__class__,"new",0
,smalltalk.__f__("""(self):
	#UndefinedObject class>>#new
	return self.error_(smalltalk.String("UndefinedObject can't be instantiated.")) 
""","UndefinedObject_class_new")
,"instantiation","""new
	" Return an instance of the receiver. "

	^self error: 'UndefinedObject can''t be instantiated.'""",nil)
smalltalk.bind(smalltalk.UndefinedObject.__class__,"alias",0
,smalltalk.__f__("""(self):
	#UndefinedObject class>>#alias
	def __blk1__():
		return self.basicNew() 
	return self.basicAt_ifAbsentPut_(smalltalk.String("@alias"),smalltalk.blk(__blk1__,0)) 
""","UndefinedObject_class_alias")
,"alias","""alias
	" Private - Return an alias of nil.
	Note that is is a hack used to wrap nil in an alias instance to make possible for Lua collections to contain nil
	"

	^self basicAt: '@alias' ifAbsentPut: [ self basicNew ]""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"ifNil:",0
,smalltalk.__f__("""(self,aBlock):
	#UndefinedObject>>#ifNil:
	return aBlock.value() 
""","UndefinedObject_ifNil_")
,"testing","""ifNil: aBlock
	" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). "

	^aBlock value""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"ifNotNil:",0
,smalltalk.__f__("""(self,aBlock):
	#UndefinedObject>>#ifNotNil:
	return self 
""","UndefinedObject_ifNotNil_")
,"testing","""ifNotNil: aBlock
	" Return the receiver if it is nil, or the result of evaluating aBlock. "

	^self""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"ifNil:ifNotNil:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#UndefinedObject>>#ifNil:ifNotNil:
	return aBlock.value() 
""","UndefinedObject_ifNil_ifNotNil_")
,"testing","""ifNil: aBlock ifNotNil: anotherBlock
	" Return the receiver if it is nil, or the result of evaluating aBlock. "

	^aBlock value""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"ifNotNil:ifNil:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#UndefinedObject>>#ifNotNil:ifNil:
	return anotherBlock.value() 
""","UndefinedObject_ifNotNil_ifNil_")
,"testing","""ifNotNil: aBlock ifNil: anotherBlock
	" Return the result of evaluating anotherBlock if teh receiver is nil, or the result of evaluating aBlock. "

	^anotherBlock value""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"isNil",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#isNil
	return smalltalk.true 
""","UndefinedObject_isNil")
,"testing","""isNil
	" Return true if the receiver is nil. "

	^true""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"notNil",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#notNil
	return smalltalk.false 
""","UndefinedObject_notNil")
,"testing","""notNil
	" Return true if the receiver is not nil. "

	^false""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"printString",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#printString
	return smalltalk.String("nil") 
""","UndefinedObject_printString")
,"printing","""printString
	" Return the text representation of the receiver. "

	^#nil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:",0
,smalltalk.__f__("""(self,aString,anotherString):
	#UndefinedObject>>#subclass:instanceVariableNames:
	return self.subclass_instanceVariableNames_category_(aString,anotherString,nil) 
""","UndefinedObject_subclass_instanceVariableNames_")
,"instantiation","""subclass: aString instanceVariableNames: anotherString
	" Create a subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: anotherString
		category: nil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:category:",0
,smalltalk.__f__("""(self,aString,aString2,aString3):
	#UndefinedObject>>#subclass:instanceVariableNames:category:
	return smalltalk.ClassBuilder.new().superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3) 
""","UndefinedObject_subclass_instanceVariableNames_category_")
,"instantiation","""subclass: aString instanceVariableNames: aString2 category: aString3
	" Create a subclass of the receiver. "

	^ClassBuilder new
		superclass: self
		subclass: aString
		instanceVariableNames: aString2
		category: aString3""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"asJSONObject",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#asJSONObject
	return None 
""","UndefinedObject_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^{''js'null'}""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"shallowCopy",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#shallowCopy
	return self 
""","UndefinedObject_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"deepCopy",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#deepCopy
	return self 
""","UndefinedObject_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"value",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#value
	return self 
""","UndefinedObject_value")
,"evaluating","""value
	" Return the result of evaluating the receiver. \"""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"@","_at"
,smalltalk.__f__("""(self,aNumber):
	#UndefinedObject>>#@
	return smalltalk.Point.x_y_(smalltalk.Number(0),aNumber) 
""","UndefinedObject__at")
,"converting","""@ aNumber
	" Return a Point with coordinates given by the receiver and aNumber. "

	^Point x: 0 y: aNumber""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#UndefinedObject>>#=
	return smalltalk.isNil_(anObject) 
""","UndefinedObject__eq")
,"comparing","""= anObject
	" Return true if the receiver is equal to argument. "

	^anObject isNil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"~=","_no_eq"
,smalltalk.__f__("""(self,anObject):
	#UndefinedObject>>#~=
	return smalltalk.notNil_(anObject) 
""","UndefinedObject__no_eq")
,"comparing","""~= anObject
	" Return true if the receiver is not equal to anObject. "

	^anObject notNil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"category:",0
,smalltalk.__f__("""(self,ignored):
	#UndefinedObject>>#category:
	return self 
""","UndefinedObject_category_")
,"instantiation","""category: ignored
	" BUG - throw an error in ClassBuilder. " """,nil)
smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,poolVarNames,aCategory):
	#UndefinedObject>>#subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
	if smalltalk.b(smalltalk.notNil_(self.smalltalk().globalAt_(aString))):
		self.note_(smalltalk.object_comma_(smalltalk.String("WARNING: class REdefinition for "),aString)) 
	 
	return smalltalk.ClassBuilder.new().superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory) 
""","UndefinedObject_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	category: aCategory
	" Create a new subclass of the receiver. "

	(self smalltalk globalAt: aString) notNil ifTrue: [
		self note: 'WARNING: class REdefinition for ',aString.
		"^self smalltalk globalAt: aString"
	].

"	self note: 'Creating ROOT class ',aString."
	^ClassBuilder new
		superclass: self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames
		category: aCategory""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,smalltalk.__f__("""(self,aString,aString2,classVarNames,poolVarNames):
	#UndefinedObject>>#subclass:instanceVariableNames:classVariableNames:poolDictionaries:
	return self.subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil) 
""","UndefinedObject_subclass_instanceVariableNames_classVariableNames_poolDictionaries_")
,"instantiation","""subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	" Create a new subclass of the receiver. "

	^self
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: classVarNames
		poolDictionaries: poolVarNames
		category: nil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"compiler",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#compiler
	return self.smalltalk().compilerSupport().for_(nil) 
""","UndefinedObject_compiler")
,"Tools-printing","""compiler
	" Return the compiler of the receiver. "

	^self smalltalk compilerSupport for: nil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"==","_eq_eq"
,smalltalk.__f__("""(self,anObject):
	#UndefinedObject>>#==
	return smalltalk.isNil_(anObject) 
""","UndefinedObject__eq_eq")
,"Tools-comparing","""== anObject
	^anObject isNil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"~~","_no_no"
,smalltalk.__f__("""(self,anObject):
	#UndefinedObject>>#~~
	return smalltalk.notNil_(anObject) 
""","UndefinedObject__no_no")
,"Tools-comparing","""~~ anObject
	^anObject notNil""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"handles",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#handles
	return self 
""","UndefinedObject_handles")
,"Natives-converting","""handles
	" Return the result of collecting the handles of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.UndefinedObject,"handle",0
,smalltalk.__f__("""(self):
	#UndefinedObject>>#handle
	return self.asJSONObject() 
""","UndefinedObject_handle")
,"Natives-converting","""handle
	" Return the handle of the receiver. "

	^self asJSONObject""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"streamClass",0
,smalltalk.__f__("""(self):
	#Collection class>>#streamClass
	return smalltalk.Stream 
""","Collection_class_streamClass")
,"streams","""streamClass
	" Private - Return the support for streamming on the receiver's instances. "

	^Stream""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"with:",0
,smalltalk.__f__("""(self,anObject):
	#Collection class>>#with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(anObject) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Collection_class_with_")
,"instantiation","""with: anObject
	" Return an instance of the receiver. "

	^self new
		add: anObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"with:with:",0
,smalltalk.__f__("""(self,anObject,anotherObject):
	#Collection class>>#with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(anObject) 
		_s8_rec.add_(anotherObject) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Collection_class_with_with_")
,"instantiation","""with: anObject with: anotherObject
	" Return an instance of the receiver. "

	^self new
		add: anObject;
		add: anotherObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"with:with:with:",0
,smalltalk.__f__("""(self,firstObject,secondObject,thirdObject):
	#Collection class>>#with:with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(firstObject) 
		_s8_rec.add_(secondObject) 
		_s8_rec.add_(thirdObject) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Collection_class_with_with_with_")
,"instantiation","""with: firstObject with: secondObject with: thirdObject
	" Return an instance of the receiver. "

	^self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"with:with:with:with:",0
,smalltalk.__f__("""(self,firstObject,secondObject,thirdObject,fourthObject):
	#Collection class>>#with:with:with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(firstObject) 
		_s8_rec.add_(secondObject) 
		_s8_rec.add_(thirdObject) 
		_s8_rec.add_(fourthObject) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Collection_class_with_with_with_with_")
,"instantiation","""with: firstObject with: secondObject with: thirdObject with: fourthObject
	" Return an instance of the receiver. "

	^self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"withAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Collection class>>#withAll:
	def __blk1__(_s8_rec):
		_s8_rec.addAll_(aCollection) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Collection_class_withAll_")
,"instantiation","""withAll: aCollection
	" Return an instance of the receiver. "

	^self new
		addAll: aCollection;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"basicNew:",0
,smalltalk.__f__("""(self,size):
	#Collection class>>#basicNew:
	return self.subclassResponsibility_(smalltalk.String("basicNew:")) 
""","Collection_class_basicNew_")
,"instantiation","""basicNew: size
	" Return an instance of the receiver of specified size. "

	^self subclassResponsibility: #basicNew:""",nil)
smalltalk.bind(smalltalk.Collection.__class__,"of:withAll:",0
,smalltalk.__f__("""(self,aType,handles):
	#Collection class>>#of:withAll:
	def __blk1__(each):
		return aType._at(each) 
	return self.withAll_(smalltalk.Array._at(handles).collect_(smalltalk.blk(__blk1__,1))) 
""","Collection_class_of_withAll_")
,"Natives-instantiation","""of: aType withAll: handles
	" Return an instance of the receiver wrapping handles with a type (or nil). "

	^self withAll: (Array @ handles collect: [:each| aType @ each ])""",nil)
smalltalk.bind(smalltalk.Collection,"wrap:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#wrap:
	return smalltalk.asNativeValue_(anObject) 
	return anObject 
""","Collection_wrap_")
,"alias","""wrap: anObject
	" Private - Return an element holding anObject. "

	{''js'self'}."macro hook"
	^anObject""",nil)
smalltalk.bind(smalltalk.Collection,"unwrap:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#unwrap:
	return smalltalk.asObject_(anObject) 
	return anObject 
""","Collection_unwrap_")
,"alias","""unwrap: anObject
	" Private - Return object held by anObject. "

	{''js'self'}."macro hook"
	^anObject""",nil)
smalltalk.bind(smalltalk.Collection,"size",0
,smalltalk.__f__("""(self):
	#Collection>>#size
	return self.subclassResponsibility_(smalltalk.String("size")) 
""","Collection_size")
,"accessing","""size
	" Return the size of the receiver. "

	^self subclassResponsibility: #size""",nil)
smalltalk.bind(smalltalk.Collection,"readStream",0
,smalltalk.__f__("""(self):
	#Collection>>#readStream
	return self.stream() 
""","Collection_readStream")
,"streams","""readStream
	" Return a read stream on the receiver. "

	^self stream""",nil)
smalltalk.bind(smalltalk.Collection,"writeStream",0
,smalltalk.__f__("""(self):
	#Collection>>#writeStream
	return self.stream() 
""","Collection_writeStream")
,"streams","""writeStream
	" Return a write stream on the receiver. "

	^self stream""",nil)
smalltalk.bind(smalltalk.Collection,"stream",0
,smalltalk.__f__("""(self):
	#Collection>>#stream
	return self.streamClass().on_(self) 
""","Collection_stream")
,"streams","""stream
	" Return a stream on the receiver. "

	^self streamClass on: self""",nil)
smalltalk.bind(smalltalk.Collection,"streamClass",0
,smalltalk.__f__("""(self):
	#Collection>>#streamClass
	return (self).__class__.streamClass() 
""","Collection_streamClass")
,"streams","""streamClass
	" Private - Return the support for streamming on the receiver. "

	^self class streamClass""",nil)
smalltalk.bind(smalltalk.Collection,"objectNotFound",0
,smalltalk.__f__("""(self):
	#Collection>>#objectNotFound
	self.smalltalk().objectNotFound(nil,nil,self) 
	return self.error_(smalltalk.String("Object is not in the collection")) 
""","Collection_objectNotFound")
,"error","""objectNotFound
	" Private - Generates an error.
	An object was not found in the receiver's contents.
	"

	self smalltalk #objectNotFound: nil at: nil in: self.
	^self error: 'Object is not in the collection'""",nil)
smalltalk.bind(smalltalk.Collection,"invalidIndex:",0
,smalltalk.__f__("""(self,anIndex):
	#Collection>>#invalidIndex:
	return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid index "),anIndex)) 
""","Collection_invalidIndex_")
,"error","""invalidIndex: anIndex
	" Private - Generates an error.
	An index to the receiver's contents is invalid/wrong.
	"

	^self error: 'Invalid index ' ,anIndex """,nil)
smalltalk.bind(smalltalk.Collection,"objectNotFound:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#objectNotFound:
	self.smalltalk().objectNotFound(anObject,nil,self) 
	return self.error_(smalltalk.object_comma_(smalltalk.String("Object not found: "),self.toString_(anObject))) 
""","Collection_objectNotFound_")
,"error","""objectNotFound: anObject
	" Private - Generates an error.
	anObject was not found in the receiver's contents.
	"

	self smalltalk #objectNotFound: anObject at: nil in: self.
	^self error: 'Object not found: ' ,(self toString: anObject)""",nil)
smalltalk.bind(smalltalk.Collection,"objectNotFoundAt:",0
,smalltalk.__f__("""(self,indexOrKey):
	#Collection>>#objectNotFoundAt:
	self.smalltalk().objectNotFound(nil,indexOrKey,self) 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Object not found at "),self.toString_(indexOrKey)),smalltalk.String(" in ")),self.asLiteral())) 
""","Collection_objectNotFoundAt_")
,"error","""objectNotFoundAt: indexOrKey
	" Private - Generates an error.
	The object at key/index was not found in the receiver's contents.
	"

	self smalltalk #objectNotFound: nil at: indexOrKey in: self.
	^self error: 'Object not found at '
		,(self toString: indexOrKey)
		,' in ' ,self asLiteral""",nil)
smalltalk.bind(smalltalk.Collection,"add:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#add:
	return self.subclassResponsibility_(smalltalk.String("add:")) 
""","Collection_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	^self subclassResponsibility: #add:""",nil)
smalltalk.bind(smalltalk.Collection,"addAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Collection>>#addAll:
	def __blk1__(each):
		return self.add_(each) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return aCollection 
""","Collection_addAll_")
,"adding","""addAll: aCollection
	" Add objects in aCollection to the receiver. "

	aCollection do: [:each | self add: each ].
	^aCollection""",nil)
smalltalk.bind(smalltalk.Collection,",","_comma"
,smalltalk.__f__("""(self,aCollection):
	#Collection>>#,
	def __blk1__(_s8_rec):
		_s8_rec.addAll_(aCollection) 
		return _s8_rec.yourself() 
	return __blk1__(self.copy()) 
""","Collection__comma")
,"copying",""", aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	^self copy
		addAll: aCollection;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection,"copyWith:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#copyWith:
	def __blk1__(_s8_rec):
		_s8_rec.add_(anObject) 
		return _s8_rec.yourself() 
	return __blk1__(self.copy()) 
""","Collection_copyWith_")
,"copying","""copyWith: anObject
	" Return a copy of the receiver with anObject. "

	^self copy add: anObject; yourself""",nil)
smalltalk.bind(smalltalk.Collection,"copyWithAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Collection>>#copyWithAll:
	def __blk1__(_s8_rec):
		_s8_rec.addAll_(aCollection) 
		return _s8_rec.yourself() 
	return __blk1__(self.copy()) 
""","Collection_copyWithAll_")
,"copying","""copyWithAll: aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	^self copy
		addAll: aCollection;
		yourself""",nil)
smalltalk.bind(smalltalk.Collection,"asArray",0
,smalltalk.__f__("""(self):
	#Collection>>#asArray
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Collection_asArray")
,"converting","""asArray
	" Return an array with the contents of the receiver. "

	| result |
	result := Array new.
	self do: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Collection,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#do:
	return self.subclassResponsibility_(smalltalk.String("do:")) 
""","Collection_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	^self subclassResponsibility: #do:""",nil)
smalltalk.bind(smalltalk.Collection,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Collection>>#detect:ifNone:
	return self.subclassResponsibility_(smalltalk.String("detect:ifNone:")) 
""","Collection_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. "

	^self subclassResponsibility: #detect:ifNone:""",nil)
smalltalk.bind(smalltalk.Collection,"reverseDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#reverseDo:
	return self.subclassResponsibility_(smalltalk.String("reverseDo:")) 
""","Collection_reverseDo_")
,"enumerating","""reverseDo: aBlock
	" Evaluate aBlock with the contents of the receiver in reverse order of iteration. "

	^self subclassResponsibility: #reverseDo:""",nil)
smalltalk.bind(smalltalk.Collection,"collect:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#collect:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(aBlock.value_(each)) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Collection_collect_")
,"enumerating","""collect: aBlock
	" Return a collection with the result of evaluating aBlock with the contents of the receiver. "

	| result |
	result := self species new.
	self do: [:each | result add: (aBlock value: each) ].
	^result""",nil)
smalltalk.bind(smalltalk.Collection,"select:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#select:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return __0__.result.add_(each) 
		return smalltalk.if_true_false_(aBlock.value_(each),smalltalk.blk(__blk2__,0),nil) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Collection_select_")
,"enumerating","""select: aBlock
	" Return the contents of the receiver which evaluates aBlock to true. "

	| result |
	result := self species new.
	self do: [:each|
	    (aBlock value: each) ifTrue: [ result add: each ]
	].
	^result""",nil)
smalltalk.bind(smalltalk.Collection,"detect:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#detect:
	def __blk1__():
		return self.objectNotFound() 
	return self.detect_ifNone_(aBlock,smalltalk.blk(__blk1__,0)) 
""","Collection_detect_")
,"enumerating","""detect: aBlock
	" Return the object in the receiver that return true when evaluated with aBlock.
	Generates an error if there is no object that evaluates aBlock to true.
	"

	^self detect: aBlock ifNone: [ self objectNotFound ]""",nil)
smalltalk.bind(smalltalk.Collection,"do:andBetweenDo:",0
,smalltalk.__f__("""(self,aBlock,separatorBlock):
	#Collection>>#do:andBetweenDo:
	return self.do_separatedBy_(aBlock,separatorBlock) 
""","Collection_do_andBetweenDo_")
,"enumerating","""do: aBlock andBetweenDo: separatorBlock
	" For each element in the receiver, evaluate aBlock with that element as the argument.
	Evaluate the separatorBlock between successive elements of the receiver.
	"

	^self do: aBlock separatedBy: separatorBlock""",nil)
smalltalk.bind(smalltalk.Collection,"do:separatedBy:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Collection>>#do:separatedBy:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		if smalltalk.b(__0__.first):
			__0__.first=smalltalk.false 
		else:
			anotherBlock.value() 
		 
		return aBlock.value_(each) 
	__0__.first=nil
	__0__.first=smalltalk.true 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Collection_do_separatedBy_")
,"enumerating","""do: aBlock separatedBy: anotherBlock
	" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. "

	| first |
	first := true.
	self do: [:each |
	    first
		ifTrue: [ first := false ]
		ifFalse: [ anotherBlock value ].
	    aBlock value: each
	]""",nil)
smalltalk.bind(smalltalk.Collection,"inject:into:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#Collection>>#inject:into:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=aBlock.value_value_(__0__.result,each)
		return __0__.result 
	__0__.result=nil
	__0__.result=anObject 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Collection_inject_into_")
,"enumerating","""inject: anObject into: aBlock
	" Evaluate aBlock for result of previous evaluation and contents of the receiver.
	On first evaluation anObject is used as first argument to evaluate aBlock.
	"

	| result |
	result := anObject.
	self do: [:each | result := aBlock value: result value: each ].
	^result""",nil)
smalltalk.bind(smalltalk.Collection,"reject:",0
,smalltalk.__f__("""(self,aBlock):
	#Collection>>#reject:
	def __blk1__(each):
		return smalltalk.isObject_equalTo_(aBlock.value_(each),smalltalk.false) 
	return self.select_(smalltalk.blk(__blk1__,1)) 
""","Collection_reject_")
,"enumerating","""reject: aBlock
	" Return the contents of the receiver wich evaluates aBlock to false. "

	^self select: [:each | (aBlock value: each) = false]""",nil)
smalltalk.bind(smalltalk.Collection,"select:thenCollect:",0
,smalltalk.__f__("""(self,selectBlock,collectBlock):
	#Collection>>#select:thenCollect:
	return self.select_(selectBlock).collect_(collectBlock) 
""","Collection_select_thenCollect_")
,"enumerating","""select: selectBlock thenCollect: collectBlock
	" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. "

	^(self select: selectBlock) collect: collectBlock""",nil)
smalltalk.bind(smalltalk.Collection,"collect:thenSelect:",0
,smalltalk.__f__("""(self,collectBlock,selectBlock):
	#Collection>>#collect:thenSelect:
	return self.collect_(collectBlock).select_(selectBlock) 
""","Collection_collect_thenSelect_")
,"enumerating","""collect: collectBlock thenSelect: selectBlock
	" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. "

	^(self collect: collectBlock) select: selectBlock""",nil)
smalltalk.bind(smalltalk.Collection,"reversed",0
,smalltalk.__f__("""(self):
	#Collection>>#reversed
	return self.subclassResponsibility_(smalltalk.String("reversed")) 
""","Collection_reversed")
,"copying","""reversed
	" Return an array with the contents of the receiver in reverse order. "

	^self subclassResponsibility: #reversed""",nil)
smalltalk.bind(smalltalk.Collection,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#includes:
	return self.subclassResponsibility_(smalltalk.String("includes:")) 
""","Collection_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^self subclassResponsibility: #includes:""",nil)
smalltalk.bind(smalltalk.Collection,"notEmpty",0
,smalltalk.__f__("""(self):
	#Collection>>#notEmpty
	return smalltalk.booleanNot_(self.isEmpty()) 
""","Collection_notEmpty")
,"testing","""notEmpty
	" Return true if the receiver is not empty. "

	^self isEmpty not""",nil)
smalltalk.bind(smalltalk.Collection,"isEmpty",0
,smalltalk.__f__("""(self):
	#Collection>>#isEmpty
	return smalltalk.b_(self.size() is smalltalk.Number(0)) 
""","Collection_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^self size == 0""",nil)
smalltalk.bind(smalltalk.Collection,"remove:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#remove:
	def __blk1__():
		return self.objectNotFound_(anObject) 
	return self.remove_ifAbsent_(anObject,smalltalk.blk(__blk1__,0)) 
""","Collection_remove_")
,"removing","""remove: anObject
	" Remove anObject from receiver, return the removed object. "

	^self remove: anObject ifAbsent: [ self objectNotFound: anObject ]""",nil)
smalltalk.bind(smalltalk.Collection,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#Collection>>#remove:ifAbsent:
	return self.subclassResponsibility_(smalltalk.String("remove:ifAbsent:")) 
""","Collection_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from receiver.
	Return the removed object or the result of evaluating aBlock (if the object is not found).
	"

	^self subclassResponsibility: #remove:ifAbsent:""",nil)
smalltalk.bind(smalltalk.Collection,"removeAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Collection>>#removeAll:
	def __blk1__(each):
		return self.remove_(each) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return aCollection 
""","Collection_removeAll_")
,"removing","""removeAll: aCollection
	" Remove aCollection from receiver. "

	aCollection do: [:each| self remove: each ].
	^aCollection""",nil)
smalltalk.bind(smalltalk.Collection,"removeAll",0
,smalltalk.__f__("""(self):
	#Collection>>#removeAll
	self.removeAll_(self.shallowCopy()) 
	return self 
""","Collection_removeAll")
,"removing","""removeAll
	" Remove all elements in the receiver. "

	self removeAll: self shallowCopy""",nil)
smalltalk.bind(smalltalk.Collection,"occurrencesOf:",0
,smalltalk.__f__("""(self,anObject):
	#Collection>>#occurrencesOf:
	def __blk1__(total,each):
		def __blk2__():
			return total._plus(smalltalk.Number(1)) 
		def __blk3__():
			return total 
		return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each,anObject),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.inject_into_(smalltalk.Number(0),smalltalk.blk(__blk1__,2)) 
""","Collection_occurrencesOf_")
,"counting","""occurrencesOf: anObject
	" Return the occurrences of anObject in the receiver. "

	^self inject: 0 into: [:total :each|
		each = anObject ifTrue: [ total + 1 ] ifFalse: [total]
	]""",nil)
smalltalk.bind(smalltalk.Collection,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Collection>>#shallowCopy
	def __blk1__(each):
		return each 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Collection_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self collect: [:each| each ]""",nil)
smalltalk.bind(smalltalk.Collection,"deepCopy",0
,smalltalk.__f__("""(self):
	#Collection>>#deepCopy
	def __blk1__(each):
		return each.deepCopy() 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Collection_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self collect: [:each| each deepCopy ]""",nil)
smalltalk.bind(smalltalk.Collection,"on:",0
,smalltalk.__f__("""(self,target):
	#Collection>>#on:
	__0__=smalltalk.newContext()
	def __blk1__(index,block):
		def __blk2__():
			nil 
		return block.value_(target.at_ifAbsent_(__0__.array.at_(index),smalltalk.blk(__blk2__,0))) 
	__0__.array=nil
	__0__.array=self.asArray() 
	return smalltalk.Number(1).to_by_value_(__0__.array.size(),smalltalk.Number(1),smalltalk.blk(__blk1__,2)) 
""","Collection_on_")
,"iterating","""on: target
	" Return an iterable on the target contents accessed by the receiver. "

	| array |
	array := self asArray.
	^1 to: array size by: 1 value: [:index :block|
		block value: (target at: (array at: index) ifAbsent:[])
	]""",nil)
smalltalk.bind(smalltalk.Collection,"asSet",0
,smalltalk.__f__("""(self):
	#Collection>>#asSet
	return smalltalk.Set.withAll_(self) 
""","Collection_asSet")
,"converting","""asSet
	" Return the receiver contents in a Set. "

	^Set withAll: self""",nil)
smalltalk.bind(smalltalk.Collection,"asHashedSet",0
,smalltalk.__f__("""(self):
	#Collection>>#asHashedSet
	return smalltalk.HashedSet.withAll_(self) 
""","Collection_asHashedSet")
,"converting","""asHashedSet
	" Return the receiver contents in a HashedSet. "

	^HashedSet withAll: self""",nil)
smalltalk.bind(smalltalk.Collection,"asParser",0
,smalltalk.__f__("""(self):
	#Collection>>#asParser
	return smalltalk.PPChoiceParser.withAll_(self.asArray()) 
""","Collection_asParser")
,"Compiler-converting","""asParser
	" Return a parser on the receiver. "

	^PPChoiceParser withAll: self asArray""",nil)
smalltalk.bind(smalltalk.Collection,"fileOut",0
,smalltalk.__f__('''(self):
	#Collection>>#fileOut
	__0__=smalltalk.newContext()
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.add_(__0__.cr) 
			_s8_rec.add_(each.fileOut()) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	__0__.cr=nil
	__0__.cr=smalltalk.String("""
	""") 
	return self.inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2)).join_(smalltalk.String("")) 
''',"Collection_fileOut")
,"Tools-fileOut","""fileOut
	" Return fileOut definition and code of classes in the receiver. "

	| cr |
	cr := '
'.	^(self inject: #() into: [:total :each|
		total add: cr; add: each fileOut; yourself
		]) join: ''""",nil)
smalltalk.bind(smalltalk.Collection,"export",0
,smalltalk.__f__('''(self):
	#Collection>>#export
	__0__=smalltalk.newContext()
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.add_(__0__.cr) 
			_s8_rec.add_(each.export()) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	__0__.cr=nil
	__0__.cr=smalltalk.String("""
	""") 
	return self.inject_into_(smalltalk.String(""),smalltalk.blk(__blk1__,2)).join_(smalltalk.String("")) 
''',"Collection_export")
,"Tools-export","""export
	" Return the result of exporting definition and source code of classes in the receiver. "

	| cr |
	cr := '
'.	^(self inject: '' into: [:total :each|
		total add: cr; add: each export; yourself
		]) join: ''""",nil)
smalltalk.bind(smalltalk.Collection,"emmit",0
,smalltalk.__f__('''(self):
	#Collection>>#emmit
	def __blk1__(each):
		return self.emmit_(each) 
	return self.asArray().compose_with_(smalltalk.blk(__blk1__,1),smalltalk.String("""
	""")) 
''',"Collection_emmit")
,"Builders-emmiting","""emmit
	" Emmit (fileIn & save generated code of) the fileNames in the receiver. "

	^self asArray compose: [:each| self emmit: each ] with: '
'""",nil)
smalltalk.bind(smalltalk.Collection,"emmitSt",0
,smalltalk.__f__("""(self):
	#Collection>>#emmitSt
	def __blk1__(module):
		return smalltalk.object_comma_(smalltalk.object_comma_(module,smalltalk.String(".")),smalltalk.String.sourceFileExtension()) 
	return self.collect_(smalltalk.blk(__blk1__,1)).emmit() 
""","Collection_emmitSt")
,"Builders-emmiting","""emmitSt
	" Emmit the code of source modules (st files) in the receiver. "

	^(self collect: [:module| module ,$. ,String sourceFileExtension ]) emmit""",nil)
smalltalk.bind(smalltalk.Collection,"handles",0
,smalltalk.__f__("""(self):
	#Collection>>#handles
	return self.asArray().handles() 
""","Collection_handles")
,"Natives-converting","""handles
	" Return an array with the handles of the receiver. "

	^self asArray handles""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"at:",0
,smalltalk.__f__("""(self,anIndex):
	#SequenceableCollection>>#at:
	def __blk1__():
		return self.objectNotFoundAt_(anIndex) 
	return self.at_ifAbsent_(anIndex,smalltalk.blk(__blk1__,0)) 
""","SequenceableCollection_at_")
,"accessing","""at: anIndex
	" Return the object in the receiver at anIndex position. "

	^self at: anIndex ifAbsent: [ self objectNotFoundAt: anIndex ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"at:ifAbsent:",0
,smalltalk.__f__("""(self,anIndex,aBlock):
	#SequenceableCollection>>#at:ifAbsent:
	return self.subclassResponsibility_(smalltalk.String("at:ifAbsent:")) 
""","SequenceableCollection_at_ifAbsent_")
,"accessing","""at: anIndex ifAbsent: aBlock
	" Return the object in the receiver at anIndex position or the result of evaluating aBlock. "

	^self subclassResponsibility: #at:ifAbsent:""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"at:put:",0
,smalltalk.__f__("""(self,anIndex,anObject):
	#SequenceableCollection>>#at:put:
	return self.subclassResponsibility_(smalltalk.String("at:put:")) 
""","SequenceableCollection_at_put_")
,"accessing","""at: anIndex put: anObject
	" Set the object in the receiver at anIndex position. "

	^self subclassResponsibility: #at:put:""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"at:ifAbsentPut:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#SequenceableCollection>>#at:ifAbsentPut:
	def __blk1__():
		return self.at_put_(aKey,aBlock.value()) 
	return self.at_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
""","SequenceableCollection_at_ifAbsentPut_")
,"accessing","""at: aKey ifAbsentPut: aBlock
	" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. "

	^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#SequenceableCollection>>#copyFrom:to:
	return self.subclassResponsibility_(smalltalk.String("copyFrom:to:")) 
""","SequenceableCollection_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return a copy of the receiver. "

	^self subclassResponsibility: #copyFrom:to:""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"indexOf:",0
,smalltalk.__f__("""(self,anObject):
	#SequenceableCollection>>#indexOf:
	def __blk1__():
		return smalltalk.Number(0) 
	return self.indexOf_ifAbsent_(anObject,smalltalk.blk(__blk1__,0)) 
""","SequenceableCollection_indexOf_")
,"testing","""indexOf: anObject
	" Return the position of anObject in the receiver, or 0. "

	^self indexOf: anObject ifAbsent: [ 0 ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"indexOf:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#SequenceableCollection>>#indexOf:ifAbsent:
	cookie=self.wrap_(anObject)
	for i, x in enumerate(smalltalk.handleOf(self)):
		if smalltalk.isObject_equalTo(x,cookie):
			return smalltalk.Number(i+1)
		
	if True:
		return smalltalk.handleOf(aBlock)()
	 
	return self 
""","SequenceableCollection_indexOf_ifAbsent_")
,"testing","""indexOf: anObject ifAbsent: aBlock
	" Return the position of anObject in the receiver, or the result of evaluating aBlock. "

	{''js'
	for(var i=0;i<self.length;i++){ if (self[i]._eq(anObject)) { return i + 1; } }
	return aBlock.value()'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#do:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return aBlock.value_(self.at_(i)) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for x in smalltalk.handleOf(self):
		aBlock(self.unwrap_(x))
	 
	return self 
""","SequenceableCollection_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=0;i<self.length;i++){fn(self[i]);}'
s8'	1 to: self size do: [:i|
		aBlock value: (self at: i)
	]'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#SequenceableCollection>>#detect:ifNone:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,each) 
			return smalltalk.if_true_false_(aBlock.value_(each),smalltalk.blk(__blk2__,0),nil) 
		__0__.fn=nil
		__0__.fn=self.callableOf_(aBlock) 
		for x in smalltalk.handleOf(self):
			each=self.unwrap_(x)
			if smalltalk.b(aBlock(each)):
				return each
			
		if True:
			return smalltalk.handleOf(anotherBlock)()
		 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SequenceableCollection_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i = 0; i < self.length; i++) if(fn(self[i])) return self[i];
	return anotherBlock.value()'
s8'	self do: [:each|
		(aBlock value: each) ifTrue: [ ^each ]
	].
	^anotherBlock value'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"reversed",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#reversed
	return self.__class__(list(smalltalk.handleOf(self))[::-1]) 
	return self 
""","SequenceableCollection_reversed")
,"copying","""reversed
	" Return an array with the contents of the receiver in reverse order. "

	{''js'
	var result = new Array();
	var len=self.length; var i=len;
	while(i--){result[len-i-1]= self[i];}
	return result'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"isEmpty",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#isEmpty
	return smalltalk.b_(len(smalltalk.handleOf(self)) == 0) 
""","SequenceableCollection_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty.
	Note: ^self size = 0 is slower than inlined impl.
	"

	^{''js'(this.length)?false:true'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"reverseDo:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#reverseDo:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return aBlock.value_(self.at_(i)) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for x in reversed(smalltalk.handleOf(self)):
		aBlock(self.unwrap_(x))
	 
	return self 
""","SequenceableCollection_reverseDo_")
,"enumerating","""reverseDo: aBlock
	" Evaluate aBlock with the contents of the receiver in reverse order of iteration. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	var i=self.length;while(i--){fn(self[i]);}'
s8'	self size to: 1 by: -1 do: [:i|
		aBlock value: (self at: i)
	]'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#SequenceableCollection>>#includes:
	cookie=self.wrap_(anObject)
	for x in smalltalk.handleOf(self):
		if smalltalk.isObject_equalTo(x,cookie):
			return smalltalk.true
		
	if True:
		return smalltalk.false
	 
	if not smalltalk.b(self.isObject_(anObject)):
		return self.indexOf(anObject)._gt(smalltalk.Number(-1)) 
	 
	
	return self 
""","SequenceableCollection_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	{''js'self'}.
	(self isObject: anObject) ifFalse: [ ^(self #indexOf: anObject) > -1 ].
	{''js'
	if (anObject.isNumber() && (self.indexOf(anObject) > -1)) return true;
	if (anObject.isString() && (self.indexOf(anObject) > -1)) return true;
	var i = self.length;
	while (i--) { if (anObject._eq(self[i])) { return true; } }
	return false'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"occurrencesOf:",0
,smalltalk.__f__("""(self,anObject):
	#SequenceableCollection>>#occurrencesOf:
	count = 0
	cookie=self.wrap_(anObject)
	for x in smalltalk.handleOf(self):
		if smalltalk.isObject_equalTo(x,cookie):
			count = count + 1
		
	if True:
		return smalltalk.Number(count)
	 
	return self 
""","SequenceableCollection_occurrencesOf_")
,"counting","""occurrencesOf: anObject
	" Return the occurrences of anObject in the receiver. "

	{''js'
	var i = self.length; var count = 0;
	while (i--) { if (self[i]._eq(anObject)) { count++; } }
	return count'}""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"first",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#first
	return self.at_(smalltalk.Number(1)) 
""","SequenceableCollection_first")
,"accessing","""first
	" Return the object in the receiver. "

	^self at: 1""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"fourth",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#fourth
	return self.at_(smalltalk.Number(4)) 
""","SequenceableCollection_fourth")
,"accessing","""fourth
	" Return the object in the receiver. "

	^self at: 4""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"last",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#last
	return self.at_(self.size()) 
""","SequenceableCollection_last")
,"accessing","""last
	" Return the object in the receiver. "

	^self at: self size""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"second",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#second
	return self.at_(smalltalk.Number(2)) 
""","SequenceableCollection_second")
,"accessing","""second
	" Return the object in the receiver. "

	^self at: 2""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"third",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#third
	return self.at_(smalltalk.Number(3)) 
""","SequenceableCollection_third")
,"accessing","""third
	" Return the object in the receiver. "

	^self at: 3""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"removeLast",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#removeLast
	return self.remove_(self.last()) 
""","SequenceableCollection_removeLast")
,"removing","""removeLast
	" Remove the last object in the receiver. "

	^self remove: self last""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"removeFirst",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#removeFirst
	return self.remove_(self.first()) 
""","SequenceableCollection_removeFirst")
,"removing","""removeFirst
	" Remove the first object in the receiver. "

	^self remove: self first""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"addLast:",0
,smalltalk.__f__("""(self,anObject):
	#SequenceableCollection>>#addLast:
	return self.add_(anObject) 
""","SequenceableCollection_addLast_")
,"adding","""addLast: anObject
	" Add anObject to the receiver (at end). "

	^self add: anObject""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"atAll:put:",0
,smalltalk.__f__("""(self,indices,anObject):
	#SequenceableCollection>>#atAll:put:
	def __blk1__(index):
		return self.at_put_(index,anObject) 
	indices.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SequenceableCollection_atAll_put_")
,"accessing","""atAll: indices put: anObject
	" Return the receiver after replacing those elements, indexed by the indices, with anObject. "

	indices do: [ :index | self at: index put: anObject ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"atAllPut:",0
,smalltalk.__f__("""(self,anObject):
	#SequenceableCollection>>#atAllPut:
	def __blk1__(index):
		return self.at_put_(index,anObject) 
	smalltalk.Number(1).to_(self.size()).do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SequenceableCollection_atAllPut_")
,"accessing","""atAllPut: anObject
	" Replace all elements of the receiver with anObject. "

	(1 to: self size) do: [ :index | self at: index put: anObject ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"withIndexDo:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#withIndexDo:
	def __blk1__(index):
		return aBlock.value_value_(self.at_(index),index) 
	smalltalk.Number(1).to_(self.size()).do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SequenceableCollection_withIndexDo_")
,"enumerating","""withIndexDo: aBlock
	" Evaluate aBlock with all the index positions in the receiver. "

	(1 to: self size) do: [ :index |
		aBlock value: (self at: index) value: index
	]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"=","_eq"
,smalltalk.__f__("""(self,aCollection):
	#SequenceableCollection>>#=
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.index._lt_eq(smalltalk.Number(0)) 
	__0__.index=nil
	if smalltalk.b(smalltalk.b_(self is aCollection)):
		return smalltalk.true 
	 
	if not smalltalk.b(smalltalk.b_((self).__class__ is (aCollection).__class__)):
		return smalltalk.false 
	 
	__0__.index=self.size() 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.index,aCollection.size())._8not()):
		return smalltalk.false 
	 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		if not smalltalk.b(smalltalk.isObject_equalTo_(self.at_(__0__.index),aCollection.at_(__0__.index))):
			return smalltalk.false 
		 
		__0__.index=__0__.index._minus(smalltalk.Number(1)) 
	 
	return smalltalk.true 
""","SequenceableCollection__eq")
,"testing","""= aCollection
	" Return true if the receiver is equal to argument. "

	| index |
	self == aCollection ifTrue: [ ^true ].
	self class == aCollection class ifFalse: [ ^false ].
	index := self size.
	index ~= aCollection size ifTrue: [ ^false ].
	[ index <= 0 ] whileFalse: [
		(self at: index) = (aCollection at: index) ifFalse: [ ^false ].
		index := index - 1
	].
	^true""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"beginsWith:",0
,smalltalk.__f__("""(self,aCollection):
	#SequenceableCollection>>#beginsWith:
	if smalltalk.b(self.size()._lt(aCollection.size())):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.size(),aCollection.size())):
		return smalltalk.isObject_equalTo_(aCollection,self) 
	 
	return smalltalk.isObject_equalTo_(aCollection,self.copyFrom_to_(smalltalk.Number(1),aCollection.size())) 
""","SequenceableCollection_beginsWith_")
,"testing","""beginsWith: aCollection
	" Return true if the receiver begins with aCollection. "

	self size < aCollection size ifTrue: [ ^false ].
	self size = aCollection size ifTrue: [ ^aCollection = self ].
	^aCollection = (self copyFrom: 1 to: aCollection size)""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"endsWith:",0
,smalltalk.__f__("""(self,aCollection):
	#SequenceableCollection>>#endsWith:
	if smalltalk.b(self.size()._lt(aCollection.size())):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.size(),aCollection.size())):
		return smalltalk.isObject_equalTo_(aCollection,self) 
	 
	return smalltalk.isObject_equalTo_(aCollection,self.copyFrom_to_(self.size()._minus(aCollection.size())._plus(smalltalk.Number(1)),self.size())) 
""","SequenceableCollection_endsWith_")
,"testing","""endsWith: aCollection
	" Return true if the receiver ends with aCollection. "

	self size < aCollection size ifTrue: [ ^false ].
	self size = aCollection size ifTrue: [ ^aCollection = self ].
	^aCollection = (self copyFrom: self size - aCollection size + 1 to: self size)""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"copyReplaceFrom:to:with:",0
,smalltalk.__f__("""(self,start,stop,aCollection):
	#SequenceableCollection>>#copyReplaceFrom:to:with:
	return smalltalk.object_comma_(smalltalk.object_comma_(self.copyFrom_to_(smalltalk.Number(1),start._minus(smalltalk.Number(1))),aCollection),self.copyFrom_to_(stop._plus(smalltalk.Number(1)),self.size())) 
""","SequenceableCollection_copyReplaceFrom_to_with_")
,"copying","""copyReplaceFrom: start to: stop with: aCollection
	" Return a collection containing a copy of the receiver with the elements at index positions from start through stop replaced with the elements of aCollection. "

	^(self copyFrom: 1 to: start - 1)
		, aCollection
		, (self copyFrom: stop + 1 to: self size)""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"copyWithout:",0
,smalltalk.__f__("""(self,anObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#SequenceableCollection>>#copyWithout:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.copy()) 
		__0__.index=nil
		__0__.index=self.indexOf_ifAbsent_(anObject,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(self.copyFrom_to_(smalltalk.Number(1),__0__.index._minus(smalltalk.Number(1))),self.copyFrom_to_(__0__.index._plus(smalltalk.Number(1)),self.size()).copyWithout_(anObject))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SequenceableCollection_copyWithout_")
,"copying","""copyWithout: anObject
	" Return a copy of the receiver excluding anObject, if any. "

	| index |
	index := self indexOf: anObject ifAbsent: [ ^self copy ].
	^(self copyFrom: 1 to: index - 1)
		,((self copyFrom: index + 1 to: self size)
			copyWithout: anObject)""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"copyWithAll:",0
,smalltalk.__f__("""(self,aCollection):
	#SequenceableCollection>>#copyWithAll:
	return smalltalk.object_comma_(self,aCollection) 
""","SequenceableCollection_copyWithAll_")
,"copying","""copyWithAll: aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	^self , aCollection """,nil)
smalltalk.bind(smalltalk.SequenceableCollection,"findFirst:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#findFirst:
	def __blk1__():
		return self.errorAbsentObject() 
	return self.findFirst_ifAbsent_(aBlock,smalltalk.blk(__blk1__,0)) 
""","SequenceableCollection_findFirst_")
,"searching","""findFirst: aBlock
	" Return the index of the first element of the receiver that causes aBlock to evaluate to true.
         If no such element is found, report an error.
	"

	^self findFirst: aBlock ifAbsent: [ self errorAbsentObject ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"findFirst:ifAbsent:",0
,smalltalk.__f__("""(self,aBlock,absentBlock):
	#SequenceableCollection>>#findFirst:ifAbsent:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.index._lt_eq(__0__.size) 
	__0__.index=nil
	__0__.size=nil
	__0__.size=self.size() 
	__0__.index=smalltalk.Number(1) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		if smalltalk.b(aBlock.value_(self.at_(__0__.index))):
			return __0__.index 
		 
		__0__.index=__0__.index._plus(smalltalk.Number(1)) 
	 
	return absentBlock.value() 
""","SequenceableCollection_findFirst_ifAbsent_")
,"searching","""findFirst: aBlock ifAbsent: absentBlock
	" Return the index of the first element of the receiver that causes aBlock to evaluate to true.
	If no such element is found, return the result of evaluating the argument block.
	"

	| index size |
	size := self size.
	index := 1.
	[ index <= size ] whileTrue: [
		(aBlock value: (self at: index)) ifTrue: [ ^index ].
		index := index + 1
	].
	^absentBlock value""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"findLast:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#findLast:
	def __blk1__():
		return self.errorAbsentObject() 
	return self.findLast_ifAbsent_(aBlock,smalltalk.blk(__blk1__,0)) 
""","SequenceableCollection_findLast_")
,"searching","""findLast: aBlock
	" Return the index of the last element of the receiver that causes aBlock to evaluate to true.
	If no such element is found, report an error.
	"

	^self findLast: aBlock ifAbsent: [ self errorAbsentObject ]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"findLast:ifAbsent:",0
,smalltalk.__f__("""(self,aBlock,absentBlock):
	#SequenceableCollection>>#findLast:ifAbsent:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.index._gt(smalltalk.Number(0)) 
	__0__.index=nil
	__0__.index=self.size() 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		if smalltalk.b(aBlock.value_(self.at_(__0__.index))):
			return __0__.index 
		 
		__0__.index=__0__.index._minus(smalltalk.Number(1)) 
	 
	return absentBlock.value() 
""","SequenceableCollection_findLast_ifAbsent_")
,"searching","""findLast: aBlock ifAbsent: absentBlock
	" Return the index of the last element of the receiver that causes aBlock to evaluate to true.
	If no such element is found, return the result of evaluating the argument block.
	"

	| index |
	index := self size.
	[ index > 0 ] whileTrue: [
		(aBlock value: (self at: index)) ifTrue: [ ^index ].
		index := index - 1
	].
	^absentBlock value""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:",0
,smalltalk.__f__("""(self,start,stop,aCollection):
	#SequenceableCollection>>#replaceFrom:to:with:
	if not smalltalk.b(smalltalk.isObject_equalTo_(stop._minus(start)._plus(smalltalk.Number(1)),aCollection.size())):
		return self.error_(smalltalk.String("Replacement has wrong size")) 
	 
	self.replaceFrom_to_with_startingAt_(start,stop,aCollection,smalltalk.Number(1)) 
	return self 
""","SequenceableCollection_replaceFrom_to_with_")
,"replace","""replaceFrom: start to: stop with: aCollection
	" Return the receiver.
	Replace the elements of the receiver at index positions start through stop, with the elements of aCollection. "

	stop - start + 1 = aCollection size ifFalse: [
		^self error: 'Replacement has wrong size'
	].
	self
		replaceFrom: start
		to: stop
		with: aCollection
		startingAt: 1""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingAt:",0
,smalltalk.__f__("""(self,start,stop,aCollection,repStart):
	#SequenceableCollection>>#replaceFrom:to:with:startingAt:
	__0__=smalltalk.newContext()
	def __blk1__():
		return repStart._lt(start) 
	def __blk2__():
		return __0__.index1._lt_eq(stop) 
	__0__.index1=nil
	__0__.index2=nil
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.b_(self is aCollection),smalltalk.blk(__blk1__,0))):
		def __blk3__():
			return start._lt_eq(__0__.index1) 
		__0__.index2=repStart._plus(stop)._minus(start) 
		__0__.index1=stop 
		while smalltalk.b(smalltalk.blk(__blk3__,0)()):
			self.at_put_(__0__.index1,aCollection.at_(__0__.index2)) 
			__0__.index1=__0__.index1._minus(smalltalk.Number(1)) 
			__0__.index2=__0__.index2._minus(smalltalk.Number(1)) 
		 
		return self 
	 
	__0__.index2=repStart 
	__0__.index1=start 
	while smalltalk.b(smalltalk.blk(__blk2__,0)()):
		self.at_put_(__0__.index1,aCollection.at_(__0__.index2)) 
		__0__.index1=__0__.index1._plus(smalltalk.Number(1)) 
		__0__.index2=__0__.index2._plus(smalltalk.Number(1)) 
	 
	return self 
""","SequenceableCollection_replaceFrom_to_with_startingAt_")
,"replace","""replaceFrom: start
    to: stop
    with: aCollection
    startingAt: repStart
	" Return the receiver.
	Replace the elements of the receiver at index positions start through stop with consecutive
         elements of aCollection beginning at index position repStart.
	"

	| index1 index2 |
	(self == aCollection and: [ repStart < start ]) ifTrue: [ "do backward move for same object"
		index2 := repStart + stop - start.
		index1 := stop.
		[ start <= index1 ] whileTrue: [
			self at: index1 put: (aCollection at: index2).
			index1 := index1 - 1.
			index2 := index2 - 1
		].
		^self
	].
	index2 := repStart.
	index1 := start.
	[ index1 <= stop ] whileTrue: [
		self at: index1 put: (aCollection at: index2).
		index1 := index1 + 1.
		index2 := index2 + 1
	]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingWith:",0
,smalltalk.__f__("""(self,start,stop,replacement,replacementStart):
	#SequenceableCollection>>#replaceFrom:to:with:startingWith:
	return self.replaceFrom_to_with_startingAt_(start,stop,replacement,replacementStart) 
""","SequenceableCollection_replaceFrom_to_with_startingWith_")
,"replace","""replaceFrom: start
    to: stop
    with: replacement
    startingWith: replacementStart
	" Replace the elements of the receiver. "

	^self
		replaceFrom: start
		to: stop
		with: replacement
		startingAt: replacementStart""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"replaceFrom:to:withObject:",0
,smalltalk.__f__("""(self,start,stop,anObject):
	#SequenceableCollection>>#replaceFrom:to:withObject:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.index._lt_eq(stop) 
	__0__.index=nil
	__0__.index=start 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		self.at_put_(__0__.index,anObject) 
		__0__.index=__0__.index._plus(smalltalk.Number(1)) 
	 
	return anObject 
""","SequenceableCollection_replaceFrom_to_withObject_")
,"replace","""replaceFrom: start to: stop withObject: anObject
	"Replace each of the elements of the receiver at index positions start through stop with anObject. "

	| index |
	index := start.
	[ index <= stop ] whileTrue: [
		self at: index put: anObject.
		index := index + 1
	].
	^anObject""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"with:do:",0
,smalltalk.__f__("""(self,aCollection,aBlock):
	#SequenceableCollection>>#with:do:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return __0__.second.atEnd() 
		return smalltalk.boolean_or_(__0__.first.atEnd(),smalltalk.blk(__blk2__,0)) 
	__0__.first=nil
	__0__.second=nil
	__0__.first=self.stream() 
	__0__.second=aCollection.stream() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		aBlock.value_value_(__0__.first.next(),__0__.second.next()) 
	 
	return self 
""","SequenceableCollection_with_do_")
,"iterating","""with: aCollection do: aBlock
	" For each pair of elements evaluate aBlock with those elements as the arguments. "

	| first second |
	first	:= self stream.
	second	:= aCollection stream.
	[ first atEnd or: [ second atEnd ] ] whileFalse: [
		aBlock value: first next value: second next
	].""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"sort",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#sort
	self.sort_(nil) 
	return self 
""","SequenceableCollection_sort")
,"sorting","""sort
	" Sort (inplace) the receiver's contents with default criteria. "

	self sort: nil""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"sort:",0
,smalltalk.__f__("""(self,aBlock):
	#SequenceableCollection>>#sort:
	self.implementedBySubclass_(smalltalk.String("sort:")) 
	return self 
""","SequenceableCollection_sort_")
,"sorting","""sort: aBlock
	" Sort (inplace) the receiver's contents with aBlock. "

	self implementedBySubclass: #sort:""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"from:to:by:",0
,smalltalk.__f__("""(self,start,end,increment):
	#SequenceableCollection>>#from:to:by:
	def __blk1__(index,block):
		return block.value_(self.at_(index)) 
	return start.to_by_value_(end,increment,smalltalk.blk(__blk1__,2)) 
""","SequenceableCollection_from_to_by_")
,"iterating","""from: start to: end by: increment
	" Return an iterable on the receiver's contents from start to end. "

	^start to: end by: increment value: [:index :block|
		block value: (self at: index)
	]""",nil)
smalltalk.bind(smalltalk.SequenceableCollection,"from:to:",0
,smalltalk.__f__("""(self,start,end):
	#SequenceableCollection>>#from:to:
	def __blk1__():
		return smalltalk.Number(1) 
	def __blk2__():
		return smalltalk.Number(-1) 
	return self.from_to_by_(start,end,smalltalk.if_true_false_(start._lt_eq(end),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","SequenceableCollection_from_to_")
,"iterating","""from: start to: end
	" Return an iterable on the receiver's contents from start to end. "

	^self	from: start to: end
		by: (start <= end ifTrue: [1] ifFalse: [-1]) """,nil)
smalltalk.bind(smalltalk.SequenceableCollection,"asActionSequence",0
,smalltalk.__f__("""(self):
	#SequenceableCollection>>#asActionSequence
	return smalltalk.ActionSequence.withAll_(self) 
""","SequenceableCollection_asActionSequence")
,"converting","""asActionSequence
	" Return an ActionSequence from the receiver. "

	^ActionSequence withAll: self""",nil)
smalltalk.bind(smalltalk.String.__class__,"fromString:",0
,smalltalk.__f__("""(self,aString):
	#String class>>#fromString:
	if isinstance(aString,self):
		return aString
	else:
		return self(aString)
	 
	return self 
""","String_class_fromString_")
,"instantiation","""fromString: aString
	" Return an instance of the receiver. "

	{''js'return new self.$fn(aString)'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"new",0
,smalltalk.__f__("""(self):
	#String class>>#new
	return self("") 
""","String_class_new")
,"instantiation","""new
	" Return an instance of the receiver. "

	^{''js'""'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"cr",0
,smalltalk.__f__("""(self):
	#String class>>#cr
	return self(chr(13)) 
""","String_class_cr")
,"constants","""cr
	" Return the singular instance. "

	^{''js'"\\r"'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"lf",0
,smalltalk.__f__("""(self):
	#String class>>#lf
	return self(chr(10)) 
""","String_class_lf")
,"constants","""lf
	" Return the singular instance. "

	^{''js'"\\n"'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"crlf",0
,smalltalk.__f__("""(self):
	#String class>>#crlf
	return self(chr(13)+chr(10)) 
""","String_class_crlf")
,"constants","""crlf
	" Return the singular instance. "

	^{''js'"\\r\\n"'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"space",0
,smalltalk.__f__("""(self):
	#String class>>#space
	return self(" ") 
""","String_class_space")
,"constants","""space
	" Return the singular instance. "

	^{''js'" "'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"tab",0
,smalltalk.__f__("""(self):
	#String class>>#tab
	return self("\\t") 
""","String_class_tab")
,"constants","""tab
	" Return the singular instance. "

	^{''js'"\\t"'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"zero",0
,smalltalk.__f__("""(self):
	#String class>>#zero
	return self(chr(0)) 
""","String_class_zero")
,"constants","""zero
	" Return the singular instance. "

	^{''js'"\\0"'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"with:",0
,smalltalk.__f__("""(self,aCharacter):
	#String class>>#with:
	return aCharacter 
""","String_class_with_")
,"instantiation","""with: aCharacter
	" Return an instance of the receiver. "

	^aCharacter""",nil)
smalltalk.bind(smalltalk.String.__class__,"with:with:",0
,smalltalk.__f__("""(self,aCharacter,bCharacter):
	#String class>>#with:with:
	return smalltalk.object_comma_(aCharacter,bCharacter) 
""","String_class_with_with_")
,"instantiation","""with: aCharacter with: bCharacter
	" Return an instance of the receiver. "

	^aCharacter , bCharacter""",nil)
smalltalk.bind(smalltalk.String.__class__,"with:with:with:",0
,smalltalk.__f__("""(self,aCharacter,bCharacter,cCharacter):
	#String class>>#with:with:with:
	return smalltalk.object_comma_(smalltalk.object_comma_(aCharacter,bCharacter),cCharacter) 
""","String_class_with_with_with_")
,"instantiation","""with: aCharacter with: bCharacter with: cCharacter
	" Return an instance of the receiver. "

	^aCharacter , bCharacter , cCharacter""",nil)
smalltalk.bind(smalltalk.String.__class__,"with:with:with:with:",0
,smalltalk.__f__("""(self,aCharacter,bCharacter,cCharacter,dCharacter):
	#String class>>#with:with:with:with:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(aCharacter,bCharacter),cCharacter),dCharacter) 
""","String_class_with_with_with_with_")
,"instantiation","""with: aCharacter with: bCharacter
	with: cCharacter with: dCharacter
	" Return an instance of the receiver. "

	^aCharacter , bCharacter , cCharacter , dCharacter""",nil)
smalltalk.bind(smalltalk.String.__class__,"fromCharCode:",0
,smalltalk.__f__("""(self,anArrayOrNumber):
	#String class>>#fromCharCode:
	return self(chr(smalltalk.handleOf(anArrayOrNumber))) 
	return self 
""","String_class_fromCharCode_")
,"instantiation","""fromCharCode: anArrayOrNumber
	" Return an instance of the receiver. "

	{''js'
	if (anArrayOrNumber.isNumber()) return String.fromCharCode(anArrayOrNumber);
	return String.fromCharCode.apply(null,anArrayOrNumber.asArray());'}""",nil)
smalltalk.bind(smalltalk.String.__class__,"doItSelector",0
,smalltalk.__f__("""(self):
	#String class>>#doItSelector
	return smalltalk.String("s8DoIt") 
""","String_class_doItSelector")
,"constants","""doItSelector
	" Return the selector to use for doIt evaluations.
	Warning: this selector will not be dump on image nor change log expressions.
	"

	^#s8DoIt""",nil)
smalltalk.bind(smalltalk.String.__class__,"nativeFileExtension",0
,smalltalk.__f__("""(self):
	#String class>>#nativeFileExtension
	return smalltalk.to_String(self.nativeLanguage()) 
""","String_class_nativeFileExtension")
,"fileNames","""nativeFileExtension
	" Return the file extension to use for files with native code. "

	^self nativeLanguage toString""",nil)
smalltalk.bind(smalltalk.String.__class__,"sourceFileExtension",0
,smalltalk.__f__("""(self):
	#String class>>#sourceFileExtension
	return smalltalk.String("st") 
""","String_class_sourceFileExtension")
,"fileNames","""sourceFileExtension
	" Return the file extension to use for source files. "

	^#st """,nil)
smalltalk.bind(smalltalk.String.__class__,"nativeLibraryExtension",0
,smalltalk.__f__("""(self):
	#String class>>#nativeLibraryExtension
	return smalltalk.object_comma_(smalltalk.object_comma_(self.sourceFileExtension(),smalltalk.String(".")),self.nativeFileExtension()) 
""","String_class_nativeLibraryExtension")
,"fileNames","""nativeLibraryExtension
	" Return the file extension to use for native library files. "

	^self sourceFileExtension ,$. ,self nativeFileExtension """,nil)
smalltalk.bind(smalltalk.String.__class__,"reservedArray",0
,smalltalk.__f__('''(self):
	#String class>>#reservedArray
	return smalltalk.String("""abstract as boolean break byte case catch char class
		continue const debugger default delete do double else
		enum export extends false final finally float for function
		goto if implements import in instanceof int interface is
		long namespace native new null package private
		protected public return short static super switch
		synchronized this throw throws transient true try typeof
		use var void volatile while with""").asArrayOfSubstrings() 
''',"String_class_reservedArray")
,"js","""reservedArray
	" Private - Return the reserved names of native language. "

	^'abstract as boolean break byte case catch char class
	continue const debugger default delete do double else
	enum export extends false final finally float for function
	goto if implements import in instanceof int interface is
	long namespace native new null package private
	protected public return short static super switch
	synchronized this throw throws transient true try typeof
	use var void volatile while with' asArrayOfSubstrings""",nil)
smalltalk.bind(smalltalk.String.__class__,"reservedWords",0
,smalltalk.__f__("""(self):
	#String class>>#reservedWords
	def __blk1__():
		return smalltalk.HashedSet.withAll_(self.reservedArray()) 
	return self.basicAt_ifAbsentPut_(smalltalk.String("$reservedSet"),smalltalk.blk(__blk1__,0)) 
""","String_class_reservedWords")
,"js","""reservedWords
	" Private - Return the reserved names of native language. "

	^self basicAt: '$reservedSet' ifAbsentPut: [
		HashedSet withAll: self reservedArray
	]""",nil)
smalltalk.bind(smalltalk.String.__class__,"streamClass",0
,smalltalk.__f__("""(self):
	#String class>>#streamClass
	return smalltalk.StringStream 
""","String_class_streamClass")
,"streams","""streamClass
	" Return the streamming support for the receiver's instances. "

	^StringStream""",nil)
smalltalk.bind(smalltalk.String.__class__,"@","_at"
,smalltalk.__f__("""(self,aHandle):
	#String class>>#@
	def __blk1__():
		return self.toString_(aHandle) 
	return smalltalk.if_true_false_(smalltalk.notNil_(aHandle),smalltalk.blk(__blk1__,0),nil) 
""","String_class__at")
,"Natives-converting","""@ aHandle
	" Return an instance of the receiver from aHandle. "

	^aHandle notNil ifTrue: [ self toString: aHandle ]""",nil)
smalltalk.bind(smalltalk.String.__class__,"pythonCommentStart",0
,smalltalk.__f__("""(self):
	#String class>>#pythonCommentStart
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),smalltalk.String('"')),smalltalk.String('"')) 
""","String_class_pythonCommentStart")
,"Python-py","""pythonCommentStart
	" Private - Return the (multiline) comment start sequence. "

	^$" ,$" ,$\"""",nil)
smalltalk.bind(smalltalk.String.__class__,"pythonCommentEnd",0
,smalltalk.__f__("""(self):
	#String class>>#pythonCommentEnd
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),smalltalk.String('"')),smalltalk.String('"')) 
""","String_class_pythonCommentEnd")
,"Python-py","""pythonCommentEnd
	" Private - Return the (multiline) comment end sequence. "

	^$" ,$" ,$\"""",nil)
smalltalk.bind(smalltalk.String.__class__,"reservedPythonWords",0
,smalltalk.__f__("""(self):
	#String class>>#reservedPythonWords
	return smalltalk.newArray(["False","None","True","and","as","assert","async","await","break","class","continue","def","del","elif","else","except","finally","for","from","global","if","import","in","is","lambda","nonlocal","not","or","pass","raise","return","try","while","with","yield","__peg_parser__"]) 
""","String_class_reservedPythonWords")
,"Python-py","""reservedPythonWords
	" Private - Return the reserved names of Python language. "

	^#(
	False	None	True
	and	as	assert	async
	await	break	class	continue
	def	del	elif	else
	except	finally	for	from
	global	if	import	in
	is	lambda	nonlocal	not
	or	pass	raise	return
	try	while	with	yield
	__peg_parser__
	)""",nil)
smalltalk.bind(smalltalk.String.__class__,"forbiddenPythonSelectors",0
,smalltalk.__f__("""(self):
	#String class>>#forbiddenPythonSelectors
	return smalltalk.newArray([]) 
""","String_class_forbiddenPythonSelectors")
,"Python-py","""forbiddenPythonSelectors
	" Private - Return the platform forbidden selectors. "

	^#( "class new" )""",nil)
smalltalk.bind(smalltalk.String.__class__,"basicNew",0
,smalltalk.__f__("""(self):
	#String class>>#basicNew
	if True: return self("") 
	return smalltalk.superReceiver(smalltalk.String.__class__,self).basicNew() 
""","String_class_basicNew")
,"Python-instantiation","""basicNew
	" Return an instance of the receiver. "

	{'self'
	py'if True: return self("")'}.
	^super basicNew""",nil)
smalltalk.bind(smalltalk.String.__class__,"basicNewXXX:",0
,smalltalk.__f__("""(self,size):
	#String class>>#basicNewXXX:
	if True: return self(" " * size.asParameter()) 
	return smalltalk.superReceiver(smalltalk.String.__class__,self).basicNew_(size) 
""","String_class_basicNewXXX_")
,"Python-instantiation","""basicNewXXX: size
	" Return an instance of the receiver of specified size. "

	{'self'
	py'if True: return self(" " * size.asParameter())'}.
	^super basicNew: size""",nil)
smalltalk.bind(smalltalk.String,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#String>>#=
	if True:
		return smalltalk.b_(smalltalk.handleOf(anObject) == smalltalk.handleOf(self))
	 
	return self 
""","String__eq")
,"comparing","""= anObject
    " Return true if the receiver is equal to argument. "

	{''js'
	if (nil.isNil_(anObject)) return false;
	if (!(anObject.isString)) return false;
	if (!(anObject.isString())) return false;
	if (self == anObject) return true;
	return ((""+self) == (""+anObject))'}""",nil)
smalltalk.bind(smalltalk.String,"size",0
,smalltalk.__f__("""(self):
	#String>>#size
	return smalltalk.Number(len(smalltalk.handleOf(self))) 
""","String_size")
,"accessing","""size
	" Return the size of the receiver. "

	^{''js'self.length'}""",nil)
smalltalk.bind(smalltalk.String,"at:",0
,smalltalk.__f__("""(self,anIndex):
	#String>>#at:
	return self.__class__(smalltalk.handleOf(self)[smalltalk.handleOf(anIndex) - 1]) 
""","String_at_")
,"accessing","""at: anIndex
	" Return the receiver at anIndex. "

	^{''js'self.charAt(anIndex - 1)'}""",nil)
smalltalk.bind(smalltalk.String,"at:put:",0
,smalltalk.__f__("""(self,anIndex,anObject):
	#String>>#at:put:
	return self.errorReadOnly_(smalltalk.String("at:put:")) 
""","String_at_put_")
,"accessing","""at: anIndex put: anObject
	" Set the receiver at anIndex. "

	^self errorReadOnly: #at:put:""",nil)
smalltalk.bind(smalltalk.String,"at:ifAbsent:",0
,smalltalk.__f__("""(self,anIndex,aBlock):
	#String>>#at:ifAbsent:
	return smalltalk.if_nil_notNil_(self.at_(anIndex),aBlock,nil) 
""","String_at_ifAbsent_")
,"accessing","""at: anIndex ifAbsent: aBlock
	" Return the receiver at anIndex position or the result of evaluating aBlock. "

	^(self at: anIndex) ifNil: aBlock""",nil)
smalltalk.bind(smalltalk.String,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#do:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return aBlock.value_(self.at_(i)) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for c in smalltalk.handleOf(self):
		aBlock(self.__class__(c))
	 
	return self 
""","String_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=0;i<self.length;i++){fn(self.charAt(i));}'
s8'	1 to: self size do: [:i|
		aBlock value: (self at: i)
	]'}""",nil)
smalltalk.bind(smalltalk.String,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#detect:ifNone:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,each) 
			return smalltalk.if_true_false_(aBlock.value_(each),smalltalk.blk(__blk2__,0),nil) 
		__0__.fn=nil
		__0__.fn=self.callableOf_(aBlock) 
		for c in smalltalk.handleOf(self):
			each = self.__class__(c)
			if smalltalk.b(smalltalk.handleOf(aBlock(each))):
				return each
			
		return smalltalk.handleOf(anotherBlock)() 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i = 0; i < self.length; i++)
		if(fn(self.charAt(i))) return self.charAt(i);
	return anotherBlock.value()'
s8'	self do: [:each|
		(aBlock value: each) ifTrue: [ ^each ]
	].
	^anotherBlock value'}""",nil)
smalltalk.bind(smalltalk.String,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#String>>#includes:
	try:
		return smalltalk.b_(smalltalk.handleOf(anObject) in smalltalk.handleOf(self))
	except TypeError:
		pass
	 
	return self.indexOf_(anObject)._gt(smalltalk.Number(0)) 
""","String_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	{'self'}. "macro hook"
	^(self indexOf: anObject) > 0""",nil)
smalltalk.bind(smalltalk.String,"withIndexDo:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#withIndexDo:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return aBlock.value_value_(self.at_(i),i) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for i in range(smalltalk.handleOf(self.size())):
		aBlock(smalltalk.handleOf(self)[i],smalltalk.Number(i+1))
	 
	return self 
""","String_withIndexDo_")
,"enumerating","""withIndexDo: aBlock
	" Evaluate aBlock with all the index positions in the receiver. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=0;i<self.length;i++){fn(self.charAt(i), i+1);}'
s8'	1 to: self size do: [:i|
		aBlock value: (self at: i) value: i
	]'}""",nil)
smalltalk.bind(smalltalk.String,"copyWithout:",0
,smalltalk.__f__("""(self,anObject):
	#String>>#copyWithout:
	return self.replace_with_(anObject,smalltalk.String("")) 
""","String_copyWithout_")
,"copying","""copyWithout: anObject
	" Return a copy of the receiver excluding anObject, if any. "

	^self replace: anObject with: ''""",nil)
smalltalk.bind(smalltalk.String,"asSymbol",0
,smalltalk.__f__("""(self):
	#String>>#asSymbol
	return self 
""","String_asSymbol")
,"conversion","""asSymbol
	" Return a symbol with the same characters as the receiver. "

	^self "we do not discriminate singular strings\"""",nil)
smalltalk.bind(smalltalk.String,"argumentCount",0
,smalltalk.__f__('''(self):
	#String>>#argumentCount
	if smalltalk.b(self.isEmpty()):
		return smalltalk.Number(0) 
	 
	if smalltalk.b(smalltalk.String("""|&\\\\\\\\+*/=><,@%~-""").includes_(self.first())):
		return smalltalk.Number(1) 
	 
	return self.occurrencesOf_(smalltalk.String(":")) 
''',"String_argumentCount")
,"evaluating","""argumentCount
	" Return the number of arguments of the receiver. "

	self isEmpty ifTrue: [ ^0 ].
	('|&\\\\+*/=><,@%~-' includes: self first) ifTrue: [ ^1 ].
	^self occurrencesOf: $:""",nil)
smalltalk.bind(smalltalk.String,"isLiteral",0
,smalltalk.__f__("""(self):
	#String>>#isLiteral
	def __blk1__():
		return smalltalk.isNil_(smalltalk.RegularExpression.fromString_(smalltalk.String("[^a-zA-Z0-9_:]")).exec_(self)) 
	if True: return smalltalk.string_isLiteral_(self) 
	return smalltalk.boolean_and_(self.notEmpty(),smalltalk.blk(__blk1__,0)) 
""","String_isLiteral")
,"testing","""isLiteral
	" Return true if the receiver can be output using literal notation. "

	{''js'self'}.
	^self notEmpty and: [
		((RegularExpression fromString: '[^a-zA-Z0-9_:]') exec: self) isNil
	]""",nil)
smalltalk.bind(smalltalk.String,"asLiteral",0
,smalltalk.__f__("""(self):
	#String>>#asLiteral
	def __blk1__():
		return smalltalk.object_comma_(smalltalk.String("#"),self) 
	def __blk2__():
		return smalltalk.printString_(self) 
	return smalltalk.if_true_false_(self.isLiteral(),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","String_asLiteral")
,"converting","""asLiteral
	" Return the receiver in literal notation. "

	^self isLiteral ifTrue: [ $# ,self ] ifFalse: [ self printString ]""",nil)
smalltalk.bind(smalltalk.String,"occurrencesOf:",0
,smalltalk.__f__("""(self,aString):
	#String>>#occurrencesOf:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.index=self.indexOf_startingAt_(aString,__0__.index._plus(smalltalk.Number(1))) 
		return __0__.index._gt(smalltalk.Number(1)) 
	__0__.result=nil
	__0__.index=nil
	if True: return smalltalk.string_occurrencesOf_(self,aString) 
	if not smalltalk.b(aString.isString()):
		__0__.result=self.match(aString) 
		if smalltalk.b(smalltalk.isNil_(__0__.result)):
			return smalltalk.Number(0) 
		 
		return smalltalk.asObject_(__0__.result.length) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(aString.size(),smalltalk.Number(1))):
		__0__.result=self.match(smalltalk.RegularExpression.fromString_flag_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),aString),smalltalk.String("]")),smalltalk.String("g"))) 
		if smalltalk.b(smalltalk.isNil_(__0__.result)):
			return smalltalk.Number(0) 
		 
		return smalltalk.asObject_(__0__.result.length) 
	 
	__0__.result=smalltalk.Number(0) 
	__0__.index=smalltalk.Number(0) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__0__.result=__0__.result._plus(smalltalk.Number(1)) 
	 
	return __0__.result 
""","String_occurrencesOf_")
,"testing","""occurrencesOf: aString
	" Return the times aString can be found in the receiver. "

	| result index |
	{''js'self'}.
	aString isString ifFalse: [
		result := self #match: aString.
		result isNil ifTrue: [ ^0 ].
		^result#length
	].
	aString size = 1 ifTrue: [
		result := self #match: (RegularExpression
				fromString: '[',aString,']'
				flag: 'g').
		result isNil ifTrue: [ ^0 ].
		^result#length
	].
	result := 0. index := 0.
	[	index := self indexOf: aString startingAt: index + 1.
		index > 1 ] whileTrue: [ result := result + 1 ].
	^result""",nil)
smalltalk.bind(smalltalk.String,"startsWith:",0
,smalltalk.__f__("""(self,aString):
	#String>>#startsWith:
	if True: return smalltalk.string_startsWith_(self,aString) 
	return self.beginsWith_(aString) 
""","String_startsWith_")
,"testing","""startsWith: aString
	" Return true if the receiver begins with the characters of aString. "

	{''js'if (self.startsWith) { return self.startsWith(aString) }'}.
	^self beginsWith: aString""",nil)
smalltalk.bind(smalltalk.String,"escaped",0
,smalltalk.__f__("""(self):
	#String>>#escaped
	if True:
		try:
			from urllib import quote
		except ImportError:
			from urllib.parse import quote
		return smalltalk.String(quote(smalltalk.handleOf(self)))
	 
	return self 
""","String_escaped")
,"converting","""escaped
	" Return the receiver with escape codes. "

	{''js'return escape(self)'}""",nil)
smalltalk.bind(smalltalk.String,"unescaped",0
,smalltalk.__f__("""(self):
	#String>>#unescaped
	if True:
		try:
			from urllib import unquote
		except ImportError:
			from urllib.parse import unquote
		return smalltalk.String(unquote(smalltalk.handleOf(self)))
	 
	return self 
""","String_unescaped")
,"converting","""unescaped
	" Return the receiver from encoded URI escape codes. "

	{''js'return unescape(self)'}""",nil)
smalltalk.bind(smalltalk.String,"escapedCode",0
,smalltalk.__f__("""(self):
	#String>>#escapedCode
	__0__=smalltalk.newContext()
	__0__.escaped=nil
	__0__.escaped=self.escaped() 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.escaped,self)):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),__0__.escaped),smalltalk.String('"')) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('unescape("'),__0__.escaped),smalltalk.String('")')) 
""","String_escapedCode")
,"converting","""escapedCode
	" Return the code to reproduce receiver from code. "

	| escaped |
	escaped := self escaped.
	escaped = self ifTrue: [ ^$" ,escaped ,$" ].
	^'unescape("' ,escaped ,'")'""",nil)
smalltalk.bind(smalltalk.String,"asEncodedURI",0
,smalltalk.__f__("""(self):
	#String>>#asEncodedURI
	if True: return self.notImplementedYet_(smalltalk.String("asEncodedURI")) 
	return self 
""","String_asEncodedURI")
,"converting","""asEncodedURI
	" Return the receiver encoded as an URI component.
	Encodes special characters and it encodes the following characters: , / ? : @ & = + $ #
	"

	{''js'return encodeURIComponent(self)'}""",nil)
smalltalk.bind(smalltalk.String,"asDecodedURI",0
,smalltalk.__f__("""(self):
	#String>>#asDecodedURI
	if True: return self.notImplementedYet_(smalltalk.String("asDecodedURI")) 
	return self 
""","String_asDecodedURI")
,"converting","""asDecodedURI
	" Return the receiver decoded as an URI component. "

	{''js'return decodeURIComponent(self)'}""",nil)
smalltalk.bind(smalltalk.String,"add:",0
,smalltalk.__f__("""(self,anObject):
	#String>>#add:
	return self.errorReadOnly_(smalltalk.String("add:")) 
""","String_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	^self errorReadOnly: #add:""",nil)
smalltalk.bind(smalltalk.String,"-->","_minus_minus_gt"
,smalltalk.__f__("""(self,anObject):
	#String>>#-->
	return smalltalk.Association.key_value_(self.asArrayOfSubstringsSeparatedBy_(smalltalk.String(".")),anObject) 
""","String__minus_minus_gt")
,"converting","""--> anObject
	" Return a far-association of the receiver to anObject. "

	^Association key: (self asArrayOfSubstringsSeparatedBy: $.) value: anObject""",nil)
smalltalk.bind(smalltalk.String,",","_comma"
,smalltalk.__f__("""(self,aCollection):
	#String>>#,
	if True:
		return self.__class__(smalltalk.handleOf(self)+str(smalltalk.handleOf(aCollection)))
	 
	return self 
""","String__comma")
,"copying",""", aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	{''js'
	if (nil.isNil_(aCollection)) return self+""; // we need this ugly patch for JSC under iOS
	return self + aCollection.toString()'}""",nil)
smalltalk.bind(smalltalk.String,"copyWith:",0
,smalltalk.__f__("""(self,anObject):
	#String>>#copyWith:
	return self.__class__(smalltalk.handleOf(self)+smalltalk.handleOf(anObject)) 
""","String_copyWith_")
,"copying","""copyWith: anObject
	" Return a copy of the receiver with anObject. "

	^{''js'self + anObject.toString()'}""",nil)
smalltalk.bind(smalltalk.String,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#String>>#copyFrom:to:
	return self.__class__(smalltalk.handleOf(self)[smalltalk.handleOf(anIndex) - 1:smalltalk.handleOf(anotherIndex)]) 
""","String_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return the receiver between limits. "

	^{''js'self.substring(anIndex - 1,anotherIndex)'}""",nil)
smalltalk.bind(smalltalk.String,"shallowCopy",0
,smalltalk.__f__("""(self):
	#String>>#shallowCopy
	return self 
""","String_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.String,"deepCopy",0
,smalltalk.__f__("""(self):
	#String>>#deepCopy
	return self 
""","String_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.String,"reversed",0
,smalltalk.__f__("""(self):
	#String>>#reversed
	__0__=smalltalk.newContext()
	def __blk1__(c):
		__0__.result=smalltalk.object_comma_(__0__.result,c)
		return __0__.result 
	__0__.result=nil
	if True:
		return smalltalk.String(smalltalk.handleOf(self)[::-1])
	 
	__0__.result=smalltalk.String("") 
	self.reverseDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","String_reversed")
,"copying","""reversed
	" Return a string with the contents of the receiver in reverse order. "

	| result |
	{''js'self'}.
	result := ''.
	self reverseDo: [:c| result := result , c ].
	^result""",nil)
smalltalk.bind(smalltalk.String,"indexOf:",0
,smalltalk.__f__("""(self,aString):
	#String>>#indexOf:
	try:
		return smalltalk.Number(smalltalk.handleOf(self).find(smalltalk.handleOf(aString))+ 1)
	except TypeError:
		return smalltalk.Number(0)
	return smalltalk.Number(0) 
	return self 
""","String_indexOf_")
,"accessing","""indexOf: aString
	" Return the position of first occurrence of aString (or 0 if not present). "

	{''js'return self.indexOf(aString) + 1'}""",nil)
smalltalk.bind(smalltalk.String,"indexOf:ifAbsent:",0
,smalltalk.__f__("""(self,aString,aBlock):
	#String>>#indexOf:ifAbsent:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result 
	__0__.result=nil
	__0__.result=self.indexOf_(aString) 
	return smalltalk.isObject_equalTo_(__0__.result,smalltalk.Number(0)).ifTrue_ifFalse_(aBlock,smalltalk.blk(__blk1__,0)) 
""","String_indexOf_ifAbsent_")
,"accessing","""indexOf: aString ifAbsent: aBlock
	" Return the position of first occurrence of aString (or the result of evaluating aBlock). "

	| result |
	result := self indexOf: aString.
	^result = 0 ifTrue: aBlock ifFalse: [ result ]""",nil)
smalltalk.bind(smalltalk.String,"indexOf:startingAt:",0
,smalltalk.__f__("""(self,aString,position):
	#String>>#indexOf:startingAt:
	try:
		return smalltalk.Number(smalltalk.handleOf(self).find(smalltalk.handleOf(aString),smalltalk.handleOf(position) - 1)+ 1)
	except TypeError:
		return smalltalk.Number(0)
	return smalltalk.Number(0) 
	return self 
""","String_indexOf_startingAt_")
,"accessing","""indexOf: aString startingAt: position
	" Return the position of first occurrence of aString after position (or 0 if not present). "

	{''js'return self.indexOf(aString,position-1) + 1'}""",nil)
smalltalk.bind(smalltalk.String,"lastIndexOf:",0
,smalltalk.__f__("""(self,aString):
	#String>>#lastIndexOf:
	offset = smalltalk.handleOf(self).rfind(smalltalk.handleOf(aString))
	if True:
		return smalltalk.Number(offset + 1)
	 
	return self 
""","String_lastIndexOf_")
,"accessing","""lastIndexOf: aString
	" Return the position of last occurrence of aString (or 0 if not present). "

	{''js'return self.lastIndexOf(aString) + 1'}""",nil)
smalltalk.bind(smalltalk.String,"lastIndexOf:ifAbsent:",0
,smalltalk.__f__("""(self,aString,aBlock):
	#String>>#lastIndexOf:ifAbsent:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result 
	__0__.result=nil
	__0__.result=self.lastIndexOf_(aString) 
	return smalltalk.isObject_equalTo_(__0__.result,smalltalk.Number(0)).ifTrue_ifFalse_(aBlock,smalltalk.blk(__blk1__,0)) 
""","String_lastIndexOf_ifAbsent_")
,"accessing","""lastIndexOf: aString ifAbsent: aBlock
	" Return the position of last occurrence of aString (or the result of evaluating aBlock). "

	| result |
	result := self lastIndexOf: aString.
	^result = 0 ifTrue: aBlock ifFalse: [ result ]""",nil)
smalltalk.bind(smalltalk.String,"lastIndexOf:startingAt:",0
,smalltalk.__f__("""(self,aString,position):
	#String>>#lastIndexOf:startingAt:
	offset = smalltalk.handleOf(self).rfind(smalltalk.handleOf(aString),smalltalk.handleOf(position) - 1)
	if True:
		return smalltalk.Number(offset + 1)
	 
	return self 
""","String_lastIndexOf_startingAt_")
,"accessing","""lastIndexOf: aString startingAt: position
	" Return the position of last occurrence of aString before position (or 0 if not present). "

	{''js'return self.lastIndexOf(aString,position-1) + 1'}""",nil)
smalltalk.bind(smalltalk.String,"upTo:startingAt:",0
,smalltalk.__f__("""(self,aString,position):
	#String>>#upTo:startingAt:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.size() 
	def __blk2__():
		return __0__.index._minus(smalltalk.Number(1)) 
	__0__.index=nil
	__0__.index=self.indexOf_startingAt_(aString,position) 
	__0__.index=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.index,smalltalk.Number(0)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return self.copyFrom_to_(position,__0__.index) 
""","String_upTo_startingAt_")
,"accessing","""upTo: aString startingAt: position
	" Return the receiver upto first occurrence of aString after position. "

	| index |
	index := self indexOf: aString startingAt: position.
	index := index = 0 ifTrue: [ self size ] ifFalse: [ index - 1 ].
	^self copyFrom: position to: index""",nil)
smalltalk.bind(smalltalk.String,"upTo:",0
,smalltalk.__f__("""(self,aCharacter):
	#String>>#upTo:
	return self.upTo_startingAt_(aCharacter,smalltalk.Number(1)) 
""","String_upTo_")
,"accessing","""upTo: aCharacter
	" Return the receiver upto first occurrence of aCharacter. "

	^self upTo: aCharacter startingAt: 1""",nil)
smalltalk.bind(smalltalk.String,"upToLast:",0
,smalltalk.__f__("""(self,aString):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#upToLast:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self) 
		__0__.index=nil
		__0__.index=self.lastIndexOf_ifAbsent_(aString,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,self.copyFrom_to_(smalltalk.Number(1),__0__.index._minus(smalltalk.Number(1)))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_upToLast_")
,"accessing","""upToLast: aString
	" Return the receiver upto last occurrence of aString. "

	| index |
	index := self lastIndexOf: aString ifAbsent: [ ^self ].
	^self copyFrom: 1 to: index - 1""",nil)
smalltalk.bind(smalltalk.String,"fromLast:",0
,smalltalk.__f__("""(self,aString):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#fromLast:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self) 
		__0__.index=nil
		__0__.index=self.lastIndexOf_ifAbsent_(aString,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,self.copyFrom_to_(__0__.index._plus(aString.size()),self.size())) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_fromLast_")
,"accessing","""fromLast: aString
	" Return the receiver contents from last occurrence of aString. "

	| index |
	index := self lastIndexOf: aString ifAbsent: [ ^self ].
	^self copyFrom: index + aString size to: self size""",nil)
smalltalk.bind(smalltalk.String,"asJsName",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#asJsName
		if smalltalk.b(smalltalk.String.reservedWords().includes_(self)):
			def __blk1__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(smalltalk.String("$$"),self)) 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(self,smalltalk.String("toString")),nil,smalltalk.blk(__blk1__,0)) 
		 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_asJsName")
,"js","""asJsName
	" Private - Return the receiver as a valid native name. "

	(String reservedWords includes: self) ifTrue: [
		self = #toString ifFalse: [ ^'$$' ,self ]
	].
	^self""",nil)
smalltalk.bind(smalltalk.String,"asNativeName",0
,smalltalk.__f__("""(self):
	#String>>#asNativeName
	return self.asPythonName() 
""","String_asNativeName")
,"js","""asNativeName
	" Return the receiver as a valid native name. "

	^{''js'self.asJsName()'}""",nil)
smalltalk.bind(smalltalk.String,"asPrivateSelector",0
,smalltalk.__f__("""(self):
	#String>>#asPrivateSelector
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result = smalltalk.string_asPrivateSelector_(self) 
	return __0__.result 
""","String_asPrivateSelector")
,"converting","""asPrivateSelector
	" Private - Return the receiver as an encoded selector. "

	| result |
	{''js'result = self
	.replace(/:/g,"_")
	.replace(/[+]/g,"_plus")
	.replace(/-/g,"_minus")
	.replace(/[*]/g,"_star")
	.replace(/[/]/g,"_slash")
	.replace(/[|]/g,"_bar")
	.replace(/[&]/g,"_amp")
	.replace(/>/g,"_gt")
	.replace(/</g,"_lt")
	.replace(/=/g,"_eq")
	.replace(/,/g,"_comma")
	.replace(/[@]/g,"_at")
	.replace(/~/g,"_no")
	.replace(/\\\\/g,"_bk")'}.
	^result """,nil)
smalltalk.bind(smalltalk.String,"asSelector",0
,smalltalk.__f__("""(self):
	#String>>#asSelector
	if smalltalk.b(self.startsWith_(smalltalk.String("#"))):
		return self.upTo_startingAt_(smalltalk.String(":"),smalltalk.Number(2)) 
	 
	return self.asPrivateSelector().asNativeName() 
""","String_asSelector")
,"converting","""asSelector
	" Private - Return the receiver as a valid native selector. "

	(self startsWith: $#) ifTrue: [
		^self upTo: $: startingAt: 2
	].
	^self asPrivateSelector asNativeName """,nil)
smalltalk.bind(smalltalk.String,"asStSelector",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#asStSelector
		__0__=smalltalk.newContext()
		def __blk1__(tuple):
			def __blk2__():
				def __blk3__(result,each):
					return result.replace_with_(each.last(),each.first()) 
				return smalltalk.raise_result_(_s8Ret_,__0__.operations.reversed().inject_into_(self,smalltalk.blk(__blk3__,2))) 
			return smalltalk.if_true_false_(self.startsWith_(tuple.last()),smalltalk.blk(__blk2__,0),nil) 
		__0__.operations=nil
		if smalltalk.b(smalltalk.isObject_equalTo_(self,smalltalk.String("$"))):
			smalltalk.raise_result_(_s8Ret_,smalltalk.String("")) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(self,smalltalk.String("_bk"))):
			smalltalk.raise_result_(_s8Ret_,smalltalk.asCharacter_(smalltalk.Number(92))) 
		 
		if smalltalk.b(self.startsWith_(smalltalk.String("$$"))):
			smalltalk.raise_result_(_s8Ret_,self.copyFrom_to_(smalltalk.Number(3),self.size()).asStSelector()) 
		 
		__0__.operations=smalltalk.newArray([["+","_plus"],["-","_minus"],["*","_star"],["/","_slash"],["|","_bar"],["&","_amp"],[">","_gt"],["<","_lt"],["=","_eq"],[",","_comma"],["@","_at"],["~","_no"]]) 
		__0__.operations.add_(smalltalk.Array.with_with_(smalltalk.asCharacter_(smalltalk.Number(92)),smalltalk.String("_bk"))) 
		__0__.operations.do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,self.replace_with_(smalltalk.String("_"),smalltalk.String(":"))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_asStSelector")
,"converting","""asStSelector
	" Return a smalltalk selector from a native function name.
	Note: it must be the reverse operation of #asSelector
	"

	| operations |
	self = '$' ifTrue: [ ^'' ].
	self = #_bk ifTrue: [ ^92 asCharacter ].
	(self startsWith: '$$') ifTrue: [ ^(self copyFrom: 3 to: self size) asStSelector ].
	operations := #(
		#( + _plus )
		#( - _minus )
		#( * _star )
		#( / _slash )
		#( | _bar )
		#( & _amp )
		#( > _gt )
		#( < _lt )
		#( = _eq )
		#( , _comma )
		#( @ _at )
		#( ~ _no )
	).
	operations add: (Array with: 92 asCharacter with: #_bk).
	operations do: [:tuple|
		(self startsWith: tuple last) ifTrue: [
			^operations reversed inject: self into: [:result :each|
				result replace: each last with: each first
			]
		].
	].
	^self replace: $_ with: $:""",nil)
smalltalk.bind(smalltalk.String,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#String>>#asNative:
	if smalltalk.b(smalltalk.isObject_equalTo_(lang,smalltalk.String("lua"))):
		__1__=smalltalk.newContext()
		__1__.encoded=nil
		__1__.bar=nil
		__1__.bar=smalltalk.asCharacter_(smalltalk.Number(92)) 
		__1__.encoded=self 
		__1__.encoded=__1__.encoded.replace_with_(__1__.bar,smalltalk.object_comma_(__1__.bar,__1__.bar)) 
		__1__.encoded=__1__.encoded.replace_with_(smalltalk.String.lf(),smalltalk.object_comma_(__1__.bar,smalltalk.String("n"))) 
		__1__.encoded=__1__.encoded.replace_with_(smalltalk.String.cr(),smalltalk.object_comma_(__1__.bar,smalltalk.String("r"))) 
		__1__.encoded=__1__.encoded.replace_with_(smalltalk.String.tab(),smalltalk.object_comma_(__1__.bar,smalltalk.String("t"))) 
		__1__.encoded=__1__.encoded.replace_with_(smalltalk.String('"'),smalltalk.object_comma_(__1__.bar,smalltalk.String('"'))) 
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),__1__.encoded),smalltalk.String('"')) 
	 
	if True: return self.asPython() 
	return self 
""","String_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	lang = #lua ifTrue: [ | encoded bar |
		bar := 92 asCharacter.
		encoded := self.
		encoded := encoded replace: bar with: bar ,bar.
		encoded := encoded replace: String lf with: bar ,$n.
		encoded := encoded replace: String cr with: bar ,$r.
		encoded := encoded replace: String tab with: bar ,$t.
		encoded := encoded replace: $" with: bar ,$".
		^$" ,encoded ,$"
	].
	{''js'
	var bar=unescape("%%22");
	if(self.search(/^[a-zA-Z0-9_:.$ ]*$/) == -1)
		return "unescape(" +bar +escape(self) +bar +")";
	else
		return bar +self +bar'}""",nil)
smalltalk.bind(smalltalk.String,"replace:with:",0
,smalltalk.__f__('''(self,aString,anotherString):
	#String>>#replace:with:
	if True: return smalltalk.String(smalltalk.handleOf(self).replace(smalltalk.handleOf(aString),smalltalk.handleOf(anotherString))) 
	if smalltalk.b(smalltalk.b_(aString is smalltalk.String("\\\\"))):
		return self.replace_with_(smalltalk.String("""\\\\\\\\"""),anotherString) 
	 
	return self.replaceRegexp_with_(smalltalk.RegularExpression.fromString_flag_(aString,smalltalk.String("g")),anotherString) 
''',"String_replace_with_")
,"regular expressions","""replace: aString with: anotherString
	" Return the result of replacement of aString with anotherString in the receiver. "

	{''js'self'}.
	aString == $\\ ifTrue: [ ^self replace: '\\\\' with: anotherString ].
	^self
		replaceRegexp: (RegularExpression fromString: aString flag: 'g')
		with: anotherString""",nil)
smalltalk.bind(smalltalk.String,"replaceRegexp:with:",0
,smalltalk.__f__("""(self,aRegexp,aString):
	#String>>#replaceRegexp:with:
	return self.notImplementedYet_(smalltalk.String("String>>#replaceRegexp:with:")) 
""","String_replaceRegexp_with_")
,"regular expressions","""replaceRegexp: aRegexp with: aString
	" Return the result of replacement of aRegexp with aString in the receiver. "

	^{''js'self.replace(aRegexp,aString)'}""",nil)
smalltalk.bind(smalltalk.String,"tokenize:",0
,smalltalk.__f__("""(self,aString):
	#String>>#tokenize:
	result = smalltalk.handleOf(self).split(smalltalk.handleOf(aString))
	return smalltalk.newArray(result) 
	return self 
""","String_tokenize_")
,"converting","""tokenize: aString
	" Return the split tokenization of the receiver. "

	{''js'return self.split(aString)'}""",nil)
smalltalk.bind(smalltalk.String,"asArrayOfSubstrings",0
,smalltalk.__f__("""(self):
	#String>>#asArrayOfSubstrings
	__0__=smalltalk.newContext()
	def __blk1__(c):
		if smalltalk.b(smalltalk.isNil_(__0__.start)):
			def __blk2__():
				__0__.start=__0__.i
				return __0__.start 
			smalltalk.if_true_false_(c.isSeparator(),nil,smalltalk.blk(__blk2__,0)) 
		else:
			def __blk3__():
				__0__.result.add_(self.copyFrom_to_(__0__.start,__0__.i._minus(smalltalk.Number(1)))) 
				__0__.start=nil
				return __0__.start 
			smalltalk.if_true_false_(c.isSeparator(),smalltalk.blk(__blk3__,0),nil) 
		 
		__0__.i=__0__.i._plus(smalltalk.Number(1))
		return __0__.i 
	__0__.result=nil
	__0__.start=nil
	__0__.i=nil
	__0__.result=smalltalk.Array.new() 
	__0__.i=smalltalk.Number(1) 
	self.do_(smalltalk.blk(__blk1__,1)) 
	if smalltalk.b(smalltalk.notNil_(__0__.start)):
		__0__.result.add_(self.copyFrom_to_(__0__.start,self.size())) 
	 
	return __0__.result 
""","String_asArrayOfSubstrings")
,"converting","""asArrayOfSubstrings
	" Return an array of substrings from the receiver.
	The receiver is divided into substrings by one or more occurrences of separators.
	"

	| result start i |
	result := Array new. i := 1.
	self do: [:c|
		start isNil ifTrue: [ "in separator"
			c isSeparator ifFalse: [ "start of substring"
				start := i.
			]
		] ifFalse: [ "in word"
			c isSeparator ifTrue: [ "end of substring"
				result add: (self copyFrom: start to: i - 1).
				start := nil.
			].
		].
		i := i + 1.
	].
	start notNil ifTrue: [
		result add: (self copyFrom: start to: self size)
	].
	^result""",nil)
smalltalk.bind(smalltalk.String,"asArrayOfSubstringsSeparatedBy:",0
,smalltalk.__f__("""(self,aCharacter):
	#String>>#asArrayOfSubstringsSeparatedBy:
	return self.tokenize_(aCharacter) 
""","String_asArrayOfSubstringsSeparatedBy_")
,"converting","""asArrayOfSubstringsSeparatedBy: aCharacter
	" Return an array of substrings from the receiver.
	The receiver is divided into substrings by one or more occurrences of aCharacter.
	"

	^self tokenize: aCharacter""",nil)
smalltalk.bind(smalltalk.String,"match:",0
,smalltalk.__f__("""(self,aRegexp):
	#String>>#match:
	return smalltalk.notNil_(smalltalk.string_match(self,aRegexp)) 
""","String_match_")
,"regular expressions","""match: aRegexp
	" Return the match index of aRegexp in the receiver. "

	^{''js'self.search(aRegexp) != -1'}""",nil)
smalltalk.bind(smalltalk.String,"asString",0
,smalltalk.__f__("""(self):
	#String>>#asString
	return self 
""","String_asString")
,"converting","""asString
	" Return the text representation of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.String,"between:and:",0
,smalltalk.__f__("""(self,min,max):
	#String>>#between:and:
	def __blk1__():
		return self._lt_eq(max) 
	return smalltalk.boolean_and_(min._lt_eq(self),smalltalk.blk(__blk1__,0)) 
""","String_between_and_")
,"testing","""between: min and: max
	" Return true if the receiver is between arguments. "

	^min <= self and: [ self <= max ]""",nil)
smalltalk.bind(smalltalk.String,"isLetter",0
,smalltalk.__f__("""(self):
	#String>>#isLetter
	return smalltalk.true if smalltalk.handleOf(self).isalpha() else smalltalk.false 
""","String_isLetter")
,"testing","""isLetter
	" Return true if the receiver is a one character letter. "

	^{''js'self.search("[A-Za-z]$")==0'}""",nil)
smalltalk.bind(smalltalk.String,"isDigit",0
,smalltalk.__f__("""(self):
	#String>>#isDigit
	return smalltalk.true if smalltalk.handleOf(self).isdigit() else smalltalk.false 
""","String_isDigit")
,"testing","""isDigit
	" Return true if the receiver is one character numeric digit. "

	^{''js'self.search("[0-9]$")==0'}""",nil)
smalltalk.bind(smalltalk.String,"isAlphaNumeric",0
,smalltalk.__f__("""(self):
	#String>>#isAlphaNumeric
	def __blk1__():
		return self.isLetter() 
	if smalltalk.handleOf(self).isalnum():
		return smalltalk.true
	else:
		return smalltalk.false
	 
	return smalltalk.boolean_or_(self.isDigit(),smalltalk.blk(__blk1__,0)) 
""","String_isAlphaNumeric")
,"testing","""isAlphaNumeric
	" Return true if the receiver is an alphanumeric character. "

	{'self'}."macro hook"
	^self isDigit or: [self isLetter]""",nil)
smalltalk.bind(smalltalk.String,"isUppercase",0
,smalltalk.__f__("""(self):
	#String>>#isUppercase
	return self.isUpperCase() 
""","String_isUppercase")
,"testing","""isUppercase
	" Return true if all the receiver characters are uppercase. "

	^self isUpperCase""",nil)
smalltalk.bind(smalltalk.String,"isUpperCase",0
,smalltalk.__f__("""(self):
	#String>>#isUpperCase
	if True:
		return smalltalk.b_(smalltalk.handleOf(self).isupper())
	 
	return smalltalk.booleanNot_(self.match_(smalltalk.String("[^A-Z]"))) 
""","String_isUpperCase")
,"testing","""isUpperCase
	" Return true if all the receiver characters are uppercase. "

	{''js'self'}.
	^(self match: '[^A-Z]') not""",nil)
smalltalk.bind(smalltalk.String,"isLowerCase",0
,smalltalk.__f__("""(self):
	#String>>#isLowerCase
	if True:
		return smalltalk.b_(smalltalk.handleOf(self).islower())
	 
	return smalltalk.booleanNot_(self.match_(smalltalk.String("[^a-z]"))) 
""","String_isLowerCase")
,"testing","""isLowerCase
	" Return true if all the receiver characters are lowercase. "

	{''js'self'}.
	^(self match: '[^a-z]') not""",nil)
smalltalk.bind(smalltalk.String,"isLowercase",0
,smalltalk.__f__("""(self):
	#String>>#isLowercase
	return self.isLowerCase() 
""","String_isLowercase")
,"testing","""isLowercase
	" Return true if the receiver is one character lowercase. "

	^self isLowerCase""",nil)
smalltalk.bind(smalltalk.String,"asUppercase",0
,smalltalk.__f__("""(self):
	#String>>#asUppercase
	return self.__class__(smalltalk.handleOf(self).upper()) 
""","String_asUppercase")
,"converting","""asUppercase
	" Return a copy of the receiver converted to uppercase. "

	^{''js'self.toUpperCase()'}""",nil)
smalltalk.bind(smalltalk.String,"asUpperCase",0
,smalltalk.__f__("""(self):
	#String>>#asUpperCase
	return self.asUppercase() 
""","String_asUpperCase")
,"converting","""asUpperCase
	" Return a copy of the receiver converted to uppercase. "

	^self asUppercase""",nil)
smalltalk.bind(smalltalk.String,"asLowercase",0
,smalltalk.__f__("""(self):
	#String>>#asLowercase
	return self.__class__(smalltalk.handleOf(self).lower()) 
""","String_asLowercase")
,"converting","""asLowercase
	" Return a copy of the receiver converted to lowercase. "

	^{''js'self.toLowerCase()'}""",nil)
smalltalk.bind(smalltalk.String,"asLowerCase",0
,smalltalk.__f__("""(self):
	#String>>#asLowerCase
	return self.asLowercase() 
""","String_asLowerCase")
,"converting","""asLowerCase
	" Return a copy of the receiver converted to lowercase. "

	^self asLowercase""",nil)
smalltalk.bind(smalltalk.String,"asSmalltalkName:",0
,smalltalk.__f__("""(self,upCase):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#asSmalltalkName:
		__0__=smalltalk.newContext()
		def __blk1__():
			def __blk2__(c):
				return c._gt_eq(smalltalk.String("a")) 
			def __blk3__():
				nil 
			return smalltalk.isNil_(self.detect_ifNone_(smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,0))) 
		def __blk4__(s,each):
			def __blk5__():
				__0__.up=smalltalk.true 
				return s 
			def __blk6__():
				def __blk7__():
					__0__.up=smalltalk.false 
					return each.asUppercase() 
				def __blk8__():
					return each 
				return smalltalk.object_comma_(s,smalltalk.if_true_false_(__0__.up,smalltalk.blk(__blk7__,0),smalltalk.blk(__blk8__,0))) 
			return smalltalk.if_true_false_(smalltalk.String("_:.&%$?").includes_(each),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
		__0__.up=nil
		__0__.result=nil
		if smalltalk.b(smalltalk.boolean_and_(smalltalk.booleanNot_(upCase),smalltalk.blk(__blk1__,0))):
			return self.asLowercase().asSmalltalkName_(upCase) 
		 
		__0__.up=upCase 
		__0__.result=self.inject_into_(smalltalk.String(""),smalltalk.blk(__blk4__,2)) 
		if smalltalk.b(__0__.result.isEmpty()):
			return smalltalk.String("_") 
		 
		if smalltalk.b(upCase):
			def __blk9__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(__0__.result.first().asUppercase(),__0__.result.copyFrom_to_(smalltalk.Number(2),__0__.result.size()))) 
			smalltalk.if_true_false_(__0__.result.first().isLowercase(),smalltalk.blk(__blk9__,0),nil) 
		else:
			def __blk10__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(__0__.result.first().asLowercase(),__0__.result.copyFrom_to_(smalltalk.Number(2),__0__.result.size()))) 
			smalltalk.if_true_false_(__0__.result.first().isUppercase(),smalltalk.blk(__blk10__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_asSmalltalkName_")
,"converting","""asSmalltalkName: upCase
	" Return a copy of the receiver converted to a smalltalk global name. "

	| up result |
	(upCase not and: [
		(self detect: [:c| c >= $a ] ifNone: []) isNil
	]) ifTrue: [
		^self asLowercase asSmalltalkName: upCase
	].
	up := upCase.
	result := self inject: '' into: [:s :each|
		('_:.&%$?' includes: each) ifTrue: [ up := true. s ]
		ifFalse: [ s , (up
			ifTrue: [  up := false. each asUppercase ]
			ifFalse: [ each ])
		]
	].
	result isEmpty ifTrue: [ ^$_ ].
	upCase ifTrue: [
		result first isLowercase ifTrue: [
			^result first asUppercase ,(result copyFrom: 2 to: result size)
		]
	] ifFalse: [
		result first isUppercase ifTrue: [
			^result first asLowercase ,(result copyFrom: 2 to: result size)
		]
	].
	^result""",nil)
smalltalk.bind(smalltalk.String,"asGlobalName",0
,smalltalk.__f__("""(self):
	#String>>#asGlobalName
	return self.asSmalltalkName_(smalltalk.true) 
""","String_asGlobalName")
,"converting","""asGlobalName
	" Return a copy of the receiver converted to a smalltalk global name. "

	^self asSmalltalkName: true""",nil)
smalltalk.bind(smalltalk.String,"asLocalName",0
,smalltalk.__f__("""(self):
	#String>>#asLocalName
	return self.asSmalltalkName_(smalltalk.false) 
""","String_asLocalName")
,"converting","""asLocalName
	" Return a copy of the receiver converted to a smalltalk local name. "

	^self asSmalltalkName: false""",nil)
smalltalk.bind(smalltalk.String,"digitValue",0
,smalltalk.__f__("""(self):
	#String>>#digitValue
	return smalltalk.String("0123456789ABCDEF").indexOf_(self)._minus(smalltalk.Number(1)).max_(smalltalk.Number(0)._minus(smalltalk.Number(1))) 
""","String_digitValue")
,"converting","""digitValue
	" Return the digit value of the receiver (or -1). "

	^('0123456789ABCDEF' indexOf: self) - 1 max: 0 - 1""",nil)
smalltalk.bind(smalltalk.String,"asNumber",0
,smalltalk.__f__("""(self):
	#String>>#asNumber
	if smalltalk.b(self.includes_(smalltalk.String("r"))):
		return smalltalk.Number.readFrom_(self.readStream()) 
	 
	return smalltalk.string_asNumber_(self) 
""","String_asNumber")
,"converting","""asNumber
	" Return the receiver as a Number. "

	(self includes: $r) ifTrue: [
		^Number readFrom: self readStream
	].
	^{''js'Number(self)'}""",nil)
smalltalk.bind(smalltalk.String,"errorReadOnly",0
,smalltalk.__f__("""(self):
	#String>>#errorReadOnly
	return self.error_(smalltalk.object_comma_(smalltalk.String("Strings are inmutable. Attempt to change "),self.asLiteral())) 
""","String_errorReadOnly")
,"error","""errorReadOnly
	" DEPRECATED, Private - The receiver is read-only instance. "

	^self error: 'Strings are inmutable. Attempt to change ' ,self asLiteral""",nil)
smalltalk.bind(smalltalk.String,"errorReadOnly:",0
,smalltalk.__f__("""(self,selector):
	#String>>#errorReadOnly:
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Strings are inmutable. "),selector.asLiteral()),smalltalk.String(" sent to ")),self.asLiteral())) 
""","String_errorReadOnly_")
,"error","""errorReadOnly: selector
	" Private - The receiver is read-only instance. "

	^self error: 'Strings are inmutable. '
		,selector asLiteral
		,' sent to ' ,self asLiteral""",nil)
smalltalk.bind(smalltalk.String,"printString",0
,smalltalk.__f__("""(self):
	#String>>#printString
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.asArrayOfSubstringsSeparatedBy_(smalltalk.String("'")).join_(smalltalk.String("''")) 
	def __blk2__():
		return self 
	__0__.body=nil
	__0__.body=smalltalk.if_true_false_(self.includes_(smalltalk.String("'")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("'"),__0__.body),smalltalk.String("'")) 
""","String_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	| body |
	body := (self includes: $') ifTrue: [
		(self asArrayOfSubstringsSeparatedBy: $') join: ''''''
	] ifFalse: [ self ].
	^$' ,body ,$'""",nil)
smalltalk.bind(smalltalk.String,"isString",0
,smalltalk.__f__("""(self):
	#String>>#isString
	return smalltalk.true 
""","String_isString")
,"testing","""isString
	" Return true if the receiver is a String. "

	^true""",nil)
smalltalk.bind(smalltalk.String,"isBackSlash",0
,smalltalk.__f__("""(self):
	#String>>#isBackSlash
	return smalltalk.isObject_equalTo_(self.asciiValue(),smalltalk.Number(92)) 
""","String_isBackSlash")
,"testing","""isBackSlash
	" Return true if the receiver is a back-slash string. "

	^self asciiValue = 92 """,nil)
smalltalk.bind(smalltalk.String,">","_gt"
,smalltalk.__f__("""(self,aString):
	#String>>#>
	return smalltalk.true if smalltalk.handleOf(self) > smalltalk.handleOf(aString) else smalltalk.false 
""","String__gt")
,"comparing","""> aString
	" Return true if the receiver is greater than argument. "

	^{''js'String(self) > aString'}""",nil)
smalltalk.bind(smalltalk.String,"<","_lt"
,smalltalk.__f__("""(self,aString):
	#String>>#<
	return smalltalk.true if smalltalk.handleOf(self) < smalltalk.handleOf(aString) else smalltalk.false 
""","String__lt")
,"comparing","""< aString
	" Return true if the receiver is smaller than argument. "

	^{''js'String(self) < aString'}""",nil)
smalltalk.bind(smalltalk.String,">=","_gt_eq"
,smalltalk.__f__("""(self,aString):
	#String>>#>=
	return smalltalk.true if smalltalk.handleOf(self) >= smalltalk.handleOf(aString) else smalltalk.false 
""","String__gt_eq")
,"comparing",""">= aString
	" Return true if the receiver is greater or equal to argument. "

	^{''js'String(self) >= aString'}""",nil)
smalltalk.bind(smalltalk.String,"<=","_lt_eq"
,smalltalk.__f__("""(self,aString):
	#String>>#<=
	return smalltalk.true if smalltalk.handleOf(self) <= smalltalk.handleOf(aString) else smalltalk.false 
""","String__lt_eq")
,"comparing","""<= aString
	" Return true if the receiver is smaller or equal to argument. "

	^{''js'String(self) <= aString'}""",nil)
smalltalk.bind(smalltalk.String,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#String>>#remove:ifAbsent:
	return self.errorReadOnly_(smalltalk.String("remove:ifAbsent:")) 
""","String_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from the receiver. "

	^self errorReadOnly: #remove:ifAbsent:""",nil)
smalltalk.bind(smalltalk.String,"removeAll:",0
,smalltalk.__f__("""(self,aCollection):
	#String>>#removeAll:
	return self.errorReadOnly_(smalltalk.String("removeAll:")) 
""","String_removeAll_")
,"removing","""removeAll: aCollection
	" Remove aCollection from receiver. "

	^self errorReadOnly: #removeAll:""",nil)
smalltalk.bind(smalltalk.String,"removeAll",0
,smalltalk.__f__("""(self):
	#String>>#removeAll
	return self.errorReadOnly_(smalltalk.String("removeAll")) 
""","String_removeAll")
,"removing","""removeAll
	" Remove all elements in the receiver. "

	^self errorReadOnly: #removeAll""",nil)
smalltalk.bind(smalltalk.String,"asJSONObject",0
,smalltalk.__f__("""(self):
	#String>>#asJSONObject
	return smalltalk.object_comma_(self,smalltalk.String("")) 
""","String_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self , ''
"Note:	we need to normalize result to do not destroy typeof checkings
	Do NOT modify this method if you do not know what you are doing.
	If you remove the ,'' computation, the returned object will return 'object' and not 'string' as result of typeof operation.
\"""",nil)
smalltalk.bind(smalltalk.String,"isCharacter",0
,smalltalk.__f__("""(self):
	#String>>#isCharacter
	return smalltalk.true if len(smalltalk.handleOf(self)) == 1 else smalltalk.false 
""","String_isCharacter")
,"testing","""isCharacter
	" Implemented to support Character protocoll for one-character Strings. "

	^{''js'self.length == 1'}""",nil)
smalltalk.bind(smalltalk.String,"asciiValue",0
,smalltalk.__f__("""(self):
	#String>>#asciiValue
	return smalltalk.Number(ord(smalltalk.handleOf(self))) 
""","String_asciiValue")
,"testing","""asciiValue
	" Return the number corresponding to the ASCII encoding of the first character of the receiver. "

	^{''js'self.charCodeAt(0)'}""",nil)
smalltalk.bind(smalltalk.String,"isSeparator",0
,smalltalk.__f__("""(self):
	#String>>#isSeparator
	return smalltalk.true if smalltalk.handleOf(self).isspace() else smalltalk.false 
""","String_isSeparator")
,"testing","""isSeparator
	" Return true if the receiver is either a space, tab, new-line, form-feed character, or double-byte space.
	Note that new-line has been extended to support NEL character.
	See https://en.wikipedia.org/wiki/Newline
	"

	^{''js'(new RegExp("\\\\s|\\\\u0085")).test(self)'}""",nil)
smalltalk.bind(smalltalk.String,"asAsciiZ",0
,smalltalk.__f__("""(self):
	#String>>#asAsciiZ
	return smalltalk.object_comma_(self,(self).__class__.zero()) 
""","String_asAsciiZ")
,"converting","""asAsciiZ
	" Return the receiver with ascii zero appended. "

	^self , self class zero""",nil)
smalltalk.bind(smalltalk.String,"trimFirst:last:",0
,smalltalk.__f__("""(self,firstBlock,lastBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#String>>#trimFirst:last:
		__0__=smalltalk.newContext()
		def __blk1__():
			if smalltalk.b(__0__.start._gt(__0__.stop)):
				smalltalk.raise_result_(_s8Ret_,smalltalk.String.new()) 
			 
			return firstBlock.value_(self.at_(__0__.start)) 
		def __blk2__():
			if smalltalk.b(__0__.stop._lt(__0__.start)):
				smalltalk.raise_result_(_s8Ret_,smalltalk.String.new()) 
			 
			return lastBlock.value_(self.at_(__0__.stop)) 
		__0__.start=nil
		__0__.stop=nil
		__0__.start=smalltalk.Number(1) 
		__0__.stop=self.size() 
		while smalltalk.b(smalltalk.blk(__blk1__,0)()):
			__0__.start=__0__.start._plus(smalltalk.Number(1)) 
		 
		while smalltalk.b(smalltalk.blk(__blk2__,0)()):
			__0__.stop=__0__.stop._minus(smalltalk.Number(1)) 
		 
		smalltalk.raise_result_(_s8Ret_,self.copyFrom_to_(__0__.start,__0__.stop)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","String_trimFirst_last_")
,"selecting","""trimFirst: firstBlock last: lastBlock
	" Return a String containing the result of trimming characters matching blocks from both sides of the receiver. "

	| start stop |
	start := 1. stop := self size.
	[	start > stop ifTrue: [ ^String new ].
		firstBlock value: (self at: start)
	] whileTrue: [ start := start + 1 ].
	[	stop < start ifTrue: [ ^String new ].
		lastBlock value: (self at: stop)
	] whileTrue: [ stop := stop - 1 ].
	^self copyFrom: start to: stop""",nil)
smalltalk.bind(smalltalk.String,"trim:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#trim:
	return self.trimFirst_last_(aBlock,aBlock) 
""","String_trim_")
,"selecting","""trim: aBlock
	" Return a String containing the result of trimming characters matching aBlock from both sides of the receiver. "

	^self trimFirst: aBlock last: aBlock""",nil)
smalltalk.bind(smalltalk.String,"trimFirst:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#trimFirst:
	def __blk1__(c):
		return smalltalk.false 
	return self.trimFirst_last_(aBlock,smalltalk.blk(__blk1__,1)) 
""","String_trimFirst_")
,"selecting","""trimFirst: aBlock
	" Return a String containing the result of trimming characters matching aBlock from start of the receiver. "

	^self trimFirst: aBlock last: [:c| false ]""",nil)
smalltalk.bind(smalltalk.String,"trimLast:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#trimLast:
	def __blk1__(c):
		return smalltalk.false 
	return self.trimFirst_last_(smalltalk.blk(__blk1__,1),aBlock) 
""","String_trimLast_")
,"selecting","""trimLast: aBlock
	" Return a String containing the result of trimming characters matching aBlock from end of the receiver. "

	^self trimFirst: [:c| false ] last: aBlock""",nil)
smalltalk.bind(smalltalk.String,"trimBlanks",0
,smalltalk.__f__("""(self):
	#String>>#trimBlanks
	def __blk1__(c):
		return c.isSeparator() 
	return self.trim_(smalltalk.blk(__blk1__,1)) 
""","String_trimBlanks")
,"selecting","""trimBlanks
	" Return a String containing the receiver string with leading and trailing blanks removed. "

	^self trim: [:c| c isSeparator ]""",nil)
smalltalk.bind(smalltalk.String,"to:",0
,smalltalk.__f__("""(self,end):
	#String>>#to:
	def __blk1__():
		return smalltalk.Number(1) 
	def __blk2__():
		return smalltalk.Number(-1) 
	return self.to_by_(end,smalltalk.if_true_false_(self._lt_eq(end),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","String_to_")
,"iterating","""to: end
	" Return an iterable from the receiver to end. "

	^self to: end by: (self <= end ifTrue: [1] ifFalse: [-1])""",nil)
smalltalk.bind(smalltalk.String,"to:by:",0
,smalltalk.__f__("""(self,end,increment):
	#String>>#to:by:
	def __blk1__(index,block):
		return block.value_(smalltalk.asCharacter_(index)) 
	return self.asciiValue().to_by_value_(end.asciiValue(),increment,smalltalk.blk(__blk1__,2)) 
""","String_to_by_")
,"iterating","""to: end by: increment
	" Return an iterable from the receiver to end. "

	^self asciiValue
		to: end asciiValue
		by: increment
		value: [:index :block| block value: index asCharacter ]""",nil)
smalltalk.bind(smalltalk.String,"writeStream",0
,smalltalk.__f__("""(self):
	#String>>#writeStream
	return smalltalk.StringWriteStream.on_(self) 
""","String_writeStream")
,"streams","""writeStream
	" Return a write stream on the receiver. "

	^StringWriteStream on: self""",nil)
smalltalk.bind(smalltalk.String,"evaluateFor:",0
,smalltalk.__f__("""(self,anObject):
	#String>>#evaluateFor:
	return anObject.perform_(self) 
""","String_evaluateFor_")
,"evaluating","""evaluateFor: anObject
	" Return the result of evaluating the receiver with anObject. "

	^anObject perform: self""",nil)
smalltalk.bind(smalltalk.String,"asParser",0
,smalltalk.__f__("""(self):
	#String>>#asParser
	def __blk1__():
		return smalltalk.PPCharacterParser.in_(self) 
	def __blk2__():
		return smalltalk.PPStringParser.new().string_(self) 
	return smalltalk.if_true_false_(self.isCharacter(),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","String_asParser")
,"Compiler-converting","""asParser
	" Return a parser on the receiver. "

	^self isCharacter
	ifTrue:  [ PPCharacterParser in: self ]
	ifFalse: [ PPStringParser new string: self ]""",nil)
smalltalk.bind(smalltalk.String,"asChoiceParser",0
,smalltalk.__f__("""(self):
	#String>>#asChoiceParser
	def __blk1__(each):
		return each.asParser() 
	return smalltalk.PPChoiceParser.withAll_(self.asArray().collect_(smalltalk.blk(__blk1__,1))) 
""","String_asChoiceParser")
,"Compiler-converting","""asChoiceParser
	" Return a parser of choices for each character the receiver. "

	^PPChoiceParser withAll: (self asArray collect: [:each | each asParser ])""",nil)
smalltalk.bind(smalltalk.String,"asCharacterParser",0
,smalltalk.__f__("""(self):
	#String>>#asCharacterParser
	return smalltalk.PPCharacterParser.new().string_(self) 
""","String_asCharacterParser")
,"Compiler-converting","""asCharacterParser
	" Return a parser on the characters of the receiver. "

	^PPCharacterParser new string: self""",nil)
smalltalk.bind(smalltalk.String,"showIt",0
,smalltalk.__f__("""(self):
	#String>>#showIt
	return self.print_(self.logEvaluate()) 
""","String_showIt")
,"Tools-evaluating","""showIt
	" Show/Print the result of evaluating the receiver. "

	^self print: self logEvaluate""",nil)
smalltalk.bind(smalltalk.String,"logEvaluate",0
,smalltalk.__f__("""(self):
	#String>>#logEvaluate
	def __blk1__():
		return self.evaluate() 
	return smalltalk.blk(__blk1__,0).logEvaluate_(self) 
""","String_logEvaluate")
,"Tools-evaluating","""logEvaluate
	" Return the result of evaluating the receiver.
	The source of evaluation will be logged.
	"

	^[ self evaluate ] logEvaluate: self """,nil)
smalltalk.bind(smalltalk.String,"evaluate",0
,smalltalk.__f__("""(self):
	#String>>#evaluate
	return self.smalltalk().compilerSupport().evaluate_(self) 
""","String_evaluate")
,"Tools-evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	^self smalltalk compilerSupport evaluate: self """,nil)
smalltalk.bind(smalltalk.String,"evaluateIn:",0
,smalltalk.__f__("""(self,aReceiver):
	#String>>#evaluateIn:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.notNil_(aReceiver) 
	def __blk2__():
		return aReceiver 
	__0__.target=nil
	__0__.target=smalltalk.if_true_false_(smalltalk.boolean_and_(self.isObject_(aReceiver),smalltalk.blk(__blk1__,0)),smalltalk.blk(__blk2__,0),nil) 
	return __0__.target.smalltalk().compilerSupport().evaluate_to_(self,__0__.target) 
""","String_evaluateIn_")
,"Tools-evaluating","""evaluateIn: aReceiver
	" Return the result of evaluating the receiver in the context of aReceiver. "

	| target |
	target := ((self isObject: aReceiver) and: [aReceiver notNil]) ifTrue: [ aReceiver ].
	^target smalltalk compilerSupport evaluate: self to: target""",nil)
smalltalk.bind(smalltalk.String,"doIt",0
,smalltalk.__f__("""(self):
	#String>>#doIt
	return self.smalltalk().compilerSupport().doIt_(self) 
""","String_doIt")
,"Tools-evaluating","""doIt
	" Return the result of evaluating the receiver or the error occurred during compilation or evaluation. "

	^self smalltalk compilerSupport doIt: self""",nil)
smalltalk.bind(smalltalk.String,"fileIn",0
,smalltalk.__f__("""(self):
	#String>>#fileIn
	return self.stream().fileIn() 
""","String_fileIn")
,"Tools-fileIn","""fileIn
	" FileIn the contents of the receiver. "

	^self stream fileIn""",nil)
smalltalk.bind(smalltalk.String,"fileOut",0
,smalltalk.__f__("""(self):
	#String>>#fileOut
	return smalltalk.Exporter.fileOut_(self) 
""","String_fileOut")
,"Tools-fileOut","""fileOut
	" FileOut the classes/categories in the receiver. "

	^Exporter fileOut: self""",nil)
smalltalk.bind(smalltalk.String,"export",0
,smalltalk.__f__("""(self):
	#String>>#export
	return smalltalk.Exporter.export_(self) 
""","String_export")
,"Tools-fileOut","""export
	" Export the classes/categories in the receiver. "

	^Exporter export: self""",nil)
smalltalk.bind(smalltalk.String,"asComment",0
,smalltalk.__f__("""(self):
	#String>>#asComment
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.includes_(smalltalk.String.lf()) 
	__0__.prologue=nil
	__0__.epilogue=nil
	if smalltalk.b(smalltalk.boolean_or_(self.includes_(smalltalk.String.cr()),smalltalk.blk(__blk1__,0))):
		__0__.prologue=smalltalk.String.pythonCommentStart() 
		__0__.epilogue=smalltalk.String.pythonCommentEnd() 
	else:
		__0__.prologue="# " 
		__0__.epilogue=smalltalk.String("") 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(__0__.prologue,self),__0__.epilogue) 
""","String_asComment")
,"Tools-converting","""asComment
	" Return the receiver as a source code comment. "

	| prologue epilogue |
	((self includes: String cr) or: [self includes: String lf]) ifTrue: [
		prologue := {''js'"/* "'}.
		epilogue := {''js'"*/ "'}.
	] ifFalse: [
		prologue := {''js'"// "'}.
		epilogue := ''
	].
	^prologue ,self ,epilogue""",nil)
smalltalk.bind(smalltalk.String,"senders",0
,smalltalk.__f__("""(self):
	#String>>#senders
	return smalltalk.Smalltalk.sendersOf_(self) 
""","String_senders")
,"Tools-query","""senders
	" Return the senders of the receiver. "

	^Smalltalk sendersOf: self""",nil)
smalltalk.bind(smalltalk.String,"implementors",0
,smalltalk.__f__("""(self):
	#String>>#implementors
	return smalltalk.Smalltalk.implementorsOf_(self) 
""","String_implementors")
,"Tools-query","""implementors
	" Return the implementors of the receiver. "

	^Smalltalk implementorsOf: self""",nil)
smalltalk.bind(smalltalk.String,"ms:",0
,smalltalk.__f__("""(self,aBlock):
	#String>>#ms:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String(" (")),aBlock.ms()),smalltalk.String("ms)"))) 
	return self 
""","String_ms_")
,"Tools-debug","""ms: aBlock
	" Print the time spent evaluating aBlock titled with the receiver. "

	self note: self ,' (' ,aBlock ms ,'ms)'""",nil)
smalltalk.bind(smalltalk.String,"emmitFiles",0
,smalltalk.__f__("""(self):
	#String>>#emmitFiles
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.stream.atEnd() 
	__0__.folder=nil
	__0__.fileNames=nil
	__0__.stream=nil
	__0__.line=nil
	__0__.folder=self 
	__0__.fileNames=smalltalk.newArray([]) 
	__0__.stream=smalltalk.object_comma_(__0__.folder,smalltalk.String("emmit.txt")).fileContents().stream() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk2__():
			def __blk3__():
				def __blk4__():
					__0__.folder=self
					return __0__.folder 
				__0__.folder=__0__.line.copyFrom_to_(smalltalk.Number(2),__0__.line.size()).trimBlanks() 
				return smalltalk.if_true_false_(__0__.folder.isEmpty(),smalltalk.blk(__blk4__,0),nil) 
			def __blk5__():
				return __0__.fileNames.add_(smalltalk.object_comma_(__0__.folder,__0__.line)) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.line.first(),smalltalk.String("@")),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk5__,0)) 
		__0__.line=__0__.stream.nextLine().upTo_(smalltalk.String(";")).trimBlanks() 
		smalltalk.if_true_false_(__0__.line.notEmpty(),smalltalk.blk(__blk2__,0),nil) 
	 
	__0__.fileNames.emmitAll() 
	return self 
""","String_emmitFiles")
,"Builders-emmiting","""emmitFiles
	" Emmit all the files listed in emmit.txt "

	| folder fileNames stream line |
	folder := self.
	fileNames := #().
	stream := (folder ,'emmit.txt') fileContents stream.
	[ stream atEnd ] whileFalse: [
		line := (stream nextLine upTo: $;) trimBlanks.
		line notEmpty ifTrue: [
			line first = $@ ifTrue: [
				folder := (line copyFrom: 2 to: line size) trimBlanks.
				folder isEmpty ifTrue: [ folder := self ]
			] ifFalse: [ fileNames add: folder ,line ]
		]
	].
	fileNames emmitAll""",nil)
smalltalk.bind(smalltalk.String,"outputToFile:",0
,smalltalk.__f__("""(self,fileName):
	#String>>#outputToFile:
	return fileWrite(fileName,self,smalltalk.String("wb")) 
""","String_outputToFile_")
,"Snapshot-io","""outputToFile: fileName
	" Save the receiver's contents onto a file at fileName. "

	^# #fileWrite: fileName string: self mode: #wb""",nil)
smalltalk.bind(smalltalk.String,"appendToFile:",0
,smalltalk.__f__("""(self,fileName):
	#String>>#appendToFile:
	return fileWrite(fileName,self,smalltalk.String("ab")) 
""","String_appendToFile_")
,"Snapshot-io","""appendToFile: fileName
	" Append the receiver's contents onto a file at fileName. "

	^# #fileWrite: fileName string: self mode: #ab""",nil)
smalltalk.bind(smalltalk.String,"asPythonName",0
,smalltalk.__f__("""(self):
	#String>>#asPythonName
	if smalltalk.b(smalltalk.isObject_equalTo_(self.first(),smalltalk.String("_"))):
		return self 
	 
	if smalltalk.b(smalltalk.String.reservedPythonWords().includes_(self)):
		return smalltalk.object_comma_(smalltalk.String("_8"),self) 
	 
	return self 
""","String_asPythonName")
,"Python-py","""asPythonName
	" Private - Return the receiver as a valid Python name. "

	self first = $_ ifTrue: [ ^self ].
	(String reservedPythonWords includes: self) ifTrue: [ ^'_8',self ].
	^self""",nil)
smalltalk.bind(smalltalk.String,"asPythonSelector",0
,smalltalk.__f__("""(self):
	#String>>#asPythonSelector
	if smalltalk.b(smalltalk.String.forbiddenPythonSelectors().includes_(self)):
		return smalltalk.object_comma_(smalltalk.String("_"),self) 
	 
	if smalltalk.b(self.startsWith_(smalltalk.String("#"))):
		return self.upTo_startingAt_(smalltalk.String(":"),smalltalk.Number(2)) 
	 
	return self.asPrivateSelector().asPythonName() 
""","String_asPythonSelector")
,"Python-py","""asPythonSelector
	" Private - Return the receiver as a valid native selector. "

	(String forbiddenPythonSelectors includes: self) ifTrue: [ ^$_ ,self ].
	(self startsWith: $#) ifTrue: [
		^self upTo: $: startingAt: 2
	].
	^self asPrivateSelector asPythonName """,nil)
smalltalk.bind(smalltalk.String,"isPythonLines",0
,smalltalk.__f__("""(self):
	#String>>#isPythonLines
	if smalltalk.b(self.includes_(smalltalk.String.cr())):
		return smalltalk.true 
	 
	if smalltalk.b(self.includes_(smalltalk.String.lf())):
		return smalltalk.true 
	 
	if smalltalk.b(self.includes_(smalltalk.asCharacter_(smalltalk.Number(92)))):
		return smalltalk.true 
	 
	return smalltalk.false 
""","String_isPythonLines")
,"Python-py","""isPythonLines
	" Private - Return true if the receiver is a complex string. "

	(self includes: String cr) ifTrue: [ ^true ].
	(self includes: String lf) ifTrue: [ ^true ].
	"(self includes: String tab) ifTrue: [ ^true ]."
	(self includes: 92 asCharacter) ifTrue: [ ^true ].
	^false""",nil)
smalltalk.bind(smalltalk.String,"asPython",0
,smalltalk.__f__("""(self):
	#String>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.String("),self.asPythonString()),smalltalk.String(")")) 
""","String_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.String(' ,self asPythonString ,$) """,nil)
smalltalk.bind(smalltalk.String,"asPythonContents",0
,smalltalk.__f__("""(self):
	#String>>#asPythonContents
	return self.asPythonString() 
""","String_asPythonContents")
,"Python-py","""asPythonContents
	" Return the native representation of the receiver in contents of aCollection. "

	^self asPythonString """,nil)
smalltalk.bind(smalltalk.String,"asPython:cuoted:",0
,smalltalk.__f__("""(self,bar,tag):
	#String>>#asPython:cuoted:
	__0__=smalltalk.newContext()
	__0__.result=nil
	if smalltalk.b(self.includes_(tag)):
		return nil 
	 
	if not smalltalk.b(self.isPythonLines()):
		return nil 
	 
	__0__.result=self.replace_with_(bar,smalltalk.object_comma_(bar,bar)) 
	if smalltalk.b(self.endsWith_(tag.last())):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(tag,__0__.result.copyFrom_to_(smalltalk.Number(1),__0__.result.size()._minus(smalltalk.Number(1)))),bar),tag.last()),tag) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(tag,__0__.result),tag) 
""","String_asPython_cuoted_")
,"Python-py","""asPython: bar cuoted: tag
	" Private - Return the Python representation of the receiver couted with tag (or nil). "

	| result |
	(self includes: tag) ifTrue: [ ^nil ].
	self isPythonLines ifFalse: [ ^nil ].
	result := self replace: bar with: bar ,bar.
	(self endsWith: tag last) ifTrue: [
		^tag	,(result copyFrom: 1 to: result size - 1)
			,bar ,tag last ,tag
	].
	^tag ,result ,tag""",nil)
smalltalk.bind(smalltalk.String,"asPythonString",0
,smalltalk.__f__("""(self):
	#String>>#asPythonString
	__0__=smalltalk.newContext()
	__0__.tag=nil
	__0__.encoded=nil
	__0__.bar=nil
	if smalltalk.b(self.isEmpty()):
		return smalltalk.String('""') 
	 
	__0__.bar=smalltalk.asCharacter_(smalltalk.Number(92)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(self,__0__.bar)):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),__0__.bar),__0__.bar),smalltalk.String('"')) 
	 
	__0__.encoded=self.asPython_cuoted_(__0__.bar,smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),smalltalk.String('"')),smalltalk.String('"'))) 
	if smalltalk.b(smalltalk.notNil_(__0__.encoded)):
		return __0__.encoded 
	 
	__0__.encoded=self.asPython_cuoted_(__0__.bar,smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("'"),smalltalk.String("'")),smalltalk.String("'"))) 
	if smalltalk.b(smalltalk.notNil_(__0__.encoded)):
		return __0__.encoded 
	 
	__0__.tag=smalltalk.String('"') 
	if smalltalk.b(self.includes_(__0__.tag)):
		__0__.tag=smalltalk.String("'") 
	 
	__0__.encoded=self.replace_with_(__0__.bar,smalltalk.object_comma_(__0__.bar,__0__.bar)) 
	__0__.encoded=__0__.encoded.replace_with_(smalltalk.String.crlf(),smalltalk.object_comma_(__0__.bar,smalltalk.String("n"))) 
	__0__.encoded=__0__.encoded.replace_with_(smalltalk.String.cr(),smalltalk.object_comma_(__0__.bar,smalltalk.String("r"))) 
	__0__.encoded=__0__.encoded.replace_with_(smalltalk.String.lf(),smalltalk.object_comma_(__0__.bar,smalltalk.String("n"))) 
	__0__.encoded=__0__.encoded.replace_with_(__0__.tag,smalltalk.object_comma_(__0__.bar,__0__.tag)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(__0__.tag,__0__.encoded),__0__.tag) 
""","String_asPythonString")
,"Python-py","""asPythonString
	" Return the Python representation of the receiver. "

	| tag encoded bar |
	self isEmpty ifTrue: [ ^'""'].
	bar := 92 asCharacter.
	self = bar ifTrue: [ ^$" ,bar ,bar ,$" ].
	encoded := self asPython: bar cuoted: $",$",$".
	encoded notNil ifTrue: [ ^encoded ].
	encoded := self asPython: bar cuoted: $',$',$'.
	encoded notNil ifTrue: [ ^encoded ].

	tag := $".
	(self includes: tag) ifTrue: [ tag := $' ].
	encoded := self replace: bar with: bar ,bar.
	encoded := encoded replace: String crlf with: bar ,$n.
	encoded := encoded replace: String cr with: bar ,$r.
	encoded := encoded replace: String lf with: bar ,$n.
	"encoded := encoded replace: String tab with: bar ,$t."
	encoded := encoded replace: tag with: bar ,tag.
	^tag ,encoded ,tag""",nil)
smalltalk.bind(smalltalk.String,"fileContents",0
,smalltalk.__f__("""(self):
	#String>>#fileContents
	return read(self) 
""","String_fileContents")
,"io","""fileContents
	" Returns the contents of file at (fileName given by) the receiver.
	Return nil if the file do not exist or contents can't be read.
	"

	^# #read: self""",nil)
smalltalk.bind(smalltalk.Array.__class__,"new",0
,smalltalk.__f__("""(self):
	#Array class>>#new
	return smalltalk.newArray([]) 
""","Array_class_new")
,"instantiation","""new
	" Return an instance of the receiver. "

	^#()""",nil)
smalltalk.bind(smalltalk.Array.__class__,"basicNew:",0
,smalltalk.__f__("""(self,size):
	#Array class>>#basicNew:
	return self([nil] * smalltalk.handleOf(size)) 
""","Array_class_basicNew_")
,"instantiation","""basicNew: size
	" Return an instance of the receiver of specified size. "

	^{''js'new Array(size)'}""",nil)
smalltalk.bind(smalltalk.Array.__class__,"new:",0
,smalltalk.__f__("""(self,size):
	#Array class>>#new:
	return self.basicNew_(size).atAllPut_(nil) 
""","Array_class_new_")
,"instantiation","""new: size
	" Return an instance of the receiver of specified size. "

	^(self basicNew: size) atAllPut: nil""",nil)
smalltalk.bind(smalltalk.Array.__class__,"with:",0
,smalltalk.__f__("""(self,anObject):
	#Array class>>#with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(anObject) 
		return _s8_rec.yourself() 
	if True:
		return smalltalk.newArray([anObject])
	 
	return __blk1__(self.new()) 
""","Array_class_with_")
,"instantiation","""with: anObject
	" Return an instance of the receiver. "

	{''js'return [ anObject ]'}.
	^self new
		add: anObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Array.__class__,"with:with:",0
,smalltalk.__f__("""(self,firstObject,secondObject):
	#Array class>>#with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(firstObject) 
		_s8_rec.add_(secondObject) 
		return _s8_rec.yourself() 
	if True:
		return smalltalk.newArray([firstObject, secondObject])
	 
	return __blk1__(self.new()) 
""","Array_class_with_with_")
,"instantiation","""with: firstObject with: secondObject
	" Return an instance of the receiver. "

	{''js'return [ firstObject, secondObject ]'}.
	^self new
		add: firstObject;
		add: secondObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Array.__class__,"with:with:with:",0
,smalltalk.__f__("""(self,firstObject,secondObject,thirdObject):
	#Array class>>#with:with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(firstObject) 
		_s8_rec.add_(secondObject) 
		_s8_rec.add_(thirdObject) 
		return _s8_rec.yourself() 
	if True:
		return smalltalk.newArray([firstObject, secondObject, thirdObject])
	 
	return __blk1__(self.new()) 
""","Array_class_with_with_with_")
,"instantiation","""with: firstObject with: secondObject with: thirdObject
	" Return an instance of the receiver. "

	{''js'return [ firstObject, secondObject, thirdObject ]'}.
	^self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Array.__class__,"with:with:with:with:",0
,smalltalk.__f__("""(self,firstObject,secondObject,thirdObject,fourthObject):
	#Array class>>#with:with:with:with:
	def __blk1__(_s8_rec):
		_s8_rec.add_(firstObject) 
		_s8_rec.add_(secondObject) 
		_s8_rec.add_(thirdObject) 
		_s8_rec.add_(fourthObject) 
		return _s8_rec.yourself() 
	if True:
		return smalltalk.newArray([firstObject, secondObject, fourthObject])
	 
	return __blk1__(self.new()) 
""","Array_class_with_with_with_with_")
,"instantiation","""with: firstObject with: secondObject with: thirdObject with: fourthObject
	" Return an instance of the receiver. "

	{''js'return [ firstObject, secondObject, thirdObject, fourthObject ]'}.
	^self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself""",nil)
smalltalk.bind(smalltalk.Array.__class__,"withAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Array class>>#withAll:
	if True:
		return self(smalltalk.handleOf(aCollection.asArray()))
	 
	return self 
""","Array_class_withAll_")
,"instantiation","""withAll: aCollection
	" Return an instance of the receiver. "

	{''js'return [].concat(aCollection.asArray())'}""",nil)
smalltalk.bind(smalltalk.Array.__class__,"slice:",0
,smalltalk.__f__("""(self,anIterable):
	#Array class>>#slice:
	return self.notImplementedYet_(smalltalk.String("Array class>>#slice:")) 
""","Array_class_slice_")
,"util","""slice: anIterable
	" Return an Array instance from contents of anIterable. "

	^{''js'Array.prototype.slice.call(anIterable)'}""",nil)
smalltalk.bind(smalltalk.Array.__class__,"@","_at"
,smalltalk.__f__("""(self,natives):
	#Array class>>#@
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.new() 
	if smalltalk.b(smalltalk.isNil_(natives)):
		return __0__.result 
	 
	result=self(natives) 
	return __0__.result 
""","Array_class__at")
,"Natives-instantiation","""@ natives
	" Return an instance of the receiver containing the values in native object. "

	| result |
	result := self new.
	natives isNil ifTrue: [ ^result ].
	{''js'result.addAll_(natives)'}.
	^result""",nil)
smalltalk.bind(smalltalk.Array.__class__,"basicNew",0
,smalltalk.__f__("""(self):
	#Array class>>#basicNew
	if True: return self([]) 
	return smalltalk.superReceiver(smalltalk.Array.__class__,self).basicNew() 
""","Array_class_basicNew")
,"Python-instantiation","""basicNew
	" Return an instance of the receiver. "

	{'self'
	py'if True: return self([])'}.
	^super basicNew""",nil)
smalltalk.bind(smalltalk.Array.__class__,"basicNewXXX:",0
,smalltalk.__f__("""(self,size):
	#Array class>>#basicNewXXX:
	if True: return self([nil] * size.asParameter()) 
	return smalltalk.superReceiver(smalltalk.Array.__class__,self).basicNew_(size) 
""","Array_class_basicNewXXX_")
,"Python-instantiation","""basicNewXXX: size
	" Return an instance of the receiver of specified size. "

	{'self'
	py'if True: return self([nil] * size.asParameter())'}.
	^super basicNew: size""",nil)
smalltalk.bind(smalltalk.Array,"size",0
,smalltalk.__f__("""(self):
	#Array>>#size
	return smalltalk.Number(len(smalltalk.handleOf(self))) 
""","Array_size")
,"accessing","""size
	" Return the size of the receiver. "

	^{''js'self.length'}""",nil)
smalltalk.bind(smalltalk.Array,"at:",0
,smalltalk.__f__("""(self,anIndex):
	#Array>>#at:
	if True:
		return smalltalk.array_at_(self,anIndex)
	 
	return self 
""","Array_at_")
,"accessing","""at: anIndex
	" Return the contents of the receiver at anIndex. "

	{''js'var value = self[anIndex - 1];
	if(value === undefined) { return self.objectNotFoundAt_(anIndex); }
	return value'}""",nil)
smalltalk.bind(smalltalk.Array,"at:ifAbsent:",0
,smalltalk.__f__("""(self,anIndex,aBlock):
	#Array>>#at:ifAbsent:
	if True:
		return smalltalk.array_at_ifAbsent_(self,anIndex,aBlock)
	 
	return self 
""","Array_at_ifAbsent_")
,"accessing","""at: anIndex ifAbsent: aBlock
	" Return the contents of the receiver at anIndex or the result of evaluating aBlock. "

	{''js'var value = self[anIndex - 1];
	if(value === undefined) { return aBlock.value(); }
	return value'}""",nil)
smalltalk.bind(smalltalk.Array,"at:put:",0
,smalltalk.__f__("""(self,anIndex,anObject):
	#Array>>#at:put:
	if True:
		return smalltalk.array_at_put_(self,anIndex,anObject)
	 
	return self 
""","Array_at_put_")
,"accessing","""at: anIndex put: anObject
	" Set the contents of the receiver at anIndex. "

	{''js'return self[anIndex - 1] = anObject'}""",nil)
smalltalk.bind(smalltalk.Array,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Array>>#do:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return aBlock.value_(self.at_(i)) 
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	for x in smalltalk.handleOf(self):
		aBlock(smalltalk.asObject_(x))
	 
	return self 
""","Array_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	| fn | fn := self callableOf: aBlock.
	{''
js'	for(var i=0;i<self.length;i++){fn(self[i]);}'
s8'	1 to: self size do: [:i|
		aBlock value: (self at: i)
	]'}""",nil)
smalltalk.bind(smalltalk.Array,"isArray",0
,smalltalk.__f__("""(self):
	#Array>>#isArray
	return smalltalk.b_((self).__class__ is smalltalk.Array) 
""","Array_isArray")
,"testing","""isArray
	" Return true if the receiver is an Array. "

	^self class == Array""",nil)
smalltalk.bind(smalltalk.Array,"addAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Array>>#addAll:
	result = smalltalk.handleOf(self) + smalltalk.handleOf(aCollection.asArray())
	setattr(self,"@handle",result) 
	return aCollection 
""","Array_addAll_")
,"adding","""addAll: aCollection
	" Add objects in aCollection to the receiver. "

	{''js'self.push.apply(self, aCollection.asArray())'}.
	^aCollection""",nil)
smalltalk.bind(smalltalk.Array,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Array>>#shallowCopy
	__0__=smalltalk.newContext()
	__0__.result=nil
	aType = type(smalltalk.handleOf(self))
	objects = aType(smalltalk.handleOf(self))
	if True:
		return self.__class__(objects)
	 
	return __0__.result 
""","Array_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	| result |
	{''js'result = self.slice(0)'}.
	^result""",nil)
smalltalk.bind(smalltalk.Array,"deepCopy",0
,smalltalk.__f__("""(self):
	#Array>>#deepCopy
	def __blk1__(each):
		return each.deepCopy() 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Array_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self collect: [:each | each deepCopy ]""",nil)
smalltalk.bind(smalltalk.Array,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#Array>>#copyFrom:to:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(self.at_(each)) 
	__0__.result=nil
	__0__.result=self.species().new() 
	anIndex.to_do_(anotherIndex,smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Array_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return the receiver contents in the interval. "

	| result |
	result := self species new.
	anIndex to: anotherIndex do: [:each | result add: (self at: each) ].
	^result""",nil)
smalltalk.bind(smalltalk.Array,"copyWithAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Array>>#copyWithAll:
	result = self.copy()
	result.addAll_(aCollection.asArray())
	if True:
		return result
	 
	return self 
""","Array_copyWithAll_")
,"copying","""copyWithAll: aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	{''js'return self.concat(aCollection.asArray())'}""",nil)
smalltalk.bind(smalltalk.Array,",","_comma"
,smalltalk.__f__("""(self,aCollection):
	#Array>>#,
	result = self.copy()
	result.addAll_(aCollection.asArray())
	if True:
		return result
	 
	return self 
""","Array__comma")
,"copying",""", aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	{''js'return self.concat(aCollection.asArray())'}""",nil)
smalltalk.bind(smalltalk.Array,"join:",0
,smalltalk.__f__("""(self,aString):
	#Array>>#join:
	return smalltalk.array_join_(self,aString) 
""","Array_join_")
,"composing","""join: aString
	" Return a string with the receiver's contents separated by aString. "

	^{''js'self.join(aString)'}""",nil)
smalltalk.bind(smalltalk.Array,"compose:with:",0
,smalltalk.__f__("""(self,aBlock,aString):
	#Array>>#compose:with:
	def __blk1__(each):
		return smalltalk.notNil_(each) 
	return self.collect_thenSelect_(aBlock,smalltalk.blk(__blk1__,1)).join_(aString) 
""","Array_compose_with_")
,"composing","""compose: aBlock with: aString
	" Return a string composed with the result of evaluating aBlock into receiver's contents. "

	^(self	collect: aBlock
		thenSelect: [:each| each notNil ])
		join: aString""",nil)
smalltalk.bind(smalltalk.Array,"compose:",0
,smalltalk.__f__("""(self,aBlock):
	#Array>>#compose:
	return self.compose_with_(aBlock,smalltalk.String("")) 
""","Array_compose_")
,"composing","""compose: aBlock
	" Return a string composed with the result of evaluating aBlock into receiver's contents. "

	^self compose: aBlock with: ''""",nil)
smalltalk.bind(smalltalk.Array,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Array>>#asNative:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return each.asNative_(lang) 
	__0__.list=nil
	__0__.list=self.collect_(smalltalk.blk(__blk1__,1)).join_(smalltalk.String(", ")) 
	if smalltalk.b(smalltalk.isObject_equalTo_(lang,smalltalk.String("lua"))):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk:newArray"),smalltalk.String("(")),smalltalk.String("{")),__0__.list),smalltalk.String("}")),smalltalk.String(")")) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),__0__.list),smalltalk.String("]")) 
""","Array_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	| list |
	list := (self collect: [:each | each asNative: lang ]) join: ', '.
	lang = #lua ifTrue: [ ^'smalltalk:newArray' ,$( ,${ ,list ,$} ,$) ].
	^$[ ,list ,$]""",nil)
smalltalk.bind(smalltalk.Array,"sort:",0
,smalltalk.__f__("""(self,aBlock):
	#Array>>#sort:
	__0__=smalltalk.newContext()
	__0__.fn=nil
	__0__.fn=self.callableOf_(aBlock) 
	smalltalk.array_sort_(self,aBlock) 
	return self 
""","Array_sort_")
,"sorting","""sort: aBlock
	" Sort (inplace) the receiver's contents with aBlock. "

	| fn | fn := self callableOf: aBlock.
	{''js'if (nil.isNil_(aBlock)) { self.sort(); return self }
	var criteria = function(a, b) {
		if(fn(a,b)) {return -1} else {return 1}
	}
	self.sort(criteria)'}""",nil)
smalltalk.bind(smalltalk.Array,"asArray",0
,smalltalk.__f__("""(self):
	#Array>>#asArray
	return self 
""","Array_asArray")
,"converting","""asArray
	" Return an array with the contents of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.Array,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#Array>>#remove:ifAbsent:
	try:
		smalltalk.handleOf(self).remove(smalltalk.asNativeValue_(anObject))
	except ValueError:
		return smalltalk.handleOf(aBlock)()
	else:
		return anObject
	 
	return self 
""","Array_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from the receiver.
	Return the result of evaluating aBlock if anObject is not in the receiver.
	"

	{''js'for(var i=0;i<self.length;i++) {
		if(self[i] == anObject) {
			self.splice(i,1); return anObject;
		}
	}; return aBlock.value()'}""",nil)
smalltalk.bind(smalltalk.Array,"add:",0
,smalltalk.__f__("""(self,anObject):
	#Array>>#add:
	smalltalk.handleOf(self).append(smalltalk.asNativeValue_(anObject)) 
	return anObject 
""","Array_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	{''js'self.push(anObject);'}.
	^anObject""",nil)
smalltalk.bind(smalltalk.Array,"addFirst:",0
,smalltalk.__f__("""(self,anObject):
	#Array>>#addFirst:
	smalltalk.handleOf(self).insert(0,smalltalk.asNativeValue_(anObject)) 
	return anObject 
""","Array_addFirst_")
,"adding","""addFirst: anObject
	" Add anObject to the receiver. "

	{''js'self.splice(0,0,anObject)'}.
	^anObject""",nil)
smalltalk.bind(smalltalk.Array,"addLast:",0
,smalltalk.__f__("""(self,anObject):
	#Array>>#addLast:
	smalltalk.handleOf(self).append(smalltalk.asNativeValue_(anObject)) 
	return anObject 
""","Array_addLast_")
,"adding","""addLast: anObject
	" Add anObject to the receiver (at end). "

	{''js'self.push(anObject)'}.
	^anObject""",nil)
smalltalk.bind(smalltalk.Array,"removeAll",0
,smalltalk.__f__("""(self):
	#Array>>#removeAll
	smalltalk.handleOf(self).clear() 
	return self 
""","Array_removeAll")
,"removing","""removeAll
	" Remove all the objects in the receiver. "

	{''js'self.splice(0,self.size())'}""",nil)
smalltalk.bind(smalltalk.Array,"removeFirst",0
,smalltalk.__f__("""(self):
	#Array>>#removeFirst
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.first() 
	smalltalk.asObject_(smalltalk.handleOf(self).pop(0)) 
	return __0__.result 
""","Array_removeFirst")
,"removing","""removeFirst
	" Remove the first object in the receiver. "

	| result |
	result := self first.
	{''js'self.splice(0,1)'}.
	^result""",nil)
smalltalk.bind(smalltalk.Array,"removeIndex:",0
,smalltalk.__f__("""(self,index):
	#Array>>#removeIndex:
	smalltalk.asObject_(smalltalk.handleOf(self).pop(smalltalk.handleOf(index)-1)) 
	return self 
""","Array_removeIndex_")
,"removing","""removeIndex: index
	" Remove the element at index. "

	{''js'self.splice(index-1,1)'}""",nil)
smalltalk.bind(smalltalk.Array,"removeLast",0
,smalltalk.__f__("""(self):
	#Array>>#removeLast
	return smalltalk.asObject_(smalltalk.handleOf(self).pop()) 
""","Array_removeLast")
,"removing","""removeLast
	" Remove the last object in the receiver. "

	^{''js'self.pop()'}""",nil)
smalltalk.bind(smalltalk.Array,"sorted",0
,smalltalk.__f__("""(self):
	#Array>>#sorted
	return self.copy().sort_(nil) 
""","Array_sorted")
,"sorting","""sorted
	" Return a sorted copy of the receiver. "

	^self copy sort: nil""",nil)
smalltalk.bind(smalltalk.Array,"sorted:",0
,smalltalk.__f__("""(self,aBlock):
	#Array>>#sorted:
	return self.copy().sort_(aBlock) 
""","Array_sorted_")
,"sorting","""sorted: aBlock
	" Return a sorted copy of the receiver. "

	^self copy sort: aBlock""",nil)
smalltalk.bind(smalltalk.Array,"atAllPut:",0
,smalltalk.__f__("""(self,anObject):
	#Array>>#atAllPut:
	array = smalltalk.handleOf(self)
	o = smalltalk.asNativeValue_(anObject)
	for i in range(0,smalltalk.handleOf(self.size())):
		array[i] = o
	 
	return self 
""","Array_atAllPut_")
,"accessing","""atAllPut: anObject
	" Replace all elements of the receiver with anObject. "

	{''js'for(var i=0;i<self.length;i++){ self[i] = anObject; }'}""",nil)
smalltalk.bind(smalltalk.Array,"first",0
,smalltalk.__f__("""(self):
	#Array>>#first
	array = smalltalk.handleOf(self)
	if array:
		return smalltalk.asObject_(array[0])
	 
	return self.at_(smalltalk.Number(1)) 
""","Array_first")
,"accessing","""first
	" Return the object in the receiver. "

	{''js'var result=self[0];
	if (typeof(result)!="undefined") return result'}.
	^self at: 1""",nil)
smalltalk.bind(smalltalk.Array,"second",0
,smalltalk.__f__("""(self):
	#Array>>#second
	array = smalltalk.handleOf(self)
	if len(array) > 1:
		return smalltalk.asObject_(array[1])
	 
	return self.at_(smalltalk.Number(2)) 
""","Array_second")
,"accessing","""second
	" Return the object in the receiver. "

	{''js'var result=self[1];
	if (typeof(result)!="undefined") return result'}.
	^self at: 2""",nil)
smalltalk.bind(smalltalk.Array,"third",0
,smalltalk.__f__("""(self):
	#Array>>#third
	array = smalltalk.handleOf(self)
	if len(array) > 2:
		return smalltalk.asObject_(array[2])
	 
	return self.at_(smalltalk.Number(3)) 
""","Array_third")
,"accessing","""third
	" Return the object in the receiver. "

	{''js'var result=self[2];
	if (typeof(result)!="undefined") return result'}.
	^self at: 3""",nil)
smalltalk.bind(smalltalk.Array,"fourth",0
,smalltalk.__f__("""(self):
	#Array>>#fourth
	array = smalltalk.handleOf(self)
	if len(array) > 3:
		return smalltalk.asObject_(array[3])
	 
	return self.at_(smalltalk.Number(4)) 
""","Array_fourth")
,"accessing","""fourth
	" Return the object in the receiver. "

	{''js'var result=self[3];
	if (typeof(result)!="undefined") return result'}.
	^self at: 4""",nil)
smalltalk.bind(smalltalk.Array,"fifth",0
,smalltalk.__f__("""(self):
	#Array>>#fifth
	array = smalltalk.handleOf(self)
	if len(array) > 4:
		return smalltalk.asObject_(array[4])
	 
	return self.at_(smalltalk.Number(5)) 
""","Array_fifth")
,"accessing","""fifth
	" Return the fifth object in the receiver. "

	{''js'var result=self[4];
	if (typeof(result)!="undefined") return result'}.
	^self at: 5""",nil)
smalltalk.bind(smalltalk.Array,"sixth",0
,smalltalk.__f__("""(self):
	#Array>>#sixth
	array = smalltalk.handleOf(self)
	if len(array) > 5:
		return smalltalk.asObject_(array[5])
	 
	return self.at_(smalltalk.Number(6)) 
""","Array_sixth")
,"accessing","""sixth
	" Return the sixth object in the receiver. "

	{''js'var result=self[5];
	if (typeof(result)!="undefined") return result'}.
	^self at: 6""",nil)
smalltalk.bind(smalltalk.Array,"withIndexDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Array>>#withIndexDo:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		aBlock.value_value_(each,__0__.index) 
		__0__.index=__0__.index._plus(smalltalk.Number(1))
		return __0__.index 
	__0__.index=nil
	__0__.index=smalltalk.Number(1) 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Array_withIndexDo_")
,"enumerating","""withIndexDo: aBlock
	" Evaluate aBlock with all the index positions in the receiver. "

	| index |
	index := 1.
	self do: [:each|
		aBlock value: each value: index.
		index := index + 1
	]""",nil)
smalltalk.bind(smalltalk.Array,"printString",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#Array>>#printString
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				return smalltalk.printString_(each) 
			def __blk3__():
				return each 
			if smalltalk.b(__0__.result.size()._gt(smalltalk.Number(10000))):
				smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(__0__.result,smalltalk.String("...)"))) 
			 
			__0__.result=smalltalk.object_comma_(smalltalk.object_comma_(__0__.result,smalltalk.if_true_false_(self.isObject_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))),smalltalk.String(" "))
			return __0__.result 
		__0__.result=nil
		if smalltalk.b(self.isEmpty()):
			smalltalk.raise_result_(_s8Ret_,smalltalk.String("#()")) 
		 
		__0__.result=smalltalk.String("#( ") 
		self.do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(__0__.result,smalltalk.String(")"))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Array_printString")
,"printing","""printString
	" DEBUG - Temporary printing method (must check for recursion). "

	| result |
	self isEmpty ifTrue: [ ^'#()' ].
	result := '#( '.
	self do: [:each|
		result size > 10000 ifTrue: [ ^result,'...)' ].
		result := result , (
			(self isObject: each)
			ifTrue: [ each printString ]
			ifFalse: [ each ]) ,' '
	].
	^result,')'""",nil)
smalltalk.bind(smalltalk.Array,"asLiteral",0
,smalltalk.__f__("""(self):
	#Array>>#asLiteral
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return each.asLiteral() 
		def __blk3__():
			return smalltalk.to_String(each) 
		return smalltalk.if_true_false_(self.isObject_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	__0__.literals=nil
	__0__.literals=self.collect_(smalltalk.blk(__blk1__,1)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("#("),__0__.literals.join_(smalltalk.String(" "))),smalltalk.String(")")) 
""","Array_asLiteral")
,"converting","""asLiteral
	" Return the receiver in literal notation. "

	| literals |
	literals := self collect: [:each|
		(self isObject: each)
		ifTrue: [ each asLiteral ]
		ifFalse: [ each toString ]
	].
	^'#(' ,(literals join: $ ) ,$)""",nil)
smalltalk.bind(smalltalk.Array,"asJSONObject",0
,smalltalk.__f__("""(self):
	#Array>>#asJSONObject
	def __blk1__(each):
		def __blk2__():
			return each.asJSONObject() 
		def __blk3__():
			return each 
		return smalltalk.if_true_false_(self.isObject_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Array_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self collect: [:each| 
		(self isObject: each)
		ifTrue: [ each asJSONObject ]
		ifFalse: [ each ]
	]""",nil)
smalltalk.bind(smalltalk.Array,"json",0
,smalltalk.__f__("""(self):
	#Array>>#json
	def __blk1__(each):
		def __blk2__():
			return each.json() 
		def __blk3__():
			return each 
		return smalltalk.if_true_false_(self.isObject_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Array_json")
,"converting","""json
	" Return the receiver as a hash object. "

	^self collect: [:each| 
		(self isObject: each)
		ifTrue: [ each json ]
		ifFalse: [ each ]
	]""",nil)
smalltalk.bind(smalltalk.Array,"emmitAllIn:",0
,smalltalk.__f__("""(self,folder):
	#Array>>#emmitAllIn:
	def __blk1__(each):
		return smalltalk.object_comma_(folder,each) 
	return self.collect_(smalltalk.blk(__blk1__,1)).emmitAll() 
""","Array_emmitAllIn_")
,"Builders-emmiting","""emmitAllIn: folder
	" Emmit(fileIn & save generated code of) the fileNames in the receiver.
	Note the receiver MUST include the file separator at end
	"

	^(self collect: [:each| folder , each ]) emmitAll""",nil)
smalltalk.bind(smalltalk.Array,"emmitAll",0
,smalltalk.__f__("""(self):
	#Array>>#emmitAll
	def __blk1__():
		self.emmit_(smalltalk.Array.with_(self.removeFirst())) 
		return self.emmitAll() 
	if smalltalk.b(self.isEmpty()):
		return self 
	 
	smalltalk.blk(__blk1__,0).valueDeferred_(smalltalk.Number(500)) 
	return self 
""","Array_emmitAll")
,"Builders-emmiting","""emmitAll
	" Deferred (consuming) emmit of fileNames in the receiver. "

	self isEmpty ifTrue: [ ^self ].
	[	self emmit: (Array with: self removeFirst).
		self emmitAll
	] valueDeferred: 500""",nil)
smalltalk.bind(smalltalk.Array,"handles",0
,smalltalk.__f__("""(self):
	#Array>>#handles
	def __blk1__(each):
		return each.handle() 
	return self.collect_(smalltalk.blk(__blk1__,1)) 
""","Array_handles")
,"Natives-converting","""handles
	" Return the result of collecting the handles of the receiver. "

	^self collect: [:each| each handle ]""",nil)
smalltalk.bind(smalltalk.Array,"addAllLua:",0
,smalltalk.__f__("""(self,natives):
	#Array>>#addAllLua:
	if smalltalk.b(smalltalk.isObject_equalTo_(self.typeOf_(natives),smalltalk.String("userdata"))):
		__1__=smalltalk.newContext()
		def __blk1__(i):
			return self.add_(smalltalk.JavaArray.nativeClass().handle().get(natives,i._minus(smalltalk.Number(1)))) 
		__1__.count=nil
		__1__.count=smalltalk.JavaArray.getLength_(smalltalk.Lua._at(natives)) 
		smalltalk.Number(1).to_do_(__1__.count,smalltalk.blk(__blk1__,1)) 
		return self 
	 
	self.addAll_(natives) 
	return self 
""","Array_addAllLua_")
,"Natives-private","""addAllLua: natives
	" Private - Add the native values to the receiver. "

	(self typeOf: natives) = #userdata ifTrue: [ | count |
		count := JavaArray getLength: Lua@natives.
		1 to: count do: [:i|
			self add: (JavaArray nativeClass handle
				#get: natives index: i - 1).
		].
		^self
	].
	{''js'self.addAll_(natives)'}.
	^self""",nil)
smalltalk.bind(smalltalk.Array,"asPython",0
,smalltalk.__f__("""(self):
	#Array>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.newArray("),self.asPythonContents()),smalltalk.String(")")) 
""","Array_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.newArray(' ,self asPythonContents ,$) """,nil)
smalltalk.bind(smalltalk.Array,"asPythonContents",0
,smalltalk.__f__("""(self):
	#Array>>#asPythonContents
	def __blk1__(each):
		return each.asPythonContents() 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),self.collect_(smalltalk.blk(__blk1__,1)).join_(smalltalk.String(","))),smalltalk.String("]")) 
""","Array_asPythonContents")
,"Python-py","""asPythonContents
	" Return the native representation of the receiver in contents of aCollection. "

	^$[ ,((self collect: [:each | each asPythonContents ]) join: $,) ,$] """,nil)
smalltalk.bind(smalltalk.Array,"__tostring",0
,smalltalk.__f__("""(self):
	#Array>>#__tostring
	return self.asLiteral() 
""","Array___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self asLiteral""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"contents",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#contents
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@contents",nil))):
		smalltalk.basic_at_put(self,"@contents",smalltalk.Array.new()) 
	 
	return getattr(self,"@contents",nil) 
""","ArrayedContents_contents")
,"private","""contents
	" Private - Return the contents of the receiver. "

	contents isNil ifTrue: [ contents := Array new ].
	^contents""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"add:",0
,smalltalk.__f__("""(self,anObject):
	#ArrayedContents>>#add:
	return self.contents().add_(anObject) 
""","ArrayedContents_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	^self contents add: anObject""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"at:ifAbsent:",0
,smalltalk.__f__("""(self,anIndex,aBlock):
	#ArrayedContents>>#at:ifAbsent:
	return self.contents().at_ifAbsent_(anIndex,aBlock) 
""","ArrayedContents_at_ifAbsent_")
,"accessing","""at: anIndex ifAbsent: aBlock
	" Return the contents of the receiver at anIndex or the result of evaluating aBlock. "

	^self contents at: anIndex ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"at:put:",0
,smalltalk.__f__("""(self,anIndex,anObject):
	#ArrayedContents>>#at:put:
	return self.contents().at_put_(anIndex,anObject) 
""","ArrayedContents_at_put_")
,"accessing","""at: anIndex put: anObject
	" Set the contents of the receiver at anIndex. "

	^self contents at: anIndex put: anObject""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"atAllPut:",0
,smalltalk.__f__("""(self,anObject):
	#ArrayedContents>>#atAllPut:
	return self.contents().atAllPut_(anObject) 
""","ArrayedContents_atAllPut_")
,"accessing","""atAllPut: anObject
	" Replace all elements of the receiver with anObject. "

	^self contents atAllPut: anObject""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#ArrayedContents>>#copyFrom:to:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(self.at_(each)) 
	__0__.result=nil
	__0__.result=self.species().new() 
	anIndex.to_do_(anotherIndex,smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ArrayedContents_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return the receiver contents in the interval. "

	| result |
	result := self species new.
	anIndex to: anotherIndex do: [:each | result add: (self at: each) ].
	^result""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"indexOf:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#ArrayedContents>>#indexOf:ifAbsent:
	return self.contents().indexOf_ifAbsent_(anObject,aBlock) 
""","ArrayedContents_indexOf_ifAbsent_")
,"testing","""indexOf: anObject ifAbsent: aBlock
	" Return the position of anObject in the receiver, or the result of evaluating aBlock. "

	^self contents indexOf: anObject ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#ArrayedContents>>#detect:ifNone:
	return self.contents().detect_ifNone_(aBlock,anotherBlock) 
""","ArrayedContents_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. "

	^self contents detect: aBlock ifNone: anotherBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#ArrayedContents>>#do:
	return self.contents().do_(aBlock) 
""","ArrayedContents_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	^self contents do: aBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#ArrayedContents>>#includes:
	return self.contents().includes_(anObject) 
""","ArrayedContents_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^self contents includes: anObject""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"isEmpty",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#isEmpty
	return self.contents().isEmpty() 
""","ArrayedContents_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^self contents isEmpty""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"occurrencesOf:",0
,smalltalk.__f__("""(self,anObject):
	#ArrayedContents>>#occurrencesOf:
	return self.contents().occurrencesOf_(anObject) 
""","ArrayedContents_occurrencesOf_")
,"counting","""occurrencesOf: anObject
	" Return the occurrences of anObject in the receiver. "

	^self contents occurrencesOf: anObject""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"reverseDo:",0
,smalltalk.__f__("""(self,aBlock):
	#ArrayedContents>>#reverseDo:
	return self.contents().reverseDo_(aBlock) 
""","ArrayedContents_reverseDo_")
,"enumerating","""reverseDo: aBlock
	" Evaluate aBlock with the contents of the receiver in reverse order of iteration. "

	^self contents reverseDo: aBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"reversed",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#reversed
	return (self).__class__.withAll_(self.contents().reversed()) 
""","ArrayedContents_reversed")
,"copying","""reversed
	" Return an array with the contents of the receiver in reverse order. "

	^self class withAll: self contents reversed""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#ArrayedContents>>#remove:ifAbsent:
	return self.contents().remove_ifAbsent_(anObject,aBlock) 
""","ArrayedContents_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from the receiver.
	Return the result of evaluating aBlock if anObject is not in the receiver.
	"

	^self contents remove: anObject ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"removeAll",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#removeAll
	smalltalk.basic_at_put(self,"@contents",nil) 
	return self 
""","ArrayedContents_removeAll")
,"removing","""removeAll
	" Remove all the objects in the receiver. "

	contents := nil""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"removeFirst",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#removeFirst
	return self.contents().removeFirst() 
""","ArrayedContents_removeFirst")
,"removing","""removeFirst
	" Remove the first object in the receiver. "

	^self contents removeFirst""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"removeLast",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#removeLast
	return self.contents().removeLast() 
""","ArrayedContents_removeLast")
,"removing","""removeLast
	" Remove the last object in the receiver. "

	^self contents removeLast""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"removeIndex:",0
,smalltalk.__f__("""(self,index):
	#ArrayedContents>>#removeIndex:
	return self.contents().removeIndex_(index) 
""","ArrayedContents_removeIndex_")
,"removing","""removeIndex: index
	" Remove the element at index. "

	^self contents removeIndex: index""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"size",0
,smalltalk.__f__("""(self):
	#ArrayedContents>>#size
	return self.contents().size() 
""","ArrayedContents_size")
,"accesing","""size
	" Return the size of the receiver. "

	^self contents size""",nil)
smalltalk.bind(smalltalk.ArrayedContents,"withIndexDo:",0
,smalltalk.__f__("""(self,aBlock):
	#ArrayedContents>>#withIndexDo:
	return self.contents().withIndexDo_(aBlock) 
""","ArrayedContents_withIndexDo_")
,"enumerating","""withIndexDo: aBlock
	" Evaluate aBlock with all the index positions in the receiver. "

	^self contents withIndexDo: aBlock""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,",","_comma"
,smalltalk.__f__("""(self,anObject):
	#ComposedAssociations>>#,
	def __blk1__():
		return self 
	def __blk2__():
		return smalltalk.superReceiver(smalltalk.ComposedAssociations,self)._comma(anObject) 
	if smalltalk.b(anObject.isAssociation()):
		def __blk3__(_s8_rec):
			_s8_rec.add_(anObject) 
			return _s8_rec.yourself() 
		return __blk3__(self) 
	 
	return smalltalk.if_true_false_(smalltalk.isNil_(anObject),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","ComposedAssociations__comma")
,"composing",""", anObject
	" Return the receiver composed with the argument. "

	anObject isAssociation ifTrue: [
		^self add: anObject; yourself
	].
	^anObject isNil ifTrue: [ self ] ifFalse: [ super , anObject ]""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"hashObject",0
,smalltalk.__f__("""(self):
	#ComposedAssociations>>#hashObject
	return smalltalk.newHash() 
""","ComposedAssociations_hashObject")
,"private","""hashObject
	" Private - Return an empty hash object. "

	^{''js'{}'}""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"install:value:into:",0
,smalltalk.__f__("""(self,key,value,jsObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#ComposedAssociations>>#install:value:into:
		def __blk1__():
			return key.isArray() 
		if smalltalk.b(smalltalk.boolean_and_(self.isObject_(key),smalltalk.blk(__blk1__,0))):
			def __blk2__():
				__2__=smalltalk.newContext()
				def __blk3__():
					return smalltalk.basic_at_put_(jsObject,self.toString_(key.first()),self.hashObject()) 
				__2__.target=nil
				__2__.target=smalltalk.basic_at_ifAbsent_(jsObject,key.first(),smalltalk.blk(__blk3__,0)) 
				return smalltalk.raise_result_(_s8Ret_,self.install_value_into_(key.copyFrom_to_(smalltalk.Number(2),key.size()),value,__2__.target)) 
			if smalltalk.b(smalltalk.isObject_equalTo_(key.size(),smalltalk.Number(1))):
				smalltalk.raise_result_(_s8Ret_,self.install_value_into_(key.first(),value,jsObject)) 
			 
			smalltalk.if_true_false_(key.size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk2__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.basic_at_put_(jsObject,self.toString_(key),value)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","ComposedAssociations_install_value_into_")
,"private","""install: key value: value into: jsObject
	" Private - Install a key/value pair into jsObject. "

	((self isObject: key) and: [ key isArray ]) ifTrue: [
		key size = 1 ifTrue: [ ^self install: key first value: value into: jsObject ].
		key size > 1 ifTrue: [ | target |
			target := jsObject basicAt: key first ifAbsent: [
				jsObject basicAt: (self toString: key first) put: self hashObject
			].
			^self install: (key copyFrom: 2 to: key size) value: value into: target
		].
	].
	^jsObject
		basicAt: (self toString: key) "it is IMPORTANT to send #toString here (v8{4.7.0} bug will expose {object} instead of {string} Ale-14/oct/2015)"
		put: value""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"asJSONObject",0
,smalltalk.__f__("""(self):
	#ComposedAssociations>>#asJSONObject
	return self.json() 
""","ComposedAssociations_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self json""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"json",0
,smalltalk.__f__("""(self):
	#ComposedAssociations>>#json
	__0__=smalltalk.newContext()
	def __blk1__(assoc):
		def __blk2__():
			return assoc.value().json() 
		def __blk3__():
			return assoc.value() 
		__0__.value=smalltalk.if_true_false_(self.isObject_(assoc.value()),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		return self.install_value_into_(assoc.key(),__0__.value,__0__.result) 
	__0__.result=nil
	__0__.value=nil
	__0__.result=self.hashObject() 
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ComposedAssociations_json")
,"converting","""json
	" Return the receiver as a hash object. "

	| result value |
	result := self hashObject.
	self do: [:assoc |
		value := (self isObject: assoc value)
			ifTrue: [ assoc value json ]
			ifFalse: [ assoc value ].
		self install: assoc key value: value into: result
	].
	^result""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"associationAt:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#ComposedAssociations>>#associationAt:ifAbsent:
		def __blk1__(assoc):
			__1__=smalltalk.newContext()
			def __blk2__():
				return smalltalk.is_kindOf_(__1__.value,((self).__class__)) 
			def __blk3__():
				def __blk4__():
					nil 
				def __blk5__():
					return smalltalk.raise_result_(_s8Ret_,__1__.value) 
				__1__.value=__1__.value.associationAt_ifAbsent_(aKey,smalltalk.blk(__blk4__,0)) 
				return smalltalk.if_true_false_(smalltalk.notNil_(__1__.value),smalltalk.blk(__blk5__,0),nil) 
			__1__.value=nil
			if smalltalk.b(smalltalk.isObject_equalTo_(assoc.key(),aKey)):
				smalltalk.raise_result_(_s8Ret_,assoc) 
			 
			__1__.value=assoc.value() 
			return smalltalk.if_true_false_(smalltalk.boolean_and_(self.isObject_(__1__.value),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),nil) 
		self.reverseDo_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.evaluate()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","ComposedAssociations_associationAt_ifAbsent_")
,"accessing","""associationAt: aKey ifAbsent: aBlock
	" Return the association at aKey (or the result of evaluating aBlock).
	Note: the search will introspect in case of composite values.
	"

	self reverseDo: [:assoc| | value |
		assoc key = aKey ifTrue: [ ^assoc ].
		value := assoc value.
		((self isObject: value) and: [value isKindOf: self class]) ifTrue: [
			value := value associationAt: aKey ifAbsent: [].
			value notNil ifTrue: [ ^value ].
		]
	].
	^aBlock evaluate""",nil)
smalltalk.bind(smalltalk.ComposedAssociations,"@","_at"
,smalltalk.__f__("""(self,aKey):
	_s8Ret_=smalltalk.newContext()
	try:
		#ComposedAssociations>>#@
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.assoc=nil
		__0__.assoc=self.associationAt_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.assoc.value()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","ComposedAssociations__at")
,"accessing","""@ aKey
	" Return the value at aKey (or nil).
	Note: the search will introspect in case of composite values.
	"

	| assoc |
	assoc := self associationAt: aKey ifAbsent: [ ^nil ].
	^assoc value""",nil)
smalltalk.bind(smalltalk.ComposedObjects,",","_comma"
,smalltalk.__f__("""(self,anObject):
	#ComposedObjects>>#,
	def __blk1__():
		return smalltalk.responds_to_(anObject,(smalltalk.String("asArray"))) 
	def __blk2__():
		return smalltalk.booleanNot_(smalltalk.is_kindOf_(anObject,(getattr(self,"@species",nil)))) 
	if smalltalk.b(smalltalk.isNil_(anObject)):
		return self 
	 
	if smalltalk.b(smalltalk.boolean_or_(anObject.isArray(),smalltalk.blk(__blk1__,0))):
		def __blk3__(each):
			return smalltalk.object_comma_(self,each) 
		anObject.asArray().do_(smalltalk.blk(__blk3__,1)) 
		return self 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@species",nil)),smalltalk.blk(__blk2__,0))):
		self.error_(smalltalk.String("Invalid object to compose")) 
	 
	self.add_(anObject) 
	return self 
""","ComposedObjects__comma")
,"composing",""", anObject
	" Return the receiver composed with the argument. "

	anObject isNil ifTrue: [ ^self ].
	(anObject isArray or: [ anObject respondsTo: #asArray ]) ifTrue: [
		anObject asArray do: [:each| self , each ].
		^self
	].

	(species notNil and: [ (anObject isKindOf: species) not ]) ifTrue: [
		self error: 'Invalid object to compose'
	].

	self add: anObject.""",nil)
smalltalk.bind(smalltalk.ComposedObjects,"species:",0
,smalltalk.__f__("""(self,aBehavior):
	#ComposedObjects>>#species:
	smalltalk.basic_at_put(self,"@species",aBehavior) 
	return self 
""","ComposedObjects_species_")
,"accessing","""species: aBehavior
	" Set the species to compose in the receiver. "

	species := aBehavior""",nil)
smalltalk.bind(smalltalk.Interval.__class__,"from:to:by:value:",0
,smalltalk.__f__("""(self,start,end,step,aBlock):
	#Interval class>>#from:to:by:value:
	return self.basicNew().initialize_to_by_value_(start,end,step,aBlock) 
""","Interval_class_from_to_by_value_")
,"instantiation","""from: start to: end by: step value: aBlock
	" Return an instance of the receiver. "

	^self basicNew initialize: start to: end by: step value: aBlock""",nil)
smalltalk.bind(smalltalk.Interval,"initialize:to:by:value:",0
,smalltalk.__f__("""(self,_8from,to,increment,aBlock):
	#Interval>>#initialize:to:by:value:
	smalltalk.basic_at_put(self,"@start",_8from) 
	smalltalk.basic_at_put(self,"@end",to) 
	smalltalk.basic_at_put(self,"@step",increment) 
	smalltalk.basic_at_put(self,"@value",aBlock) 
	return self 
""","Interval_initialize_to_by_value_")
,"initialize","""initialize: from to: to by: increment value: aBlock
	" Private - Initialize the receiver. "

	start := from.
	end := to.
	step := increment.
	value := aBlock""",nil)
smalltalk.bind(smalltalk.Interval,"start",0
,smalltalk.__f__("""(self):
	#Interval>>#start
	return getattr(self,"@start",nil) 
""","Interval_start")
,"accessing","""start
	" Return the start of the receiver. "

	^start """,nil)
smalltalk.bind(smalltalk.Interval,"end",0
,smalltalk.__f__("""(self):
	#Interval>>#end
	return getattr(self,"@end",nil) 
""","Interval_end")
,"accessing","""end
	" Return the end of the receiver. "

	^end """,nil)
smalltalk.bind(smalltalk.Interval,"step",0
,smalltalk.__f__("""(self):
	#Interval>>#step
	return getattr(self,"@step",nil) 
""","Interval_step")
,"accessing","""step
	" Return the step of the receiver. "

	^step """,nil)
smalltalk.bind(smalltalk.Interval,"start:",0
,smalltalk.__f__("""(self,_8from):
	#Interval>>#start:
	smalltalk.basic_at_put(self,"@start",_8from) 
	return self 
""","Interval_start_")
,"accessing","""start: from
	" Set the start of the receiver. "

	start := from """,nil)
smalltalk.bind(smalltalk.Interval,"end:",0
,smalltalk.__f__("""(self,to):
	#Interval>>#end:
	smalltalk.basic_at_put(self,"@end",to) 
	return self 
""","Interval_end_")
,"accessing","""end: to
	" Set the end of the receiver. "

	end := to """,nil)
smalltalk.bind(smalltalk.Interval,"step:",0
,smalltalk.__f__("""(self,increment):
	#Interval>>#step:
	smalltalk.basic_at_put(self,"@step",increment) 
	return self 
""","Interval_step_")
,"accessing","""step: increment
	" Set the step of the receiver. "

	step := increment """,nil)
smalltalk.bind(smalltalk.Interval,"species",0
,smalltalk.__f__("""(self):
	#Interval>>#species
	return smalltalk.Array 
""","Interval_species")
,"species","""species
	" Return the species to instantiate objects like the receiver. "

	^Array """,nil)
smalltalk.bind(smalltalk.Interval,"subclassResponsibility:",0
,smalltalk.__f__("""(self,aSelector):
	#Interval>>#subclassResponsibility:
	return self.invalidMessage_(aSelector) 
""","Interval_subclassResponsibility_")
,"error","""subclassResponsibility: aSelector
	" Private - The concrete implementation on the receiver is not complete.
	Note: Unimplemented methods handle invalid messages sent to the receiver.
	"

	^self invalidMessage: aSelector""",nil)
smalltalk.bind(smalltalk.Interval,"size",0
,smalltalk.__f__("""(self):
	#Interval>>#size
	return smalltalk.Number(0).max_(getattr(self,"@end",nil)._minus(getattr(self,"@start",nil))._slash_slash(getattr(self,"@step",nil))._plus(smalltalk.Number(1))) 
""","Interval_size")
,"accessing","""size
	" Return the size of the receiver. "

	^0 max: end - start // step + 1""",nil)
smalltalk.bind(smalltalk.Interval,"consume:",0
,smalltalk.__f__("""(self,aBlock):
	#Interval>>#consume:
	def __blk1__():
		return self.isEmpty() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		aBlock.value_(getattr(self,"@start",nil)) 
		smalltalk.basic_at_put(self,"@start",getattr(self,"@start",nil)._plus(getattr(self,"@step",nil))) 
	 
	return self 
""","Interval_consume_")
,"iterating","""consume: aBlock
	" Private - Evaluates aBlock while the receiver is not empty. "

	[ self isEmpty ] whileFalse: [
		aBlock value: start.
		start := start + step
	] """,nil)
smalltalk.bind(smalltalk.Interval,"atEnd",0
,smalltalk.__f__("""(self):
	#Interval>>#atEnd
	return smalltalk.isObject_equalTo_(self.size(),smalltalk.Number(0)) 
""","Interval_atEnd")
,"testing","""atEnd
	" Return true if the receiver is at end. "

	^self size = 0 """,nil)
smalltalk.bind(smalltalk.Interval,"isEmpty",0
,smalltalk.__f__("""(self):
	#Interval>>#isEmpty
	return smalltalk.isObject_equalTo_(self.size(),smalltalk.Number(0)) 
""","Interval_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^self size = 0 """,nil)
smalltalk.bind(smalltalk.Interval,"notEmpty",0
,smalltalk.__f__("""(self):
	#Interval>>#notEmpty
	return smalltalk.booleanNot_(self.isEmpty()) 
""","Interval_notEmpty")
,"testing","""notEmpty
	" Return true if the receiver is not empty. "

	^self isEmpty not""",nil)
smalltalk.bind(smalltalk.Interval,"reversed",0
,smalltalk.__f__("""(self):
	#Interval>>#reversed
	return (self).__class__.from_to_by_value_(getattr(self,"@end",nil),getattr(self,"@start",nil),getattr(self,"@step",nil).negated(),getattr(self,"@value",nil)) 
""","Interval_reversed")
,"copying","""reversed
	" Return an Interval with the contents of the receiver in reverse order. "

	^self class from: end to: start by: step negated value: value """,nil)
smalltalk.bind(smalltalk.Interval,"reverseDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Interval>>#reverseDo:
	return self.reversed().do_(aBlock) 
""","Interval_reverseDo_")
,"enumerating","""reverseDo: aBlock
	" Evaluate aBlock with the contents of the receiver in reverse order of iteration. "

	^self reversed do: aBlock """,nil)
smalltalk.bind(smalltalk.Interval,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Interval>>#do:
	def __blk1__(i):
		return getattr(self,"@value",nil).value_value_(i,aBlock) 
	getattr(self,"@start",nil).to_by_do_(getattr(self,"@end",nil),getattr(self,"@step",nil),smalltalk.blk(__blk1__,1)) 
	return self 
""","Interval_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	start to: end by: step do: [:i|
		value value: i value: aBlock
	]""",nil)
smalltalk.bind(smalltalk.Interval,"+","_plus"
,smalltalk.__f__("""(self,aNumber):
	#Interval>>#+
	return getattr(self,"@start",nil)._plus(aNumber).to_by_value_(getattr(self,"@end",nil)._plus(aNumber),getattr(self,"@step",nil),getattr(self,"@value",nil)) 
""","Interval__plus")
,"arithmetic","""+ aNumber
	" Return the result of operation. "

	^start + aNumber to: end + aNumber by: step value: value""",nil)
smalltalk.bind(smalltalk.Interval,"-","_minus"
,smalltalk.__f__("""(self,aNumber):
	#Interval>>#-
	return getattr(self,"@start",nil)._minus(aNumber).to_by_value_(getattr(self,"@end",nil)._minus(aNumber),getattr(self,"@step",nil),getattr(self,"@value",nil)) 
""","Interval__minus")
,"arithmetic","""- aNumber
	" Return the result of operation. "

	^start - aNumber to: end - aNumber by: step value: value""",nil)
smalltalk.bind(smalltalk.Interval,"printString",0
,smalltalk.__f__("""(self):
	#Interval>>#printString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("("),getattr(self,"@start",nil)),smalltalk.String("to:")),getattr(self,"@end",nil)),smalltalk.String(")")) 
""","Interval_printString")
,"printing","""printString
	" Return the string representation of the receiver. "

	^$( ,start ,#to: ,end ,$) """,nil)
smalltalk.bind(smalltalk.Interval,"toString",0
,smalltalk.__f__("""(self):
	#Interval>>#toString
	def __blk1__():
		return smalltalk.isNil_(getattr(self,"@end",nil)) 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(getattr(self,"@start",nil)),smalltalk.blk(__blk1__,0))):
		return smalltalk.superReceiver(smalltalk.Interval,self).toString() 
	 
	return smalltalk.printString_(self) 
""","Interval_toString")
,"converting","""toString
	" Return the receiver as a String. "

	(start isNil or: [end isNil]) ifTrue: [ ^super toString ].
	^self printString """,nil)
smalltalk.bind(smalltalk.Interval,"__tostring",0
,smalltalk.__f__("""(self):
	#Interval>>#__tostring
	return smalltalk.to_String(self) 
""","Interval___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Set.__class__,"newContents:",0
,smalltalk.__f__("""(self,contents):
	#Set class>>#newContents:
	return self.basicNew().initialize_(contents) 
""","Set_class_newContents_")
,"private","""newContents: contents
	" Return an instance of the receiver initialized from given contents. "

	^self basicNew initialize: contents""",nil)
smalltalk.bind(smalltalk.Set.__class__,"basicNew:",0
,smalltalk.__f__("""(self,size):
	#Set class>>#basicNew:
	return self.new() 
""","Set_class_basicNew_")
,"instantiation","""basicNew: size
	" Return an instance of the receiver of specified size. "

	^self new""",nil)
smalltalk.bind(smalltalk.Set,"initialize",0
,smalltalk.__f__("""(self):
	#Set>>#initialize
	smalltalk.superReceiver(smalltalk.Set,self).initialize() 
	smalltalk.basic_at_put(self,"@contents",smalltalk.newArray([])) 
	return self 
""","Set_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	contents := #().""",nil)
smalltalk.bind(smalltalk.Set,"initialize:",0
,smalltalk.__f__("""(self,initializer):
	#Set>>#initialize:
	smalltalk.basic_at_put(self,"@contents",initializer) 
	return self 
""","Set_initialize_")
,"initialize","""initialize: initializer
	" Private - Initialize the receiver. "

	contents := initializer.""",nil)
smalltalk.bind(smalltalk.Set,"size",0
,smalltalk.__f__("""(self):
	#Set>>#size
	return getattr(self,"@contents",nil).size() 
""","Set_size")
,"accessing","""size
	" Return the size of the receiver. "

	^contents size""",nil)
smalltalk.bind(smalltalk.Set,"basicAdd:",0
,smalltalk.__f__("""(self,anObject):
	#Set>>#basicAdd:
	getattr(self,"@contents",nil).add_(anObject) 
	return anObject 
""","Set_basicAdd_")
,"private","""basicAdd: anObject
	" Private - Add anObject to the receiver's contents. "

	contents add: anObject.
	^anObject""",nil)
smalltalk.bind(smalltalk.Set,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#Set>>#includes:
	return getattr(self,"@contents",nil).includes_(anObject) 
""","Set_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^contents includes: anObject""",nil)
smalltalk.bind(smalltalk.Set,"add:",0
,smalltalk.__f__("""(self,anObject):
	#Set>>#add:
	if smalltalk.b(self.includes_(anObject)):
		return anObject 
	 
	return self.basicAdd_(anObject) 
""","Set_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	(self includes: anObject) ifTrue: [ ^anObject ].
	^self basicAdd: anObject""",nil)
smalltalk.bind(smalltalk.Set,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#Set>>#remove:ifAbsent:
	return getattr(self,"@contents",nil).remove_ifAbsent_(anObject,aBlock) 
""","Set_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from the receiver.
	Return the result of evaluating aBlock if anObject is not in the receiver.
	"

	^contents remove: anObject ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.Set,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#Set>>#copyFrom:to:
	return self.shouldNotImplement_(smalltalk.String("copyFrom:to:")) 
""","Set_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return a copy of the receiver from anIndex to anotherIndex. "

	^self shouldNotImplement: #copyFrom:to:""",nil)
smalltalk.bind(smalltalk.Set,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Set>>#asNative:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String(":") 
	def __blk2__():
		return smalltalk.String(".") 
	__0__.send=nil
	__0__.send=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(lang,smalltalk.String("lua")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),__0__.send),smalltalk.String("newContents_(")),getattr(self,"@contents",nil).asNative_(lang)),smalltalk.String(")")) 
""","Set_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	| send |
	send := lang = #lua ifTrue: [ $: ] ifFalse: [ $. ].
	^'smalltalk.' ,self class name
		,send ,'newContents_('
		,(contents asNative: lang)
		,')'""",nil)
smalltalk.bind(smalltalk.Set,"=","_eq"
,smalltalk.__f__("""(self,aSet):
	_s8Ret_=smalltalk.newContext()
	try:
		#Set>>#=
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(aSet.includes_(each),nil,smalltalk.blk(__blk2__,0)) 
		if not smalltalk.b(smalltalk.isObject_equalTo_((self).__class__,(aSet).__class__)):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		if not smalltalk.b(smalltalk.isObject_equalTo_(self.size(),aSet.size())):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		self.do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Set__eq")
,"comparing","""= aSet
	" Return true if the receiver is equal to argument. "

	self class = aSet class ifFalse: [^false].
	self size = aSet size ifFalse: [^false].
	self do: [:each | (aSet includes: each) ifFalse: [^false] ].
	^true""",nil)
smalltalk.bind(smalltalk.Set,"asArray",0
,smalltalk.__f__("""(self):
	#Set>>#asArray
	return getattr(self,"@contents",nil).copy() 
""","Set_asArray")
,"converting","""asArray
	" Return an array with the contents of the receiver. "

	^contents copy""",nil)
smalltalk.bind(smalltalk.Set,"toString",0
,smalltalk.__f__("""(self):
	#Set>>#toString
	return smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" withAll: ")),smalltalk.printString_(self.asArray())) 
""","Set_toString")
,"converting","""toString
	" Convert the receiver to a String. "

	^self class name,' withAll: ',self asArray printString""",nil)
smalltalk.bind(smalltalk.Set,"sorted",0
,smalltalk.__f__("""(self):
	#Set>>#sorted
	return self.asArray().sort() 
""","Set_sorted")
,"sorting","""sorted
	" Return the contents of the receiver sorted. "

	^self asArray sort""",nil)
smalltalk.bind(smalltalk.Set,"sorted:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#sorted:
	return self.asArray().sort_(aBlock) 
""","Set_sorted_")
,"sorting","""sorted: aBlock
	" Return a sorted copy of the receiver. "

	^self asArray sort: aBlock""",nil)
smalltalk.bind(smalltalk.Set,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#do:
	return getattr(self,"@contents",nil).do_(aBlock) 
""","Set_do_")
,"enumerating","""do: aBlock
	" Evaluate aBlock with the contents of the receiver. "

	^contents do: aBlock""",nil)
smalltalk.bind(smalltalk.Set,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Set>>#detect:ifNone:
	return getattr(self,"@contents",nil).detect_ifNone_(aBlock,anotherBlock) 
""","Set_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. "

	^contents detect: aBlock ifNone: anotherBlock""",nil)
smalltalk.bind(smalltalk.Set,"reverseDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#reverseDo:
	return getattr(self,"@contents",nil).reverseDo_(aBlock) 
""","Set_reverseDo_")
,"enumerating","""reverseDo: aBlock
	" Evaluate aBlock with the contents of the receiver in reverse order of iteration. "

	^contents reverseDo: aBlock""",nil)
smalltalk.bind(smalltalk.Set,"collect:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#collect:
	return (self).__class__.withAll_(getattr(self,"@contents",nil).collect_(aBlock)) 
""","Set_collect_")
,"enumerating","""collect: aBlock
	" Return a collection with the result of evaluating aBlock with the contents of the receiver. "

	^self class withAll: (contents collect: aBlock)""",nil)
smalltalk.bind(smalltalk.Set,"do:separatedBy:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Set>>#do:separatedBy:
	return getattr(self,"@contents",nil).do_separatedBy_(aBlock,anotherBlock) 
""","Set_do_separatedBy_")
,"enumerating","""do: aBlock separatedBy: anotherBlock
	" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. "

	^contents do: aBlock separatedBy: anotherBlock""",nil)
smalltalk.bind(smalltalk.Set,"inject:into:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#Set>>#inject:into:
	return getattr(self,"@contents",nil).inject_into_(anObject,aBlock) 
""","Set_inject_into_")
,"enumerating","""inject: anObject into: aBlock
	" Evaluate aBlock for result of previous evaluation and contents of the receiver.
	On first evaluation anObject is used as first argument to evaluate aBlock.
	"

	^contents inject: anObject into: aBlock""",nil)
smalltalk.bind(smalltalk.Set,"select:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#select:
	return (self).__class__.withAll_(getattr(self,"@contents",nil).select_(aBlock)) 
""","Set_select_")
,"enumerating","""select: aBlock
	" Return a copy of the receiver with elements wich evaluates aBlock to true. "

	^self class withAll: (contents select: aBlock)""",nil)
smalltalk.bind(smalltalk.Set,"reject:",0
,smalltalk.__f__("""(self,aBlock):
	#Set>>#reject:
	return (self).__class__.withAll_(getattr(self,"@contents",nil).reject_(aBlock)) 
""","Set_reject_")
,"enumerating","""reject: aBlock
	" Return the contents of the receiver wich evaluates aBlock to false. "

	^self class withAll: (contents reject: aBlock)""",nil)
smalltalk.bind(smalltalk.Set,"reversed",0
,smalltalk.__f__("""(self):
	#Set>>#reversed
	return getattr(self,"@contents",nil).reversed() 
""","Set_reversed")
,"copying","""reversed
	" Return an array with the contents of the receiver in reverse order. "

	^contents reversed""",nil)
smalltalk.bind(smalltalk.Set,"notEmpty",0
,smalltalk.__f__("""(self):
	#Set>>#notEmpty
	return getattr(self,"@contents",nil).notEmpty() 
""","Set_notEmpty")
,"testing","""notEmpty
	" Return true if the receiver is not empty. "

	^contents notEmpty""",nil)
smalltalk.bind(smalltalk.Set,"isEmpty",0
,smalltalk.__f__("""(self):
	#Set>>#isEmpty
	return getattr(self,"@contents",nil).isEmpty() 
""","Set_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^contents isEmpty""",nil)
smalltalk.bind(smalltalk.Set,"occurrencesOf:",0
,smalltalk.__f__("""(self,anObject):
	#Set>>#occurrencesOf:
	def __blk1__():
		return smalltalk.Number(1) 
	def __blk2__():
		return smalltalk.Number(0) 
	return smalltalk.if_true_false_(self.includes_(anObject),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Set_occurrencesOf_")
,"counting","""occurrencesOf: anObject
	" Return the occurrences of anObject in the receiver. "

	^(self includes: anObject) ifTrue: [ 1 ] ifFalse: [ 0 ]""",nil)
smalltalk.bind(smalltalk.Set,"asSet",0
,smalltalk.__f__("""(self):
	#Set>>#asSet
	return self 
""","Set_asSet")
,"converting","""asSet
	" Return the receiver contents in a Set. "

	^self""",nil)
smalltalk.bind(smalltalk.Set,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Set>>#shallowCopy
	return self.species().newContents_(getattr(self,"@contents",nil).copy()) 
""","Set_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self species newContents: contents copy""",nil)
smalltalk.bind(smalltalk.Set,"deepCopy",0
,smalltalk.__f__("""(self):
	#Set>>#deepCopy
	return self.species().newContents_(getattr(self,"@contents",nil).deepCopy()) 
""","Set_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self species newContents: contents deepCopy""",nil)
smalltalk.bind(smalltalk.Set,"asPython",0
,smalltalk.__f__("""(self):
	#Set>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),smalltalk.String(".newContents_(")),getattr(self,"@contents",nil).asPython()),smalltalk.String(")")) 
""","Set_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.' ,self class name
	, '.newContents_('
		, contents asPython
	,')'""",nil)
smalltalk.bind(smalltalk.Set,"__tostring",0
,smalltalk.__f__("""(self):
	#Set>>#__tostring
	return smalltalk.to_String(self) 
""","Set___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.HashedSet,"initialize",0
,smalltalk.__f__("""(self):
	#HashedSet>>#initialize
	smalltalk.superReceiver(smalltalk.HashedSet,self).initialize() 
	self.initializeHash() 
	return self 
""","HashedSet_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	self initializeHash.""",nil)
smalltalk.bind(smalltalk.HashedSet,"initialize:",0
,smalltalk.__f__("""(self,initializer):
	#HashedSet>>#initialize:
	smalltalk.basic_at_put(self,"@contents",initializer) 
	self.rehash() 
	return self 
""","HashedSet_initialize_")
,"initialize","""initialize: initializer
	" Private - Initialize the receiver. "

	contents := initializer.
	self rehash.""",nil)
smalltalk.bind(smalltalk.HashedSet,"initializeHash",0
,smalltalk.__f__("""(self):
	#HashedSet>>#initializeHash
	smalltalk.basic_at_put(self,"@hash",dict()) 
	return self 
""","HashedSet_initializeHash")
,"private","""initializeHash
	" Private - Initialize the hash of the receiver. "

	hash := {''js'{}'}.""",nil)
smalltalk.bind(smalltalk.HashedSet,"rehash",0
,smalltalk.__f__("""(self):
	#HashedSet>>#rehash
	def __blk1__(each):
		return self.privateAdd_(self.wrap_(each)) 
	self.initializeHash() 
	getattr(self,"@contents",nil).do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","HashedSet_rehash")
,"private","""rehash
	" Private - Rehash the receiver contents. "

	self initializeHash.
	contents do: [:each|
		self privateAdd: (self wrap: each)
	]""",nil)
smalltalk.bind(smalltalk.HashedSet,"asHashedSet",0
,smalltalk.__f__("""(self):
	#HashedSet>>#asHashedSet
	return self 
""","HashedSet_asHashedSet")
,"converting","""asHashedSet
	" Return the receiver contents in a HashedSet. "

	^self""",nil)
smalltalk.bind(smalltalk.HashedSet,"indexOf:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#HashedSet>>#indexOf:ifAbsent:
	if not smalltalk.b(self.includes_(anObject)):
		return aBlock.value() 
	 
	return getattr(self,"@contents",nil).indexOf_ifAbsent_(anObject,aBlock) 
""","HashedSet_indexOf_ifAbsent_")
,"private","""indexOf: anObject ifAbsent: aBlock
	" Return the position of anObject in the receiver, or the result of evaluating aBlock. "

	(self includes: anObject) ifFalse: [ ^aBlock value ].
	^contents indexOf: anObject ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.HashedSet,"withIndexDo:",0
,smalltalk.__f__("""(self,aBlock):
	#HashedSet>>#withIndexDo:
	return getattr(self,"@contents",nil).withIndexDo_(aBlock) 
""","HashedSet_withIndexDo_")
,"private","""withIndexDo: aBlock
	" Evaluate aBlock with all the index positions in the receiver. "

	^contents withIndexDo: aBlock""",nil)
smalltalk.bind(smalltalk.HashedSet,"removeIndex:",0
,smalltalk.__f__("""(self,index):
	#HashedSet>>#removeIndex:
	return self.remove_(getattr(self,"@contents",nil).at_(index)) 
""","HashedSet_removeIndex_")
,"private","""removeIndex: index
	" Remove the element at index. "

	^self remove: (contents at: index)""",nil)
smalltalk.bind(smalltalk.HashedSet,"privateAdd:",0
,smalltalk.__f__("""(self,cookie):
	#HashedSet>>#privateAdd:
	smalltalk.hashedSet_privateAdd_(self,cookie)
	if True:
		return
	 
	smalltalk.basic_at_put_(getattr(self,"@hash",nil),cookie,cookie) 
	return self 
""","HashedSet_privateAdd_")
,"private","""privateAdd: cookie
	" Private - Register a cookie onto the receiver's hash. "

	{'self'}. "macro hook"
	hash basicAt: cookie put: cookie""",nil)
smalltalk.bind(smalltalk.HashedSet,"privateRemove:",0
,smalltalk.__f__("""(self,cookie):
	#HashedSet>>#privateRemove:
	smalltalk.hashedSet_privateRemove_(self,cookie) 
	return self 
""","HashedSet_privateRemove_")
,"private","""privateRemove: cookie
	" Private - Remove a cookie in the receiver's hash. "

	{''js'delete self["@hash"][cookie]'}""",nil)
smalltalk.bind(smalltalk.HashedSet,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#HashedSet>>#includes:
	__0__=smalltalk.newContext()
	__0__.cookie=nil
	__0__.cookie=self.wrap_(anObject) 
	return smalltalk.b_(str(smalltalk.handleOf(__0__.cookie)) in getattr(self,"@hash")) 
""","HashedSet_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	| cookie |
	cookie := self wrap: anObject.
	^{''js'Object.prototype.hasOwnProperty.call(self["@hash"],cookie)'}""",nil)
smalltalk.bind(smalltalk.HashedSet,"add:",0
,smalltalk.__f__("""(self,anObject):
	#HashedSet>>#add:
	if smalltalk.b(self.includes_(anObject)):
		return anObject 
	 
	self.privateAdd_(self.wrap_(anObject)) 
	return self.basicAdd_(anObject) 
""","HashedSet_add_")
,"adding","""add: anObject
	" Add anObject to the receiver. "

	(self includes: anObject) ifTrue: [ ^anObject ].
	self privateAdd: (self wrap: anObject).
	^self basicAdd: anObject""",nil)
smalltalk.bind(smalltalk.HashedSet,"remove:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	#HashedSet>>#remove:ifAbsent:
	def __blk1__():
		nil 
	if not smalltalk.b(self.includes_(anObject)):
		return aBlock.value() 
	 
	getattr(self,"@contents",nil).remove_ifAbsent_(anObject,smalltalk.blk(__blk1__,0)) 
	self.privateRemove_(self.wrap_(anObject)) 
	return anObject 
""","HashedSet_remove_ifAbsent_")
,"removing","""remove: anObject ifAbsent: aBlock
	" Remove anObject from the receiver.
	Return the result of evaluating aBlock if anObject is not in the receiver.
	"

	(self includes: anObject) ifFalse: [ ^aBlock value ].
	contents remove: anObject ifAbsent: [ ].
	self privateRemove: (self wrap: anObject).
	^anObject""",nil)
smalltalk.bind(smalltalk.KeyedCollection.__class__,"basicNew:",0
,smalltalk.__f__("""(self,size):
	#KeyedCollection class>>#basicNew:
	return self.new() 
""","KeyedCollection_class_basicNew_")
,"instantiation","""basicNew: size
	" Return an instance of the receiver of specified size. "

	^self new""",nil)
smalltalk.bind(smalltalk.KeyedCollection.__class__,"@","_at"
,smalltalk.__f__("""(self,jsObject):
	#KeyedCollection class>>#@
	__0__=smalltalk.newContext()
	def __blk1__(key):
		return __0__.result.at_put_(key,smalltalk.basic_at_(jsObject,key)) 
	__0__.result=nil
	__0__.parts=nil
	if smalltalk.b(smalltalk.isNil_(jsObject)):
		return nil 
	 
	__0__.result=self.new() 
	self.notImplementedYet_(smalltalk.String("KeyedCollection>>#@")) 
	__0__.parts.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","KeyedCollection_class__at")
,"instantiation","""@ jsObject
	" Return an instance of the receiver with the properties owned by jsObject (or nil). "

	| result parts |
	jsObject isNil ifTrue: [ ^nil ].
	result := self new.
	{''js'parts=Object.getOwnPropertyNames(jsObject)'}.
	parts do: [:key|
		result at: key put: (jsObject basicAt: key)
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection.__class__,"fromTuples:",0
,smalltalk.__f__("""(self,tuples):
	#KeyedCollection class>>#fromTuples:
	__0__=smalltalk.newContext()
	def __blk1__(tuple):
		return __0__.result.at_put_(tuple.first(),tuple.last()) 
	__0__.result=nil
	__0__.result=self.new() 
	tuples.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","KeyedCollection_class_fromTuples_")
,"instantiation","""fromTuples: tuples
	" Return an instance of the receiver. "

	| result |
	result := self new.
	tuples do: [:tuple| result at: tuple first put: tuple last ].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,",","_comma"
,smalltalk.__f__("""(self,aCollection):
	#KeyedCollection>>#,
	return self.shouldNotImplement_(smalltalk.String(",")) 
""","KeyedCollection__comma")
,"copying",""", aCollection
	" Return a copy of the receiver with all contents of aCollection. "

	^self shouldNotImplement: #,""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#KeyedCollection>>#=
		def __blk1__(key,value):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(anObject.at_ifAbsent_(key,smalltalk.blk(__blk2__,0)),value),nil,smalltalk.blk(__blk3__,0)) 
		if not smalltalk.b(smalltalk.isObject_equalTo_((self).__class__,(anObject).__class__)):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		if not smalltalk.b(smalltalk.isObject_equalTo_(self.size(),anObject.size())):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","KeyedCollection__eq")
,"comparing","""= anObject
	" Return true if the receiver is equal to argument. "

	self class = anObject class ifFalse: [^false].
	self size = anObject size ifFalse: [^false].
	self keysAndValuesDo: [:key :value |
		(anObject at: key ifAbsent: [^false])
			= value ifFalse: [^false]
	].
	^true""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"add:",0
,smalltalk.__f__("""(self,anAssociation):
	#KeyedCollection>>#add:
	self.at_put_(anAssociation.key(),anAssociation.value()) 
	return anAssociation 
""","KeyedCollection_add_")
,"adding","""add: anAssociation
	" Bind anAssociation to the receiver. "

	self at: anAssociation key put: anAssociation value.
	^anAssociation""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"addAll:",0
,smalltalk.__f__("""(self,aKeyedCollection):
	#KeyedCollection>>#addAll:
	smalltalk.superReceiver(smalltalk.KeyedCollection,self).addAll_(aKeyedCollection.associations()) 
	return aKeyedCollection 
""","KeyedCollection_addAll_")
,"adding","""addAll: aKeyedCollection
	" Bind all associations in aKeyedCollection to the receiver. "

	super addAll: aKeyedCollection associations.
	^aKeyedCollection""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"newHash",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#newHash
	return smalltalk.newHash() 
""","KeyedCollection_newHash")
,"private","""newHash
	" Private - Return a new hash object. "

	^{''js'{}'}""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"asJSONObject",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#asJSONObject
	__0__=smalltalk.newContext()
	def __blk1__(key,aValue):
		def __blk2__():
			return aValue.asJSONObject() 
		def __blk3__():
			return aValue 
		__0__.value=smalltalk.if_true_false_(self.isObject_(aValue),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		return smalltalk.basic_at_put_(__0__.result,key,__0__.value) 
	__0__.result=nil
	__0__.value=nil
	__0__.result=self.newHash() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	| result value |
	result := self newHash.
	self keysAndValuesDo: [:key :aValue |
		value := (self isObject: aValue)
			ifTrue: [ aValue asJSONObject ]
			ifFalse: [ aValue ].
		result basicAt: key put: value
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"associations",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#associations
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.result.add_(each) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.associationsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","KeyedCollection_associations")
,"accessing","""associations
	" Return the associations of the receiver. "

	| result |
	result := Array new.
	self associationsDo: [:each| result add: each ].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"associationsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#associationsDo:
	def __blk1__(key,value):
		return aBlock.value_(smalltalk.Association.key_value_(key,value)) 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return self 
""","KeyedCollection_associationsDo_")
,"enumerating","""associationsDo: aBlock
	" Evaluate aBlock for all the receiver's associations. "

	self keysAndValuesDo: [:key :value|
		aBlock value: (Association key: key value: value)
	].""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:",0
,smalltalk.__f__("""(self,aKey):
	#KeyedCollection>>#at:
	def __blk1__():
		return self.objectNotFoundAt_(aKey) 
	return self.at_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
""","KeyedCollection_at_")
,"accessing","""at: aKey
	" Return the value at aKey.
	Signal an error if the key is not present.
	"

	^self at: aKey ifAbsent: [ self objectNotFoundAt: aKey ]""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#KeyedCollection>>#at:ifAbsent:
	return self.implementedBySubclass_(smalltalk.String("at:ifAbsent:")) 
""","KeyedCollection_at_ifAbsent_")
,"accessing","""at: aKey ifAbsent: aBlock
	" Return the value at aKey or the result of evaluating aBlock. "

	^self implementedBySubclass: #at:ifAbsent:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"values",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#values
	return self.implementedBySubclass_(smalltalk.String("values")) 
""","KeyedCollection_values")
,"accessing","""values
	" Return the values of the receiver. "

	^self implementedBySubclass: #values""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:ifAbsentPut:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#KeyedCollection>>#at:ifAbsentPut:
	def __blk1__():
		return self.at_put_(aKey,aBlock.value()) 
	return self.at_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
""","KeyedCollection_at_ifAbsentPut_")
,"accessing","""at: aKey ifAbsentPut: aBlock
	" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. "

	^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:put:",0
,smalltalk.__f__("""(self,aKey,aValue):
	#KeyedCollection>>#at:put:
	return self.implementedBySubclass_(smalltalk.String("at:put:")) 
""","KeyedCollection_at_put_")
,"accessing","""at: aKey put: aValue
	" Set the value at aKey of the receiver. "

	^self implementedBySubclass: #at:put:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#KeyedCollection>>#detect:ifNone:
	return self.implementedBySubclass_(smalltalk.String("detect:ifNone:")) 
""","KeyedCollection_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Detect the value who matches aBlock.
	Return the result of evaluating aBlock if no value matches detection block.
	"

	^self implementedBySubclass: #detect:ifNone:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#do:
	return self.implementedBySubclass_(smalltalk.String("do:")) 
""","KeyedCollection_do_")
,"enumerating","""do: aBlock
	" Evaluates aBlock for all values in the receiver. "

	^self implementedBySubclass: #do:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#KeyedCollection>>#includes:
	return self.implementedBySubclass_(smalltalk.String("includes:")) 
""","KeyedCollection_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^self implementedBySubclass: #includes:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"keyForValue:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#KeyedCollection>>#keyForValue:ifAbsent:
		def __blk1__(key,value):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,key) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(anObject,value),smalltalk.blk(__blk2__,0),nil) 
		self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.value()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","KeyedCollection_keyForValue_ifAbsent_")
,"accessing","""keyForValue: anObject ifAbsent: aBlock
	" Return the key in the receiver for value anObject, or the result of evaluating aBlock. "

	self keysAndValuesDo: [:key :value| anObject = value ifTrue: [ ^key ] ].
	^aBlock value""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"keys",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#keys
	return self.implementedBySubclass_(smalltalk.String("keys")) 
""","KeyedCollection_keys")
,"accessing","""keys
	" Return the keys of the receiver. "

	^self implementedBySubclass: #keys""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"keysAndValuesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#keysAndValuesDo:
	return self.implementedBySubclass_(smalltalk.String("keysAndValuesDo:")) 
""","KeyedCollection_keysAndValuesDo_")
,"enumerating","""keysAndValuesDo: aBlock
	" Evaluate aBlock for key/value pairs of the receiver. "

	^self implementedBySubclass: #keysAndValuesDo:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"keysDo:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#keysDo:
	return self.implementedBySubclass_(smalltalk.String("keysDo:")) 
""","KeyedCollection_keysDo_")
,"enumerating","""keysDo: aBlock
	" Evaluate aBlock with the keys of the receiver. "

	^self implementedBySubclass: #keysDo:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"includesKey:",0
,smalltalk.__f__("""(self,aKey):
	#KeyedCollection>>#includesKey:
	return self.implementedBySubclass_(smalltalk.String("includesKey:")) 
""","KeyedCollection_includesKey_")
,"testing","""includesKey: aKey
	" Return true if the receiver's keys include aKey. "

	^self implementedBySubclass: #includesKey:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"removeKey:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#KeyedCollection>>#removeKey:ifAbsent:
	return self.implementedBySubclass_(smalltalk.String("removeKey:ifAbsent:")) 
""","KeyedCollection_removeKey_ifAbsent_")
,"removing","""removeKey: aKey ifAbsent: aBlock
	" Remove the binding at aKey. "

	^self implementedBySubclass: #removeKey:ifAbsent:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"removeKeys:",0
,smalltalk.__f__("""(self,aCollection):
	#KeyedCollection>>#removeKeys:
	def __blk1__(each):
		def __blk2__():
			nil 
		return self.removeKey_ifAbsent_(each,smalltalk.blk(__blk2__,0)) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","KeyedCollection_removeKeys_")
,"removing","""removeKeys: aCollection
	" Remove aCollection of keys in the receiver. "

	aCollection do: [:each| self removeKey: each ifAbsent: [] ]""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"removeAll",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#removeAll
	self.initialize() 
	return self 
""","KeyedCollection_removeAll")
,"removing","""removeAll
	" Remove all elements in the receiver. "

	self initialize""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"isEmpty",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#isEmpty
	return smalltalk.isObject_equalTo_(self.size(),smalltalk.Number(0)) 
""","KeyedCollection_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^self size = 0""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:ifPresent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#KeyedCollection>>#at:ifPresent:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.aValue=nil
		__0__.aValue=self.at_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.value_(__0__.aValue)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","KeyedCollection_at_ifPresent_")
,"accessing","""at: aKey ifPresent: aBlock
	" Return the result of evaluating aBlock if there is a value at aKey (or nil). "

	| aValue |
	aValue := self at: aKey ifAbsent: [ ^nil ].
	^aBlock value: aValue""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"at:ifPresent:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock,anotherBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#KeyedCollection>>#at:ifPresent:ifAbsent:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,anotherBlock.value()) 
		__0__.aValue=nil
		__0__.aValue=self.at_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.value_(__0__.aValue)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","KeyedCollection_at_ifPresent_ifAbsent_")
,"accessing","""at: aKey ifPresent: aBlock ifAbsent: anotherBlock
	" Return the result of evaluating aBlock if there is a value at aKey (or the result of evaluating anotherBlock). "

	| aValue |
	aValue := self at: aKey ifAbsent: [ ^anotherBlock value ].
	^aBlock value: aValue""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"collect:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#collect:
	__0__=smalltalk.newContext()
	def __blk1__(key,value):
		return __0__.result.at_put_(key,aBlock.value_(value)) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_collect_")
,"enumerating","""collect: aBlock
	" Return aKeyedCollection with keys and result of evaluating aBlock with value. "

	| result |
	result := self species new.
	self keysAndValuesDo: [:key :value |
		result at: key put: (aBlock value: value)
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"select:",0
,smalltalk.__f__("""(self,aBlock):
	#KeyedCollection>>#select:
	__0__=smalltalk.newContext()
	def __blk1__(key,value):
		def __blk2__():
			return __0__.result.at_put_(key,value) 
		return smalltalk.if_true_false_(aBlock.value_(value),smalltalk.blk(__blk2__,0),nil) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_select_")
,"enumerating","""select: aBlock
	" Return the contents of the receiver wich evaluates aBlock to true. "

	| result |
	result := self species new.
	self keysAndValuesDo: [:key :value |
		(aBlock value: value) ifTrue: [ result at: key put: value ]
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"shallowCopy",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#shallowCopy
	__0__=smalltalk.newContext()
	def __blk1__(key,value):
		return __0__.result.at_put_(key,value) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	| result |
	result := self species new.
	self keysAndValuesDo: [:key :value | result at: key put: value ].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"tuples",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#tuples
	__0__=smalltalk.newContext()
	def __blk1__(key,value):
		return __0__.result.add_(smalltalk.Array.with_with_(key,value)) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_tuples")
,"accessing","""tuples
	" Return an array of tuples built from the receiver's contents. "

	| result |
	result := Array new.
	self keysAndValuesDo: [:key :value|
		result add: (Array with: key with: value)
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"copyFrom:to:",0
,smalltalk.__f__("""(self,anIndex,anotherIndex):
	#KeyedCollection>>#copyFrom:to:
	return self.shouldNotImplement_(smalltalk.String("copyFrom:to:")) 
""","KeyedCollection_copyFrom_to_")
,"copying","""copyFrom: anIndex to: anotherIndex
	" Return a copy of the receiver from anIndex to anotherIndex. "

	^self shouldNotImplement: #copyFrom:to:""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"deepCopy",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#deepCopy
	__0__=smalltalk.newContext()
	def __blk1__(key,value):
		return __0__.result.at_put_(key,value.deepCopy()) 
	__0__.result=nil
	__0__.result=self.species().new() 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return __0__.result 
""","KeyedCollection_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	| result |
	result := self species new.
	self keysAndValuesDo: [:key :value |
		result at: key put: value deepCopy
	].
	^result""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"remove:",0
,smalltalk.__f__("""(self,aKey):
	#KeyedCollection>>#remove:
	self.removeKey_(aKey) 
	return self 
""","KeyedCollection_remove_")
,"removing","""remove: aKey
	" Remove the binding at aKey. "

	self removeKey: aKey""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"removeKey:",0
,smalltalk.__f__("""(self,aKey):
	#KeyedCollection>>#removeKey:
	def __blk1__():
		return self.objectNotFoundAt_(aKey) 
	return self.removeKey_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
""","KeyedCollection_removeKey_")
,"removing","""removeKey: aKey
	" Remove the binding at aKey.
	Signal an error if the key is not present.
	"

	^self removeKey: aKey ifAbsent: [ self objectNotFoundAt: aKey ]""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"printString",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#printString
	return smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" fromTuples: ")),self.tuples().asLiteral()) 
""","KeyedCollection_printString")
,"converting","""printString
	" Return a printable representation of the receiver. "

	^self class name ,' fromTuples: ' ,self tuples asLiteral""",nil)
smalltalk.bind(smalltalk.KeyedCollection,"isDictionary",0
,smalltalk.__f__("""(self):
	#KeyedCollection>>#isDictionary
	return smalltalk.true 
""","KeyedCollection_isDictionary")
,"testing","""isDictionary
	" Return true if the receiver is a dictionary. "

	^true""",nil)
smalltalk.bind(smalltalk.Dictionary.__class__,"basicNew",0
,smalltalk.__f__("""(self):
	#Dictionary class>>#basicNew
	if True:
		return smalltalk.PoolDictionary.new()
	 
	return smalltalk.superReceiver(smalltalk.Dictionary.__class__,self).basicNew() 
""","Dictionary_class_basicNew")
,"instantiation","""basicNew
	" Return an instance of the receiver. "

	{''js'self'}.
	^super basicNew""",nil)
smalltalk.bind(smalltalk.Dictionary.__class__,"fromKeys:and:",0
,smalltalk.__f__("""(self,keys,values):
	#Dictionary class>>#fromKeys:and:
	return self.basicNew().initializeKeys_values_(keys,values) 
""","Dictionary_class_fromKeys_and_")
,"instantiation","""fromKeys: keys and: values
	" Return an instance of the receiver. "

	^self basicNew initializeKeys: keys values: values""",nil)
smalltalk.bind(smalltalk.Dictionary,"initialize",0
,smalltalk.__f__("""(self):
	#Dictionary>>#initialize
	smalltalk.superReceiver(smalltalk.Dictionary,self).initialize() 
	smalltalk.basic_at_put(self,"@keys",smalltalk.HashedSet.new()) 
	smalltalk.basic_at_put(self,"@values",smalltalk.newArray([])) 
	return self 
""","Dictionary_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	keys := HashedSet new.
	values := #().""",nil)
smalltalk.bind(smalltalk.Dictionary,"initializeKeys:values:",0
,smalltalk.__f__("""(self,privateKeys,privateValues):
	#Dictionary>>#initializeKeys:values:
	smalltalk.superReceiver(smalltalk.Dictionary,self).initialize() 
	smalltalk.basic_at_put(self,"@keys",smalltalk.HashedSet.newContents_(privateKeys)) 
	smalltalk.basic_at_put(self,"@values",privateValues.asArray()) 
	return self 
""","Dictionary_initializeKeys_values_")
,"initialize","""initializeKeys: privateKeys values: privateValues
	" Private - Initialize the receiver. "

	super initialize.
	keys := HashedSet newContents: privateKeys.
	values := privateValues asArray.""",nil)
smalltalk.bind(smalltalk.Dictionary,"size",0
,smalltalk.__f__("""(self):
	#Dictionary>>#size
	return getattr(self,"@keys",nil).size() 
""","Dictionary_size")
,"accessing","""size
	" Return the size of the receiver. "

	^keys size""",nil)
smalltalk.bind(smalltalk.Dictionary,"isEmpty",0
,smalltalk.__f__("""(self):
	#Dictionary>>#isEmpty
	return getattr(self,"@keys",nil).isEmpty() 
""","Dictionary_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^keys isEmpty""",nil)
smalltalk.bind(smalltalk.Dictionary,"lookUpKey:",0
,smalltalk.__f__("""(self,aKey):
	#Dictionary>>#lookUpKey:
	def __blk1__():
		return nil 
	return getattr(self,"@keys",nil).indexOf_ifAbsent_(aKey,smalltalk.blk(__blk1__,0)) 
""","Dictionary_lookUpKey_")
,"private","""lookUpKey: aKey
	" Private - Return the index where aKey is found (or nil). "

	^keys indexOf: aKey ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.Dictionary,"keysAndValuesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Dictionary>>#keysAndValuesDo:
	def __blk1__(aKey,index):
		return aBlock.value_value_(aKey,getattr(self,"@values",nil).at_(index)) 
	getattr(self,"@keys",nil).withIndexDo_(smalltalk.blk(__blk1__,2)) 
	return self 
""","Dictionary_keysAndValuesDo_")
,"enumerating","""keysAndValuesDo: aBlock
	" Evaluate aBlock for key/value pairs of the receiver. "

	keys withIndexDo: [:aKey :index | aBlock value: aKey value: (values at: index) ]""",nil)
smalltalk.bind(smalltalk.Dictionary,"keys",0
,smalltalk.__f__("""(self):
	#Dictionary>>#keys
	return getattr(self,"@keys",nil).copy() 
""","Dictionary_keys")
,"accessing","""keys
	" Return the keys of the receiver. "

	^keys copy""",nil)
smalltalk.bind(smalltalk.Dictionary,"keysDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Dictionary>>#keysDo:
	getattr(self,"@keys",nil).do_(aBlock) 
	return self 
""","Dictionary_keysDo_")
,"enumerating","""keysDo: aBlock
	" Evaluate aBlock with the keys of the receiver. "

	keys do: aBlock""",nil)
smalltalk.bind(smalltalk.Dictionary,"values",0
,smalltalk.__f__("""(self):
	#Dictionary>>#values
	return getattr(self,"@values",nil).copy() 
""","Dictionary_values")
,"accessing","""values
	" Return the values of the receiver. "

	^values copy""",nil)
smalltalk.bind(smalltalk.Dictionary,"at:put:",0
,smalltalk.__f__("""(self,aKey,aValue):
	#Dictionary>>#at:put:
	__0__=smalltalk.newContext()
	__0__.index=nil
	__0__.index=self.lookUpKey_(aKey) 
	if smalltalk.b(smalltalk.isNil_(__0__.index)):
		getattr(self,"@keys",nil).add_(aKey) 
		getattr(self,"@values",nil).add_(aValue) 
	else:
		getattr(self,"@values",nil).at_put_(__0__.index,aValue) 
	 
	return aValue 
""","Dictionary_at_put_")
,"accessing","""at: aKey put: aValue
	" Set the value at aKey of the receiver. "

	| index |
	index := self lookUpKey: aKey.
	index isNil
		ifTrue: [ keys add: aKey. values add: aValue.]
		ifFalse: [ values at: index put: aValue ].
	^aValue""",nil)
smalltalk.bind(smalltalk.Dictionary,"at:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#Dictionary>>#at:ifAbsent:
	__0__=smalltalk.newContext()
	__0__.index=nil
	__0__.index=self.lookUpKey_(aKey) 
	if smalltalk.b(smalltalk.isNil_(__0__.index)):
		return aBlock.value() 
	 
	return getattr(self,"@values",nil).at_(__0__.index) 
""","Dictionary_at_ifAbsent_")
,"accessing","""at: aKey ifAbsent: aBlock
	" Return the value at aKey or the result of evaluating aBlock. "

	| index |
	index := self lookUpKey: aKey.
	index isNil ifTrue: [ ^aBlock value ].
	^values at: index""",nil)
smalltalk.bind(smalltalk.Dictionary,"at:ifAbsentPut:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#Dictionary>>#at:ifAbsentPut:
	__0__=smalltalk.newContext()
	__0__.index=nil
	__0__.index=self.lookUpKey_(aKey) 
	if smalltalk.b(smalltalk.isNil_(__0__.index)):
		return self.at_put_(aKey,aBlock.value()) 
	 
	return getattr(self,"@values",nil).at_(__0__.index) 
""","Dictionary_at_ifAbsentPut_")
,"accessing","""at: aKey ifAbsentPut: aBlock
	" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. "

	| index |
	index := self lookUpKey: aKey.
	index isNil ifTrue: [ ^self at: aKey put: aBlock value ].
	^values at: index""",nil)
smalltalk.bind(smalltalk.Dictionary,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Dictionary>>#do:
	return getattr(self,"@values",nil).do_(aBlock) 
""","Dictionary_do_")
,"enumerating","""do: aBlock
	" Evaluates aBlock for all values in the receiver. "

	^values do: aBlock""",nil)
smalltalk.bind(smalltalk.Dictionary,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	#Dictionary>>#detect:ifNone:
	return getattr(self,"@values",nil).detect_ifNone_(aBlock,anotherBlock) 
""","Dictionary_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Detect the value who matches aBlock.
	Return the result of evaluating aBlock if no value matches detection block.
	"

	^values detect: aBlock ifNone: anotherBlock""",nil)
smalltalk.bind(smalltalk.Dictionary,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#Dictionary>>#includes:
	return getattr(self,"@values",nil).includes_(anObject) 
""","Dictionary_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^values includes: anObject""",nil)
smalltalk.bind(smalltalk.Dictionary,"includesKey:",0
,smalltalk.__f__("""(self,aKey):
	#Dictionary>>#includesKey:
	return getattr(self,"@keys",nil).includes_(aKey) 
""","Dictionary_includesKey_")
,"enumerating","""includesKey: aKey
	" Return true if the receiver's keys include aKey. "

	^keys includes: aKey""",nil)
smalltalk.bind(smalltalk.Dictionary,"removeKey:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#Dictionary>>#removeKey:ifAbsent:
	__0__=smalltalk.newContext()
	__0__.index=nil
	__0__.index=self.lookUpKey_(aKey) 
	if smalltalk.b(smalltalk.isNil_(__0__.index)):
		return aBlock.value() 
	 
	getattr(self,"@keys",nil).removeIndex_(__0__.index) 
	getattr(self,"@values",nil).removeIndex_(__0__.index) 
	return self 
""","Dictionary_removeKey_ifAbsent_")
,"removing","""removeKey: aKey ifAbsent: aBlock
	" Remove the binding at aKey. "

	| index |
	index := self lookUpKey: aKey.
	index isNil ifTrue: [ ^aBlock value ].
	keys removeIndex: index.
	values removeIndex: index.""",nil)
smalltalk.bind(smalltalk.Dictionary,"keyForValue:ifAbsent:",0
,smalltalk.__f__("""(self,anObject,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#Dictionary>>#keyForValue:ifAbsent:
		def __blk1__(key,aValue):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,key) 
			return smalltalk.if_true_false_(smalltalk.b_(anObject is aValue),smalltalk.blk(__blk2__,0),nil) 
		self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,aBlock.value()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Dictionary_keyForValue_ifAbsent_")
,"accessing","""keyForValue: anObject ifAbsent: aBlock
	" Return the key in the receiver for value anObject, or the result of evaluating aBlock. "

	self keysAndValuesDo: [:key :aValue| anObject == aValue ifTrue: [ ^key ] ].
	^aBlock value""",nil)
smalltalk.bind(smalltalk.Dictionary,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#Dictionary>>#asNative:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String(":") 
	def __blk2__():
		return smalltalk.String(".") 
	__0__.send=nil
	__0__.send=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(lang,smalltalk.String("lua")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),__0__.send),smalltalk.String("fromKeys_and_(")),getattr(self,"@keys",nil).asArray().asNative_(lang)),smalltalk.String(",")),getattr(self,"@values",nil).asNative_(lang)),smalltalk.String(")")) 
""","Dictionary_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	| send |
	send := lang = #lua ifTrue: [$:] ifFalse: [$.].
	^'smalltalk.' ,self class name
		,send ,'fromKeys_and_('
			,(keys asArray asNative: lang)
			,',' ,(values asNative: lang)
		,')'""",nil)
smalltalk.bind(smalltalk.Dictionary,"asPython",0
,smalltalk.__f__("""(self):
	#Dictionary>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),smalltalk.String(".fromKeys_and_(")),getattr(self,"@keys",nil).asArray().asPython()),smalltalk.String(",")),getattr(self,"@values",nil).asPython()),smalltalk.String(")")) 
""","Dictionary_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.' ,self class name
	, '.fromKeys_and_('
		, keys asArray asPython
		,',' ,values asPython
	,')'""",nil)
smalltalk.bind(smalltalk.PoolDictionary.__class__,"@@","_at_at"
,smalltalk.__f__("""(self,aHash):
	#PoolDictionary class>>#@@
	def __blk1__(_s8_rec):
		_s8_rec.instVarAt_put_(smalltalk.String("hash"),aHash) 
		return _s8_rec.yourself() 
	return __blk1__(self.basicNew()) 
""","PoolDictionary_class__at_at")
,"instantiation","""@@ aHash
	" Return an instance of the receiver. "
	" The instance will hack aHash violating encapsulation of aHash and instance.
	 Both will share internal state. "

	^self basicNew
		instVarAt: #hash put: aHash;
		yourself""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"initialize",0
,smalltalk.__f__("""(self):
	#PoolDictionary>>#initialize
	smalltalk.superReceiver(smalltalk.PoolDictionary,self).initialize() 
	smalltalk.basic_at_put(self,"@hash",self.newHash()) 
	return self 
""","PoolDictionary_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	hash := self newHash.""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"validKey:",0
,smalltalk.__f__("""(self,aKey):
	#PoolDictionary>>#validKey:
	
	return aKey 
""","PoolDictionary_validKey_")
,"initialize","""validKey: aKey
	" Private - Returns a valid key to store a value in the receiver. "

	{'self'}."macro hook"
	"(self typeOf: aKey) = #string ifFalse: [ ^self error: 'Invalid key (must be aString).' ]."
	^aKey """,nil)
smalltalk.bind(smalltalk.PoolDictionary,"at:put:",0
,smalltalk.__f__("""(self,aKey,aValue):
	#PoolDictionary>>#at:put:
	smalltalk.basic_at_put(self,"@size",nil) 
	if True:
		return smalltalk.pool_at_put_(self, aKey, aValue)
	 
	smalltalk.basic_at_put_(getattr(self,"@hash",nil),self.validKey_(aKey),self.wrap_(aValue)) 
	return aValue 
""","PoolDictionary_at_put_")
,"accessing","""at: aKey put: aValue
	" Set the value at aKey of the receiver. "

	size := nil.
	{'self'}."macro hook"
	hash	basicAt: (self validKey: aKey)
		put: (self wrap: aValue).
	^aValue""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"removeKey:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#PoolDictionary>>#removeKey:ifAbsent:
	if not smalltalk.b(self.includesKey_(aKey)):
		return aBlock.value() 
	 
	smalltalk.basic_at_put(self,"@size",nil) 
	smalltalk.pool_removeKey_(self, aKey) 
	return self 
""","PoolDictionary_removeKey_ifAbsent_")
,"removing","""removeKey: aKey ifAbsent: aBlock
	" Remove the binding at aKey. "

	(self includesKey: aKey) ifFalse: [ ^aBlock value ].
	size := nil.
	{''js'delete self["@hash"][aKey]'}""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"size",0
,smalltalk.__f__("""(self):
	#PoolDictionary>>#size
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@size",nil))):
		smalltalk.basic_at_put(self,"@size",self.keys().size()) 
	 
	return getattr(self,"@size",nil) 
""","PoolDictionary_size")
,"accessing","""size
	" Return the size of the receiver. "

	size isNil ifTrue: [ size := self keys size ].
	^size""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"at:ifAbsent:",0
,smalltalk.__f__("""(self,aKey,aBlock):
	#PoolDictionary>>#at:ifAbsent:
	if True:
		return smalltalk.pool_at_ifAbsent_(self, aKey, aBlock)
	 
	return self 
""","PoolDictionary_at_ifAbsent_")
,"accessing","""at: aKey ifAbsent: aBlock
	" Return the value at aKey or the result of evaluating aBlock. "

	{''js'var found = Object.prototype.hasOwnProperty.call(self["@hash"],aKey);
	if(found) return self["@hash"][aKey];
	return aBlock.value()'}""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"includesKey:",0
,smalltalk.__f__("""(self,aKey):
	#PoolDictionary>>#includesKey:
	return smalltalk.pool_includesKey_(self, aKey) 
""","PoolDictionary_includesKey_")
,"testing","""includesKey: aKey
	" Return true if the receiver's keys include aKey. "

	^{''js'Object.prototype.hasOwnProperty.call(self["@hash"],aKey)'}""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"keys",0
,smalltalk.__f__("""(self):
	#PoolDictionary>>#keys
	if True:
		return smalltalk.pool_keys(self)
	 
	return self 
""","PoolDictionary_keys")
,"accessing","""keys
	" Return the keys of the receiver. "

	{''js'return Object.getOwnPropertyNames(self["@hash"])'}""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"keysAndValuesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#PoolDictionary>>#keysAndValuesDo:
	def __blk1__(key):
		return aBlock.value_value_(key,self.at_(key)) 
	self.keysDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","PoolDictionary_keysAndValuesDo_")
,"enumerating","""keysAndValuesDo: aBlock
	" Evaluate aBlock for key/value pairs of the receiver. "

	self keysDo: [:key |
		aBlock value: key value: (self at: key)
	]""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"values",0
,smalltalk.__f__("""(self):
	#PoolDictionary>>#values
	def __blk1__(key):
		return self.at_(key) 
	return self.keys().collect_(smalltalk.blk(__blk1__,1)) 
""","PoolDictionary_values")
,"accessing","""values
	" Return the values of the receiver. "

	^self keys collect: [:key| self at: key ]""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"asNative:",0
,smalltalk.__f__("""(self,lang):
	#PoolDictionary>>#asNative:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String(":") 
	def __blk2__():
		return smalltalk.String(".") 
	__0__.send=nil
	__0__.send=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(lang,smalltalk.String("lua")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),__0__.send),smalltalk.String("fromTuples_(")),self.tuples().asNative_(lang)),smalltalk.String(")")) 
""","PoolDictionary_asNative_")
,"converting","""asNative: lang
	" Return the native representation of the receiver. "

	| send |
	send := lang = #lua ifTrue: [$:] ifFalse: [$.].
	^'smalltalk.' ,self class name
		,send ,'fromTuples_('
		,(self tuples asNative: lang)
		,')'""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"detect:ifNone:",0
,smalltalk.__f__("""(self,aBlock,anotherBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#PoolDictionary>>#detect:ifNone:
		def __blk1__(key,value):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,value) 
			return smalltalk.if_true_false_(aBlock.value_(value),smalltalk.blk(__blk2__,0),nil) 
		self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,anotherBlock.value()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PoolDictionary_detect_ifNone_")
,"enumerating","""detect: aBlock ifNone: anotherBlock
	" Detect the value who matches aBlock.
	Return the result of evaluating aBlock if no value matches detection block.
	"

	self keysAndValuesDo: [:key :value |
		(aBlock value: value) ifTrue: [ ^value ]
	].
	^anotherBlock value""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#PoolDictionary>>#do:
	def __blk1__(key,value):
		return aBlock.value_(value) 
	self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
	return self 
""","PoolDictionary_do_")
,"enumerating","""do: aBlock
	" Evaluates aBlock for all values in the receiver. "

	self keysAndValuesDo: [:key :value | aBlock value: value ]""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"includes:",0
,smalltalk.__f__("""(self,anObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#PoolDictionary>>#includes:
		def __blk1__(key,value):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(anObject,value),smalltalk.blk(__blk2__,0),nil) 
		self.keysAndValuesDo_(smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PoolDictionary_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	self keysAndValuesDo: [:key :value |
		anObject = value ifTrue: [ ^true ].
	].
	^false""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"keysDo:",0
,smalltalk.__f__("""(self,aBlock):
	#PoolDictionary>>#keysDo:
	self.keys().do_(aBlock) 
	return self 
""","PoolDictionary_keysDo_")
,"enumerating","""keysDo: aBlock
	" Evaluate aBlock with the keys of the receiver. "

	self keys do: aBlock""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"@","_at"
,smalltalk.__f__("""(self,keyOrPath):
	_s8Ret_=smalltalk.newContext()
	try:
		#PoolDictionary>>#@
		__0__=smalltalk.newContext()
		def __blk1__(pool,key):
			__1__=smalltalk.newContext()
			__1__.value=nil
			__1__.value=pool._at(key)
			if smalltalk.b(smalltalk.isNil_((__1__.value))):
				smalltalk.raise_result_(_s8Ret_,nil) 
			 
			return __1__.value 
		__0__.result=nil
		if not smalltalk.b(keyOrPath.isArray()):
			def __blk2__():
				nil 
			smalltalk.raise_result_(_s8Ret_,self.at_ifAbsent_(keyOrPath,smalltalk.blk(__blk2__,0))) 
		 
		__0__.result=keyOrPath.inject_into_(self,smalltalk.blk(__blk1__,2)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PoolDictionary__at")
,"accessing","""@ keyOrPath
	" Return the result of accessing the receiver at key or path (or nil). "

	| result |
	keyOrPath isArray ifFalse: [ ^self at: keyOrPath ifAbsent: [] ].
	result := keyOrPath inject: self into: [:pool :key | | value |
		(value := pool @ key) isNil ifTrue: [ ^nil ].
		value
	].
	^result""",nil)
smalltalk.bind(smalltalk.PoolDictionary,"asPython",0
,smalltalk.__f__("""(self):
	#PoolDictionary>>#asPython
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),(self).__class__.name()),smalltalk.String(".fromTuples_(")),self.tuples().asPython()),smalltalk.String(")")) 
""","PoolDictionary_asPython")
,"Python-py","""asPython
	" Return the native representation of the receiver. "

	^'smalltalk.',self class name
	, '.fromTuples_('
		, self tuples asPython
	,')'""",nil)
smalltalk.bind(smalltalk.RegularExpression.__class__,"fromString:flag:",0
,smalltalk.__f__("""(self,aString,anotherString):
	#RegularExpression class>>#fromString:flag:
	return self.notImplementedYet_(smalltalk.String("RegularExpression>>#fromString:flag:")) 
""","RegularExpression_class_fromString_flag_")
,"instantiation","""fromString: aString flag: anotherString
	" Return an instance of the receiver. "

	^{''js'new RegExp(aString, anotherString)'}""",nil)
smalltalk.bind(smalltalk.RegularExpression.__class__,"fromString:",0
,smalltalk.__f__("""(self,aString):
	#RegularExpression class>>#fromString:
	return self.fromString_flag_(aString,smalltalk.String("")) 
""","RegularExpression_class_fromString_")
,"instantiation","""fromString: aString
	" Return an instance of the receiver. "

	    ^self fromString: aString flag: ''""",nil)
smalltalk.bind(smalltalk.RegularExpression,"compile:",0
,smalltalk.__f__("""(self,aString):
	#RegularExpression>>#compile:
	return self.compile(aString) 
""","RegularExpression_compile_")
,"evaluating","""compile: aString
	" Return the result of compilation of aString. "

	^self #compile: aString""",nil)
smalltalk.bind(smalltalk.RegularExpression,"exec:",0
,smalltalk.__f__("""(self,aString):
	#RegularExpression>>#exec:
	return self.exec(aString) 
""","RegularExpression_exec_")
,"evaluating","""exec: aString
	" Return the result of excecution of aString. "

	^self #exec: aString""",nil)
smalltalk.bind(smalltalk.RegularExpression,"test:",0
,smalltalk.__f__("""(self,aString):
	#RegularExpression>>#test:
	return self.test(aString) 
""","RegularExpression_test_")
,"evaluating","""test: aString
	" Return the result of testing of aString. "

	^self #test: aString""",nil)
smalltalk.bind(smalltalk.RegularExpression,"shallowCopy",0
,smalltalk.__f__("""(self):
	#RegularExpression>>#shallowCopy
	return self 
""","RegularExpression_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.RegularExpression,"deepCopy",0
,smalltalk.__f__("""(self):
	#RegularExpression>>#deepCopy
	return self 
""","RegularExpression_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.RegularExpression,"asJSONObject",0
,smalltalk.__f__("""(self):
	#RegularExpression>>#asJSONObject
	return self 
""","RegularExpression_asJSONObject")
,"json","""asJSONObject
	" Return the receiver as a hash object. "

	^self""",nil)
smalltalk.bind(smalltalk.Exception,"nativeException",0
,smalltalk.__f__("""(self):
	#Exception>>#nativeException
	return smalltalk.basic_at_(self,smalltalk.String("@nativeException")) 
""","Exception_nativeException")
,"private","""nativeException
	" Private, Internal - Return the native exception associated with the receiver (or nil). "

	^self basicAt: '@nativeException'""",nil)
smalltalk.bind(smalltalk.Exception,"nativeException:",0
,smalltalk.__f__("""(self,nex):
	#Exception>>#nativeException:
	return smalltalk.basic_at_put_(self,smalltalk.String("@nativeException"),nex) 
""","Exception_nativeException_")
,"private","""nativeException: nex
	" Private, Internal - Set the native exception associated with the receiver. "

	^self basicAt: '@nativeException' put: nex""",nil)
smalltalk.bind(smalltalk.Exception,"stack",0
,smalltalk.__f__("""(self):
	#Exception>>#stack
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.String("") 
	def __blk2__():
		return __0__.stk 
	__0__.nex=nil
	__0__.stk=nil
	__0__.nex=self.nativeException() 
	if smalltalk.b(smalltalk.isNil_(__0__.nex)):
		return smalltalk.String("") 
	 
	__0__.stk=smalltalk.basic_at_(__0__.nex,smalltalk.String("stack")) 
	return smalltalk.if_true_false_(smalltalk.isNil_(__0__.stk),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Exception_stack")
,"stack","""stack
	" Private - Return a stack trace string (or an empty string). "

	| nex stk |
	nex := self nativeException.
	nex isNil ifTrue: [ ^'' ].
	stk := nex basicAt: #stack.
	^stk isNil ifTrue: [''] ifFalse: [stk]""",nil)
smalltalk.bind(smalltalk.Exception,"toString",0
,smalltalk.__f__('''(self):
	#Exception>>#toString
	__0__=smalltalk.newContext()
	__0__.txt=nil
	__0__.stk=nil
	__0__.txt=self.messageText() 
	if smalltalk.b(smalltalk.isNil_(__0__.txt)):
		__0__.txt=smalltalk.String("") 
	 
	__0__.stk=self.stack() 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.stk.size(),smalltalk.Number(0))):
		__0__.stk=smalltalk.String("") 
	else:
		__0__.stk=smalltalk.object_comma_(smalltalk.String("""
	"""),__0__.stk) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("{st: "),self.description()),smalltalk.String("}")),__0__.stk) 
''',"Exception_toString")
,"converting","""toString
	" Return the receiver as a String. "

	| txt stk |
	txt := self messageText.
	txt isNil ifTrue: [ txt := '' ].
	stk := self stack.
	stk size = 0
	ifTrue: [ stk := '' ]
	ifFalse: [ stk := '
'		,stk ].
	^'{st: ' ,self description ,$} ,stk""",nil)
smalltalk.bind(smalltalk.Exception,"messageText",0
,smalltalk.__f__("""(self):
	#Exception>>#messageText
	return getattr(self,"@messageText",nil) 
""","Exception_messageText")
,"accessing","""messageText
	" Return the messageText of the receiver. "

	^messageText""",nil)
smalltalk.bind(smalltalk.Exception,"description",0
,smalltalk.__f__("""(self):
	#Exception>>#description
	__0__=smalltalk.newContext()
	__0__.txt=nil
	__0__.txt=self.messageText() 
	if smalltalk.b(smalltalk.isNil_(__0__.txt)):
		__0__.txt=self.nativeException() 
	 
	__0__.txt=self.toString_(__0__.txt) 
	return smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" - ")),__0__.txt) 
""","Exception_description")
,"accessing","""description
	" Return the description of the receiver. "

	| txt |
	txt := self messageText.
	txt isNil ifTrue: [ txt := self nativeException ].
	txt := self toString: txt.
	^self class name ,' - ' ,txt """,nil)
smalltalk.bind(smalltalk.Exception,"messageText:",0
,smalltalk.__f__("""(self,aString):
	#Exception>>#messageText:
	smalltalk.basic_at_put(self,"@messageText",aString) 
	return self 
""","Exception_messageText_")
,"accessing","""messageText: aString
	" Set the messageText of the receiver. "

	messageText := aString""",nil)
smalltalk.bind(smalltalk.Exception,"signal",0
,smalltalk.__f__("""(self):
	#Exception>>#signal
	self.note_(self.description()) 
	raise Exception(self) 
	return self 
""","Exception_signal")
,"signaling","""signal
	" Signal/throw the receiver. "

	self note: self description.
	{''js'throw(self)'}""",nil)
smalltalk.bind(smalltalk.Exception,"__tostring",0
,smalltalk.__f__("""(self):
	#Exception>>#__tostring
	return smalltalk.to_String(self) 
""","Exception___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Error.__class__,"signal:",0
,smalltalk.__f__("""(self,aString):
	#Error class>>#signal:
	def __blk1__(_s8_rec):
		_s8_rec.messageText_(aString) 
		return _s8_rec.signal() 
	return __blk1__(self.new()) 
""","Error_class_signal_")
,"instantiation","""signal: aString
	" Signal an instance of the receiver. "

	^self new
		messageText: aString;
		signal""",nil)
smalltalk.bind(smalltalk.MessageNotUnderstood,"message",0
,smalltalk.__f__("""(self):
	#MessageNotUnderstood>>#message
	return getattr(self,"@message",nil) 
""","MessageNotUnderstood_message")
,"accessing","""message
	" Return the message of the receiver. "

	^message""",nil)
smalltalk.bind(smalltalk.MessageNotUnderstood,"message:",0
,smalltalk.__f__("""(self,aMessage):
	#MessageNotUnderstood>>#message:
	smalltalk.basic_at_put(self,"@message",aMessage) 
	return self 
""","MessageNotUnderstood_message_")
,"accessing","""message: aMessage
	" Set the message of the receiver. "

	message := aMessage""",nil)
smalltalk.bind(smalltalk.MessageNotUnderstood,"receiver",0
,smalltalk.__f__("""(self):
	#MessageNotUnderstood>>#receiver
	return getattr(self,"@receiver",nil) 
""","MessageNotUnderstood_receiver")
,"accessing","""receiver
	" Return the receiver of the receiver. "

	^receiver""",nil)
smalltalk.bind(smalltalk.MessageNotUnderstood,"receiver:",0
,smalltalk.__f__("""(self,anObject):
	#MessageNotUnderstood>>#receiver:
	smalltalk.basic_at_put(self,"@receiver",anObject) 
	return self 
""","MessageNotUnderstood_receiver_")
,"accessing","""receiver: anObject
	" Set the receiver of the receiver. "

	receiver := anObject""",nil)
smalltalk.bind(smalltalk.MessageNotUnderstood,"messageText",0
,smalltalk.__f__("""(self):
	#MessageNotUnderstood>>#messageText
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.object_comma_(smalltalk.String("instance of "),(getattr(self,"@receiver",nil)).__class__.name()) 
	def __blk2__():
		return smalltalk.String("native object") 
	def __blk3__():
		return getattr(self,"@message",nil).asLiteral() 
	def __blk4__():
		return getattr(self,"@message",nil).selector() 
	__0__.type=nil
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@message",nil))):
		return smalltalk.String("unknown") 
	 
	__0__.type=smalltalk.if_true_false_(self.isObject_(getattr(self,"@receiver",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.if_true_false_(getattr(self,"@message",nil).isString(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)),smalltalk.String(" not understood by ")),__0__.type) 
""","MessageNotUnderstood_messageText")
,"accessing","""messageText
	" Return the message text of the receiver. "

	| type |
	message isNil ifTrue: [ ^#unknown ].
	type := (self isObject: receiver)
		ifTrue: [ 'instance of ' ,receiver class name ]
		ifFalse: [ 'native object' ].
	^(message isString
		ifTrue: [ message asLiteral ]
		ifFalse: [ message selector ])
		,' not understood by ' ,type""",nil)
smalltalk.bind(smalltalk.Association.__class__,"key:",0
,smalltalk.__f__("""(self,aKey):
	#Association class>>#key:
	return self.new().key_(aKey) 
""","Association_class_key_")
,"instantiation","""key: aKey
	" Return an instance of the receiver. "

	^self new key: aKey""",nil)
smalltalk.bind(smalltalk.Association.__class__,"key:value:",0
,smalltalk.__f__("""(self,aKey,aValue):
	#Association class>>#key:value:
	return self.key_(aKey).value_(aValue) 
""","Association_class_key_value_")
,"instantiation","""key: aKey value: aValue
	" Return an instance of the receiver. "

	^(self key: aKey) value: aValue""",nil)
smalltalk.bind(smalltalk.Association,"=","_eq"
,smalltalk.__f__("""(self,anAssociation):
	#Association>>#=
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(self.value(),anAssociation.value()) 
		return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(self.key(),anAssociation.key()),smalltalk.blk(__blk2__,0)) 
	return smalltalk.boolean_and_(smalltalk.isObject_equalTo_((self).__class__,(anAssociation).__class__),smalltalk.blk(__blk1__,0)) 
""","Association__eq")
,"comparing","""= anAssociation
	" Return true if the receiver is equal to argument. "

	^self class = anAssociation class and: [
	    self key = anAssociation key and: [
		self value = anAssociation value]]""",nil)
smalltalk.bind(smalltalk.Association,"key:",0
,smalltalk.__f__("""(self,aKey):
	#Association>>#key:
	smalltalk.basic_at_put(self,"@key",aKey) 
	return self 
""","Association_key_")
,"accessing","""key: aKey
	" Set the key of the receiver. "

	key := aKey""",nil)
smalltalk.bind(smalltalk.Association,"key",0
,smalltalk.__f__("""(self):
	#Association>>#key
	return getattr(self,"@key",nil) 
""","Association_key")
,"accessing","""key
	" Return the key of the receiver. "

	^key""",nil)
smalltalk.bind(smalltalk.Association,"value:",0
,smalltalk.__f__("""(self,aValue):
	#Association>>#value:
	smalltalk.basic_at_put(self,"@value",aValue) 
	return self 
""","Association_value_")
,"accessing","""value: aValue
	" Set the value of the receiver. "

	value := aValue""",nil)
smalltalk.bind(smalltalk.Association,"value",0
,smalltalk.__f__("""(self):
	#Association>>#value
	return getattr(self,"@value",nil) 
""","Association_value")
,"accessing","""value
	" Return the value of the receiver. "

	^value""",nil)
smalltalk.bind(smalltalk.Association,",","_comma"
,smalltalk.__f__("""(self,anAssociation):
	#Association>>#,
	return smalltalk.ComposedAssociations.with_with_(self,anAssociation) 
""","Association__comma")
,"composing",""", anAssociation
	" Return the receiver composed with the argument. "

	^ComposedAssociations with: self with: anAssociation""",nil)
smalltalk.bind(smalltalk.Association,"json",0
,smalltalk.__f__("""(self):
	#Association>>#json
	return smalltalk.ComposedAssociations.with_(self).json() 
""","Association_json")
,"converting","""json
	" Return the receiver as a hash object. "

	^(ComposedAssociations with: self) json""",nil)
smalltalk.bind(smalltalk.Association,"isAssociation",0
,smalltalk.__f__("""(self):
	#Association>>#isAssociation
	return smalltalk.true 
""","Association_isAssociation")
,"testing","""isAssociation
	" Return true if the receiver is anAssociation. "

	^true""",nil)
smalltalk.bind(smalltalk.Association,"printString",0
,smalltalk.__f__("""(self):
	#Association>>#printString
	return smalltalk.to_String(self) 
""","Association_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^self toString """,nil)
smalltalk.bind(smalltalk.Association,"toString",0
,smalltalk.__f__("""(self):
	#Association>>#toString
	__0__=smalltalk.newContext()
	def __blk1__(x):
		def __blk2__():
			def __blk3__():
				return smalltalk.String("nil") 
			def __blk4__():
				def __blk5__():
					return x.asLiteral() 
				def __blk6__():
					return self.toString_(x) 
				return smalltalk.if_true_false_(self.isObject_(x),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
			return smalltalk.if_true_false_(smalltalk.isNil_(x),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
		def __blk7__(ex):
			return smalltalk.object_comma_(smalltalk.String("??? "),ex.description()) 
		return smalltalk.blk(__blk2__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk7__,1)) 
	__0__.string=nil
	__0__.string=smalltalk.blk(__blk1__,1) 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("("),__0__.string.value_(getattr(self,"@key",nil))),smalltalk.String(" -> ")),__0__.string.value_(getattr(self,"@value",nil))),smalltalk.String(")")) 
""","Association_toString")
,"converting","""toString
	" Return the receiver as a String. "

	| string |
	string := [:x| [
		x isNil ifTrue: [ #nil ] ifFalse: [
			(self isObject: x) ifTrue: [ x asLiteral ]
			ifFalse: [ self toString: x ] ]
		] on: Exception do: [:ex| '??? ' ,ex description ] ].
	^$( ,(string value: key) ,' -> ' ,(string value: value) ,$)""",nil)
smalltalk.bind(smalltalk.Association,"__tostring",0
,smalltalk.__f__("""(self):
	#Association>>#__tostring
	return smalltalk.to_String(self) 
""","Association___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:",0
,smalltalk.__f__("""(self,aClass,aString):
	#ClassBuilder>>#superclass:subclass:
	return self.superclass_subclass_instanceVariableNames_category_(aClass,aString,smalltalk.String(""),nil) 
""","ClassBuilder_superclass_subclass_")
,"instantiation","""superclass: aClass subclass: aString
	" Create/Register a new class in the system. "

	^self
		superclass: aClass
		subclass: aString
		instanceVariableNames: ''
		category: nil""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,smalltalk.__f__("""(self,aClass,aString,aString2,classVarNames,poolVarNames,aString3):
	#ClassBuilder>>#superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return smalltalk.String("unclassified") 
		def __blk3__():
			return aClass.category() 
		return smalltalk.if_true_false_(smalltalk.isNil_(aClass),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	def __blk4__():
		return aString3 
	def __blk5__(_s8_rec):
		_s8_rec.classVariableNames_(classVarNames) 
		_s8_rec.poolDictionaryNames_(poolVarNames) 
		return _s8_rec.category_(__0__.aCategory) 
	def __blk6__():
		return smalltalk.Smalltalk.includesKey_(smalltalk.String("Exporter")) 
	__0__.result=nil
	__0__.aCategory=nil
	__0__.aCategory=smalltalk.if_true_false_(smalltalk.isNil_(aString3),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk4__,0)) 
	__0__.result=self.addSubclassOf_named_instanceVariableNames_(aClass,aString,self.instanceVariableNamesFor_(aString2)) 
	self.setupClass_(__0__.result) 
	__blk5__(__0__.result) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aClass),smalltalk.blk(__blk6__,0))):
		self.print_(smalltalk.Exporter.new().exportNew_(__0__.result)) 
	 
	return __0__.result 
""","ClassBuilder_superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_")
,"instantiation","""superclass: aClass
	subclass: aString
	instanceVariableNames: aString2
	classVariableNames: classVarNames
	poolDictionaries: poolVarNames
	category: aString3
	" Create/Register a new class in the system. "

	| result aCategory |
	aCategory := aString3 isNil ifTrue: [
			aClass isNil ifTrue: [ #unclassified ]
			ifFalse: [ aClass category ]
		] ifFalse: [ aString3 ].
	result := self
		addSubclassOf: aClass named: aString
		instanceVariableNames: (self instanceVariableNamesFor: aString2).
	self setupClass: result.
	result 
		classVariableNames: classVarNames;
		poolDictionaryNames: poolVarNames;
		category: aCategory.
	(aClass notNil and: [ Smalltalk includesKey: #Exporter ]) ifTrue: [
		self print: (Exporter new exportNew: result)
	].
	^result""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:category:",0
,smalltalk.__f__("""(self,aClass,aString,aString2,aString3):
	#ClassBuilder>>#superclass:subclass:instanceVariableNames:category:
	return self.superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass,aString,aString2,smalltalk.String(""),smalltalk.String(""),aString3) 
""","ClassBuilder_superclass_subclass_instanceVariableNames_category_")
,"instantiation","""superclass: aClass
	subclass: aString
	instanceVariableNames: aString2
	category: aString3
	" Create/Register a new class in the system. "

	^self
		superclass: aClass
		subclass: aString
		instanceVariableNames: aString2
		classVariableNames: ''
		poolDictionaries: ''
		category: aString3""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"basicClass:instanceVariableNames:",0
,smalltalk.__f__("""(self,aMetaClass,anArray):
	#ClassBuilder>>#basicClass:instanceVariableNames:
	return self.smalltalk().metaVarNames(aMetaClass,anArray) 
""","ClassBuilder_basicClass_instanceVariableNames_")
,"private","""basicClass: aMetaClass instanceVariableNames: anArray
	" Private - Register instance variables onto aMetaClass. "

	^self smalltalk #metaVarNames: aMetaClass array: anArray""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"class:instanceVariableNames:",0
,smalltalk.__f__("""(self,aMetaClass,aString):
	_s8Ret_=smalltalk.newContext()
	try:
		#ClassBuilder>>#class:instanceVariableNames:
		__0__=smalltalk.newContext()
		__0__.varNames=nil
		if not smalltalk.b(aMetaClass.isMetaclass()):
			return self.error_(smalltalk.object_comma_(aMetaClass.name(),smalltalk.String(" is not a metaclass"))) 
		 
		__0__.varNames=self.instanceVariableNamesFor_(aString) 
		if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.varNames,aMetaClass.instanceVariableNames())):
			def __blk1__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			smalltalk.if_true_false_(self.basicClass_instanceVariableNames_(aMetaClass,__0__.varNames),nil,smalltalk.blk(__blk1__,0)) 
		 
		self.setupClass_(aMetaClass) 
		if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("Exporter"))):
			self.print_(smalltalk.Exporter.new().exportMetaDefinitionOf_(aMetaClass.instanceClass())) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","ClassBuilder_class_instanceVariableNames_")
,"metaclass","""class: aMetaClass instanceVariableNames: aString
	" Register instance variable names onto aMetaClass. "

	| varNames |
	aMetaClass isMetaclass ifFalse: [
		^self error: aMetaClass name, ' is not a metaclass'
	].
	varNames := self instanceVariableNamesFor: aString.
	varNames = aMetaClass instanceVariableNames ifFalse: [
		(self basicClass: aMetaClass instanceVariableNames: varNames) ifFalse: [ ^false ].
	].
	self setupClass: aMetaClass.
	(Smalltalk includesKey: #Exporter) ifTrue: [
		self print: (Exporter new exportMetaDefinitionOf: aMetaClass instanceClass)
	].
	^true """,nil)
smalltalk.bind(smalltalk.ClassBuilder,"instanceVariableNamesFor:",0
,smalltalk.__f__("""(self,aString):
	#ClassBuilder>>#instanceVariableNamesFor:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=aString.asArrayOfSubstrings() 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.result.size(),__0__.result.asSet().size())):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid instance variable names "),__0__.result.asLiteral())) 
	 
	return __0__.result 
""","ClassBuilder_instanceVariableNamesFor_")
,"private","""instanceVariableNamesFor: aString
	" Private - Return the instance variable names string. "

	| result |
	result := aString asArrayOfSubstrings.
	result size = result asSet size ifFalse: [
		^self error: 'Invalid instance variable names ' ,result asLiteral
	].
	^result""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"addSubclassOf:named:instanceVariableNames:",0
,smalltalk.__f__("""(self,aClass,aString,aCollection):
	#ClassBuilder>>#addSubclassOf:named:instanceVariableNames:
	aName = str(smalltalk.handleOf(aString))
	smalltalk.addClass(aName, aClass, aCollection)
	if True:
		return getattr(smalltalk,aName,nil)
	 
	return self 
""","ClassBuilder_addSubclassOf_named_instanceVariableNames_")
,"private","""addSubclassOf: aClass named: aString instanceVariableNames: aCollection
	" Private - Add the subclass to system. "

	{''js'smalltalk.addClass(aString, aClass, aCollection);
	return smalltalk[aString]'}""",nil)
smalltalk.bind(smalltalk.ClassBuilder,"setupClass:",0
,smalltalk.__f__("""(self,aClass):
	#ClassBuilder>>#setupClass:
	return self 
""","ClassBuilder_setupClass_")
,"private","""setupClass: aClass
	" Private - Bind/initialize the class delegation chain. \"""",nil)
smalltalk.bind(smalltalk.Stream.__class__,"on:",0
,smalltalk.__f__("""(self,aCollection):
	#Stream class>>#on:
	def __blk1__(_s8_rec):
		_s8_rec.collection_(aCollection) 
		_s8_rec.readLimit_(aCollection.size()) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Stream_class_on_")
,"instantiation","""on: aCollection
	" Return an instance of the receiver. "

	^self new 
		collection: aCollection;
		readLimit: aCollection size;
		yourself""",nil)
smalltalk.bind(smalltalk.Stream,"collection",0
,smalltalk.__f__("""(self):
	#Stream>>#collection
	return getattr(self,"@collection",nil) 
""","Stream_collection")
,"accessing","""collection
	" Private - Return the collection of the receiver. "

	^collection""",nil)
smalltalk.bind(smalltalk.Stream,"collection:",0
,smalltalk.__f__("""(self,aCollection):
	#Stream>>#collection:
	smalltalk.basic_at_put(self,"@collection",aCollection) 
	return self 
""","Stream_collection_")
,"accessing","""collection: aCollection
	" Private - Set the collection of the receiver. "

	collection := aCollection""",nil)
smalltalk.bind(smalltalk.Stream,"setCollection:",0
,smalltalk.__f__("""(self,aCollection):
	#Stream>>#setCollection:
	self.collection_(aCollection) 
	return self 
""","Stream_setCollection_")
,"accessing","""setCollection: aCollection
	" Private - Set the receiver stream collection to aCollection. "

	self collection: aCollection""",nil)
smalltalk.bind(smalltalk.Stream,"initialize",0
,smalltalk.__f__("""(self):
	#Stream>>#initialize
	smalltalk.superReceiver(smalltalk.Stream,self).initialize() 
	smalltalk.basic_at_put(self,"@position",smalltalk.Number(0)) 
	return self 
""","Stream_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	position := 0.""",nil)
smalltalk.bind(smalltalk.Stream,"position",0
,smalltalk.__f__("""(self):
	#Stream>>#position
	return getattr(self,"@position",nil) 
""","Stream_position")
,"accessing","""position
	" Return the position of the receiver. "

	^position""",nil)
smalltalk.bind(smalltalk.Stream,"position:",0
,smalltalk.__f__("""(self,anInteger):
	#Stream>>#position:
	smalltalk.basic_at_put(self,"@position",anInteger) 
	return self 
""","Stream_position_")
,"accessing","""position: anInteger
	" Set the position of the receiver. "

	position := anInteger""",nil)
smalltalk.bind(smalltalk.Stream,"readLimit",0
,smalltalk.__f__("""(self):
	#Stream>>#readLimit
	if smalltalk.b(smalltalk.b_(getattr(self,"@readLimit",nil) is nil)):
		smalltalk.basic_at_put(self,"@readLimit",self.collection().size()) 
	 
	return getattr(self,"@readLimit",nil) 
""","Stream_readLimit")
,"accessing","""readLimit
	" Private - Return the read limit of the receiver. "

	readLimit == nil ifTrue: [ readLimit := self collection size ].
	^readLimit""",nil)
smalltalk.bind(smalltalk.Stream,"readLimit:",0
,smalltalk.__f__("""(self,anInteger):
	#Stream>>#readLimit:
	smalltalk.basic_at_put(self,"@readLimit",anInteger) 
	return self 
""","Stream_readLimit_")
,"accessing","""readLimit: anInteger
	" Private - Set the stream size of the receiver. "

	readLimit := anInteger""",nil)
smalltalk.bind(smalltalk.Stream,"contents",0
,smalltalk.__f__("""(self):
	#Stream>>#contents
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.collection() 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.readLimit(),__0__.result.size())):
		return __0__.result 
	 
	return __0__.result.copyFrom_to_(smalltalk.Number(1),self.readLimit()) 
""","Stream_contents")
,"accessing","""contents
	" Return the contents of the receiver. "

	| result |
	result := self collection.
	self readLimit = result size ifTrue: [ ^result ].
	^result copyFrom: 1 to: self readLimit""",nil)
smalltalk.bind(smalltalk.Stream,"size",0
,smalltalk.__f__("""(self):
	#Stream>>#size
	return self.readLimit() 
""","Stream_size")
,"accessing","""size
	" Return the size of the receiver. "

	^self readLimit""",nil)
smalltalk.bind(smalltalk.Stream,"reset",0
,smalltalk.__f__("""(self):
	#Stream>>#reset
	self.position_(smalltalk.Number(0)) 
	return self 
""","Stream_reset")
,"actions","""reset
	" Reset the receiver. "

	self position: 0""",nil)
smalltalk.bind(smalltalk.Stream,"close",0
,smalltalk.__f__("""(self):
	#Stream>>#close
	return self 
""","Stream_close")
,"actions","""close
	" Close the receiver. \"""",nil)
smalltalk.bind(smalltalk.Stream,"flush",0
,smalltalk.__f__("""(self):
	#Stream>>#flush
	return self 
""","Stream_flush")
,"io","""flush
	" Flush the receiver. \"""",nil)
smalltalk.bind(smalltalk.Stream,"resetContents",0
,smalltalk.__f__("""(self):
	#Stream>>#resetContents
	def __blk1__(_s8_rec):
		_s8_rec.reset() 
		return _s8_rec.readLimit_(smalltalk.Number(0)) 
	__blk1__(self) 
	return self 
""","Stream_resetContents")
,"actions","""resetContents
	" Reset the receiver contents. "

	self reset; readLimit: 0""",nil)
smalltalk.bind(smalltalk.Stream,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Stream>>#do:
	def __blk1__():
		return self.atEnd() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		aBlock.value_(self.next()) 
	 
	return self 
""","Stream_do_")
,"enumerating","""do: aBlock
	" Evaluates aBlock streaming on the receiver. "

	[ self atEnd ] whileFalse: [ aBlock value: self next ]""",nil)
smalltalk.bind(smalltalk.Stream,"setToEnd",0
,smalltalk.__f__("""(self):
	#Stream>>#setToEnd
	self.position_(self.size()) 
	return self 
""","Stream_setToEnd")
,"positioning","""setToEnd
	" Position the receiver at end. "

	self position: self size""",nil)
smalltalk.bind(smalltalk.Stream,"skip:",0
,smalltalk.__f__("""(self,anInteger):
	#Stream>>#skip:
	self.position_(anInteger._plus(self.position()).min_(self.size()).max_(smalltalk.Number(0))) 
	return self 
""","Stream_skip_")
,"positioning","""skip: anInteger
	" Skip next anInteger readable elements in the receiver. "

	self position: ((anInteger + self position min: self size) max: 0)""",nil)
smalltalk.bind(smalltalk.Stream,"next",0
,smalltalk.__f__("""(self):
	#Stream>>#next
	self.position_(self.position()._plus(smalltalk.Number(1))) 
	return getattr(self,"@collection",nil).at_(self.position()) 
""","Stream_next")
,"reading","""next
	" Return the next readable element in the receiver (or nil). "

	self position: self position + 1. 
	^collection at: self position""",nil)
smalltalk.bind(smalltalk.Stream,"next:",0
,smalltalk.__f__("""(self,anInteger):
	_s8Ret_=smalltalk.newContext()
	try:
		#Stream>>#next:
		__0__=smalltalk.newContext()
		def __blk1__():
			if smalltalk.b(self.atEnd()):
				smalltalk.raise_result_(_s8Ret_,__0__.result) 
			 
			return __0__.result.add_(self.next()) 
		__0__.result=nil
		__0__.result=self.collection().species().new() 
		smalltalk.times_repeat_(anInteger,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Stream_next_")
,"reading","""next: anInteger
	" Return the next anInteger elements read from the receiver.
	If the receiver reach its end, the returned collection has less elements.
	"

	| result |
	result := self collection species new.
	anInteger timesRepeat: [
		self atEnd ifTrue: [ ^result ].
		result add: self next.
	].
	^result""",nil)
smalltalk.bind(smalltalk.Stream,"nextPut:",0
,smalltalk.__f__("""(self,anObject):
	#Stream>>#nextPut:
	self.position_(self.position()._plus(smalltalk.Number(1))) 
	self.collection().at_put_(getattr(self,"@position",nil),anObject) 
	self.readLimit_(self.readLimit().max_(getattr(self,"@position",nil))) 
	return self 
""","Stream_nextPut_")
,"writing","""nextPut: anObject
	" Put anObject onto the receiver. "

	self position: self position + 1.
	self collection at: position put: anObject.
	self readLimit: (self readLimit max: position)""",nil)
smalltalk.bind(smalltalk.Stream,"nextPutAll:",0
,smalltalk.__f__("""(self,aCollection):
	#Stream>>#nextPutAll:
	def __blk1__(each):
		return self.nextPut_(each) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Stream_nextPutAll_")
,"writing","""nextPutAll: aCollection
	" Put aCollection onto the receiver. "

	aCollection do: [:each | self nextPut: each ]""",nil)
smalltalk.bind(smalltalk.Stream,"cr",0
,smalltalk.__f__("""(self):
	#Stream>>#cr
	self.nextPutAll_(smalltalk.String.crlf()) 
	return self 
""","Stream_cr")
,"writing","""cr
	" Put a line break sequence onto the receiver.
	Note: this implementation MUST be consistent with #nextLine
	"

	self nextPutAll: String crlf""",nil)
smalltalk.bind(smalltalk.Stream,"space",0
,smalltalk.__f__("""(self):
	#Stream>>#space
	self.nextPutAll_(smalltalk.String.space()) 
	return self 
""","Stream_space")
,"writing","""space
	" Put a space sequence onto the receiver. "

	self nextPutAll: String space""",nil)
smalltalk.bind(smalltalk.Stream,"tab",0
,smalltalk.__f__("""(self):
	#Stream>>#tab
	self.nextPutAll_(smalltalk.String.tab()) 
	return self 
""","Stream_tab")
,"writing","""tab
	" Put a tab sequence onto the receiver. "

	self nextPutAll: String tab""",nil)
smalltalk.bind(smalltalk.Stream,"peek",0
,smalltalk.__f__("""(self):
	#Stream>>#peek
	def __blk1__():
		return self.collection().at_(self.position()._plus(smalltalk.Number(1))) 
	return smalltalk.if_true_false_(self.atEnd(),nil,smalltalk.blk(__blk1__,0)) 
""","Stream_peek")
,"reading","""peek
	" Return the next readable element from the receiver without advancing the receiver (or nil). "

	^self atEnd ifFalse: [
	    self collection at: self position + 1
	]""",nil)
smalltalk.bind(smalltalk.Stream,"peekFor:",0
,smalltalk.__f__("""(self,anObject):
	#Stream>>#peekFor:
	def __blk1__():
		if not smalltalk.b(self.atEnd()):
			self.next() 
		 
		return smalltalk.true 
	return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(anObject,self.peek()),smalltalk.blk(__blk1__,0)) 
""","Stream_peekFor_")
,"reading","""peekFor: anObject
	" Return true if the next readable element from the receiver equals anObject.
	Advance the receiver if the result is true.
	"

	^anObject = self peek and: [
		self atEnd ifFalse: [ self next ].
		true
	]""",nil)
smalltalk.bind(smalltalk.Stream,"peekForAll:",0
,smalltalk.__f__("""(self,aCollection):
	_s8Ret_=smalltalk.newContext()
	try:
		#Stream>>#peekForAll:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				self.position_(__0__.back) 
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(self.peekFor_(each),nil,smalltalk.blk(__blk2__,0)) 
		__0__.back=nil
		__0__.back=self.position() 
		aCollection.do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Stream_peekForAll_")
,"reading","""peekForAll: aCollection
	" Return true if the next readable elements from the receiver matches aCollection.
	Advance the receiver if the result is true.
	"

	| back |
	back := self position.
	aCollection do: [:each|
		(self peekFor: each) ifFalse: [
			self position: back.
			^false
		].
	].
	^true""",nil)
smalltalk.bind(smalltalk.Stream,"atEnd",0
,smalltalk.__f__("""(self):
	#Stream>>#atEnd
	return self.position()._gt_eq(self.size()) 
""","Stream_atEnd")
,"testing","""atEnd
	" Return true if the receiver is at end. "

	^self position >= self size""",nil)
smalltalk.bind(smalltalk.Stream,"atStart",0
,smalltalk.__f__("""(self):
	#Stream>>#atStart
	return smalltalk.isObject_equalTo_(self.position(),smalltalk.Number(0)) 
""","Stream_atStart")
,"testing","""atStart
	" Return true if the receiver is at start position. "

	^self position = 0""",nil)
smalltalk.bind(smalltalk.Stream,"isEmpty",0
,smalltalk.__f__("""(self):
	#Stream>>#isEmpty
	return smalltalk.isObject_equalTo_(self.size(),smalltalk.Number(0)) 
""","Stream_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^self size = 0""",nil)
smalltalk.bind(smalltalk.Stream,"notEmpty",0
,smalltalk.__f__("""(self):
	#Stream>>#notEmpty
	return smalltalk.booleanNot_(self.isEmpty()) 
""","Stream_notEmpty")
,"testing","""notEmpty
	" Return true if the receiver is not empty. "

	^self isEmpty not""",nil)
smalltalk.bind(smalltalk.Stream,"upTo:",0
,smalltalk.__f__("""(self,anObject):
	#Stream>>#upTo:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(self.peek(),anObject) 
		return smalltalk.boolean_or_(self.atEnd(),smalltalk.blk(__blk2__,0)) 
	__0__.result=nil
	__0__.result=self.collection().species().new() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__0__.result.add_(self.next()) 
	 
	if not smalltalk.b(self.atEnd()):
		self.next() 
	 
	return __0__.result 
""","Stream_upTo_")
,"reading","""upTo: anObject
	" Return the elements read from the receiver upto anObject (or end). "

	| result |
	result := self collection species new.
	[ self atEnd or: [ self peek = anObject ]] whileFalse: [
		result add: self next
	].
	self atEnd ifFalse: [ self next ].
	^result""",nil)
smalltalk.bind(smalltalk.Stream,"upToEnd",0
,smalltalk.__f__("""(self):
	#Stream>>#upToEnd
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.collection().copyFrom_to_(self.position()._plus(smalltalk.Number(1)),self.readLimit()) 
	self.setToEnd() 
	return __0__.result 
""","Stream_upToEnd")
,"reading","""upToEnd
	" Return the contents of the receiver upto end. "

	| result |
	result := self collection copyFrom: self position + 1 to: self readLimit.
	self setToEnd.
	^result""",nil)
smalltalk.bind(smalltalk.Stream,"nextLine",0
,smalltalk.__f__("""(self):
	#Stream>>#nextLine
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.start=nil
	__0__.start=self.position() 
	__0__.result=self.upTo_(smalltalk.String.cr()) 
	if smalltalk.b(__0__.result.includes_(smalltalk.String.lf())):
		def __blk1__(_s8_rec):
			_s8_rec.position_(__0__.start) 
			return _s8_rec.upTo_(smalltalk.String.lf()) 
		return __blk1__(self) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.peek(),smalltalk.String.lf())):
		self.next() 
	 
	return __0__.result 
""","Stream_nextLine")
,"reading","""nextLine
	" Return the characters read from the receiver up to the line delimiter. "

	| result start |
	start := self position.
	result := self upTo: String cr.
	(result includes: String lf) ifTrue: [
		^self position: start; upTo: String lf
	].
	(self peek = String lf) ifTrue: [ self next ].
	^result""",nil)
smalltalk.bind(smalltalk.Stream,"skipTo:",0
,smalltalk.__f__("""(self,anObject):
	_s8Ret_=smalltalk.newContext()
	try:
		#Stream>>#skipTo:
		def __blk1__():
			return self.atEnd() 
		while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(self.next(),anObject),smalltalk.blk(__blk2__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Stream_skipTo_")
,"reading","""skipTo: anObject
	" Advance the receiver upto anObject (or end). "

	[ self atEnd ] whileFalse: [
		self next = anObject ifTrue: [ ^true ].
	].
	^false""",nil)
smalltalk.bind(smalltalk.Stream,"skipSeparators",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#Stream>>#skipSeparators
		def __blk1__():
			if smalltalk.b(self.atEnd()):
				smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			 
			return self.peek().isSeparator() 
		while smalltalk.b(smalltalk.blk(__blk1__,0)()):
			self.next() 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Stream_skipSeparators")
,"reading","""skipSeparators
	" Advance the receiver upto a non-separator (or end).
	Return true  if a non-separator contents is found,
	return false if run upto end of stream.
	"

	[ self atEnd ifTrue: [ ^false ].
	  self peek isSeparator
	] whileTrue: [ self next ].
	^true""",nil)
smalltalk.bind(smalltalk.Stream,"nextChunk",0
,smalltalk.__f__("""(self):
	#Stream>>#nextChunk
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.isObject_equalTo_(self.peek(),smalltalk.String("!")) 
	def __blk2__(c):
		return c.asciiValue()._lt_eq(smalltalk.Number(32)) 
	__0__.result=nil
	__0__.result=self.upTo_(smalltalk.String("!")) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		self.next() 
		__0__.result=smalltalk.object_comma_(smalltalk.object_comma_(__0__.result,smalltalk.String("!")),self.upTo_(smalltalk.String("!"))) 
	 
	return __0__.result.trimFirst_(smalltalk.blk(__blk2__,1)) 
""","Stream_nextChunk")
,"Tools-fileIn","""nextChunk
	" FileIn - Return the next chunk read from the receiver.
	Trailing non-printing characters are skipped. "

	| result |
	result := self upTo: $!.
	[ self peek = $! ] whileTrue: [
		self next.
		result := result, '!', (self upTo: $!)
	].
	^result trimFirst: [:c| c asciiValue <= 32 ]""",nil)
smalltalk.bind(smalltalk.Stream,"fileInto:",0
,smalltalk.__f__("""(self,aReceiver):
	#Stream>>#fileInto:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.atEnd() 
	__0__.scanner=nil
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		if smalltalk.b(smalltalk.isNil_(__0__.scanner)):
			__0__.scanner=aReceiver 
		 
		__0__.scanner=__0__.scanner.scanFrom_(self) 
	 
	return __0__.scanner 
""","Stream_fileInto_")
,"Tools-fileIn","""fileInto: aReceiver
	" FileIn - FileIn the receiver's contents (in chunk format) using aReceiver as default scanner. "

	| scanner |
	[self atEnd] whileFalse: [
		scanner isNil ifTrue: [ scanner := aReceiver ].
		scanner := scanner scanFrom: self
	].
	^scanner""",nil)
smalltalk.bind(smalltalk.Stream,"fileIn",0
,smalltalk.__f__("""(self):
	#Stream>>#fileIn
	return self.fileInto_(nil) 
""","Stream_fileIn")
,"Tools-fileIn","""fileIn
	" FileIn - FileIn the receiver's contents (in chunk format). "

	^self fileInto: nil""",nil)
smalltalk.bind(smalltalk.Stream,"nextChunkPut:",0
,smalltalk.__f__("""(self,aString):
	#Stream>>#nextChunkPut:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return self.nextPutAll_(each) 
	def __blk2__():
		return self.nextPutAll_(smalltalk.object_comma_(__0__.eoc,__0__.eoc)) 
	__0__.eoc=nil
	__0__.parts=nil
	__0__.eoc=smalltalk.String("!") 
	if smalltalk.b(smalltalk.isNil_(aString)):
		self.nextPut_(__0__.eoc) 
		return nil 
	 
	if smalltalk.b(aString.isEmpty()):
		self.nextPut_(smalltalk.String(" ")) 
	 
	aString.asArrayOfSubstringsSeparatedBy_(__0__.eoc).do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	self.nextPut_(__0__.eoc) 
	return aString 
""","Stream_nextChunkPut_")
,"Tools-fileOut","""nextChunkPut: aString
	" Output aString in chunk format. "

	| eoc parts |
	eoc := $!.
	aString isNil ifTrue: [  self nextPut: eoc. ^nil ].
	aString isEmpty ifTrue: [ self nextPut: $ ].
	(aString asArrayOfSubstringsSeparatedBy: eoc)
		do: [:each| self nextPutAll: each ]
		separatedBy: [ self nextPutAll: eoc,eoc ].
	self nextPut: eoc.
	^aString""",nil)
smalltalk.bind(smalltalk.StringStream,"next:",0
,smalltalk.__f__("""(self,anInteger):
	#StringStream>>#next:
	__0__=smalltalk.newContext()
	__0__.start=nil
	__0__.result=nil
	__0__.stop=nil
	__0__.start=self.position() 
	__0__.stop=__0__.start._plus(anInteger).min_(self.readLimit()) 
	__0__.result=self.collection().copyFrom_to_(__0__.start._plus(smalltalk.Number(1)),__0__.stop) 
	self.position_(__0__.stop) 
	return __0__.result 
""","StringStream_next_")
,"reading","""next: anInteger
	" Return the next anInteger elements read from the receiver.
	If the receiver reach its end, the returned collection has less elements.
	"

	| start result stop |
	start := self position.
	stop := start + anInteger min: self readLimit.
	result := self collection copyFrom: start + 1 to: stop.
	self position: stop.
	^result""",nil)
smalltalk.bind(smalltalk.StringStream,"nextPut:",0
,smalltalk.__f__("""(self,aString):
	#StringStream>>#nextPut:
	self.nextPutAll_(aString) 
	return self 
""","StringStream_nextPut_")
,"writing","""nextPut: aString
	" Put aString onto the receiver. "

	self nextPutAll: aString""",nil)
smalltalk.bind(smalltalk.StringStream,"nextPutAll:",0
,smalltalk.__f__("""(self,aString):
	#StringStream>>#nextPutAll:
	__0__=smalltalk.newContext()
	__0__.result=nil
	if smalltalk.b(smalltalk.isObject_equalTo_(self.position(),self.collection().size())):
		__0__.result=smalltalk.object_comma_(self.collection(),aString) 
	else:
		__1__=smalltalk.newContext()
		def __blk1__():
			return aString 
		def __blk2__():
			return smalltalk.object_comma_(__1__.substring,aString) 
		def __blk3__():
			return __0__.result 
		def __blk4__():
			return smalltalk.object_comma_(__0__.result,__1__.substring) 
		__1__.substring=nil
		__1__.substring=self.collection().copyFrom_to_(smalltalk.Number(1),self.position()) 
		__0__.result=smalltalk.if_true_false_(__1__.substring.isEmpty(),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
		__1__.substring=self.collection().copyFrom_to_(self.position()._plus(smalltalk.Number(1))._plus(aString.size()),self.collection().size()) 
		__0__.result=smalltalk.if_true_false_(__1__.substring.isEmpty(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
	 
	self.collection_(__0__.result) 
	self.position_(self.position()._plus(aString.size())) 
	self.readLimit_(self.readLimit().max_(getattr(self,"@position",nil))) 
	return self 
""","StringStream_nextPutAll_")
,"writing","""nextPutAll: aString
	" Put aString onto the receiver at current position; expanding internal contents. "

	| result |
	self position = self collection size
	ifTrue: [ result := self collection , aString ]
	ifFalse: [ | substring |
		substring := self collection copyFrom: 1 to: self position.
		result := substring isEmpty ifTrue: [ aString ] ifFalse: [ substring , aString ].
		substring := self collection
			copyFrom: self position + 1 + aString size
			to: self collection size.
		result := substring isEmpty ifTrue: [ result ] ifFalse: [ result , substring ].
	].
	self collection: result.
	self position: self position + aString size.
	self readLimit: (self readLimit max: position)""",nil)
smalltalk.bind(smalltalk.StringStream,"skipTo:",0
,smalltalk.__f__("""(self,anObject):
	#StringStream>>#skipTo:
	__0__=smalltalk.newContext()
	__0__.index=nil
	if not smalltalk.b(anObject.isString()):
		self.setToEnd() 
		return smalltalk.false 
	 
	__0__.index=self.collection().indexOf_startingAt_(anObject,self.position()._plus(smalltalk.Number(1))) 
	if smalltalk.b(__0__.index.between_and_(self.position()._plus(smalltalk.Number(1)),self.readLimit())):
		self.position_(__0__.index._plus(anObject.size())._minus(smalltalk.Number(1))) 
		return smalltalk.true 
	 
	self.setToEnd() 
	return smalltalk.false 
""","StringStream_skipTo_")
,"reading","""skipTo: anObject
	" Advance the receiver upto anObject (or end). "

	| index |
	anObject isString ifFalse: [ self setToEnd. ^false ].
	index := self collection indexOf: anObject startingAt: self position + 1.
	(index between: self position + 1 and: self readLimit) ifTrue: [
		self position: index + anObject size - 1.
		^true
	].
	self setToEnd.
	^false""",nil)
smalltalk.bind(smalltalk.StringStream,"upTo:",0
,smalltalk.__f__("""(self,anObject):
	#StringStream>>#upTo:
	__0__=smalltalk.newContext()
	def __blk1__():
		return anObject.size() 
	def __blk2__():
		return smalltalk.Number(0) 
	__0__.start=nil
	__0__.found=nil
	if not smalltalk.b(anObject.isString()):
		return self.upToEnd() 
	 
	__0__.start=self.position()._plus(smalltalk.Number(1)) 
	__0__.found=smalltalk.if_true_false_(self.skipTo_(anObject),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return self.collection().copyFrom_to_(__0__.start,self.position()._minus(__0__.found)) 
""","StringStream_upTo_")
,"reading","""upTo: anObject
	" Return the elements read from the receiver upto anObject (or end). "

	| start found |
	anObject isString ifFalse: [ ^self upToEnd ].
	start := self position + 1.
	found := (self skipTo: anObject) ifTrue: [ anObject size ] ifFalse: [ 0 ].
	^self collection copyFrom: start to: self position - found""",nil)
smalltalk.bind(smalltalk.StringStream,"peek",0
,smalltalk.__f__("""(self):
	#StringStream>>#peek
	try:
		s = smalltalk.handleOf(self.collection())
		offs = smalltalk.handleOf(self.position())
		if offs>=len(s):
			return nil
		return smalltalk.String(s[offs])
	except:
		return nil
	 
	return self 
""","StringStream_peek")
,"reading","""peek
	" Return the next readable element from the receiver without advancing (or nil). "

	{''js'return self["@collection"].charAt(self.position())||nil'}""",nil)
smalltalk.bind(smalltalk.StringStream,"next",0
,smalltalk.__f__("""(self):
	#StringStream>>#next
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.peek() 
	if smalltalk.b(smalltalk.notNil_(__0__.result)):
		smalltalk.basic_at_put(self,"@position",getattr(self,"@position",nil)._plus(smalltalk.Number(1))) 
	 
	return __0__.result 
""","StringStream_next")
,"reading","""next
	" Return the next readable element in the receiver (or nil). "

	| result |
	result := self peek.
	result notNil ifTrue: [ position := position + 1 ].
	^result""",nil)
smalltalk.bind(smalltalk.StringStream,"peekForAll:",0
,smalltalk.__f__("""(self,aCollection):
	#StringStream>>#peekForAll:
	if not smalltalk.b(aCollection.isString()):
		return smalltalk.superReceiver(smalltalk.StringStream,self).peekForAll_(aCollection) 
	 
	start = smalltalk.handleOf(self.position())
	s = smalltalk.handleOf(self.collection())
	if not s.startswith(smalltalk.handleOf(aCollection),start):
		return smalltalk.false
	 
	smalltalk.basic_at_put(self,"@position",getattr(self,"@position",nil)._plus(aCollection.size())) 
	return smalltalk.true 
""","StringStream_peekForAll_")
,"reading","""peekForAll: aCollection
	" Return true if the next readable elements from the receiver matches aCollection.
	Advance the receiver if the result is true.
	"

	aCollection isString ifFalse: [ ^super peekForAll: aCollection ].
	{''js'var start = self.position();
	for (var i=0;i<aCollection.length; i++){
		if (self["@collection"].charCodeAt(start+i) != aCollection.charCodeAt(i)) return false;
	}'}.
	position := position + aCollection size.
	^true""",nil)
smalltalk.bind(smalltalk.StringStream,"upToSeparator",0
,smalltalk.__f__("""(self):
	#StringStream>>#upToSeparator
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return smalltalk.booleanNot_(self.peek().isSeparator()) 
		return smalltalk.boolean_and_(smalltalk.booleanNot_(self.atEnd()),smalltalk.blk(__blk2__,0)) 
	__0__.start=nil
	__0__.start=self.position()._plus(smalltalk.Number(1)) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		self.next() 
	 
	return self.collection().copyFrom_to_(__0__.start,self.position()) 
""","StringStream_upToSeparator")
,"reading","""upToSeparator
	" Return the elements read from the receiver upto a separator (or end). "

	| start |
	start := self position + 1.
	[self atEnd not and: [self peek isSeparator not]] whileTrue: [
		self next
	].
	^self collection copyFrom: start to: self position""",nil)
smalltalk.bind(smalltalk.StringStream,"nextMessagePattern",0
,smalltalk.__f__("""(self):
	#StringStream>>#nextMessagePattern
	__0__=smalltalk.newContext()
	__0__.part=nil
	__0__.selector=nil
	__0__.args=nil
	__0__.args=smalltalk.newArray([]) 
	self.skipSeparators() 
	__0__.selector=self.upToSeparator() 
	if smalltalk.b(__0__.selector.isEmpty()):
		return nil 
	 
	if smalltalk.b(__0__.selector.argumentCount()._gt(smalltalk.Number(0))):
		__1__=smalltalk.newContext()
		def __blk1__():
			def __blk2__():
				return smalltalk.String("") 
			def __blk3__():
				return self.upToSeparator() 
			def __blk4__():
				return smalltalk.isObject_equalTo_(__1__.part.last(),smalltalk.String(":")) 
			self.skipSeparators() 
			__0__.args.add_(self.upToSeparator()) 
			self.skipSeparators() 
			__1__.part=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(self.peek(),smalltalk.String('"')),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
			return smalltalk.boolean_and_(__1__.part.notEmpty(),smalltalk.blk(__blk4__,0)) 
		def __blk5__():
			__0__.selector=smalltalk.object_comma_(__0__.selector,__1__.part)
			return __0__.selector 
		__1__.part=nil
		smalltalk.while_do_(smalltalk.blk(__blk1__,0),smalltalk.blk(__blk5__,0)) 
	 
	__0__.part=smalltalk.Message.selector_arguments_(__0__.selector,__0__.args) 
	self.skipSeparators() 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.peek(),smalltalk.String('"'))):
		def __blk6__(_s8_rec):
			_s8_rec.next() 
			return _s8_rec.upTo_(smalltalk.String('"')) 
		__0__.part.comment_(__blk6__(self).trimBlanks()) 
	 
	return __0__.part 
""","StringStream_nextMessagePattern")
,"tools","""nextMessagePattern
	" Return a message pattern read from the receiver (or nil).
	Note: it is assumed that there is a correct message header in the receiver.
	"

	| part selector args |
	args := #().
	self skipSeparators.
	selector := self upToSeparator.
	selector isEmpty ifTrue: [ ^nil ].
	selector argumentCount > 0 ifTrue: [ | part |
		[ self skipSeparators.
		  args add: self upToSeparator.
		  self skipSeparators.
		  part := self peek = $" ifTrue: [ '' ]
			ifFalse: [ self upToSeparator ].
		  part notEmpty and: [ part last = $: ]
		] whileTrue: [
		  selector := selector , part
		].
	].
	part := Message selector: selector arguments: args.
	self skipSeparators.
	self peek = $" ifTrue: [
		part comment: (self next; upTo: $") trimBlanks
	].
	^part""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"collection",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#collection
	return self.invalidMessage_(smalltalk.String("collection")) 
""","StringWriteStream_collection")
,"accessing","""collection
	" Private - Return the collection of the receiver. "

	^self invalidMessage: #collection""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"collection:",0
,smalltalk.__f__("""(self,aCollection):
	#StringWriteStream>>#collection:
	if not smalltalk.b(aCollection.isString()):
		self.error_(smalltalk.String("Collection must be a String")) 
	 
	smalltalk.basic_at_put(self,"@collection",smalltalk.Array.with_(aCollection)) 
	return self 
""","StringWriteStream_collection_")
,"accessing","""collection: aCollection
	" Private - Set the collection of the receiver. "

	aCollection isString ifFalse: [ self error: 'Collection must be a String' ].
	collection := Array with: aCollection""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"contents",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#contents
	return getattr(self,"@collection",nil).join_(smalltalk.String("")) 
""","StringWriteStream_contents")
,"accessing","""contents
	" Return the contents of the receiver. "

	^collection join: ''""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"position",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#position
	return self.readLimit() 
""","StringWriteStream_position")
,"accessing","""position
	" Return the position of the receiver. "

	^self readLimit""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"position:",0
,smalltalk.__f__("""(self,anInteger):
	#StringWriteStream>>#position:
	return self.invalidMessage_(smalltalk.String("position:")) 
""","StringWriteStream_position_")
,"accessing","""position: anInteger
	" Set the position of the receiver. "

	^self invalidMessage: #position:""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"readLimit",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#readLimit
	return getattr(self,"@readLimit",nil) 
""","StringWriteStream_readLimit")
,"accessing","""readLimit
	" Private - Return the read limit of the receiver. "

	^readLimit""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"readLimit:",0
,smalltalk.__f__("""(self,anInteger):
	#StringWriteStream>>#readLimit:
	smalltalk.basic_at_put(self,"@readLimit",anInteger) 
	return self 
""","StringWriteStream_readLimit_")
,"accessing","""readLimit: anInteger
	" Private - Set the stream size of the receiver. "

	readLimit := anInteger""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"setCollection:",0
,smalltalk.__f__("""(self,aCollection):
	#StringWriteStream>>#setCollection:
	return self.invalidMessage_(smalltalk.String("setCollection:")) 
""","StringWriteStream_setCollection_")
,"accessing","""setCollection: aCollection
	" Private - Set the receiver stream collection to aCollection. "

	^self invalidMessage: #setCollection:""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"size",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#size
	return self.readLimit() 
""","StringWriteStream_size")
,"accessing","""size
	" Return the size of the receiver. "

	^self readLimit""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"close",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#close
	return self 
""","StringWriteStream_close")
,"actions","""close
	" Close the receiver. \"""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"reset",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#reset
	self.initialize() 
	return self 
""","StringWriteStream_reset")
,"actions","""reset
	" Reset the receiver. "

	self initialize""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#StringWriteStream>>#do:
	return self.invalidMessage_(smalltalk.String("do:")) 
""","StringWriteStream_do_")
,"enumerating","""do: aBlock
	" Evaluates aBlock streaming on the receiver. "

	^self invalidMessage: #do:""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"initialize",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#initialize
	smalltalk.superReceiver(smalltalk.StringWriteStream,self).initialize() 
	smalltalk.basic_at_put(self,"@collection",smalltalk.Array.new()) 
	smalltalk.basic_at_put(self,"@readLimit",smalltalk.basic_at_put(self,"@position",smalltalk.Number(0))) 
	return self 
""","StringWriteStream_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	collection := Array new.
	readLimit := position := 0.""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"setToEnd",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#setToEnd
	return self 
""","StringWriteStream_setToEnd")
,"positioning","""setToEnd
	" Position the receiver at end. \"""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"skip:",0
,smalltalk.__f__("""(self,anInteger):
	#StringWriteStream>>#skip:
	return self.invalidMessage_(smalltalk.String("skip:")) 
""","StringWriteStream_skip_")
,"positioning","""skip: anInteger
	" Skip next anInteger readable elements in the receiver. "

	^self invalidMessage: #skip:""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"next",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#next
	return self.invalidMessage_(smalltalk.String("next")) 
""","StringWriteStream_next")
,"reading","""next
	" Return the next readable element in the receiver (or nil). "

	^self invalidMessage: #next""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"next:",0
,smalltalk.__f__("""(self,anInteger):
	#StringWriteStream>>#next:
	return self.invalidMessage_(smalltalk.String("next")) 
""","StringWriteStream_next_")
,"reading","""next: anInteger
	" Return the next anInteger elements read from the receiver. "

	^self invalidMessage: #next""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"nextLine",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#nextLine
	return self.invalidMessage_(smalltalk.String("nextLine")) 
""","StringWriteStream_nextLine")
,"reading","""nextLine
	" Return the characters read from the receiver up to the line delimiter. "

	^self invalidMessage: #nextLine""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"peek",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#peek
	return self.invalidMessage_(smalltalk.String("peek")) 
""","StringWriteStream_peek")
,"reading","""peek
	" Return the next readable element from the receiver without advancing the receiver (or nil). "

	^self invalidMessage: #peek""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"upTo:",0
,smalltalk.__f__("""(self,anObject):
	#StringWriteStream>>#upTo:
	return self.invalidMessage_(smalltalk.String("upTo:")) 
""","StringWriteStream_upTo_")
,"reading","""upTo: anObject
	" Return the elements read from the receiver upto anObject (or end). "

	^self invalidMessage: #upTo:""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"upToEnd",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#upToEnd
	return self.invalidMessage_(smalltalk.String("upToEnd")) 
""","StringWriteStream_upToEnd")
,"reading","""upToEnd
	" Return the contents of the receiver upto end. "

	^self invalidMessage: #upToEnd""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"atEnd",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#atEnd
	return smalltalk.true 
""","StringWriteStream_atEnd")
,"testing","""atEnd
	" Return true if the receiver is at end. "

	^true""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"nextPut:",0
,smalltalk.__f__("""(self,anObject):
	#StringWriteStream>>#nextPut:
	__0__=smalltalk.newContext()
	__0__.string=nil
	__0__.string=smalltalk.asString_(anObject) 
	getattr(self,"@collection",nil).add_(__0__.string) 
	smalltalk.basic_at_put(self,"@readLimit",getattr(self,"@readLimit",nil)._plus(__0__.string.size())) 
	return self 
""","StringWriteStream_nextPut_")
,"writing","""nextPut: anObject
	" Put anObject onto the receiver. "

	| string |
	string :=  anObject asString.
	collection add: string.
	readLimit := readLimit + string size""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"nextPutAll:",0
,smalltalk.__f__("""(self,aCollection):
	#StringWriteStream>>#nextPutAll:
	self.nextPut_(aCollection) 
	return self 
""","StringWriteStream_nextPutAll_")
,"writing","""nextPutAll: aCollection
	" Put aCollection onto the receiver. "

	self nextPut: aCollection""",nil)
smalltalk.bind(smalltalk.StringWriteStream,"removeLastInput",0
,smalltalk.__f__("""(self):
	#StringWriteStream>>#removeLastInput
	smalltalk.basic_at_put(self,"@readLimit",getattr(self,"@readLimit",nil)._minus(getattr(self,"@collection",nil).removeLast().size())) 
	return self 
""","StringWriteStream_removeLastInput")
,"back","""removeLastInput
	" Remove last input recorded in the receiver. "

	readLimit := readLimit - collection removeLast size""",nil)
smalltalk.bind(smalltalk.Random,"next",0
,smalltalk.__f__("""(self):
	#Random>>#next
	if True:
		import random
		return smalltalk.Number(random.random())
	 
	return self 
""","Random_next")
,"accessing","""next
	" Return the next random number. "

	{''js'return Math.random()'}""",nil)
smalltalk.bind(smalltalk.Random,"next:",0
,smalltalk.__f__("""(self,anInteger):
	#Random>>#next:
	def __blk1__(each):
		return self.next() 
	return smalltalk.Number(1).to_(anInteger).collect_(smalltalk.blk(__blk1__,1)) 
""","Random_next_")
,"accessing","""next: anInteger
	" Return the next anInteger random numbers. "

	^(1 to: anInteger) collect: [:each | self next ]""",nil)
smalltalk.bind(smalltalk.Point.__class__,"x:y:",0
,smalltalk.__f__("""(self,x,y):
	#Point class>>#x:y:
	def __blk1__(_s8_rec):
		_s8_rec.x_(x) 
		return _s8_rec.y_(y) 
	return __blk1__(self.basicNew()) 
""","Point_class_x_y_")
,"instantiation","""x: x y: y
	" Return an instance of the receiver. "

	^self basicNew x: x; y: y""",nil)
smalltalk.bind(smalltalk.Point.__class__,"zero",0
,smalltalk.__f__("""(self):
	#Point class>>#zero
	return self.basicNew().x_y_(smalltalk.Number(0),smalltalk.Number(0)) 
""","Point_class_zero")
,"instantiation","""zero
	" Return an instance of the receiver. "

	^self basicNew x: 0 y: 0""",nil)
smalltalk.bind(smalltalk.Point.__class__,"test_SuperInstanceSend",0
,smalltalk.__f__("""(self):
	#Point class>>#test_SuperInstanceSend
	if not smalltalk.b(smalltalk.b_(smalltalk.superReceiver(smalltalk.Point.__class__,self).test_SuperInstanceSend() is (smalltalk.Object).__class__)):
		return smalltalk.false 
	 
	return smalltalk.b_((self).__class__ is (smalltalk.Point).__class__) 
""","Point_class_test_SuperInstanceSend")
,"_tests_","""test_SuperInstanceSend	"
	PythonEncoder export: Point class>>#test_SuperInstanceSend
	"

	super test_SuperInstanceSend == Object class ifFalse: [ ^false ].
	^self class == Point class """,nil)
smalltalk.bind(smalltalk.Point.__class__,"sample",0
,smalltalk.__f__("""(self):
	#Point class>>#sample
	return smalltalk.Number(3)._plus(smalltalk.superReceiver(smalltalk.Point.__class__,self).sample()) 
""","Point_class_sample")
,"_tests_-super","""sample
	^3 + super sample""",nil)
smalltalk.bind(smalltalk.Point,"x",0
,smalltalk.__f__("""(self):
	#Point>>#x
	return getattr(self,"@x",nil) 
""","Point_x")
,"accessing","""x
	" Return the x of the receiver. "

	^x""",nil)
smalltalk.bind(smalltalk.Point,"y",0
,smalltalk.__f__("""(self):
	#Point>>#y
	return getattr(self,"@y",nil) 
""","Point_y")
,"accessing","""y
	" Return the y of the receiver. "

	^y""",nil)
smalltalk.bind(smalltalk.Point,"x:y:",0
,smalltalk.__f__("""(self,xValue,yValue):
	#Point>>#x:y:
	smalltalk.basic_at_put(self,"@x",xValue) 
	smalltalk.basic_at_put(self,"@y",yValue) 
	return self 
""","Point_x_y_")
,"accessing","""x: xValue y: yValue
	" Set the receiver's coordinates. "

	x := xValue.
	y := yValue""",nil)
smalltalk.bind(smalltalk.Point,"y:",0
,smalltalk.__f__("""(self,aNumber):
	#Point>>#y:
	def __blk1__():
		return smalltalk.Number(0) 
	def __blk2__():
		return aNumber 
	smalltalk.basic_at_put(self,"@y",smalltalk.if_true_false_(smalltalk.isNil_(aNumber),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
	return self 
""","Point_y_")
,"accessing","""y: aNumber
	" Set the y of the receiver. "

	y := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]""",nil)
smalltalk.bind(smalltalk.Point,"x:",0
,smalltalk.__f__("""(self,aNumber):
	#Point>>#x:
	def __blk1__():
		return smalltalk.Number(0) 
	def __blk2__():
		return aNumber 
	smalltalk.basic_at_put(self,"@x",smalltalk.if_true_false_(smalltalk.isNil_(aNumber),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
	return self 
""","Point_x_")
,"accessing","""x: aNumber
	" Set the x of the receiver. "

	x := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]""",nil)
smalltalk.bind(smalltalk.Point,"*","_star"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#*
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._star(aPoint)._at(getattr(self,"@y",nil)._star(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._star(aPoint.asPoint().x()),getattr(self,"@y",nil)._star(aPoint.asPoint().y())) 
""","Point__star")
,"arithmetic","""* aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x * aPoint @ (y * aPoint) ].
	^Point	x: x * aPoint asPoint x
		y: y * aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"+","_plus"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#+
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._plus(aPoint)._at(getattr(self,"@y",nil)._plus(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._plus(aPoint.asPoint().x()),getattr(self,"@y",nil)._plus(aPoint.asPoint().y())) 
""","Point__plus")
,"arithmetic","""+ aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x + aPoint @ (y + aPoint) ].
	^Point	x: x + aPoint asPoint x
		y: y + aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"-","_minus"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#-
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._minus(aPoint)._at(getattr(self,"@y",nil)._minus(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._minus(aPoint.asPoint().x()),getattr(self,"@y",nil)._minus(aPoint.asPoint().y())) 
""","Point__minus")
,"arithmetic","""- aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x - aPoint @ (y - aPoint) ].
	^Point	x: x - aPoint asPoint x
		y: y - aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"/","_slash"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#/
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._slash(aPoint)._at(getattr(self,"@y",nil)._slash(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._slash(aPoint.asPoint().x()),getattr(self,"@y",nil)._slash(aPoint.asPoint().y())) 
""","Point__slash")
,"arithmetic","""/ aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x / aPoint @ (y / aPoint) ].
	^Point	x: x / aPoint asPoint x
		y: y / aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"//","_slash_slash"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#//
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._slash_slash(aPoint)._at(getattr(self,"@y",nil)._slash_slash(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._slash_slash(aPoint.asPoint().x()),getattr(self,"@y",nil)._slash_slash(aPoint.asPoint().y())) 
""","Point__slash_slash")
,"arithmetic","""// aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x // aPoint @ (y // aPoint) ].
	^Point	x: x // aPoint asPoint x
		y: y // aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"""\\\\""","_bk_bk"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#\\\\\\\\
	if smalltalk.b(self.isNumber_(aPoint)):
		return getattr(self,"@x",nil)._bk_bk(aPoint)._at(getattr(self,"@y",nil)._bk_bk(aPoint)) 
	 
	return smalltalk.Point.x_y_(getattr(self,"@x",nil)._bk_bk(aPoint.asPoint().x()),getattr(self,"@y",nil)._bk_bk(aPoint.asPoint().y())) 
""","Point__bk_bk_bk_bk")
,"arithmetic","""\\\\\\\\ aPoint
	" Return the result of operation. "

	(self isNumber: aPoint) ifTrue: [ ^x \\\\ aPoint @ (y \\\\ aPoint) ].
	^Point	x: x \\\\ aPoint asPoint x
		y: y \\\\ aPoint asPoint y""",nil)
smalltalk.bind(smalltalk.Point,"<","_lt"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#<
	def __blk1__():
		return getattr(self,"@y",nil)._lt(aPoint.y()) 
	if smalltalk.b(self.isNumber_(aPoint)):
		return self._lt(aPoint.asPoint()) 
	 
	return smalltalk.boolean_and_(getattr(self,"@x",nil)._lt(aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Point__lt")
,"comparing","""< aPoint
	" Return true if the receiver is smaller than argument. "

	(self isNumber: aPoint) ifTrue: [ ^self < aPoint asPoint ].
	^x < aPoint x and: [ y < aPoint y ]""",nil)
smalltalk.bind(smalltalk.Point,"<=","_lt_eq"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#<=
	def __blk1__():
		return getattr(self,"@y",nil)._lt_eq(aPoint.y()) 
	if smalltalk.b(self.isNumber_(aPoint)):
		return self._lt_eq(aPoint.asPoint()) 
	 
	return smalltalk.boolean_and_(getattr(self,"@x",nil)._lt_eq(aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Point__lt_eq")
,"comparing","""<= aPoint
	" Return true if the receiver is smaller or equal to argument. "

	(self isNumber: aPoint) ifTrue: [ ^self <= aPoint asPoint ].
	^x <= aPoint x and: [ y <= aPoint y ]""",nil)
smalltalk.bind(smalltalk.Point,">","_gt"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#>
	def __blk1__():
		return getattr(self,"@y",nil)._gt(aPoint.y()) 
	if smalltalk.b(self.isNumber_(aPoint)):
		return self._gt(aPoint.asPoint()) 
	 
	return smalltalk.boolean_and_(getattr(self,"@x",nil)._gt(aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Point__gt")
,"comparing","""> aPoint
	" Return true if the receiver is greater than argument. "

	(self isNumber: aPoint) ifTrue: [ ^self > aPoint asPoint ].
	^x > aPoint x and: [ y > aPoint y ]""",nil)
smalltalk.bind(smalltalk.Point,">=","_gt_eq"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#>=
	def __blk1__():
		return getattr(self,"@y",nil)._gt_eq(aPoint.y()) 
	if smalltalk.b(self.isNumber_(aPoint)):
		return self._gt_eq(aPoint.asPoint()) 
	 
	return smalltalk.boolean_and_(getattr(self,"@x",nil)._gt_eq(aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Point__gt_eq")
,"comparing",""">= aPoint
	" Return true if the receiver is greater or equal to argument. "

	(self isNumber: aPoint) ifTrue: [ ^self >= aPoint asPoint ].
	^x >= aPoint x and: [ y >= aPoint y ]""",nil)
smalltalk.bind(smalltalk.Point,"rounded",0
,smalltalk.__f__("""(self):
	#Point>>#rounded
	return getattr(self,"@x",nil).rounded()._at(getattr(self,"@y",nil).rounded()) 
""","Point_rounded")
,"converting","""rounded
	" Return the receiver rounded. "

	^x rounded @ y rounded""",nil)
smalltalk.bind(smalltalk.Point,"truncated",0
,smalltalk.__f__("""(self):
	#Point>>#truncated
	return getattr(self,"@x",nil).truncated()._at(getattr(self,"@y",nil).truncated()) 
""","Point_truncated")
,"converting","""truncated
	" Return the receiver truncated. "

	^x truncated @ y truncated""",nil)
smalltalk.bind(smalltalk.Point,"asPoint",0
,smalltalk.__f__("""(self):
	#Point>>#asPoint
	return self 
""","Point_asPoint")
,"converting","""asPoint
	" Return the receiver as a Point. "

	^self""",nil)
smalltalk.bind(smalltalk.Point,"printString",0
,smalltalk.__f__("""(self):
	#Point>>#printString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.to_String(getattr(self,"@x",nil)),smalltalk.String(" @ ")),smalltalk.to_String(getattr(self,"@y",nil))) 
""","Point_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	^x toString ,' @ ' ,y toString""",nil)
smalltalk.bind(smalltalk.Point,"toString",0
,smalltalk.__f__("""(self):
	#Point>>#toString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.to_String(getattr(self,"@x",nil)),smalltalk.String("@")),smalltalk.to_String(getattr(self,"@y",nil))) 
""","Point_toString")
,"printing","""toString
	" Return the printable representation of the receiver. "

	^x toString ,$@ ,y toString""",nil)
smalltalk.bind(smalltalk.Point,"asLiteral",0
,smalltalk.__f__("""(self):
	#Point>>#asLiteral
	__0__=smalltalk.newContext()
	def __blk1__(v):
		__1__=smalltalk.newContext()
		def __blk2__():
			return v.asLiteral() 
		def __blk3__():
			return smalltalk.to_String(v) 
		def __blk4__():
			def __blk5__():
				return smalltalk.String("#'-+").includes_(__1__.string.first()) 
			return smalltalk.boolean_or_(__1__.string.first().isDigit(),smalltalk.blk(__blk5__,0)) 
		def __blk6__():
			return __1__.string 
		def __blk7__():
			return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("("),__1__.string),smalltalk.String(")")) 
		__1__.string=nil
		__1__.string=smalltalk.if_true_false_(self.isObject_(v),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		return smalltalk.if_true_false_(smalltalk.boolean_or_(__1__.string.isEmpty(),smalltalk.blk(__blk4__,0)),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk7__,0)) 
	__0__.literal=nil
	__0__.literal=smalltalk.blk(__blk1__,1) 
	return smalltalk.object_comma_(smalltalk.object_comma_(__0__.literal.value_(getattr(self,"@x",nil)),smalltalk.String("@")),__0__.literal.value_(getattr(self,"@y",nil))) 
""","Point_asLiteral")
,"converting","""asLiteral
	" Return the receiver in literal notation. "

	| literal |
	literal := [:v| | string |
		string := (self isObject: v) ifTrue: [v asLiteral] ifFalse: [v toString].
		(string isEmpty or: [string first isDigit or: ['#''-+' includes: string first]])
		ifTrue: [string] ifFalse: [ $( ,string ,$) ]
	].
	^(literal value: x) ,$@ ,(literal value: y)""",nil)
smalltalk.bind(smalltalk.Point,"shallowCopy",0
,smalltalk.__f__("""(self):
	#Point>>#shallowCopy
	return (self).__class__.basicNew().x_y_(self.x(),self.y()) 
""","Point_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self class basicNew
		x: self x y: self y""",nil)
smalltalk.bind(smalltalk.Point,"=","_eq"
,smalltalk.__f__("""(self,aPoint):
	#Point>>#=
	def __blk1__():
		return smalltalk.isObject_equalTo_(getattr(self,"@y",nil),aPoint.y()) 
	if smalltalk.b(smalltalk.isNil_(aPoint)):
		return smalltalk.false 
	 
	if not smalltalk.b(aPoint.isMemberOf_((self).__class__)):
		def __blk2__():
			return smalltalk.isObject_equalTo_(aPoint.asPoint(),self) 
		return smalltalk.boolean_and_(smalltalk.responds_to_(aPoint,(smalltalk.String("asPoint"))),smalltalk.blk(__blk2__,0)) 
	 
	return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(getattr(self,"@x",nil),aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Point__eq")
,"testing","""= aPoint
	" Return true if the receiver is equal to argument. "

	aPoint isNil ifTrue: [ ^false ].
	(aPoint isMemberOf: self class) ifFalse: [
		^(aPoint respondsTo: #asPoint) and: [
			aPoint asPoint = self
		]
	].
	^x = aPoint x and: [ y = aPoint y ]""",nil)
smalltalk.bind(smalltalk.Point,"min:",0
,smalltalk.__f__("""(self,aPoint):
	#Point>>#min:
	return getattr(self,"@x",nil).min_(aPoint.x())._at(getattr(self,"@y",nil).min_(aPoint.y())) 
""","Point_min_")
,"magnitude","""min: aPoint
	" Return the minimum of the receiver and aPoint. "

	^(x min: aPoint x) @ (y min: aPoint y)""",nil)
smalltalk.bind(smalltalk.Point,"max:",0
,smalltalk.__f__("""(self,aPoint):
	#Point>>#max:
	return getattr(self,"@x",nil).max_(aPoint.x())._at(getattr(self,"@y",nil).max_(aPoint.y())) 
""","Point_max_")
,"magnitude","""max: aPoint
	" Return the maximum of the receiver and aPoint. "

	^(x max: aPoint x) @ (y max: aPoint y)""",nil)
smalltalk.bind(smalltalk.Point,"extent:",0
,smalltalk.__f__("""(self,extent):
	#Point>>#extent:
	return smalltalk.Rectangle.leftTop_rightBottom_(self,self._plus(extent)) 
""","Point_extent_")
,"converting","""extent: extent
	" Return a Rectangle from the receiver with specified extent. "

	^Rectangle leftTop: self rightBottom: self + extent""",nil)
smalltalk.bind(smalltalk.Point,"rightBottom:",0
,smalltalk.__f__("""(self,rightBottom):
	#Point>>#rightBottom:
	return smalltalk.Rectangle.leftTop_rightBottom_(self,rightBottom) 
""","Point_rightBottom_")
,"converting","""rightBottom: rightBottom
	" Return a Rectangle from the receiver to rightBottom. "

	^Rectangle leftTop: self rightBottom: rightBottom""",nil)
smalltalk.bind(smalltalk.Point,"to:",0
,smalltalk.__f__("""(self,rightBottom):
	#Point>>#to:
	return smalltalk.Rectangle.leftTop_rightBottom_(self,rightBottom) 
""","Point_to_")
,"converting","""to: rightBottom
	" Return a Rectangle from the receiver to rightBottom. "

	^Rectangle leftTop: self rightBottom: rightBottom""",nil)
smalltalk.bind(smalltalk.Point,"__tostring",0
,smalltalk.__f__("""(self):
	#Point>>#__tostring
	return smalltalk.to_String(self) 
""","Point___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Point,"isNilXXX",0
,smalltalk.__f__("""(self):
	#Point>>#isNilXXX
	def __blk1__():
		return smalltalk.isNil_(getattr(self,"@y",nil)) 
	return smalltalk.boolean_or_(smalltalk.isNil_(getattr(self,"@x",nil)),smalltalk.blk(__blk1__,0)) 
""","Point_isNilXXX")
,"_tests_","""isNilXXX
	" Responds true if the receiver is partially undefined. "

	^x isNil or: [ y isNil ]""",nil)
smalltalk.bind(smalltalk.Point,"testError:",0
,smalltalk.__f__("""(self,cause):
	#Point>>#testError:
	self.note_(cause) 
	return smalltalk.false 
""","Point_testError_")
,"debug","""testError: cause
	" Print an error and returns false. "

	self note: cause.
	^false""",nil)
smalltalk.bind(smalltalk.Point,"test_SuperInstanceSend",0
,smalltalk.__f__("""(self):
	#Point>>#test_SuperInstanceSend
	if not smalltalk.b(smalltalk.b_(smalltalk.superReceiver(smalltalk.Point,self).test_SuperInstanceSend() is smalltalk.Object)):
		return smalltalk.false 
	 
	return smalltalk.b_((self).__class__ is smalltalk.Point) 
""","Point_test_SuperInstanceSend")
,"_tests_","""test_SuperInstanceSend	"
	PythonEncoder export: Point>>#test_SuperInstanceSend
	"

	super test_SuperInstanceSend == Object ifFalse: [ ^false ].
	^self class == Point """,nil)
smalltalk.bind(smalltalk.Point,"test_SuperSendClass",0
,smalltalk.__f__("""(self):
	#Point>>#test_SuperSendClass
	return smalltalk.isObject_equalTo_(smalltalk.superReceiver(smalltalk.Point,self).test_SuperSendClass(),(self).__class__) 
""","Point_test_SuperSendClass")
,"_tests_","""test_SuperSendClass	"
	PythonEncoder export: Point>>#test_SuperSendClass
	"
	^super test_SuperSendClass = self class """,nil)
smalltalk.bind(smalltalk.Point,"test_SuperSendOther",0
,smalltalk.__f__("""(self):
	#Point>>#test_SuperSendOther
	return smalltalk.isObject_equalTo_(smalltalk.superReceiver(smalltalk.Point,self).test_SuperSendClass(),(self).__class__) 
""","Point_test_SuperSendOther")
,"_tests_","""test_SuperSendOther	"
	PythonEncoder export: Point>>#test_SuperSendOther
	"
	^super test_SuperSendClass = self class """,nil)
smalltalk.bind(smalltalk.Point,"test_recompile",0
,smalltalk.__f__("""(self):
	#Point>>#test_recompile
	def __blk1__():
		return smalltalk.Point.recompile_(smalltalk.String("asLiteral")) 
	smalltalk.PPParser.debugWhile_(smalltalk.blk(__blk1__,0)) 
	return smalltalk.isObject_equalTo_(smalltalk.Point.zero().asLiteral(),smalltalk.String("0@0")) 
""","Point_test_recompile")
,"_tests_","""test_recompile
	PPParser debugWhile: [ Point recompile: #asLiteral ].
	^Point zero asLiteral = '0@0'""",nil)
smalltalk.bind(smalltalk.Rectangle.__class__,"leftTop:extent:",0
,smalltalk.__f__("""(self,leftTop,extent):
	#Rectangle class>>#leftTop:extent:
	return self.new().leftTop_rightBottom_(leftTop,leftTop._plus(extent)) 
""","Rectangle_class_leftTop_extent_")
,"instantiation","""leftTop: leftTop extent: extent
	" Return an instance of the receiver. "

	^self new leftTop: leftTop rightBottom: leftTop + extent""",nil)
smalltalk.bind(smalltalk.Rectangle.__class__,"leftTop:rightBottom:",0
,smalltalk.__f__("""(self,leftTop,rightBottom):
	#Rectangle class>>#leftTop:rightBottom:
	return self.new().leftTop_rightBottom_(leftTop,rightBottom) 
""","Rectangle_class_leftTop_rightBottom_")
,"instantiation","""leftTop: leftTop rightBottom: rightBottom
	" Return an instance of the receiver. "

	^self new leftTop: leftTop rightBottom: rightBottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"=","_eq"
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#=
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(getattr(self,"@rightBottom",nil),aRectangle.rightBottom()) 
		return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(getattr(self,"@leftTop",nil),aRectangle.leftTop()),smalltalk.blk(__blk2__,0)) 
	return smalltalk.boolean_and_(aRectangle.isRectangle(),smalltalk.blk(__blk1__,0)) 
""","Rectangle__eq")
,"testing","""= aRectangle
	" Return true if the receiver is equal to argument. "

	^aRectangle isRectangle
	and: [ leftTop = aRectangle leftTop
	and: [ rightBottom = aRectangle rightBottom ]]""",nil)
smalltalk.bind(smalltalk.Rectangle,"area",0
,smalltalk.__f__("""(self):
	#Rectangle>>#area
	return self.height()._star(self.width()) 
""","Rectangle_area")
,"accessing","""area
	" Return the area of the receiver."

	^self height * self width""",nil)
smalltalk.bind(smalltalk.Rectangle,"areasOutside:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#areasOutside:
	def __blk1__():
		return aRectangle.containsPoint_(self.bottomRight()) 
	def __blk2__():
		return self.topLeft().rightBottom_(self.right()._at(aRectangle.top())) 
	def __blk3__():
		return self.left()._at(aRectangle.bottom()).rightBottom_(self.bottomRight()) 
	def __blk4__():
		return self.left()._at(self.top().max_(aRectangle.top())).rightBottom_(aRectangle.left()._at(self.bottom().min_(aRectangle.bottom()))) 
	def __blk5__():
		return aRectangle.right()._at(self.top().max_(aRectangle.top())).rightBottom_(self.right()._at(self.bottom().min_(aRectangle.bottom()))) 
	def __blk6__(each):
		return smalltalk.notNil_(each) 
	if not smalltalk.b(self.intersects_(aRectangle)):
		return smalltalk.Array.with_(self) 
	 
	if smalltalk.b(smalltalk.boolean_and_(aRectangle.containsPoint_(self.topLeft()),smalltalk.blk(__blk1__,0))):
		return smalltalk.newArray([]) 
	 
	return smalltalk.Array.with_with_with_with_(smalltalk.if_true_false_(aRectangle.top()._gt(self.top()),smalltalk.blk(__blk2__,0),nil),smalltalk.if_true_false_(aRectangle.bottom()._lt(self.bottom()),smalltalk.blk(__blk3__,0),nil),smalltalk.if_true_false_(aRectangle.left()._gt(self.left()),smalltalk.blk(__blk4__,0),nil),smalltalk.if_true_false_(aRectangle.right()._lt(self.right()),smalltalk.blk(__blk5__,0),nil)).select_(smalltalk.blk(__blk6__,1)) 
""","Rectangle_areasOutside_")
,"accessing","""areasOutside: aRectangle
	"Return a collection of rectangles where the receiver do not intersect aRectangle. "

	(self intersects: aRectangle) ifFalse: [ ^Array with: self ].
	((aRectangle containsPoint: self topLeft)
	and: [aRectangle containsPoint: self bottomRight])
        ifTrue: [ ^#() ].
	^(Array
	with: (aRectangle top > self top ifTrue: [ self topLeft rightBottom: self right @ aRectangle top])
	with: (aRectangle bottom < self bottom ifTrue: [ self left @ aRectangle bottom rightBottom: self bottomRight])
	with: (aRectangle left > self left ifTrue: [ self left @ (self top max: aRectangle top) rightBottom: aRectangle left @ (self bottom min: aRectangle bottom) ])
	with: (aRectangle right < self right ifTrue: [ aRectangle right @ (self top max: aRectangle top) rightBottom: self right @ (self bottom min: aRectangle bottom) ])
	) select: [:each| each notNil ]""",nil)
smalltalk.bind(smalltalk.Rectangle,"bottom",0
,smalltalk.__f__("""(self):
	#Rectangle>>#bottom
	return getattr(self,"@rightBottom",nil).y() 
""","Rectangle_bottom")
,"accessing","""bottom
	" Return the bottom of the receiver."

	^rightBottom y""",nil)
smalltalk.bind(smalltalk.Rectangle,"bottomCenter",0
,smalltalk.__f__("""(self):
	#Rectangle>>#bottomCenter
	return self.center().x()._at(self.bottom()) 
""","Rectangle_bottomCenter")
,"accessing","""bottomCenter
	" Return the center of the bottom edge of the receiver. "

	^self center x @ self bottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"bottomLeft",0
,smalltalk.__f__("""(self):
	#Rectangle>>#bottomLeft
	return self.left()._at(self.bottom()) 
""","Rectangle_bottomLeft")
,"accessing","""bottomLeft
	" Return the bottom-left corner of the receiver. "

	^self left @ self bottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"bottomRight",0
,smalltalk.__f__("""(self):
	#Rectangle>>#bottomRight
	return getattr(self,"@rightBottom",nil) 
""","Rectangle_bottomRight")
,"accessing","""bottomRight
	" Return the bottom-right corner of the receiver. "

	^rightBottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"center",0
,smalltalk.__f__("""(self):
	#Rectangle>>#center
	return getattr(self,"@leftTop",nil)._plus(getattr(self,"@rightBottom",nil))._slash_slash(smalltalk.Number(2)) 
""","Rectangle_center")
,"accessing","""center
	" Return the center of the receiver. "

	^leftTop + rightBottom // 2""",nil)
smalltalk.bind(smalltalk.Rectangle,"centerTop",0
,smalltalk.__f__("""(self):
	#Rectangle>>#centerTop
	return self.right()._plus(self.left())._slash_slash(smalltalk.Number(2))._at(self.top()) 
""","Rectangle_centerTop")
,"accessing","""centerTop
	" Return the center top of the receiver. "

	^self right + self left // 2 @ self top""",nil)
smalltalk.bind(smalltalk.Rectangle,"contains:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#contains:
	def __blk1__():
		def __blk2__():
			def __blk3__():
				return aRectangle.top()._gt_eq(self.top()) 
			return smalltalk.boolean_and_(self.bottom()._gt_eq(aRectangle.bottom()),smalltalk.blk(__blk3__,0)) 
		return smalltalk.boolean_and_(aRectangle.right()._lt_eq(self.right()),smalltalk.blk(__blk2__,0)) 
	return smalltalk.boolean_and_(self.left()._lt_eq(aRectangle.left()),smalltalk.blk(__blk1__,0)) 
""","Rectangle_contains_")
,"testing","""contains: aRectangle
	" Return true if aRectangle lies completely within or on the edge of the receiver. "

	^self left <= aRectangle left
	and: [ aRectangle right <= self right
	and: [ self bottom >= aRectangle bottom
	and: [ aRectangle top >= self top ]]]""",nil)
smalltalk.bind(smalltalk.Rectangle,"containsPoint:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#containsPoint:
	def __blk1__():
		def __blk2__():
			def __blk3__():
				return aPoint.y()._gt_eq(self.top()) 
			return smalltalk.boolean_and_(self.bottom()._gt(aPoint.y()),smalltalk.blk(__blk3__,0)) 
		return smalltalk.boolean_and_(aPoint.x()._lt(self.right()),smalltalk.blk(__blk2__,0)) 
	return smalltalk.boolean_and_(self.left()._lt_eq(aPoint.x()),smalltalk.blk(__blk1__,0)) 
""","Rectangle_containsPoint_")
,"testing","""containsPoint: aPoint
	" Return true if aPoint is contained within the receiver. "

	^(self left <= aPoint x)
	and: [ aPoint x < self right
	and: [ self bottom > aPoint y
	and: [ aPoint y >= self top ]]]""",nil)
smalltalk.bind(smalltalk.Rectangle,"expandBy:",0
,smalltalk.__f__("""(self,delta):
	#Rectangle>>#expandBy:
	if smalltalk.b(delta.isRectangle()):
		return getattr(self,"@leftTop",nil)._minus(delta.leftTop()).rightBottom_(getattr(self,"@rightBottom",nil)._plus(delta.rightBottom())) 
	 
	return getattr(self,"@leftTop",nil)._minus(delta).rightBottom_(getattr(self,"@rightBottom",nil)._plus(delta)) 
""","Rectangle_expandBy_")
,"accessing","""expandBy: delta
	" Return a Rectangle obtained from the receiver expanded by delta. "

	delta isRectangle ifTrue: [
            ^leftTop - delta leftTop rightBottom: rightBottom + delta rightBottom
	].
	^leftTop - delta rightBottom: rightBottom + delta""",nil)
smalltalk.bind(smalltalk.Rectangle,"extent",0
,smalltalk.__f__("""(self):
	#Rectangle>>#extent
	return self.width()._at(self.height()) 
""","Rectangle_extent")
,"accessing","""extent
	" Return receiver's width and height."

	^self width @ self height""",nil)
smalltalk.bind(smalltalk.Rectangle,"extent:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#extent:
	self.width_(aPoint.x()) 
	self.height_(aPoint.y()) 
	return self 
""","Rectangle_extent_")
,"accessing","""extent: aPoint
	" Set the extent of receiver to aPoint. "

	self width: aPoint x.
	self height: aPoint y""",nil)
smalltalk.bind(smalltalk.Rectangle,"height",0
,smalltalk.__f__("""(self):
	#Rectangle>>#height
	return getattr(self,"@leftTop",nil).y()._minus(getattr(self,"@rightBottom",nil).y()).abs() 
""","Rectangle_height")
,"accessing","""height
	" Return the height of the receiver. "

	^(leftTop y - rightBottom y) abs""",nil)
smalltalk.bind(smalltalk.Rectangle,"height:",0
,smalltalk.__f__("""(self,aNumber):
	#Rectangle>>#height:
	getattr(self,"@rightBottom",nil).y_(getattr(self,"@leftTop",nil).y()._plus(aNumber)) 
	return self 
""","Rectangle_height_")
,"accessing","""height: aNumber
	" Change the height of the receiver. "

	rightBottom y: leftTop y + aNumber""",nil)
smalltalk.bind(smalltalk.Rectangle,"insetBy:",0
,smalltalk.__f__("""(self,delta):
	#Rectangle>>#insetBy:
	if smalltalk.b(delta.isRectangle()):
		return getattr(self,"@leftTop",nil)._plus(delta.leftTop()).rightBottom_(getattr(self,"@rightBottom",nil)._minus(delta.rightBottom())) 
	 
	return getattr(self,"@leftTop",nil)._plus(delta).rightBottom_(getattr(self,"@rightBottom",nil)._minus(delta)) 
""","Rectangle_insetBy_")
,"accessing","""insetBy: delta
	" Return the receiver inset by delta. "

	delta isRectangle ifTrue: [
            ^leftTop + delta leftTop rightBottom: rightBottom - delta rightBottom
	].
	^leftTop + delta rightBottom: rightBottom - delta""",nil)
smalltalk.bind(smalltalk.Rectangle,"intersect:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#intersect:
	if smalltalk.b(smalltalk.isNil_(aRectangle)):
		return self 
	 
	return getattr(self,"@leftTop",nil).max_(aRectangle.leftTop()).rightBottom_(getattr(self,"@rightBottom",nil).min_(aRectangle.rightBottom())) 
""","Rectangle_intersect_")
,"accessing","""intersect: aRectangle
	" Return the rectangle in which the receiver and aRectangle overlap. "

	aRectangle isNil ifTrue: [ ^self ].
	^(leftTop max: aRectangle leftTop)
        rightBottom: (rightBottom min: aRectangle rightBottom)""",nil)
smalltalk.bind(smalltalk.Rectangle,"intersects:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#intersects:
	def __blk1__():
		return aRectangle.leftTop()._lt(getattr(self,"@rightBottom",nil)) 
	return smalltalk.boolean_and_(getattr(self,"@leftTop",nil)._lt(aRectangle.rightBottom()),smalltalk.blk(__blk1__,0)) 
""","Rectangle_intersects_")
,"accessing","""intersects: aRectangle
	" Return true if the receiver and aRectangle have any area in common. "

	^leftTop < aRectangle rightBottom
	and: [ aRectangle leftTop < rightBottom ]""",nil)
smalltalk.bind(smalltalk.Rectangle,"isRectangle",0
,smalltalk.__f__("""(self):
	#Rectangle>>#isRectangle
	return smalltalk.true 
""","Rectangle_isRectangle")
,"testing","""isRectangle
	" Return true if receiver is a Rectangle. "

	^true""",nil)
smalltalk.bind(smalltalk.Rectangle,"left",0
,smalltalk.__f__("""(self):
	#Rectangle>>#left
	return getattr(self,"@leftTop",nil).x() 
""","Rectangle_left")
,"accessing","""left
	" Return the left of the receiver. "

	^leftTop x""",nil)
smalltalk.bind(smalltalk.Rectangle,"leftBottom",0
,smalltalk.__f__("""(self):
	#Rectangle>>#leftBottom
	return self.left()._at(self.bottom()) 
""","Rectangle_leftBottom")
,"accessing","""leftBottom
	" Return the left bottom corner of the receiver. "

	^self left @ self bottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"leftCenter",0
,smalltalk.__f__("""(self):
	#Rectangle>>#leftCenter
	return self.left()._at(self.center().y()) 
""","Rectangle_leftCenter")
,"accessing","""leftCenter
	" Return the center of the left edge of the receiver. "

	^self left @ self center y""",nil)
smalltalk.bind(smalltalk.Rectangle,"leftTop",0
,smalltalk.__f__("""(self):
	#Rectangle>>#leftTop
	return getattr(self,"@leftTop",nil) 
""","Rectangle_leftTop")
,"accessing","""leftTop
	" Return the left top of the receiver. "

	^leftTop""",nil)
smalltalk.bind(smalltalk.Rectangle,"leftTop:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#leftTop:
	smalltalk.basic_at_put(self,"@leftTop",aPoint) 
	return self 
""","Rectangle_leftTop_")
,"accessing","""leftTop: aPoint
	" Set the leftTop of the receiver."

	leftTop := aPoint""",nil)
smalltalk.bind(smalltalk.Rectangle,"leftTop:rightBottom:",0
,smalltalk.__f__("""(self,leftTopPoint,rightBottomPoint):
	#Rectangle>>#leftTop:rightBottom:
	smalltalk.basic_at_put(self,"@leftTop",leftTopPoint) 
	smalltalk.basic_at_put(self,"@rightBottom",rightBottomPoint) 
	return self 
""","Rectangle_leftTop_rightBottom_")
,"accessing","""leftTop: leftTopPoint rightBottom: rightBottomPoint
	"Set the receiver's coordinates. "

	leftTop := leftTopPoint.
	rightBottom := rightBottomPoint.""",nil)
smalltalk.bind(smalltalk.Rectangle,"merge:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#merge:
	if smalltalk.b(smalltalk.isNil_(aRectangle)):
		return self 
	 
	return getattr(self,"@leftTop",nil).min_(aRectangle.leftTop()).rightBottom_(getattr(self,"@rightBottom",nil).max_(aRectangle.rightBottom())) 
""","Rectangle_merge_")
,"accessing","""merge: aRectangle
	" Return a Rectangle representing the area in which the receiver and aRectangle merged together. "

	aRectangle isNil ifTrue: [ ^self ].
	^(leftTop min: aRectangle leftTop) rightBottom: (rightBottom max: aRectangle rightBottom)""",nil)
smalltalk.bind(smalltalk.Rectangle,"moveBy:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#moveBy:
	smalltalk.basic_at_put(self,"@leftTop",getattr(self,"@leftTop",nil)._plus(aPoint)) 
	smalltalk.basic_at_put(self,"@rightBottom",getattr(self,"@rightBottom",nil)._plus(aPoint)) 
	return self 
""","Rectangle_moveBy_")
,"accessing","""moveBy: aPoint
	" Move the receiver by aPoint. "

	leftTop := leftTop + aPoint.
	rightBottom := rightBottom + aPoint""",nil)
smalltalk.bind(smalltalk.Rectangle,"moveTo:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#moveTo:
	self.moveBy_(aPoint._minus(getattr(self,"@leftTop",nil))) 
	return self 
""","Rectangle_moveTo_")
,"accessing","""moveTo: aPoint
	" Move the receiver to aPoint. "

	self moveBy: aPoint - leftTop""",nil)
smalltalk.bind(smalltalk.Rectangle,"moveToLeftTop:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#moveToLeftTop:
	self.moveBy_(aPoint._minus(self.leftTop())) 
	return self 
""","Rectangle_moveToLeftTop_")
,"accessing","""moveToLeftTop: aPoint
	" Move the receiver to leftTop. "

	self moveBy: aPoint - self leftTop""",nil)
smalltalk.bind(smalltalk.Rectangle,"nonIntersections:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#nonIntersections:
	__0__=smalltalk.newContext()
	def __blk1__():
		return aRectangle.containsPoint_(getattr(self,"@rightBottom",nil)) 
	def __blk2__():
		return getattr(self,"@leftTop",nil).rightBottom_(getattr(self,"@rightBottom",nil).x()._at(aRectangle.top())) 
	def __blk3__():
		return getattr(self,"@leftTop",nil).x()._at(aRectangle.bottom()).rightBottom_(getattr(self,"@rightBottom",nil)) 
	def __blk4__():
		return getattr(self,"@leftTop",nil).x()._at(getattr(self,"@leftTop",nil).y().max_(aRectangle.top())).rightBottom_(aRectangle.left()._at(getattr(self,"@rightBottom",nil).y().min_(aRectangle.bottom()))) 
	def __blk5__():
		return aRectangle.right()._at(getattr(self,"@leftTop",nil).y().max_(aRectangle.top())).rightBottom_(getattr(self,"@rightBottom",nil).x()._at(getattr(self,"@rightBottom",nil).y().min_(aRectangle.bottom()))) 
	def __blk6__(each):
		return smalltalk.notNil_(each) 
	__0__.areas=nil
	if not smalltalk.b(self.intersects_(aRectangle)):
		return smalltalk.Array.with_(self) 
	 
	if smalltalk.b(smalltalk.boolean_and_(aRectangle.containsPoint_(getattr(self,"@leftTop",nil)),smalltalk.blk(__blk1__,0))):
		return smalltalk.newArray([]) 
	 
	return smalltalk.Array.with_with_with_with_(smalltalk.if_true_false_(aRectangle.top()._gt(self.top()),smalltalk.blk(__blk2__,0),nil),smalltalk.if_true_false_(aRectangle.bottom()._lt(self.bottom()),smalltalk.blk(__blk3__,0),nil),smalltalk.if_true_false_(aRectangle.left()._gt(self.left()),smalltalk.blk(__blk4__,0),nil),smalltalk.if_true_false_(aRectangle.right()._lt(self.right()),smalltalk.blk(__blk5__,0),nil)).select_(smalltalk.blk(__blk6__,1)) 
""","Rectangle_nonIntersections_")
,"accessing","""nonIntersections: aRectangle
	" Return the rectangles describing areas of the receiver outside aRectangle. "

	| areas |
	(self intersects: aRectangle) ifFalse: [ ^Array with: self ].
	((aRectangle containsPoint: leftTop)
		and: [ aRectangle containsPoint: rightBottom ])
		ifTrue: [ ^#() ].
	^(Array
	with: (aRectangle top > self top ifTrue: [ leftTop rightBottom: rightBottom x @ aRectangle top ])
	with: (aRectangle bottom < self bottom ifTrue: [ leftTop x @ aRectangle bottom rightBottom: rightBottom ])
	with: (aRectangle left > self left ifTrue: [ leftTop x @ (leftTop y max: aRectangle top)
                rightBottom: aRectangle left @ (rightBottom y min: aRectangle bottom) ])
	with: (aRectangle right < self right ifTrue: [ aRectangle right @ (leftTop y max: aRectangle top)
                rightBottom: rightBottom x @ (rightBottom y min: aRectangle bottom) ])
	) select: [:each| each notNil ]""",nil)
smalltalk.bind(smalltalk.Rectangle,"toString",0
,smalltalk.__f__("""(self):
	#Rectangle>>#toString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.to_String(getattr(self,"@leftTop",nil)),smalltalk.String(" to: ")),smalltalk.to_String(getattr(self,"@rightBottom",nil))) 
""","Rectangle_toString")
,"printing","""toString
	" Return the printable representation of the receiver. "

	^leftTop toString ,' to: ' ,rightBottom toString """,nil)
smalltalk.bind(smalltalk.Rectangle,"printString",0
,smalltalk.__f__("""(self):
	#Rectangle>>#printString
	return smalltalk.to_String(self) 
""","Rectangle_printString")
,"printing","""printString
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.Rectangle,"relativeTo:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#relativeTo:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.isObject_equalTo_(aRectangle.extent().y(),smalltalk.Number(0)) 
	__0__.extent=nil
	__0__.extent=aRectangle.extent() 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isObject_equalTo_(aRectangle.extent().x(),smalltalk.Number(0)),smalltalk.blk(__blk1__,0))):
		return self 
	 
	return getattr(self,"@leftTop",nil)._minus(aRectangle.leftTop())._slash(__0__.extent).extent_(self.extent()._slash(__0__.extent)) 
""","Rectangle_relativeTo_")
,"accessing","""relativeTo: aRectangle
	" Return a Rectangle proportionally relative to aRectangle. "

	| extent |
	extent := aRectangle extent.
	(aRectangle extent x = 0 or: [ aRectangle extent y = 0 ]) ifTrue: [ ^self ].
	^leftTop - aRectangle leftTop / extent extent: self extent / extent""",nil)
smalltalk.bind(smalltalk.Rectangle,"right",0
,smalltalk.__f__("""(self):
	#Rectangle>>#right
	return getattr(self,"@rightBottom",nil).x() 
""","Rectangle_right")
,"accessing","""right
	" Return the receiver's right side. "

	^rightBottom x""",nil)
smalltalk.bind(smalltalk.Rectangle,"rightBottom",0
,smalltalk.__f__("""(self):
	#Rectangle>>#rightBottom
	return getattr(self,"@rightBottom",nil) 
""","Rectangle_rightBottom")
,"accessing","""rightBottom
	" Return the right bottom corner. "

	^rightBottom""",nil)
smalltalk.bind(smalltalk.Rectangle,"rightBottom:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#rightBottom:
	smalltalk.basic_at_put(self,"@rightBottom",aPoint) 
	return self 
""","Rectangle_rightBottom_")
,"accessing","""rightBottom: aPoint
	" Set the right bottom corner of the receiver. "

	rightBottom := aPoint""",nil)
smalltalk.bind(smalltalk.Rectangle,"rightCenter",0
,smalltalk.__f__("""(self):
	#Rectangle>>#rightCenter
	return self.right()._at(self.center().y()) 
""","Rectangle_rightCenter")
,"accessing","""rightCenter
	" Return the center of the right edge of the receiver. "

	^self right @ self center y""",nil)
smalltalk.bind(smalltalk.Rectangle,"rightTop",0
,smalltalk.__f__("""(self):
	#Rectangle>>#rightTop
	return self.right()._at(self.top()) 
""","Rectangle_rightTop")
,"accessing","""rightTop
        " Return the right top of the receiver. "

	^self right @ self top""",nil)
smalltalk.bind(smalltalk.Rectangle,"rounded",0
,smalltalk.__f__("""(self):
	#Rectangle>>#rounded
	smalltalk.basic_at_put(self,"@leftTop",getattr(self,"@leftTop",nil).rounded()) 
	smalltalk.basic_at_put(self,"@rightBottom",getattr(self,"@rightBottom",nil).rounded()) 
	return self 
""","Rectangle_rounded")
,"accessing","""rounded
	" Set the receiver with coordinates rounded to integers. "

	leftTop := leftTop rounded.
	rightBottom := rightBottom rounded.""",nil)
smalltalk.bind(smalltalk.Rectangle,"scaleBy:",0
,smalltalk.__f__("""(self,delta):
	#Rectangle>>#scaleBy:
	return getattr(self,"@leftTop",nil)._star(delta).rightBottom_(getattr(self,"@rightBottom",nil)._star(delta)) 
""","Rectangle_scaleBy_")
,"accessing","""scaleBy: delta
	" Return the receiver multiplied by delta. "

	^leftTop * delta rightBottom: rightBottom * delta""",nil)
smalltalk.bind(smalltalk.Rectangle,"scaleTo:",0
,smalltalk.__f__("""(self,aRectangle):
	#Rectangle>>#scaleTo:
	return aRectangle.scaleBy_(self.extent()).truncated().moveBy_(self.leftTop()) 
""","Rectangle_scaleTo_")
,"accessing","""scaleTo: aRectangle
	" Return a Rectangle whose size is proportional to the receiver with ratios specified by aRectangle. "

	^(aRectangle scaleBy: self extent) truncated moveBy: self leftTop""",nil)
smalltalk.bind(smalltalk.Rectangle,"top",0
,smalltalk.__f__("""(self):
	#Rectangle>>#top
	return getattr(self,"@leftTop",nil).y() 
""","Rectangle_top")
,"accessing","""top
	" Return the top side of the receiver. "

	^leftTop y""",nil)
smalltalk.bind(smalltalk.Rectangle,"topCenter",0
,smalltalk.__f__("""(self):
	#Rectangle>>#topCenter
	return self.center().x()._at(self.top()) 
""","Rectangle_topCenter")
,"accessing","""topCenter
	" Return the center of the top edge of the receiver. "

	^self center x @ self top""",nil)
smalltalk.bind(smalltalk.Rectangle,"topLeft",0
,smalltalk.__f__("""(self):
	#Rectangle>>#topLeft
	return getattr(self,"@leftTop",nil) 
""","Rectangle_topLeft")
,"accessing","""topLeft
	" Return the top-left corner of the receiver. "

	^leftTop""",nil)
smalltalk.bind(smalltalk.Rectangle,"topLeft:",0
,smalltalk.__f__("""(self,aPoint):
	#Rectangle>>#topLeft:
	smalltalk.basic_at_put(self,"@leftTop",aPoint) 
	return self 
""","Rectangle_topLeft_")
,"accessing","""topLeft: aPoint
	"Set the top left corner of the receiver. "

	leftTop := aPoint""",nil)
smalltalk.bind(smalltalk.Rectangle,"topRight",0
,smalltalk.__f__("""(self):
	#Rectangle>>#topRight
	return self.right()._at(self.top()) 
""","Rectangle_topRight")
,"accessing","""topRight
	" Return the top-right corner of the receiver. "

	^self right @ self top""",nil)
smalltalk.bind(smalltalk.Rectangle,"translateBy:",0
,smalltalk.__f__("""(self,delta):
	#Rectangle>>#translateBy:
	return getattr(self,"@leftTop",nil)._plus(delta).rightBottom_(getattr(self,"@rightBottom",nil)._plus(delta)) 
""","Rectangle_translateBy_")
,"accessing","""translateBy: delta
	" Return the receiver with position incremented by delta. "

	^leftTop + delta rightBottom: rightBottom + delta""",nil)
smalltalk.bind(smalltalk.Rectangle,"truncated",0
,smalltalk.__f__("""(self):
	#Rectangle>>#truncated
	smalltalk.basic_at_put(self,"@leftTop",getattr(self,"@leftTop",nil).truncated()) 
	smalltalk.basic_at_put(self,"@rightBottom",getattr(self,"@rightBottom",nil).truncated()) 
	return self 
""","Rectangle_truncated")
,"accessing","""truncated
	" Set the receiver with the coordinates truncated to integers. "

	leftTop := leftTop truncated.
	rightBottom := rightBottom truncated.""",nil)
smalltalk.bind(smalltalk.Rectangle,"width",0
,smalltalk.__f__("""(self):
	#Rectangle>>#width
	return getattr(self,"@rightBottom",nil).x()._minus(getattr(self,"@leftTop",nil).x()).abs() 
""","Rectangle_width")
,"accessing","""width
	" Return the width of the receiver. "

	^(rightBottom x - leftTop x) abs""",nil)
smalltalk.bind(smalltalk.Rectangle,"width:",0
,smalltalk.__f__("""(self,anInteger):
	#Rectangle>>#width:
	getattr(self,"@rightBottom",nil).x_(getattr(self,"@leftTop",nil).x()._plus(anInteger)) 
	return self 
""","Rectangle_width_")
,"accessing","""width: anInteger
	" Set the width of the receiver. "

	rightBottom x: leftTop x + anInteger""",nil)
smalltalk.bind(smalltalk.Rectangle,"__tostring",0
,smalltalk.__f__("""(self):
	#Rectangle>>#__tostring
	return smalltalk.to_String(self) 
""","Rectangle___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.EvaluableAction,",","_comma"
,smalltalk.__f__("""(self,anAction):
	#EvaluableAction>>#,
	return smalltalk.ActionSequence.with_with_(self,anAction) 
""","EvaluableAction__comma")
,"composing",""", anAction
	" Return the receiver composed with the argument. "

	^ActionSequence with: self with: anAction""",nil)
smalltalk.bind(smalltalk.Message.__class__,"selector:arguments:",0
,smalltalk.__f__("""(self,aString,anArray):
	#Message class>>#selector:arguments:
	def __blk1__(_s8_rec):
		_s8_rec.selector_(aString) 
		_s8_rec.arguments_(anArray) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Message_class_selector_arguments_")
,"instantiation","""selector: aString arguments: anArray
	" Return an instance of the receiver. "

	^self new
		selector: aString;
		arguments: anArray;
		yourself""",nil)
smalltalk.bind(smalltalk.Message.__class__,"receiver:selector:arguments:",0
,smalltalk.__f__("""(self,anObject,aString,anArray):
	#Message class>>#receiver:selector:arguments:
	def __blk1__(_s8_rec):
		_s8_rec.receiver_(anObject) 
		_s8_rec.selector_(aString) 
		_s8_rec.arguments_(anArray) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Message_class_receiver_selector_arguments_")
,"instantiation","""receiver: anObject selector: aString arguments: anArray
	" Return an instance of the receiver. "

	^self new
		receiver: anObject;
		selector: aString;
		arguments: anArray;
		yourself""",nil)
smalltalk.bind(smalltalk.Message,"selector",0
,smalltalk.__f__("""(self):
	#Message>>#selector
	return getattr(self,"@selector",nil) 
""","Message_selector")
,"accessing","""selector
	" Return the selector of the receiver. "

	^selector""",nil)
smalltalk.bind(smalltalk.Message,"selector:",0
,smalltalk.__f__("""(self,aString):
	#Message>>#selector:
	smalltalk.basic_at_put(self,"@selector",aString) 
	return self 
""","Message_selector_")
,"accessing","""selector: aString
	" Set the selector of the receiver. "

	selector := aString""",nil)
smalltalk.bind(smalltalk.Message,"arguments:",0
,smalltalk.__f__("""(self,anArray):
	#Message>>#arguments:
	smalltalk.basic_at_put(self,"@arguments",anArray) 
	return self 
""","Message_arguments_")
,"accessing","""arguments: anArray
	" Set the arguments of the receiver. "

	arguments := anArray""",nil)
smalltalk.bind(smalltalk.Message,"arguments",0
,smalltalk.__f__("""(self):
	#Message>>#arguments
	return getattr(self,"@arguments",nil) 
""","Message_arguments")
,"accessing","""arguments
	" Return the arguments of the receiver. "

	^arguments""",nil)
smalltalk.bind(smalltalk.Message,"receiver",0
,smalltalk.__f__("""(self):
	#Message>>#receiver
	return getattr(self,"@receiver",nil) 
""","Message_receiver")
,"accessing","""receiver
	" Return the receiver of the receiver. "

	^receiver""",nil)
smalltalk.bind(smalltalk.Message,"receiver:",0
,smalltalk.__f__("""(self,anObject):
	#Message>>#receiver:
	smalltalk.basic_at_put(self,"@receiver",anObject) 
	return self 
""","Message_receiver_")
,"accessing","""receiver: anObject
	" Set the receiver of the receiver. "

	receiver := anObject""",nil)
smalltalk.bind(smalltalk.Message,"comment",0
,smalltalk.__f__("""(self):
	#Message>>#comment
	return smalltalk.basic_at_(self,smalltalk.String("@comment")) 
""","Message_comment")
,"accessing","""comment
	" Return the comment of the receiver (or nil). "

	^self basicAt: '@comment'""",nil)
smalltalk.bind(smalltalk.Message,"comment:",0
,smalltalk.__f__("""(self,aString):
	#Message>>#comment:
	if smalltalk.b(smalltalk.isNil_(aString)):
		return self.basicDelete_(smalltalk.String("@comment")) 
	 
	smalltalk.basic_at_put_(self,smalltalk.String("@comment"),aString) 
	return self 
""","Message_comment_")
,"accessing","""comment: aString
	" Set the comment of the receiver. "

	aString isNil ifTrue: [ ^self basicDelete: '@comment' ].
	self basicAt: '@comment' put: aString""",nil)
smalltalk.bind(smalltalk.Message,"perform",0
,smalltalk.__f__("""(self):
	#Message>>#perform
	return self.receiver().perform_withArguments_(self.selector(),self.arguments()) 
""","Message_perform")
,"private","""perform
	" Return the result of sending the receiver. "

	^self receiver
		perform: self selector
		withArguments: self arguments""",nil)
smalltalk.bind(smalltalk.Message,"performDeferred",0
,smalltalk.__f__("""(self):
	#Message>>#performDeferred
	def __blk1__():
		return self.perform() 
	smalltalk.blk(__blk1__,0).valueDeferred() 
	return self 
""","Message_performDeferred")
,"evaluating","""performDeferred
	" Evaluate the receiver deferred in time.
	Return the receiver.
	"

	[ self perform ] valueDeferred.""",nil)
smalltalk.bind(smalltalk.Message,"evaluate",0
,smalltalk.__f__("""(self):
	#Message>>#evaluate
	return self.perform() 
""","Message_evaluate")
,"evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	^self perform""",nil)
smalltalk.bind(smalltalk.Message,"evaluateFor:",0
,smalltalk.__f__("""(self,anObject):
	#Message>>#evaluateFor:
	return self.evaluateWithArguments_(smalltalk.Array.with_(anObject)) 
""","Message_evaluateFor_")
,"evaluating","""evaluateFor: anObject
	" Return the result of evaluating the receiver with anObject. "

	^self evaluateWithArguments: (Array with: anObject)""",nil)
smalltalk.bind(smalltalk.Message,"evaluateWithArguments:",0
,smalltalk.__f__("""(self,anArray):
	#Message>>#evaluateWithArguments:
	return self.receiver().perform_withArguments_(self.selector(),self.collectArguments_(anArray)) 
""","Message_evaluateWithArguments_")
,"evaluating","""evaluateWithArguments: anArray
	" Return the result of evaluating the receiver. "

	^self receiver
		perform: self selector
		withArguments: (self collectArguments: anArray)""",nil)
smalltalk.bind(smalltalk.Message,"initializeArguments",0
,smalltalk.__f__("""(self):
	#Message>>#initializeArguments
	smalltalk.basic_at_put(self,"@arguments",smalltalk.Array.new_(self.selector().argumentCount())) 
	return self 
""","Message_initializeArguments")
,"private","""initializeArguments
	" Private - Initialize the arguments of the receiver. "

	arguments := Array new: self selector argumentCount""",nil)
smalltalk.bind(smalltalk.Message,"argumentCount",0
,smalltalk.__f__("""(self):
	#Message>>#argumentCount
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@arguments",nil))):
		self.initializeArguments() 
	 
	return getattr(self,"@arguments",nil).size() 
""","Message_argumentCount")
,"private","""argumentCount
	" Return the number of arguments of the receiver. "

	arguments isNil ifTrue: [ self initializeArguments ].
	^arguments size""",nil)
smalltalk.bind(smalltalk.Message,"collectArguments:",0
,smalltalk.__f__("""(self,evaluationArguments):
	#Message>>#collectArguments:
	if smalltalk.b(smalltalk.isObject_equalTo_(getattr(self,"@arguments",nil).size(),evaluationArguments.size())):
		return evaluationArguments 
	 
	return evaluationArguments.copyFrom_to_(smalltalk.Number(1),self.argumentCount().min_(evaluationArguments.size())) 
""","Message_collectArguments_")
,"private","""collectArguments: evaluationArguments
	" Private - Return the arguments to evaluate the receiver. "

	arguments size = evaluationArguments size ifTrue: [ ^evaluationArguments ].
	^evaluationArguments copyFrom: 1 to: (self argumentCount min: evaluationArguments size)""",nil)
smalltalk.bind(smalltalk.Message,"resolve:with:",0
,smalltalk.__f__("""(self,what,aPoolOrBlock):
	#Message>>#resolve:with:
	if not smalltalk.b(aPoolOrBlock.isMemberOf_(smalltalk.PoolDictionary)):
		return aPoolOrBlock.evaluateWith_(what) 
	 
	if smalltalk.b(smalltalk.isNil_(what)):
		return what 
	 
	if not smalltalk.b(self.isObject_(what)):
		return what 
	 
	if smalltalk.b(what.isString()):
		def __blk1__():
			return what 
		return aPoolOrBlock.at_ifAbsent_(what,smalltalk.blk(__blk1__,0)) 
	 
	return what 
""","Message_resolve_with_")
,"resolution","""resolve: what with: aPoolOrBlock
	" Private - Return the receiver to be evaluated with mappings given by aPoolOrBlock. "

	(aPoolOrBlock isMemberOf: PoolDictionary) ifFalse: [
		^aPoolOrBlock evaluateWith: what
	].
	what isNil ifTrue: [ ^what ].
	(self isObject: what) ifFalse: [ ^what ].
	what isString ifTrue: [ ^aPoolOrBlock at: what ifAbsent: [ what ] ].
	^what""",nil)
smalltalk.bind(smalltalk.Message,"resolveWith:",0
,smalltalk.__f__("""(self,aPoolOrBlock):
	#Message>>#resolveWith:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__(each):
			return self.resolve_with_(each,aPoolOrBlock) 
		return getattr(self,"@arguments",nil).collect_(smalltalk.blk(__blk2__,1)) 
	__0__.args=nil
	__0__.args=smalltalk.if_true_false_(smalltalk.notNil_(getattr(self,"@arguments",nil)),smalltalk.blk(__blk1__,0),nil) 
	return (self).__class__.receiver_selector_arguments_(self.resolve_with_(getattr(self,"@receiver",nil),aPoolOrBlock),self.selector(),__0__.args) 
""","Message_resolveWith_")
,"resolution","""resolveWith: aPoolOrBlock
	" Return a message set to be evaluated with mappings given by aPoolOrBlock. "

	| args |
	args := arguments notNil ifTrue: [
		arguments collect: [:each|
			self resolve: each with: aPoolOrBlock
		]
	].
	^self class
		receiver: (self resolve: receiver with: aPoolOrBlock)
		selector: self selector
		arguments: args""",nil)
smalltalk.bind(smalltalk.Message,"isMessage",0
,smalltalk.__f__("""(self):
	#Message>>#isMessage
	return smalltalk.true 
""","Message_isMessage")
,"testing","""isMessage
	" Return true if the receiver is a message. "

	^true""",nil)
smalltalk.bind(smalltalk.LinkMessage,"resultAction",0
,smalltalk.__f__("""(self):
	#LinkMessage>>#resultAction
	return getattr(self,"@resultAction",nil) 
""","LinkMessage_resultAction")
,"accessing","""resultAction
	" Return the resultAction of the receiver. "

	^resultAction""",nil)
smalltalk.bind(smalltalk.LinkMessage,"resultAction:",0
,smalltalk.__f__("""(self,anObject):
	#LinkMessage>>#resultAction:
	smalltalk.basic_at_put(self,"@resultAction",anObject) 
	return self 
""","LinkMessage_resultAction_")
,"accessing","""resultAction: anObject
	" Set the resultAction of the receiver. "

	resultAction := anObject""",nil)
smalltalk.bind(smalltalk.LinkMessage,"evaluate",0
,smalltalk.__f__("""(self):
	#LinkMessage>>#evaluate
	return self.evaluateWithArguments_(smalltalk.newArray([])) 
""","LinkMessage_evaluate")
,"evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	^self evaluateWithArguments: #()""",nil)
smalltalk.bind(smalltalk.LinkMessage,"collectArguments:",0
,smalltalk.__f__("""(self,evaluationArguments):
	#LinkMessage>>#collectArguments:
	def __blk1__(each):
		return each.evaluateWithArguments_(evaluationArguments) 
	return self.arguments().collect_(smalltalk.blk(__blk1__,1)) 
""","LinkMessage_collectArguments_")
,"evaluating","""collectArguments: evaluationArguments
	" Private - Return the arguments to evaluate the receiver. "

	^self arguments collect: [:each| each evaluateWithArguments: evaluationArguments ]""",nil)
smalltalk.bind(smalltalk.ActionSequence.__class__,"withAll:",0
,smalltalk.__f__("""(self,aCollection):
	#ActionSequence class>>#withAll:
	def __blk1__(_s8_rec):
		_s8_rec.contents_(aCollection) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","ActionSequence_class_withAll_")
,"instantiation","""withAll: aCollection
	" Return an instance of the receiver. "

	^self new
		contents: aCollection;
		yourself""",nil)
smalltalk.bind(smalltalk.ActionSequence.__class__,"with:",0
,smalltalk.__f__("""(self,anObject):
	#ActionSequence class>>#with:
	return self.withAll_(smalltalk.Array.with_(anObject)) 
""","ActionSequence_class_with_")
,"instantiation","""with: anObject
	" Return an instance of the receiver. "

	^self withAll: (Array with: anObject)""",nil)
smalltalk.bind(smalltalk.ActionSequence.__class__,"with:with:",0
,smalltalk.__f__("""(self,anObject,bObject):
	#ActionSequence class>>#with:with:
	return self.withAll_(smalltalk.Array.with_with_(anObject,bObject)) 
""","ActionSequence_class_with_with_")
,"instantiation","""with: anObject with: bObject
	" Return an instance of the receiver. "

	^self withAll: (Array with: anObject with: bObject)""",nil)
smalltalk.bind(smalltalk.ActionSequence.__class__,"with:with:with:",0
,smalltalk.__f__("""(self,anObject,bObject,cObject):
	#ActionSequence class>>#with:with:with:
	return self.withAll_(smalltalk.Array.with_with_with_(anObject,bObject,cObject)) 
""","ActionSequence_class_with_with_with_")
,"instantiation","""with: anObject with: bObject with: cObject
	" Return an instance of the receiver. "

	^self withAll: (Array with: anObject with: bObject with: cObject)""",nil)
smalltalk.bind(smalltalk.ActionSequence,"contents:",0
,smalltalk.__f__("""(self,aCollection):
	#ActionSequence>>#contents:
	smalltalk.basic_at_put(self,"@contents",aCollection) 
	return self 
""","ActionSequence_contents_")
,"private","""contents: aCollection
	" Private - Set the contents of the receiver. "

	contents := aCollection""",nil)
smalltalk.bind(smalltalk.ActionSequence,"contents",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#contents
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@contents",nil))):
		smalltalk.basic_at_put(self,"@contents",smalltalk.Array.new()) 
	 
	return getattr(self,"@contents",nil) 
""","ActionSequence_contents")
,"private","""contents
	" Private - Return the contents of the receiver. "

	contents isNil ifTrue: [ contents := Array new ].
	^contents""",nil)
smalltalk.bind(smalltalk.ActionSequence,"isEmpty",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#isEmpty
	def __blk1__():
		return getattr(self,"@contents",nil).isEmpty() 
	return smalltalk.boolean_or_(smalltalk.isNil_(getattr(self,"@contents",nil)),smalltalk.blk(__blk1__,0)) 
""","ActionSequence_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^contents isNil or: [ contents isEmpty ]""",nil)
smalltalk.bind(smalltalk.ActionSequence,"notEmpty",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#notEmpty
	def __blk1__():
		return getattr(self,"@contents",nil).notEmpty() 
	return smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@contents",nil)),smalltalk.blk(__blk1__,0)) 
""","ActionSequence_notEmpty")
,"testing","""notEmpty
	" Return true if the receiver is not empty. "

	^contents notNil and: [ contents notEmpty ]""",nil)
smalltalk.bind(smalltalk.ActionSequence,"asArray",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#asArray
	if smalltalk.b(self.isEmpty()):
		return smalltalk.newArray([]) 
	 
	return getattr(self,"@contents",nil).asArray() 
""","ActionSequence_asArray")
,"converting","""asArray
	" Return an array with the contents of the receiver. "

	self isEmpty ifTrue: [ ^#() ].
	^contents asArray""",nil)
smalltalk.bind(smalltalk.ActionSequence,"asActionSequence",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#asActionSequence
	return self 
""","ActionSequence_asActionSequence")
,"converting","""asActionSequence
	" Return an ActionSequence from the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.ActionSequence,",","_comma"
,smalltalk.__f__("""(self,anAction):
	#ActionSequence>>#,
	if smalltalk.b(self.isEmpty()):
		return anAction.asActionSequence() 
	 
	return (self).__class__.withAll_(smalltalk.object_comma_(self.contents(),anAction.asActionSequence().contents())) 
""","ActionSequence__comma")
,"converting",""", anAction
	" Return an action composed with the receiver and anAction. "

	self isEmpty ifTrue: [ ^anAction asActionSequence ].
	^self class withAll: self contents , anAction asActionSequence contents""",nil)
smalltalk.bind(smalltalk.ActionSequence,"copyWith:",0
,smalltalk.__f__("""(self,anObject):
	#ActionSequence>>#copyWith:
	return (self).__class__.withAll_(self.contents().copyWith_(anObject)) 
""","ActionSequence_copyWith_")
,"converting","""copyWith: anObject
	" Return an action composed with the receiver and anObject. "

	^self class withAll: (self contents copyWith: anObject)""",nil)
smalltalk.bind(smalltalk.ActionSequence,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#ActionSequence>>#do:
	def __blk1__():
		return self.contents().do_(aBlock) 
	return smalltalk.if_true_false_(self.notEmpty(),smalltalk.blk(__blk1__,0),nil) 
""","ActionSequence_do_")
,"converting","""do: aBlock
	" Evaluate aBlock for each object in the receiver's contents. "

	^self notEmpty ifTrue: [ self contents do: aBlock ]""",nil)
smalltalk.bind(smalltalk.ActionSequence,"includes:",0
,smalltalk.__f__("""(self,anObject):
	#ActionSequence>>#includes:
	def __blk1__():
		return self.contents().includes_(anObject) 
	return smalltalk.boolean_and_(self.notEmpty(),smalltalk.blk(__blk1__,0)) 
""","ActionSequence_includes_")
,"testing","""includes: anObject
	" Return true if anObject is in the receiver. "

	^self notEmpty and: [ self contents includes: anObject ]""",nil)
smalltalk.bind(smalltalk.ActionSequence,"select:",0
,smalltalk.__f__("""(self,aBlock):
	#ActionSequence>>#select:
	return (self).__class__.withAll_(self.asArray().select_(aBlock)) 
""","ActionSequence_select_")
,"enumerating","""select: aBlock
	" Return the a copy of the receiver with elements wich evaluates aBlock to true. "

	^self class withAll: (self asArray select: aBlock)""",nil)
smalltalk.bind(smalltalk.ActionSequence,"reject:",0
,smalltalk.__f__("""(self,aBlock):
	#ActionSequence>>#reject:
	return (self).__class__.withAll_(self.asArray().reject_(aBlock)) 
""","ActionSequence_reject_")
,"enumerating","""reject: aBlock
	" Return the a copy of the receiver with elements wich evaluates aBlock to false. "

	^self class withAll: (self asArray reject: aBlock)""",nil)
smalltalk.bind(smalltalk.ActionSequence,"evaluate",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#evaluate
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=each.evaluate()
		return __0__.result 
	__0__.result=nil
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ActionSequence_evaluate")
,"evaluating","""evaluate
	" Return the result of evaluating the receiver. "

	| result |
	self do: [:each| result := each evaluate ].
	^result""",nil)
smalltalk.bind(smalltalk.ActionSequence,"evaluateWithArguments:",0
,smalltalk.__f__("""(self,anArray):
	#ActionSequence>>#evaluateWithArguments:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=each.evaluateWithArguments_(anArray)
		return __0__.result 
	__0__.result=nil
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ActionSequence_evaluateWithArguments_")
,"evaluating","""evaluateWithArguments: anArray
	" Return the result of evaluating the receiver. "

	| result |
	self do: [:each| result := each evaluateWithArguments: anArray ].
	^result""",nil)
smalltalk.bind(smalltalk.ActionSequence,"evaluateFor:",0
,smalltalk.__f__("""(self,anObject):
	#ActionSequence>>#evaluateFor:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=each.evaluateFor_(anObject)
		return __0__.result 
	__0__.result=nil
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ActionSequence_evaluateFor_")
,"evaluating","""evaluateFor: anObject
	" Return the result of evaluating the receiver with anObject. "

	| result |
	self do: [:each| result := each evaluateFor: anObject ].
	^result""",nil)
smalltalk.bind(smalltalk.ActionSequence,"reduced",0
,smalltalk.__f__("""(self):
	#ActionSequence>>#reduced
	def __blk1__():
		def __blk2__():
			return getattr(self,"@contents",nil).first() 
		def __blk3__():
			return self 
		return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(getattr(self,"@contents",nil).size(),smalltalk.Number(1)),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return smalltalk.if_true_false_(self.notEmpty(),smalltalk.blk(__blk1__,0),nil) 
""","ActionSequence_reduced")
,"events","""reduced
	" Return the receiver reduced to minimal evaluable expression. "

	^self notEmpty ifTrue: [
		contents size = 1
		ifTrue: [ contents first ]
		ifFalse: [ self ]
	]""",nil)
smalltalk.bind(smalltalk.ActionSequence,"evaluateWithSelector:withArguments:",0
,smalltalk.__f__("""(self,aSelector,array):
	#ActionSequence>>#evaluateWithSelector:withArguments:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=each.receiver().perform_withArguments_(aSelector,array)
		return __0__.result 
	__0__.result=nil
	self.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","ActionSequence_evaluateWithSelector_withArguments_")
,"changes","""evaluateWithSelector: aSelector withArguments: array
	" Private - Return the result of evaluating the receiver with aSelector and arguments array. "

	| result |
	self do: [:each| result := each receiver perform: aSelector withArguments: array ].
	^result""",nil)
smalltalk.bind(smalltalk.ActionSequence,"resolveWith:",0
,smalltalk.__f__("""(self,aPoolOrBlock):
	#ActionSequence>>#resolveWith:
	def __blk1__(each):
		def __blk2__():
			return each.resolveWith_(aPoolOrBlock) 
		def __blk3__():
			return each 
		return smalltalk.if_true_false_(smalltalk.responds_to_(each,(smalltalk.String("resolveWith:"))),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return (self).__class__.withAll_(self.asArray().collect_(smalltalk.blk(__blk1__,1))) 
""","ActionSequence_resolveWith_")
,"resolution","""resolveWith: aPoolOrBlock
	" Return an instance set to be evaluated with mappings given by aPoolOrBlock. "

	^self class withAll: (self asArray collect: [:each|
		(each respondsTo: #resolveWith:)
		ifTrue: [ each resolveWith: aPoolOrBlock ]
		ifFalse: [ each ]
	])""",nil)
smalltalk.bind(smalltalk.EventManager.__class__,"eventsTriggered",0
,smalltalk.__f__("""(self):
	#EventManager class>>#eventsTriggered
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@eventsTriggered",nil))):
		self.initializeEventsTriggered() 
	 
	return getattr(self,"@eventsTriggered",nil) 
""","EventManager_class_eventsTriggered")
,"events","""eventsTriggered
	" Return all the events managed by instances of the receiver. "

	eventsTriggered isNil ifTrue: [ self initializeEventsTriggered ].
	^eventsTriggered""",nil)
smalltalk.bind(smalltalk.EventManager.__class__,"eventsTriggered:",0
,smalltalk.__f__("""(self,aCollection):
	#EventManager class>>#eventsTriggered:
	smalltalk.basic_at_put(self,"@eventsTriggered",aCollection) 
	return self 
""","EventManager_class_eventsTriggered_")
,"events","""eventsTriggered: aCollection
	" Set all the events managed by instances of the receiver. "

	eventsTriggered := aCollection""",nil)
smalltalk.bind(smalltalk.EventManager.__class__,"initializeEventsTriggered",0
,smalltalk.__f__("""(self):
	#EventManager class>>#initializeEventsTriggered
	self.eventsTriggered_(self.constructEventsTriggered()) 
	return self 
""","EventManager_class_initializeEventsTriggered")
,"events","""initializeEventsTriggered
	" Private - Initialize all the events managed by instances of the receiver. "

	self eventsTriggered: self constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.EventManager,"eventTable",0
,smalltalk.__f__("""(self):
	#EventManager>>#eventTable
	def __blk1__():
		return self.eventTableCreate() 
	def __blk2__():
		return getattr(self,"@handlers",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@handlers",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","EventManager_eventTable")
,"events","""eventTable
	" Private - Return the mapping event names to actions of the receiver. "

	^handlers isNil
		ifTrue: [ self eventTableCreate ]
		ifFalse: [ handlers ]""",nil)
smalltalk.bind(smalltalk.EventManager,"eventTableForEdit",0
,smalltalk.__f__("""(self):
	#EventManager>>#eventTableForEdit
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@handlers",nil))):
		smalltalk.basic_at_put(self,"@handlers",self.eventTableCreate()) 
	 
	return getattr(self,"@handlers",nil) 
""","EventManager_eventTableForEdit")
,"events","""eventTableForEdit
	" Private - Return the mapping event names to actions of the receiver.
	Set the internal map if not present.
	"

	handlers isNil ifTrue: [ handlers := self eventTableCreate ].
	^handlers""",nil)
smalltalk.bind(smalltalk.EventManager,"releaseEventTable",0
,smalltalk.__f__("""(self):
	#EventManager>>#releaseEventTable
	smalltalk.basic_at_put(self,"@handlers",nil) 
	return self 
""","EventManager_releaseEventTable")
,"events","""releaseEventTable
	" Private - Release the event table. "

	handlers := nil""",nil)
smalltalk.bind(smalltalk.S8Encoder.__class__,"for:",0
,smalltalk.__f__("""(self,aCompiler):
	#S8Encoder class>>#for:
	return self.support().new().compiler_(aCompiler) 
""","S8Encoder_class_for_")
,"instantiation","""for: aCompiler
	" Private - Return an instance of the receiver. "

	^self support new compiler: aCompiler""",nil)
smalltalk.bind(smalltalk.S8Encoder.__class__,"support",0
,smalltalk.__f__("""(self):
	#S8Encoder class>>#support
	__0__=smalltalk.newContext()
	def __blk1__(cls):
		return cls.supportsLanguage_(__0__.lang) 
	def __blk2__():
		return self.invalidMessage_(smalltalk.String("support")) 
	__0__.lang=nil
	__0__.lang=smalltalk.Smalltalk.nativeLanguage() 
	return self.allSubclasses().detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
""","S8Encoder_class_support")
,"instantiation","""support
	" Private - Return the support to encode for native platform. "

	| lang |
	lang := Smalltalk nativeLanguage.
	^self allSubclasses
		detect: [:cls| cls supportsLanguage: lang ]
		ifNone: [ self invalidMessage: #support ]""",nil)
smalltalk.bind(smalltalk.S8Encoder.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,aLanguage):
	#S8Encoder class>>#supportsLanguage:
	return smalltalk.false 
""","S8Encoder_class_supportsLanguage_")
,"instantiation","""supportsLanguage: aLanguage
	" Private - Return true if instances of the receiver can encode to aLanguage. "

	^false""",nil)
smalltalk.bind(smalltalk.S8Encoder.__class__,"export:",0
,smalltalk.__f__("""(self,what):
	#S8Encoder class>>#export:
	return self.new().export_(what) 
""","S8Encoder_class_export_")
,"Tools-export","""export: what
	" Return the native code result of encoding elements in what. "

	^self new export: what""",nil)
smalltalk.bind(smalltalk.S8Encoder,"messageSendConnector",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#messageSendConnector
	return self.implementedBySubclass_(smalltalk.String("messageSendConnector")) 
""","S8Encoder_messageSendConnector")
,"encoding","""messageSendConnector
	" Private - Return the connector to use for sending a message. "

	^self implementedBySubclass: #messageSendConnector """,nil)
smalltalk.bind(smalltalk.S8Encoder,"propertyAccessConnector",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#propertyAccessConnector
	return self.messageSendConnector() 
""","S8Encoder_propertyAccessConnector")
,"encoding","""propertyAccessConnector
	" Private - Return the connector to use for accessing a native property. "

	^self messageSendConnector """,nil)
smalltalk.bind(smalltalk.S8Encoder,"codeToGetGlobal:",0
,smalltalk.__f__("""(self,aName):
	#S8Encoder>>#codeToGetGlobal:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk"),self.propertyAccessConnector()),aName) 
""","S8Encoder_codeToGetGlobal_")
,"encoding","""codeToGetGlobal: aName
	" Private - Return the native code to get global at aName. "

	^#smalltalk ,self propertyAccessConnector ,aName """,nil)
smalltalk.bind(smalltalk.S8Encoder,"nativeUndefined",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#nativeUndefined
	return self.implementedBySubclass_(smalltalk.String("nativeUndefined")) 
""","S8Encoder_nativeUndefined")
,"encoding","""nativeUndefined
	" Private - Return the code for undefined. "

	^self implementedBySubclass: #nativeUndefined """,nil)
smalltalk.bind(smalltalk.S8Encoder,"nativeNameOfMetaClass:",0
,smalltalk.__f__("""(self,aClass):
	#S8Encoder>>#nativeNameOfMetaClass:
	return self.implementedBySubclass_(smalltalk.String("nativeNameOfMetaClass:")) 
""","S8Encoder_nativeNameOfMetaClass_")
,"encoding","""nativeNameOfMetaClass: aClass
	" Private - Return the native name for metaclass aClass. "

	^self implementedBySubclass: #nativeNameOfMetaClass: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"nativeNameOfClass:",0
,smalltalk.__f__("""(self,aClass):
	#S8Encoder>>#nativeNameOfClass:
	if smalltalk.b(aClass.isMetaclass()):
		return self.nativeNameOfMetaClass_(aClass) 
	 
	return aClass.name() 
""","S8Encoder_nativeNameOfClass_")
,"encoding","""nativeNameOfClass: aClass
	" Private - Return the native name for aClass. "

	aClass isMetaclass ifTrue: [
		^self nativeNameOfMetaClass: aClass
	].
	^aClass name """,nil)
smalltalk.bind(smalltalk.S8Encoder,"smalltalkNameFor:",0
,smalltalk.__f__("""(self,aClass):
	#S8Encoder>>#smalltalkNameFor:
	if smalltalk.b(smalltalk.isNil_(aClass)):
		return self.nativeUndefined() 
	 
	return self.codeToGetGlobal_(self.nativeNameOfClass_(aClass)) 
""","S8Encoder_smalltalkNameFor_")
,"export","""smalltalkNameFor: aClass
	" Private - Return the global name of aClass (can be nil). "

	aClass isNil ifTrue: [ ^self nativeUndefined ].
	^self codeToGetGlobal: (self nativeNameOfClass: aClass) """,nil)
smalltalk.bind(smalltalk.S8Encoder,"compiler",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#compiler
	return getattr(self,"@compiler",nil) 
""","S8Encoder_compiler")
,"accessing","""compiler
	" Return the compiler of the receiver. "

	^compiler""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compiler:",0
,smalltalk.__f__("""(self,aCompiler):
	#S8Encoder>>#compiler:
	smalltalk.basic_at_put(self,"@compiler",aCompiler) 
	return self 
""","S8Encoder_compiler_")
,"accessing","""compiler: aCompiler
	" Set the compiler of the receiver. "

	compiler := aCompiler""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:",0
,smalltalk.__f__("""(self,selector):
	#S8Encoder>>#compilerEvent:
	return getattr(self,"@compiler",nil).triggerEvent_(selector) 
""","S8Encoder_compilerEvent_")
,"events","""compilerEvent: selector
	" Return the result of triggering the compiler's event. "

	^compiler triggerEvent: selector""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,aBlock):
	#S8Encoder>>#compilerEvent:ifNotHandled:
	return getattr(self,"@compiler",nil).triggerEvent_ifNotHandled_(selector,aBlock) 
""","S8Encoder_compilerEvent_ifNotHandled_")
,"events","""compilerEvent: selector ifNotHandled: aBlock
	" Return the result of triggering the compiler's event. "

	^compiler triggerEvent: selector ifNotHandled: aBlock""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:with:",0
,smalltalk.__f__("""(self,selector,anObject):
	#S8Encoder>>#compilerEvent:with:
	return getattr(self,"@compiler",nil).triggerEvent_with_(selector,anObject) 
""","S8Encoder_compilerEvent_with_")
,"events","""compilerEvent: selector with: anObject
	" Return the result of triggering the compiler's event with anObject. "

	^compiler
		triggerEvent: selector
		with: anObject""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:with:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,anObject,aBlock):
	#S8Encoder>>#compilerEvent:with:ifNotHandled:
	return getattr(self,"@compiler",nil).triggerEvent_with_ifNotHandled_(selector,anObject,aBlock) 
""","S8Encoder_compilerEvent_with_ifNotHandled_")
,"events","""compilerEvent: selector with: anObject ifNotHandled: aBlock
	" Return the result of triggering the compiler's event with anObject. "

	^compiler
		triggerEvent: selector
		with: anObject
		ifNotHandled: aBlock""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:withArguments:",0
,smalltalk.__f__("""(self,selector,array):
	#S8Encoder>>#compilerEvent:withArguments:
	return getattr(self,"@compiler",nil).triggerEvent_withArguments_(selector,array) 
""","S8Encoder_compilerEvent_withArguments_")
,"events","""compilerEvent: selector withArguments: array
	" Return the result of triggering the compiler's event with the arguments. "

	^compiler
		triggerEvent: selector
		withArguments: array""",nil)
smalltalk.bind(smalltalk.S8Encoder,"compilerEvent:withArguments:ifNotHandled:",0
,smalltalk.__f__("""(self,selector,array,aBlock):
	#S8Encoder>>#compilerEvent:withArguments:ifNotHandled:
	return getattr(self,"@compiler",nil).triggerEvent_withArguments_ifNotHandled_(selector,array,aBlock) 
""","S8Encoder_compilerEvent_withArguments_ifNotHandled_")
,"events","""compilerEvent: selector withArguments: array ifNotHandled: aBlock
	" Return the result of triggering the compiler's event with the arguments. "

	^compiler
		triggerEvent: selector
		withArguments: array
		ifNotHandled: aBlock""",nil)
smalltalk.bind(smalltalk.S8Encoder,"currentClass",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#currentClass
	return getattr(self,"@compiler",nil).currentClass() 
""","S8Encoder_currentClass")
,"accessing","""currentClass
	" Return the current class of the receiver. "

	^compiler currentClass""",nil)
smalltalk.bind(smalltalk.S8Encoder,"ignore:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#ignore:
	return self 
""","S8Encoder_ignore_")
,"visiting","ignore: aNode",nil)
smalltalk.bind(smalltalk.S8Encoder,"asSelector:",0
,smalltalk.__f__("""(self,aSelector):
	#S8Encoder>>#asSelector:
	return aSelector.asSelector() 
""","S8Encoder_asSelector_")
,"converting","""asSelector: aSelector
	" Return the native representation of aSelector. "

	^aSelector asSelector""",nil)
smalltalk.bind(smalltalk.S8Encoder,"knownVariables",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#knownVariables
	return getattr(self,"@compiler",nil).knownVariables() 
""","S8Encoder_knownVariables")
,"variables","""knownVariables
	" Return the knownVariables of the receiver. "

	^compiler knownVariables""",nil)
smalltalk.bind(smalltalk.S8Encoder,"localName:",0
,smalltalk.__f__("""(self,aName):
	#S8Encoder>>#localName:
	if smalltalk.b(self.pseudoVariables().includes_(aName)):
		return aName 
	 
	return self.asSelector_(aName) 
""","S8Encoder_localName_")
,"private","""localName: aName
	" Private - Return a valid (native, local) name for aName. "

	(self pseudoVariables includes: aName) ifTrue: [ ^aName ].
	^self asSelector: aName""",nil)
smalltalk.bind(smalltalk.S8Encoder,"nativeLanguage",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#nativeLanguage
	return nil 
""","S8Encoder_nativeLanguage")
,"accessing","""nativeLanguage
	" Return the nativeLanguage of the receiver.
	The default action return nil (the default native language).
	"

	^nil""",nil)
smalltalk.bind(smalltalk.S8Encoder,"emmitedCode",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#emmitedCode
	return self.implementedBySubclass_(smalltalk.String("emmitedCode")) 
""","S8Encoder_emmitedCode")
,"results","""emmitedCode
	" Return the emmited code during compilation (or nil). "

	^self implementedBySubclass: #emmitedCode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"endCompiling:",0
,smalltalk.__f__("""(self,aMethodNode):
	#S8Encoder>>#endCompiling:
	return self 
""","S8Encoder_endCompiling_")
,"private","""endCompiling: aMethodNode
	" Private - Finish emmiting code for aMethodNode. \"""",nil)
smalltalk.bind(smalltalk.S8Encoder,"startCompiling:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#startCompiling:
	return self 
""","S8Encoder_startCompiling_")
,"private","""startCompiling: aNode
	" Private - Set the receiver to start emmiting code for aNode. \"""",nil)
smalltalk.bind(smalltalk.S8Encoder,"prepare:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#prepare:
	def __blk1__(each,parent):
		return each.prepareIn_for_(parent,self) 
	if smalltalk.b(aNode.isParseFailure()):
		return nil 
	 
	aNode.do_(smalltalk.blk(__blk1__,2)) 
	return self 
""","S8Encoder_prepare_")
,"private","""prepare: aNode
	" Private - Prepare aNode for traversal. "

	aNode isParseFailure ifTrue: [ ^nil ].
	aNode do: [:each :parent|
		each prepareIn: parent for: self
	]""",nil)
smalltalk.bind(smalltalk.S8Encoder,"pseudoVariables",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#pseudoVariables
	return getattr(self,"@compiler",nil).pseudoVariables() 
""","S8Encoder_pseudoVariables")
,"variables","""pseudoVariables
	" Return the pseudoVariables of the receiver. "

	^compiler pseudoVariables""",nil)
smalltalk.bind(smalltalk.S8Encoder,"tempVariables",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#tempVariables
	return getattr(self,"@compiler",nil).tempVariables() 
""","S8Encoder_tempVariables")
,"variables","""tempVariables
	" Return the tempVariables of the receiver. "

	^compiler tempVariables""",nil)
smalltalk.bind(smalltalk.S8Encoder,"unknownVariables",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#unknownVariables
	return getattr(self,"@compiler",nil).unknownVariables() 
""","S8Encoder_unknownVariables")
,"variables","""unknownVariables
	" Return the unknownVariables of the receiver. "

	^compiler unknownVariables""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visit:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visit:
	return aNode.accept_(self) 
""","S8Encoder_visit_")
,"visiting","""visit: aNode
	^aNode accept: self""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitAssignmentNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitAssignmentNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitAssignmentNode_")
,"visiting","""visitAssignmentNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitBlockNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitBlockNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitBlockNode_")
,"visiting","""visitBlockNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitBlockSequenceNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitBlockSequenceNode:
	self.visitSequenceNode_(aNode) 
	return self 
""","S8Encoder_visitBlockSequenceNode_")
,"visiting","""visitBlockSequenceNode: aNode
	self visitSequenceNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitCascadeNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitCascadeNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitCascadeNode_")
,"visiting","""visitCascadeNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitMacroAssignment:to:",0
,smalltalk.__f__("""(self,aVariableNode,anExpressionNode):
	#S8Encoder>>#visitMacroAssignment:to:
	return smalltalk.false 
""","S8Encoder_visitMacroAssignment_to_")
,"visiting","""visitMacroAssignment: aVariableNode to: anExpressionNode
	" Return true if the receiver generated code to a macro assignment to aVariableNode. "

	^false""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitMethodNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitMethodNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitMethodNode_")
,"visiting","""visitMethodNode: aNode
	" Visit a method node. "

	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitNode:
	self.ignore_(aNode) 
	return self 
""","S8Encoder_visitNode_")
,"visiting","""visitNode: aNode
	self ignore: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitReturnNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitReturnNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitReturnNode_")
,"visiting","""visitReturnNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitSendNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitSendNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitSendNode_")
,"visiting","""visitSendNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitSequenceNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitSequenceNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitSequenceNode_")
,"visiting","""visitSequenceNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitValueNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitValueNode:
	self.visitNode_(aNode) 
	return self 
""","S8Encoder_visitValueNode_")
,"visiting","""visitValueNode: aNode
	self visitNode: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"visitVariableNode:",0
,smalltalk.__f__("""(self,aNode):
	#S8Encoder>>#visitVariableNode:
	self.ignore_(aNode) 
	return self 
""","S8Encoder_visitVariableNode_")
,"visiting","""visitVariableNode: aNode
	self ignore: aNode""",nil)
smalltalk.bind(smalltalk.S8Encoder,"translate:by:",0
,smalltalk.__f__("""(self,aNode,delta):
	#S8Encoder>>#translate:by:
	if smalltalk.b(smalltalk.isObject_equalTo_(delta,smalltalk.Number(0))):
		return self 
	 
	self.compilerEvent_withArguments_(smalltalk.String("move:by:"),smalltalk.Array.with_with_(aNode,delta)) 
	return self 
""","S8Encoder_translate_by_")
,"private","""translate: aNode by: delta
	" Private - Translate the contents of aNode by delta characters in source code. "

	delta = 0 ifTrue: [ ^self ].
	self	compilerEvent: #move:by:
		withArguments: (Array with: aNode with: delta).""",nil)
smalltalk.bind(smalltalk.S8Encoder,"loadRequirementsOf:",0
,smalltalk.__f__("""(self,aClass):
	#S8Encoder>>#loadRequirementsOf:
	return self.implementedBySubclass_(smalltalk.String("loadRequirementsOf:")) 
""","S8Encoder_loadRequirementsOf_")
,"export","""loadRequirementsOf: aClass
	" Private - Return the requirements to load aClass. "

	^self implementedBySubclass: #loadRequirementsOf: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"exportDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#S8Encoder>>#exportDefinitionOf:on:
	return self.implementedBySubclass_(smalltalk.String("exportDefinitionOf:on:")) 
""","S8Encoder_exportDefinitionOf_on_")
,"export","""exportDefinitionOf: aClass on: aStream
	" Export definition of aClass onto aStream. "

	^self implementedBySubclass: #exportDefinitionOf:on: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"exportMetaDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#S8Encoder>>#exportMetaDefinitionOf:on:
	return self.implementedBySubclass_(smalltalk.String("exportMetaDefinitionOf:on:")) 
""","S8Encoder_exportMetaDefinitionOf_on_")
,"export","""exportMetaDefinitionOf: aClass on: aStream
	" Export class side definition of aClass onto aStream. "

	^self implementedBySubclass: #exportMetaDefinitionOf:on: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"export:method:on:",0
,smalltalk.__f__("""(self,aClass,aMethod,aStream):
	#S8Encoder>>#export:method:on:
	return self.implementedBySubclass_(smalltalk.String("export:method:on:")) 
""","S8Encoder_export_method_on_")
,"export","""export: aClass method: aMethod on: aStream
	" Export a method definition of aClass onto aStream. "

	^self implementedBySubclass: #export:method:on: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"arrayLiteralStart",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#arrayLiteralStart
	return self.implementedBySubclass_(smalltalk.String("arrayLiteralStart")) 
""","S8Encoder_arrayLiteralStart")
,"literals","""arrayLiteralStart
	" Private - Return the code string to start exporting an array literal. "

	^self implementedBySubclass: #arrayLiteralStart""",nil)
smalltalk.bind(smalltalk.S8Encoder,"arrayLiteralEnd",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#arrayLiteralEnd
	return self.implementedBySubclass_(smalltalk.String("arrayLiteralEnd")) 
""","S8Encoder_arrayLiteralEnd")
,"literals","""arrayLiteralEnd
	" Private - Return the code string to end exporting an array literal. "

	^self implementedBySubclass: #arrayLiteralEnd""",nil)
smalltalk.bind(smalltalk.S8Encoder,"escaped:",0
,smalltalk.__f__("""(self,string):
	#S8Encoder>>#escaped:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),string),smalltalk.String('"')) 
""","S8Encoder_escaped_")
,"literals","""escaped: string
	" Private - Return the code string to export string literal. "

	^$" ,string ,$\"""",nil)
smalltalk.bind(smalltalk.S8Encoder,"argumentsSeparatorOp",0
,smalltalk.__f__("""(self):
	#S8Encoder>>#argumentsSeparatorOp
	return smalltalk.String(",") 
""","S8Encoder_argumentsSeparatorOp")
,"constants","""argumentsSeparatorOp
	" Private - Return the OP for separating arguments. "

	^$, """,nil)
smalltalk.bind(smalltalk.S8Encoder,"export:literals:on:",0
,smalltalk.__f__("""(self,tags,anArray,aStream):
	#S8Encoder>>#export:literals:on:
	def __blk1__(each):
		def __blk2__():
			return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),each),smalltalk.String('"')) 
		def __blk3__():
			return smalltalk.printString_(each) 
		return aStream.nextPutAll_(smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))) 
	def __blk4__():
		return aStream.nextPutAll_(self.argumentsSeparatorOp()) 
	if smalltalk.b(smalltalk.notNil_(tags)):
		aStream.nextPutAll_(tags.first()) 
	 
	anArray.do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk4__,0)) 
	if smalltalk.b(smalltalk.notNil_(tags)):
		aStream.nextPutAll_(tags.last()) 
	 
	return self 
""","S8Encoder_export_literals_on_")
,"literals","""export: tags literals: anArray on: aStream
	" Private - Export the native code for elements in anArray between tags. "

	tags notNil ifTrue: [ aStream nextPutAll: tags first ].
	anArray
	    do: [:each | aStream nextPutAll: (
		each isString ifTrue: [ $" ,each ,$" ] ifFalse: [ each printString ]
	    ) ] separatedBy: [ aStream nextPutAll: self argumentsSeparatorOp ].
	tags notNil ifTrue: [ aStream nextPutAll: tags last ]""",nil)
smalltalk.bind(smalltalk.S8Encoder,"exportArrayLiteral:on:newLine:",0
,smalltalk.__f__("""(self,anArray,aStream,newLine):
	#S8Encoder>>#exportArrayLiteral:on:newLine:
	self.export_literals_on_(smalltalk.Array.with_with_(self.arrayLiteralStart(),self.arrayLiteralEnd()),anArray,aStream) 
	if smalltalk.b(newLine):
		aStream.cr() 
	 
	return self 
""","S8Encoder_exportArrayLiteral_on_newLine_")
,"literals","""exportArrayLiteral: anArray on: aStream newLine: newLine
	" Private - Export the native code for elements in anArray. "

	self	export: (Array
			with: self arrayLiteralStart
			with: self arrayLiteralEnd)
		literals: anArray on: aStream.
	newLine ifTrue: [ aStream cr ]""",nil)
smalltalk.bind(smalltalk.S8Encoder,"sourceToTry:",0
,smalltalk.__f__("""(self,sourceCode):
	#S8Encoder>>#sourceToTry:
	return sourceCode 
""","S8Encoder_sourceToTry_")
,"directives","""sourceToTry: sourceCode
	" Return the code to emmit to try execution of sourceCode. "

	^sourceCode """,nil)
smalltalk.bind(smalltalk.S8Encoder,"sourceToDirectCall:with:",0
,smalltalk.__f__("""(self,nativeSelector,arg):
	#S8Encoder>>#sourceToDirectCall:with:
	return self.implementedBySubclass_(smalltalk.String("sourceToDirectCall:with:")) 
""","S8Encoder_sourceToDirectCall_with_")
,"directives","""sourceToDirectCall: nativeSelector with: arg
	" Return the code to emmit to direct native call to selector with argument. "

	^self implementedBySubclass: #sourceToDirectCall:with: """,nil)
smalltalk.bind(smalltalk.S8Encoder,"export:",0
,smalltalk.__f__("""(self,what):
	#S8Encoder>>#export:
	__0__=smalltalk.newContext()
	__0__.exporter=nil
	__0__.exporter=smalltalk.Exporter.new() 
	__0__.exporter.encoder_(self) 
	if smalltalk.b(smalltalk.isObject_equalTo_(what,smalltalk.String("all"))):
		return __0__.exporter.exportAll() 
	 
	if smalltalk.b(what.isArray()):
		return __0__.exporter.exportAll_(what) 
	 
	return __0__.exporter.exportAll_(smalltalk.Array.with_(what)) 
""","S8Encoder_export_")
,"Tools-export","""export: what
	" Return the native code result of encoding elements in what. "

	| exporter |
	exporter := Exporter new.
	exporter encoder: self.
	what = #all ifTrue: [ ^exporter exportAll ].
	what isArray ifTrue: [ ^exporter exportAll: what ].
	^exporter exportAll: (Array with: what)""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder.__class__,"inlines",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder class>>#inlines
	def __blk1__(msg):
		def __blk2__():
			return msg.endsWith_(smalltalk.String("Inlines:")) 
		return smalltalk.boolean_and_(msg.startsWith_(smalltalk.String("initialize")),smalltalk.blk(__blk2__,0)) 
	def __blk3__(each):
		return self.perform_with_(each,getattr(self,"@inlines",nil)) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@inlines",nil))):
		return getattr(self,"@inlines",nil) 
	 
	smalltalk.basic_at_put(self,"@inlines",smalltalk.PoolDictionary.new()) 
	(self).__class__.selectors().select_(smalltalk.blk(__blk1__,1)).do_(smalltalk.blk(__blk3__,1)) 
	return getattr(self,"@inlines",nil) 
""","OptimizingEncoder_class_inlines")
,"inlines","""inlines
	" Private - Return the pool of inlines known by the receiver.
	Note that initialize defaults from methods implementing #initialize*Inlines: in the receiver
	"

	inlines notNil ifTrue: [ ^inlines ].
	inlines := PoolDictionary new.
	(self class selectors
		select: [:msg| (msg startsWith: #initialize) and: [ msg endsWith: #Inlines: ] ])
		do: [:each| self perform: each with: inlines ].
	^inlines """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder.__class__,"register:into:",0
,smalltalk.__f__("""(self,literals,pool):
	#OptimizingEncoder class>>#register:into:
	def __blk1__(tuple):
		__1__=smalltalk.newContext()
		def __blk2__(token):
			def __blk3__():
				return token.first().isLowercase() 
			def __blk4__():
				return pool.at_put_(token,__1__.value) 
			def __blk5__():
				__3__=smalltalk.newContext()
				def __blk6__():
					return smalltalk.PoolDictionary.new() 
				def __blk7__(pair):
					def __blk8__():
						return smalltalk.Array.with_(pair.first()) 
					def __blk9__():
						return pair.first() 
					def __blk10__(selector):
						if not smalltalk.b(selector.isString()):
							self.error_(smalltalk.object_comma_(smalltalk.String("Must be string "),selector.asLiteral())) 
						 
						return __3__.options.at_put_(selector,__1__.value) 
					if not smalltalk.b(pair.isArray()):
						self.error_(smalltalk.object_comma_(smalltalk.String("Must be array "),tuple)) 
					 
					if not smalltalk.b(smalltalk.isObject_equalTo_(pair.size(),smalltalk.Number(2))):
						self.error_(smalltalk.String("Invalid pair size (must be 2)")) 
					 
					__1__.value=pair.last() 
					return smalltalk.if_true_false_(pair.first().isString(),smalltalk.blk(__blk8__,0),smalltalk.blk(__blk9__,0)).do_(smalltalk.blk(__blk10__,1)) 
				__3__.options=nil
				__3__.options=pool.at_ifAbsentPut_(token,smalltalk.blk(__blk6__,0)) 
				return __1__.value.do_(smalltalk.blk(__blk7__,1)) 
			if not smalltalk.b(token.isString()):
				self.error_(smalltalk.object_comma_(smalltalk.String("Must be string "),token.asLiteral())) 
			 
			return smalltalk.if_true_false_(smalltalk.boolean_or_(token.isEmpty(),smalltalk.blk(__blk3__,0)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		__1__.tokens=nil
		__1__.value=nil
		if not smalltalk.b(tuple.isArray()):
			self.error_(smalltalk.object_comma_(smalltalk.String("Must be array "),tuple)) 
		 
		if not smalltalk.b(smalltalk.isObject_equalTo_(tuple.size(),smalltalk.Number(2))):
			self.error_(smalltalk.String("Invalid tuple size (must be 2)")) 
		 
		__1__.tokens=tuple.first() 
		__1__.value=tuple.last() 
		if smalltalk.b(__1__.tokens.isString()):
			__1__.tokens=smalltalk.Array.with_(__1__.tokens) 
		 
		return __1__.tokens.do_(smalltalk.blk(__blk2__,1)) 
	literals.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","OptimizingEncoder_class_register_into_")
,"inlines","""register: literals into: pool
	" Private - Register literals array onto pool dictionary.
	literals must be a collection of arrays like:
		#(token inlines)
		#(ClassName #(
			#(selector inlines)
		))
	inlines can be a string or array of strings to be used to encode inlines in source
	token must be lowercase and ClassName must be uppercase names
	token & className can be arrays for multiple registrations
	"

	literals do: [:tuple| | tokens value |
		tuple isArray ifFalse: [ self error: 'Must be array ' ,tuple ].
		tuple size = 2 ifFalse: [ self error: 'Invalid tuple size (must be 2)' ].
		tokens := tuple first. value := tuple last.
		tokens isString ifTrue: [ tokens := Array with: tokens ].
		tokens do: [:token|
			token isString ifFalse: [ self error: 'Must be string ' ,token asLiteral ].
			(token isEmpty or: [ token first isLowercase ]) ifTrue: [ "#(token inlines) "
				pool at: token put: value
			] ifFalse: [ | options | "#(ClassName pairs)"
				options := pool at: token ifAbsentPut: [PoolDictionary new].
				value do: [:pair| "#(selector inlines)"
					pair isArray ifFalse: [ self error: 'Must be array ' ,tuple ].
					pair size = 2 ifFalse: [ self error: 'Invalid pair size (must be 2)' ].
					value := pair last.
					(pair first isString ifTrue: [Array with: pair first] ifFalse: [pair first]) do: [:selector|
						selector isString ifFalse: [ self error: 'Must be string ' ,selector asLiteral ].
						options at: selector put: value
					]
				]
			]
		]
	] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder.__class__,"inlinesFor:compiler:",0
,smalltalk.__f__("""(self,token,aCompiler):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder class>>#inlinesFor:compiler:
		__0__=smalltalk.newContext()
		__0__.result=nil
		if smalltalk.b(smalltalk.notNil_(token)):
			def __blk1__():
				nil 
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,__0__.result) 
			__0__.result=self.inlines().at_ifAbsent_(token,smalltalk.blk(__blk1__,0)) 
			smalltalk.if_true_false_(smalltalk.notNil_(__0__.result),smalltalk.blk(__blk2__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,self.inlines()._at(smalltalk.Array.with_with_(aCompiler.currentClass().name(),aCompiler.selector()))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_class_inlinesFor_compiler_")
,"inlines","""inlinesFor: token compiler: aCompiler
	" Private - Return the inlines stream with native source chunks to inject while generating code. "

	| result |
	token notNil ifTrue: [
		result := self inlines at: token ifAbsent: [].
		result notNil ifTrue: [ ^result ].
	].
	^self inlines @ (Array
		with: aCompiler currentClass name
		with: aCompiler selector) """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder.__class__,"unknownVariable:in:",0
,smalltalk.__f__("""(self,aNode,anEncoder):
	#OptimizingEncoder class>>#unknownVariable:in:
	self.note_(smalltalk.object_comma_(smalltalk.String("Unknown variable "),smalltalk.asString_(aNode.value()))) 
	return self.error_(smalltalk.object_comma_(smalltalk.String("Unknown variable "),aNode.value())) 
""","OptimizingEncoder_class_unknownVariable_in_")
,"variables","""unknownVariable: aNode in: anEncoder
	" Private - anEncoder has found an unknown name reference.
	The default action will thrown an error (stop compilation),
	 this method can be refined/changed to silently ignore the
	 unknown to let the compiler produce code to refer code
	 in outer native contexts.
	See implementors of #visitVariableNode:
	"

self note: 'Unknown variable ' ,aNode value asString.
	^self error: 'Unknown variable ',aNode value""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder.__class__,"bind:in:",0
,smalltalk.__f__("""(self,aName,anEncoder):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder class>>#bind:in:
		def __blk1__(c):
			return smalltalk.isObject_equalTo_(c,smalltalk.String("_"))._8not() 
		def __blk2__():
			def __blk3__():
				return smalltalk.basic_at_put_(smalltalk.Smalltalk._8global(),aName,nil) 
			smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(aName,smalltalk.blk(__blk3__,0)) 
			anEncoder.knownVariables().add_(aName) 
			return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		aName.detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_class_bind_in_")
,"variables","""bind: aName in: anEncoder
	" Private - Return true if aName has been bound to anEncoder.
	Note that the process of binding must register aName onto knownVariables of encoder. "

	"we use underscores as native cookies"
	aName detect: [:c| c ~= #_ ] ifNone: [ "all underscores"
		Smalltalk nativeObjectAt: aName ifAbsent: [
			Smalltalk global basicAt: aName put: nil
		].
		anEncoder knownVariables add: aName.
		^true
	].
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"addOptimizations:",0
,smalltalk.__f__("""(self,array):
	#OptimizingEncoder>>#addOptimizations:
	def __blk1__(opt):
		return self.optimizationMap().addAll_(self.optimizationLiteralsFor_(opt)) 
	array.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","OptimizingEncoder_addOptimizations_")
,"optimization","""addOptimizations: array
	" Private - Add an array of optimizations to the receiver. "

	array do: [:opt|
		self optimizationMap addAll:
			(self optimizationLiteralsFor: opt)
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"allBlockNoArguments:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#allBlockNoArguments:
	def __blk1__():
		return self.hasBlockNoArguments_(aNode) 
	return smalltalk.boolean_and_(self.receiverIsBlockNoArguments_(aNode),smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_allBlockNoArguments_")
,"optimization","""allBlockNoArguments: aNode
	" Private - Return true if receiver and arguments of aNode are blocks with no arguments. "

	^(self receiverIsBlockNoArguments: aNode) and: [
		self hasBlockNoArguments: aNode
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"arg1HasNumber:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#arg1HasNumber:
	return aNode.arguments().at_(smalltalk.Number(1)).hasNumber() 
""","OptimizingEncoder_arg1HasNumber_")
,"optimization","""arg1HasNumber: aNode
	" Private - Return true if argument of aNode is a number literal. "

	^(aNode arguments at: 1) hasNumber""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"arg2HasNumber:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#arg2HasNumber:
	return aNode.arguments().at_(smalltalk.Number(2)).hasNumber() 
""","OptimizingEncoder_arg2HasNumber_")
,"optimization","""arg2HasNumber: aNode
	" Private - Return true if argument of aNode is a number literal. "

	^(aNode arguments at: 2) hasNumber""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"arg3HasNumber:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#arg3HasNumber:
	return aNode.arguments().at_(smalltalk.Number(3)).hasNumber() 
""","OptimizingEncoder_arg3HasNumber_")
,"optimization","""arg3HasNumber: aNode
	" Private - Return true if argument of aNode is a number literal. "

	^(aNode arguments at: 3) hasNumber""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"argumentsHasNumber:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#argumentsHasNumber:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(each.hasNumber(),smalltalk.blk(__blk2__,0),nil) 
		aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_argumentsHasNumber_")
,"optimization","""argumentsHasNumber: aNode
	" Private - Return true if any argument of aNode is a number literal. "

	aNode arguments do: [:each|
		each hasNumber ifTrue: [ ^true ]
	].
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"argumentsHasString:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#argumentsHasString:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(each.hasString(),smalltalk.blk(__blk2__,0),nil) 
		aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_argumentsHasString_")
,"optimization","""argumentsHasString: aNode
	" Private - Return true if any argument of aNode is a string literal. "

	aNode arguments do: [:each|
		each hasString ifTrue: [ ^true ]
	].
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"defaultKnownOptimizations",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#defaultKnownOptimizations
	return smalltalk.newArray([]) 
""","OptimizingEncoder_defaultKnownOptimizations")
,"defaults","""defaultKnownOptimizations
	" Private - Return the default knownOptimizations of the receiver. "

	^#()""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"defaultOptimizations",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#defaultOptimizations
	return smalltalk.newArray([]) 
""","OptimizingEncoder_defaultOptimizations")
,"defaults","""defaultOptimizations
	" Private - Return the default optimizations of the receiver. "

	^#()""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasBlockArguments:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#hasBlockArguments:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(smalltalk.is_kindOf_(each,(smalltalk.BlockNode)),nil,smalltalk.blk(__blk2__,0)) 
		aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_hasBlockArguments_")
,"optimization","""hasBlockArguments: aNode
	" Private - Return true if arguments of aNode are blocks. "

	aNode arguments do: [:each|
		(each isKindOf: BlockNode) ifFalse: [ ^false ].
	].
	^true""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasBlockNoArguments:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#hasBlockNoArguments:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(each.parameters().isEmpty(),nil,smalltalk.blk(__blk2__,0)) 
		if not smalltalk.b(self.hasBlockArguments_(aNode)):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_hasBlockNoArguments_")
,"optimization","""hasBlockNoArguments: aNode
	" Private - Return true if arguments of aNode are blocks with no parameters. "

	(self hasBlockArguments: aNode) ifFalse: [ ^false ].
	aNode arguments do: [:each|
		each parameters isEmpty ifFalse: [ ^false ].
	].
	^true""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasBlockOneArguments:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#hasBlockOneArguments:
		def __blk1__(each):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each.parameters().size(),smalltalk.Number(1)),nil,smalltalk.blk(__blk2__,0)) 
		if not smalltalk.b(self.hasBlockArguments_(aNode)):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_hasBlockOneArguments_")
,"optimization","""hasBlockOneArguments: aNode
	" Private - Return true if arguments of aNode are blocks with ONE parameter. "

	(self hasBlockArguments: aNode) ifFalse: [ ^false ].
	aNode arguments do: [:each|
		each parameters size = 1 ifFalse: [ ^false ].
	].
	^true""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasNumber:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#hasNumber:
	def __blk1__():
		return self.argumentsHasNumber_(aNode) 
	return smalltalk.boolean_or_(self.receiverHasNumber_(aNode),smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_hasNumber_")
,"optimization","""hasNumber: aNode
	" Private - Return true if the receiver or arguments in aNode has numeric value. "

	^(self receiverHasNumber: aNode) or: [
		self argumentsHasNumber: aNode
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasString:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#hasString:
	def __blk1__():
		return self.argumentsHasString_(aNode) 
	return smalltalk.boolean_or_(self.receiverHasString_(aNode),smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_hasString_")
,"optimization","""hasString: aNode
	" Private - Return true if the receiver or arguments in aNode has string value. "

	^(self receiverHasString: aNode) or: [
		self argumentsHasString: aNode
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"noClient:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#noClient:
	return smalltalk.isObject_equalTo_(aNode.client(),smalltalk.String("none")) 
""","OptimizingEncoder_noClient_")
,"optimization","""noClient: aNode
	" Private - Return true if aNode has no client. "

	^aNode client = #none """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"hasClient:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#hasClient:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.isObject_equalTo_(__0__.client,smalltalk.String("none"))._8not() 
	__0__.client=nil
	__0__.client=aNode.client() 
	return smalltalk.boolean_and_(smalltalk.notNil_(__0__.client),smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_hasClient_")
,"optimization","""hasClient: aNode
	" Private - Return true if aNode has a client. "

	| client |
	client := aNode client.
	^client notNil and: [ client ~= #none ] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"initializeKnownOptimizations",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#initializeKnownOptimizations
	smalltalk.basic_at_put(self,"@knownOptimizations",self.defaultKnownOptimizations()) 
	return self 
""","OptimizingEncoder_initializeKnownOptimizations")
,"initialize","""initializeKnownOptimizations
	" Private - Initialize the knownOptimizations of the receiver. "

	knownOptimizations := self defaultKnownOptimizations""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"initializeOptimizationMap",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#initializeOptimizationMap
	def __blk1__():
		return smalltalk.newArray([]) 
	def __blk2__():
		return self.addOptimizations_(self.defaultOptimizations()) 
	smalltalk.basic_at_put(self,"@optimizationMap",self.compilerEvent_ifNotHandled_(smalltalk.String("needsOptimizationMap"),smalltalk.blk(__blk1__,0))) 
	self.compilerEvent_ifNotHandled_(smalltalk.String("initializeOptimizations"),smalltalk.blk(__blk2__,0)) 
	self.compilerEvent_(smalltalk.String("customizeOptimizations")) 
	return self 
""","OptimizingEncoder_initializeOptimizationMap")
,"initialize","""initializeOptimizationMap
	" Private - Initialize the optimization map of the receiver. "

	optimizationMap := self
		compilerEvent: #needsOptimizationMap
		ifNotHandled: [ #() ].
	self compilerEvent: #initializeOptimizations ifNotHandled: [
		self addOptimizations: self defaultOptimizations
	].
	self compilerEvent: #customizeOptimizations""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"knownOptimizations",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#knownOptimizations
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@knownOptimizations",nil))):
		self.initializeKnownOptimizations() 
	 
	return getattr(self,"@knownOptimizations",nil) 
""","OptimizingEncoder_knownOptimizations")
,"accessing","""knownOptimizations
	" Return the knownOptimizations of the receiver. "

	knownOptimizations isNil ifTrue: [ self initializeKnownOptimizations ].
	^knownOptimizations""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"knownOptimizations:",0
,smalltalk.__f__("""(self,anObject):
	#OptimizingEncoder>>#knownOptimizations:
	smalltalk.basic_at_put(self,"@knownOptimizations",anObject) 
	return self 
""","OptimizingEncoder_knownOptimizations_")
,"accessing","""knownOptimizations: anObject
	" Set the knownOptimizations of the receiver. "

	knownOptimizations := anObject""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"matchOptimizedCondition:with:",0
,smalltalk.__f__("""(self,condition,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#matchOptimizedCondition:with:
		if smalltalk.b(smalltalk.newArray(["hasNumber:","receiverHasNumber:","argumentsHasNumber:","hasString:","receiverHasString:","argumentsHasString:","arg1HasNumber:","arg2HasNumber:","arg3HasNumber:","hasBlockArguments:","hasBlockNoArguments:","hasBlockOneArguments:","allBlockNoArguments:","receiverIsBlockNoArguments:","noClient:","hasClient:"]).includes_(condition)):
			return self.perform_withArguments_(condition,smalltalk.Array.with_(aNode)) 
		 
		if smalltalk.b(condition.isArray()):
			def __blk1__(one):
				return smalltalk.isObject_equalTo_(smalltalk.false,self.matchOptimizedCondition_with_(one,aNode)) 
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			condition.detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(condition,smalltalk.String("true"))):
			smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(condition,smalltalk.String("false"))):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		self.note_(smalltalk.object_comma_(smalltalk.String("Unknown optimize-condition: "),condition)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_matchOptimizedCondition_with_")
,"optimization","""matchOptimizedCondition: condition with: aNode
	" Private - Return true if aNode matches the condition. "

	(#(
	hasNumber: receiverHasNumber: argumentsHasNumber:
	hasString: receiverHasString: argumentsHasString:
	arg1HasNumber: arg2HasNumber: arg3HasNumber:
	hasBlockArguments: hasBlockNoArguments: hasBlockOneArguments:
	allBlockNoArguments: receiverIsBlockNoArguments:
	noClient: hasClient:
	) includes: condition) ifTrue: [
		^self perform: condition withArguments: (Array with: aNode)
	].
	condition isArray ifTrue: [
		condition detect: [:one|
			false = (self matchOptimizedCondition: one with: aNode)
		] ifNone: [ ^true ].
		^false
	].
	condition = #true ifTrue: [ ^true ].
	condition = #false ifTrue: [ ^false ].
	self note: 'Unknown optimize-condition: ',condition.
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"optimizationLiteralsFor:",0
,smalltalk.__f__("""(self,opt):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#optimizationLiteralsFor:
		__0__=smalltalk.newContext()
		def __blk1__(pair):
			def __blk2__():
				def __blk3__(total,tuple):
					def __blk4__(_s8_rec):
						_s8_rec.addAll_(self.optimizationLiteralsFor_(tuple)) 
						return _s8_rec.yourself() 
					return __blk4__(total) 
				return smalltalk.raise_result_(_s8Ret_,pair.last().inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk3__,2))) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(pair.first(),opt),smalltalk.blk(__blk2__,0),nil) 
		def __blk5__(pair):
			def __blk6__(tuple):
				def __blk7__():
					return smalltalk.isObject_equalTo_(tuple.first(),opt) 
				def __blk8__():
					return smalltalk.raise_result_(_s8Ret_,smalltalk.Array.with_(tuple)) 
				return smalltalk.if_true_false_(smalltalk.boolean_and_(tuple.isArray(),smalltalk.blk(__blk7__,0)),smalltalk.blk(__blk8__,0),nil) 
			return pair.last().do_(smalltalk.blk(__blk6__,1)) 
		__0__.array=nil
		if not smalltalk.b(opt.isString()):
			smalltalk.raise_result_(_s8Ret_,smalltalk.Array.with_(opt)) 
		 
		__0__.array=self.knownOptimizations() 
		__0__.array.do_(smalltalk.blk(__blk1__,1)) 
		__0__.array.do_(smalltalk.blk(__blk5__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.newArray([])) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_optimizationLiteralsFor_")
,"optimization","""optimizationLiteralsFor: opt
	" Private - Return the optimization literals array defined for opt.
	opt can be an optimization family or message selector
	"

	| array |
	opt isString ifFalse: [ ^Array with: opt ].
	array := self knownOptimizations.
	array do: [:pair|
		pair first = opt ifTrue: [
			^pair last inject: #() into: [:total :tuple|
				total addAll: (self optimizationLiteralsFor: tuple); yourself
			]
		].
	].
	array do: [:pair|
		pair last do: [:tuple|
			(tuple isArray and: [tuple first = opt]) ifTrue: [ ^Array with: tuple ]
		].
	].
	^#()""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"optimizationMap",0
,smalltalk.__f__("""(self):
	#OptimizingEncoder>>#optimizationMap
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@optimizationMap",nil))):
		self.initializeOptimizationMap() 
	 
	return getattr(self,"@optimizationMap",nil) 
""","OptimizingEncoder_optimizationMap")
,"accessing","""optimizationMap
	" Return the message send optimization map of the receiver. "

	optimizationMap isNil ifTrue: [ self initializeOptimizationMap ].
	^optimizationMap""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"optimizationMap:",0
,smalltalk.__f__("""(self,aSpec):
	#OptimizingEncoder>>#optimizationMap:
	smalltalk.basic_at_put(self,"@optimizationMap",aSpec) 
	return self 
""","OptimizingEncoder_optimizationMap_")
,"accessing","""optimizationMap: aSpec
	" Set the current optimizationMap of the receiver. "

	optimizationMap := aSpec""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"emmitCode:",0
,smalltalk.__f__("""(self,code):
	#OptimizingEncoder>>#emmitCode:
	return self.implementedBySubclass_(smalltalk.String("emmitCode:")) 
""","OptimizingEncoder_emmitCode_")
,"generation","""emmitCode: code
	" Private - Emmit code onto output stream. "

	^self implementedBySubclass: #emmitCode: """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"emmitInlinedCode:",0
,smalltalk.__f__("""(self,code):
	#OptimizingEncoder>>#emmitInlinedCode:
	return self.emmitCode_(code) 
""","OptimizingEncoder_emmitInlinedCode_")
,"generation","""emmitInlinedCode: code
	" Private - Emmit inlined code onto output stream. "

	^self emmitCode: code """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"macroStream:",0
,smalltalk.__f__("""(self,macro):
	#OptimizingEncoder>>#macroStream:
	return macro.readStream() 
""","OptimizingEncoder_macroStream_")
,"optimizing","""macroStream: macro
	" Private - Return a code stream from macro string. "

	^macro readStream """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"expandMacrosIn:with:",0
,smalltalk.__f__("""(self,input,aNode):
	#OptimizingEncoder>>#expandMacrosIn:with:
	def __blk1__():
		return input.atEnd() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__1__=smalltalk.newContext()
		def __blk2__():
			return self.visitMacroIn_with_(input,aNode) 
		__1__.code=nil
		__1__.code=input.upTo_(smalltalk.String("%")) 
		if smalltalk.b(__1__.code.size()._gt(smalltalk.Number(0))):
			self.emmitInlinedCode_(__1__.code) 
		 
		smalltalk.if_true_false_(input.atEnd(),nil,smalltalk.blk(__blk2__,0)) 
	 
	return self 
""","OptimizingEncoder_expandMacrosIn_with_")
,"optimizing","""expandMacrosIn: input with: aNode
	" Private - Parse input expanding macros.
	Expandable macros are defined between %%
	"

	[input atEnd] whileFalse: [ | code |
		code := input upTo: $%.
		code size > 0 ifTrue: [ self emmitInlinedCode: code ].
		input atEnd ifFalse: [ self visitMacroIn: input with: aNode ]
	] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"optimize:macro:",0
,smalltalk.__f__("""(self,aNode,template):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#optimize:macro:
		if smalltalk.b(template.isArray()):
			def __blk1__(one):
				return self.visitOptimizedNode_as_(aNode,one) 
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
			template.detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
			smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
		 
		if not smalltalk.b(template.isString()):
			smalltalk.raise_result_(_s8Ret_,smalltalk.notNil_(template.value_value_(aNode,self))) 
		 
		self.expandMacrosIn_with_(self.macroStream_(template),aNode) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_optimize_macro_")
,"optimizing","""optimize: aNode macro: template
	" Private - Generate the code for aNode using a macro template.
	Return true if expanded the macro, or leave the receiver unchanged returning false
	"

	template isArray ifTrue: [ "conditional templates"
		template detect: [:one| self visitOptimizedNode: aNode as: one ]
			ifNone: [ ^false ].
		^true
	].
	template isString ifFalse: [ "an evaluable template (must return nil if failed to expand)"
		^(template value: aNode value: self) notNil
	].
	self expandMacrosIn: (self macroStream: template) with: aNode.
	^true""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"receiverHasNumber:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#receiverHasNumber:
	return aNode.receiver().hasNumber() 
""","OptimizingEncoder_receiverHasNumber_")
,"optimization","""receiverHasNumber: aNode
	" Private - Return true if the receiver of aNode is a number literal. "

	^aNode receiver hasNumber""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"receiverHasString:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#receiverHasString:
	return aNode.receiver().hasString() 
""","OptimizingEncoder_receiverHasString_")
,"optimization","""receiverHasString: aNode
	" Private - Return true if the receiver of aNode is a string literal. "

	^aNode receiver hasString""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"receiverIsBlockNoArguments:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#receiverIsBlockNoArguments:
	def __blk1__():
		return aNode.receiver().parameters().isEmpty() 
	return smalltalk.boolean_and_(smalltalk.is_kindOf_(aNode.receiver(),(smalltalk.BlockNode)),smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_receiverIsBlockNoArguments_")
,"optimization","""receiverIsBlockNoArguments: aNode
	" Private - Return true if receiver of aNode is block with no arguments. "

	^(aNode receiver isKindOf: BlockNode) and: [
		aNode receiver parameters isEmpty
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"removeOptimizationLiteral:",0
,smalltalk.__f__("""(self,aLiteral):
	#OptimizingEncoder>>#removeOptimizationLiteral:
	self.optimizationMap().remove_(aLiteral) 
	return self 
""","OptimizingEncoder_removeOptimizationLiteral_")
,"optimization","""removeOptimizationLiteral: aLiteral
	" Private - Remove the optimization from the receiver. "

	self optimizationMap remove: aLiteral """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"removeOptimizations:",0
,smalltalk.__f__("""(self,array):
	#OptimizingEncoder>>#removeOptimizations:
	def __blk1__(opt):
		def __blk2__(each):
			return self.removeOptimizationLiteral_(each) 
		return self.optimizationLiteralsFor_(opt).do_(smalltalk.blk(__blk2__,1)) 
	array.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","OptimizingEncoder_removeOptimizations_")
,"optimization","""removeOptimizations: array
	" Private - Remove an array of optimizations to the receiver. "

	array do: [:opt|
		(self optimizationLiteralsFor: opt) do: [:each|
			self removeOptimizationLiteral: each
		]
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"inlineToken:",0
,smalltalk.__f__("""(self,string):
	#OptimizingEncoder>>#inlineToken:
	return string.copyFrom_to_(smalltalk.Number(2),string.size()) 
""","OptimizingEncoder_inlineToken_")
,"inlines","""inlineToken: string
	" Private - Return the inline key to search for contents (or nil). "

	^string copyFrom: 2 to: string size """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"inlineKey:",0
,smalltalk.__f__("""(self,string):
	#OptimizingEncoder>>#inlineKey:
	if smalltalk.b(smalltalk.isObject_equalTo_(string.size(),smalltalk.Number(0))):
		return smalltalk.String("") 
	 
	if smalltalk.b(string.startsWith_(smalltalk.String("#"))):
		return self.inlineToken_(string) 
	 
	return nil 
""","OptimizingEncoder_inlineKey_")
,"inlines","""inlineKey: string
	" Private - Return the inline key to search for inline contents (or nil). "

	string size = 0 ifTrue: [ ^'' ].
	(string startsWith: $#) ifTrue: [ ^self inlineToken: string ].
	^nil """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"inlinesFor:",0
,smalltalk.__f__("""(self,default):
	#OptimizingEncoder>>#inlinesFor:
	__0__=smalltalk.newContext()
	__0__.chunks=nil
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@inlines",nil))):
		return getattr(self,"@inlines",nil) 
	 
	__0__.chunks=(self).__class__.inlinesFor_compiler_(self.inlineKey_(default),self.compiler()) 
	if smalltalk.b(smalltalk.isNil_(__0__.chunks)):
		__0__.chunks=smalltalk.newArray([]) 
	 
	if smalltalk.b(__0__.chunks.isString()):
		__0__.chunks=smalltalk.Array.with_(__0__.chunks) 
	 
	smalltalk.basic_at_put(self,"@inlines",__0__.chunks.stream()) 
	return getattr(self,"@inlines",nil) 
""","OptimizingEncoder_inlinesFor_")
,"inlines","""inlinesFor: default
	" Private - Return the inlines stream with native source chunks to inject while generating code. "

	| chunks |
	inlines notNil ifTrue: [ ^inlines ].
	chunks := self class inlinesFor: (self inlineKey: default) compiler: self compiler.
	chunks isNil ifTrue: [ chunks := #() ].
	chunks isString ifTrue: [ chunks := Array with: chunks ].
	inlines := chunks stream.
	^inlines""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"missingNativeCodeFor:as:",0
,smalltalk.__f__("""(self,aNode,lang):
	#OptimizingEncoder>>#missingNativeCodeFor:as:
	return self.error_(smalltalk.object_comma_(smalltalk.String("Missing native code for language "),lang)) 
""","OptimizingEncoder_missingNativeCodeFor_as_")
,"inlines","""missingNativeCodeFor: aNode as: lang
	" Private - Return the native language code for missing expression (or nil). "

	^self error: 'Missing native code for language ' ,lang """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"inline:source:",0
,smalltalk.__f__("""(self,aNode,default):
	#OptimizingEncoder>>#inline:source:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.chunks.next() 
	__0__.chunks=nil
	__0__.chunks=self.inlinesFor_(default) 
	return smalltalk.if_true_false_(__0__.chunks.atEnd(),nil,smalltalk.blk(__blk1__,0)) 
""","OptimizingEncoder_inline_source_")
,"inlines","""inline: aNode source: default
	" Return the default source for inline node. "

	| chunks |
	chunks := self inlinesFor: default.
	^chunks atEnd ifFalse: [ chunks next ] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitInlineNode:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitInlineNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.optimize_macro_(aNode,__0__.string) 
	__0__.string=nil
	__0__.lang=nil
	__0__.lang=self.nativeLanguage() 
	if smalltalk.b(smalltalk.isNil_(__0__.lang)):
		__0__.lang=smalltalk.Smalltalk.nativeLanguage() 
	 
	__0__.string=aNode.sourceFor_in_(__0__.lang,self) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.string,smalltalk.String("self"))):
		return nil 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.string.size(),smalltalk.Number(0))):
		__0__.string=self.missingNativeCodeFor_as_(aNode,__0__.lang) 
	 
	return smalltalk.if_true_false_(smalltalk.notNil_(__0__.string),smalltalk.blk(__blk1__,0),nil) 
""","OptimizingEncoder_visitInlineNode_")
,"inlines","""visitInlineNode: aNode
	" Private - Encode an inline node containing native language code. "

	| string lang |
	lang := self nativeLanguage.
	lang isNil ifTrue:  [ lang := Smalltalk nativeLanguage ].
	string := aNode sourceFor: lang in: self.
	string = #self ifTrue: [ ^nil ]. "the inline {'self'} is considered a no-operation"
	string size = 0 ifTrue:  [ string := self missingNativeCodeFor: aNode as: lang ].
	^string notNil ifTrue: [ self optimize: aNode macro: string ] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"startCompiling:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#startCompiling:
	smalltalk.basic_at_put(self,"@inlines",nil) 
	return smalltalk.superReceiver(smalltalk.OptimizingEncoder,self).startCompiling_(aNode) 
""","OptimizingEncoder_startCompiling_")
,"private","""startCompiling: aNode
	" Private - Set the receiver to start emmiting code for aNode. "

	inlines := nil.
	^super startCompiling: aNode""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitInlined:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitInlined:
	def __blk1__(each):
		return self.visit_(each) 
	if not smalltalk.b(smalltalk.is_kindOf_(aNode,(smalltalk.BlockNode))):
		return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid block node ("),aNode),smalltalk.String(")."))) 
	 
	aNode.nodes().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","OptimizingEncoder_visitInlined_")
,"optimization","""visitInlined: aNode
	" Private - Encode aNode as inlined sequence of statements. "

	(aNode isKindOf: BlockNode) ifFalse: [
		^self error: 'Invalid block node (' ,aNode ,').'
	].
	aNode nodes do: [:each | self visit: each ].""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitInlinedMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#visitInlinedMacro:in:with:
		if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("inlinedReceiver"))):
			return self.visitInlined_(aNode.receiver()) 
		 
		if smalltalk.b(macro.startsWith_(smalltalk.String("inlined"))):
			__1__=smalltalk.newContext()
			def __blk1__(i):
				def __blk2__():
					return smalltalk.raise_result_(_s8Ret_,self.visitInlined_(__1__.args.at_(i))) 
				return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(smalltalk.object_comma_(smalltalk.String("inlined"),smalltalk.asString_(i)),macro),smalltalk.blk(__blk2__,0),nil) 
			__1__.args=nil
			__1__.args=aNode.arguments() 
			smalltalk.Number(1).to_do_(__1__.args.size(),smalltalk.blk(__blk1__,1)) 
		 
		smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid macro ["),macro),smalltalk.String("]")))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_visitInlinedMacro_in_with_")
,"optimizing","""visitInlinedMacro: macro in: input with: aNode
	" Private - Visit inlined macro in input. "

	macro = #inlinedReceiver ifTrue: [ ^self visitInlined: aNode receiver ].
	(macro startsWith: #inlined) ifTrue: [ | args |
		args := aNode arguments.
		1 to: args size do: [:i|
			#inlined ,i asString = macro ifTrue: [
				^self visitInlined: (args at: i)
			].
		].
	].
	^self error: 'Invalid macro [',macro,']' """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitSeqMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	#OptimizingEncoder>>#visitSeqMacro:in:with:
	__0__=smalltalk.newContext()
	__0__.args=nil
	__0__.i=nil
	if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("sequence"))):
		return self.visitSequenceNode_(aNode) 
	 
	__0__.i=macro.copyFrom_to_(smalltalk.Number(4),macro.size()).asNumber() 
	__0__.args=aNode.arguments() 
	if smalltalk.b(__0__.i.between_and_(smalltalk.Number(1),__0__.args.size())):
		__1__=smalltalk.newContext()
		__1__.block=nil
		__1__.block=__0__.args.at_(__0__.i) 
		if not smalltalk.b(smalltalk.isObject_equalTo_(__1__.block.parameters().size(),smalltalk.Number(0))):
			self.error_(smalltalk.String("Invalid block (has parameters)")) 
		 
		return self.visitSequenceNode_(__1__.block.nodes().first()) 
	 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid macro ["),macro),smalltalk.String("]"))) 
""","OptimizingEncoder_visitSeqMacro_in_with_")
,"optimizing","""visitSeqMacro: macro in: input with: aNode
	" Private - Visit argument macro in input. "

	| args i |
	macro = #sequence ifTrue: [
		^self visitSequenceNode: aNode
	].
	i := (macro copyFrom: 4 to: macro size) asNumber.
	args := aNode arguments.
	(i between: 1 and: args size) ifTrue: [ | block |
		block := args at: i.
		block parameters size = 0 ifFalse: [
			self error: 'Invalid block (has parameters)'
		].
		^self visitSequenceNode: block nodes first
	].
	^self error: 'Invalid macro [',macro,']' """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitArgMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	#OptimizingEncoder>>#visitArgMacro:in:with:
	__0__=smalltalk.newContext()
	__0__.args=nil
	__0__.i=nil
	__0__.i=macro.copyFrom_to_(smalltalk.Number(4),macro.size()).asNumber() 
	__0__.args=aNode.arguments() 
	if smalltalk.b(__0__.i.between_and_(smalltalk.Number(1),__0__.args.size())):
		return self.visit_(__0__.args.at_(__0__.i)) 
	 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid macro ["),macro),smalltalk.String("]"))) 
""","OptimizingEncoder_visitArgMacro_in_with_")
,"optimizing","""visitArgMacro: macro in: input with: aNode
	" Private - Visit argument macro in input. "

	| args i |
	i := (macro copyFrom: 4 to: macro size) asNumber.
	args := aNode arguments.
	(i between: 1 and: args size) ifTrue: [
		^self visit: (args at: i)
	].
	^self error: 'Invalid macro [',macro,']' """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"basicMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	#OptimizingEncoder>>#basicMacro:in:with:
	if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("lang"))):
		return self.nextPutAll_(self.nativeLanguage()) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("receiver"))):
		return self.visitReceiver_(aNode.receiver()) 
	 
	if smalltalk.b(macro.startsWith_(smalltalk.String("arg"))):
		return self.visitArgMacro_in_with_(macro,input,aNode) 
	 
	if smalltalk.b(macro.startsWith_(smalltalk.String("seq"))):
		return self.visitSeqMacro_in_with_(macro,input,aNode) 
	 
	if smalltalk.b(macro.startsWith_(smalltalk.String("!"))):
		def __blk1__(_s8_rec):
			_s8_rec.next() 
			return _s8_rec.fileInto_(self) 
		return __blk1__(macro.stream()) 
	 
	if smalltalk.b(macro.startsWith_(smalltalk.String("inlined"))):
		return self.visitInlinedMacro_in_with_(macro,input,aNode) 
	 
	if smalltalk.b(smalltalk.responds_to_(self,(macro))):
		return self.perform_withArguments_(macro,smalltalk.Array.with_with_(aNode,input)) 
	 
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Missing macro ["),macro),smalltalk.String("]"))) 
""","OptimizingEncoder_basicMacro_in_with_")
,"macros","""basicMacro: macro in: input with: aNode
	" Private - Visit aNode encoding/expanding basic macros in input. "

	macro = #lang ifTrue: [
		^self nextPutAll: self nativeLanguage
	].
	macro = #receiver ifTrue: [
		^self visitReceiver: aNode receiver
	].
	(macro startsWith: #arg) ifTrue: [
		^self visitArgMacro: macro in: input with: aNode
	].
	(macro startsWith: #seq) ifTrue: [
		^self visitSeqMacro: macro in: input with: aNode
	].
	(macro startsWith: $!) ifTrue: [
		^macro stream next; fileInto: self
	].
	(macro startsWith: #inlined) ifTrue: [
		^self visitInlinedMacro: macro in: input with: aNode
	].
	(self respondsTo: macro) ifTrue: [
		^self perform: macro withArguments: (Array with: aNode with: input)
	].
	^self error: 'Missing macro [' ,macro ,$] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitUppercaseMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#visitUppercaseMacro:in:with:
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.basicMacro_in_with_(macro,input,aNode)) 
		if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("Lang"))):
			smalltalk.raise_result_(_s8Ret_,self.nextPutAll_(self.nativeLanguage().asGlobalName())) 
		 
		smalltalk.Smalltalk.at_ifAbsent_(macro,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,self.nextPutAll_(self.codeToGetGlobal_(macro))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_visitUppercaseMacro_in_with_")
,"optimizing","""visitUppercaseMacro: macro in: input with: aNode
	" Private - Visit aNode encoding/expanding macro in input. "

	macro = #Lang ifTrue: [
		^self nextPutAll: self nativeLanguage asGlobalName
	].
	Smalltalk at: macro ifAbsent: [
		^self basicMacro: macro in: input with: aNode 
	].
	^self nextPutAll: (self codeToGetGlobal: macro) """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	#OptimizingEncoder>>#visitMacro:in:with:
	if smalltalk.b(macro.startsWith_(self.messageSendConnector())):
		return self.nextPutAll_(smalltalk.object_comma_(smalltalk.String("smalltalk"),macro)) 
	 
	if smalltalk.b(macro.first().isUppercase()):
		return self.visitUppercaseMacro_in_with_(macro,input,aNode) 
	 
	return self.basicMacro_in_with_(macro,input,aNode) 
""","OptimizingEncoder_visitMacro_in_with_")
,"optimizing","""visitMacro: macro in: input with: aNode
	" Private - Visit aNode encoding/expanding macro in input. "

	(macro startsWith: self messageSendConnector) ifTrue: [ " %.smalltalkAPI% "
		^self nextPutAll: #smalltalk ,macro
	].
	macro first isUppercase ifTrue: [ " %GlobalName% "
		^self visitUppercaseMacro: macro in: input with: aNode 
	].
	^self basicMacro: macro in: input with: aNode """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitMacroIn:with:",0
,smalltalk.__f__("""(self,input,aNode):
	#OptimizingEncoder>>#visitMacroIn:with:
	__0__=smalltalk.newContext()
	__0__.macro=nil
	__0__.macro=input.upTo_(smalltalk.String("%")) 
	if smalltalk.b(__0__.macro.isEmpty()):
		self.emmitCode_(smalltalk.String("%")) 
	else:
		self.visitMacro_in_with_(__0__.macro,input,aNode) 
	 
	return self 
""","OptimizingEncoder_visitMacroIn_with_")
,"optimizing","""visitMacroIn: input with: aNode
	" Private - Visit next macro in input. "

	| macro |
	macro := input upTo: $%.
	macro isEmpty
		ifTrue: [ self emmitCode: $% ]
		ifFalse: [ self visitMacro: macro in: input with: aNode ] """,nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitOptimizedNode:as:",0
,smalltalk.__f__("""(self,aNode,mapping):
	#OptimizingEncoder>>#visitOptimizedNode:as:
	__0__=smalltalk.newContext()
	__0__.macro=nil
	__0__.macro=mapping.last() 
	if smalltalk.b(smalltalk.isObject_equalTo_(mapping.size(),smalltalk.Number(2))):
		return self.optimize_macro_(aNode,__0__.macro) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(mapping.size(),smalltalk.Number(3))):
		def __blk1__():
			return self.optimize_macro_(aNode,__0__.macro) 
		return smalltalk.boolean_and_(self.matchOptimizedCondition_with_(mapping.at_(smalltalk.Number(2)),aNode),smalltalk.blk(__blk1__,0)) 
	 
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Compiler optimization"),smalltalk.String(" for #")),aNode.selector()),smalltalk.String(" - not implemented ")),mapping.asLiteral())) 
	return smalltalk.false 
""","OptimizingEncoder_visitOptimizedNode_as_")
,"visiting","""visitOptimizedNode: aNode as: mapping
	" Private - Generate the code for aNode using custom mapping.
	Return true if the code can be generated.
	If the optimization fails, the receiver remains intact.
	"

	| macro |
	macro := mapping last.

	mapping size = 2 ifTrue: [ "(selector macro)"
		^self optimize: aNode macro: macro
	].
	mapping size = 3 ifTrue: ["(selector condition macro)"
		^(self matchOptimizedCondition: (mapping at:2) with: aNode)
			and: [ self optimize: aNode macro: macro ]
	].

	self note: 'Compiler optimization'
		,' for #',aNode selector
		,' - not implemented '
		,mapping asLiteral.
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitOptimizedSend:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitOptimizedSend:
	return self.visitOptimizedSend_with_(aNode,self.optimizationMap()) 
""","OptimizingEncoder_visitOptimizedSend_")
,"visiting","""visitOptimizedSend: aNode
	" Private - Generate optimal code for aNode using optimization map.
	Return true if optimization was successfull.
	"

	^self visitOptimizedSend: aNode with: self optimizationMap""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitOptimizedSend:with:",0
,smalltalk.__f__("""(self,aNode,mapping):
	_s8Ret_=smalltalk.newContext()
	try:
		#OptimizingEncoder>>#visitOptimizedSend:with:
		__0__=smalltalk.newContext()
		def __blk1__(tuple):
			def __blk2__():
				return smalltalk.isObject_equalTo_(tuple.first(),__0__.argCount) 
			def __blk3__():
				def __blk4__():
					return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
				return smalltalk.if_true_false_(self.visitOptimizedSend_with_(aNode,tuple.last()),smalltalk.blk(__blk4__,0),nil) 
			def __blk5__():
				def __blk6__():
					def __blk7__():
						return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
					return smalltalk.if_true_false_(self.visitOptimizedNode_as_(aNode,tuple),smalltalk.blk(__blk7__,0),nil) 
				return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(tuple.first(),aNode.selector()),smalltalk.blk(__blk6__,0),nil) 
			return smalltalk.if_true_false_(smalltalk.boolean_and_(tuple.first().isNumber(),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk5__,0)) 
		__0__.argCount=nil
		__0__.argCount=aNode.arguments().size() 
		mapping.do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","OptimizingEncoder_visitOptimizedSend_with_")
,"visiting","""visitOptimizedSend: aNode with: mapping
	" Private - Generate optimal code for aNode using mapping.
	Return true if the code has been generated.
	Leave the receiver intact if the optimization do not apply.
	"

	| argCount |
	argCount := aNode arguments size.
	mapping do: [:tuple|
		(tuple first isNumber and: [ tuple first = argCount ]) ifTrue: [ "arguments size match"
			(self visitOptimizedSend: aNode with: tuple last) ifTrue: [ ^true ].
		] ifFalse: [
			tuple first = aNode selector ifTrue: [ "selector match"
				(self visitOptimizedNode: aNode as: tuple) ifTrue: [ ^true ].
			].
		].
	].
	^false""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitReceiver:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitReceiver:
	return self.implementedBySubclass_(smalltalk.String("visitReceiver:")) 
""","OptimizingEncoder_visitReceiver_")
,"visiting","""visitReceiver: aNode
	" Private - Visit the node (as receiver) emmitting output. "

	^self implementedBySubclass: #visitReceiver:""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitSendNode:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitSendNode:
	return self.implementedBySubclass_(smalltalk.String("visitSendNode:")) 
""","OptimizingEncoder_visitSendNode_")
,"visiting","""visitSendNode: aNode
	" Private - Visit the node (message send node) emmitting output. "

	^self implementedBySubclass: #visitSendNode:""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitNode:index:",0
,smalltalk.__f__("""(self,aNode,index):
	#OptimizingEncoder>>#visitNode:index:
	return self.implementedBySubclass_(smalltalk.String("visitNode:index:")) 
""","OptimizingEncoder_visitNode_index_")
,"visiting","""visitNode: aNode index: index
	" Private - Generate code for indexed access. "

	^self implementedBySubclass: #visitNode:index:""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitNodeIndices:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitNodeIndices:
	def __blk1__(each):
		return self.visitNode_index_(aNode,each) 
	aNode.indices().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","OptimizingEncoder_visitNodeIndices_")
,"visiting","""visitNodeIndices: aNode
	" Private - Generate code for indexed access. "

	aNode indices do: [:each| self visitNode: aNode index: each ].""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"missingVariable:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#missingVariable:
	def __blk1__():
		__1__=smalltalk.newContext()
		def __blk2__():
			self.unknownVariables().add_(__1__.unknown) 
			return (self).__class__.unknownVariable_in_(aNode,self) 
		__1__.unknown=nil
		__1__.unknown=aNode.value() 
		return smalltalk.if_true_false_((self).__class__.bind_in_(__1__.unknown,self),nil,smalltalk.blk(__blk2__,0)) 
	self.compilerEvent_withArguments_ifNotHandled_(smalltalk.String("missingVariable:in:"),smalltalk.Array.with_with_(aNode,self),smalltalk.blk(__blk1__,0)) 
	return self 
""","OptimizingEncoder_missingVariable_")
,"variables","""missingVariable: aNode
	" Private - Try to bind to access to variable in aNode. "

	self	compilerEvent: #missingVariable:in:
		withArguments: (Array with: aNode with: self)
		ifNotHandled: [ | unknown |
			unknown := aNode value.
			(self class bind: unknown in: self) ifFalse: [
				self unknownVariables add: unknown.
				self class unknownVariable: aNode in: self.
			]
	]""",nil)
smalltalk.bind(smalltalk.OptimizingEncoder,"visitVariableNode:",0
,smalltalk.__f__("""(self,aNode):
	#OptimizingEncoder>>#visitVariableNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		return aNode.needsVerification() 
	def __blk2__():
		return self.knownVariables().includes_(aNode.value()) 
	__0__.code=nil
	__0__.code=self.currentClass().codeFor_accessing_(self,aNode) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.isNil_(__0__.code),smalltalk.blk(__blk1__,0))):
		def __blk3__():
			return self.missingVariable_(aNode) 
		smalltalk.if_true_false_(self.knownVariables().includes_(aNode.value()),nil,smalltalk.blk(__blk3__,0)) 
	 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(__0__.code),smalltalk.blk(__blk2__,0))):
		__0__.code=aNode.localNameIn_(self) 
	 
	self.emmitCode_(__0__.code) 
	self.visitNodeIndices_(aNode) 
	return self 
""","OptimizingEncoder_visitVariableNode_")
,"variables","""visitVariableNode: aNode
	" Private - Generate code to access variable aNode. "

	| code |
	code := self currentClass codeFor: self accessing: aNode.
	(code isNil and: [aNode needsVerification]) ifTrue: [
		(self knownVariables includes: aNode value) ifFalse: [
			self missingVariable: aNode
		].
	].
	(code isNil or: [self knownVariables includes: aNode value]) ifTrue: [
		code := aNode localNameIn: self
	].

	self emmitCode: code.
	self visitNodeIndices: aNode.""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"cr",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#cr
	getattr(self,"@stream",nil).cr() 
	return self 
""","NativeEncoder_cr")
,"writing","""cr
	" Private - Emmit a new line onto output stream. "

	stream cr""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"tab",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#tab
	getattr(self,"@stream",nil).tab() 
	return self 
""","NativeEncoder_tab")
,"writing","""tab
	" Private - Emmit a tab onto output stream. "

	stream tab""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"space",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#space
	getattr(self,"@stream",nil).space() 
	return self 
""","NativeEncoder_space")
,"writing","""space
	" Private - Emmit a space onto output stream. "

	stream space""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"nextPutAll:",0
,smalltalk.__f__("""(self,aString):
	#NativeEncoder>>#nextPutAll:
	getattr(self,"@stream",nil).nextPutAll_(aString) 
	return self 
""","NativeEncoder_nextPutAll_")
,"writing","""nextPutAll: aString
	" Private - Emmit aString onto output stream. "

	stream nextPutAll: aString""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"assignmentOp",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#assignmentOp
	return smalltalk.String("=") 
""","NativeEncoder_assignmentOp")
,"constants","""assignmentOp
	" Private - Return the OP for encoding assignment. "

	^$= """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"separatorOp",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#separatorOp
	return smalltalk.String(";") 
""","NativeEncoder_separatorOp")
,"constants","""separatorOp
	" Private - Return the OP for separating statements. "

	^$; """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"returnOpStart",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#returnOpStart
	return smalltalk.String("return ") 
""","NativeEncoder_returnOpStart")
,"constants","""returnOpStart
	" Private - Return the OP for starting return expressions. "

	^'return ' """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"returnOpEnd",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#returnOpEnd
	return nil 
""","NativeEncoder_returnOpEnd")
,"constants","""returnOpEnd
	" Private - Return the OP for ending return expressions. "

	^nil """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"returnOps",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#returnOps
	return smalltalk.Array.with_with_(self.returnOpStart(),self.returnOpEnd()) 
""","NativeEncoder_returnOps")
,"constants","""returnOps
	" Private - Return the OPs for return expression. "

	^Array	with: self returnOpStart
		with: self returnOpEnd """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"between:do:",0
,smalltalk.__f__("""(self,separators,aBlock):
	#NativeEncoder>>#between:do:
	if smalltalk.b(smalltalk.notNil_(separators.first())):
		getattr(self,"@stream",nil).nextPutAll_(separators.first()) 
	 
	aBlock.evaluate() 
	if smalltalk.b(smalltalk.notNil_(separators.last())):
		getattr(self,"@stream",nil).nextPutAll_(separators.last()) 
	 
	return self 
""","NativeEncoder_between_do_")
,"writing","""between: separators do: aBlock
	" Private - Emmit aBlock between separators onto output stream. "

	separators first notNil ifTrue: [ stream nextPutAll: separators first ].
	aBlock evaluate.
	separators last notNil ifTrue: [ stream nextPutAll: separators last ] """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"nextArgumentsPut:",0
,smalltalk.__f__("""(self,aBlock):
	#NativeEncoder>>#nextArgumentsPut:
	self.between_do_(smalltalk.String("()"),aBlock) 
	return self 
""","NativeEncoder_nextArgumentsPut_")
,"writing","""nextArgumentsPut: aBlock
	" Private - Emmit arguments list evaluating aBlock onto output stream. "

	self between: '()' do: aBlock """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"nextIndexPut:",0
,smalltalk.__f__("""(self,aBlock):
	#NativeEncoder>>#nextIndexPut:
	self.between_do_(smalltalk.String("[]"),aBlock) 
	return self 
""","NativeEncoder_nextIndexPut_")
,"writing","""nextIndexPut: aBlock
	" Private - Emmit a series between indexing notation evaluating aBlock onto output stream. "

	self between: '[]' do: aBlock """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"nextReturn:put:",0
,smalltalk.__f__("""(self,early,aBlock):
	#NativeEncoder>>#nextReturn:put:
	self.between_do_(self.returnOps(),aBlock) 
	return self 
""","NativeEncoder_nextReturn_put_")
,"writing","""nextReturn: early put: aBlock
	" Private - Emmit a return OP evaluating aBlock onto output stream. "

	self between: self returnOps do: aBlock """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitCode:",0
,smalltalk.__f__("""(self,code):
	#NativeEncoder>>#emmitCode:
	self.nextPutAll_(code) 
	return self 
""","NativeEncoder_emmitCode_")
,"generation","""emmitCode: code
	" Private - Emmit code onto output stream. "

	self nextPutAll: code""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"codeToAccessProperty:in:",0
,smalltalk.__f__("""(self,aName,aNode):
	#NativeEncoder>>#codeToAccessProperty:in:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('self["'),aName),smalltalk.String('"]')) 
""","NativeEncoder_codeToAccessProperty_in_")
,"encoding","""codeToAccessProperty: aName in: aNode
	" Private - Return the source code to access property aName. "

	^'self["',aName,'"]'""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"codeToAccessInstanceVariable:in:",0
,smalltalk.__f__("""(self,aName,aNode):
	#NativeEncoder>>#codeToAccessInstanceVariable:in:
	return self.codeToAccessProperty_in_(smalltalk.object_comma_(smalltalk.String("@"),aName),aNode) 
""","NativeEncoder_codeToAccessInstanceVariable_in_")
,"encoding","""codeToAccessInstanceVariable: aName in: aNode
	" Private - Return the source code to access instance variable aName. "

	^self codeToAccessProperty: '@', aName in: aNode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"defaultRequirementsFor:",0
,smalltalk.__f__("""(self,aClass):
	#NativeEncoder>>#defaultRequirementsFor:
	return smalltalk.newArray([]) 
""","NativeEncoder_defaultRequirementsFor_")
,"export","""defaultRequirementsFor: aClass
	" Private - Return the default (collection of) requirements to load aClass.
	Return an empty collection.
	This method can be refined by subclasses.
	"

	^#() """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"acceptAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#acceptAssignment:
	def __blk1__():
		return smalltalk.true 
	return self.compilerEvent_with_ifNotHandled_(smalltalk.String("acceptAssignmentTo:"),aNode.left(),smalltalk.blk(__blk1__,0)) 
""","NativeEncoder_acceptAssignment_")
,"assignment","""acceptAssignment: aNode
	" Private - Return true if assignment aNode can be accepted. "

	^self	compilerEvent: #acceptAssignmentTo:
		with: aNode left
		ifNotHandled: [ true ]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunctionStart:",0
,smalltalk.__f__("""(self,fName):
	#NativeEncoder>>#emmitFunctionStart:
	self.nextPutAll_(smalltalk.String("function")) 
	return self 
""","NativeEncoder_emmitFunctionStart_")
,"generation","""emmitFunctionStart: fName
	" Private - Emmit the code of function start definition. "

	self nextPutAll: #function """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunctionArguments:",0
,smalltalk.__f__("""(self,argList):
	#NativeEncoder>>#emmitFunctionArguments:
	def __blk1__():
		return self.nextPutAll_(argList) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeEncoder_emmitFunctionArguments_")
,"generation","""emmitFunctionArguments: argList
	" Private - Emmit the code of function arguments. "

	self nextArgumentsPut: [
		self nextPutAll: argList
	] """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunctionBody:",0
,smalltalk.__f__("""(self,aBlock):
	#NativeEncoder>>#emmitFunctionBody:
	return self.implementedBySubclass_(smalltalk.String("emmitFunctionBody:")) 
""","NativeEncoder_emmitFunctionBody_")
,"generation","""emmitFunctionBody: aBlock
	" Private - Emmit the code of function body evaluating aBlock. "

	^self implementedBySubclass: #emmitFunctionBody: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunction:arguments:doing:",0
,smalltalk.__f__("""(self,fName,argList,aBlock):
	#NativeEncoder>>#emmitFunction:arguments:doing:
	def __blk1__():
		self.emmitFunctionStart_(fName) 
		self.compilerEvent_with_(smalltalk.String("startFunctionName:"),fName) 
		return self.emmitFunctionArguments_(argList) 
	def __blk2__():
		self.compilerEvent_withArguments_(smalltalk.String("startFunctionBody:with:"),smalltalk.Array.with_with_(fName,argList)) 
		return aBlock.evaluate() 
	self.compilerEvent_withArguments_ifNotHandled_(smalltalk.String("startFunction:with:"),smalltalk.Array.with_with_(fName,argList),smalltalk.blk(__blk1__,0)) 
	self.emmitFunctionBody_(smalltalk.blk(__blk2__,0)) 
	self.compilerEvent_with_(smalltalk.String("endFunction:"),fName) 
	return self 
""","NativeEncoder_emmitFunction_arguments_doing_")
,"generation","""emmitFunction: fName arguments: argList doing: aBlock
	" Private - Emmit function on receiver's code stream. "

	self
		compilerEvent: #startFunction:with:
		withArguments: (Array with: fName with: argList)
		ifNotHandled: [
			self emmitFunctionStart: fName.
			self compilerEvent: #startFunctionName: with: fName.
			self emmitFunctionArguments: argList
		].
	self emmitFunctionBody: [
		self	compilerEvent: #startFunctionBody:with:
			withArguments: (Array with: fName with: argList).
		aBlock evaluate
	].
	self compilerEvent: #endFunction: with: fName.""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunction:node:doing:",0
,smalltalk.__f__("""(self,fName,aNode,aBlock):
	#NativeEncoder>>#emmitFunction:node:doing:
	return self.emmitFunction_node_arguments_doing_(fName,aNode,aNode.argumentNames(),aBlock) 
""","NativeEncoder_emmitFunction_node_doing_")
,"generation","""emmitFunction: fName node: aNode doing: aBlock
	" Private - Generate function for aNode. "

	^self	emmitFunction: fName
		node: aNode arguments: aNode argumentNames
		doing: aBlock""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunctionDoing:",0
,smalltalk.__f__("""(self,aBlock):
	#NativeEncoder>>#emmitFunctionDoing:
	return self.emmitFunction_arguments_doing_(smalltalk.String(""),smalltalk.String(""),aBlock) 
""","NativeEncoder_emmitFunctionDoing_")
,"generation","""emmitFunctionDoing: aBlock
	" Private - Emmit function on receiver's code stream. "

	^self emmitFunction: '' arguments: '' doing: aBlock""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitReturn:early:",0
,smalltalk.__f__("""(self,aBlockOrString,early):
	#NativeEncoder>>#emmitReturn:early:
	def __blk1__():
		def __blk2__():
			return self.nextPutAll_(aBlockOrString) 
		def __blk3__():
			return aBlockOrString.evaluate() 
		self.compilerEvent_with_(smalltalk.String("return:"),aBlockOrString) 
		return smalltalk.if_true_false_(aBlockOrString.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	self.compilerEvent_with_(smalltalk.String("aboutReturn:"),aBlockOrString) 
	self.nextReturn_put_(early,smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.notNil_(aBlockOrString)):
		self.compilerEvent_withArguments_(smalltalk.String("returned:early:"),smalltalk.Array.with_with_(aBlockOrString,early)) 
	 
	return self 
""","NativeEncoder_emmitReturn_early_")
,"generation","""emmitReturn: aBlockOrString early: early
	" Private - Generate return code. "

	self compilerEvent: #aboutReturn: with: aBlockOrString.
	self nextReturn: early put: [
		self compilerEvent: #return: with: aBlockOrString.
		aBlockOrString isString
			ifTrue: [ self nextPutAll: aBlockOrString ]
			ifFalse: [ aBlockOrString evaluate ]
	].
	aBlockOrString notNil ifTrue: [
		self	compilerEvent: #returned:early:
			withArguments: (Array with: aBlockOrString with: early).
	].""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitReturn:",0
,smalltalk.__f__("""(self,aBlockOrString):
	#NativeEncoder>>#emmitReturn:
	return self.emmitReturn_early_(aBlockOrString,smalltalk.false) 
""","NativeEncoder_emmitReturn_")
,"generation","""emmitReturn: aBlockOrString
	" Private - Generate return code. "

	^self emmitReturn: aBlockOrString early: false""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"defaultOptimizations",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#defaultOptimizations
	return smalltalk.newArray(["s8"]) 
""","NativeEncoder_defaultOptimizations")
,"defaults","""defaultOptimizations
	" Private - Return the default optimizations of the receiver.
	Note that returned optimizations MUST be provided by the subclasses. "

	^#( s8 "magnitude math" )""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitedCode",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#emmitedCode
	def __blk1__():
		return getattr(self,"@stream",nil).contents() 
	return smalltalk.if_true_false_(smalltalk.notNil_(getattr(self,"@stream",nil)),smalltalk.blk(__blk1__,0),nil) 
""","NativeEncoder_emmitedCode")
,"results","""emmitedCode
	" Return the emmited code during compilation (or nil). "

	^stream notNil ifTrue: [ stream contents ]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"arrayLiteralStart",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#arrayLiteralStart
	return smalltalk.String("[") 
""","NativeEncoder_arrayLiteralStart")
,"literals","""arrayLiteralStart
	" Private - Return the code string to start exporting an array literal. "

	^$[""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"arrayLiteralEnd",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#arrayLiteralEnd
	return smalltalk.String("]") 
""","NativeEncoder_arrayLiteralEnd")
,"literals","""arrayLiteralEnd
	" Private - Return the code string to end exporting an array literal. "

	^$]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"escaped:",0
,smalltalk.__f__("""(self,string):
	#NativeEncoder>>#escaped:
	return string.escapedCode() 
""","NativeEncoder_escaped_")
,"literals","""escaped: string
	" Private - Return the code string to export string literal. "

	^string escapedCode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"nativeSourceFor:",0
,smalltalk.__f__("""(self,aMethod):
	#NativeEncoder>>#nativeSourceFor:
	return aMethod.compiledSource() 
""","NativeEncoder_nativeSourceFor_")
,"private","""nativeSourceFor: aMethod
	" Private - Return the code of native function implementing aMethod. "

	^aMethod compiledSource""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitMethodContents:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#emmitMethodContents:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return self.emmitEnterMethod_(aNode) 
		def __blk3__(each):
			return self.visit_(each) 
		self.compilerEvent_withArguments_ifNotHandled_(smalltalk.String("enterMethod:"),smalltalk.Array.with_(aNode),smalltalk.blk(__blk2__,0)) 
		return aNode.nodes().do_(smalltalk.blk(__blk3__,1)) 
	__0__.code=nil
	__0__.delta=nil
	__0__.code=self.generatedCodeFor_while_(aNode,smalltalk.blk(__blk1__,0)) 
	__0__.delta=self.generate_early_return_(getattr(self,"@functionName",nil),getattr(self,"@earlyReturn",nil),__0__.code) 
	self.translate_by_(aNode,__0__.delta) 
	return self 
""","NativeEncoder_emmitMethodContents_")
,"generation","""emmitMethodContents: aNode
	" Private - Generate code for contents of method aNode. "

	| code delta |
	code := self generatedCodeFor: aNode while: [
		self compilerEvent: #enterMethod: withArguments: (Array with: aNode)
			ifNotHandled: [ self emmitEnterMethod: aNode ].
		aNode nodes do: [:each | self visit: each ].
	].
	delta := self generate: functionName early: earlyReturn return: code.
	self translate: aNode by: delta.""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitMethod:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#emmitMethod:
	def __blk1__():
		self.compilerEvent_with_(smalltalk.String("startMethod:"),aNode) 
		self.emmitMethodContents_(aNode) 
		return self.compilerEvent_with_(smalltalk.String("endMethod:"),aNode) 
	smalltalk.basic_at_put(self,"@nestedBlocks",smalltalk.Number(0)) 
	smalltalk.basic_at_put(self,"@earlyReturn",smalltalk.false) 
	self.compiler().resetVariables() 
	smalltalk.basic_at_put(self,"@functionName",self.asSelector_(aNode.selector())) 
	aNode.validateArguments() 
	self.emmitFunction_node_doing_(getattr(self,"@functionName",nil),aNode,smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeEncoder_emmitMethod_")
,"generation","""emmitMethod: aNode
	" Private - Generate code of method aNode. "

	nestedBlocks := 0.
	earlyReturn := false.
	self compiler resetVariables.

	functionName := self asSelector: aNode selector.
	aNode validateArguments.
	self emmitFunction: functionName node: aNode doing: [
		self compilerEvent: #startMethod: with: aNode.
		self emmitMethodContents: aNode.
		self compilerEvent: #endMethod: with: aNode.
	]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"saveState",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#saveState
	return smalltalk.Array.with_with_(getattr(self,"@stream",nil),getattr(self,"@startOffset",nil)) 
""","NativeEncoder_saveState")
,"state","""saveState
	" Private - Return the state of the receiver. "

	^Array	with: stream
		with: startOffset """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"restoreState:",0
,smalltalk.__f__("""(self,array):
	#NativeEncoder>>#restoreState:
	smalltalk.basic_at_put(self,"@stream",array.first()) 
	smalltalk.basic_at_put(self,"@startOffset",array.second()) 
	return self 
""","NativeEncoder_restoreState_")
,"state","""restoreState: array
	" Private - Restore the state of the receiver. "

	stream := array first.
	startOffset := array second """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"generatedCodeFor:while:",0
,smalltalk.__f__("""(self,aNode,aBlock):
	#NativeEncoder>>#generatedCodeFor:while:
	__0__=smalltalk.newContext()
	__0__.backup=nil
	__0__.result=nil
	__0__.backup=self.saveState() 
	smalltalk.basic_at_put(self,"@startOffset",getattr(self,"@stream",nil).position()) 
	smalltalk.basic_at_put(self,"@stream",smalltalk.String("").writeStream()) 
	self.visit_doing_(aNode,aBlock) 
	__0__.result=getattr(self,"@stream",nil).contents() 
	self.restoreState_(__0__.backup) 
	return __0__.result 
""","NativeEncoder_generatedCodeFor_while_")
,"generation","""generatedCodeFor: aNode while: aBlock
	" Private - Return the code generated during evaluation of aBlock. "

	| backup result |
	backup := self saveState.
	startOffset := stream position.
	stream := '' writeStream.
	self visit: aNode doing: aBlock.
	result := stream contents.
	self restoreState: backup.
	^result """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"includeSourceCode",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#includeSourceCode
	return smalltalk.true 
""","NativeEncoder_includeSourceCode")
,"generation","""includeSourceCode
	" Private - Return true if source code is included as method argument. "

	^true""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"isOperation:",0
,smalltalk.__f__('''(self,aNode):
	#NativeEncoder>>#isOperation:
	def __blk1__():
		def __blk2__():
			def __blk3__():
				return smalltalk.String("""|&\\\\\\\\+*/=><,@%~-""").includes_(aNode.selector().at_(smalltalk.Number(2))) 
			return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(aNode.selector().first(),smalltalk.String("#")),smalltalk.blk(__blk3__,0)) 
		return smalltalk.boolean_and_(aNode.selector().size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk2__,0)) 
	return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(aNode.arguments().size(),smalltalk.Number(1)),smalltalk.blk(__blk1__,0)) 
''',"NativeEncoder_isOperation_")
,"operations","""isOperation: aNode
	" Private - Return true if aNode is an operation. "

	^aNode arguments size = 1 and: [
		aNode selector size > 1 and: [
		aNode selector first = $# and: [
		'|&\\\\+*/=><,@%~-' includes: (aNode selector at: 2)
		]]]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"loadRequirementsOf:",0
,smalltalk.__f__("""(self,aClass):
	#NativeEncoder>>#loadRequirementsOf:
	__0__=smalltalk.newContext()
	__0__.requirements=nil
	__0__.requirements=self.defaultRequirementsFor_(aClass) 
	aClass.loadRequirementsInto_(__0__.requirements) 
	return __0__.requirements 
""","NativeEncoder_loadRequirementsOf_")
,"export","""loadRequirementsOf: aClass
	" Private - Return the requirements to load aClass.
	It must be a collection of requirements.
	aRequirement must implement #fileOutOn: or must be aString(native code) to execute just before defining aClass.
	"

	| requirements |
	requirements := self defaultRequirementsFor: aClass.
	aClass loadRequirementsInto: requirements.
	^requirements""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"position",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#position
	return getattr(self,"@stream",nil).position()._plus(getattr(self,"@startOffset",nil)) 
""","NativeEncoder_position")
,"accessing","""position
	" Return the current position in output stream. "

	^stream position + startOffset""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"startCompiling:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#startCompiling:
	smalltalk.superReceiver(smalltalk.NativeEncoder,self).startCompiling_(aNode) 
	smalltalk.basic_at_put(self,"@stream",smalltalk.String("").writeStream()) 
	smalltalk.basic_at_put(self,"@startOffset",getattr(self,"@stream",nil).position()) 
	return self 
""","NativeEncoder_startCompiling_")
,"private","""startCompiling: aNode
	" Private - Set the receiver to start emmiting code for aNode. "

	super startCompiling: aNode.
	stream := '' writeStream.
	startOffset := stream position.""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"stream",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#stream
	return getattr(self,"@stream",nil) 
""","NativeEncoder_stream")
,"accessing","""stream
	" Return the current stream (or nil). "

	^stream""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visit:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visit:
	def __blk1__():
		return smalltalk.superReceiver(smalltalk.NativeEncoder,self).visit_(aNode) 
	return self.visit_doing_(aNode,smalltalk.blk(__blk1__,0)) 
""","NativeEncoder_visit_")
,"visiting","""visit: aNode
	^self visit: aNode doing: [ super visit: aNode ]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visit:doing:",0
,smalltalk.__f__("""(self,aNode,aBlock):
	#NativeEncoder>>#visit:doing:
	__0__=smalltalk.newContext()
	def __blk1__():
		return nil 
	__0__.cookie=nil
	__0__.result=nil
	__0__.cookie=self.compilerEvent_with_ifNotHandled_(smalltalk.String("needsCookie:"),aNode,smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.notNil_(__0__.cookie)):
		self.compilerEvent_with_(smalltalk.String("startVisit:"),__0__.cookie) 
	 
	__0__.result=aBlock.evaluate() 
	if smalltalk.b(smalltalk.notNil_(__0__.cookie)):
		self.compilerEvent_with_(smalltalk.String("endVisit:"),__0__.cookie) 
	 
	return __0__.result 
""","NativeEncoder_visit_doing_")
,"visiting","""visit: aNode doing: aBlock
	| cookie result |
	cookie := self
		compilerEvent: #needsCookie: with: aNode
		ifNotHandled: [ nil ].
	cookie notNil ifTrue: [ self compilerEvent: #startVisit: with: cookie ].
	result := aBlock evaluate.
	cookie notNil ifTrue: [ self compilerEvent: #endVisit: with: cookie ].
	^result""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitArgument:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitArgument:
	if smalltalk.b(aNode.isAssignment()):
		return self.visitLocalAssignment_(aNode) 
	 
	return self.visit_(aNode) 
""","NativeEncoder_visitArgument_")
,"visiting","""visitArgument: aNode
	" Private - Visit the argument emmitting output. "

	aNode isAssignment ifTrue: [ ^self visitLocalAssignment: aNode ].
	^self visit: aNode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#emmitAssignment:
	def __blk1__(_s8_rec):
		_s8_rec.visit_(aNode.left()) 
		_s8_rec.nextPutAll_(self.assignmentOp()) 
		return _s8_rec.visit_(aNode.right()) 
	__blk1__(self) 
	return self 
""","NativeEncoder_emmitAssignment_")
,"generation","""emmitAssignment: aNode
	" Private - Emmit the code for assignment. "

	self
		visit: aNode left;
		nextPutAll: self assignmentOp;
		visit: aNode right""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitAssignmentNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitAssignmentNode:
	if smalltalk.b(self.visitMacroAssignment_(aNode)):
		return self 
	 
	if smalltalk.b(self.acceptAssignment_(aNode)):
		self.emmitAssignment_(aNode) 
	else:
		def __blk1__():
			return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid assignment to "),aNode.left().value())) 
		self.compilerEvent_with_ifNotHandled_(smalltalk.String("invalidAssignment:"),aNode,smalltalk.blk(__blk1__,0)) 
	 
	return self 
""","NativeEncoder_visitAssignmentNode_")
,"visiting","""visitAssignmentNode: aNode

	(self visitMacroAssignment: aNode) ifTrue: [ ^self ].
	(self acceptAssignment: aNode) ifTrue: [
		self emmitAssignment: aNode
	] ifFalse: [
		self	compilerEvent: #invalidAssignment: with: aNode
			ifNotHandled: [ self error: 'Invalid assignment to ' ,aNode left value ]
	]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitNode:in:cr:",0
,smalltalk.__f__("""(self,aNode,aParentNode,withCr):
	#NativeEncoder>>#visitNode:in:cr:
	if smalltalk.b(smalltalk.notNil_(self.visit_(aNode))):
		def __blk1__():
			return self.cr() 
		self.nextPutAll_(self.separatorOp()) 
		smalltalk.if_true_false_(withCr,smalltalk.blk(__blk1__,0),nil) 
	 
	return self 
""","NativeEncoder_visitNode_in_cr_")
,"visiting","""visitNode: aNode in: aParentNode cr: withCr
	" Private - Visit aNode as part of sequence in aParentNode. "

	(self visit: aNode) notNil ifTrue: [
		self nextPutAll: self separatorOp.
		withCr ifTrue: [ self cr ].
	]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitEmptyNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitEmptyNode:
	return self 
""","NativeEncoder_visitEmptyNode_")
,"visiting","""visitEmptyNode: aNode
	" Private - Visit an empty node, aNode. " """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitNodesIn:cr:",0
,smalltalk.__f__("""(self,aNode,withCr):
	#NativeEncoder>>#visitNodesIn:cr:
	__0__=smalltalk.newContext()
	def __blk1__(one):
		return self.visitNode_in_cr_(one,aNode,smalltalk.false) 
	def __blk2__():
		def __blk3__():
			return self.cr() 
		return smalltalk.if_true_false_(withCr,smalltalk.blk(__blk3__,0),nil) 
	__0__.array=nil
	__0__.array=aNode.nodes() 
	if smalltalk.b(__0__.array.isEmpty()):
		return self.visitEmptyNode_(aNode) 
	 
	__0__.array.do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	return self 
""","NativeEncoder_visitNodesIn_cr_")
,"visiting","""visitNodesIn: aNode cr: withCr
	" Private - Visit the nodes contained in aNode. "

	| array |
	array := aNode nodes.
	array isEmpty ifTrue: [ ^self visitEmptyNode: aNode ].
	array do: [:one|
		self visitNode: one in: aNode cr: false
	] separatedBy: [ withCr ifTrue: [ self cr ] ]""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"defineTemporary:",0
,smalltalk.__f__("""(self,aName):
	#NativeEncoder>>#defineTemporary:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("var "),self.localName_(aName)),smalltalk.String("=nil;"))) 
		return _s8_rec.cr() 
	__blk1__(self) 
	return self 
""","NativeEncoder_defineTemporary_")
,"encoding","""defineTemporary: aName
	" Private - Return the code for defining temporary variable with aName. "

	self nextPutAll: 'var ' ,(self localName: aName) ,'=nil;' ;cr """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"withNodesIn:do:atEnd:",0
,smalltalk.__f__("""(self,aNode,aBlock,endBlock):
	#NativeEncoder>>#withNodesIn:do:atEnd:
	__0__=smalltalk.newContext()
	def __blk1__(index):
		return aBlock.evaluateWith_(__0__.array.at_(index)) 
	def __blk2__():
		return __0__.array.last() 
	__0__.array=nil
	__0__.array=aNode.nodes().asArray() 
	smalltalk.Number(1).to_do_(__0__.array.size()._minus(smalltalk.Number(1)),smalltalk.blk(__blk1__,1)) 
	return endBlock.evaluateWith_(smalltalk.if_true_false_(__0__.array.notEmpty(),smalltalk.blk(__blk2__,0),nil)) 
""","NativeEncoder_withNodesIn_do_atEnd_")
,"visiting","""withNodesIn: aNode do: aBlock atEnd: endBlock
	" Evaluates aBlock for nodes in aNode (without last).
	Return the result of evaluating lastBlock with the last node in aNode (or nil).
	"

	| array |
	array := aNode nodes asArray.
	1 to: array size - 1 do: [:index|
		aBlock evaluateWith: (array at: index)
	].
	^endBlock evaluateWith: (array notEmpty ifTrue: [ array last ]) """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitTemporaries:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitTemporaries:
	def __blk1__(aName):
		self.tempVariables().add_(aName) 
		return self.defineTemporary_(aName) 
	aNode.tempNames().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","NativeEncoder_visitTemporaries_")
,"visiting","""visitTemporaries: aNode
	" Private - Emmit code for local variables in aNode. "

	aNode tempNames do: [:aName |
		self tempVariables add: aName.
		self defineTemporary: aName
	] """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"startSequence:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#startSequence:
	return self 
""","NativeEncoder_startSequence_")
,"contexts","""startSequence: aNode
	" Private - Prepare context for sequence aNode. " """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"endSequence:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#endSequence:
	return self 
""","NativeEncoder_endSequence_")
,"contexts","""endSequence: aNode
	" Private - Leave context for sequence aNode. " """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"sequenceSpace:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#sequenceSpace:
	return self 
""","NativeEncoder_sequenceSpace_")
,"contexts","""sequenceSpace: aNode
	" Private - aNode has been visited in a sequence. " """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"sequenceExit:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#sequenceExit:
	def __blk1__():
		return self.visit_(aNode) 
	self.emmitReturn_(smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeEncoder_sequenceExit_")
,"contexts","""sequenceExit: aNode
	" Private - A block sequence is exiting with aNode. "

	self emmitReturn: [ self visit: aNode ] """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitBlockSequenceNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitBlockSequenceNode:
	smalltalk.basic_at_put(self,"@nestedBlocks",getattr(self,"@nestedBlocks",nil)._plus(smalltalk.Number(1))) 
	if smalltalk.b(aNode.nodes().isEmpty()):
		self.emmitReturn_(smalltalk.String("nil")) 
	else:
		def __blk1__(_s8_rec):
			def __blk2__(each):
				self.visitNode_in_cr_(each,aNode,smalltalk.false) 
				return self.sequenceSpace_(each) 
			def __blk3__(last):
				return self.sequenceExit_(last) 
			_s8_rec.startSequence_(aNode) 
			_s8_rec.visitTemporaries_(aNode) 
			_s8_rec.withNodesIn_do_atEnd_(aNode,smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,1)) 
			return _s8_rec.endSequence_(aNode) 
		__blk1__(self) 
	 
	smalltalk.basic_at_put(self,"@nestedBlocks",getattr(self,"@nestedBlocks",nil)._minus(smalltalk.Number(1))) 
	return self 
""","NativeEncoder_visitBlockSequenceNode_")
,"visiting","""visitBlockSequenceNode: aNode
	" Private - Visit the block sequence emmitting output. "

	nestedBlocks := nestedBlocks + 1.
	aNode nodes isEmpty
	ifTrue: [ self emmitReturn: #nil ]
	ifFalse: [
		self	startSequence: aNode;
			visitTemporaries: aNode;
			withNodesIn: aNode do: [:each|
				self visitNode: each in: aNode cr: false.
				self sequenceSpace: each
			] atEnd: [:last| self sequenceExit: last ];
			endSequence: aNode.
	].
	nestedBlocks := nestedBlocks - 1 """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitSequenceNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitSequenceNode:
	def __blk1__(_s8_rec):
		_s8_rec.startSequence_(aNode) 
		_s8_rec.visitTemporaries_(aNode) 
		_s8_rec.visitNodesIn_cr_(aNode,smalltalk.true) 
		return _s8_rec.endSequence_(aNode) 
	__blk1__(self) 
	return self 
""","NativeEncoder_visitSequenceNode_")
,"visiting","""visitSequenceNode: aNode
	" Private - Visit the sequence emmitting output. "

	self	startSequence: aNode;
		visitTemporaries: aNode;
		visitNodesIn: aNode cr: true;
		endSequence: aNode. """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitExtendedSequenceNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitExtendedSequenceNode:
	def __blk1__(each):
		return self.visitDirectiveNode_(each) 
	aNode.directives().do_(smalltalk.blk(__blk1__,1)) 
	return self.visitSequenceNode_(aNode) 
""","NativeEncoder_visitExtendedSequenceNode_")
,"visiting","""visitExtendedSequenceNode: aNode
	" Private - Visit an extended sequence node. "

	aNode directives do: [:each|
		self visitDirectiveNode: each
	].
	^self visitSequenceNode: aNode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitMacroAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitMacroAssignment:
	return aNode.left().acceptMacroAssignment_with_(aNode.right(),self) 
""","NativeEncoder_visitMacroAssignment_")
,"visiting","""visitMacroAssignment: aNode
	^aNode left acceptMacroAssignment: aNode right with: self""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitMacroAssignment:to:",0
,smalltalk.__f__("""(self,aVariableNode,anExpressionNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeEncoder>>#visitMacroAssignment:to:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				self.visitClassVariableAssignment_in_to_(each,__0__.aClass,anExpressionNode) 
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each,__0__.aName),smalltalk.blk(__blk2__,0),nil) 
		def __blk3__(poolName,pool):
			def __blk4__():
				self.visitPoolVariableAssignment_in_to_(__0__.aName,poolName,anExpressionNode) 
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(pool.includesKey_(__0__.aName),smalltalk.blk(__blk4__,0),nil) 
		__0__.aName=nil
		__0__.aClass=nil
		if smalltalk.b(aVariableNode.indices().notEmpty()):
			smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
		 
		__0__.aName=aVariableNode.value() 
		__0__.aClass=self.currentClass().instanceClass() 
		__0__.aClass.classVariableNamesDo_(smalltalk.blk(__blk1__,1)) 
		__0__.aClass.sharedPoolsAndNamesDo_(smalltalk.blk(__blk3__,2)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeEncoder_visitMacroAssignment_to_")
,"visiting","""visitMacroAssignment: aVariableNode to: anExpressionNode
	" Return true if the receiver generated code to a macro assignment to aVariableNode. "

	| aName aClass |
	aVariableNode indices notEmpty ifTrue: [ ^false ].
	aName := aVariableNode value.
	aClass := self currentClass instanceClass.
	aClass classVariableNamesDo: [:each|
		each = aName ifTrue: [
			self visitClassVariableAssignment: each
				in: aClass
				to: anExpressionNode.
			^true
		]
	].
	aClass sharedPoolsAndNamesDo: [:poolName :pool|
		(pool includesKey: aName) ifTrue: [
			self visitPoolVariableAssignment: aName
				in: poolName
				to: anExpressionNode.
			^true
		].
	].
	^false""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitReceiver:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitReceiver:
	if smalltalk.b(aNode.isAssignment()):
		return self.visitLocalAssignment_(aNode) 
	 
	return self.visit_(aNode) 
""","NativeEncoder_visitReceiver_")
,"visiting","""visitReceiver: aNode
	" Private - Visit the node (as receiver) emmitting output. "

	aNode isAssignment ifTrue: [ ^self visitLocalAssignment: aNode. ].
	^self visit: aNode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitLocalAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitLocalAssignment:
	def __blk1__():
		return self.visit_(aNode) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeEncoder_visitLocalAssignment_")
,"visiting","""visitLocalAssignment: aNode
	" Private - Visit a node that is an assignment in a local expression. "

	self nextArgumentsPut: [ self visit: aNode ] """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitSendArguments:",0
,smalltalk.__f__("""(self,aSendNode):
	#NativeEncoder>>#visitSendArguments:
	def __blk1__(each):
		return self.visitArgument_(each) 
	def __blk2__():
		return self.nextPutAll_(self.argumentsSeparatorOp()) 
	aSendNode.arguments().do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	return self 
""","NativeEncoder_visitSendArguments_")
,"visiting","""visitSendArguments: aSendNode

	aSendNode arguments 
	    do: [:each | self visitArgument: each ]
	    separatedBy: [ self nextPutAll: self argumentsSeparatorOp ].""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitSendNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitSendNode:
	if smalltalk.b(aNode.receiver().isSuper()):
		return self.visitSendToSuper_(aNode) 
	 
	if smalltalk.b(self.visitOptimizedSend_(aNode)):
		return self 
	 
	if smalltalk.b(self.isOperation_(aNode)):
		return self.visitOperation_(aNode) 
	 
	return self.visitNormalSend_(aNode) 
""","NativeEncoder_visitSendNode_")
,"visiting","""visitSendNode: aNode
	" Private - Visit the node (message send node) emmitting output. "

	aNode receiver isSuper ifTrue: [ ^self visitSendToSuper: aNode ].
	(self visitOptimizedSend: aNode) ifTrue: [ ^self ].
	(self isOperation: aNode) ifTrue: [ ^self visitOperation: aNode ].
	^self visitNormalSend: aNode""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitValueNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitValueNode:
	self.nextPutAll_(aNode.value().asNative_(self.nativeLanguage())) 
	return self 
""","NativeEncoder_visitValueNode_")
,"visiting","""visitValueNode: aNode
	" Private - Visit the node emmitting output. "

	self nextPutAll: (aNode value asNative: self nativeLanguage)""",nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitEnterMethod:",0
,smalltalk.__f__("""(self,aMethodNode):
	#NativeEncoder>>#emmitEnterMethod:
	return self.implementedBySubclass_(smalltalk.String("emmitEnterMethod:")) 
""","NativeEncoder_emmitEnterMethod_")
,"generation","""emmitEnterMethod: aMethodNode
	" Private - Generate home context definitions, entering aMethodNode. "

	^self implementedBySubclass: #emmitEnterMethod: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"emmitFunction:node:arguments:doing:",0
,smalltalk.__f__("""(self,fName,aNode,argumentNames,aBlock):
	#NativeEncoder>>#emmitFunction:node:arguments:doing:
	return self.implementedBySubclass_(smalltalk.String("emmitFunction:node:arguments:doing:")) 
""","NativeEncoder_emmitFunction_node_arguments_doing_")
,"generation","""emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock
	" Private - Generate function for aNode. "

	^self implementedBySubclass: #emmitFunction:node:arguments:doing: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"generate:early:return:",0
,smalltalk.__f__("""(self,fName,early,code):
	#NativeEncoder>>#generate:early:return:
	return self.implementedBySubclass_(smalltalk.String("generate:early:return:")) 
""","NativeEncoder_generate_early_return_")
,"generation","""generate: fName early: early return: code
	" Private - Generate code to catch early return of code expression in fName. "

	^self implementedBySubclass: #generate:early:return: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitBlockNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitBlockNode:
	return self.implementedBySubclass_(smalltalk.String("visitBlockNode:")) 
""","NativeEncoder_visitBlockNode_")
,"visiting","""visitBlockNode: aNode

	^self implementedBySubclass: #visitBlockNode: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitReturnNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitReturnNode:
	return self.implementedBySubclass_(smalltalk.String("visitReturnNode:")) 
""","NativeEncoder_visitReturnNode_")
,"visiting","""visitReturnNode: aNode

	^self implementedBySubclass: #visitReturnNode: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitCascadeNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitCascadeNode:
	return self.implementedBySubclass_(smalltalk.String("visitCascadeNode:")) 
""","NativeEncoder_visitCascadeNode_")
,"visiting","""visitCascadeNode: aNode

	^self implementedBySubclass: #visitCascadeNode: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitClassVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aClassVariableName,aClass,anExpressionNode):
	#NativeEncoder>>#visitClassVariableAssignment:in:to:
	return self.implementedBySubclass_(smalltalk.String("visitClassVariableAssignment:in:to:")) 
""","NativeEncoder_visitClassVariableAssignment_in_to_")
,"visiting","""visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode

	^self implementedBySubclass: #visitClassVariableAssignment:in:to: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitPoolVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aName,poolName,anExpressionNode):
	#NativeEncoder>>#visitPoolVariableAssignment:in:to:
	return self.implementedBySubclass_(smalltalk.String("visitPoolVariableAssignment:in:to:")) 
""","NativeEncoder_visitPoolVariableAssignment_in_to_")
,"visiting","""visitPoolVariableAssignment: aName in: poolName to: anExpressionNode

	^self implementedBySubclass: #visitPoolVariableAssignment:in:to: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitDirectiveNode:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitDirectiveNode:
	return self.implementedBySubclass_(smalltalk.String("visitDirectiveNode:")) 
""","NativeEncoder_visitDirectiveNode_")
,"visiting","""visitDirectiveNode: aNode
	" Private - Visit a directive node. "

	^self implementedBySubclass: #visitDirectiveNode: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitMethodNode:",0
,smalltalk.__f__("""(self,aMethodNode):
	#NativeEncoder>>#visitMethodNode:
	return self.implementedBySubclass_(smalltalk.String("visitMethodNode:")) 
""","NativeEncoder_visitMethodNode_")
,"visiting","""visitMethodNode: aMethodNode
	" Visit a method node. "

	^self implementedBySubclass: #visitMethodNode: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitOperation:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitOperation:
	return self.implementedBySubclass_(smalltalk.String("visitOperation:")) 
""","NativeEncoder_visitOperation_")
,"visiting","""visitOperation: aNode
	" Private - aNode is an operation and selector is mapped to target operation. "

	^self implementedBySubclass: #visitOperation: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"isNativeCall:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#isNativeCall:
	return aNode.selector().startsWith_(smalltalk.String("#")) 
""","NativeEncoder_isNativeCall_")
,"query","""isNativeCall: aNode
	" Private - Return true if aNode is a send calling to native function. "

	^aNode selector startsWith: $# """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"encodeNormalSend:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#encodeNormalSend:
	return self.implementedBySubclass_(smalltalk.String("encodeNormalSend:")) 
""","NativeEncoder_encodeNormalSend_")
,"encoding","""encodeNormalSend: aNode
	" Private - Generate code for direct/inlined message send."

	^self implementedBySubclass: #encodeNormalSend: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"encodeSuperSend:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#encodeSuperSend:
	return self.implementedBySubclass_(smalltalk.String("encodeSuperSend:")) 
""","NativeEncoder_encodeSuperSend_")
,"encoding","""encodeSuperSend: aNode
	" Private - Generate code for super message send."

	^self implementedBySubclass: #encodeSuperSend: """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitNormalSend:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitNormalSend:
	self.compilerEvent_with_(smalltalk.String("aboutSend:"),aNode) 
	self.encodeNormalSend_(aNode) 
	self.compilerEvent_with_(smalltalk.String("send:"),aNode) 
	return self 
""","NativeEncoder_visitNormalSend_")
,"visiting","""visitNormalSend: aNode
	" Visit direct/inlined message send."

	self compilerEvent: #aboutSend: with: aNode.
	self encodeNormalSend: aNode.
	self compilerEvent: #send: with: aNode. """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"visitSendToSuper:",0
,smalltalk.__f__("""(self,aNode):
	#NativeEncoder>>#visitSendToSuper:
	self.compilerEvent_with_(smalltalk.String("aboutSend:"),aNode) 
	self.encodeSuperSend_(aNode) 
	self.compilerEvent_with_(smalltalk.String("send:"),aNode) 
	return self 
""","NativeEncoder_visitSendToSuper_")
,"visiting","""visitSendToSuper: aNode
	" Generate code for super message send."

	self compilerEvent: #aboutSend: with: aNode.
	self encodeSuperSend: aNode.
	self compilerEvent: #send: with: aNode. """,nil)
smalltalk.bind(smalltalk.NativeEncoder,"currentMethodInfo",0
,smalltalk.__f__("""(self):
	#NativeEncoder>>#currentMethodInfo
	return smalltalk.object_comma_(smalltalk.object_comma_(self.compiler().currentClass().name(),smalltalk.String(">>#")),self.compiler().selector()) 
""","NativeEncoder_currentMethodInfo")
,"debug","""currentMethodInfo
	" Private - Returns the debug info for current method. "

	^self compiler currentClass name 
		,'>>#' ,self compiler selector""",nil)
smalltalk.bind(smalltalk.JSEncoder.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,aLanguage):
	#JSEncoder class>>#supportsLanguage:
	def __blk1__():
		return smalltalk.newArray(["js","javascript"]).includes_(aLanguage) 
	return smalltalk.boolean_or_(smalltalk.isNil_(aLanguage),smalltalk.blk(__blk1__,0)) 
""","JSEncoder_class_supportsLanguage_")
,"instantiation","""supportsLanguage: aLanguage
	" Private - Return true if instances of the receiver can encode to aLanguage. "

	^aLanguage isNil or: [ #(js javascript) includes: aLanguage ] """,nil)
smalltalk.bind(smalltalk.JSEncoder,"nativeLanguage",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#nativeLanguage
	return smalltalk.String("js") 
""","JSEncoder_nativeLanguage")
,"accessing","""nativeLanguage
	" Return the nativeLanguage of the receiver. "

	^#js """,nil)
smalltalk.bind(smalltalk.JSEncoder,"nativeUndefined",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#nativeUndefined
	return smalltalk.String("undefined") 
""","JSEncoder_nativeUndefined")
,"encoding","""nativeUndefined
	" Private - Return the code for undefined. "

	^#undefined """,nil)
smalltalk.bind(smalltalk.JSEncoder,"nativeNameOfMetaClass:",0
,smalltalk.__f__("""(self,aClass):
	#JSEncoder>>#nativeNameOfMetaClass:
	return smalltalk.object_comma_(aClass.instanceClass().name(),smalltalk.String(".$klass")) 
""","JSEncoder_nativeNameOfMetaClass_")
,"encoding","""nativeNameOfMetaClass: aClass
	" Private - Return the native name for metaclass aClass. "

	^aClass instanceClass name ,'.$klass' """,nil)
smalltalk.bind(smalltalk.JSEncoder,"missingNativeCodeFor:as:",0
,smalltalk.__f__("""(self,aNode,lang):
	#JSEncoder>>#missingNativeCodeFor:as:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('(self.invalidMessage_("'),getattr(self,"@compiler",nil).selector()),smalltalk.String('"))')) 
""","JSEncoder_missingNativeCodeFor_as_")
,"inlines","""missingNativeCodeFor: aNode as: lang
	" Private - Return the native language code for missing expression (or nil). "

	^'(self.invalidMessage_("' ,compiler selector ,'"))'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"defaultRequirementsFor:",0
,smalltalk.__f__("""(self,aClass):
	#JSEncoder>>#defaultRequirementsFor:
	__0__=smalltalk.newContext()
	__0__.constructorName=nil
	__0__.code=nil
	__0__.constructorName=aClass.constructorName() 
	if smalltalk.b(smalltalk.isNil_(__0__.constructorName)):
		return smalltalk.newArray([]) 
	 
	return smalltalk.Array.with_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("if("),__0__.constructorName),smalltalk.String(" && !")),self.smalltalkNameFor_(aClass)),smalltalk.String(') smalltalk.mapClassName("')),aClass.name()),smalltalk.String('","')),aClass.category()),smalltalk.String('",')),__0__.constructorName),smalltalk.String(",")),self.smalltalkNameFor_(aClass.superclass())),smalltalk.String(");"))) 
""","JSEncoder_defaultRequirementsFor_")
,"export","""defaultRequirementsFor: aClass
	" Private - Return the default requirements to load aClass.
	Detect native bindings and generate code to rebind before class definition.
	"

	| constructorName code |
	constructorName := aClass constructorName.
	constructorName isNil ifTrue: [ ^#() ].
	^Array with:
		'if(',constructorName,' && !'
		, (self smalltalkNameFor: aClass)
		,') smalltalk.mapClassName("'
		,aClass name ,'","'
		,aClass category, '",'
		,constructorName, ','
		,(self smalltalkNameFor: aClass superclass)
		,');'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"emmitEnterMethod:",0
,smalltalk.__f__("""(self,aMethodNode):
	#JSEncoder>>#emmitEnterMethod:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String("var self=this;")) 
		return _s8_rec.cr() 
	__blk1__(self) 
	return self 
""","JSEncoder_emmitEnterMethod_")
,"generation","""emmitEnterMethod: aMethodNode
	" Private - Generate home context definitions, entering aMethodNode. "

	self nextPutAll: 'var self=this;'; cr """,nil)
smalltalk.bind(smalltalk.JSEncoder,"emmitFunctionBody:",0
,smalltalk.__f__("""(self,aBlock):
	#JSEncoder>>#emmitFunctionBody:
	self.nextPutAll_(smalltalk.String("{")) 
	aBlock.evaluate() 
	self.nextPutAll_(smalltalk.String("}")) 
	return self 
""","JSEncoder_emmitFunctionBody_")
,"generation","""emmitFunctionBody: aBlock
	" Private - Emmit the code of function body evaluating aBlock. "

	self nextPutAll: ${.
	aBlock evaluate.
	self nextPutAll: $}. """,nil)
smalltalk.bind(smalltalk.JSEncoder,"emmitFunction:node:arguments:doing:",0
,smalltalk.__f__("""(self,fName,aNode,argumentNames,aBlock):
	#JSEncoder>>#emmitFunction:node:arguments:doing:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		self.tempVariables().add_(each) 
		return __0__.aStream.nextPutAll_(self.localName_(each)) 
	def __blk2__():
		return __0__.aStream.nextPutAll_(smalltalk.String(",")) 
	__0__.aStream=nil
	__0__.aStream=smalltalk.String("").writeStream() 
	argumentNames.do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	self.emmitFunction_arguments_doing_(fName,__0__.aStream.contents(),aBlock) 
	return self 
""","JSEncoder_emmitFunction_node_arguments_doing_")
,"generation","""emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock
	" Private - Generate function for aNode. "

	| aStream |
	aStream := '' writeStream.
	argumentNames do: [:each | 
		self tempVariables add: each.
		aStream nextPutAll: (self localName: each) ]
	    separatedBy: [ aStream nextPutAll: ',' ].
	self	emmitFunction: fName
		arguments: aStream contents
		doing: aBlock""",nil)
smalltalk.bind(smalltalk.JSEncoder,"export:method:on:",0
,smalltalk.__f__('''(self,aClass,aMethod,aStream):
	#JSEncoder>>#export:method:on:
	__0__=smalltalk.newContext()
	def __blk1__():
		return aMethod.source().notEmpty() 
	def __blk2__():
		return smalltalk.notNil_(aMethod.stamp()) 
	__0__.fName=nil
	__0__.selectorName=nil
	__0__.bar=nil
	__0__.source=nil
	__0__.source=self.nativeSourceFor_(aMethod) 
	if smalltalk.b(smalltalk.isNil_(__0__.source)):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isNil_(aMethod)):
		self.error_(smalltalk.String("Method is missing")) 
	 
	__0__.bar=smalltalk.asString_(smalltalk.String('"')) 
	__0__.fName=aMethod.selector() 
	if smalltalk.b(__0__.fName.first().isBackSlash()):
		__0__.selectorName=self.escaped_(aMethod.selector()) 
		__0__.fName=self.escaped_(self.asSelector_(__0__.fName)) 
	else:
		def __blk3__():
			__0__.fName=smalltalk.String("0")
			return __0__.fName 
		def __blk4__():
			__0__.fName=smalltalk.object_comma_(smalltalk.object_comma_(__0__.bar,self.asSelector_(__0__.fName)),__0__.bar)
			return __0__.fName 
		__0__.selectorName=smalltalk.object_comma_(smalltalk.object_comma_(__0__.bar,aMethod.selector()),__0__.bar) 
		smalltalk.if_true_false_(smalltalk.isObject_equalTo_(self.asSelector_(__0__.fName),aMethod.selector().replace_with_(smalltalk.String(":"),smalltalk.String("_"))),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
	 
	aStream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.bind("),self.smalltalkNameFor_(aClass)),smalltalk.String(",")),__0__.selectorName),smalltalk.String(",")),__0__.fName),smalltalk.String("""
	,""")),__0__.source)) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aMethod.source()),smalltalk.blk(__blk1__,0))):
		def __blk5__(_s8_rec):
			_s8_rec.cr() 
			return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aMethod.category())),smalltalk.String(",")),self.escaped_(aMethod.source()))) 
		__blk5__(aStream) 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.responds_to_(aMethod,(smalltalk.String("stamp"))),smalltalk.blk(__blk2__,0))):
		aStream.nextPutAll_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aMethod.stamp()))) 
	 
	aStream.nextPutAll_(smalltalk.String(""");
	""")) 
	return self 
''',"JSEncoder_export_method_on_")
,"export","""export: aClass method: aMethod on: aStream
	" Export a method definition of aClass onto aStream. "

	| fName selectorName bar source |
	source := self nativeSourceFor: aMethod.
	source isNil ifTrue: [ ^false ].
	aMethod isNil ifTrue: [ self error: 'Method is missing' ].
	bar := $" asString.
	fName := aMethod selector.
	fName first isBackSlash ifTrue: [
		selectorName := self escaped: aMethod selector.
		fName := self escaped: (self asSelector: fName).
	] ifFalse: [
		selectorName := bar ,aMethod selector, bar.
		(self asSelector: fName) = (aMethod selector replace: $: with: $_) ifTrue: [
			fName := '0' "we exploit the fact that 0 isNil to signal a compact selector"
		] ifFalse: [
			fName := bar ,(self asSelector: fName) ,bar
		].
	].
	aStream
		nextPutAll: 'smalltalk.bind(' ,(self smalltalkNameFor: aClass)
			,',' ,selectorName ,',' ,fName ,'
,'			,source.
	(aMethod source notNil and: [ aMethod source notEmpty ]) ifTrue: [
	    aStream cr; "warning: this cr is important for debugger"
		nextPutAll: ',' ,(self escaped: aMethod category)
			,',' ,(self escaped: aMethod source).
	].
	((aMethod respondsTo: #stamp) and: [ aMethod stamp notNil ]) ifTrue: [
		aStream nextPutAll: ',' ,(self escaped: aMethod stamp)
	].
	aStream nextPutAll: ');
'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"exportDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#JSEncoder>>#exportDefinitionOf:on:
	def __blk1__(each):
		def __blk2__():
			def __blk3__(_s8_rec):
				_s8_rec.nextPutAll_(each) 
				return _s8_rec.cr() 
			return __blk3__(aStream) 
		def __blk4__():
			return aStream.fileOutOn_(aStream) 
		return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk4__,0)) 
	def __blk5__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk.addClass("'),aClass.name()),smalltalk.String('",'))) 
		_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass.superclass())) 
		return _s8_rec.nextPutAll_(smalltalk.String(",")) 
	def __blk6__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"'),aClass.category()),smalltalk.String('"'))) 
		_s8_rec.nextPutAll_(smalltalk.String(");")) 
		return _s8_rec.cr() 
	def __blk7__():
		return aClass.comment().notEmpty() 
	self.loadRequirementsOf_(aClass).do_(smalltalk.blk(__blk1__,1)) 
	__blk5__(aStream) 
	self.exportArrayLiteral_on_newLine_(aClass.instanceVariableNames(),aStream,smalltalk.false) 
	__blk6__(aStream) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aClass.comment()),smalltalk.blk(__blk7__,0))):
		def __blk8__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String(".$comment="),self.escaped_(aClass.comment()))) 
			_s8_rec.nextPutAll_(smalltalk.String(";")) 
			return _s8_rec.cr() 
		__blk8__(aStream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.classVariables())):
		def __blk9__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String(".$classVariableNames="),self.escaped_(aClass.classVariablesString()))) 
			_s8_rec.nextPutAll_(smalltalk.String(";")) 
			return _s8_rec.cr() 
		__blk9__(aStream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.poolDictionaries())):
		def __blk10__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
			return _s8_rec.nextPutAll_(smalltalk.String(".$poolDictionaries=")) 
		__blk10__(aStream) 
		self.exportArrayLiteral_on_newLine_(aClass.poolDictionaries(),aStream,smalltalk.true) 
	 
	if smalltalk.b(aClass.propertyNames().notEmpty()):
		def __blk11__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
			return _s8_rec.nextPutAll_(smalltalk.String(".$propertyNames=")) 
		__blk11__(aStream) 
		self.exportArrayLiteral_on_newLine_(aClass.propertyNames(),aStream,smalltalk.true) 
	 
	return self 
""","JSEncoder_exportDefinitionOf_on_")
,"export","""exportDefinitionOf: aClass on: aStream
	" Export definition of aClass onto aStream. "

	(self loadRequirementsOf: aClass) do: [:each|
		each isString
		ifTrue: [ aStream nextPutAll: each;cr ]
		ifFalse: [ aStream fileOutOn: aStream ].
	].
	aStream 
	    nextPutAll: 'smalltalk.addClass("', aClass name, '",';
	    nextPutAll: (self smalltalkNameFor: aClass superclass);
	    nextPutAll: ','.
	self exportArrayLiteral: aClass instanceVariableNames on: aStream newLine: false.
	aStream
	    nextPutAll: ',"' ,aClass category, $";
	    nextPutAll: ');'; cr.
	(aClass comment notNil and: [aClass comment notEmpty]) ifTrue: [
	    aStream
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.$comment=' ,(self escaped: aClass comment);
		nextPutAll: ';'; cr
	].
	aClass classVariables notNil ifTrue: [
	    aStream
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.$classVariableNames=' ,(self escaped: aClass classVariablesString);
		nextPutAll: ';'; cr
	].
	aClass poolDictionaries notNil ifTrue: [
	    aStream
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.$poolDictionaries='.
	   self exportArrayLiteral: aClass poolDictionaries on: aStream newLine: true.
	].
	aClass propertyNames notEmpty ifTrue: [
	    aStream
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.$propertyNames='.
	   self exportArrayLiteral: aClass propertyNames on: aStream newLine: true.
	].""",nil)
smalltalk.bind(smalltalk.JSEncoder,"exportMetaDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#JSEncoder>>#exportMetaDefinitionOf:on:
	if smalltalk.b((aClass).__class__.instanceVariableNames().notEmpty()):
		def __blk1__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_((aClass).__class__)) 
			return _s8_rec.nextPutAll_(smalltalk.String(".$iVarNames=")) 
		__blk1__(aStream) 
		self.exportArrayLiteral_on_newLine_((aClass).__class__.instanceVariableNames(),aStream,smalltalk.true) 
	 
	if smalltalk.b((aClass).__class__.propertyNames().notEmpty()):
		def __blk2__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_((aClass).__class__)) 
			return _s8_rec.nextPutAll_(smalltalk.String(".$propertyNames=")) 
		__blk2__(aStream) 
		self.exportArrayLiteral_on_newLine_((aClass).__class__.propertyNames(),aStream,smalltalk.true) 
	 
	return self 
""","JSEncoder_exportMetaDefinitionOf_on_")
,"export","""exportMetaDefinitionOf: aClass on: aStream
	" Export class side definition of aClass onto aStream. "

	aClass class instanceVariableNames notEmpty ifTrue: [
		aStream 
			nextPutAll: (self smalltalkNameFor: aClass class);
			nextPutAll: '.$iVarNames='.
		self exportArrayLiteral: aClass class instanceVariableNames on: aStream newLine: true.
	].

	aClass class propertyNames notEmpty ifTrue: [
		aStream 
			nextPutAll: (self smalltalkNameFor: aClass class);
			nextPutAll: '.$propertyNames='.
		self exportArrayLiteral: aClass class propertyNames on: aStream newLine: true.
	].""",nil)
smalltalk.bind(smalltalk.JSEncoder,"sourceToTry:",0
,smalltalk.__f__('''(self,sourceCode):
	#JSEncoder>>#sourceToTry:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("try"),smalltalk.String("{")),sourceCode),smalltalk.String("}")),smalltalk.String(""" catch($$e) {
		if ($$e.directiveError) { return(this.error_($$e.directiveError)); }
		if (!$$e.directiveFailed) { throw($$e); } }""")) 
''',"JSEncoder_sourceToTry_")
,"directives","""sourceToTry: sourceCode
	" Return the code to emmit to try execution of sourceCode. "

	^'try' ,${ ,sourceCode ,$} ,' catch($$e) {
	if ($$e.directiveError) { return(this.error_($$e.directiveError)); }
	if (!$$e.directiveFailed) { throw($$e); } }'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"sourceToDirectCall:with:",0
,smalltalk.__f__("""(self,nativeSelector,arg):
	#JSEncoder>>#sourceToDirectCall:with:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("return this."),nativeSelector),smalltalk.String("(")),arg),smalltalk.String(",")),smalltalk.String("arguments")),smalltalk.String(");")) 
""","JSEncoder_sourceToDirectCall_with_")
,"directives","""sourceToDirectCall: nativeSelector with: arg
	" Return the code to emmit to direct native call to selector with argument. "

	^'return this.' ,nativeSelector ,'(' ,arg ,',' ,'arguments' ,');' """,nil)
smalltalk.bind(smalltalk.JSEncoder,"generate:early:return:",0
,smalltalk.__f__("""(self,fName,early,code):
	#JSEncoder>>#generate:early:return:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(__0__.prev) 
		_s8_rec.nextPutAll_(code) 
		return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("}"),smalltalk.String(" catch($$ex) {if($$ex === $s8Ret$)")),smalltalk.String("{"))) 
	__0__.prev=nil
	if not smalltalk.b(early):
		self.nextPutAll_(code) 
		return smalltalk.Number(0) 
	 
	__0__.prev=smalltalk.object_comma_(smalltalk.String('var $s8Ret$={name:"stReturn"};try'),smalltalk.String("{")) 
	__blk1__(self) 
	self.emmitReturn_early_(smalltalk.String("$$ex.result"),smalltalk.true) 
	self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("}"),smalltalk.String(" throw($$ex);")),smalltalk.String("}"))) 
	return __0__.prev.size() 
""","JSEncoder_generate_early_return_")
,"generation","""generate: fName early: early return: code
	" Private - Generate code to catch early return of code expression in fName. "

	| prev |
	early ifFalse: [ self nextPutAll: code. ^0 ].
	prev := 'var $s8Ret$={name:"stReturn"};try' ,${.
	self	nextPutAll: prev;
		nextPutAll: code;
		nextPutAll: $} ,' catch($$ex) {if($$ex === $s8Ret$)' ,${.
	self emmitReturn: '$$ex.result' early: true.
	self nextPutAll: $} ,' throw($$ex);' ,$}.
	^prev size""",nil)
smalltalk.bind(smalltalk.JSEncoder,"newMethodFunctionName",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#newMethodFunctionName
	return smalltalk.String("smalltalk.newMethod") 
""","JSEncoder_newMethodFunctionName")
,"generation","""newMethodFunctionName
	" Private - Return the function to call when installing a new method. "

	^'smalltalk.newMethod'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitBlockNode:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#visitBlockNode:
	def __blk1__():
		def __blk2__():
			return self.visitNodesIn_cr_(aNode,smalltalk.false) 
		return self.emmitFunction_node_arguments_doing_(smalltalk.String(""),aNode,aNode.parameterNames(),smalltalk.blk(__blk2__,0)) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","JSEncoder_visitBlockNode_")
,"visiting","""visitBlockNode: aNode

	self nextArgumentsPut: [
		self	emmitFunction: '' node: aNode
			arguments: aNode parameterNames
			doing: [ self visitNodesIn: aNode cr: false ]
	] """,nil)
smalltalk.bind(smalltalk.JSEncoder,"visitCascadeNode:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#visitCascadeNode:
	def __blk1__():
		def __blk2__():
			__2__=smalltalk.newContext()
			def __blk3__(each):
				def __blk4__(_s8_rec):
					_s8_rec.value_(smalltalk.String("$rec")) 
					return _s8_rec.start_end_(each.start(),each.start()) 
				__2__.index=__2__.index._plus(smalltalk.Number(1)) 
				if smalltalk.b(smalltalk.isObject_equalTo_(__2__.index,aNode.nodes().size())):
					self.emmitReturn_(nil) 
				 
				__2__.rec=smalltalk.VariableNode.new() 
				__blk4__(__2__.rec) 
				each.receiver_(__2__.rec) 
				self.visit_(each) 
				if smalltalk.b(smalltalk.isObject_equalTo_(__2__.index,aNode.nodes().size())):
					self.compilerEvent_withArguments_(smalltalk.String("returned:early:"),smalltalk.Array.with_with_(nil,smalltalk.false)) 
				 
				return self.nextPutAll_(smalltalk.String(";")) 
			__2__.index=nil
			__2__.rec=nil
			__2__.index=smalltalk.Number(0) 
			return aNode.nodes().do_(smalltalk.blk(__blk3__,1)) 
		return self.emmitFunction_arguments_doing_(smalltalk.String(""),smalltalk.String("$rec"),smalltalk.blk(__blk2__,0)) 
	def __blk5__():
		return self.visit_(aNode.receiver()) 
	if not smalltalk.b(self.tempVariables().includes_(smalltalk.String("$rec"))):
		self.tempVariables().add_(smalltalk.String("$rec")) 
	 
	self.compilerEvent_with_(smalltalk.String("aboutCascade:"),aNode) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	self.nextArgumentsPut_(smalltalk.blk(__blk5__,0)) 
	self.compilerEvent_with_(smalltalk.String("cascade:"),aNode) 
	return self 
""","JSEncoder_visitCascadeNode_")
,"visiting","""visitCascadeNode: aNode

	(self tempVariables includes: '$rec') ifFalse: [ self tempVariables add: '$rec' ].
	self compilerEvent: #aboutCascade: with: aNode.
	self nextArgumentsPut: [
		self emmitFunction: '' arguments: '$rec' doing: [ | index rec |
			index := 0.
			aNode nodes do: [:each |
			    index := index + 1.
			    index = aNode nodes size ifTrue: [ self emmitReturn: nil ].
			    rec := VariableNode new.
			    rec value: '$rec'; start: each start end: each start.
			    each receiver: rec.
			    self visit: each.
			    index = aNode nodes size ifTrue: [
				self compilerEvent: #returned:early: withArguments: (Array with: nil with: false)
			    ].
			    self nextPutAll: ';'
			].
		]
	].
	self nextArgumentsPut: [ self visit: aNode receiver ].
	self compilerEvent: #cascade: with: aNode.""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitClassVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aClassVariableName,aClass,anExpressionNode):
	#JSEncoder>>#visitClassVariableAssignment:in:to:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
		_s8_rec.nextPutAll_(smalltalk.String('.classVariableAt_put_("')) 
		_s8_rec.nextPutAll_(aClassVariableName) 
		return _s8_rec.nextPutAll_(smalltalk.String('",')) 
	__blk1__(self) 
	self.visit_(anExpressionNode) 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","JSEncoder_visitClassVariableAssignment_in_to_")
,"visiting","""visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode

	self
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.classVariableAt_put_("';
		nextPutAll: aClassVariableName;
		nextPutAll: '",'.
	self visit: anExpressionNode.
	self	nextPutAll: ')'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitDirectiveNode:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#visitDirectiveNode:
	if smalltalk.b(smalltalk.responds_to_(aNode,(smalltalk.String("asNative:for:on:")))):
		__1__=smalltalk.newContext()
		def __blk1__():
			def __blk2__(_s8_rec):
				_s8_rec.nextPutAll_(__1__.code) 
				return _s8_rec.cr() 
			return __blk2__(self) 
		__1__.code=nil
		__1__.code=aNode.asNative_for_on_(getattr(self,"@functionName",nil),self,getattr(self,"@stream",nil)) 
		return smalltalk.if_true_false_(smalltalk.notNil_(__1__.code),smalltalk.blk(__blk1__,0),nil) 
	 
	self.visitNode_in_cr_(aNode,nil,smalltalk.true) 
	return self 
""","JSEncoder_visitDirectiveNode_")
,"visiting","""visitDirectiveNode: aNode
	" Private - Visit a directive node. "

	(aNode respondsTo: #asNative:for:on:) ifTrue: [
		| code |
		code := aNode
			asNative: functionName
			for: self on: stream.
		^code notNil ifTrue: [
			self nextPutAll: code; cr
		]
	].
	self visitNode: aNode in: nil cr: true""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitGlobalReferenceNode:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#JSEncoder>>#visitGlobalReferenceNode:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				def __blk3__(_s8_rec):
					_s8_rec.nextPutAll_(self.smalltalkNameFor_(__0__.aClass)) 
					_s8_rec.nextPutAll_(smalltalk.String('.classVariableAt_("')) 
					_s8_rec.nextPutAll_(__0__.aName) 
					return _s8_rec.nextPutAll_(smalltalk.String('")')) 
				__blk3__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each,__0__.aName),smalltalk.blk(__blk2__,0),nil) 
		def __blk4__(poolName,pool):
			def __blk5__():
				def __blk6__(_s8_rec):
					_s8_rec.nextPutAll_(smalltalk.String('smalltalk.poolDictionary_("')) 
					_s8_rec.nextPutAll_(poolName) 
					_s8_rec.nextPutAll_(smalltalk.String('").at_("')) 
					_s8_rec.nextPutAll_(__0__.aName) 
					return _s8_rec.nextPutAll_(smalltalk.String('")')) 
				__blk6__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			return smalltalk.if_true_false_(pool.includesKey_(__0__.aName),smalltalk.blk(__blk5__,0),nil) 
		def __blk7__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String("smalltalk.")) 
			return _s8_rec.nextPutAll_(aNode.value()) 
		__0__.aName=nil
		__0__.aClass=nil
		__0__.lookupPools=nil
		__0__.aName=aNode.value() 
		__0__.aClass=self.currentClass().instanceClass() 
		__0__.aClass.classVariableNamesDo_(smalltalk.blk(__blk1__,1)) 
		__0__.aClass.sharedPoolsAndNamesDo_(smalltalk.blk(__blk4__,2)) 
		__blk7__(self) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","JSEncoder_visitGlobalReferenceNode_")
,"visiting","""visitGlobalReferenceNode: aNode

	| aName aClass lookupPools |
	aName := aNode value.
	aClass := self currentClass instanceClass.
	aClass classVariableNamesDo: [:each|
		each = aName ifTrue: [
			self
				nextPutAll: (self smalltalkNameFor: aClass);
				nextPutAll: '.classVariableAt_("';
				nextPutAll: aName;
				nextPutAll: '")'.
			^self
		]
	].
	aClass sharedPoolsAndNamesDo: [:poolName :pool|
		(pool includesKey: aName) ifTrue: [
			self
				nextPutAll: 'smalltalk.poolDictionary_("';
				nextPutAll: poolName;
				nextPutAll: '").at_("';
				nextPutAll: aName;
				nextPutAll: '")'.
			^self
		].
	].
	self
		nextPutAll: 'smalltalk.';
		nextPutAll: aNode value.""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitMethodNode:",0
,smalltalk.__f__("""(self,aMethodNode):
	#JSEncoder>>#visitMethodNode:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(self.newMethodFunctionName(),smalltalk.String("("))) 
		_s8_rec.nextPutAll_(self.smalltalkNameFor_(self.currentClass())) 
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"'),aMethodNode.selector()),smalltalk.String('",'))) 
		return _s8_rec.cr() 
	__blk1__(self) 
	self.emmitMethod_(aMethodNode) 
	if smalltalk.b(self.includeSourceCode()):
		def __blk2__(_s8_rec):
			_s8_rec.cr() 
			return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aMethodNode.source()))) 
		__blk2__(self) 
	 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","JSEncoder_visitMethodNode_")
,"visiting","""visitMethodNode: aMethodNode
	" Visit a method node. "

	self
		nextPutAll: self newMethodFunctionName, '(';
		nextPutAll: (self smalltalkNameFor: self currentClass);
		nextPutAll: ',"', aMethodNode selector, '",'; cr.
	self emmitMethod: aMethodNode.
	self includeSourceCode ifTrue: [
		self	cr; "warning: this cr is important for debugger"
			nextPutAll: ',' ,(self escaped: aMethodNode source)
	].
	self nextPutAll: ')'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitNode:index:",0
,smalltalk.__f__("""(self,aNode,index):
	_s8Ret_=smalltalk.newContext()
	try:
		#JSEncoder>>#visitNode:index:
		__0__=smalltalk.newContext()
		def __blk1__():
			return index.hasString() 
		def __blk2__():
			return self.visit_(index) 
		__0__.selector=nil
		if smalltalk.b(smalltalk.boolean_and_(index.isMemberOf_(smalltalk.ValueNode),smalltalk.blk(__blk1__,0))):
			def __blk3__():
				return __0__.selector.includes_(smalltalk.String("_")) 
			def __blk4__():
				def __blk5__(_s8_rec):
					_s8_rec.nextPutAll_(smalltalk.String(".")) 
					return _s8_rec.nextPutAll_(__0__.selector) 
				__blk5__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			__0__.selector=self.asSelector_(index.value()) 
			smalltalk.if_true_false_(smalltalk.boolean_or_(__0__.selector.includes_(smalltalk.String(" ")),smalltalk.blk(__blk3__,0)),nil,smalltalk.blk(__blk4__,0)) 
		 
		self.nextIndexPut_(smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","JSEncoder_visitNode_index_")
,"visiting","""visitNode: aNode index: index
	" Private - Generate code for indexed access. "

	| selector |
	((index isMemberOf: ValueNode) and: [ index hasString ]) ifTrue: [
		selector := self asSelector: index value.
		((selector includes: $ ) or: [ selector includes: $_ ]) ifFalse: [
			self nextPutAll: $.; nextPutAll: selector.
			^self
		].
	].
	self nextIndexPut: [ self visit: index ] """,nil)
smalltalk.bind(smalltalk.JSEncoder,"messageSendConnector",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#messageSendConnector
	return smalltalk.String(".") 
""","JSEncoder_messageSendConnector")
,"encoding","""messageSendConnector
	" Private - Return the connector to use for sending a message. "

	^$. """,nil)
smalltalk.bind(smalltalk.JSEncoder,"messageSendConnector:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#messageSendConnector:
	if smalltalk.b(smalltalk.isNil_(aNode.receiver().messageSendConnector())):
		return smalltalk.String("") 
	 
	return self.messageSendConnector() 
""","JSEncoder_messageSendConnector_")
,"encoding","""messageSendConnector: aNode
	" Private - Return the connector to use for sending message. "

	aNode receiver messageSendConnector isNil ifTrue: [ ^'' ].
	^self messageSendConnector """,nil)
smalltalk.bind(smalltalk.JSEncoder,"encodeNormalSend:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#encodeNormalSend:
	def __blk1__(_s8_rec):
		def __blk2__():
			return self.visitSendArguments_(aNode) 
		_s8_rec.visitReceiver_(aNode.receiver()) 
		_s8_rec.nextPutAll_(self.messageSendConnector_(aNode)) 
		_s8_rec.nextPutAll_(self.asSelector_(aNode.selector())) 
		return _s8_rec.nextArgumentsPut_(smalltalk.blk(__blk2__,0)) 
	__blk1__(self) 
	return self 
""","JSEncoder_encodeNormalSend_")
,"encoding","""encodeNormalSend: aNode
	" Private - Generate code for message send. "

	self	visitReceiver: aNode receiver;
		nextPutAll: (self messageSendConnector: aNode);
		nextPutAll: (self asSelector: aNode selector);
		nextArgumentsPut: [ self visitSendArguments: aNode ] """,nil)
smalltalk.bind(smalltalk.JSEncoder,"visitOperation:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#visitOperation:
	def __blk1__():
		return self.visitReceiver_(aNode.receiver()) 
	self.compilerEvent_with_(smalltalk.String("aboutOperation:"),aNode) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	self.nextPutAll_(self.asSelector_(aNode.selector())) 
	self.visitSendArguments_(aNode) 
	self.compilerEvent_with_(smalltalk.String("operation:"),aNode) 
	return self 
""","JSEncoder_visitOperation_")
,"visiting","""visitOperation: aNode
	" Private - aNode is an operation and selector is mapped to target operation. "

	self compilerEvent: #aboutOperation: with: aNode.
	self nextArgumentsPut: [ self visitReceiver: aNode receiver ].
	self nextPutAll: (self asSelector: aNode selector).
	self visitSendArguments: aNode.
	self compilerEvent: #operation: with: aNode.""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitPoolVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aName,poolName,anExpressionNode):
	#JSEncoder>>#visitPoolVariableAssignment:in:to:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String('smalltalk.poolDictionary_("')) 
		_s8_rec.nextPutAll_(poolName) 
		_s8_rec.nextPutAll_(smalltalk.String('").at_put_("')) 
		_s8_rec.nextPutAll_(aName) 
		return _s8_rec.nextPutAll_(smalltalk.String('",')) 
	__blk1__(self) 
	self.visit_(anExpressionNode) 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","JSEncoder_visitPoolVariableAssignment_in_to_")
,"visiting","""visitPoolVariableAssignment: aName in: poolName to: anExpressionNode

	self
		nextPutAll: 'smalltalk.poolDictionary_("';
		nextPutAll: poolName; nextPutAll: '").at_put_("';
		nextPutAll: aName; nextPutAll: '",'.
	self visit: anExpressionNode.
	self	nextPutAll: ')'""",nil)
smalltalk.bind(smalltalk.JSEncoder,"visitReturnNode:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#visitReturnNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			def __blk3__(each):
				return self.visit_(each) 
			return aNode.nodes().do_(smalltalk.blk(__blk3__,1)) 
		return self.emmitReturn_(smalltalk.blk(__blk2__,0)) 
	def __blk4__(_s8_rec):
		def __blk5__():
			def __blk6__():
				def __blk7__(_s8_rec):
					def __blk8__():
						return self.emmitFunctionDoing_(__0__.theReturn) 
					def __blk9__():
						nil 
					_s8_rec.nextArgumentsPut_(smalltalk.blk(__blk8__,0)) 
					return _s8_rec.nextArgumentsPut_(smalltalk.blk(__blk9__,0)) 
				self.nextPutAll_(smalltalk.String("$s8Ret$.result=")) 
				__blk7__(self) 
				return self.nextPutAll_(smalltalk.String(";throw($s8Ret$)")) 
			return self.emmitFunctionDoing_(smalltalk.blk(__blk6__,0)) 
		def __blk10__():
			nil 
		_s8_rec.nextArgumentsPut_(smalltalk.blk(__blk5__,0)) 
		return _s8_rec.nextArgumentsPut_(smalltalk.blk(__blk10__,0)) 
	__0__.theReturn=nil
	if smalltalk.b(getattr(self,"@nestedBlocks",nil)._gt(smalltalk.Number(0))):
		smalltalk.basic_at_put(self,"@earlyReturn",smalltalk.true) 
	 
	__0__.theReturn=smalltalk.blk(__blk1__,0) 
	if not smalltalk.b(getattr(self,"@earlyReturn",nil)):
		return __0__.theReturn.value() 
	 
	__blk4__(self) 
	return self 
""","JSEncoder_visitReturnNode_")
,"visiting","""visitReturnNode: aNode

	| theReturn |
	nestedBlocks > 0 ifTrue: [ earlyReturn := true ].
	theReturn := [ self emmitReturn: [
		aNode nodes do: [:each | self visit: each ]
	] ].
	earlyReturn ifFalse: [ ^theReturn value ].
	self nextArgumentsPut: [
		self emmitFunctionDoing: [
			self nextPutAll: '$s8Ret$.result='.
			self nextArgumentsPut: [
				self emmitFunctionDoing: theReturn.
			]; nextArgumentsPut: [].
			self nextPutAll: ';throw($s8Ret$)'
		]
	]; nextArgumentsPut: [] """,nil)
smalltalk.bind(smalltalk.JSEncoder,"encodeSuperSend:",0
,smalltalk.__f__("""(self,aNode):
	#JSEncoder>>#encodeSuperSend:
	def __blk1__():
		return self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.smalltalkNameFor_(self.currentClass()),smalltalk.String(',"')),self.asSelector_(aNode.selector())),smalltalk.String('"'))) 
	def __blk2__():
		return self.visitSendArguments_(aNode) 
	self.nextPutAll_(smalltalk.String("smalltalk.superImplementor")) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	self.nextPutAll_(smalltalk.String(".apply(self, ")) 
	self.nextIndexPut_(smalltalk.blk(__blk2__,0)) 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","JSEncoder_encodeSuperSend_")
,"encoding","""encodeSuperSend: aNode
	" Private - Generate code for super message send."

	self nextPutAll: 'smalltalk.superImplementor'.
	self nextArgumentsPut: [
		self nextPutAll:
			(self smalltalkNameFor: self currentClass)
			,',"',(self asSelector: aNode selector) ,$"
	].
	self nextPutAll: '.apply(self, '.
	self nextIndexPut: [ self visitSendArguments: aNode ].
	self nextPutAll: ')'. """,nil)
smalltalk.bind(smalltalk.JSEncoder,"coreOptimizations",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#coreOptimizations
	return smalltalk.newArray(["core",[["class","%receiver%.$klass"],["isNil","(nil.isNil_(%receiver%))"],["notNil","(nil.isNil_(%receiver%)===false)"],["==","(nil.is_eqeq_(%receiver%,%arg1%))"],["===","(%receiver% === %arg1%)"],["||","(%receiver% || %arg1%)"],["basicAt:","((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return nil;return $1$;})())"],["ifUndefined:","hasBlockNoArguments:",'(function(){var $1$=(%receiver%);if (typeof($1$)=="undefined") return %arg1%();return $1$;})()'],["basicAt:ifAbsent:","((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return (%arg2%.value());return $1$;})())"],["basicAt:put:","(%receiver%[%arg1%]=(%arg2%))"]]]) 
""","JSEncoder_coreOptimizations")
,"optimization","""coreOptimizations
	" Private - Return the optimization set. "

	^#(core  #(
		#(class	'%receiver%.$klass' )
		#(isNil	'(nil.isNil_(%receiver%))' )
		#(notNil '(nil.isNil_(%receiver%)===false)' )
		#(==	'(nil.is_eqeq_(%receiver%,%arg1%))' )
		#(===	'(%receiver% === %arg1%)' )
		#(||	'(%receiver% || %arg1%)' )
		#(basicAt: '((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return nil;return $1$;})())' )
		#(ifUndefined: hasBlockNoArguments: '(function(){var $1$=(%receiver%);if (typeof($1$)=="undefined") return %arg1%();return $1$;})()' )
		#(basicAt:ifAbsent: '((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return (%arg2%.value());return $1$;})())' )
		#(basicAt:put: '(%receiver%[%arg1%]=(%arg2%))' )
	))""",nil)
smalltalk.bind(smalltalk.JSEncoder,"s8Optimizations",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#s8Optimizations
	return smalltalk.newArray(["s8",["core",["ifTrue:","hasBlockNoArguments:",[["ifTrue:","noClient:","if (%receiver%){%seq1%};"],["ifTrue:","((%receiver%).mustBeBoolean()==true ? %arg1%() : nil)"]]],["ifFalse:","hasBlockNoArguments:",[["ifFalse:","noClient:","if (!(%receiver%)){%seq1%};"],["ifFalse:","((%receiver%).mustBeBoolean()==true ? nil : %arg1%())"]]],["ifTrue:ifFalse:","hasBlockNoArguments:",[["ifTrue:ifFalse:","noClient:","if (%receiver%){%seq1%} else{%seq2%};"],["ifTrue:ifFalse:","((%receiver%).mustBeBoolean()==true ? %arg1%() : %arg2%())"]]],["ifFalse:ifTrue:","hasBlockNoArguments:",[["ifFalse:ifTrue:","noClient:","if (%receiver%){%seq2%} else{%seq1%};"],["ifFalse:ifTrue:","((%receiver%).mustBeBoolean()==true ? %arg2%() : %arg1%())"]]],["whileTrue","receiverIsBlockNoArguments:","(function(){while(%receiver%()){};return nil})()"],["whileFalse","receiverIsBlockNoArguments:","(function(){while(!%receiver%()){};return nil})()"],["orNil","(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? nil : $1$;})()"],["whileTrue:","allBlockNoArguments:",[["whileTrue:","noClient:","while(%receiver%()){%seq1%};"],["whileTrue:","(function(){while(%receiver%()){%arg1%()};return nil})()"]]],["whileFalse:","allBlockNoArguments:",[["whileFalse:","noClient:","while(!%receiver%()){%seq1%};"],["whileFalse:","(function(){while(!%receiver%()){%arg1%()};return nil})()"]]],["ifNil:","hasBlockArguments:","(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? %arg1%() : $1$;})()"],["ifNotNil:","hasBlockArguments:","(function(){var $1$=(%receiver%);return (nil.isNil_($1$)===false) ? %arg1%() : $1$;})()"],["timesRepeat:","hasBlockNoArguments:","(function(){for(var $1$=(%receiver%);$1$>0;$1$--){%arg1%()};return nil})()"],["isKindOf:","smalltalk.is_kindOf_(%receiver%,(%arg1%))"],["respondsTo:","smalltalk.responds_to_(%receiver%,(%arg1%))"],["ifNil:ifNotNil:","hasBlockNoArguments:","(nil.isNil_(%receiver%)) ? %arg1%() : %arg2%()"],["ifNotNil:ifNil:","hasBlockNoArguments:","(nil.isNil_(%receiver%)===false) ? %arg1%() : %arg2%()"]]]) 
""","JSEncoder_s8Optimizations")
,"optimization","""s8Optimizations
	" Private - Return the optimization set. "

	^#(s8	#(
		core
		#(ifTrue: hasBlockNoArguments: #(
			#(ifTrue: noClient: 'if (%receiver%){%seq1%};' )
			#(ifTrue: '((%receiver%).mustBeBoolean()==true ? %arg1%() : nil)' )
		))
		#(ifFalse: hasBlockNoArguments:  #(
			#(ifFalse: noClient: 'if (!(%receiver%)){%seq1%};' )
			#(ifFalse: '((%receiver%).mustBeBoolean()==true ? nil : %arg1%())' )
		))
		#(ifTrue:ifFalse: hasBlockNoArguments: #(
			#(ifTrue:ifFalse: noClient: 'if (%receiver%){%seq1%} else{%seq2%};' )
			#(ifTrue:ifFalse: '((%receiver%).mustBeBoolean()==true ? %arg1%() : %arg2%())' )
		))
		#(ifFalse:ifTrue: hasBlockNoArguments: #(
			#(ifFalse:ifTrue: noClient: 'if (%receiver%){%seq2%} else{%seq1%};' )
			#(ifFalse:ifTrue: '((%receiver%).mustBeBoolean()==true ? %arg2%() : %arg1%())' )
		))
		#(whileTrue receiverIsBlockNoArguments: '(function(){while(%receiver%()){};return nil})()' )
		#(whileFalse receiverIsBlockNoArguments: '(function(){while(!%receiver%()){};return nil})()' )
		#(orNil '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? nil : $1$;})()' )
		#(whileTrue: allBlockNoArguments: #(
			#(whileTrue: noClient: 'while(%receiver%()){%seq1%};' )
			#(whileTrue: '(function(){while(%receiver%()){%arg1%()};return nil})()' )
		))
		#(whileFalse: allBlockNoArguments: #(
			#(whileFalse: noClient: 'while(!%receiver%()){%seq1%};' )
			#(whileFalse: '(function(){while(!%receiver%()){%arg1%()};return nil})()' )
		))
		#(ifNil: hasBlockArguments: '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? %arg1%() : $1$;})()' )
		#(ifNotNil: hasBlockArguments: '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)===false) ? %arg1%() : $1$;})()' )
		#(timesRepeat: hasBlockNoArguments: '(function(){for(var $1$=(%receiver%);$1$>0;$1$--){%arg1%()};return nil})()' )
		#(isKindOf: 'smalltalk.is_kindOf_(%receiver%,(%arg1%))' )
		#(respondsTo: 'smalltalk.responds_to_(%receiver%,(%arg1%))' )
		#(ifNil:ifNotNil: hasBlockNoArguments: '(nil.isNil_(%receiver%)) ? %arg1%() : %arg2%()' )
		#(ifNotNil:ifNil: hasBlockNoArguments: '(nil.isNil_(%receiver%)===false) ? %arg1%() : %arg2%()' )
	)) """,nil)
smalltalk.bind(smalltalk.JSEncoder,"magnitudeOptimizations",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#magnitudeOptimizations
	return smalltalk.newArray(["magnitude",[[">","hasNumber:","(%receiver% > %arg1%)"],["<","hasNumber:","(%receiver% < %arg1%)"],[">=","hasNumber:","(%receiver% >= %arg1%)"],["<=","hasNumber:","(%receiver% <= %arg1%)"]]]) 
""","JSEncoder_magnitudeOptimizations")
,"optimization","""magnitudeOptimizations
	" Private - Return the optimization set. "

	^#(magnitude #(
		#(>  hasNumber: '(%receiver% > %arg1%)' )
		#(<  hasNumber: '(%receiver% < %arg1%)' )
		#(>= hasNumber: '(%receiver% >= %arg1%)' )
		#(<= hasNumber: '(%receiver% <= %arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.JSEncoder,"mathOptimizations",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#mathOptimizations
	return smalltalk.newArray(["math",[["+","hasNumber:","(%receiver% + %arg1%)"],["-","hasNumber:","(%receiver% - %arg1%)"],["*","hasNumber:","(%receiver% * %arg1%)"],["/","hasNumber:","(%receiver% / %arg1%)"],["=","hasNumber:","(%receiver% == %arg1%)"]]]) 
""","JSEncoder_mathOptimizations")
,"optimization","""mathOptimizations
	" Private - Return the optimization set. "

	^#(math #(
		#(+ hasNumber: '(%receiver% + %arg1%)' )
		#(#- hasNumber: '(%receiver% - %arg1%)' )
		#(* hasNumber: '(%receiver% * %arg1%)' )
		#(/ hasNumber: '(%receiver% / %arg1%)' )
		#(= hasNumber: '(%receiver% == %arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.JSEncoder,"defaultKnownOptimizations",0
,smalltalk.__f__("""(self):
	#JSEncoder>>#defaultKnownOptimizations
	def __blk1__(_s8_rec):
		_s8_rec.add_(self.s8Optimizations()) 
		_s8_rec.add_(self.magnitudeOptimizations()) 
		_s8_rec.add_(self.mathOptimizations()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.Array.with_(self.coreOptimizations())) 
""","JSEncoder_defaultKnownOptimizations")
,"defaults","""defaultKnownOptimizations
	" Private - Return the default knownOptimizations of the receiver. "

	^(Array	with: self coreOptimizations)
		add: self s8Optimizations;
		add: self magnitudeOptimizations;
		add: self mathOptimizations;
		yourself""",nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,aLanguage):
	#PythonEncoder class>>#supportsLanguage:
	return smalltalk.isObject_equalTo_(aLanguage,smalltalk.String("py")) 
""","PythonEncoder_class_supportsLanguage_")
,"instantiation","""supportsLanguage: aLanguage
	" Private - Return true if instances of the receiver can encode to aLanguage. "

	^aLanguage = #py """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"initializeKernelInlines:",0
,smalltalk.__f__("""(self,pool):
	#PythonEncoder class>>#initializeKernelInlines:
	return self.register_into_(self.kernelInlines(),pool) 
""","PythonEncoder_class_initializeKernelInlines_")
,"inlines","""initializeKernelInlines: pool
	" Private - Initialize the inlines for methods in the category. "

	^self register: self kernelInlines into: pool """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"kernelInlines",0
,smalltalk.__f__('''(self):
	#PythonEncoder class>>#kernelInlines
	return smalltalk.newArray([["Object",[["halt","import pdb; pdb.set_trace()"],["toString","if self.__class__ == smalltalk.String or self.__class__ == smalltalk.Number: return smalltalk.stObject().toString(self)"],["toString:","%String%(str(anObject))"],["isObject:","return %.b_%(%.isObject%(anObject))"],["typeOf:","%String%(type(anObject).__name__)"],["callableOf:","if True:%>%return %.handleOf%(aBlock)%<%"],["basicDelete:","key = smalltalk.handleOf(aString)%cr%try:%>%del self[key]%<%except TypeError:%>%delattr(self,key)%<%"],["basicPerform:withArguments:","__0__.fn(*%.arguments_toCall_%(list(%.handleOf%(anArray)),__0__.fn))"],["asJSONObject","%.newHash%()"]]],["Smalltalk",[["includesKey:","StObject(nil)"],["eval:",'return %.__f__%("""():%>%"""+%.handleOf%(anExpression))()%<%']]],["Smalltalk class",[["global","globals()"],["gc","if True:%>%import gc%cr%return gc.collect()%<%"]]],["Behavior",[["basicNew","self(nil)"],["fn","if True:%>%return %.fn_Of%(self)%<%"],["prototype","if True:%>%return %.prototype_Of%(self)%<%"],["privateMethods","if True:%>%return %.methods_Of%(self)%<%"]]],["CompiledMethod",[["asClosure","if True:%>%return %BlockClosure%(self.fn())%<%"]]],["Boolean",[["not","%false% if %.handleOf%(self) else %true%"],["=","if %.b%(%.is_kindOf_%(anObject, %Boolean%)):%>%return %.b_%(%.handleOf%(self) == %.handleOf%(anObject))%<%if True:%>%return %.b_%(%.handleOf%(self) == anObject)%<%"],["ifTrue:ifFalse:","if %.b%(self):%>%return %.handleOf%(aBlock)()%<%return %.handleOf%(anotherBlock)()"]]],["Number",[["=","if True: return %.b_%(%.handleOf%(anObject) is %.handleOf%(self))"],[">","%.b_%(%.handleOf%(self) > %.handleOf%(aNumber))"],["<","%.b_%(%.handleOf%(self) < %.handleOf%(aNumber))"],[">=","%.b_%(%.handleOf%(self) >= %.handleOf%(aNumber))"],["<=","%.b_%(%.handleOf%(self) <= %.handleOf%(aNumber))"],["+","%Number%(%.handleOf%(self) + %.handleOf%(aNumber))"],["-","%Number%(%.handleOf%(self) - %.handleOf%(aNumber))"],["*","%Number%(%.handleOf%(self) * %.handleOf%(aNumber.mustBeNumber()))"],["/","%Number%(%.handleOf%(self) / %.handleOf%(aNumber))"],["sin","%Number%(%.math%.sin(%.handleOf%(self)))"],["cos","%Number%(%.math%.cos(%.handleOf%(self)))"],["tan","%Number%(%.math%.tan(%.handleOf%(self)))"],["arcCos","%Number%(%.math%.acos(%.handleOf%(self)))"],["arcSin","%Number%(%.math%.asin(%.handleOf%(self)))(self)"],["arcTan","%Number%(%.math%.atan(%.handleOf%(self)))"],["atan2:","%Number%(%.math%.atan2(%.handleOf%(self)))"],["sqrt","%Number%(%.math%.sqrt(%.handleOf%(self)))"],["<<","%Number%(%.handleOf%(self) << %.handleOf%(aNumber))"],[">>","%Number%(%.handleOf%(self) >> %.handleOf%(aNumber))"],["raisedTo:","%Number%(%.math%.pow(%.handleOf%(self),%.handleOf%(aNumber)))"],["max:","%Number%(max(%.handleOf%(self),%.handleOf%(aNumber)))"],["min:","%Number%(min(%.handleOf%(self),%.handleOf%(aNumber)))"],["rounded","%Number%(round(%.handleOf%(self)))"],["truncated","%Number%(%.math%.trunc(%.handleOf%(self)))"],["timesRepeat:","for i in range(%.handleOf%(self)): aBlock(%Number%(i+1))"],["to:do:","for i in range(%.handleOf%(self),%.handleOf%(aNumber)+1): aBlock(%Number%(i))"],["to:by:do:","incr = %.handleOf%(increment)%cr%gap = 1 if incr>0 else -1%cr%for i in range(%.handleOf%(self),%.handleOf%(aNumber)+gap,incr): aBlock(%Number%(i))"],["printString","%String%(str(%.handleOf%(self)))"],["toString:","%.basen%(self,radix)"],["isNumber","if True:%>%return %.b_%(%.is_Number%(%.handleOf%(self)))%<%"],["clearInterval",'self.notImplementedYet_(%String%("clearInterval"))']]],["Number class",[["pi","self(%.math%.pi)"]]],["BlockClosure",[["whileTrue:","while %.handleOf%(self)(): %.handleOf%(aBlock)()"],["whileFalse:","while not %.handleOf%(self)(): %.handleOf%(aBlock)()"],["valueWithPossibleArguments:","self(*%.arrayContents%(array))"],["try:catch:","try:%>%return aBlock()%<%except Exception as e:%>%stEx = smalltalk.Exception(e)%cr%stEx.nativeException_(e)%cr%stEx.messageText_(str(e))%cr%return anotherBlock(self.smalltalkErrorOf_(stEx))%<%"],["valueWithTimeout:","%.value_withTimeout_%(self,aNumber)"],["valueWithInterval:","%.value_withInterval_%(self,aNumber)"],["ensure:","try:%>%return self()%<%finally:%>%aBlock()%<%"],["ifCurtailed:","try:%>%result = self()%cr%curtailed = smalltalk.false%<%finally:%>%if %.b%(curtailed):%>%%.handleOf%(exceptionBlock)()%<%%<%return result"],["argumentCount","%.argumentCount_%(self)"]]],["UndefinedObject",[["asJSONObject","None"]]],["Collection",[["wrap:","return %.asNativeValue_%(anObject)"],["unwrap:","return %.asObject_%(anObject)"]]],["HashedSet",[["initializeHash","dict()"],["includes:",'%.b_%(str(smalltalk.handleOf(__0__.cookie)) in getattr(self,"@hash"))'],["privateAdd:","%.hashedSet_privateAdd_%(self,cookie)%cr%if True:%>%return%<%"],["privateRemove:","%.hashedSet_privateRemove_%(self,cookie)"]]],["SequenceableCollection",[["indexOf:ifAbsent:","cookie=self.wrap_(anObject)%cr%for i, x in enumerate(%.handleOf%(self)):%>%if %.isObject_equalTo%(x,cookie):%>%return %Number%(i+1)%<%%<%if True:%>%return %.handleOf%(aBlock)()%<%"],["do:","for x in %.handleOf%(self):%>%aBlock(self.unwrap_(x))%<%"],["detect:ifNone:","for x in %.handleOf%(self):%>%each=self.unwrap_(x)%cr%if %.b%(aBlock(each)):%>%return each%<%%<%if True:%>%return %.handleOf%(anotherBlock)()%<%"],["reversed","return self.__class__(list(%.handleOf%(self))[::-1])"],["isEmpty","%.b_%(len(%.handleOf%(self)) == 0)"],["reverseDo:","for x in reversed(%.handleOf%(self)):%>%aBlock(self.unwrap_(x))%<%"],["includes:",["cookie=self.wrap_(anObject)%cr%for x in %.handleOf%(self):%>%if %.isObject_equalTo%(x,cookie):%>%return %true%%<%%<%if True:%>%return %false%%<%","self"]],["occurrencesOf:","count = 0%cr%cookie=self.wrap_(anObject)%cr%for x in %.handleOf%(self):%>%if %.isObject_equalTo%(x,cookie):%>%count = count + 1%<%%<%if True:%>%return %Number%(count)%<%"]]],["String class",[["fromString:","if isinstance(aString,self):%>%return aString%<%else:%>%return self(aString)%<%"],["new",'self("")'],["cr","self(chr(13))"],["lf","self(chr(10))"],["crlf","self(chr(13)+chr(10))"],["space",'self(" ")'],["tab","""self("\\\\t")"""],["zero","self(chr(0))"],["fromCharCode:","return self(chr(%.handleOf%(anArrayOrNumber)))"]]],["String",[["=","if True:%>%return %.b_%(%.handleOf%(anObject) == %.handleOf%(self))%<%"],["size","%Number%(len(%.handleOf%(self)))"],["at:","self.__class__(%.handleOf%(self)[%.handleOf%(anIndex) - 1])"],["do:","for c in %.handleOf%(self):%>%aBlock(self.__class__(c))%<%"],["withIndexDo:","for i in range(%.handleOf%(self.size())):%>%aBlock(%.handleOf%(self)[i],%Number%(i+1))%<%"],["detect:ifNone:","for c in %.handleOf%(self):%>%each = self.__class__(c)%cr%if %.b%(%.handleOf%(aBlock(each))):%>%return each%<%%<%return %.handleOf%(anotherBlock)()"],["isLiteral","if True: return %.string_isLiteral_%(self)"],["occurrencesOf:","if True: return %.string_occurrencesOf_%(self,aString)"],["startsWith:","if True: return %.string_startsWith_%(self,aString)"],["escaped","if True:%>%try:%>%from urllib import quote%<%except ImportError:%>%from urllib.parse import quote%<%return %String%(quote(%.handleOf%(self)))%<%"],["unescaped","if True:%>%try:%>%from urllib import unquote%<%except ImportError:%>%from urllib.parse import unquote%<%return %String%(unquote(%.handleOf%(self)))%<%"],["asEncodedURI",'if True: return self.notImplementedYet_(%String%("asEncodedURI"))'],["asDecodedURI",'if True: return self.notImplementedYet_(%String%("asDecodedURI"))'],[",","if True:%>%return self.__class__(%.handleOf%(self)+str(%.handleOf%(aCollection)))%<%"],["copyWith:","self.__class__(%.handleOf%(self)+%.handleOf%(anObject))"],["copyFrom:to:","self.__class__(%.handleOf%(self)[%.handleOf%(anIndex) - 1:%.handleOf%(anotherIndex)])"],["reversed","if True:%>%return %String%(%.handleOf%(self)[::-1])%<%"],["includes:","try:%>%return %.b_%(%.handleOf%(anObject) in %.handleOf%(self))%<%except TypeError:%>%pass%<%"],["indexOf:","try:%>%return %Number%(%.handleOf%(self).find(%.handleOf%(aString))+ 1)%<%except TypeError:%>%return %Number%(0)%<%return %Number%(0)"],["indexOf:startingAt:","try:%>%return %Number%(%.handleOf%(self).find(%.handleOf%(aString),%.handleOf%(position) - 1)+ 1)%<%except TypeError:%>%return %Number%(0)%<%return %Number%(0)"],["lastIndexOf:","offset = %.handleOf%(self).rfind(%.handleOf%(aString))%cr%if True:%>%return %Number%(offset + 1)%<%"],["lastIndexOf:startingAt:","offset = %.handleOf%(self).rfind(%.handleOf%(aString),%.handleOf%(position) - 1)%cr%if True:%>%return %Number%(offset + 1)%<%"],["asNativeName","self.asPythonName()"],["asPrivateSelector","__0__.result = %.string_asPrivateSelector_%(self)"],["asNative:","if True: return self.asPython()"],["replace:with:","if True: return %String%(%.handleOf%(self).replace(%.handleOf%(aString),%.handleOf%(anotherString)))"],["replaceRegexp:with:",'self.notImplementedYet_(%String%("String>>#replaceRegexp:with:"))'],["tokenize:","result = %.handleOf%(self).split(%.handleOf%(aString))%cr%return %.newArray%(result)"],["match:","%.notNil_%(%.string_match%(self,aRegexp))"],["isLetter","%true% if %.handleOf%(self).isalpha() else %false%"],["isDigit","%true% if %.handleOf%(self).isdigit() else %false%"],["isAlphaNumeric","if %.handleOf%(self).isalnum():%>%return %true%%<%else:%>%return %false%%<%"],["isUpperCase","if True:%>%return %.b_%(%.handleOf%(self).isupper())%<%"],["isLowerCase","if True:%>%return %.b_%(%.handleOf%(self).islower())%<%"],["asUppercase","self.__class__(%.handleOf%(self).upper())"],["asLowercase","self.__class__(%.handleOf%(self).lower())"],["asNumber","%.string_asNumber_%(self)"],[">","%true% if %.handleOf%(self) > %.handleOf%(aString) else %false%"],["<","%true% if %.handleOf%(self) < %.handleOf%(aString) else %false%"],[">=","%true% if %.handleOf%(self) >= %.handleOf%(aString) else %false%"],["<=","%true% if %.handleOf%(self) <= %.handleOf%(aString) else %false%"],["isCharacter","%true% if len(%.handleOf%(self)) == 1 else %false%"],["asciiValue","%Number%(ord(%.handleOf%(self)))"],["isSeparator","%true% if %.handleOf%(self).isspace() else %false%"]]],["Array class",[["basicNew:","self([nil] * %.handleOf%(size))"],["with:","if True:%>%return %.newArray%([anObject])%<%"],["with:with:","if True:%>%return %.newArray%([firstObject, secondObject])%<%"],["with:with:with:","if True:%>%return %.newArray%([firstObject, secondObject, thirdObject])%<%"],["with:with:with:with:","if True:%>%return %.newArray%([firstObject, secondObject, fourthObject])%<%"],["withAll:","if True:%>%return self(%.handleOf%(aCollection.asArray()))%<%"],["slice:",'self.notImplementedYet_(%String%("Array class>>#slice:"))']]],["Array",[["size","%Number%(len(%.handleOf%(self)))"],["at:","if True:%>%return %.array_at_%(self,anIndex)%<%"],["at:ifAbsent:","if True:%>%return %.array_at_ifAbsent_%(self,anIndex,aBlock)%<%"],["at:put:","if True:%>%return %.array_at_put_%(self,anIndex,anObject)%<%"],["do:","for x in %.handleOf%(self):%>%aBlock(%.asObject_%(x))%<%"],["addAll:",'result = %.handleOf%(self) + %.handleOf%(aCollection.asArray())%cr%setattr(self,"@handle",result)'],["shallowCopy","aType = type(%.handleOf%(self))%cr%objects = aType(%.handleOf%(self))%cr%if True:%>%return self.__class__(objects)%<%"],["copyWithAll:","result = self.copy()%cr%result.addAll_(aCollection.asArray())%cr%if True:%>%return result%<%"],[",","result = self.copy()%cr%result.addAll_(aCollection.asArray())%cr%if True:%>%return result%<%"],["join:","%.array_join_%(self,aString)"],["sort:","%.array_sort_%(self,aBlock)"],["remove:ifAbsent:","try:%>%%.handleOf%(self).remove(%.asNativeValue_%(anObject))%<%except ValueError:%>%return %.handleOf%(aBlock)()%<%else:%>%return anObject%<%"],["add:","%.handleOf%(self).append(%.asNativeValue_%(anObject))"],["addFirst:","%.handleOf%(self).insert(0,%.asNativeValue_%(anObject))"],["addLast:","%.handleOf%(self).append(%.asNativeValue_%(anObject))"],["removeAll","%.handleOf%(self).clear()"],["removeFirst","%.asObject_%(%.handleOf%(self).pop(0))"],["removeIndex:","%.asObject_%(%.handleOf%(self).pop(%.handleOf%(index)-1))"],["removeLast","%.asObject_%(%.handleOf%(self).pop())"],["atAllPut:","array = %.handleOf%(self)%cr%o = %.asNativeValue_%(anObject)%cr%for i in range(0,%.handleOf%(self.size())):%>%array[i] = o%<%"],["first","array = %.handleOf%(self)%cr%if array:%>%return %.asObject_%(array[0])%<%"],["second","array = %.handleOf%(self)%cr%if len(array) > 1:%>%return %.asObject_%(array[1])%<%"],["third","array = %.handleOf%(self)%cr%if len(array) > 2:%>%return %.asObject_%(array[2])%<%"],["fourth","	array = %.handleOf%(self)%cr%if len(array) > 3:%>%return %.asObject_%(array[3])%<%"],["fifth","array = %.handleOf%(self)%cr%if len(array) > 4:%>%return %.asObject_%(array[4])%<%"],["sixth","array = %.handleOf%(self)%cr%if len(array) > 5:%>%return %.asObject_%(array[5])%<%"]]],["RegularExpression class",[["fromString:flag:",'self.notImplementedYet_(%String%("RegularExpression>>#fromString:flag:"))']]],["Exception",[["signal","raise Exception(self)"]]],["ComposedAssociations",[["hashObject","%.newHash%()"]]],["KeyedCollection class",[["@",'self.notImplementedYet_(%String%("KeyedCollection>>#@"))']]],["KeyedCollection",[["newHash","%.newHash%()"]]],["Dictionary class",[["basicNew","if True:%>%return %PoolDictionary%.new()%<%"]]],["PoolDictionary",[["at:put:","if True:%>%return %.pool_at_put_%(self, aKey, aValue)%<%"],["removeKey:ifAbsent:","%.pool_removeKey_%(self, aKey)"],["at:ifAbsent:","if True:%>%return %.pool_at_ifAbsent_%(self, aKey, aBlock)%<%"],["includesKey:","%.pool_includesKey_%(self, aKey)"],["keys","if True:%>%return %.pool_keys%(self)%<%"]]],["ClassBuilder",[["addSubclassOf:named:instanceVariableNames:","aName = str(%.handleOf%(aString))%cr%%.addClass%(aName, aClass, aCollection)%cr%if True:%>%return getattr(smalltalk,aName,nil)%<%"]]],["StringStream",[["peek","try:%>%s = %.handleOf%(self.collection())%cr%offs = %.handleOf%(self.position())%cr%if offs>=len(s):%>%return nil%<%return %String%(s[offs])%<%except:%>%return nil%<%"],["peekForAll:","start = %.handleOf%(self.position())%cr%s = %.handleOf%(self.collection())%cr%if not s.startswith(%.handleOf%(aCollection),start):%>%return %false%%<%"]]],["Random",[["next","if True:%>%import random%cr%return %Number%(random.random())%<%"]]],["DateTime class",[["new:",'iso = %.handleOf%(anObject).replace("/","-")%cr%if True:%>%import datetime%cr%return self(datetime.fromisoformat(iso))%<%'],["today","if True:%>%from datetime import date%cr%return self(date.today())%<%"],["now","if True:%>%from datetime import datetime%cr%return self(datetime.now())%<%"],["msNow","if True:%>%import time%cr%return %Number%(int(time.time_ns() / 1000000))%<%"]]],["DateTime",[["<","%.b_%(%.handleOf%(self) < %.handleOf%(aDateTime))"],[">","%.b_%(%.handleOf%(self) > %.handleOf%(aDateTime))"],["<=","%.b_%(%.handleOf%(self) <= %.handleOf%(aDateTime))"],[">=","%.b_%(%.handleOf%(self) >= %.handleOf%(aDateTime))"],["-","self.__class__(%.handleOf%(self) - %.handleOf%(aDateTime))"],["+","self.__class__(%.handleOf%(self) + %.handleOf%(aDateTime))"],["isValid","%true%"],["year","%.handleOf%(self).year"],["year:","%.handleOf%(self).year = aNumber"],["month","%.handleOf%(self).month"],["day","%.handleOf%(self).day"],["day:","self.day = aNumber"],["dayOfMonth","%.handleOf%(self).day"],["dayOfMonth:","%.handleOf%(self).day = aNumber"],["asLocaleString",'self.notImplementedYet_(%String%("asLocaleString"))'],["asDateString",'self.notImplementedYet_(%String%("asDateString"))'],["asTimeString",'self.notImplementedYet_(%String%("asTimeString"))'],["time",'self.invalidMessage(%String%("time"))'],["time:",'self.invalidMessage(%String%("time:"))'],["hours:",'self.invalidMessage(%String%("hours:"))'],["minutes:",'self.invalidMessage(%String%("minutes:"))'],["seconds:",'self.invalidMessage(%String%("seconds:"))'],["milliseconds:",'self.invalidMessage(%String%("milliseconds:"))'],["hours",'self.notImplementedYet_(%String%("hours"))'],["minutes",'self.notImplementedYet_(%String%("minutes"))'],["seconds",'self.notImplementedYet_(%String%("seconds"))'],["milliseconds",'self.notImplementedYet_(%String%("milliseconds"))']]]]) 
''',"PythonEncoder_class_kernelInlines")
,"inlines",'''kernelInlines
	" Private - Return the inlines for methods in the category. "

	^#(
#(Object #(
#(halt		'import pdb; pdb.set_trace()')
#(toString	'if self.__class__ == smalltalk.String or self.__class__ == smalltalk.Number: return smalltalk.stObject().toString(self)')
#(toString:	'%String%(str(anObject))')
#(isObject:	'return %.b_%(%.isObject%(anObject))')
#(typeOf:	'%String%(type(anObject).__name__)')
#(callableOf:	'if True:%>%return %.handleOf%(aBlock)%<%')
#(basicDelete:	'key = smalltalk.handleOf(aString)%cr%try:%>%del self[key]%<%except TypeError:%>%delattr(self,key)%<%')
#(basicPerform:withArguments: '__0__.fn(*%.arguments_toCall_%(list(%.handleOf%(anArray)),__0__.fn))')
#(asJSONObject	'%.newHash%()')
))
#(Smalltalk #(
#(includesKey:	'StObject(nil)')
#(eval:	'return %.__f__%("""():%>%"""+%.handleOf%(anExpression))()%<%')
))
#('Smalltalk class' #(
#(global	'globals()')
#(gc	'if True:%>%import gc%cr%return gc.collect()%<%')
))
#(Behavior #(
#(basicNew	'self(nil)')
#(fn		'if True:%>%return %.fn_Of%(self)%<%')
#(prototype	'if True:%>%return %.prototype_Of%(self)%<%')
#(privateMethods	'if True:%>%return %.methods_Of%(self)%<%')
))
#(CompiledMethod #(
#(asClosure	'if True:%>%return %BlockClosure%(self.fn())%<%')
))
#(Boolean #(
#(not 	'%false% if %.handleOf%(self) else %true%')
#(=	'if %.b%(%.is_kindOf_%(anObject, %Boolean%)):%>%return %.b_%(%.handleOf%(self) == %.handleOf%(anObject))%<%if True:%>%return %.b_%(%.handleOf%(self) == anObject)%<%')
#(ifTrue:ifFalse: 'if %.b%(self):%>%return %.handleOf%(aBlock)()%<%return %.handleOf%(anotherBlock)()')
))
#(Number #(
#(= 'if True: return %.b_%(%.handleOf%(anObject) is %.handleOf%(self))')
#(> '%.b_%(%.handleOf%(self) > %.handleOf%(aNumber))')
#(< '%.b_%(%.handleOf%(self) < %.handleOf%(aNumber))')
#(>= '%.b_%(%.handleOf%(self) >= %.handleOf%(aNumber))')
#(<= '%.b_%(%.handleOf%(self) <= %.handleOf%(aNumber))')
#(+ '%Number%(%.handleOf%(self) + %.handleOf%(aNumber))')
#(- '%Number%(%.handleOf%(self) - %.handleOf%(aNumber))')
#(* '%Number%(%.handleOf%(self) * %.handleOf%(aNumber.mustBeNumber()))')
#(/ '%Number%(%.handleOf%(self) / %.handleOf%(aNumber))')
#(sin '%Number%(%.math%.sin(%.handleOf%(self)))')
#(cos '%Number%(%.math%.cos(%.handleOf%(self)))')
#(tan '%Number%(%.math%.tan(%.handleOf%(self)))')
#(arcCos '%Number%(%.math%.acos(%.handleOf%(self)))')
#(arcSin '%Number%(%.math%.asin(%.handleOf%(self)))(self)')
#(arcTan '%Number%(%.math%.atan(%.handleOf%(self)))')
#(atan2: '%Number%(%.math%.atan2(%.handleOf%(self)))')
#(sqrt '%Number%(%.math%.sqrt(%.handleOf%(self)))')
#(<< '%Number%(%.handleOf%(self) << %.handleOf%(aNumber))')
#(>> '%Number%(%.handleOf%(self) >> %.handleOf%(aNumber))')
#(raisedTo: '%Number%(%.math%.pow(%.handleOf%(self),%.handleOf%(aNumber)))')
#(max: '%Number%(max(%.handleOf%(self),%.handleOf%(aNumber)))')
#(min: '%Number%(min(%.handleOf%(self),%.handleOf%(aNumber)))')
#(rounded '%Number%(round(%.handleOf%(self)))')
#(truncated '%Number%(%.math%.trunc(%.handleOf%(self)))')
#(timesRepeat: 'for i in range(%.handleOf%(self)): aBlock(%Number%(i+1))')
#(to:do: 'for i in range(%.handleOf%(self),%.handleOf%(aNumber)+1): aBlock(%Number%(i))')
#(to:by:do: 'incr = %.handleOf%(increment)%cr%gap = 1 if incr>0 else -1%cr%for i in range(%.handleOf%(self),%.handleOf%(aNumber)+gap,incr): aBlock(%Number%(i))')
#(printString '%String%(str(%.handleOf%(self)))')
#(toString: '%.basen%(self,radix)')
#(isNumber 'if True:%>%return %.b_%(%.is_Number%(%.handleOf%(self)))%<%')
#(clearInterval 'self.notImplementedYet_(%String%("clearInterval"))')
))
#('Number class' #(
#(pi 'self(%.math%.pi)')
))
#(BlockClosure #(
#(whileTrue: 'while %.handleOf%(self)(): %.handleOf%(aBlock)()')
#(whileFalse: 'while not %.handleOf%(self)(): %.handleOf%(aBlock)()')
#(valueWithPossibleArguments: 'self(*%.arrayContents%(array))')
#(try:catch: 'try:%>%return aBlock()%<%except Exception as e:%>%stEx = smalltalk.Exception(e)%cr%stEx.nativeException_(e)%cr%stEx.messageText_(str(e))%cr%return anotherBlock(self.smalltalkErrorOf_(stEx))%<%')
#(valueWithTimeout: '%.value_withTimeout_%(self,aNumber)')
#(valueWithInterval: '%.value_withInterval_%(self,aNumber)')
#(ensure: 'try:%>%return self()%<%finally:%>%aBlock()%<%')
#(ifCurtailed: 'try:%>%result = self()%cr%curtailed = smalltalk.false%<%finally:%>%if %.b%(curtailed):%>%%.handleOf%(exceptionBlock)()%<%%<%return result')
#(argumentCount '%.argumentCount_%(self)')
))
#(UndefinedObject  #(
#(asJSONObject 'None')
))
#(Collection  #(
#(wrap: 'return %.asNativeValue_%(anObject)')
#(unwrap: 'return %.asObject_%(anObject)')
))
#(HashedSet #(
#(initializeHash 'dict()')
#(includes: '%.b_%(str(smalltalk.handleOf(__0__.cookie)) in getattr(self,"@hash"))')
#(privateAdd: '%.hashedSet_privateAdd_%(self,cookie)%cr%if True:%>%return%<%')
#(privateRemove: '%.hashedSet_privateRemove_%(self,cookie)')
))
#(SequenceableCollection #(
#(indexOf:ifAbsent: 'cookie=self.wrap_(anObject)%cr%for i, x in enumerate(%.handleOf%(self)):%>%if %.isObject_equalTo%(x,cookie):%>%return %Number%(i+1)%<%%<%if True:%>%return %.handleOf%(aBlock)()%<%')
#(do: 'for x in %.handleOf%(self):%>%aBlock(self.unwrap_(x))%<%')
#(detect:ifNone: 'for x in %.handleOf%(self):%>%each=self.unwrap_(x)%cr%if %.b%(aBlock(each)):%>%return each%<%%<%if True:%>%return %.handleOf%(anotherBlock)()%<%')
#(reversed 'return self.__class__(list(%.handleOf%(self))[::-1])')
#(isEmpty '%.b_%(len(%.handleOf%(self)) == 0)')
#(reverseDo:  'for x in reversed(%.handleOf%(self)):%>%aBlock(self.unwrap_(x))%<%')
#(includes: #('cookie=self.wrap_(anObject)%cr%for x in %.handleOf%(self):%>%if %.isObject_equalTo%(x,cookie):%>%return %true%%<%%<%if True:%>%return %false%%<%' 'self'))
#(occurrencesOf: 'count = 0%cr%cookie=self.wrap_(anObject)%cr%for x in %.handleOf%(self):%>%if %.isObject_equalTo%(x,cookie):%>%count = count + 1%<%%<%if True:%>%return %Number%(count)%<%')
))
#('String class' #(
#(fromString: 'if isinstance(aString,self):%>%return aString%<%else:%>%return self(aString)%<%')
#(new	'self("")')
#(cr 	'self(chr(13))')
#(lf 	'self(chr(10))')
#(crlf 	'self(chr(13)+chr(10))')
#(space	'self(" ")')
#(tab	'self("\\t")')
#(zero	'self(chr(0))')
#(fromCharCode: 'return self(chr(%.handleOf%(anArrayOrNumber)))')
))
#(String #(
#(=	'if True:%>%return %.b_%(%.handleOf%(anObject) == %.handleOf%(self))%<%')
#(size	'%Number%(len(%.handleOf%(self)))')
#(at:	'self.__class__(%.handleOf%(self)[%.handleOf%(anIndex) - 1])')
#(do: 	'for c in %.handleOf%(self):%>%aBlock(self.__class__(c))%<%')
#(withIndexDo: 'for i in range(%.handleOf%(self.size())):%>%aBlock(%.handleOf%(self)[i],%Number%(i+1))%<%')
#(detect:ifNone: 'for c in %.handleOf%(self):%>%each = self.__class__(c)%cr%if %.b%(%.handleOf%(aBlock(each))):%>%return each%<%%<%return %.handleOf%(anotherBlock)()')
#(isLiteral 'if True: return %.string_isLiteral_%(self)')
#(occurrencesOf: 'if True: return %.string_occurrencesOf_%(self,aString)')
#(startsWith: 'if True: return %.string_startsWith_%(self,aString)')
#(escaped 'if True:%>%try:%>%from urllib import quote%<%except ImportError:%>%from urllib.parse import quote%<%return %String%(quote(%.handleOf%(self)))%<%')
#(unescaped 'if True:%>%try:%>%from urllib import unquote%<%except ImportError:%>%from urllib.parse import unquote%<%return %String%(unquote(%.handleOf%(self)))%<%')
#(asEncodedURI 'if True: return self.notImplementedYet_(%String%("asEncodedURI"))')
#(asDecodedURI 'if True: return self.notImplementedYet_(%String%("asDecodedURI"))')
#(, 'if True:%>%return self.__class__(%.handleOf%(self)+str(%.handleOf%(aCollection)))%<%')
#(copyWith: 'self.__class__(%.handleOf%(self)+%.handleOf%(anObject))')
#(copyFrom:to: 'self.__class__(%.handleOf%(self)[%.handleOf%(anIndex) - 1:%.handleOf%(anotherIndex)])')
#(reversed 'if True:%>%return %String%(%.handleOf%(self)[::-1])%<%')
#(includes: 'try:%>%return %.b_%(%.handleOf%(anObject) in %.handleOf%(self))%<%except TypeError:%>%pass%<%')
#(indexOf: 'try:%>%return %Number%(%.handleOf%(self).find(%.handleOf%(aString))+ 1)%<%except TypeError:%>%return %Number%(0)%<%return %Number%(0)')
#(indexOf:startingAt: 'try:%>%return %Number%(%.handleOf%(self).find(%.handleOf%(aString),%.handleOf%(position) - 1)+ 1)%<%except TypeError:%>%return %Number%(0)%<%return %Number%(0)')
#(lastIndexOf: 'offset = %.handleOf%(self).rfind(%.handleOf%(aString))%cr%if True:%>%return %Number%(offset + 1)%<%')
#(lastIndexOf:startingAt: 'offset = %.handleOf%(self).rfind(%.handleOf%(aString),%.handleOf%(position) - 1)%cr%if True:%>%return %Number%(offset + 1)%<%')
#(asNativeName 'self.asPythonName()')
#(asPrivateSelector '__0__.result = %.string_asPrivateSelector_%(self)')
#(asNative: 'if True: return self.asPython()')
#(replace:with: 'if True: return %String%(%.handleOf%(self).replace(%.handleOf%(aString),%.handleOf%(anotherString)))')
#(replaceRegexp:with: 'self.notImplementedYet_(%String%("String>>#replaceRegexp:with:"))')
#(tokenize: 'result = %.handleOf%(self).split(%.handleOf%(aString))%cr%return %.newArray%(result)')
#(match: '%.notNil_%(%.string_match%(self,aRegexp))')
#(isLetter '%true% if %.handleOf%(self).isalpha() else %false%')
#(isDigit '%true% if %.handleOf%(self).isdigit() else %false%')
#(isAlphaNumeric 'if %.handleOf%(self).isalnum():%>%return %true%%<%else:%>%return %false%%<%')
#(isUpperCase 'if True:%>%return %.b_%(%.handleOf%(self).isupper())%<%')
#(isLowerCase 'if True:%>%return %.b_%(%.handleOf%(self).islower())%<%')
#(asUppercase 'self.__class__(%.handleOf%(self).upper())')
#(asLowercase 'self.__class__(%.handleOf%(self).lower())')
#(asNumber '%.string_asNumber_%(self)')
#(> '%true% if %.handleOf%(self) > %.handleOf%(aString) else %false%')
#(< '%true% if %.handleOf%(self) < %.handleOf%(aString) else %false%')
#(>= '%true% if %.handleOf%(self) >= %.handleOf%(aString) else %false%')
#(<= '%true% if %.handleOf%(self) <= %.handleOf%(aString) else %false%')
#(isCharacter '%true% if len(%.handleOf%(self)) == 1 else %false%')
#(asciiValue '%Number%(ord(%.handleOf%(self)))')
#(isSeparator '%true% if %.handleOf%(self).isspace() else %false%')
))
#('Array class' #(
#(basicNew: 'self([nil] * %.handleOf%(size))')
#(with: 'if True:%>%return %.newArray%([anObject])%<%')
#(with:with: 'if True:%>%return %.newArray%([firstObject, secondObject])%<%')
#(with:with:with: 'if True:%>%return %.newArray%([firstObject, secondObject, thirdObject])%<%')
#(with:with:with:with: 'if True:%>%return %.newArray%([firstObject, secondObject, fourthObject])%<%')
#(withAll: 'if True:%>%return self(%.handleOf%(aCollection.asArray()))%<%')
#(slice: 'self.notImplementedYet_(%String%("Array class>>#slice:"))')
))
#(Array #(
#(size '%Number%(len(%.handleOf%(self)))')
#(at: 'if True:%>%return %.array_at_%(self,anIndex)%<%')
#(at:ifAbsent: 'if True:%>%return %.array_at_ifAbsent_%(self,anIndex,aBlock)%<%')
#(at:put: 'if True:%>%return %.array_at_put_%(self,anIndex,anObject)%<%')
#(do: 'for x in %.handleOf%(self):%>%aBlock(%.asObject_%(x))%<%')
#(addAll: 'result = %.handleOf%(self) + %.handleOf%(aCollection.asArray())%cr%setattr(self,"@handle",result)')
#(shallowCopy 'aType = type(%.handleOf%(self))%cr%objects = aType(%.handleOf%(self))%cr%if True:%>%return self.__class__(objects)%<%')
#(copyWithAll: 'result = self.copy()%cr%result.addAll_(aCollection.asArray())%cr%if True:%>%return result%<%')
#(, 'result = self.copy()%cr%result.addAll_(aCollection.asArray())%cr%if True:%>%return result%<%')
#(join: '%.array_join_%(self,aString)')
#(sort: '%.array_sort_%(self,aBlock)')
#(remove:ifAbsent: 'try:%>%%.handleOf%(self).remove(%.asNativeValue_%(anObject))%<%except ValueError:%>%return %.handleOf%(aBlock)()%<%else:%>%return anObject%<%')
#(add: '%.handleOf%(self).append(%.asNativeValue_%(anObject))')
#(addFirst: '%.handleOf%(self).insert(0,%.asNativeValue_%(anObject))')
#(addLast: '%.handleOf%(self).append(%.asNativeValue_%(anObject))')
#(removeAll '%.handleOf%(self).clear()')
#(removeFirst '%.asObject_%(%.handleOf%(self).pop(0))')
#(removeIndex: '%.asObject_%(%.handleOf%(self).pop(%.handleOf%(index)-1))')
#(removeLast '%.asObject_%(%.handleOf%(self).pop())')
#(atAllPut: 'array = %.handleOf%(self)%cr%o = %.asNativeValue_%(anObject)%cr%for i in range(0,%.handleOf%(self.size())):%>%array[i] = o%<%')
#(first 'array = %.handleOf%(self)%cr%if array:%>%return %.asObject_%(array[0])%<%')
#(second 'array = %.handleOf%(self)%cr%if len(array) > 1:%>%return %.asObject_%(array[1])%<%')
#(third 'array = %.handleOf%(self)%cr%if len(array) > 2:%>%return %.asObject_%(array[2])%<%')
#(fourth '	array = %.handleOf%(self)%cr%if len(array) > 3:%>%return %.asObject_%(array[3])%<%')
#(fifth 'array = %.handleOf%(self)%cr%if len(array) > 4:%>%return %.asObject_%(array[4])%<%')
#(sixth 'array = %.handleOf%(self)%cr%if len(array) > 5:%>%return %.asObject_%(array[5])%<%')
))
#('RegularExpression class' #(
#(fromString:flag: 'self.notImplementedYet_(%String%("RegularExpression>>#fromString:flag:"))')
))
#(Exception #(
#(signal 'raise Exception(self)')
))
#(ComposedAssociations #(
#(hashObject '%.newHash%()')
))
#('KeyedCollection class' #(
#(@ 'self.notImplementedYet_(%String%("KeyedCollection>>#@"))')
))
#(KeyedCollection #(
#(newHash '%.newHash%()')
))
#('Dictionary class' #(
#(basicNew 'if True:%>%return %PoolDictionary%.new()%<%')
))
#(PoolDictionary #(
#(at:put: 'if True:%>%return %.pool_at_put_%(self, aKey, aValue)%<%')
#(removeKey:ifAbsent: '%.pool_removeKey_%(self, aKey)')
#(at:ifAbsent: 'if True:%>%return %.pool_at_ifAbsent_%(self, aKey, aBlock)%<%')
#(includesKey: '%.pool_includesKey_%(self, aKey)')
#(keys 'if True:%>%return %.pool_keys%(self)%<%')
))
#(ClassBuilder #(
#(addSubclassOf:named:instanceVariableNames: 'aName = str(%.handleOf%(aString))%cr%%.addClass%(aName, aClass, aCollection)%cr%if True:%>%return getattr(smalltalk,aName,nil)%<%')
))
#(StringStream #(
#(peek 'try:%>%s = %.handleOf%(self.collection())%cr%offs = %.handleOf%(self.position())%cr%if offs>=len(s):%>%return nil%<%return %String%(s[offs])%<%except:%>%return nil%<%')
#(peekForAll: 'start = %.handleOf%(self.position())%cr%s = %.handleOf%(self.collection())%cr%if not s.startswith(%.handleOf%(aCollection),start):%>%return %false%%<%')
))
#(Random #(
#(next 'if True:%>%import random%cr%return %Number%(random.random())%<%')
))
#('DateTime class' #(
#(new: 'iso = %.handleOf%(anObject).replace("/","-")%cr%if True:%>%import datetime%cr%return self(datetime.fromisoformat(iso))%<%')
#(today 'if True:%>%from datetime import date%cr%return self(date.today())%<%')
#(now 'if True:%>%from datetime import datetime%cr%return self(datetime.now())%<%')
#(msNow 'if True:%>%import time%cr%return %Number%(int(time.time_ns() / 1000000))%<%')
))
#(DateTime #(
#(< '%.b_%(%.handleOf%(self) < %.handleOf%(aDateTime))')
#(> '%.b_%(%.handleOf%(self) > %.handleOf%(aDateTime))')
#(<= '%.b_%(%.handleOf%(self) <= %.handleOf%(aDateTime))')
#(>= '%.b_%(%.handleOf%(self) >= %.handleOf%(aDateTime))')
#(- 'self.__class__(%.handleOf%(self) - %.handleOf%(aDateTime))')
#(+ 'self.__class__(%.handleOf%(self) + %.handleOf%(aDateTime))')
#(isValid '%true%')
#(year '%.handleOf%(self).year')
#(year: '%.handleOf%(self).year = aNumber')
#(month '%.handleOf%(self).month')
#(day '%.handleOf%(self).day')
#(day: 'self.day = aNumber')
#(dayOfMonth '%.handleOf%(self).day')
#(dayOfMonth: '%.handleOf%(self).day = aNumber')
#(asLocaleString 'self.notImplementedYet_(%String%("asLocaleString"))')
#(asDateString 'self.notImplementedYet_(%String%("asDateString"))')
#(asTimeString 'self.notImplementedYet_(%String%("asTimeString"))')
#(time 'self.invalidMessage(%String%("time"))')
#(time: 'self.invalidMessage(%String%("time:"))')
#(hours: 'self.invalidMessage(%String%("hours:"))')
#(minutes: 'self.invalidMessage(%String%("minutes:"))')
#(seconds: 'self.invalidMessage(%String%("seconds:"))')
#(milliseconds: 'self.invalidMessage(%String%("milliseconds:"))')
#(hours 'self.notImplementedYet_(%String%("hours"))')
#(minutes 'self.notImplementedYet_(%String%("minutes"))')
#(seconds 'self.notImplementedYet_(%String%("seconds"))')
#(milliseconds 'self.notImplementedYet_(%String%("milliseconds"))')
))
	) ''',nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"initializeNativeInlines:",0
,smalltalk.__f__("""(self,pool):
	#PythonEncoder class>>#initializeNativeInlines:
	return self.register_into_(self.nativeInlines(),pool) 
""","PythonEncoder_class_initializeNativeInlines_")
,"inlines","""initializeNativeInlines: pool
	" Private - Initialize the inlines for methods in the category. "

	^self register: self nativeInlines into: pool """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"nativeInlines",0
,smalltalk.__f__("""(self):
	#PythonEncoder class>>#nativeInlines
	return smalltalk.newArray([["NativeObject class",[["undefined","None"],["codeToNumber",'" "']]],["NativeObject",[["jsObject",'self.invalidMessage_(%String%("jsObject"))'],["ownPropertyNames","keys=self.handle().keys()%cr%if True:%>%return %Array%(list(keys))%<%"]]],["NativeHandle",[["hasOwnProperty:",'%true% if hasattr(getattr(self,"@handle"),aName) else %false%'],["delete:",'delattr(getattr(self,"@handle"),aName)']]],["NativeLibraryObject class",[["basicLoad:","require(url)"]]],["NativeLibraryObject",[["newHandleOf:","result = aConstructor()"],["newHandleOf:with:","result = aConstructor(arg1)"],["newHandleOf:with:with:","result = aConstructor(arg1,arg2)"],["newHandleOf:with:with:with:","result = aConstructor(arg1,arg2,arg3)"],["newHandleOf:with:with:with:with:","result = aConstructor(arg1,arg2,arg3,arg4)"],["newHandleOf:with:with:with:with:with:","result = aConstructor(arg1,arg2,arg3,arg4,arg5)"],["newHandleOf:with:with:with:with:with:with:","result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)"],["newHandleOf:with:with:with:with:with:with:with:","result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)"],["newHandleOf:with:with:with:with:with:with:with:with:","result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)"]]],["Array",[["addAllLua:","self.addAll_(natives)"]]],["Array class",[["@","result=self(natives)"]]],["Boolean class",[["@","h=%.handleOf%(aBOOL)%cr%if h==1 or h==True:%>%return %true%%<%"]]]]) 
""","PythonEncoder_class_nativeInlines")
,"inlines","""nativeInlines
	" Private - Return the inlines for methods in the category. "

	^#(
#('NativeObject class' #(
#(undefined 'None')
#(codeToNumber '" "')
))
#(NativeObject #(
#(jsObject 'self.invalidMessage_(%String%("jsObject"))')
#(ownPropertyNames 'keys=self.handle().keys()%cr%if True:%>%return %Array%(list(keys))%<%')
))
#(NativeHandle #(
#(hasOwnProperty: '%true% if hasattr(getattr(self,"@handle"),aName) else %false%')
#(delete: 'delattr(getattr(self,"@handle"),aName)')
))
#('NativeLibraryObject class' #(
#(basicLoad: 'require(url)')
))
#(NativeLibraryObject  #(
#(newHandleOf: 'result = aConstructor()')
#(newHandleOf:with: 'result = aConstructor(arg1)')
#(newHandleOf:with:with: 'result = aConstructor(arg1,arg2)')
#(newHandleOf:with:with:with: 'result = aConstructor(arg1,arg2,arg3)')
#(newHandleOf:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4)')
#(newHandleOf:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5)')
#(newHandleOf:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)')
#(newHandleOf:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)')
#(newHandleOf:with:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)')
))
#(Array #(
#(addAllLua: 'self.addAll_(natives)')
))
#('Array class' #(
#(@ 'result=self(natives)')
))
#('Boolean class' #(
#(@ 'h=%.handleOf%(aBOOL)%cr%if h==1 or h==True:%>%return %true%%<%')
))
	) """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"initializeToolsInlines:",0
,smalltalk.__f__("""(self,pool):
	#PythonEncoder class>>#initializeToolsInlines:
	return self.register_into_(self.toolsInlines(),pool) 
""","PythonEncoder_class_initializeToolsInlines_")
,"inlines","""initializeToolsInlines: pool
	" Private - Initialize the inlines for methods in the category. "

	^self register: self toolsInlines into: pool """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"toolsInlines",0
,smalltalk.__f__("""(self):
	#PythonEncoder class>>#toolsInlines
	return smalltalk.newArray([["NativeReader",[["initializeObject","%.newHash%()"]]],["String",[["asComment",["%String%.pythonCommentStart()","%String%.pythonCommentEnd()",'"# "']]]],["MethodReferences",[["dot",'%String%(".")'],["localDef",'%String%(" ")'],["superSendPatternOf:","self.superPythonSendPatternOf_(aSelector)"],["compiledSourceStart",'%String%("(")']]],["Class",[["hackDNU",'self.notImplementedYet_(%String%("Class>>#hackDNU"))']]]]) 
""","PythonEncoder_class_toolsInlines")
,"inlines","""toolsInlines
	" Private - Return the inlines for methods in the category. "

	^#(
#(NativeReader #(
#(initializeObject '%.newHash%()')
))
#(String  #(
#(asComment #('%String%.pythonCommentStart()' 	'%String%.pythonCommentEnd()' 	'"# "'))
))
#(MethodReferences #(
#(dot		'%String%(".")')
#(localDef	'%String%(" ")')
#(superSendPatternOf:	'self.superPythonSendPatternOf_(aSelector)')
#(compiledSourceStart	'%String%("(")')
))
#(Class #(
#(hackDNU 'self.notImplementedYet_(%String%("Class>>#hackDNU"))')
))
	) """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"initializeSnapshotInlines:",0
,smalltalk.__f__("""(self,pool):
	#PythonEncoder class>>#initializeSnapshotInlines:
	return self.register_into_(self.snapshotInlines(),pool) 
""","PythonEncoder_class_initializeSnapshotInlines_")
,"inlines","""initializeSnapshotInlines: pool
	" Private - Initialize the inlines for methods in the category. "

	^self register: self snapshotInlines into: pool """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"snapshotInlines",0
,smalltalk.__f__("""(self):
	#PythonEncoder class>>#snapshotInlines
	return smalltalk.newArray([["Snapshot",[["bootHeader",'%String%("")'],["bootFooter",'%String%("")'],["launchExpression",'%String%("%.launchImage%()")']]]]) 
""","PythonEncoder_class_snapshotInlines")
,"inlines","""snapshotInlines
	" Private - Return the inlines for methods in the category. "

	^#(
#(Snapshot #(
#(bootHeader	'%String%("")')
#(bootFooter	'%String%("")')
#(launchExpression '%String%("%.launchImage%()")')
))
	) """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"initializeOtherInlines:",0
,smalltalk.__f__("""(self,pool):
	#PythonEncoder class>>#initializeOtherInlines:
	return self.register_into_(self.otherInlines(),pool) 
""","PythonEncoder_class_initializeOtherInlines_")
,"inlines","""initializeOtherInlines: pool
	" Private - Initialize the inlines for methods in the category. "

	^self register: self otherInlines into: pool """,nil)
smalltalk.bind(smalltalk.PythonEncoder.__class__,"otherInlines",0
,smalltalk.__f__("""(self):
	#PythonEncoder class>>#otherInlines
	return smalltalk.newArray([]) 
""","PythonEncoder_class_otherInlines")
,"inlines","""otherInlines
	" Private - Return the inlines for methods in the category. "

	^#(
"#(ClassName #(
#(selector '...')
))"
	) """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"nativeLanguage",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#nativeLanguage
	return smalltalk.String("py") 
""","PythonEncoder_nativeLanguage")
,"accessing","""nativeLanguage
	" Return the nativeLanguage of the receiver. "

	^#py """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"nativeUndefined",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#nativeUndefined
	return smalltalk.String("nil") 
""","PythonEncoder_nativeUndefined")
,"encoding","""nativeUndefined
	" Private - Return the code for undefined. "

	^#nil """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"nativeNameOfMetaClass:",0
,smalltalk.__f__("""(self,aClass):
	#PythonEncoder>>#nativeNameOfMetaClass:
	return smalltalk.object_comma_(aClass.instanceClass().name(),smalltalk.String(".__class__")) 
""","PythonEncoder_nativeNameOfMetaClass_")
,"encoding","""nativeNameOfMetaClass: aClass
	" Private - Return the native name for metaclass aClass. "

	^aClass instanceClass name ,'.__class__' """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"startCompiling:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#startCompiling:
	smalltalk.basic_at_put(self,"@indentation",smalltalk.basic_at_put(self,"@blocks",smalltalk.basic_at_put(self,"@scopes",nil))) 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).startCompiling_(aNode) 
""","PythonEncoder_startCompiling_")
,"private","""startCompiling: aNode
	" Private - Set the receiver to start emmiting code for aNode. "

	indentation := blocks := scopes := nil.
	^super startCompiling: aNode""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"separatorOp",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#separatorOp
	return smalltalk.String(" ") 
""","PythonEncoder_separatorOp")
,"constants","""separatorOp
	" Private - Return the OP for separating statements. "

	^$ """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"indentation",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#indentation
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@indentation",nil))):
		smalltalk.basic_at_put(self,"@indentation",smalltalk.Number(0)) 
	 
	return getattr(self,"@indentation",nil) 
""","PythonEncoder_indentation")
,"indentation","""indentation
	" Private - Return the indentation of the receiver. "

	indentation isNil ifTrue: [ indentation := 0 ].
	^indentation """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"indent",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#indent
	smalltalk.basic_at_put(self,"@indentation",self.indentation()._plus(smalltalk.Number(1))) 
	self.cr() 
	return self 
""","PythonEncoder_indent")
,"indentation","""indent
	" Private - Enter the next level of indentation. "

	indentation := self indentation + 1.
	self cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"dedent",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#dedent
	smalltalk.basic_at_put(self,"@indentation",self.indentation()._minus(smalltalk.Number(1)).max_(smalltalk.Number(0))) 
	self.cr() 
	return self 
""","PythonEncoder_dedent")
,"indentation","""dedent
	" Private - Exit the current level of indentation. "

	indentation := self indentation - 1 max: 0.
	self cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"saveState",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#saveState
	def __blk1__(_s8_rec):
		_s8_rec.add_(self.indentation()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.superReceiver(smalltalk.PythonEncoder,self).saveState()) 
""","PythonEncoder_saveState")
,"state","""saveState
	" Private - Return the state of the receiver. "

	^super saveState
		add: self indentation;
		yourself """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"restoreState:",0
,smalltalk.__f__("""(self,array):
	#PythonEncoder>>#restoreState:
	smalltalk.superReceiver(smalltalk.PythonEncoder,self).restoreState_(array) 
	smalltalk.basic_at_put(self,"@indentation",array.third()) 
	return self 
""","PythonEncoder_restoreState_")
,"state","""restoreState: array
	" Private - Restore the state of the receiver. "

	super restoreState: array.
	indentation := array third """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"cr",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#cr
	def __blk1__():
		return getattr(self,"@stream",nil).nextPut_(smalltalk.String.tab()) 
	smalltalk.superReceiver(smalltalk.PythonEncoder,self).cr() 
	smalltalk.times_repeat_(self.indentation(),smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_cr")
,"writing","""cr
	" Private - Emmit a new line onto output stream. "

	super cr.
	self indentation timesRepeat: [
		stream nextPut: String tab
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"nextBlockPut:",0
,smalltalk.__f__("""(self,aBlock):
	#PythonEncoder>>#nextBlockPut:
	self.indent() 
	aBlock.evaluate() 
	self.dedent() 
	return self 
""","PythonEncoder_nextBlockPut_")
,"writing","""nextBlockPut: aBlock
	" Private - Evaluates aBlock on the next level of indentation. "

	self indent.
	aBlock evaluate.
	self dedent """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"macroStream:",0
,smalltalk.__f__("""(self,macro):
	#PythonEncoder>>#macroStream:
	def __blk1__(_s8_rec):
		_s8_rec.skipSeparators() 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.superReceiver(smalltalk.PythonEncoder,self).macroStream_(macro)) 
""","PythonEncoder_macroStream_")
,"optimizing","""macroStream: macro
	" Private - Return a code stream from macro string. "

	^(super macroStream: macro)
		skipSeparators;
		yourself""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"basicMacro:in:with:",0
,smalltalk.__f__("""(self,macro,input,aNode):
	#PythonEncoder>>#basicMacro:in:with:
	def __blk1__():
		return macro.startsWith_(smalltalk.String("-")) 
	if smalltalk.b(smalltalk.newArray(["true","false",">","<",","]).includes_(macro)):
		if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String(">"))):
			return self.indent() 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String("<"))):
			return self.dedent() 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(macro,smalltalk.String(","))):
			return self.nextPutAll_(smalltalk.String("smalltalk.object_comma_")) 
		 
		return self.nextPutAll_(smalltalk.object_comma_(smalltalk.String("smalltalk."),macro)) 
	 
	if smalltalk.b(smalltalk.boolean_or_(macro.first().isDigit(),smalltalk.blk(__blk1__,0))):
		return self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.Number("),macro),smalltalk.String(")"))) 
	 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).basicMacro_in_with_(macro,input,aNode) 
""","PythonEncoder_basicMacro_in_with_")
,"optimizing","""basicMacro: macro in: input with: aNode
	" Private - Visit aNode encoding/expanding basic macros in input. "

	(#( #true #false #> #< #, ) includes: macro) ifTrue: [
		macro = #> ifTrue: [ ^self indent ].
		macro = #< ifTrue: [ ^self dedent ].
		macro = #, ifTrue: [ ^self nextPutAll: 'smalltalk.object_comma_' ].
		^self nextPutAll: 'smalltalk.' ,macro " %true% %false% "
	].
	(macro first isDigit or: [macro startsWith: $-]) ifTrue: [ " %aNumber% "
		^self nextPutAll: 'smalltalk.Number(' ,macro ,$)
	].
	^super basicMacro: macro in: input with: aNode """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitInlinedCode:",0
,smalltalk.__f__("""(self,code):
	#PythonEncoder>>#emmitInlinedCode:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.input.atEnd() 
	__0__.input=nil
	__0__.input=code.readStream() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk2__():
			return self.cr() 
		self.emmitCode_(__0__.input.nextLine()) 
		smalltalk.if_true_false_(__0__.input.atEnd(),nil,smalltalk.blk(__blk2__,0)) 
	 
	return self 
""","PythonEncoder_emmitInlinedCode_")
,"generation","""emmitInlinedCode: code
	" Private - Emmit inlined code onto output stream. "

	| input |
	input := code readStream.
	[input atEnd] whileFalse: [
		self emmitCode: input nextLine.
		input atEnd ifFalse: [ self cr ]
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitFunctionStart:",0
,smalltalk.__f__("""(self,fName):
	#PythonEncoder>>#emmitFunctionStart:
	return self 
""","PythonEncoder_emmitFunctionStart_")
,"generation","""emmitFunctionStart: fName
	" Private - Emmit the code of function start definition. "

	"self nextPutAll: #function" """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"missingNativeCodeFor:as:",0
,smalltalk.__f__("""(self,aNode,lang):
	#PythonEncoder>>#missingNativeCodeFor:as:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('self.invalidMessage_(smalltalk.String("'),getattr(self,"@compiler",nil).selector()),smalltalk.String('"))')) 
""","PythonEncoder_missingNativeCodeFor_as_")
,"inlines","""missingNativeCodeFor: aNode as: lang
	" Private - Return the native language code for missing expression (or nil). "

	^'self.invalidMessage_(smalltalk.String("' ,compiler selector ,'"))'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"callEscape",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#callEscape
	return smalltalk.String("#_") 
""","PythonEncoder_callEscape")
,"accessing","""callEscape
	" Private - Return the selector sequence to escape OO message send selector, and produce code for function call.
	Note that an alien selector starting with two $$ are understood as a function call to function starting with $
	"

	^'#_'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"canExportMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#PythonEncoder>>#canExportMethod:
	__0__=smalltalk.newContext()
	__0__.array=nil
	return smalltalk.true 
""","PythonEncoder_canExportMethod_")
,"private","""canExportMethod: aMethod
	" Private - Return true if the receiver can/want to export method aMethod.
	Patching Encoder to export ONLY the test methods/classes
	"

	| array |
"	array := #( Object Point
		Behavior Class Metaclass
		CompiledMethod Smalltalk String Number
		) collect: [:each| Smalltalk at: each ].
	(array includes: aMethod classField instanceClass) ifFalse: [ ^false ].
""	#( _test ) do: [:key| (aMethod category includes: key) ifFalse: [ ^false ] ].
""	^aMethod classField ~= String or: [
		aMethod selector ~= #replace:with:
	]
"	^true
	""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"asSelector:",0
,smalltalk.__f__("""(self,aSelector):
	#PythonEncoder>>#asSelector:
	return aSelector.asPythonSelector() 
""","PythonEncoder_asSelector_")
,"converting","""asSelector: aSelector
	" Return the native representation of aSelector. "

	^aSelector asPythonSelector""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"nativeSourceFor:",0
,smalltalk.__f__("""(self,aMethod):
	#PythonEncoder>>#nativeSourceFor:
	def __blk1__():
		return self.privateSourceFor_(aMethod) 
	return smalltalk.if_true_false_(self.canExportMethod_(aMethod),smalltalk.blk(__blk1__,0),nil) 
""","PythonEncoder_nativeSourceFor_")
,"private","""nativeSourceFor: aMethod
	" Private - Return the code of native function implementing aMethod. "

	^(self canExportMethod: aMethod) ifTrue: [
		self privateSourceFor: aMethod
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"export:method:on:",0
,smalltalk.__f__("""(self,aClass,aMethod,aStream):
	#PythonEncoder>>#export:method:on:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.bind("),self.smalltalkNameFor_(aClass)),smalltalk.String(",")),__0__.selectorName),smalltalk.String(",")),__0__.fName)) 
		_s8_rec.cr() 
		_s8_rec.nextPutAll_(smalltalk.String(",")) 
		return _s8_rec.nextPutAll_(__0__.source) 
	def __blk2__():
		return aMethod.source().notEmpty() 
	def __blk3__():
		return smalltalk.notNil_(aMethod.stamp()) 
	def __blk4__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String(")")) 
		return _s8_rec.cr() 
	__0__.fName=nil
	__0__.selectorName=nil
	__0__.bar=nil
	__0__.source=nil
	__0__.source=self.nativeSourceFor_(aMethod) 
	if smalltalk.b(smalltalk.isNil_(__0__.source)):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isNil_(aMethod)):
		self.error_(smalltalk.String("Method is missing")) 
	 
	__0__.bar=smalltalk.String('"') 
	__0__.fName=aMethod.selector() 
	if smalltalk.b(__0__.fName.first().isBackSlash()):
		__0__.selectorName=self.escaped_(aMethod.selector()) 
		__0__.fName=self.escaped_(self.asSelector_(__0__.fName)) 
	else:
		def __blk5__():
			__0__.fName=smalltalk.Number(0)
			return __0__.fName 
		def __blk6__():
			__0__.fName=smalltalk.object_comma_(smalltalk.object_comma_(__0__.bar,self.asSelector_(__0__.fName)),__0__.bar)
			return __0__.fName 
		__0__.selectorName=smalltalk.object_comma_(smalltalk.object_comma_(__0__.bar,aMethod.selector()),__0__.bar) 
		smalltalk.if_true_false_(smalltalk.isObject_equalTo_(self.asSelector_(__0__.fName),aMethod.selector().replace_with_(smalltalk.String(":"),smalltalk.String("_"))),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
	 
	__blk1__(aStream) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aMethod.source()),smalltalk.blk(__blk2__,0))):
		__1__=smalltalk.newContext()
		def __blk7__(_s8_rec):
			_s8_rec.cr() 
			return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aMethod.category())),smalltalk.String(",")),self.escaped_(aMethod.source())),smalltalk.String(",")),__1__.compiledSource)) 
		__1__.compiledSource=nil
		__1__.compiledSource=smalltalk.String("nil") 
		__blk7__(aStream) 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.responds_to_(aMethod,(smalltalk.String("stamp"))),smalltalk.blk(__blk3__,0))):
		aStream.nextPutAll_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aMethod.stamp()))) 
	 
	__blk4__(aStream) 
	return smalltalk.true 
""","PythonEncoder_export_method_on_")
,"export","""export: aClass method: aMethod on: aStream
	" Export a method definition of aClass onto aStream. "

	| fName selectorName bar source |
	source := self nativeSourceFor: aMethod.
	source isNil ifTrue: [ ^false ].
	aMethod isNil ifTrue: [ self error: 'Method is missing' ].
	bar := $".
	fName := aMethod selector.
	fName first isBackSlash ifTrue: [
		selectorName := self escaped: aMethod selector.
		fName := self escaped: (self asSelector: fName).
	] ifFalse: [
		selectorName := bar ,aMethod selector, bar.
		(self asSelector: fName) = (aMethod selector replace: $: with: $_) ifTrue: [
			fName := 0
		] ifFalse: [
			fName := bar ,(self asSelector: fName) ,bar
		].
	].
	aStream
		nextPutAll: 'smalltalk.bind(' ,(self smalltalkNameFor: aClass)
			,',' ,selectorName ,',' ,fName;
		cr;nextPutAll: ','; nextPutAll: source.
	(aMethod source notNil and: [ aMethod source notEmpty ]) ifTrue: [
		| compiledSource |
		compiledSource := "self escaped: source." #nil.
		aStream cr; "warning: this cr is important for debugger"
			nextPutAll: ',' ,(self escaped: aMethod category)
				,',' ,(self escaped: aMethod source)
				,',' ,compiledSource
	].
	((aMethod respondsTo: #stamp) and: [ aMethod stamp notNil ]) ifTrue: [
		aStream nextPutAll: ',' ,(self escaped: aMethod stamp)
	].
	aStream nextPutAll: ')'; cr.
	^true""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"arrayLiteralStart",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#arrayLiteralStart
	return smalltalk.String("smalltalk.newArray([") 
""","PythonEncoder_arrayLiteralStart")
,"code","""arrayLiteralStart
	" Private - Return the code string to start exporting an array literal. "

	^'smalltalk.newArray(['""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"arrayLiteralEnd",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#arrayLiteralEnd
	return smalltalk.String("])") 
""","PythonEncoder_arrayLiteralEnd")
,"code","""arrayLiteralEnd
	" Private - Return the code string to end exporting an array literal. "

	^'])'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"functionStart",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#functionStart
	return smalltalk.String("smalltalk.__f__(") 
""","PythonEncoder_functionStart")
,"code","""functionStart
	" Private - Return the code string to start a function. "

	^'smalltalk.__f__('""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"functionEnd",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#functionEnd
	if smalltalk.b(smalltalk.true):
		__1__=smalltalk.newContext()
		__1__.tag=nil
		__1__.tag=smalltalk.object_comma_(smalltalk.object_comma_(self.compiler().currentClass().name(),smalltalk.String("_")),self.asSelector_(self.compiler().selector())) 
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"'),__1__.tag.replace_with_(smalltalk.String(" "),smalltalk.String("_"))),smalltalk.String('")')) 
	 
	return smalltalk.String(")") 
""","PythonEncoder_functionEnd")
,"code","""functionEnd
	" Private - Return the code string to end a function. "

"DEBUG"	true ifTrue: [ "add debug tag to functions"
	| tag |
	tag := self compiler currentClass name 
		,$_ ,(self asSelector: self compiler selector).
	^',"' ,(tag replace: $ with: $_) ,'")'
].

	^$)""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"escaped:",0
,smalltalk.__f__("""(self,string):
	#PythonEncoder>>#escaped:
	return string.asPythonString() 
""","PythonEncoder_escaped_")
,"literals","""escaped: string
	" Private - Return the code string to export string literal. "

	^string asPythonString """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"exportDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#PythonEncoder>>#exportDefinitionOf:on:
	def __blk1__(each):
		def __blk2__():
			def __blk3__(_s8_rec):
				_s8_rec.nextPutAll_(each) 
				return _s8_rec.cr() 
			return __blk3__(aStream) 
		def __blk4__():
			return aStream.fileOutOn_(aStream) 
		return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk4__,0)) 
	def __blk5__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk.addClass("'),aClass.name()),smalltalk.String('",'))) 
		_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass.superclass())) 
		return _s8_rec.nextPutAll_(smalltalk.String(",")) 
	def __blk6__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"'),aClass.category()),smalltalk.String('"'))) 
		_s8_rec.nextPutAll_(smalltalk.String(")")) 
		return _s8_rec.cr() 
	def __blk7__():
		return aClass.comment().notEmpty() 
	self.loadRequirementsOf_(aClass).do_(smalltalk.blk(__blk1__,1)) 
	__blk5__(aStream) 
	if smalltalk.b(aClass.instanceVariableNames().isEmpty()):
		aStream.nextPutAll_(smalltalk.String("nil")) 
	else:
		self.export_literals_on_(smalltalk.String("[]"),aClass.instanceVariableNames(),aStream) 
	 
	__blk6__(aStream) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aClass.comment()),smalltalk.blk(__blk7__,0))):
		def __blk8__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String("setattr("),self.smalltalkNameFor_(aClass))) 
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"$comment",'),self.escaped_(aClass.comment())),smalltalk.String(")"))) 
			return _s8_rec.cr() 
		__blk8__(aStream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.classVariables())):
		def __blk9__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String("setattr("),self.smalltalkNameFor_(aClass))) 
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"$classVariableNames",'),self.escaped_(aClass.classVariablesString())),smalltalk.String(")"))) 
			return _s8_rec.cr() 
		__blk9__(aStream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.poolDictionaries())):
		def __blk10__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String("setattr("),self.smalltalkNameFor_(aClass))) 
			return _s8_rec.nextPutAll_(smalltalk.String(',"$poolDictionaries",')) 
		def __blk11__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String(")")) 
			return _s8_rec.cr() 
		__blk10__(aStream) 
		self.exportArrayLiteral_on_newLine_(aClass.poolDictionaries(),aStream,smalltalk.false) 
		__blk11__(aStream) 
	 
	if smalltalk.b(aClass.propertyNames().notEmpty()):
		def __blk12__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String("setattr("),self.smalltalkNameFor_(aClass))) 
			return _s8_rec.nextPutAll_(smalltalk.String(',"$propertyNames",')) 
		def __blk13__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String(")")) 
			return _s8_rec.cr() 
		__blk12__(aStream) 
		self.exportArrayLiteral_on_newLine_(aClass.propertyNames(),aStream,smalltalk.false) 
		__blk13__(aStream) 
	 
	return self 
""","PythonEncoder_exportDefinitionOf_on_")
,"export","""exportDefinitionOf: aClass on: aStream
	" Export definition of aClass onto aStream. "

	(self loadRequirementsOf: aClass) do: [:each|
		each isString
		ifTrue: [ aStream nextPutAll: each;cr ]
		ifFalse: [ aStream fileOutOn: aStream ].
	].
	aStream 
	    nextPutAll: 'smalltalk.addClass("', aClass name, '",';
	    nextPutAll: (self smalltalkNameFor: aClass superclass);
	    nextPutAll: ','.
	aClass instanceVariableNames isEmpty
		ifTrue: [ aStream nextPutAll: #nil ]
		ifFalse: [ self export: '[]' literals: aClass instanceVariableNames on: aStream ].
	aStream
	    nextPutAll: ',"' ,aClass category, $";
	    nextPutAll: ')'; cr.
	(aClass comment notNil and: [aClass comment notEmpty]) ifTrue: [
	    aStream
		nextPutAll: 'setattr(' ,(self smalltalkNameFor: aClass);
		nextPutAll: ',"$comment",' ,(self escaped: aClass comment) ,')'; cr
	].
	aClass classVariables notNil ifTrue: [
	    aStream
		nextPutAll: 'setattr(' ,(self smalltalkNameFor: aClass);
		nextPutAll: ',"$classVariableNames",' ,(self escaped: aClass classVariablesString) ,')'; cr
	].
	aClass poolDictionaries notNil ifTrue: [
	    aStream
		nextPutAll: 'setattr(' ,(self smalltalkNameFor: aClass);
		nextPutAll: ',"$poolDictionaries",'.
	   self exportArrayLiteral: aClass poolDictionaries on: aStream newLine: false.
	   aStream nextPutAll: ')'; cr
	].
	aClass propertyNames notEmpty ifTrue: [
	    aStream
		nextPutAll: 'setattr(' ,(self smalltalkNameFor: aClass);
		nextPutAll: ',"$propertyNames",'.
	   self exportArrayLiteral: aClass propertyNames on: aStream newLine: false.
	   aStream nextPutAll: ')'; cr
	].""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"exportMetaDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#PythonEncoder>>#exportMetaDefinitionOf:on:
	if smalltalk.b((aClass).__class__.instanceVariableNames().notEmpty()):
		def __blk1__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String("smalltalk.setVarNames(")) 
			_s8_rec.nextPutAll_(self.smalltalkNameFor_((aClass).__class__)) 
			return _s8_rec.nextPutAll_(smalltalk.String(",")) 
		def __blk2__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String(")")) 
			return _s8_rec.cr() 
		__blk1__(aStream) 
		self.exportArrayLiteral_on_newLine_((aClass).__class__.instanceVariableNames(),aStream,smalltalk.false) 
		__blk2__(aStream) 
	 
	if smalltalk.b((aClass).__class__.propertyNames().notEmpty()):
		def __blk3__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String("smalltalk.setPropertyNames(")) 
			_s8_rec.nextPutAll_(self.smalltalkNameFor_((aClass).__class__)) 
			return _s8_rec.nextPutAll_(smalltalk.String(",")) 
		def __blk4__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String(")")) 
			return _s8_rec.cr() 
		__blk3__(aStream) 
		self.exportArrayLiteral_on_newLine_((aClass).__class__.propertyNames(),aStream,smalltalk.false) 
		__blk4__(aStream) 
	 
	return self 
""","PythonEncoder_exportMetaDefinitionOf_on_")
,"export","""exportMetaDefinitionOf: aClass on: aStream
	" Export class side definition of aClass onto aStream. "

	aClass class instanceVariableNames notEmpty ifTrue: [
		aStream	nextPutAll: 'smalltalk.setVarNames(';
			nextPutAll: (self smalltalkNameFor: aClass class);
			nextPutAll: $,.
		self exportArrayLiteral: aClass class instanceVariableNames on: aStream newLine: false.
		aStream nextPutAll: ')'; cr
	].

	aClass class propertyNames notEmpty ifTrue: [
		aStream	nextPutAll: 'smalltalk.setPropertyNames(';
			nextPutAll: (self smalltalkNameFor: aClass class);
			nextPutAll: $,.
		self exportArrayLiteral: aClass class propertyNames on: aStream newLine: false.
		aStream nextPutAll: ')'; cr
	].""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"privateSourceFor:",0
,smalltalk.__f__("""(self,aMethod):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#privateSourceFor:
		__0__=smalltalk.newContext()
		def __blk1__():
			return self.privateCodeFor_(aMethod) 
		def __blk2__(ex):
			self.note_(aMethod) 
			return self.privateNIYSourceFor_with_(aMethod,ex.description()) 
		__0__.code=nil
		if smalltalk.b(smalltalk.Smalltalk.isRunningOn_(self.nativeLanguage())):
			def __blk3__():
				nil 
			def __blk4__():
				return smalltalk.raise_result_(_s8Ret_,__0__.code) 
			__0__.code=smalltalk.basic_at_ifAbsent_(aMethod,smalltalk.String("$nativeSource"),smalltalk.blk(__blk3__,0)) 
			smalltalk.if_true_false_(smalltalk.notNil_(__0__.code),smalltalk.blk(__blk4__,0),nil) 
		 
		__0__.code=smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(smalltalk.object_comma_(self.functionStart(),self.escaped_(__0__.code)),self.functionEnd())) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_privateSourceFor_")
,"py","""privateSourceFor: aMethod
	" Private - Return the native code implementing aMethod. "

	| code |
	(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [
		code := aMethod basicAt: '$nativeSource' ifAbsent: [].
		code notNil ifTrue: [ ^code ].
	].

	code := [ self privateCodeFor: aMethod ] on: Exception do: [:ex|
		self note: aMethod.
		self privateNIYSourceFor: aMethod with: ex description
	].
	^self functionStart ,(self escaped: code) ,self functionEnd """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"privateNIYSourceFor:with:",0
,smalltalk.__f__("""(self,aMethod,description):
	#PythonEncoder>>#privateNIYSourceFor:with:
	return smalltalk.object_comma_(self.privateMethodDefinition_(aMethod),self.privateMethodBody_with_(aMethod,description)) 
""","PythonEncoder_privateNIYSourceFor_with_")
,"niy","""privateNIYSourceFor: aMethod with: description
	" Private - Return the native code implementing aMethod. "

	^(self privateMethodDefinition: aMethod)
	,(self privateMethodBody: aMethod with: description)""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"privateMethodDefinition:",0
,smalltalk.__f__("""(self,aMethod):
	#PythonEncoder>>#privateMethodDefinition:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.upTo_(smalltalk.String("(")) 
		return _s8_rec.upTo_(smalltalk.String(")")) 
	__0__.args=nil
	__0__.args=__blk1__(aMethod.compiledSource().stream()) 
	if smalltalk.b(__0__.args.notEmpty()):
		def __blk2__(total,each):
			return smalltalk.object_comma_(smalltalk.object_comma_(total,smalltalk.String(",")),each.asPythonName()) 
		__0__.args=__0__.args.asArrayOfSubstringsSeparatedBy_(smalltalk.String(",")).inject_into_(smalltalk.String(""),smalltalk.blk(__blk2__,2)) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("(self"),__0__.args),smalltalk.String(")")) 
""","PythonEncoder_privateMethodDefinition_")
,"niy","""privateMethodDefinition: aMethod
	" Private - Return the (Python) method definition of aMethod. "

	| args |
	args := aMethod compiledSource stream upTo: $(; upTo: $).
	args notEmpty ifTrue: [
		args := (args asArrayOfSubstringsSeparatedBy: $,)
			inject: '' into: [:total :each| total ,',' ,each asPythonName ].
	].
	^'(self' ,args ,')'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"privateMethodBody:with:",0
,smalltalk.__f__('''(self,aMethod,description):
	#PythonEncoder>>#privateMethodBody:with:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("""
	print("NIY:#privateMethodBody: """),aMethod),smalltalk.String(" - ")),description),smalltalk.String("""")
	return self""")) 
''',"PythonEncoder_privateMethodBody_with_")
,"niy","""privateMethodBody: aMethod with: description
	" Private - Return the (Python) body of aMethod. "

	^'
print("NIY:#privateMethodBody: ',aMethod,' - ',description,'")
return self'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"privateCodeFor:",0
,smalltalk.__f__("""(self,aMethod):
	#PythonEncoder>>#privateCodeFor:
	def __blk1__(_s8_rec):
		_s8_rec.encoder_(self) 
		return _s8_rec.compile_(aMethod.source()) 
	self.compiler_(aMethod.classField().compiler()) 
	return __blk1__(self.compiler()) 
""","PythonEncoder_privateCodeFor_")
,"compiling","""privateCodeFor: aMethod
	" Private - Return the native code translated from sources of aMethod. "

	self compiler: aMethod classField compiler.
	^self compiler
		encoder: self;
		compile: aMethod source""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"codeToAccessProperty:in:",0
,smalltalk.__f__("""(self,aName,aNode):
	#PythonEncoder>>#codeToAccessProperty:in:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('getattr(self,"'),aName),smalltalk.String('",nil)')) 
""","PythonEncoder_codeToAccessProperty_in_")
,"generation","""codeToAccessProperty: aName in: aNode
	" Private - Return the source code to access property aName. "

	^'getattr(self,"',aName,'",nil)'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitFunctionBody:",0
,smalltalk.__f__("""(self,aBlock):
	#PythonEncoder>>#emmitFunctionBody:
	self.nextPutAll_(smalltalk.String(":")) 
	self.nextBlockPut_(aBlock) 
	return self 
""","PythonEncoder_emmitFunctionBody_")
,"generation","""emmitFunctionBody: aBlock
	" Private - Emmit the code of function body evaluating aBlock. "

	self nextPutAll: $:.
	self nextBlockPut: aBlock """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitEnterMethod:",0
,smalltalk.__f__("""(self,aMethodNode):
	#PythonEncoder>>#emmitEnterMethod:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String("#"),self.currentMethodInfo())) 
		return _s8_rec.cr() 
	__blk1__(self) 
	return self 
""","PythonEncoder_emmitEnterMethod_")
,"generation","""emmitEnterMethod: aMethodNode
	" Private - Generate home context definitions, entering aMethodNode. "

"DEBUG"	self nextPutAll: $# ,self currentMethodInfo; cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"newMethodFunctionName",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#newMethodFunctionName
	return smalltalk.String("smalltalk.newMethod") 
""","PythonEncoder_newMethodFunctionName")
,"generation","""newMethodFunctionName
	" Private - Return the function to call when installing a new method. "

	^'smalltalk.newMethod'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitFunction:node:withSelf:arguments:doing:",0
,smalltalk.__f__("""(self,fName,aNode,withSelf,argumentNames,aBlock):
	#PythonEncoder>>#emmitFunction:node:withSelf:arguments:doing:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		self.tempVariables().add_(each) 
		return __0__.aStream.nextPutAll_(self.localName_(each)) 
	def __blk2__():
		return __0__.aStream.nextPutAll_(self.argumentsSeparatorOp()) 
	__0__.aStream=nil
	__0__.aStream=smalltalk.String("").writeStream() 
	if smalltalk.b(withSelf):
		def __blk3__():
			return __0__.aStream.nextPutAll_(self.argumentsSeparatorOp()) 
		__0__.aStream.nextPutAll_(smalltalk.String("self")) 
		smalltalk.if_true_false_(argumentNames.notEmpty(),smalltalk.blk(__blk3__,0),nil) 
	 
	argumentNames.do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	self.emmitFunction_arguments_doing_(fName,__0__.aStream.contents(),aBlock) 
	return self 
""","PythonEncoder_emmitFunction_node_withSelf_arguments_doing_")
,"generation","""emmitFunction: fName node: aNode withSelf: withSelf arguments: argumentNames doing: aBlock
	" Private - Generate function for aNode. "

	| aStream |
	aStream := '' writeStream.
	withSelf ifTrue: [
		aStream nextPutAll: #self.
		argumentNames notEmpty ifTrue: [ aStream nextPutAll: self argumentsSeparatorOp ].
	].
	argumentNames do: [:each | 
		self tempVariables add: each.
		aStream nextPutAll: (self localName: each) ]
	    separatedBy: [ aStream nextPutAll: self argumentsSeparatorOp ].
	self	emmitFunction: fName
		arguments: aStream contents
		doing: aBlock""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitFunction:node:arguments:doing:",0
,smalltalk.__f__("""(self,fName,aNode,argumentNames,aBlock):
	#PythonEncoder>>#emmitFunction:node:arguments:doing:
	return self.emmitFunction_node_withSelf_arguments_doing_(fName,aNode,smalltalk.true,argumentNames,aBlock) 
""","PythonEncoder_emmitFunction_node_arguments_doing_")
,"generation","""emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock
	" Private - Generate function for aNode. "

	^self	emmitFunction: fName node: aNode
		withSelf: true arguments: argumentNames
		doing: aBlock""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitFunction:node:doing:",0
,smalltalk.__f__("""(self,fName,aNode,aBlock):
	#PythonEncoder>>#emmitFunction:node:doing:
	return self.emmitFunction_node_withSelf_arguments_doing_(fName,aNode,smalltalk.true,aNode.argumentNames(),aBlock) 
""","PythonEncoder_emmitFunction_node_doing_")
,"generation","""emmitFunction: fName node: aNode doing: aBlock
	" Private - Generate function for aNode. "

	^self	emmitFunction: fName node: aNode
		withSelf: true arguments: aNode argumentNames
		doing: aBlock""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitEmptyNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitEmptyNode:
	self.nextPutAll_(smalltalk.String("pass")) 
	return self 
""","PythonEncoder_visitEmptyNode_")
,"visiting","""visitEmptyNode: aNode
	" Private - Visit an empty node, aNode. "

	self nextPutAll: #pass """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitMethodNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitMethodNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__(_s8_rec):
			_s8_rec.nextPutAll_(self.smalltalkNameFor_(self.currentClass())) 
			_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(',"'),aNode.selector()),smalltalk.String('",'))) 
			return _s8_rec.cr() 
		def __blk3__(_s8_rec):
			_s8_rec.nextPutAll_(self.functionStart()) 
			_s8_rec.nextPutAll_(self.escaped_(__0__.nativeSource)) 
			return _s8_rec.nextPutAll_(self.functionEnd()) 
		def __blk4__():
			def __blk5__(_s8_rec):
				_s8_rec.cr() 
				_s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.String(","),self.escaped_(aNode.source()))) 
				return _s8_rec.nextPutAll_(smalltalk.String(",nil")) 
			return __blk5__(self) 
		__blk2__(self) 
		__blk3__(self) 
		return smalltalk.if_true_false_(self.includeSourceCode(),smalltalk.blk(__blk4__,0),nil) 
	__0__.nativeSource=nil
	self.emmitMethod_(aNode) 
	if not smalltalk.b(smalltalk.Smalltalk.isRunningOn_(self.nativeLanguage())):
		return self 
	 
	__0__.nativeSource=getattr(self,"@stream",nil).contents() 
	self.restoreState_(smalltalk.Array.with_with_with_(smalltalk.String("").writeStream(),smalltalk.Number(0),smalltalk.Number(0))) 
	self.nextPutAll_(self.newMethodFunctionName()) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_visitMethodNode_")
,"visiting","""visitMethodNode: aNode
	" Visit a method node. "

	| nativeSource |
	self emmitMethod: aNode.
	(Smalltalk isRunningOn: self nativeLanguage) ifFalse: [ ^self ].

	nativeSource := stream contents.
	self restoreState: (Array with: '' writeStream with: 0 with: 0).
	self nextPutAll: self newMethodFunctionName.
	self nextArgumentsPut: [
		self
			nextPutAll: (self smalltalkNameFor: self currentClass);
			nextPutAll: ',"', aNode selector, '",'; cr.
		self	nextPutAll: self functionStart;
			nextPutAll: (self escaped: nativeSource);
			nextPutAll: self functionEnd.
		self includeSourceCode ifTrue: [
			self	cr; "warning: this cr is important for debugger"
				nextPutAll: ',' ,(self escaped: aNode source)
				;nextPutAll: ',nil' ",(self escaped: nativeSource)"
		]
	] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitDirectiveNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitDirectiveNode:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.separatorOp()) 
		return _s8_rec.cr() 
	if smalltalk.b(smalltalk.responds_to_(aNode,(smalltalk.String("asNative:for:on:")))):
		def __blk2__(_s8_rec):
			_s8_rec.nextPutAll_(aNode.asNative_for_on_(getattr(self,"@functionName",nil),self,getattr(self,"@stream",nil))) 
			return _s8_rec.cr() 
		__blk2__(self) 
		return self 
	 
	self.visit_(aNode) 
	__blk1__(self) 
	return self 
""","PythonEncoder_visitDirectiveNode_")
,"visiting","""visitDirectiveNode: aNode
	" Private - Visit a directive node. "

	(aNode respondsTo: #asNative:for:on:) ifTrue: [
		self nextPutAll: (aNode
			asNative: functionName
			for: self on: stream); cr.
		^self
	].

	self visit: aNode.
	self nextPutAll: self separatorOp; cr""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitedCode",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#emmitedCode
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@stream",nil))):
		return nil 
	 
	if smalltalk.b(smalltalk.Smalltalk.isRunningOn_(self.nativeLanguage())):
		return smalltalk.object_comma_(smalltalk.String("return "),getattr(self,"@stream",nil).contents()) 
	 
	return getattr(self,"@stream",nil).contents() 
""","PythonEncoder_emmitedCode")
,"results","""emmitedCode
	" Return the emmited code during compilation (or nil). "

	stream isNil ifTrue: [ ^nil ].
	(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [
		"the code must be valid native code including return expression"
		^'return ' ,stream contents
	].
	^stream contents""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"returnOpStart",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#returnOpStart
	if smalltalk.b(getattr(self,"@earlyReturn",nil)):
		return smalltalk.String("smalltalk.raise_result_(_s8Ret_,") 
	 
	return smalltalk.String("return ") 
""","PythonEncoder_returnOpStart")
,"constants","""returnOpStart
	" Private - Return the OP for starting return expressions. "

	earlyReturn ifTrue: [
		^'smalltalk.raise_result_(_s8Ret_,'
	].
	^'return ' """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"returnOpEnd",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#returnOpEnd
	if smalltalk.b(getattr(self,"@earlyReturn",nil)):
		return smalltalk.String(")") 
	 
	return nil 
""","PythonEncoder_returnOpEnd")
,"constants","""returnOpEnd
	" Private - Return the OP for ending return expressions. "

	earlyReturn ifTrue: [
		^$)
	].
	^nil """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"asPythonLiteral:",0
,smalltalk.__f__("""(self,value):
	#PythonEncoder>>#asPythonLiteral:
	return value.asPython() 
""","PythonEncoder_asPythonLiteral_")
,"literals","""asPythonLiteral: value
	" Private - Return the literal representation of value. "

	^value asPython """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitValueNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitValueNode:
	self.nextPutAll_(self.asPythonLiteral_(aNode.value())) 
	return self 
""","PythonEncoder_visitValueNode_")
,"visiting","""visitValueNode: aNode
	" Private - Visit the node emmitting output. "

	self nextPutAll: (self asPythonLiteral: aNode value) """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitNode:index:",0
,smalltalk.__f__("""(self,aNode,index):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#visitNode:index:
		def __blk1__():
			return index.hasString() 
		def __blk2__():
			return self.visit_(index) 
		if smalltalk.b(smalltalk.boolean_and_(index.isMemberOf_(smalltalk.ValueNode),smalltalk.blk(__blk1__,0))):
			__1__=smalltalk.newContext()
			def __blk3__():
				return __1__.selector.includes_(smalltalk.String("_")) 
			def __blk4__():
				def __blk5__(_s8_rec):
					_s8_rec.nextPutAll_(smalltalk.String(".")) 
					return _s8_rec.nextPutAll_(__1__.selector) 
				__blk5__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			__1__.selector=nil
			__1__.selector=self.asSelector_(index.value()) 
			smalltalk.if_true_false_(smalltalk.boolean_or_(__1__.selector.includes_(smalltalk.String(" ")),smalltalk.blk(__blk3__,0)),nil,smalltalk.blk(__blk4__,0)) 
		 
		self.nextIndexPut_(smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_visitNode_index_")
,"visiting","""visitNode: aNode index: index
	" Private - Generate code for indexed access. "

	((index isMemberOf: ValueNode) and: [ index hasString ]) ifTrue: [
		| selector |
		selector := self asSelector: index value.
		((selector includes: $ ) or: [ selector includes: $_ ]) ifFalse: [
			self nextPutAll: '.'; nextPutAll: selector.
			^self
		].
	].
	self nextIndexPut: [ self visit: index ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"nextIndexPut:",0
,smalltalk.__f__("""(self,aBlock):
	#PythonEncoder>>#nextIndexPut:
	self.between_do_(smalltalk.newArray(["[smalltalk.handleOf(",")]"]),aBlock) 
	return self 
""","PythonEncoder_nextIndexPut_")
,"writing","""nextIndexPut: aBlock
	" Private - Emmit a series between indexing notation evaluating aBlock onto output stream. "

	self between: #('[smalltalk.handleOf(' ')]') do: aBlock """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitVariableNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitVariableNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.b_(smalltalk.basic_at_(aNode,smalltalk.String("onAssignment")) is smalltalk.true) 
	def __blk2__():
		return smalltalk.superReceiver(smalltalk.PythonEncoder,self).visitVariableNode_(aNode) 
	__0__.indices=nil
	__0__.indices=aNode.indices() 
	if smalltalk.b(smalltalk.boolean_or_(__0__.indices.isEmpty(),smalltalk.blk(__blk1__,0))):
		return smalltalk.superReceiver(smalltalk.PythonEncoder,self).visitVariableNode_(aNode) 
	 
	self.between_do_(smalltalk.newArray(["smalltalk.asObject_(",")"]),smalltalk.blk(__blk2__,0)) 
	return self 
""","PythonEncoder_visitVariableNode_")
,"variables","""visitVariableNode: aNode
	" Private - Generate code to access variable aNode. "

	| indices |
	indices := aNode indices.
	(indices isEmpty or: [
		(aNode basicAt: #onAssignment) == true
	]) ifTrue: [ ^super visitVariableNode: aNode ].
	self between: #('smalltalk.asObject_(' ')') do: [
		super visitVariableNode: aNode
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"messageSendConnector",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#messageSendConnector
	return smalltalk.String(".") 
""","PythonEncoder_messageSendConnector")
,"encoding","""messageSendConnector
	" Private - Return the connector to use for sending a message. "

	^$. """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"functionCallConnector",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#functionCallConnector
	return smalltalk.String(".") 
""","PythonEncoder_functionCallConnector")
,"encoding","""functionCallConnector
	" Private - Return the connector to use for calling a function. "

	^$. """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"messageSendConnector:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#messageSendConnector:
	if smalltalk.b(smalltalk.isObject_equalTo_(aNode.receiver().messageSendConnector().size(),smalltalk.Number(0))):
		return smalltalk.String("") 
	 
	if smalltalk.b(self.isNativeCall_(aNode)):
		if smalltalk.b(aNode.selector().startsWith_(self.callEscape())):
			return self.functionCallConnector() 
		 
		return self.messageSendConnector() 
	 
	return self.messageSendConnector() 
""","PythonEncoder_messageSendConnector_")
,"accessing","""messageSendConnector: aNode
	" Private - Return the caracter to use for sending message. "

	aNode receiver messageSendConnector size = 0 ifTrue: [ ^'' ].
	(self isNativeCall: aNode) ifTrue: [ "calling an alien"
		(aNode selector startsWith: self callEscape) ifTrue: [
			^self functionCallConnector
		].
		^self messageSendConnector
	].
	^self messageSendConnector """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"asPrivateSelector:",0
,smalltalk.__f__("""(self,aSelector):
	#PythonEncoder>>#asPrivateSelector:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=self.asSelector_(aSelector) 
	if smalltalk.b(aSelector.startsWith_(self.callEscape())):
		return __0__.result.copyFrom_to_(smalltalk.Number(2),__0__.result.size()) 
	 
	return __0__.result 
""","PythonEncoder_asPrivateSelector_")
,"accessing","""asPrivateSelector: aSelector
	" Private - Validate and returns a valid native selector "

	| result |
	result := self asSelector: aSelector.
	(aSelector startsWith: self callEscape) ifTrue: [ "call to an alien starting with _"
		^result copyFrom: 2 to: result size
	].
	^result""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitPrivateMessage:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitPrivateMessage:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.messageSendConnector_(aNode)) 
		return _s8_rec.nextPutAll_(self.asPrivateSelector_(aNode.selector())) 
	__blk1__(self) 
	return self 
""","PythonEncoder_visitPrivateMessage_")
,"visiting","""visitPrivateMessage: aNode
	" Private - Generate code for native message send."

	self
		nextPutAll: (self messageSendConnector: aNode);
		nextPutAll: (self asPrivateSelector: aNode selector)""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"encodeNormalSend:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#encodeNormalSend:
	def __blk1__():
		return self.visitSendArguments_(aNode) 
	self.visitReceiver_(aNode.receiver()) 
	self.visitPrivateMessage_(aNode) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_encodeNormalSend_")
,"visiting","""encodeNormalSend: aNode
	" Private - Generate code for direct/inlined message send."

	self visitReceiver: aNode receiver.
	self visitPrivateMessage: aNode.
	self nextArgumentsPut: [ self visitSendArguments: aNode ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitSendArguments:",0
,smalltalk.__f__("""(self,aSendNode):
	#PythonEncoder>>#visitSendArguments:
	def __blk1__(each):
		return self.visitArgument_(each) 
	def __blk2__():
		return self.nextPutAll_(self.argumentsSeparatorOp()) 
	aSendNode.arguments().do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	return self 
""","PythonEncoder_visitSendArguments_")
,"visiting","""visitSendArguments: aSendNode

	aSendNode arguments 
	    do: [:each | self visitArgument: each ]
	    separatedBy: [ self nextPutAll: self argumentsSeparatorOp ].""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitReceiver:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitReceiver:
	if smalltalk.b(aNode.isAssignment()):
		self.visitLocalAssignment_(aNode) 
	else:
		self.visit_(aNode) 
	 
	return self 
""","PythonEncoder_visitReceiver_")
,"visiting","""visitReceiver: aNode
	" Private - Visit the node (as receiver) emmitting output. "

	aNode isAssignment
	ifTrue: [ self visitLocalAssignment: aNode ]
	ifFalse: [ self visit: aNode ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitGlobalReferenceNode:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#visitGlobalReferenceNode:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				def __blk3__(_s8_rec):
					_s8_rec.nextPutAll_(self.smalltalkNameFor_(__0__.aClass)) 
					_s8_rec.nextPutAll_(smalltalk.String('.classVariableAt_("')) 
					_s8_rec.nextPutAll_(__0__.aName) 
					return _s8_rec.nextPutAll_(smalltalk.String('")')) 
				__blk3__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each,__0__.aName),smalltalk.blk(__blk2__,0),nil) 
		def __blk4__(poolName,pool):
			def __blk5__():
				def __blk6__(_s8_rec):
					_s8_rec.nextPutAll_(smalltalk.String('(smalltalk.poolDictionary_("')) 
					_s8_rec.nextPutAll_(poolName) 
					_s8_rec.nextPutAll_(smalltalk.String('")).at_("')) 
					_s8_rec.nextPutAll_(__0__.aName) 
					return _s8_rec.nextPutAll_(smalltalk.String('")')) 
				__blk6__(self) 
				return smalltalk.raise_result_(_s8Ret_,self) 
			return smalltalk.if_true_false_(pool.includesKey_(__0__.aName),smalltalk.blk(__blk5__,0),nil) 
		def __blk7__(_s8_rec):
			_s8_rec.nextPutAll_(smalltalk.String("smalltalk.")) 
			return _s8_rec.nextPutAll_(aNode.value()) 
		__0__.aName=nil
		__0__.aClass=nil
		__0__.lookupPools=nil
		__0__.aName=aNode.value() 
		__0__.aClass=self.currentClass().instanceClass() 
		__0__.aClass.classVariableNamesDo_(smalltalk.blk(__blk1__,1)) 
		__0__.aClass.sharedPoolsAndNamesDo_(smalltalk.blk(__blk4__,2)) 
		__blk7__(self) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_visitGlobalReferenceNode_")
,"visiting","""visitGlobalReferenceNode: aNode

	| aName aClass lookupPools |
	aName := aNode value.
	aClass := self currentClass instanceClass.
	aClass classVariableNamesDo: [:each|
		each = aName ifTrue: [
			self
				nextPutAll: (self smalltalkNameFor: aClass);
				nextPutAll: '.classVariableAt_("';
				nextPutAll: aName;
				nextPutAll: '")'.
			^self
		]
	].
	aClass sharedPoolsAndNamesDo: [:poolName :pool|
		(pool includesKey: aName) ifTrue: [
			self
				nextPutAll: '(smalltalk.poolDictionary_("';
				nextPutAll: poolName;
				nextPutAll: '")).at_("';
				nextPutAll: aName;
				nextPutAll: '")'.
			^self
		].
	].
	self 
		nextPutAll: 'smalltalk.';
		nextPutAll: aNode value.""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"knownVariables",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#knownVariables
	__0__=smalltalk.newContext()
	def __blk1__(total,scope):
		return smalltalk.object_comma_(total,scope.value()) 
	__0__.locals=nil
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@scopes",nil))):
		return smalltalk.superReceiver(smalltalk.PythonEncoder,self).knownVariables() 
	 
	return smalltalk.object_comma_(smalltalk.superReceiver(smalltalk.PythonEncoder,self).knownVariables(),getattr(self,"@scopes",nil).inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2))) 
""","PythonEncoder_knownVariables")
,"variables","""knownVariables
	" Return the knownVariables of the receiver. "

	| locals |
	scopes isNil ifTrue: [
		^super knownVariables
	].
	^super knownVariables
	,(scopes inject: #() into: [:total :scope|
		total ,scope value
	])""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitInternalAssignment:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#emmitInternalAssignment:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				def __blk3__():
					return self.visit_(aNode.right()) 
				self.between_do_(__0__.tags,smalltalk.blk(__blk3__,0)) 
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.aName,each),smalltalk.blk(__blk2__,0),nil) 
		def __blk4__(each):
			def __blk5__():
				def __blk6__():
					return self.visit_(aNode.right()) 
				self.between_do_(__0__.tags,smalltalk.blk(__blk6__,0)) 
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__0__.aName,each),smalltalk.blk(__blk5__,0),nil) 
		__0__.cls=nil
		__0__.aName=nil
		__0__.tags=nil
		__0__.cls=self.currentClass() 
		__0__.aName=aNode.left().value() 
		__0__.tags=smalltalk.Array.with_with_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk.basic_at_put(self,"@'),__0__.aName),smalltalk.String('",')),smalltalk.String(")")) 
		__0__.cls.allInstVarNamesDo_(smalltalk.blk(__blk1__,1)) 
		__0__.tags=smalltalk.Array.with_with_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk.basic_at_put(self,"'),__0__.aName),smalltalk.String('",')),smalltalk.String(")")) 
		__0__.cls.allPropertyNamesDo_(smalltalk.blk(__blk4__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_emmitInternalAssignment_")
,"assignments","""emmitInternalAssignment: aNode
	" Private - Return true if the receiver emmited the code for internal (i.v. & property) assignment. "

	| cls aName tags |
	cls := self currentClass.
	aName := aNode left value.
	tags := Array with: 'smalltalk.basic_at_put(self,"@',aName,'",' with: $).
	cls allInstVarNamesDo: [:each|
		aName = each ifTrue: [
			self between:tags do: [ self visit: aNode right ].
			^true
		].
	].
	tags := Array with: 'smalltalk.basic_at_put(self,"',aName,'",' with: $).
	cls allPropertyNamesDo: [:each|
		aName = each ifTrue: [
			self between:tags do: [ self visit: aNode right ].
			^true
		].
	].
	^false """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"emmitAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#emmitAssignment:
	__0__=smalltalk.newContext()
	def __blk1__():
		nil 
	__0__.id=nil
	smalltalk.basic_at_put_(aNode.left(),smalltalk.String("onAssignment"),smalltalk.true) 
	__0__.id=smalltalk.basic_at_ifAbsent_(aNode,smalltalk.String("ID"),smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.notNil_(__0__.id)):
		return self.visit_(__0__.id) 
	 
	if smalltalk.b(self.emmitInternalAssignment_(aNode)):
		return self 
	 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).emmitAssignment_(aNode) 
""","PythonEncoder_emmitAssignment_")
,"assignments","""emmitAssignment: aNode

	| id |
	aNode left basicAt: #onAssignment put: true.
	id := aNode basicAt: #ID ifAbsent: [].
	id notNil ifTrue: [ ^self visit: id ].
	(self emmitInternalAssignment: aNode) ifTrue: [ ^self ].
	^super emmitAssignment: aNode """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepareAssignment:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#prepareAssignment:
	def __blk1__():
		def __blk2__(_s8_rec):
			_s8_rec.emmitAssignment_(aNode) 
			return _s8_rec.cr() 
		__blk2__(self) 
		return self.prepareValue_(aNode.left()) 
	aNode.basicAt_ifAbsentPut_(smalltalk.String("ID"),smalltalk.blk(__blk1__,0)) 
	return aNode 
""","PythonEncoder_prepareAssignment_")
,"assignments","""prepareAssignment: aNode
	" Private - Assignments are not valid expressions here,
	 so we must encode the assignment in advance
	 and mark the assignment to do not encode when pushed as value.
	"

	aNode basicAt: #ID ifAbsentPut: [
		self emmitAssignment: aNode; cr.
		self prepareValue: aNode left
	].
	^aNode """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepareSendNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#prepareSendNode:
	def __blk1__(each):
		return self.prepareValue_(each) 
	self.prepareValue_(aNode.receiver()) 
	aNode.arguments().do_(smalltalk.blk(__blk1__,1)) 
	return aNode 
""","PythonEncoder_prepareSendNode_")
,"arguments","""prepareSendNode: aNode
	" Private - Prepare a Send node to be used as value. "

	self prepareValue: aNode receiver.
	aNode arguments do: [:each| self prepareValue: each ].
	^aNode """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepareValue:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#prepareValue:
	if smalltalk.b(aNode.isAssignment()):
		return self.prepareAssignment_(aNode) 
	 
	if smalltalk.b(aNode.isSend()):
		if smalltalk.b(aNode.isCascade()):
			return aNode 
		 
		return self.prepareSendNode_(aNode) 
	 
	return aNode 
""","PythonEncoder_prepareValue_")
,"arguments","""prepareValue: aNode
	" Private - Prepare aNode to be used as a return value.
	Note that code can be generated as side effect of preparation
	e.g. for asignments in return expression or arguments resolution
	Returns the node to be emmited.
	"

	aNode isAssignment ifTrue: [ ^self prepareAssignment: aNode ].
	aNode isSend ifTrue: [
		aNode isCascade ifTrue: [ ^aNode ].
		^self prepareSendNode: aNode
	].
	^aNode """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitSendNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitSendNode:
	self.prepareSendNode_(aNode) 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).visitSendNode_(aNode) 
""","PythonEncoder_visitSendNode_")
,"visiting","""visitSendNode: aNode
	" Private - Visit the node (message send node) emmitting output. "

	self prepareSendNode: aNode.
	^super visitSendNode: aNode""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"registerBlock:id:",0
,smalltalk.__f__("""(self,aNode,aName):
	#PythonEncoder>>#registerBlock:id:
	def __blk1__():
		return self.visitNodesIn_cr_(aNode,smalltalk.true) 
	self.nextPutAll_(smalltalk.object_comma_(smalltalk.String("def "),aName)) 
	self.emmitFunction_node_withSelf_arguments_doing_(aName,aNode,smalltalk.false,aNode.parameterNames(),smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_registerBlock_id_")
,"contexts","""registerBlock: aNode id: aName
	" Private - Dump the block aNode with name aName. "

	self nextPutAll: 'def ' ,aName.
	self	emmitFunction: aName node: aNode
		withSelf: false arguments: aNode parameterNames
		doing: [ self visitNodesIn: aNode cr: true ]  """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"isSendIf:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#isSendIf:
	def __blk1__():
		return smalltalk.newArray(["ifTrue:","ifFalse:","ifTrue:ifFalse:","ifFalse:ifTrue:"]).includes_(aNode.selector()) 
	return smalltalk.boolean_and_(self.hasBlockNoArguments_(aNode),smalltalk.blk(__blk1__,0)) 
""","PythonEncoder_isSendIf_")
,"contexts","""isSendIf: aNode
	" Private - Return true if the block aNode is an If expression. "

	^(self hasBlockNoArguments: aNode) and: [
	#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: aNode selector ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"isSendWhile:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#isSendWhile:
	def __blk1__():
		return smalltalk.newArray(["whileTrue:","whileFalse:"]).includes_(aNode.selector()) 
	return smalltalk.boolean_and_(self.allBlockNoArguments_(aNode),smalltalk.blk(__blk1__,0)) 
""","PythonEncoder_isSendWhile_")
,"contexts","""isSendWhile: aNode
	" Private - Return true if the block aNode is a while expression. "

	^(self allBlockNoArguments: aNode) and: [
	#(whileTrue: whileFalse:) includes: aNode selector ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"willBeInlined:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#willBeInlined:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			def __blk3__():
				def __blk4__():
					def __blk5__():
						return smalltalk.isObject_equalTo_(aNode,__0__.client.receiver())._8not() 
					return smalltalk.boolean_and_(self.isSendWhile_(__0__.client),smalltalk.blk(__blk5__,0)) 
				return smalltalk.boolean_or_(self.isSendIf_(__0__.client),smalltalk.blk(__blk4__,0)) 
			return smalltalk.boolean_and_(self.noClient_(__0__.client),smalltalk.blk(__blk3__,0)) 
		return smalltalk.boolean_and_(__0__.client.isSend(),smalltalk.blk(__blk2__,0)) 
	__0__.client=nil
	__0__.client=aNode.client() 
	return smalltalk.boolean_and_(smalltalk.responds_to_(__0__.client,(smalltalk.String("isSend"))),smalltalk.blk(__blk1__,0)) 
""","PythonEncoder_willBeInlined_")
,"contexts","""willBeInlined: aNode
	" Private - Return true if the block aNode will be optimized to an inline code.
	Note that the implementation is related with optimization of well known messages.
	"

	| client |
	client := aNode client.
	^(client respondsTo: #isSend)
	and: [	client isSend
	and: [	(self noClient: client)
	and: [	(self isSendIf: client)
	or:  [	(self isSendWhile: client) and: [
		aNode ~= client receiver
	]] ]]] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepareBlock:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#prepareBlock:
	__0__=smalltalk.newContext()
	__0__.id=nil
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@blocks",nil))):
		smalltalk.basic_at_put(self,"@blocks",smalltalk.Array.new()) 
	 
	if smalltalk.b(self.willBeInlined_(aNode)):
		return smalltalk.false 
	 
	getattr(self,"@blocks",nil).add_(aNode) 
	__0__.id=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("__blk"),getattr(self,"@blocks",nil).size()),smalltalk.String("__")) 
	smalltalk.basic_at_put_(aNode,smalltalk.String("ID"),__0__.id) 
	self.registerBlock_id_(aNode,__0__.id) 
	return smalltalk.true 
""","PythonEncoder_prepareBlock_")
,"contexts","""prepareBlock: aNode
	" Private - Register the block aNode. "

	| id |
	blocks isNil ifTrue: [ blocks := Array new ].
	(self willBeInlined: aNode) ifTrue: [ ^false ].
	blocks add: aNode.
	id := '__blk' ,blocks size ,'__'.
	aNode basicAt: #ID put: id.
	self registerBlock: aNode id: id.
	^true """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepareBlocksIn:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#prepareBlocksIn:
	def __blk1__(each):
		return each.isBlock() 
	def __blk2__(each):
		return each.isBlock() 
	def __blk3__(each):
		return self.prepareBlock_(each) 
	aNode.with_except_do_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,1)) 
	return self 
""","PythonEncoder_prepareBlocksIn_")
,"contexts","""prepareBlocksIn: aNode
	" Private - Prepare block contexts in aNode. "

	aNode	with: [:each| each isBlock ]
		except: [:each| each isBlock ]
		do: [:each| self prepareBlock: each ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitBlockNode:",0
,smalltalk.__f__("""(self,aNode):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#visitBlockNode:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.String("Broken block - must be registered"))) 
		def __blk2__():
			return smalltalk.false 
		__0__.id=nil
		__0__.count=nil
		__0__.debug=nil
		__0__.id=smalltalk.basic_at_ifAbsent_(aNode,smalltalk.String("ID"),smalltalk.blk(__blk1__,0)) 
		if smalltalk.b(smalltalk.basic_at_ifAbsent_(aNode,smalltalk.String("noWrap"),smalltalk.blk(__blk2__,0))):
			smalltalk.raise_result_(_s8Ret_,self.nextPutAll_(__0__.id)) 
		 
		__0__.count=smalltalk.object_comma_(smalltalk.String(","),aNode.parameters().size()) 
		__0__.debug=self.blockHome_info_(aNode,__0__.id) 
		if smalltalk.b(__0__.debug.notEmpty()):
			__0__.debug=smalltalk.object_comma_(smalltalk.String(","),__0__.debug) 
		 
		self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.blk("),__0__.id),__0__.count),__0__.debug),smalltalk.String(")"))) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_visitBlockNode_")
,"visiting","""visitBlockNode: aNode

	| id count debug |
	id := aNode basicAt: #ID ifAbsent: [
		^self error: 'Broken block - must be registered'
	].
	(aNode basicAt: #noWrap ifAbsent: [false]) ifTrue: [
		^self nextPutAll: id
	].
	count := $, ,aNode parameters size.
	debug := self blockHome: aNode info: id.
	debug notEmpty ifTrue: [ debug := $, ,debug ].
	self nextPutAll: 'smalltalk.blk(' ,id ,count ,debug ,$) """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"blockHome:info:",0
,smalltalk.__f__("""(self,aNode,id):
	#PythonEncoder>>#blockHome:info:
	if smalltalk.b(smalltalk.true):
		return smalltalk.String("") 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),self.currentMethodInfo()),smalltalk.String("@")),id),smalltalk.String('"')) 
""","PythonEncoder_blockHome_info_")
,"debug","""blockHome: aNode info: id
	" Private - Returns the debug info for block aNode (or empty String).
	Note: edit this method to emmit blocks w/o $info link to method
	"

	true ifTrue: [ ^'' ].
"DEBUG"	^$" ,self currentMethodInfo ,$@ ,id ,$\"""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"createContext:",0
,smalltalk.__f__("""(self,aName):
	#PythonEncoder>>#createContext:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(aName,smalltalk.String("=smalltalk.newContext()"))) 
		return _s8_rec.cr() 
	__blk1__(self) 
	return self 
""","PythonEncoder_createContext_")
,"contexts","""createContext: aName
	" Private - Emmit code for new context with local name aName. "

	self nextPutAll: aName ,'=smalltalk.newContext()'; cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"startSequence:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#startSequence:
	__0__=smalltalk.newContext()
	__0__.key=nil
	__0__.vars=nil
	__0__.vars=aNode.tempNames() 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@scopes",nil))):
		smalltalk.basic_at_put(self,"@scopes",smalltalk.newArray([])) 
	 
	__0__.key=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("__"),smalltalk.asString_(getattr(self,"@scopes",nil).size())),smalltalk.String("__")) 
	getattr(self,"@scopes",nil).add_(__0__.key._minus_gt(__0__.vars)) 
	if smalltalk.b(__0__.vars.notEmpty()):
		self.createContext_(__0__.key) 
	 
	self.prepareBlocksIn_(aNode) 
	return self 
""","PythonEncoder_startSequence_")
,"contexts","""startSequence: aNode
	" Private - Prepare context for sequence aNode. "

	| key vars |
	vars := aNode tempNames.
	scopes isNil ifTrue: [ scopes := #() ].
	key := '__' ,scopes size asString ,'__'.
	scopes add: key -> vars.
	vars notEmpty ifTrue: [ self createContext: key ].
	self prepareBlocksIn: aNode. """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"endSequence:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#endSequence:
	getattr(self,"@scopes",nil).removeLast() 
	return self 
""","PythonEncoder_endSequence_")
,"contexts","""endSequence: aNode
	" Private - Leave context for sequence aNode. "

	scopes removeLast """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"sequenceSpace:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#sequenceSpace:
	self.cr() 
	return self 
""","PythonEncoder_sequenceSpace_")
,"contexts","""sequenceSpace: aNode
	" Private - aNode has been visited in a sequence. "

	self cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"localReturnOps",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#localReturnOps
	return smalltalk.Array.with_with_(smalltalk.String("return "),nil) 
""","PythonEncoder_localReturnOps")
,"contexts","""localReturnOps
	" Private - Return the OPs for local return expression. "

	^Array with: 'return ' with: nil """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"sequenceExit:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#sequenceExit:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.visit_(__0__.result) 
	__0__.result=nil
	__0__.result=self.prepareValue_(aNode) 
	self.between_do_(self.localReturnOps(),smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_sequenceExit_")
,"contexts","""sequenceExit: aNode
	" Private - A block sequence is exiting with aNode. "

	| result |
	result := self prepareValue: aNode.
	self between: self localReturnOps do: [ self visit: result ] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"defineTemporary:",0
,smalltalk.__f__("""(self,aName):
	#PythonEncoder>>#defineTemporary:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.object_comma_(self.localName_(aName),smalltalk.String("=nil"))) 
		return _s8_rec.cr() 
	__blk1__(self) 
	return self 
""","PythonEncoder_defineTemporary_")
,"encoding","""defineTemporary: aName
	" Private - Return the code for defining temporary variable with aName. "

	self nextPutAll: (self localName: aName) ,'=nil' ;cr """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"pseudoName:",0
,smalltalk.__f__("""(self,aName):
	#PythonEncoder>>#pseudoName:
	if smalltalk.b(smalltalk.newArray(["true","false"]).includes_(aName)):
		return smalltalk.object_comma_(smalltalk.String("smalltalk."),aName) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(aName,smalltalk.String("thisContext"))):
		def __blk1__():
			return smalltalk.String("nil") 
		def __blk2__():
			return getattr(self,"@scopes",nil).last().key() 
		return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@scopes",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	 
	return aName 
""","PythonEncoder_pseudoName_")
,"locals","""pseudoName: aName
	" Private - Return the literal to encode constant aName. "

	(#(#true #false) includes: aName) ifTrue: [ ^'smalltalk.' ,aName ].
	aName = #thisContext ifTrue: [
		^scopes isNil ifTrue: [ #nil ] ifFalse: [
			scopes last key
		]
	].
	^aName """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"localName:",0
,smalltalk.__f__("""(self,aName):
	_s8Ret_=smalltalk.newContext()
	try:
		#PythonEncoder>>#localName:
		__0__=smalltalk.newContext()
		__0__.result=nil
		__0__.result=smalltalk.superReceiver(smalltalk.PythonEncoder,self).localName_(aName) 
		if smalltalk.b(smalltalk.notNil_(getattr(self,"@scopes",nil))):
			def __blk1__(assoc):
				def __blk2__():
					def __blk3__():
						return __0__.result 
					def __blk4__():
						return smalltalk.object_comma_(smalltalk.object_comma_(assoc.key(),smalltalk.String(".")),__0__.result) 
					return smalltalk.raise_result_(_s8Ret_,smalltalk.if_true_false_(smalltalk.isNil_(assoc.key()),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0))) 
				return smalltalk.if_true_false_(assoc.value().includes_(aName),smalltalk.blk(__blk2__,0),nil) 
			getattr(self,"@scopes",nil).reverseDo_(smalltalk.blk(__blk1__,1)) 
		 
		smalltalk.raise_result_(_s8Ret_,self.pseudoName_(__0__.result)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PythonEncoder_localName_")
,"locals","""localName: aName
	" Private - Return a valid (native, local) name for aName. "

	| result |
	result := super localName: aName.
	scopes notNil ifTrue: [
		scopes reverseDo: [:assoc|
			(assoc value includes: aName) ifTrue: [
				^assoc key isNil
					ifTrue: [ result ]
					ifFalse: [ assoc key ,'.' ,result ]
			].
		].
	].
	^self pseudoName: result """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"startBlock:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#startBlock:
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@scopes",nil))):
		smalltalk.basic_at_put(self,"@scopes",smalltalk.newArray([])) 
	 
	getattr(self,"@scopes",nil).add_(nil._minus_gt(aNode.parameterNames())) 
	return self 
""","PythonEncoder_startBlock_")
,"contexts","""startBlock: aNode
	" Private - Prepare arguments for block aNode. "

	scopes isNil ifTrue: [ scopes := #() ].
	scopes add: nil -> aNode parameterNames. """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"endBlock:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#endBlock:
	getattr(self,"@scopes",nil).removeLast() 
	return self 
""","PythonEncoder_endBlock_")
,"contexts","""endBlock: aNode
	" Private - Leave a block aNode. "

	scopes removeLast """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitCascadeNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitCascadeNode:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.visit_(__0__.evaluation.arguments().first()) 
	__0__.evaluation=nil
	__0__.blk=nil
	if not smalltalk.b(smalltalk.isObject_equalTo_(aNode.nodes().size(),smalltalk.Number(1))):
		return self.error_(smalltalk.String("Broken cascade - needs transform")) 
	 
	if not smalltalk.b(smalltalk.isObject_equalTo_(aNode.nodes().first().selector(),smalltalk.String("value:"))):
		return self.error_(smalltalk.String("Broken cascade - must be #value:")) 
	 
	__0__.evaluation=aNode.nodes().first() 
	self.compilerEvent_with_(smalltalk.String("aboutCascade:"),aNode) 
	__0__.blk=aNode.receiver() 
	smalltalk.basic_at_put_(__0__.blk,smalltalk.String("noWrap"),smalltalk.true) 
	self.visit_(__0__.blk) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	self.compilerEvent_with_(smalltalk.String("cascade:"),aNode) 
	return self 
""","PythonEncoder_visitCascadeNode_")
,"visiting","""visitCascadeNode: aNode

	| evaluation blk |
	aNode nodes size = 1 ifFalse: [ ^self error: 'Broken cascade - needs transform' ].
	aNode nodes first selector = #value: ifFalse: [ ^self error: 'Broken cascade - must be #value:' ].
	evaluation := aNode nodes first.
	self compilerEvent: #aboutCascade: with: aNode.
	blk := aNode receiver.
	blk basicAt: #noWrap put: true.
	self visit: blk.
	self nextArgumentsPut: [ self visit: evaluation arguments first ].
	self compilerEvent: #cascade: with: aNode.""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"transformCascade:in:",0
,smalltalk.__f__("""(self,cascade,aParent):
	#PythonEncoder>>#transformCascade:in:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nodes_(cascade.nodes()) 
		_s8_rec.temps_(smalltalk.newArray([])) 
		_s8_rec.start_end_(cascade.start(),cascade.end()) 
		return _s8_rec.yourself() 
	def __blk2__(_s8_rec):
		_s8_rec.parameters_(smalltalk.Array.with_(smalltalk.ValueNode.with_(__0__.target.value()))) 
		_s8_rec.addNode_(__0__.sequence) 
		_s8_rec.start_end_(cascade.nodes().first().start(),cascade.nodes().last().end()) 
		return _s8_rec.yourself() 
	def __blk3__(send):
		return send.receiver_(__0__.target) 
	def __blk4__(_s8_rec):
		_s8_rec.selector_(smalltalk.String("value:")) 
		_s8_rec.arguments_(smalltalk.Array.with_(cascade.receiver())) 
		_s8_rec.start_end_(cascade.start(),cascade.end()) 
		return _s8_rec.yourself() 
	def __blk5__(_s8_rec):
		_s8_rec.receiver_(__0__.block) 
		return _s8_rec.nodes_(smalltalk.Array.with_(__0__.evaluation)) 
	__0__.target=nil
	__0__.block=nil
	__0__.evaluation=nil
	__0__.sequence=nil
	__0__.target=smalltalk.VariableNode.with_(smalltalk.String("_s8_rec")) 
	__0__.target.start_end_(cascade.receiver().start(),cascade.receiver().end()) 
	__0__.sequence=__blk1__(smalltalk.BlockSequenceNode.new()) 
	__0__.block=__blk2__(smalltalk.BlockNode.new()) 
	cascade.nodes().do_(smalltalk.blk(__blk3__,1)) 
	__0__.evaluation=__blk4__(smalltalk.SendNode.new()) 
	__blk5__(cascade) 
	return self 
""","PythonEncoder_transformCascade_in_")
,"cascade","""transformCascade: cascade in: aParent
	" Private - Cascades are mutated to block semantics. "

	| target block evaluation sequence |
	target := VariableNode with: #_s8_rec.
	target start: cascade receiver start end: cascade receiver end.
	sequence := BlockSequenceNode new
	    nodes: cascade nodes; temps: #();
	    start: cascade start end: cascade end;
	    yourself.
	block := BlockNode new
		parameters: (Array with: (ValueNode with: target value));
		addNode: sequence;
		start: cascade nodes first start end: cascade nodes last end;
		yourself.
	cascade nodes do: [:send| send receiver: target ].
	evaluation := SendNode new
	    selector: #value:;
	    arguments: (Array with: cascade receiver);
	    start: cascade start end: cascade end;
	    yourself.
	cascade
		receiver: block;
		nodes: (Array with: evaluation) """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"prepare:",0
,smalltalk.__f__("""(self,aMethodNode):
	#PythonEncoder>>#prepare:
	def __blk1__(each,parent):
		def __blk2__():
			return self.transformCascade_in_(each,parent) 
		return smalltalk.if_true_false_(each.isCascade(),smalltalk.blk(__blk2__,0),nil) 
	aMethodNode.do_(smalltalk.blk(__blk1__,2)) 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).prepare_(aMethodNode) 
""","PythonEncoder_prepare_")
,"private","""prepare: aMethodNode
	" Private - Prepare aMethodNode for traversal. "

	aMethodNode do: [:each :parent|
		each isCascade ifTrue: [
			self transformCascade: each in: parent
		]
	].
	^super prepare: aMethodNode""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitClassVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aClassVariableName,aClass,anExpressionNode):
	#PythonEncoder>>#visitClassVariableAssignment:in:to:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.smalltalkNameFor_(aClass)) 
		_s8_rec.nextPutAll_(smalltalk.String('.classVariableAt_put_("')) 
		_s8_rec.nextPutAll_(aClassVariableName) 
		return _s8_rec.nextPutAll_(smalltalk.String('",')) 
	__blk1__(self) 
	self.visit_(anExpressionNode) 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","PythonEncoder_visitClassVariableAssignment_in_to_")
,"visiting","""visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode

	self
		nextPutAll: (self smalltalkNameFor: aClass);
		nextPutAll: '.classVariableAt_put_("';
		nextPutAll: aClassVariableName; nextPutAll: '",'.
	self visit: anExpressionNode.
	self	nextPutAll: ')'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitPoolVariableAssignment:in:to:",0
,smalltalk.__f__("""(self,aName,poolName,anExpressionNode):
	#PythonEncoder>>#visitPoolVariableAssignment:in:to:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String('smalltalk.poolDictionary_("')) 
		_s8_rec.nextPutAll_(poolName) 
		_s8_rec.nextPutAll_(smalltalk.String('").at_put_("')) 
		_s8_rec.nextPutAll_(aName) 
		return _s8_rec.nextPutAll_(smalltalk.String('",')) 
	__blk1__(self) 
	self.visit_(anExpressionNode) 
	self.nextPutAll_(smalltalk.String(")")) 
	return self 
""","PythonEncoder_visitPoolVariableAssignment_in_to_")
,"visiting","""visitPoolVariableAssignment: aName in: poolName to: anExpressionNode

	self
		nextPutAll: 'smalltalk.poolDictionary_("';
		nextPutAll: poolName; nextPutAll: '").at_put_("';
		nextPutAll: aName; nextPutAll: '",'.
	self visit: anExpressionNode.
	self	nextPutAll: ')'""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitOperation:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitOperation:
	def __blk1__():
		return self.visitReceiver_(aNode.receiver()) 
	self.compilerEvent_with_(smalltalk.String("aboutOperation:"),aNode) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	self.nextPutAll_(self.asPrivateSelector_(aNode.selector())) 
	self.visitSendArguments_(aNode) 
	self.compilerEvent_with_(smalltalk.String("operation:"),aNode) 
	return self 
""","PythonEncoder_visitOperation_")
,"visiting","""visitOperation: aNode
	" Private - aNode is an operation and selector is mapped to target operation. "

	self compilerEvent: #aboutOperation: with: aNode.
	self nextArgumentsPut: [ self visitReceiver: aNode receiver ].
	self nextPutAll: (self asPrivateSelector: aNode selector).
	self visitSendArguments: aNode.
	self compilerEvent: #operation: with: aNode.""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"encodeSuperSend:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#encodeSuperSend:
	def __blk1__():
		return self.visitSendArguments_(aNode) 
	self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.superReceiver("),self.smalltalkNameFor_(self.currentClass())),smalltalk.String(",self).")),self.asPrivateSelector_(aNode.selector()))) 
	self.nextArgumentsPut_(smalltalk.blk(__blk1__,0)) 
	return self 
""","PythonEncoder_encodeSuperSend_")
,"encoding","""encodeSuperSend: aNode
	" Private - Generate code for super message send."

	self nextPutAll: 'smalltalk.superReceiver('
		,(self smalltalkNameFor: self currentClass)
		,',self).',(self asPrivateSelector: aNode selector).
	self nextArgumentsPut: [
		self visitSendArguments: aNode
	] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"nextReturn:put:",0
,smalltalk.__f__("""(self,early,aBlock):
	#PythonEncoder>>#nextReturn:put:
	if not smalltalk.b(early):
		return aBlock.value() 
	 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).nextReturn_put_(early,aBlock) 
""","PythonEncoder_nextReturn_put_")
,"writing","""nextReturn: early put: aBlock
	" Private - Emmit a return OP evaluating aBlock onto output stream. "

	early ifFalse: [ ^aBlock value ]. "the return OPs will dump while visiting the return node"
	^super nextReturn: early put: aBlock """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"defineBlock:arguments:doing:",0
,smalltalk.__f__("""(self,aName,argumentNames,aBlock):
	#PythonEncoder>>#defineBlock:arguments:doing:
	self.nextPutAll_(smalltalk.object_comma_(smalltalk.String("def "),aName)) 
	self.emmitFunction_node_withSelf_arguments_doing_(aName,nil,smalltalk.false,argumentNames,aBlock) 
	return self 
""","PythonEncoder_defineBlock_arguments_doing_")
,"generation","""defineBlock: aName arguments: argumentNames doing: aBlock
	" Private - Generate code for block function named aName.  "

	self nextPutAll: 'def ' ,aName.
	self	emmitFunction: aName node: nil
		withSelf: false arguments: argumentNames
		doing: aBlock """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"visitReturnNode:",0
,smalltalk.__f__("""(self,aNode):
	#PythonEncoder>>#visitReturnNode:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return self.visitNode_in_cr_(each,aNode,smalltalk.true) 
	def __blk2__(last):
		__0__.result=self.prepareValue_(last)
		return __0__.result 
	def __blk3__():
		def __blk4__():
			return self.visit_(__0__.result) 
		return self.emmitReturn_early_(smalltalk.blk(__blk4__,0),smalltalk.false) 
	__0__.result=nil
	if smalltalk.b(getattr(self,"@nestedBlocks",nil)._gt(smalltalk.Number(0))):
		smalltalk.basic_at_put(self,"@earlyReturn",smalltalk.true) 
	 
	self.withNodesIn_do_atEnd_(aNode,smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(smalltalk.isNil_(__0__.result)):
		return self.error_(smalltalk.String("Missing result value")) 
	 
	return self.between_do_(self.returnOps(),smalltalk.blk(__blk3__,0)) 
""","PythonEncoder_visitReturnNode_")
,"visiting","""visitReturnNode: aNode

	| result |
	nestedBlocks > 0 ifTrue: [ earlyReturn := true ].
	self withNodesIn: aNode do: [:each|
		self visitNode: each in: aNode cr: true
	] atEnd: [:last|
		result := self prepareValue: last
	].
	result isNil ifTrue: [ ^self error: 'Missing result value' ].
	^self between: self returnOps do: [
		self emmitReturn: [ self visit: result ] early: false
	] """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"generatedCodeFor:while:",0
,smalltalk.__f__("""(self,aNode,aBlock):
	#PythonEncoder>>#generatedCodeFor:while:
	def __blk1__():
		__1__=smalltalk.newContext()
		__1__.result=nil
		smalltalk.basic_at_put(self,"@indentation",smalltalk.Number(0)) 
		__1__.result=aBlock.value() 
		smalltalk.basic_at_put(self,"@indentation",smalltalk.Number(0)) 
		return __1__.result 
	return smalltalk.superReceiver(smalltalk.PythonEncoder,self).generatedCodeFor_while_(aNode,smalltalk.blk(__blk1__,0)) 
""","PythonEncoder_generatedCodeFor_while_")
,"generation","""generatedCodeFor: aNode while: aBlock
	" Private - Return the code generated during evaluation of aBlock. "

	^super generatedCodeFor: aNode while: [ | result |
		indentation := 0." self cr."
		result := aBlock value.
		indentation := 0.
		result
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"nextCodePut:",0
,smalltalk.__f__("""(self,code):
	#PythonEncoder>>#nextCodePut:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.lines.atEnd() 
	__0__.lines=nil
	__0__.lines=code.stream() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk2__():
			return self.cr() 
		self.nextPutAll_(__0__.lines.nextLine()) 
		smalltalk.if_true_false_(__0__.lines.atEnd(),nil,smalltalk.blk(__blk2__,0)) 
	 
	return self 
""","PythonEncoder_nextCodePut_")
,"writing","""nextCodePut: code
	" Private - Emmit code (preserving indent) onto output stream. "

	| lines |
	lines := code stream.
	[lines atEnd] whileFalse: [
		self nextPutAll: lines nextLine.
		lines atEnd ifFalse: [ self cr ]
	]""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"generate:early:return:",0
,smalltalk.__f__("""(self,fName,early,code):
	#PythonEncoder>>#generate:early:return:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.nextCodePut_(code) 
	def __blk2__():
		def __blk3__():
			return self.nextPutAll_(smalltalk.String("return smalltalk.exceptionResult_(__ex)")) 
		self.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("if smalltalk.exception_at(__ex,"),__0__.target),smalltalk.String("):"))) 
		self.nextBlockPut_(smalltalk.blk(__blk3__,0)) 
		return self.nextPutAll_(smalltalk.String("raise __ex")) 
	__0__.prev=nil
	__0__.target=nil
	if not smalltalk.b(early):
		self.nextCodePut_(code) 
		return smalltalk.Number(0) 
	 
	__0__.prev=getattr(self,"@stream",nil).position() 
	__0__.target=smalltalk.String("_s8Ret_") 
	self.createContext_(__0__.target) 
	self.nextPutAll_(smalltalk.String("try:")) 
	__0__.prev=getattr(self,"@stream",nil).position()._minus(__0__.prev) 
	self.nextBlockPut_(smalltalk.blk(__blk1__,0)) 
	self.nextPutAll_(smalltalk.String("except Exception as __ex:")) 
	self.nextBlockPut_(smalltalk.blk(__blk2__,0)) 
	return __0__.prev 
""","PythonEncoder_generate_early_return_")
,"generation","""generate: fName early: early return: code
	" Private - Generate code to catch early return of code expression in fName. "

	| prev target |
	early ifFalse: [
		self nextCodePut: code.
		^0
	].
	prev := stream position.
	target := #_s8Ret_.
	self createContext: target.
	self nextPutAll: #try:.
	prev := stream position - prev.
	self nextBlockPut: [ self nextCodePut: code ].
	self nextPutAll: 'except Exception as __ex:'.
	self nextBlockPut: [
		self nextPutAll: 'if smalltalk.exception_at(__ex,',target ,'):'.
		self nextBlockPut: [
			self nextPutAll: 'return smalltalk.exceptionResult_(__ex)'
		].
		self nextPutAll: 'raise __ex'
	].
	^prev """,nil)
smalltalk.bind(smalltalk.PythonEncoder,"coreOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#coreOptimizations
	return smalltalk.newArray(["core",[["class","(%receiver%).__class__"],["isNil","%.isNil_%(%receiver%)"],["notNil","%.notNil_%(%receiver%)"],["=","%.isObject_equalTo_%(%receiver%,%arg1%)"],["~=","%.isObject_equalTo_%(%receiver%,%arg1%)._8not()"],["==","%.b_%(%receiver% is %arg1%)"],["~~","%.b_%(not (%receiver% is %arg1%))"],["===","%.b_%(%receiver% is %arg1%)"],["||","%.b_%(%receiver% or %arg1%)"],[",","%,%(%receiver%,%arg1%)"],["basicAt:","%.basic_at_%(%receiver%,%arg1%)"],["basicAt:ifAbsent:","%.basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)"],["basicAt:put:","%.basic_at_put_%(%receiver%,%arg1%,%arg2%)"],["ifUndefined:","%.ifUndefined_do_%(%receiver%,%arg1%)"]]]) 
""","PythonEncoder_coreOptimizations")
,"optimization","""coreOptimizations
	" Private - Return the optimization set. "

	^#(core  #(
		#(class	'(%receiver%).__class__' )
		#(isNil	'%.isNil_%(%receiver%)' )
		#(notNil	'%.notNil_%(%receiver%)' )
		#(=	'%.isObject_equalTo_%(%receiver%,%arg1%)' )
		#(~=	'%.isObject_equalTo_%(%receiver%,%arg1%)._8not()' )
		#(==	'%.b_%(%receiver% is %arg1%)' )
		#(~~	'%.b_%(not (%receiver% is %arg1%))' )
		#(===	'%.b_%(%receiver% is %arg1%)' )
		#(||	'%.b_%(%receiver% or %arg1%)' )
		#(,	'%,%(%receiver%,%arg1%)' )
		#(basicAt:	'%.basic_at_%(%receiver%,%arg1%)' )
		#(basicAt:ifAbsent: '%.basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)' )
		#(basicAt:put: '%.basic_at_put_%(%receiver%,%arg1%,%arg2%)' )
		#(ifUndefined: '%.ifUndefined_do_%(%receiver%,%arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"s8Optimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#s8Optimizations
	return smalltalk.newArray(["s8",["core",["ifTrue:","hasBlockNoArguments:",[["ifTrue:","noClient:","if %.b%(%receiver%):%>%%seq1%%<%"],["ifTrue:","%.if_true_false_%(%receiver%,%arg1%,nil)"]]],["ifFalse:","hasBlockNoArguments:",[["ifFalse:","noClient:","if not %.b%(%receiver%):%>%%seq1%%<%"],["ifFalse:","%.if_true_false_%(%receiver%,nil,%arg1%)"]]],["ifTrue:ifFalse:","hasBlockNoArguments:",[["ifTrue:ifFalse:","noClient:","if %.b%(%receiver%):%>%%seq1%%<%else:%>%%seq2%%<%"],["ifTrue:ifFalse:","%.if_true_false_%(%receiver%,%arg1%,%arg2%)"]]],["ifFalse:ifTrue:","hasBlockNoArguments:",[["ifFalse:ifTrue:","noClient:","if %.b%(%receiver%):%>%%seq2%%<%else:%>%%seq1%%<%"],["ifFalse:ifTrue:","%.if_true_false_%(%receiver%,%arg2%,%arg1%)"]]],["whileTrue","receiverIsBlockNoArguments:",[["whileTrue","noClient:","while %.b%(%receiver%()):%>%continue%<%"],["whileTrue","%.while_do_%(%receiver%,nil)"]]],["whileFalse","receiverIsBlockNoArguments:",[["whileFalse","noClient:","while not %.b%(%receiver%()):%>%continue%<%"],["whileFalse","%.whileNot_do_%(%receiver%,nil)"]]],["whileTrue:","receiverIsBlockNoArguments:",[["whileTrue:","noClient:","while %.b%(%receiver%()):%>%%seq1%%<%"],["whileTrue:","%.while_do_%(%receiver%,%arg1%)"]]],["whileFalse:","receiverIsBlockNoArguments:",[["whileFalse:","noClient:","while not %.b%(%receiver%()):%>%%seq1%%<%"],["whileFalse:","%.whileNot_do_%(%receiver%,%arg1%)"]]],["orNil","(%receiver% or nil)"],["timesRepeat:","%.times_repeat_%(%receiver%,%arg1%)"],["isKindOf:","%.is_kindOf_%(%receiver%,(%arg1%))"],["respondsTo:","%.responds_to_%(%receiver%,(%arg1%))"],["ifNil:","%.if_nil_notNil_%(%receiver%,%arg1%,nil)"],["ifNotNil:","%.if_nil_notNil_%(%receiver%,nil,%arg1%)"],["ifNil:ifNotNil:","%.if_nil_notNil_%(%receiver%,%arg1%,%arg2%)"],["ifNotNil:ifNil:","%.if_nil_notNil_%(%receiver%,%arg2%,%arg1%)"]]]) 
""","PythonEncoder_s8Optimizations")
,"optimization","""s8Optimizations
	" Private - Return the optimization set. "

	^#(s8	#(
		core
		#(ifTrue: hasBlockNoArguments: #(
			#(ifTrue: noClient: 'if %.b%(%receiver%):%>%%seq1%%<%' )
			#(ifTrue: '%.if_true_false_%(%receiver%,%arg1%,nil)' )
		))
		#(ifFalse: hasBlockNoArguments: #(
			#(ifFalse: noClient: 'if not %.b%(%receiver%):%>%%seq1%%<%' )
			#(ifFalse: '%.if_true_false_%(%receiver%,nil,%arg1%)' )
		))
		#(ifTrue:ifFalse: hasBlockNoArguments: #(
			#(ifTrue:ifFalse: noClient: 'if %.b%(%receiver%):%>%%seq1%%<%else:%>%%seq2%%<%' )
			#(ifTrue:ifFalse: '%.if_true_false_%(%receiver%,%arg1%,%arg2%)' )
		))
		#(ifFalse:ifTrue: hasBlockNoArguments: #(
			#(ifFalse:ifTrue: noClient: 'if %.b%(%receiver%):%>%%seq2%%<%else:%>%%seq1%%<%' )
			#(ifFalse:ifTrue: '%.if_true_false_%(%receiver%,%arg2%,%arg1%)' )
		))
		#(whileTrue receiverIsBlockNoArguments: #(
			#(whileTrue noClient: 'while %.b%(%receiver%()):%>%continue%<%' )
			#(whileTrue '%.while_do_%(%receiver%,nil)' )
		))
		#(whileFalse receiverIsBlockNoArguments: #(
			#(whileFalse noClient: 'while not %.b%(%receiver%()):%>%continue%<%' )
			#(whileFalse '%.whileNot_do_%(%receiver%,nil)' )
		))
		#(whileTrue: receiverIsBlockNoArguments: #(
			#(whileTrue: noClient: 'while %.b%(%receiver%()):%>%%seq1%%<%' )
			#(whileTrue: '%.while_do_%(%receiver%,%arg1%)' )
		))
		#(whileFalse: receiverIsBlockNoArguments:  #(
			#(whileFalse: noClient: 'while not %.b%(%receiver%()):%>%%seq1%%<%' )
			#(whileFalse: '%.whileNot_do_%(%receiver%,%arg1%)' )
		))
		#(orNil '(%receiver% or nil)' )
		#(timesRepeat: '%.times_repeat_%(%receiver%,%arg1%)' )
		#(isKindOf: '%.is_kindOf_%(%receiver%,(%arg1%))' )
		#(respondsTo: '%.responds_to_%(%receiver%,(%arg1%))' )
		#(ifNil: '%.if_nil_notNil_%(%receiver%,%arg1%,nil)' )
		#(ifNotNil: '%.if_nil_notNil_%(%receiver%,nil,%arg1%)' )
		#(ifNil:ifNotNil: '%.if_nil_notNil_%(%receiver%,%arg1%,%arg2%)' )
		#(ifNotNil:ifNil: '%.if_nil_notNil_%(%receiver%,%arg2%,%arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"magnitudeOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#magnitudeOptimizations
	return smalltalk.newArray(["magnitude",[[">","%.b_%(%receiver% > %arg1%)"],["<","%.b_%(%receiver% < %arg1%)"],[">=","%.b_%(%receiver% >= %arg1%)"],["<=","%.b_%(%receiver% <= %arg1%)"]]]) 
""","PythonEncoder_magnitudeOptimizations")
,"optimization","""magnitudeOptimizations
	" Private - Return the optimization set. "

	^#(magnitude #(
		#(> 	'%.b_%(%receiver% > %arg1%)' )
		#(< 	'%.b_%(%receiver% < %arg1%)' )
		#(>=	'%.b_%(%receiver% >= %arg1%)' )
		#(<=	'%.b_%(%receiver% <= %arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"mathOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#mathOptimizations
	return smalltalk.newArray(["math",[["max:","max(%receiver%,%arg1%)"],["min:","min(%receiver%,%arg1%)"],["mustBeNumber","%.mustBeNumber_%(%receiver%)"],["+","(%receiver% + %arg1%)"],["-","(%receiver% - %arg1%)"],["*","(%receiver% * %arg1%)"],["/","(%receiver% / %arg1%)"]]]) 
""","PythonEncoder_mathOptimizations")
,"optimization","""mathOptimizations
	" Private - Return the optimization set. "

	^#(math #(
		#(max:	'max(%receiver%,%arg1%)' )
		#(min:	'min(%receiver%,%arg1%)' )
		#(mustBeNumber	'%.mustBeNumber_%(%receiver%)' )
		#(+	'(%receiver% + %arg1%)' )
		#(#-	'(%receiver% - %arg1%)' )
		#(*	'(%receiver% * %arg1%)' )
		#(/	'(%receiver% / %arg1%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"printingOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#printingOptimizations
	return smalltalk.newArray(["printing",[["toString","%.to_String%(%receiver%)"],["printString","%.printString_%(%receiver%)"],["asString","%.asString_%(%receiver%)"],["asCharacter","%.asCharacter_%(%receiver%)"]]]) 
""","PythonEncoder_printingOptimizations")
,"optimization","""printingOptimizations
	" Private - Return the optimization set. "

	^#(printing #(
		#(toString	'%.to_String%(%receiver%)' )
		#(printString	'%.printString_%(%receiver%)' )
		#(asString	'%.asString_%(%receiver%)' )
		#(asCharacter	'%.asCharacter_%(%receiver%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"booleanOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#booleanOptimizations
	return smalltalk.newArray(["boolean",[["isBoolean","%.isBoolean_%(%receiver%)"],["and:","hasBlockNoArguments:","%.boolean_and_%(%receiver%,%arg1%)"],["or:","hasBlockNoArguments:","%.boolean_or_%(%receiver%,%arg1%)"],["not","%.booleanNot_%(%receiver%)"]]]) 
""","PythonEncoder_booleanOptimizations")
,"optimization","""booleanOptimizations
	" Private - Return the optimization set. "

	^#(boolean #(
		#(isBoolean '%.isBoolean_%(%receiver%)' )
		#(and: hasBlockNoArguments: '%.boolean_and_%(%receiver%,%arg1%)' )
		#(or: hasBlockNoArguments:  '%.boolean_or_%(%receiver%,%arg1%)' )
		#(not '%.booleanNot_%(%receiver%)' )
	))""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"defaultKnownOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#defaultKnownOptimizations
	def __blk1__(_s8_rec):
		_s8_rec.add_(self.s8Optimizations()) 
		_s8_rec.add_(self.booleanOptimizations()) 
		_s8_rec.add_(self.printingOptimizations()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.Array.with_(self.coreOptimizations())) 
""","PythonEncoder_defaultKnownOptimizations")
,"defaults","""defaultKnownOptimizations
	" Private - Return the default knownOptimizations of the receiver. "

	^(Array	with: self coreOptimizations)
		add: self s8Optimizations;
"		add: self magnitudeOptimizations;
		add: self mathOptimizations;"
		add: self booleanOptimizations;
		add: self printingOptimizations;
		yourself""",nil)
smalltalk.bind(smalltalk.PythonEncoder,"defaultOptimizations",0
,smalltalk.__f__("""(self):
	#PythonEncoder>>#defaultOptimizations
	return smalltalk.newArray(["s8","magnitude","boolean","printing"]) 
""","PythonEncoder_defaultOptimizations")
,"defaults","""defaultOptimizations
	" Private - Return the default optimizations of the receiver. "

	^#( s8 magnitude "math" boolean "evaluation" printing )""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#Compiler class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.newArray(["needsCookie:","startVisit:","endVisit:","startMethod:","enterMethod:","endMethod:","startFunction:with:","startFunctionName:","startFunctionBody:with:","endFunction:","aboutReturn:","return:","returned:early:","aboutSend:","send:","aboutOperation:","operation:","aboutCascade:","cascade:","aboutToCompile:","setTransformers:","needsParser","aboutToParse:","needsEncoder","aboutToEncode:","aboutToRecompile:","recompiled:","startCompiling:","endCompiling:","needsOptimizationMap","initializeOptimizations","customizeOptimizations","unknownVariable:","acceptAssignmentTo:","invalidAssignment:","move:by:"]),smalltalk.superReceiver(smalltalk.Compiler.__class__,self).constructEventsTriggered()) 
""","Compiler_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^#(	#needsCookie: #startVisit: #endVisit:
		#startMethod: #enterMethod: #endMethod:
		#startFunction:with: #startFunctionName: #startFunctionBody:with: #endFunction:
		#aboutReturn: #return: #returned:early:
		#aboutSend: #send:
		#aboutOperation: #operation:
		#aboutCascade: #cascade:
		#aboutToCompile: #setTransformers:
		#needsParser #aboutToParse:
		#needsEncoder #aboutToEncode:
		#aboutToRecompile: #recompiled:
		#startCompiling: #endCompiling:
		#needsOptimizationMap #initializeOptimizations #customizeOptimizations
		#unknownVariable: #acceptAssignmentTo: #invalidAssignment:
		#move:by:
	) ,super constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugCookieFrom:",0
,smalltalk.__f__("""(self,aStream):
	#Compiler class>>#debugCookieFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		return aStream.nextChunk().asNumber() 
	__0__.nextOffset=nil
	__0__.nextOffset=smalltalk.blk(__blk1__,0) 
	return smalltalk.Array.with_with_with_with_(aStream.nextChunk(),__0__.nextOffset.value()._at(__0__.nextOffset.value()),__0__.nextOffset.value()._at(__0__.nextOffset.value()),aStream.nextChunk().asArrayOfSubstrings()) 
""","Compiler_class_debugCookieFrom_")
,"private","""debugCookieFrom: aStream
	" Private - Return the next debug cookie encoded in aStream (or nil). "

	| nextOffset |
	nextOffset := [ aStream nextChunk asNumber ].
	^Array	"ref. #debugInfo:forClass: "
		with: aStream nextChunk
		with: nextOffset value @ nextOffset value
		with: nextOffset value @ nextOffset value
		with: aStream nextChunk asArrayOfSubstrings""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugCookiesFrom:",0
,smalltalk.__f__("""(self,aStream):
	#Compiler class>>#debugCookiesFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__(_s8_rec):
			_s8_rec.skipSeparators() 
			return _s8_rec.atEnd() 
		return __blk2__(aStream) 
	__0__.result=nil
	__0__.cookie=nil
	__0__.result=smalltalk.Array.new() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk3__():
			return __0__.result.add_(__0__.cookie) 
		__0__.cookie=self.debugCookieFrom_(aStream) 
		smalltalk.if_true_false_(smalltalk.notNil_(__0__.cookie),smalltalk.blk(__blk3__,0),nil) 
	 
	return __0__.result 
""","Compiler_class_debugCookiesFrom_")
,"private","""debugCookiesFrom: aStream
	" Private - Return the debug cookies encoded in aStream. "

	| result cookie |
	result := Array new.
	[ aStream skipSeparators; atEnd ] whileFalse: [
		cookie := self debugCookieFrom: aStream.
		cookie notNil ifTrue: [ result add: cookie ].
	].
	^result""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugInfo:",0
,smalltalk.__f__("""(self,aMethod):
	#Compiler class>>#debugInfo:
	def __blk1__():
		return self.debugInfo_forClass_(aMethod.source(),aMethod.classField()) 
	return aMethod.basicAt_ifAbsentPut_(smalltalk.String("$debugInfo"),smalltalk.blk(__blk1__,0)) 
""","Compiler_class_debugInfo_")
,"debug","""debugInfo: aMethod
	" Return the debug information of aMethod. "

	^aMethod basicAt: '$debugInfo' ifAbsentPut: [
		self debugInfo: aMethod source forClass: aMethod classField
	]""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugInfo:forClass:",0
,smalltalk.__f__("""(self,aString,aClass):
	#Compiler class>>#debugInfo:forClass:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		def __blk2__(one):
			return __0__.cookies.add_(smalltalk.Array.with_with_(one,__0__.compiler.encoder().position())) 
		def __blk3__(cookie):
			return cookie.add_(__0__.compiler.encoder().position()) 
		def __blk4__(one,distance):
			__0__.delta=__0__.delta._plus(distance)
			return __0__.delta 
		_s8_rec.useTemplates_(smalltalk.false) 
		_s8_rec.when_do_(smalltalk.String("needsCookie:"),smalltalk.blk(__blk2__,1)) 
		_s8_rec.when_do_(smalltalk.String("endVisit:"),smalltalk.blk(__blk3__,1)) 
		return _s8_rec.when_do_(smalltalk.String("move:by:"),smalltalk.blk(__blk4__,2)) 
	def __blk5__(_s8_rec):
		_s8_rec.nextChunkPut_(aClass.name()) 
		_s8_rec.nextChunkPut_(aString) 
		_s8_rec.nextChunkPut_(__0__.compiler.compile_forClass_(aString,aClass)) 
		return _s8_rec.yourself() 
	def __blk6__(tuple):
		def __blk7__(_s8_rec):
			_s8_rec.nextChunkPut_((__0__.aNode).__class__.name()) 
			_s8_rec.nextChunkPut_(smalltalk.asString_(__0__.aNode.start())) 
			_s8_rec.nextChunkPut_(smalltalk.asString_(__0__.aNode.end())) 
			_s8_rec.nextChunkPut_(smalltalk.asString_(tuple.second()._plus(__0__.delta))) 
			_s8_rec.nextChunkPut_(smalltalk.asString_(tuple.third()._plus(__0__.delta))) 
			return _s8_rec.yourself() 
		def __blk8__(each):
			return __0__.output.nextPutAll_(smalltalk.object_comma_(smalltalk.String(" "),each)) 
		__0__.aNode=tuple.first() 
		__blk7__(__0__.output) 
		__0__.aNode.bindings().do_(smalltalk.blk(__blk8__,1)) 
		return __0__.output.nextChunkPut_(smalltalk.String(" ")) 
	__0__.compiler=nil
	__0__.output=nil
	__0__.cookies=nil
	__0__.aNode=nil
	__0__.delta=nil
	__0__.output=smalltalk.String("").writeStream() 
	__0__.cookies=smalltalk.newArray([]) 
	__0__.delta=smalltalk.Number(0) 
	__0__.compiler=self.new() 
	__blk1__(__0__.compiler) 
	__blk5__(__0__.output) 
	__0__.cookies.do_(smalltalk.blk(__blk6__,1)) 
	return __0__.output.contents() 
""","Compiler_class_debugInfo_forClass_")
,"debug","""debugInfo: aString forClass: aClass
	" Private - Return aString with information of compiling aString as a method implemented in aClass. "

	| compiler output cookies aNode delta |
	output := '' writeStream.
	cookies := #(). delta := 0.
	compiler := self new.
	compiler
		useTemplates: false;
		when: #needsCookie: do: [:one| cookies add: (Array with: one with: compiler encoder position) ];
		when: #endVisit: do: [:cookie| cookie add: compiler encoder position ];
		when: #move:by: do: [:one :distance| delta := delta + distance ].
	output
		nextChunkPut: aClass name;
		nextChunkPut: aString;
		nextChunkPut: (compiler compile: aString forClass: aClass);
		yourself.
	cookies do: [:tuple|
		aNode := tuple first.
		output
			nextChunkPut: aNode class name;
			nextChunkPut: aNode start asString;
			nextChunkPut: aNode end asString;
			nextChunkPut: (tuple second + delta) asString;
			nextChunkPut: (tuple third + delta) asString;
			yourself.
		aNode bindings do: [:each| output nextPutAll: ' ' ,each ].
		output nextChunkPut: ' '.
	].
	^output contents""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugInfoFrom:",0
,smalltalk.__f__("""(self,aString):
	#Compiler class>>#debugInfoFrom:
	return self.debugInfoFromStream_(aString.stream()) 
""","Compiler_class_debugInfoFrom_")
,"debug","""debugInfoFrom: aString
	" Private - Return the debug information decoding aString contents.
	Note: aString must be result of sending #getInfo: to the receiver.
	"

	^self debugInfoFromStream: aString stream""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"debugInfoFromStream:",0
,smalltalk.__f__("""(self,aStream):
	#Compiler class>>#debugInfoFromStream:
	return smalltalk.Array.with_with_with_with_(aStream.nextChunk(),aStream.nextChunk(),aStream.nextChunk(),self.debugCookiesFrom_(aStream)) 
""","Compiler_class_debugInfoFromStream_")
,"private","""debugInfoFromStream: aStream
	" Private - Return the debug information encoded in aStream. "

	^Array	"ref. #debugInfo:forClass: "
		with: aStream nextChunk
		with: aStream nextChunk
		with: aStream nextChunk
		with: (self debugCookiesFrom: aStream)""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"doIt:",0
,smalltalk.__f__("""(self,smalltalkExpression):
	#Compiler class>>#doIt:
	return self.doIt_to_(smalltalkExpression,nil) 
""","Compiler_class_doIt_")
,"evaluation","""doIt: smalltalkExpression
	" Return the result of evaluating the smalltalk expression in the global context or a description of an error situation occurred evaluating the code. "

	^self doIt: smalltalkExpression to: nil""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"doIt:to:",0
,smalltalk.__f__("""(self,smalltalkExpression,aReceiver):
	#Compiler class>>#doIt:to:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return self.evaluate_(smalltalkExpression) 
		def __blk3__():
			return self.evaluate_to_(smalltalkExpression,aReceiver) 
		__0__.result=smalltalk.if_true_false_(smalltalk.isNil_(aReceiver),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))
		return __0__.result 
	def __blk4__(error):
		def __blk5__():
			return smalltalk.booleanNot_(error.isString()) 
		__0__.result=error 
		if smalltalk.b(smalltalk.boolean_and_(self.isObject_(error),smalltalk.blk(__blk5__,0))):
			__0__.result=smalltalk.object_comma_(smalltalk.object_comma_((error).__class__.name(),smalltalk.String(": ")),error.messageText()) 
		 
		return self.note_(__0__.result) 
	__0__.result=nil
	smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk4__,1)) 
	return __0__.result 
""","Compiler_class_doIt_to_")
,"evaluation","""doIt: smalltalkExpression to: aReceiver
	" Return the result of evaluating the smalltalk expression in the context of aReceiver or a description of an error situation occurred evaluating the code. "

	| result |
	[ result := aReceiver isNil
			ifTrue:  [ self evaluate: smalltalkExpression ]
			ifFalse: [ self evaluate: smalltalkExpression to: aReceiver ]
	] on: Exception do: [:error|
		result := error.
		((self isObject: error) and: [ error isString not ])
		ifTrue: [ result := error class name ,': ' ,error messageText ].
		self note: result
	].
	^result""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"evaluate:",0
,smalltalk.__f__("""(self,smalltalkExpression):
	#Compiler class>>#evaluate:
	return self.new().evaluate_(smalltalkExpression) 
""","Compiler_class_evaluate_")
,"evaluation","""evaluate: smalltalkExpression
	" Return the result of evaluating the smalltalk expression in a global context. "

	^self new evaluate: smalltalkExpression""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"evaluate:in:to:",0
,smalltalk.__f__("""(self,expression,aClass,aReceiver):
	#Compiler class>>#evaluate:in:to:
	return aClass.compiler().evaluate_in_to_(expression,aClass,aReceiver) 
""","Compiler_class_evaluate_in_to_")
,"evaluation","""evaluate: expression in: aClass to: aReceiver
	" Return the result of evaluating the expression with aReceiver. "

	^aClass compiler evaluate: expression in: aClass to: aReceiver""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"targetFor:",0
,smalltalk.__f__("""(self,aReceiver):
	#Compiler class>>#targetFor:
	def __blk1__():
		return aReceiver 
	def __blk2__():
		return smalltalk.NativeHandle.support()._at(aReceiver) 
	return smalltalk.if_true_false_(self.isObject_(aReceiver),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Compiler_class_targetFor_")
,"evaluation","""targetFor: aReceiver
	" Return the object to use for compiling expressions to be evaluated in aReceiver. "

	^(self isObject: aReceiver)
		ifTrue: [ aReceiver ]
		ifFalse: [ NativeHandle support @ aReceiver ] """,nil)
smalltalk.bind(smalltalk.Compiler.__class__,"evaluate:to:",0
,smalltalk.__f__("""(self,expression,aReceiver):
	#Compiler class>>#evaluate:to:
	__0__=smalltalk.newContext()
	__0__.target=nil
	__0__.target=self.targetFor_(aReceiver) 
	return self.evaluate_in_to_(expression,(__0__.target).__class__,__0__.target) 
""","Compiler_class_evaluate_to_")
,"evaluation","""evaluate: expression to: aReceiver
	" Return the result of evaluating the expression with aReceiver. "

	| target |
	target := self targetFor: aReceiver.
	^self evaluate: expression in: target class to: target""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"for:",0
,smalltalk.__f__("""(self,aBehavior):
	#Compiler class>>#for:
	def __blk1__(_s8_rec):
		_s8_rec.currentClass_(aBehavior) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","Compiler_class_for_")
,"instantiation","""for: aBehavior
	" Return an instance of the receiver. "

	^self new
		currentClass: aBehavior;
		yourself""",nil)
smalltalk.bind(smalltalk.Compiler.__class__,"getInfo:",0
,smalltalk.__f__("""(self,aString):
	#Compiler class>>#getInfo:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(__0__.aMethod.source(),__0__.source) 
		return smalltalk.boolean_or_(__0__.source.trimBlanks().isEmpty(),smalltalk.blk(__blk2__,0)) 
	__0__.stream=nil
	__0__.aClass=nil
	__0__.selector=nil
	__0__.source=nil
	__0__.aMethod=nil
	__0__.stream=aString.stream() 
	__0__.aClass=__0__.stream.nextChunk().doIt() 
	__0__.selector=__0__.stream.nextChunk() 
	__0__.source=__0__.stream.nextChunk() 
	__0__.aMethod=__0__.aClass._gt_gt(__0__.selector) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(__0__.aMethod),smalltalk.blk(__blk1__,0))):
		return self.debugInfo_(__0__.aMethod) 
	 
	return self.debugInfo_forClass_(__0__.source,__0__.aClass) 
""","Compiler_class_getInfo_")
,"debug","""getInfo: aString
	" Private - Return the information of compiling aString as a chunked spec. "

	| stream aClass selector source aMethod |
	stream := aString stream.
	aClass := stream nextChunk doIt.
	selector := stream nextChunk.
	source := stream nextChunk.
	aMethod := aClass >> selector.
	(aMethod notNil and: [ source trimBlanks isEmpty or: [
		aMethod source = source ]]) ifTrue: [
		^self debugInfo: aMethod
	].
	^self debugInfo: source forClass: aClass""",nil)
smalltalk.bind(smalltalk.Compiler,"parseMethod:",0
,smalltalk.__f__("""(self,aString):
	_s8Ret_=smalltalk.newContext()
	try:
		#Compiler>>#parseMethod:
		__0__=smalltalk.newContext()
		def __blk1__():
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,__0__.result) 
			__0__.result=self.nodeFromTemplateIn_(aString) 
			return smalltalk.if_true_false_(smalltalk.notNil_(__0__.result),smalltalk.blk(__blk2__,0),nil) 
		__0__.result=nil
		self.triggerEvent_with_ifNotHandled_(smalltalk.String("aboutToParse:"),aString,smalltalk.blk(__blk1__,0)) 
		__0__.result=self.parser().parse_(aString.readStream()) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Compiler_parseMethod_")
,"parsing","""parseMethod: aString
	" Return the result of parsing aString as a method source code. "

	| result |
	self	triggerEvent: #aboutToParse:
		with: aString ifNotHandled: [
			result := self nodeFromTemplateIn: aString.
			result notNil ifTrue: [ ^result ]
		].
	result := self parser parse: aString readStream.
	^result""",nil)
smalltalk.bind(smalltalk.Compiler,"parse:",0
,smalltalk.__f__("""(self,aString):
	#Compiler>>#parse:
	self.error_(smalltalk.object_comma_(smalltalk.String("OBSOLETE message #parse: "),smalltalk.printString_(aString))) 
	return self.parseMethod_(aString) 
""","Compiler_parse_")
,"parsing","""parse: aString
	" OBSOLETE - Return the result of parsing aString. "

	self error: 'OBSOLETE message #parse: ' ,aString printString.
	^self parseMethod: aString """,nil)
smalltalk.bind(smalltalk.Compiler,"compile:",0
,smalltalk.__f__("""(self,methodSource):
	#Compiler>>#compile:
	__0__=smalltalk.newContext()
	__0__.aNode=nil
	__0__.aNode=self.parseMethod_(methodSource) 
	self.triggerEvent_with_(smalltalk.String("aboutToCompile:"),__0__.aNode) 
	return self.emmitNode_(__0__.aNode) 
""","Compiler_compile_")
,"private","""compile: methodSource
	" Return the native code result of compiling methodSource for currentClass. "

	| aNode |
	aNode := self parseMethod: methodSource.
	self triggerEvent: #aboutToCompile: with: aNode.
	^self emmitNode: aNode""",nil)
smalltalk.bind(smalltalk.Compiler,"compile:forClass:",0
,smalltalk.__f__("""(self,methodSource,aClass):
	#Compiler>>#compile:forClass:
	self.currentClass_(aClass) 
	return self.compile_(methodSource) 
""","Compiler_compile_forClass_")
,"compiling","""compile: methodSource forClass: aClass
	" Return the native code result of compiling methodSource as a method implemented by aClass. "

	self currentClass: aClass.
	^self compile: methodSource """,nil)
smalltalk.bind(smalltalk.Compiler,"compile:forClass:category:",0
,smalltalk.__f__("""(self,methodSource,aClass,category):
	#Compiler>>#compile:forClass:category:
	__0__=smalltalk.newContext()
	def __blk1__():
		return methodSource.isEmpty() 
	__0__.method=nil
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(methodSource),smalltalk.blk(__blk1__,0))):
		return nil 
	 
	__0__.method=self.load_forClass_(methodSource,aClass) 
	__0__.method.category_(category) 
	aClass.addCompiledMethod_(__0__.method) 
	return __0__.method 
""","Compiler_compile_forClass_category_")
,"compiling","""compile: methodSource forClass: aClass category: category
	" Return the compiled method result of installing a new method compiled from methodSource in aClass. "

	| method |
	(methodSource isNil or: [ methodSource isEmpty ]) ifTrue: [ ^nil ].
	method := self load: methodSource forClass: aClass.
	method category: category.
	aClass addCompiledMethod: method.
	^method""",nil)
smalltalk.bind(smalltalk.Compiler,"selector",0
,smalltalk.__f__("""(self):
	#Compiler>>#selector
	return getattr(self,"@selector",nil) 
""","Compiler_selector")
,"accessing","""selector
	" Return the selector of the receiver (or nil). "

	^selector """,nil)
smalltalk.bind(smalltalk.Compiler,"currentClass",0
,smalltalk.__f__("""(self):
	#Compiler>>#currentClass
	return getattr(self,"@currentClass",nil) 
""","Compiler_currentClass")
,"accessing","""currentClass
	" Return the current class of the receiver. "

	^currentClass""",nil)
smalltalk.bind(smalltalk.Compiler,"currentClass:",0
,smalltalk.__f__("""(self,aClass):
	#Compiler>>#currentClass:
	smalltalk.basic_at_put(self,"@currentClass",aClass) 
	return self 
""","Compiler_currentClass_")
,"accessing","""currentClass: aClass
	" Set the current class of the receiver. "

	currentClass := aClass""",nil)
smalltalk.bind(smalltalk.Compiler,"emmitNode:",0
,smalltalk.__f__("""(self,aNode):
	#Compiler>>#emmitNode:
	self.startCompiling_(aNode) 
	self.prepare_(aNode) 
	self.triggerEvent_with_(smalltalk.String("aboutToEncode:"),aNode) 
	self.encoder().visit_(aNode) 
	self.endCompiling_(aNode) 
	return self.encoder().emmitedCode() 
""","Compiler_emmitNode_")
,"private","""emmitNode: aNode
	" Private - Return the native code for aNode. "

	self startCompiling: aNode.
	self prepare: aNode.
	self triggerEvent: #aboutToEncode: with: aNode.
	self encoder visit: aNode.
	self endCompiling: aNode.
	^self encoder emmitedCode""",nil)
smalltalk.bind(smalltalk.Compiler,"encoder",0
,smalltalk.__f__("""(self):
	#Compiler>>#encoder
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@encoder",nil))):
		self.initializeEncoder() 
	 
	return getattr(self,"@encoder",nil) 
""","Compiler_encoder")
,"accessing","""encoder
	" Return the encoder of the receiver. "

	encoder isNil ifTrue: [ self initializeEncoder ].
	^encoder""",nil)
smalltalk.bind(smalltalk.Compiler,"encoder:",0
,smalltalk.__f__("""(self,anEncoder):
	#Compiler>>#encoder:
	smalltalk.basic_at_put(self,"@encoder",anEncoder) 
	return self 
""","Compiler_encoder_")
,"accessing","""encoder: anEncoder
	" Set the encoder of the receiver. "

	encoder := anEncoder""",nil)
smalltalk.bind(smalltalk.Compiler,"endCompiling:",0
,smalltalk.__f__("""(self,aMethodNode):
	#Compiler>>#endCompiling:
	self.encoder().endCompiling_(aMethodNode) 
	self.triggerEvent_with_(smalltalk.String("endCompiling:"),aMethodNode) 
	return self 
""","Compiler_endCompiling_")
,"private","""endCompiling: aMethodNode
	" Private - Finish emmiting code for aMethodNode. "

	self encoder endCompiling: aMethodNode.
	self triggerEvent: #endCompiling: with: aMethodNode.""",nil)
smalltalk.bind(smalltalk.Compiler,"eval:",0
,smalltalk.__f__("""(self,nativeExpression):
	#Compiler>>#eval:
	return smalltalk.Smalltalk.current().eval_(nativeExpression) 
""","Compiler_eval_")
,"evaluation","""eval: nativeExpression
	" Return the result of evaluating a native expression in global context. "

	^Smalltalk current eval: nativeExpression""",nil)
smalltalk.bind(smalltalk.Compiler,"eval:as:",0
,smalltalk.__f__("""(self,nativeExpression,aState):
	#Compiler>>#eval:as:
	return smalltalk.Smalltalk.current().eval_as_(nativeExpression,aState) 
""","Compiler_eval_as_")
,"evaluation","""eval: nativeExpression as: aState
	" Return the result of evaluating a native expression in global context.
	The state of the system change to state while evaluating the expression.
	"

	^Smalltalk current eval: nativeExpression as: aState""",nil)
smalltalk.bind(smalltalk.Compiler,"evaluate:",0
,smalltalk.__f__("""(self,smalltalkExpression):
	#Compiler>>#evaluate:
	return self.evaluate_in_to_(smalltalkExpression,(nil).__class__,nil) 
""","Compiler_evaluate_")
,"doIt","""evaluate: smalltalkExpression
	" Return the result of evaluating the smalltalk expression in global context. "

	^self evaluate: smalltalkExpression in: nil class to: nil""",nil)
smalltalk.bind(smalltalk.Compiler,"compiledMethodToEvaluate:in:",0
,smalltalk.__f__("""(self,smalltalkExpression,aClass):
	#Compiler>>#compiledMethodToEvaluate:in:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.doIt=nil
	__0__.node=nil
	__0__.code=nil
	__0__.doIt=smalltalk.String.doItSelector() 
	self.currentClass_(aClass) 
	__0__.node=self.parseMethod_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.doIt,smalltalk.String(" ^[")),smalltalkExpression),smalltalk.String("] value"))) 
	__0__.code=self.emmitNode_(__0__.node) 
	__0__.result=self.eval_(__0__.code) 
	__0__.result.category_(__0__.doIt) 
	aClass.addCompiledMethod_(__0__.result) 
	return __0__.result 
""","Compiler_compiledMethodToEvaluate_in_")
,"evaluation","""compiledMethodToEvaluate: smalltalkExpression in: aClass
	" Return a compiled method to evaluate the smalltalk expression in aClass. "

	| result doIt node code |
	doIt := String doItSelector.
	self currentClass: aClass.
	node := self parseMethod: doIt,' ^[', smalltalkExpression, '] value'.
	code := self emmitNode: node.
	result := self eval: code.
	result category: doIt.
	aClass addCompiledMethod: result.
	^result""",nil)
smalltalk.bind(smalltalk.Compiler,"evaluate:in:to:",0
,smalltalk.__f__("""(self,smalltalkExpression,aClass,aReceiver):
	#Compiler>>#evaluate:in:to:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.result=aReceiver.perform_(__0__.cm.selector())
		return __0__.result 
	def __blk2__():
		return __0__.cm.removeFromSystem() 
	__0__.result=nil
	__0__.cm=nil
	__0__.cm=self.compiledMethodToEvaluate_in_(smalltalkExpression,aClass) 
	smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
	return __0__.result 
""","Compiler_evaluate_in_to_")
,"evaluation","""evaluate: smalltalkExpression in: aClass to: aReceiver
	" Return the result of evaluating the smalltalk expression with aReceiver. "

	| result cm |
	cm := self compiledMethodToEvaluate: smalltalkExpression in: aClass.
	[ result := aReceiver perform: cm selector.
	] ensure: [ cm removeFromSystem ].
	^result""",nil)
smalltalk.bind(smalltalk.Compiler,"initialize",0
,smalltalk.__f__("""(self):
	#Compiler>>#initialize
	smalltalk.superReceiver(smalltalk.Compiler,self).initialize() 
	self.resetVariables() 
	return self 
""","Compiler_initialize")
,"initialize","""initialize
	" Private - Initialize the receiver. "

	super initialize.
	self resetVariables.""",nil)
smalltalk.bind(smalltalk.Compiler,"initializeEncoder",0
,smalltalk.__f__("""(self):
	#Compiler>>#initializeEncoder
	def __blk1__():
		return smalltalk.S8Encoder.for_(self) 
	smalltalk.basic_at_put(self,"@encoder",self.triggerEvent_ifNotHandled_(smalltalk.String("needsEncoder"),smalltalk.blk(__blk1__,0))) 
	return self 
""","Compiler_initializeEncoder")
,"private","""initializeEncoder
	" Private - Initialize the encoder of the receiver. "

	encoder := self
		triggerEvent: #needsEncoder
		ifNotHandled: [ S8Encoder for: self ]""",nil)
smalltalk.bind(smalltalk.Compiler,"knownVariables",0
,smalltalk.__f__("""(self):
	#Compiler>>#knownVariables
	return smalltalk.object_comma_(self.pseudoVariables(),self.tempVariables()) 
""","Compiler_knownVariables")
,"variables","""knownVariables
	" Return the knownVariables of the receiver. "

	^self pseudoVariables , self tempVariables""",nil)
smalltalk.bind(smalltalk.Compiler,"load:forClass:",0
,smalltalk.__f__("""(self,aString,aClass):
	#Compiler>>#load:forClass:
	__0__=smalltalk.newContext()
	__0__.nativeCode=nil
	__0__.nativeCode=self.compile_forClass_(aString,aClass) 
	return self.eval_(__0__.nativeCode) 
""","Compiler_load_forClass_")
,"compiling","""load: aString forClass: aClass
	" Return the CompiledMethod result of compiling aString as a method implemented in aClass. "

	| nativeCode |
	nativeCode := self compile: aString forClass: aClass.
	^self eval: nativeCode""",nil)
smalltalk.bind(smalltalk.Compiler,"localName:",0
,smalltalk.__f__("""(self,aName):
	#Compiler>>#localName:
	return self.encoder().localName_(aName) 
""","Compiler_localName_")
,"private","""localName: aName
	" Private - Return a valid (native, local) name for aName. "

	^self encoder localName: aName""",nil)
smalltalk.bind(smalltalk.Compiler,"nativeLanguage",0
,smalltalk.__f__("""(self):
	#Compiler>>#nativeLanguage
	return self.encoder().nativeLanguage() 
""","Compiler_nativeLanguage")
,"accessing","""nativeLanguage

	^self encoder nativeLanguage""",nil)
smalltalk.bind(smalltalk.Compiler,"nodeFromTemplateIn:",0
,smalltalk.__f__("""(self,aString):
	_s8Ret_=smalltalk.newContext()
	try:
		#Compiler>>#nodeFromTemplateIn:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.booleanNot_(smalltalk.isObject_equalTo_(aString.last(),smalltalk.String('"'))) 
		def __blk2__(mth):
			def __blk3__():
				def __blk4__(_s8_rec):
					_s8_rec.source_(aString) 
					return _s8_rec.yourself() 
				return __blk4__(mth) 
			return smalltalk.if_true_false_(smalltalk.notNil_(mth),smalltalk.blk(__blk3__,0),nil) 
		__0__.src=nil
		__0__.driver=nil
		__0__.selector=nil
		__0__.count=nil
		__0__.found=nil
		if smalltalk.b(smalltalk.boolean_or_(aString.isEmpty(),smalltalk.blk(__blk1__,0))):
			return nil 
		 
		__0__.src=aString.upToLast_(smalltalk.String('"')).fromLast_(smalltalk.String('"')).stream() 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.src.peek(),smalltalk.String("#"))):
			__0__.src.next() 
		else:
			def __blk5__():
				return smalltalk.raise_result_(_s8Ret_,nil) 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(smalltalk.String("template"),__0__.src.nextLine().upTo_(smalltalk.String(" "))),nil,smalltalk.blk(__blk5__,0)) 
		 
		__0__.driver=__0__.src.upTo_(smalltalk.String(" ")) 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.driver,smalltalk.String("self"))):
			__0__.driver=self 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.driver,smalltalk.String("class"))):
			__0__.driver=self.currentClass() 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.driver,smalltalk.String("encoder"))):
			__0__.driver=self.encoder() 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.driver,smalltalk.String("api"))):
			__0__.driver=smalltalk.String("APIBuilder") 
		 
		if smalltalk.b(__0__.driver.isString()):
			def __blk6__():
				nil 
			__0__.driver=smalltalk.Smalltalk.at_ifAbsent_(__0__.driver,smalltalk.blk(__blk6__,0)) 
		 
		smalltalk.basic_at_put(self,"@selector",__0__.src.upTo_(smalltalk.String(" "))) 
		if not smalltalk.b(smalltalk.responds_to_(__0__.driver,(__0__.selector))):
			smalltalk.raise_result_(_s8Ret_,nil) 
		 
		__0__.count=__0__.selector.occurrencesOf_(smalltalk.String(":")) 
		__0__.found=smalltalk.blk(__blk2__,1) 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.count,smalltalk.Number(0))):
			smalltalk.raise_result_(_s8Ret_,__0__.found.value_(__0__.driver.perform_(__0__.selector))) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.count,smalltalk.Number(1))):
			smalltalk.raise_result_(_s8Ret_,__0__.found.value_(__0__.driver.perform_with_(__0__.selector,__0__.src.upToEnd()))) 
		 
		smalltalk.raise_result_(_s8Ret_,nil) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","Compiler_nodeFromTemplateIn_")
,"templates","""nodeFromTemplateIn: aString
	" Return the nodes syntetized from inlined templates in aString (or nil).
	Inlined templates are detected from last comment in source.
	"

	| src driver selector count found |
	(aString isEmpty or: [(aString last = $") not]) ifTrue: [ ^nil ].
	src := ((aString upToLast: $") fromLast: $") stream.
	src peek = $# ifTrue: [ src next ] ifFalse: [
		#template = (src nextLine upTo: $ ) ifFalse: [ ^nil ]
	].
	driver := src upTo: $ .
	driver = #self  ifTrue: [ driver := self ].
	driver = #class ifTrue: [ driver := self currentClass ].
	driver = #encoder ifTrue: [ driver := self encoder ].
	driver = #api   ifTrue: [ driver := #APIBuilder ].
	driver isString ifTrue: [ driver := Smalltalk at: driver ifAbsent: [] ].
	selector := src upTo: $ .
	(driver respondsTo: selector) ifFalse: [ ^nil ].
	count := selector occurrencesOf: $:.
	found := [:mth| mth notNil ifTrue: [ mth source: aString; yourself ] ].
	count = 0 ifTrue: [ ^found value: (driver perform: selector) ].
	count = 1 ifTrue: [ ^found value: (driver perform: selector with: src upToEnd) ].
	^nil""",nil)
smalltalk.bind(smalltalk.Compiler,"parser",0
,smalltalk.__f__("""(self):
	#Compiler>>#parser
	def __blk1__():
		return smalltalk.SmalltalkParser.new() 
	return self.triggerEvent_ifNotHandled_(smalltalk.String("needsParser"),smalltalk.blk(__blk1__,0)) 
""","Compiler_parser")
,"private","""parser
	" Private - Return the parser of the receiver. "

	^self	triggerEvent: #needsParser
		ifNotHandled: [ SmalltalkParser new ]""",nil)
smalltalk.bind(smalltalk.Compiler,"prepare:",0
,smalltalk.__f__("""(self,aMethodNode):
	#Compiler>>#prepare:
	def __blk1__(each):
		return each.visit_(aMethodNode) 
	self.encoder().prepare_(aMethodNode) 
	self.transformers().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Compiler_prepare_")
,"private","""prepare: aMethodNode
	" Private - Apply tranformations/optimization to aMethodNode. "

	self encoder prepare: aMethodNode.
	self transformers do: [:each| each visit: aMethodNode ].""",nil)
smalltalk.bind(smalltalk.Compiler,"pseudoVariables",0
,smalltalk.__f__("""(self):
	#Compiler>>#pseudoVariables
	return smalltalk.newArray(["self","super","true","false","nil","thisContext"]) 
""","Compiler_pseudoVariables")
,"variables","""pseudoVariables
	" Return the pseudoVariables of the receiver. "

	^#( #self #super #true #false #nil #thisContext )""",nil)
smalltalk.bind(smalltalk.Compiler,"recompile:",0
,smalltalk.__f__("""(self,aClass):
	#Compiler>>#recompile:
	def __blk1__(each):
		return self.compile_forClass_category_(each.source(),aClass,each.category()) 
	self.triggerEvent_with_(smalltalk.String("aboutToRecompile:"),aClass) 
	aClass.methodDictionary().do_(smalltalk.blk(__blk1__,1)) 
	self.triggerEvent_with_(smalltalk.String("recompiled:"),aClass) 
	if not smalltalk.b(aClass.isMetaclass()):
		self.recompile_((aClass).__class__) 
	 
	return self 
""","Compiler_recompile_")
,"compiling","""recompile: aClass
	" Re-compile all the methods defined by aClass. "

	self triggerEvent: #aboutToRecompile: with: aClass.
	aClass methodDictionary do: [:each |
"Debug		self note: each."
		self compile: each source forClass: aClass category: each category
	].
	self triggerEvent: #recompiled: with: aClass.
	aClass isMetaclass ifFalse: [ self recompile: aClass class ].""",nil)
smalltalk.bind(smalltalk.Compiler,"resetVariables",0
,smalltalk.__f__("""(self):
	#Compiler>>#resetVariables
	smalltalk.basic_at_put(self,"@unknownVariables",smalltalk.newArray([])) 
	smalltalk.basic_at_put(self,"@tempVariables",smalltalk.newArray([])) 
	return self 
""","Compiler_resetVariables")
,"variables","""resetVariables
	" Reset the variables of the receiver. "

	unknownVariables := #().
	tempVariables := #().""",nil)
smalltalk.bind(smalltalk.Compiler,"smalltalkNameFor:",0
,smalltalk.__f__("""(self,aClass):
	#Compiler>>#smalltalkNameFor:
	return self.encoder().smalltalkNameFor_(aClass) 
""","Compiler_smalltalkNameFor_")
,"names","""smalltalkNameFor: aClass
	" Return the global name of aClass (can be nil). "

	^self encoder smalltalkNameFor: aClass""",nil)
smalltalk.bind(smalltalk.Compiler,"startCompiling:",0
,smalltalk.__f__("""(self,aNode):
	#Compiler>>#startCompiling:
	if not smalltalk.b(aNode.isParseFailure()):
		smalltalk.basic_at_put(self,"@selector",aNode.selector()) 
	 
	self.triggerEvent_with_(smalltalk.String("startCompiling:"),aNode) 
	self.encoder().startCompiling_(aNode) 
	return self 
""","Compiler_startCompiling_")
,"private","""startCompiling: aNode
	" Private - Set the receiver to start emmiting code for aNode. "

	aNode isParseFailure ifFalse: [
		selector := aNode selector
	].
	self triggerEvent: #startCompiling: with: aNode.
	self encoder startCompiling: aNode.""",nil)
smalltalk.bind(smalltalk.Compiler,"tempVariables",0
,smalltalk.__f__("""(self):
	#Compiler>>#tempVariables
	return getattr(self,"@tempVariables",nil) 
""","Compiler_tempVariables")
,"variables","""tempVariables
	" Return the tempVariables of the receiver. "

	^tempVariables""",nil)
smalltalk.bind(smalltalk.Compiler,"transformers",0
,smalltalk.__f__("""(self):
	#Compiler>>#transformers
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@transformers",nil))):
		smalltalk.basic_at_put(self,"@transformers",smalltalk.Array.new()) 
		self.triggerEvent_with_(smalltalk.String("setTransformers:"),getattr(self,"@transformers",nil)) 
	 
	return getattr(self,"@transformers",nil) 
""","Compiler_transformers")
,"accessing","""transformers
	" Return the node transformers installed in the receiver. "

	transformers isNil ifTrue: [
		transformers := Array new.
		self triggerEvent: #setTransformers: with: transformers.
	].
	^transformers""",nil)
smalltalk.bind(smalltalk.Compiler,"unknownVariables",0
,smalltalk.__f__("""(self):
	#Compiler>>#unknownVariables
	return getattr(self,"@unknownVariables",nil) 
""","Compiler_unknownVariables")
,"variables","""unknownVariables
	" Return the unknownVariables of the receiver. "

	^unknownVariables""",nil)
smalltalk.bind(smalltalk.Compiler,"useTemplates",0
,smalltalk.__f__("""(self):
	#Compiler>>#useTemplates
	def __blk1__():
		return getattr(self,"@useTemplates",nil) 
	return smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@useTemplates",nil)),smalltalk.blk(__blk1__,0)) 
""","Compiler_useTemplates")
,"accessing","""useTemplates
	" Return true if the receiver use templates. "

	^useTemplates notNil and: [ useTemplates ]""",nil)
smalltalk.bind(smalltalk.Compiler,"useTemplates:",0
,smalltalk.__f__("""(self,aBoolean):
	#Compiler>>#useTemplates:
	smalltalk.basic_at_put(self,"@useTemplates",aBoolean) 
	return self 
""","Compiler_useTemplates_")
,"accessing","""useTemplates: aBoolean
	" Set the receiver to consider inlined templates. "

	useTemplates := aBoolean""",nil)
smalltalk.bind(smalltalk.SourceCodeParser.__class__,"parse:",0
,smalltalk.__f__("""(self,aStream):
	#SourceCodeParser class>>#parse:
	return self.new().parse_(aStream) 
""","SourceCodeParser_class_parse_")
,"instantiation","""parse: aStream
	" Return the result of parsing contents in aStream. "

	^self new parse: aStream """,nil)
smalltalk.bind(smalltalk.SourceCodeParser.__class__,"debug:",0
,smalltalk.__f__("""(self,aStream):
	#SourceCodeParser class>>#debug:
	def __blk1__():
		return self.parse_(aStream) 
	return smalltalk.PPParser.debugWhile_(smalltalk.blk(__blk1__,0)) 
""","SourceCodeParser_class_debug_")
,"debug","""debug: aStream
	^PPParser debugWhile: [
		self parse: aStream
	]""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"parse:",0
,smalltalk.__f__("""(self,aStream):
	#SourceCodeParser>>#parse:
	return self.parser().parse_(aStream) 
""","SourceCodeParser_parse_")
,"parsing","""parse: aStream
	" Return the result of parsing contents in aStream. "

	^self parser parse: aStream""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"gc",0
,smalltalk.__f__("""(self):
	#SourceCodeParser>>#gc
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("JSC"))):
		smalltalk.Smalltalk.gc() 
	 
	return self 
""","SourceCodeParser_gc")
,"gc","""gc
	" Private - Perform (preventive) garbage collection.
	Note: JavascriptCore VM can crash reporting
	 'memory issues' if we do not GC asap.
	 This issue will persist while Apple continue
	  distributing a version of JSC with issue reported
		http://alereimondo.no-ip.org/U8/232
		https://bugs.webkit.org/show_bug.cgi?id=160027
	"

	(Smalltalk includesKey: #JSC) ifTrue: [ Smalltalk gc ].""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"separator",0
,smalltalk.__f__("""(self):
	#SourceCodeParser>>#separator
	return smalltalk.PPCharacterParser.separator() 
""","SourceCodeParser_separator")
,"parsers","""separator
	" Return the parser for separator. "

	^PPCharacterParser separator""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"parser",0
,smalltalk.__f__("""(self):
	#SourceCodeParser>>#parser
	return self.implementedBySubclass_(smalltalk.String("parser")) 
""","SourceCodeParser_parser")
,"parsers","""parser
	" Return the method parser. "

	^self implementedBySubclass: #parser""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"charParser:",0
,smalltalk.__f__("""(self,options):
	#SourceCodeParser>>#charParser:
	def __blk1__(c):
		def __blk2__():
			return options.includes_(c) 
		return smalltalk.boolean_or_(c.isAlphaNumeric(),smalltalk.blk(__blk2__,0)) 
	return smalltalk.PPCharacterParser.for_doing_(smalltalk.object_comma_(smalltalk.String("a-zA-Z0-9"),options),smalltalk.blk(__blk1__,1)) 
""","SourceCodeParser_charParser_")
,"parsers","""charParser: options
	" Private - Return the character parser. "

	^PPCharacterParser for: 'a-zA-Z0-9',options doing: [:c|
		c isAlphaNumeric or: [ options includes: c ]
	]""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"charParserOr:",0
,smalltalk.__f__("""(self,char):
	#SourceCodeParser>>#charParserOr:
	def __blk1__(c):
		def __blk2__():
			return smalltalk.isObject_equalTo_(c,char) 
		return smalltalk.boolean_or_(c.isAlphaNumeric(),smalltalk.blk(__blk2__,0)) 
	return smalltalk.PPCharacterParser.for_doing_(smalltalk.object_comma_(smalltalk.String("a-zA-Z0-9"),char),smalltalk.blk(__blk1__,1)) 
""","SourceCodeParser_charParserOr_")
,"parsers","""charParserOr: char
	" Private - Return the character parser. "

	^PPCharacterParser for: 'a-zA-Z0-9',char doing: [:c|
		c isAlphaNumeric or: [ c = char ]
	]""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,",","_comma"
,smalltalk.__f__("""(self,anObject):
	#SourceCodeParser>>#,
	return smalltalk.object_comma_(smalltalk.PPParser,anObject) 
""","SourceCodeParser__comma")
,"parsers",""", anObject
	" Private - Return the parser to start parsing anObject. "

	^PPParser , anObject""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"optional:",0
,smalltalk.__f__("""(self,anObject):
	#SourceCodeParser>>#optional:
	return smalltalk.PPParser.optional_(anObject) 
""","SourceCodeParser_optional_")
,"parsers","""optional: anObject
	" Private - Return the parser to parse an optional element anObject. "

	^PPParser optional: anObject""",nil)
smalltalk.bind(smalltalk.SourceCodeParser,"gc:",0
,smalltalk.__f__("""(self,anObject):
	#SourceCodeParser>>#gc:
	def __blk1__(node):
		self.gc() 
		return node 
	return smalltalk.object_comma_(self,anObject)._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","SourceCodeParser_gc_")
,"parsers","""gc: anObject
	" Private - Return the parser to parse anObject. "

	^(self ,anObject) ==> [:node| self gc. node ]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#SmalltalkParser class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.newArray(["needsDirectiveParser:ws:"]),smalltalk.superReceiver(smalltalk.SmalltalkParser.__class__,self).constructEventsTriggered()) 
""","SmalltalkParser_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^#(	#needsDirectiveParser:ws:
	) , super constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"missingDirective:ws:",0
,smalltalk.__f__("""(self,number,ws):
	#SmalltalkParser>>#missingDirective:ws:
	def __blk1__(node):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid directive - "),node.first())) 
	return smalltalk.object_comma_(smalltalk.PPCharacterParser.notIn_(smalltalk.String(">")).star().flatten(),smalltalk.String(">"))._at_at(smalltalk.String("missingDirective"))._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","SmalltalkParser_missingDirective_ws_")
,"directives","""missingDirective: number ws: ws
	" Private - Return the parser for missing support of directives. "

	^(PPCharacterParser notIn: $>) star flatten
	, $> @@#missingDirective
	==> [:node| self error: 'Invalid directive - ' ,node first ]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"jsDirective:ws:",0
,smalltalk.__f__("""(self,number,ws):
	#SmalltalkParser>>#jsDirective:ws:
	def __blk1__(node):
		return smalltalk.JSDirectiveNode.code_protected_(node.second(),smalltalk.isObject_equalTo_(node.first(),smalltalk.String("javascript:"))) 
	return smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("js:"))._slash(smalltalk.String("javascript:")),smalltalk.PPInlineParser.upTo_(smalltalk.String(":>")))._at_at(smalltalk.String("jsDirective"))._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","SmalltalkParser_jsDirective_ws_")
,"directives","""jsDirective: number ws: ws
	" Private - Return the parser for native directives.
	"

	^self	, #js: / #javascript:
		, (PPInlineParser upTo: ':>')
		@@#jsDirective
	==> [:node| JSDirectiveNode
		code: node second
		protected: node first = #javascript:
	]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"optDirective:ws:",0
,smalltalk.__f__("""(self,number,ws):
	#SmalltalkParser>>#optDirective:ws:
	def __blk1__(node):
		def __blk2__(_s8_rec):
			_s8_rec.args_(node.second().asArrayOfSubstrings()) 
			_s8_rec.remove_(smalltalk.isObject_equalTo_(node.first(),smalltalk.String("opt-:"))) 
			return _s8_rec.yourself() 
		return __blk2__(smalltalk.InlineOptimizationNode.new()) 
	return smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("opt:"))._slash(smalltalk.String("opt+:"))._slash(smalltalk.String("opt-:")),smalltalk.PPInlineParser.upTo_(smalltalk.String(":>")))._at_at(smalltalk.String("optDirective"))._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","SmalltalkParser_optDirective_ws_")
,"directives","""optDirective: number ws: ws
	" Private - Return the parser for compiler optimizations directive.
	"

	^self	, #opt: / #opt+: / #opt-:
		,(PPInlineParser upTo: ':>')
		@@#optDirective
	==> [:node| InlineOptimizationNode new
		args: node second asArrayOfSubstrings;
		remove: node first = #opt-:;
		yourself
	]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"defaultDirective:ws:",0
,smalltalk.__f__("""(self,number,ws):
	#SmalltalkParser>>#defaultDirective:ws:
	return self.optDirective_ws_(number,ws)._slash(self.jsDirective_ws_(number,ws))._slash(self.missingDirective_ws_(number,ws)) 
""","SmalltalkParser_defaultDirective_ws_")
,"directives","""defaultDirective: number ws: ws
	" Private - Return the parser for default support of directives.
	We support inlined native directives.
	"

	^ (self optDirective: number ws: ws)
	/ (self jsDirective: number ws: ws)
	/ (self missingDirective: number ws: ws)""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"directive:ws:",0
,smalltalk.__f__("""(self,number,ws):
	#SmalltalkParser>>#directive:ws:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.defaultDirective_ws_(number,ws) 
	def __blk2__(node):
		return node.second().second() 
	__0__.parser=nil
	__0__.parser=self.triggerEvent_withArguments_ifNotHandled_(smalltalk.String("needsDirectiveParser:ws:"),smalltalk.Array.with_with_(number,ws),smalltalk.blk(__blk1__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("<")),smalltalk.object_comma_(smalltalk.object_comma_(ws,__0__.parser),ws))._at_at(smalltalk.String("directive"))._eq_eq_gt(smalltalk.blk(__blk2__,1)) 
""","SmalltalkParser_directive_ws_")
,"directives","""directive: number ws: ws
	" Private - Return the parser for directives. "

	| parser |
	parser := self
		triggerEvent: #needsDirectiveParser:ws:
		withArguments: (Array with: number with: ws)
		ifNotHandled: [ self defaultDirective: number ws: ws ].

	^self	, $< ,(ws, parser, ws) @@#directive
		==> [:node | node second second ]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"binarySelectorChars",0
,smalltalk.__f__('''(self):
	#SmalltalkParser>>#binarySelectorChars
	return smalltalk.String("""|&+*/=><,@%~-\\\\?!""") 
''',"SmalltalkParser_binarySelectorChars")
,"constants","""binarySelectorChars
	" Return the binary selector characters mask. "

	^'|&+*/=><,@%~-\\?!' """,nil)
smalltalk.bind(smalltalk.SmalltalkParser,"binaryCharParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#binaryCharParser
	return smalltalk.PPCharacterParser.in_(self.binarySelectorChars())._at_at(smalltalk.String("binaryChar")) 
""","SmalltalkParser_binaryCharParser")
,"parsers","""binaryCharParser
	" Return the binary selector character parser. "

	^(PPCharacterParser in: self binarySelectorChars) @@#binaryChar""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"symbolCharParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#symbolCharParser
	return self.charParserOr_(smalltalk.String("_"))._at_at(smalltalk.String("symbolChar")) 
""","SmalltalkParser_symbolCharParser")
,"parsers","""symbolCharParser
	" Return the symbol character parser. "

	^(self charParserOr: $_) @@#symbolChar""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"jsSymbolCharParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#jsSymbolCharParser
	return self.charParser_(smalltalk.String("_$"))._at_at(smalltalk.String("jsSymbolChar")) 
""","SmalltalkParser_jsSymbolCharParser")
,"parsers","""jsSymbolCharParser
	" Private - Return the js symbol character parser. "

	^(self charParser: '_$') @@#jsSymbolChar""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"extendedSymbolCharParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#extendedSymbolCharParser
	return self.charParser_(smalltalk.object_comma_(smalltalk.String("_:"),self.binarySelectorChars()))._at_at(smalltalk.String("extendedSymbolChar")) 
""","SmalltalkParser_extendedSymbolCharParser")
,"parsers","""extendedSymbolCharParser
	" Private - Return the extended symbol character parser. "

	^(self charParser: '_:' , self binarySelectorChars) @@#extendedSymbolChar""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"globalNameParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#globalNameParser
	return smalltalk.object_comma_(smalltalk.PPCharacterParser.between_and_(smalltalk.String("A"),smalltalk.String("Z")),self.symbolCharParser().star()).flatten()._at_at(smalltalk.String("globalNameParser")) 
""","SmalltalkParser_globalNameParser")
,"parsers","""globalNameParser
	" Return the parser for global names. "

	^((PPCharacterParser between: $A and: $Z)
		, self symbolCharParser star)
		flatten @@#globalNameParser""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"comment",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#comment
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"').asParser(),smalltalk.object_comma_(smalltalk.booleanNot_(smalltalk.String('"').asParser()),smalltalk.PPAnyParser.new()).star()),smalltalk.String('"'))._at_at(smalltalk.String("stComment")).flatten()._at_at(smalltalk.String("comment")) 
""","SmalltalkParser_comment")
,"parsers","""comment
	" Return the parser for comment. "

	^($" asParser
	,($" asParser not, PPAnyParser new) star
	, $" @@#stComment) flatten
	@@#comment""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"nameStart",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#nameStart
	def __blk1__(c):
		def __blk2__():
			return smalltalk.isObject_equalTo_(c,smalltalk.String("_")) 
		return smalltalk.boolean_or_(c.between_and_(smalltalk.String("a"),smalltalk.String("z")),smalltalk.blk(__blk2__,0)) 
	return smalltalk.PPCharacterParser.for_doing_(smalltalk.String("a-z_"),smalltalk.blk(__blk1__,1))._at_at(smalltalk.String("nameStart")) 
""","SmalltalkParser_nameStart")
,"parsers","""nameStart
	" Return the parser for name start."

	^(PPCharacterParser for: 'a-z_' doing: [:c|
		(c between: $a and: $z)
		or: [ c = $_ ]
	]) @@#nameStart""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"upNameStart",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#upNameStart
	def __blk1__(c):
		def __blk2__():
			return smalltalk.isObject_equalTo_(c,smalltalk.String("_")) 
		return smalltalk.boolean_or_(c.isLetter(),smalltalk.blk(__blk2__,0)) 
	return smalltalk.PPCharacterParser.for_doing_(smalltalk.String("A-Za-z_"),smalltalk.blk(__blk1__,1))._at_at(smalltalk.String("upNameStart")) 
""","SmalltalkParser_upNameStart")
,"parsers","""upNameStart
	" Return the parser for name start (can be uppercase)."

	^(PPCharacterParser for: 'A-Za-z_' doing: [:c|
		c isLetter or: [ c = $_ ]
	]) @@#upNameStart""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"digits",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#digits
	return smalltalk.PPCharacterParser.between_and_(smalltalk.String("0"),smalltalk.String("9")).plus() 
""","SmalltalkParser_digits")
,"parsers","""digits
	" Return the parser for numeric digits."

	^(PPCharacterParser between: $0 and: $9) plus""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"decimals",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#decimals
	return smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String(".")),self.digits())._at_at(smalltalk.String("decimals")) 
""","SmalltalkParser_decimals")
,"parsers","""decimals
	" Return the parser for number decimals."

	^self	, $.
		, self digits
		@@#decimals""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"exponent",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#exponent
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("e")),self.optional_(smalltalk.String("-"))),self.digits())._at_at(smalltalk.String("exponent")) 
""","SmalltalkParser_exponent")
,"parsers","""exponent
	" Return the parser for number exponent."

	^self	, $e
		, (self optional: $-)
		, self digits
		@@#exponent""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"radix",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#radix
	def __blk1__(c):
		def __blk2__():
			return c.between_and_(smalltalk.String("A"),smalltalk.String("Z")) 
		return smalltalk.boolean_or_(c.between_and_(smalltalk.String("0"),smalltalk.String("9")),smalltalk.blk(__blk2__,0)) 
	return smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("r")),smalltalk.PPCharacterParser.for_doing_(smalltalk.String("0-9A-Z"),smalltalk.blk(__blk1__,1)).plus())._at_at(smalltalk.String("radix")) 
""","SmalltalkParser_radix")
,"parsers","""radix
	" Return the parser for number radix."

	^self	, $r
		, (PPCharacterParser for: '0-9A-Z' doing: [:c|
			(c between: $0 and: $9)
			or: [ c between: $A and: $Z ]
		]) plus
		@@#radix""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"number",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#number
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.optional_(smalltalk.String("-")),self.digits()),self.decimals().optional()),self.exponent()._slash(self.radix()).optional())._at_at(smalltalk.String("number")) 
""","SmalltalkParser_number")
,"parsers","""number
	" Return the parser for number."

	^(self optional: $-)
		, self digits , self decimals optional
		, (self exponent / self radix) optional
		@@#number""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"annotationStart",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#annotationStart
	return smalltalk.object_comma_(self,smalltalk.String("::")) 
""","SmalltalkParser_annotationStart")
,"private","""annotationStart
	" Private - Return the parser for starting annotations. "

	^self ,#:: """,nil)
smalltalk.bind(smalltalk.SmalltalkParser,"methodParserParts",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#methodParserParts
	__0__=smalltalk.newContext()
	def __blk1__(node):
		return smalltalk.ValueNode.with_(node.second()) 
	def __blk2__(node):
		return smalltalk.ValueNode.with_(node.second()) 
	def __blk3__(node):
		return smalltalk.ValueNode.with_(node.first()).annotations_(node.last()) 
	def __blk4__(node):
		return smalltalk.ValueNode.with_(node.second()) 
	def __blk5__(node):
		return smalltalk.ValueNode.with_(node.asNumber()) 
	def __blk6__(node):
		return smalltalk.ValueNode.with_(node.at_(smalltalk.Number(2))) 
	def __blk7__(token):
		return smalltalk.VariableNode.new().value_(token) 
	def __blk8__(token):
		return smalltalk.NoReceiverNode.new() 
	def __blk9__(node):
		return smalltalk.ValueNode.with_(smalltalk.true) 
	def __blk10__(node):
		return smalltalk.ValueNode.with_(smalltalk.false) 
	def __blk11__(node):
		return smalltalk.ValueNode.with_(nil) 
	def __blk12__(node):
		return smalltalk.ValueNode.with_(node) 
	def __blk13__(node):
		def __blk14__(each):
			return each.second().value() 
		return smalltalk.ValueNode.with_(smalltalk.Array.withAll_(node.second().collect_(smalltalk.blk(__blk14__,1)))) 
	def __blk15__(node):
		return smalltalk.ValueNode.with_(smalltalk.Array.new()) 
	def __blk16__(token):
		self.gc() 
		return smalltalk.GlobalReferenceNode.new().value_(token) 
	def __blk17__(node):
		return smalltalk.AlienNode.new().value_(node.second()) 
	def __blk18__(nodes):
		return nodes.first().indexedAs_(nodes) 
	def __blk19__(nodes):
		def __blk20__(each):
			return each.at_(smalltalk.Number(2)) 
		def __blk21__(each):
			return each.at_(smalltalk.Number(4)) 
		return smalltalk.Array.with_with_(nodes.collect_(smalltalk.blk(__blk20__,1)).join_(smalltalk.String("")),nodes.collect_(smalltalk.blk(__blk21__,1))) 
	def __blk22__(node):
		return smalltalk.Array.with_with_(node.second(),smalltalk.Array.with_(node.fourth())) 
	def __blk23__(node):
		return smalltalk.Array.with_with_(node.second(),smalltalk.Array.new()) 
	def __blk24__(node):
		return node.fourth() 
	def __blk25__(node):
		return smalltalk.object_comma_(smalltalk.Array.with_(node.first()),node.second()) 
	def __blk26__(node):
		def __blk27__(_s8_rec):
			_s8_rec.left_(node.first()) 
			return _s8_rec.right_(node.at_(smalltalk.Number(5))) 
		return __blk27__(smalltalk.AssignmentNode.new()) 
	def __blk28__(node):
		def __blk29__(_s8_rec):
			_s8_rec.addNode_(node.at_(smalltalk.Number(3)).annotations_(node.at_(smalltalk.Number(4)))) 
			return _s8_rec.yourself() 
		return __blk29__(smalltalk.ReturnNode.new()) 
	def __blk30__(node):
		def __blk31__(each):
			return each.second() 
		return node.second().collect_(smalltalk.blk(__blk31__,1)) 
	def __blk32__(node):
		def __blk33__(each):
			return each.third() 
		return node.first().collect_(smalltalk.blk(__blk33__,1)) 
	def __blk34__(node):
		return node.third() 
	def __blk35__(node):
		return smalltalk.Array.with_(node) 
	def __blk36__(node):
		def __blk37__(_s8_rec):
			_s8_rec.add_(node.at_(smalltalk.Number(5))) 
			return _s8_rec.yourself() 
		return __blk37__(node.first()) 
	def __blk38__(node):
		return node.first() 
	def __blk39__(node):
		def __blk40__(_s8_rec):
			_s8_rec.temps_(node.first()) 
			_s8_rec.directives_(node.third()) 
			_s8_rec.nodes_(node.at_(smalltalk.Number(5))) 
			return _s8_rec.yourself() 
		return __blk40__(smalltalk.ExtendedSequenceNode.new()) 
	def __blk41__(node):
		def __blk42__(_s8_rec):
			_s8_rec.parameters_(node.third()) 
			return _s8_rec.addNode_(node.at_(smalltalk.Number(5)).asBlockSequenceNode()) 
		return __blk42__(smalltalk.BlockNode.new()) 
	def __blk43__(node):
		return smalltalk.SendNode.new().selector_(node.second()) 
	def __blk44__(node):
		def __blk45__():
			return node.first() 
		def __blk46__():
			return node.second().valueForReceiver_(node.first()) 
		return smalltalk.if_true_false_(smalltalk.isNil_(node.second()),smalltalk.blk(__blk45__,0),smalltalk.blk(__blk46__,0)) 
	def __blk47__(node):
		def __blk48__():
			return node.first() 
		def __blk49__():
			return node.second().valueForReceiver_(node.first()) 
		return smalltalk.if_true_false_(smalltalk.isNil_(node.second()),smalltalk.blk(__blk48__,0),smalltalk.blk(__blk49__,0)) 
	def __blk50__(node):
		def __blk51__(_s8_rec):
			_s8_rec.selector_(node.second()) 
			return _s8_rec.arguments_(smalltalk.Array.with_(node.fourth())) 
		return __blk51__(smalltalk.SendNode.new()) 
	def __blk52__(node):
		def __blk53__():
			return node.first() 
		def __blk54__():
			return node.second().valueForReceiver_(node.first()) 
		return smalltalk.if_true_false_(smalltalk.isNil_(node.second()),smalltalk.blk(__blk53__,0),smalltalk.blk(__blk54__,0)) 
	def __blk55__(node):
		def __blk56__():
			return node.first() 
		def __blk57__():
			return node.second().valueForReceiver_(node.first()) 
		return smalltalk.if_true_false_(smalltalk.isNil_(node.second()),smalltalk.blk(__blk56__,0),smalltalk.blk(__blk57__,0)) 
	def __blk58__(nodes):
		def __blk59__(_s8_rec):
			def __blk60__(each):
				return each.second().first() 
			def __blk61__(each):
				return each.second().third() 
			_s8_rec.selector_(nodes.collect_(smalltalk.blk(__blk60__,1)).join_(smalltalk.String(""))) 
			return _s8_rec.arguments_(nodes.collect_(smalltalk.blk(__blk61__,1))) 
		return __blk59__(smalltalk.SendNode.new()) 
	def __blk62__(node):
		return node.second().valueForReceiver_(node.first()) 
	def __blk63__(node):
		def __blk64__(each):
			return each.third() 
		return node.first().cascadeNodeWithMessages_(node.second().collect_(smalltalk.blk(__blk64__,1))) 
	def __blk65__(node):
		return smalltalk.InlineNode.sources_parser_(node.second(),smalltalk.object_comma_(__0__.ws,__0__.sequence.optional())) 
	__0__.expression=nil
	__0__.separator=nil
	__0__.comment=nil
	__0__.ws=nil
	__0__.identifier=nil
	__0__.keyword=nil
	__0__.stSelectorPart=nil
	__0__.string=nil
	__0__.symbol=nil
	__0__.number=nil
	__0__.variable=nil
	__0__.reference=nil
	__0__.globalReference=nil
	__0__.literal=nil
	__0__.returnExpression=nil
	__0__.expressionParser=nil
	__0__.keyword=nil
	__0__.unarySelector=nil
	__0__.binarySelector=nil
	__0__.keywordPattern=nil
	__0__.unaryPattern=nil
	__0__.binaryPattern=nil
	__0__.assignment=nil
	__0__.temps=nil
	__0__.blockParamList=nil
	__0__.block=nil
	__0__.expression=nil
	__0__.expressions=nil
	__0__.subexpression=nil
	__0__.statements=nil
	__0__.sequence=nil
	__0__.operand=nil
	__0__.unaryMessage=nil
	__0__.unarySend=nil
	__0__.unaryTail=nil
	__0__.binaryMessage=nil
	__0__.binarySend=nil
	__0__.binaryTail=nil
	__0__.keywordMessage=nil
	__0__.keywordSend=nil
	__0__.keywordPair=nil
	__0__.cascade=nil
	__0__.message=nil
	__0__.inline=nil
	__0__.jsIndex=nil
	__0__.character=nil
	__0__.directive=nil
	__0__.arrayLiteral=nil
	__0__.arrayVariable=nil
	__0__.literalArray=nil
	__0__.aSymbol=nil
	__0__.stIdentifier=nil
	__0__.jsIdentifier=nil
	__0__.noReference=nil
	__0__.alienReference=nil
	__0__.alienIdentifier=nil
	__0__.emptyArray=nil
	__0__.hashedString=nil
	__0__.annotation=nil
	__0__.argument=nil
	__0__.separator=self.separator() 
	__0__.comment=self.comment() 
	__0__.ws=__0__.separator._slash(__0__.comment)._at_at(smalltalk.String("sp")).star()._at_at(smalltalk.String("ws")) 
	__0__.string=smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("'")),smalltalk.PPStStringParser.new())._at_at(smalltalk.String("string"))._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
	__0__.hashedString=smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.object_comma_(smalltalk.String("#"),smalltalk.String("'"))),smalltalk.PPStStringParser.new())._at_at(smalltalk.String("hashedString"))._eq_eq_gt(smalltalk.blk(__blk2__,1)) 
	__0__.stIdentifier=smalltalk.object_comma_(self.nameStart(),self.symbolCharParser().star())._at_at(smalltalk.String("stId")).flatten()._at_at(smalltalk.String("stIdentifier")) 
	__0__.stSelectorPart=smalltalk.object_comma_(self.upNameStart(),self.symbolCharParser().star())._at_at(smalltalk.String("stSel")).flatten()._at_at(smalltalk.String("stSelectorPart")) 
	__0__.jsIdentifier=smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("#")),self.jsSymbolCharParser().plus())._at_at(smalltalk.String("jsId")).flatten()._at_at(smalltalk.String("jsIdentifier")) 
	__0__.alienIdentifier=self.jsSymbolCharParser().plus().flatten()._at_at(smalltalk.String("alienIdentifier")) 
	__0__.identifier=__0__.jsIdentifier._slash(__0__.stIdentifier)._at_at(smalltalk.String("identifier")) 
	__0__.keyword=smalltalk.object_comma_(__0__.stSelectorPart._slash(__0__.identifier),smalltalk.String(":")).flatten()._at_at(smalltalk.String("keyword")) 
	__0__.annotation=smalltalk.object_comma_(self.annotationStart(),__0__.string._slash(__0__.stIdentifier)._slash(self.globalNameParser()))._at_at(smalltalk.String("annotation")) 
	__0__.argument=smalltalk.object_comma_(__0__.identifier,__0__.annotation.star())._eq_eq_gt(smalltalk.blk(__blk3__,1)) 
	__0__.symbol=smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("#")),self.extendedSymbolCharParser().plus().flatten())._at_at(smalltalk.String("symbol"))._eq_eq_gt(smalltalk.blk(__blk4__,1)) 
	__0__.number=self.number().flatten()._eq_eq_gt(smalltalk.blk(__blk5__,1)) 
	__0__.character=smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("$")),smalltalk.PPAnyParser.new())._at_at(smalltalk.String("character"))._eq_eq_gt(smalltalk.blk(__blk6__,1)) 
	__0__.directive=self.directive_ws_(__0__.number,__0__.ws) 
	__0__.variable=__0__.identifier._eq_eq_gt(smalltalk.blk(__blk7__,1)) 
	__0__.noReference=smalltalk.object_comma_(self,smalltalk.String("#"))._at_at(smalltalk.String("noReference"))._eq_eq_gt(smalltalk.blk(__blk8__,1)) 
	__0__.literal=smalltalk.PPDelegateParser.new()._at_at(smalltalk.String("literalDelegate")) 
	__0__.expression=smalltalk.PPDelegateParser.new()._at_at(smalltalk.String("expressionDelegate")) 
	__0__.arrayVariable=smalltalk.object_comma_(self,smalltalk.String("true"))._eq_eq_gt(smalltalk.blk(__blk9__,1))._slash(smalltalk.object_comma_(self,smalltalk.String("false"))._eq_eq_gt(smalltalk.blk(__blk10__,1)))._slash(smalltalk.object_comma_(self,smalltalk.String("nil"))._eq_eq_gt(smalltalk.blk(__blk11__,1)))._at_at(smalltalk.String("arrayVariable")) 
	__0__.aSymbol=self.extendedSymbolCharParser().plus().flatten()._at_at(smalltalk.String("aSymbol"))._eq_eq_gt(smalltalk.blk(__blk12__,1)) 
	__0__.arrayLiteral=__0__.literal._slash(__0__.arrayVariable)._slash(__0__.aSymbol)._slash(__0__.variable) 
	__0__.literalArray=smalltalk.object_comma_(smalltalk.object_comma_(self.gc_(smalltalk.String("#(")),smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.arrayLiteral),__0__.ws).star()),smalltalk.String(")"))._at_at(smalltalk.String("literalArray"))._eq_eq_gt(smalltalk.blk(__blk13__,1)) 
	__0__.emptyArray=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("#(")),__0__.ws),smalltalk.String(")"))._at_at(smalltalk.String("emptyArray"))._eq_eq_gt(smalltalk.blk(__blk15__,1)) 
	__0__.globalReference=self.globalNameParser()._at_at(smalltalk.String("globalReference"))._eq_eq_gt(smalltalk.blk(__blk16__,1)) 
	__0__.alienReference=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.object_comma_(smalltalk.String("#"),smalltalk.String("{"))),__0__.alienIdentifier),smalltalk.String("}"))._at_at(smalltalk.String("alienReference"))._eq_eq_gt(smalltalk.blk(__blk17__,1)) 
	__0__.jsIndex=smalltalk.object_comma_(smalltalk.object_comma_(self.gc_(smalltalk.String("[")),__0__.expression),smalltalk.String("]"))._slash(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("#")),__0__.alienIdentifier)) 
	__0__.reference=smalltalk.object_comma_(__0__.variable._slash(__0__.globalReference)._slash(__0__.alienReference)._at_at(smalltalk.String("ref")),__0__.jsIndex.star())._at_at(smalltalk.String("reference"))._eq_eq_gt(smalltalk.blk(__blk18__,1)) 
	__0__.binarySelector=smalltalk.object_comma_(self.optional_(smalltalk.String("#")),self.binaryCharParser().plus()).flatten()._at_at(smalltalk.String("binarySelector")) 
	__0__.unarySelector=__0__.stSelectorPart._slash(__0__.identifier)._at_at(smalltalk.String("unarySelector")) 
	__0__.keywordPattern=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.keyword)._at_at(smalltalk.String("kw")),__0__.ws),__0__.argument)._at_at(smalltalk.String("kwId")).plus()._at_at(smalltalk.String("keywordPattern"))._eq_eq_gt(smalltalk.blk(__blk19__,1)) 
	__0__.binaryPattern=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.binarySelector),__0__.ws),__0__.argument)._at_at(smalltalk.String("binaryPattern"))._eq_eq_gt(smalltalk.blk(__blk22__,1)) 
	__0__.unaryPattern=smalltalk.object_comma_(__0__.ws,__0__.unarySelector)._at_at(smalltalk.String("unaryPattern"))._eq_eq_gt(smalltalk.blk(__blk23__,1)) 
	__0__.expressions=smalltalk.object_comma_(__0__.expression,smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,smalltalk.String(".")),__0__.ws),__0__.expression)._at_at(smalltalk.String("anExpression"))._eq_eq_gt(smalltalk.blk(__blk24__,1)).star())._at_at(smalltalk.String("expressions"))._eq_eq_gt(smalltalk.blk(__blk25__,1)) 
	__0__.assignment=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.reference,__0__.ws),smalltalk.String(":=")),__0__.ws),__0__.expression)._at_at(smalltalk.String("assignment"))._eq_eq_gt(smalltalk.blk(__blk26__,1)) 
	__0__.returnExpression=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.gc_(smalltalk.String("^"))._at_at(smalltalk.String("caret")),__0__.ws),__0__.expression),__0__.annotation.star()),__0__.ws),smalltalk.String(".").asParser().optional())._at_at(smalltalk.String("returnExpression"))._eq_eq_gt(smalltalk.blk(__blk28__,1)) 
	__0__.temps=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("|")),smalltalk.object_comma_(__0__.ws,__0__.argument).star()),__0__.ws),smalltalk.String("|"))._at_at(smalltalk.String("temps"))._eq_eq_gt(smalltalk.blk(__blk30__,1)) 
	__0__.blockParamList=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String(":")),__0__.ws),__0__.argument),__0__.ws).plus(),smalltalk.String("|"))._at_at(smalltalk.String("blockParamList"))._eq_eq_gt(smalltalk.blk(__blk32__,1)) 
	__0__.subexpression=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.gc_(smalltalk.String("(")),__0__.ws),__0__.expression),__0__.ws),smalltalk.String(")"))._at_at(smalltalk.String("subexpression"))._eq_eq_gt(smalltalk.blk(__blk34__,1)) 
	__0__.statements=__0__.returnExpression._at_at(smalltalk.String("stat1"))._eq_eq_gt(smalltalk.blk(__blk35__,1))._slash(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.expressions,__0__.ws),smalltalk.String(".")),__0__.ws),__0__.returnExpression)._at_at(smalltalk.String("stat2"))._eq_eq_gt(smalltalk.blk(__blk36__,1)))._slash(smalltalk.object_comma_(__0__.expressions,self.optional_(smalltalk.String(".")))._at_at(smalltalk.String("stat3"))._eq_eq_gt(smalltalk.blk(__blk38__,1))) 
	__0__.sequence=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.temps.optional()._at_at(smalltalk.String("temps")),__0__.ws),__0__.directive.star()),__0__.ws),__0__.statements.optional()),__0__.ws)._at_at(smalltalk.String("sequence"))._eq_eq_gt(smalltalk.blk(__blk39__,1)) 
	__0__.block=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.gc_(smalltalk.String("[")),__0__.ws),__0__.blockParamList.optional()),__0__.ws),__0__.sequence.optional()),__0__.ws),smalltalk.String("]"))._at_at(smalltalk.String("block"))._eq_eq_gt(smalltalk.blk(__blk41__,1)) 
	__0__.operand=__0__.block._slash(__0__.literal)._slash(__0__.reference)._slash(__0__.noReference)._slash(__0__.subexpression)._at_at(smalltalk.String("operand")) 
	__0__.literal.parser_(__0__.symbol._slash(__0__.number)._slash(__0__.string)._slash(__0__.character)._slash(__0__.emptyArray)._slash(__0__.literalArray)._slash(__0__.hashedString)._at_at(smalltalk.String("literalDelegate"))) 
	__0__.unaryMessage=smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.unarySelector),smalltalk.booleanNot_(smalltalk.object_comma_(self,smalltalk.String(":"))))._at_at(smalltalk.String("unaryMessage"))._eq_eq_gt(smalltalk.blk(__blk43__,1)) 
	__0__.unaryTail=smalltalk.PPDelegateParser.new()._at_at(smalltalk.String("unaryTailDelegate")) 
	__0__.unaryTail.parser_(smalltalk.object_comma_(__0__.unaryMessage,__0__.unaryTail.optional())._at_at(smalltalk.String("unaryTailDelegate"))._eq_eq_gt(smalltalk.blk(__blk44__,1))) 
	__0__.unarySend=smalltalk.object_comma_(__0__.operand,__0__.unaryTail.optional())._at_at(smalltalk.String("unarySend"))._eq_eq_gt(smalltalk.blk(__blk47__,1)) 
	__0__.binaryMessage=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.binarySelector),__0__.ws),__0__.unarySend._slash(__0__.operand))._at_at(smalltalk.String("binaryMessage"))._eq_eq_gt(smalltalk.blk(__blk50__,1)) 
	__0__.binaryTail=smalltalk.PPDelegateParser.new()._at_at(smalltalk.String("binaryTailDelegate")) 
	__0__.binaryTail.parser_(smalltalk.object_comma_(__0__.binaryMessage,__0__.binaryTail.optional())._eq_eq_gt(smalltalk.blk(__blk52__,1))) 
	__0__.binarySend=smalltalk.object_comma_(__0__.unarySend,__0__.binaryTail.optional())._at_at(smalltalk.String("binarySend"))._eq_eq_gt(smalltalk.blk(__blk55__,1)) 
	__0__.keywordPair=smalltalk.object_comma_(smalltalk.object_comma_(__0__.keyword,__0__.ws),__0__.binarySend)._at_at(smalltalk.String("keywordPair")) 
	__0__.keywordMessage=smalltalk.object_comma_(__0__.ws,__0__.keywordPair).plus()._at_at(smalltalk.String("keywordMessage"))._eq_eq_gt(smalltalk.blk(__blk58__,1)) 
	__0__.keywordSend=smalltalk.object_comma_(__0__.binarySend,__0__.keywordMessage)._at_at(smalltalk.String("keywordSend"))._eq_eq_gt(smalltalk.blk(__blk62__,1)) 
	__0__.message=__0__.binaryMessage._slash(__0__.unaryMessage)._slash(__0__.keywordMessage)._at_at(smalltalk.String("message")) 
	__0__.cascade=smalltalk.object_comma_(__0__.keywordSend._slash(__0__.binarySend)._at_at(smalltalk.String("head")),smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,smalltalk.String(";")),__0__.message).plus())._at_at(smalltalk.String("cascade"))._eq_eq_gt(smalltalk.blk(__blk63__,1)) 
	__0__.inline=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self,smalltalk.String("{")),smalltalk.object_comma_(smalltalk.object_comma_(__0__.stIdentifier.optional(),__0__.string),__0__.ws).plus()),smalltalk.String("}"))._at_at(smalltalk.String("inline"))._eq_eq_gt(smalltalk.blk(__blk65__,1)) 
	__0__.expression.parser_(__0__.assignment._slash(__0__.cascade)._slash(__0__.keywordSend)._slash(__0__.binarySend)._slash(__0__.inline)._at_at(smalltalk.String("expression"))) 
	return smalltalk.Array.with_with_with_(__0__.ws,__0__.keywordPattern._slash(__0__.binaryPattern)._slash(__0__.unaryPattern)._at_at(smalltalk.String("header")),__0__.sequence.optional()._at_at(smalltalk.String("body"))) 
""","SmalltalkParser_methodParserParts")
,"private","""methodParserParts
	" Private - Return a parser for parts of a method. "

 | expression separator comment ws identifier keyword stSelectorPart
  string symbol number variable reference globalReference
  literal returnExpression expressionParser keyword unarySelector
  binarySelector keywordPattern unaryPattern binaryPattern assignment
  temps blockParamList block expression expressions subexpression
  statements sequence operand unaryMessage unarySend unaryTail
  binaryMessage binarySend binaryTail keywordMessage keywordSend
  keywordPair cascade message inline jsIndex character directive
  arrayLiteral arrayVariable literalArray aSymbol
  stIdentifier jsIdentifier noReference alienReference
  alienIdentifier emptyArray hashedString annotation argument
 |

 separator := self separator.
 comment := self comment.
 ws := (separator / comment @@#sp) star @@#ws.
 
 string := self ,$' ,PPStStringParser new @@#string
  ==> [:node| ValueNode with: node second ].
 
 hashedString := self ,($#,$') ,PPStStringParser new @@#hashedString
  ==> [:node| ValueNode with: node second ].

 stIdentifier := (self nameStart, self symbolCharParser star @@#stId) flatten @@#stIdentifier.
 stSelectorPart := (self upNameStart, self symbolCharParser star @@#stSel) flatten @@#stSelectorPart.
 jsIdentifier := (self ,$# ,self jsSymbolCharParser plus @@#jsId) flatten @@#jsIdentifier.
 alienIdentifier := self jsSymbolCharParser plus flatten @@#alienIdentifier.
 identifier := jsIdentifier / stIdentifier @@#identifier.

 keyword := (stSelectorPart / identifier, $:) flatten @@#keyword.

 annotation := self annotationStart ,(string / stIdentifier / self globalNameParser) @@#annotation.
 argument := identifier ,annotation star ==> [:node|
	(ValueNode with: node first) annotations: node last
 ].

 symbol := self ,$# ,self extendedSymbolCharParser plus flatten @@#symbol
  ==> [:node | ValueNode with: node second ].

 number := self number flatten
  ==> [:node | ValueNode with: node asNumber ].

 character := self ,$$ ,PPAnyParser new @@#character
  ==> [:node | ValueNode with: (node at: 2) ].

 directive := self directive: number ws: ws.

 variable := identifier ==> [:token | VariableNode new value: token ].
 noReference := self ,$# @@#noReference ==> [:token | NoReceiverNode new ].
 literal := PPDelegateParser new @@#literalDelegate.
 expression := PPDelegateParser new @@#expressionDelegate.

 arrayVariable :=
	  (self ,#true  ==> [:node| ValueNode with: true ])
	/ (self ,#false ==> [:node| ValueNode with: false ])
	/ (self ,#nil   ==> [:node| ValueNode with: nil ])
	@@#arrayVariable.

 aSymbol := self extendedSymbolCharParser plus flatten @@#aSymbol
  ==> [:node| ValueNode with: node ].

 arrayLiteral := literal / arrayVariable / aSymbol / variable.
 literalArray := (self gc: '#(')
	,(ws ,arrayLiteral ,ws) star ,$)
	@@#literalArray
  ==> [:node | ValueNode with: (Array
	withAll: (node second
		collect: [:each | each second value])) ].
 emptyArray := self ,'#(' ,ws ,$) @@#emptyArray
  ==> [:node | ValueNode with: Array new ].

 globalReference := self globalNameParser @@#globalReference
  ==> [:token | self gc. GlobalReferenceNode new value: token ].
 alienReference := self ,($# ,${) ,alienIdentifier, $} @@#alienReference
  ==> [:node | AlienNode new value: node second ].

 jsIndex := (self gc: $[) ,expression, $] / (self ,$# ,alienIdentifier).
 reference := (variable / globalReference / alienReference @@#ref)
	,jsIndex star @@#reference
  ==> [:nodes | nodes first indexedAs: nodes ].

 binarySelector := (
	(self optional: $#)
	,self binaryCharParser plus
	) flatten @@#binarySelector.

 unarySelector := stSelectorPart / identifier @@#unarySelector.

 keywordPattern :=
	(ws, keyword  @@#kw ,
	 ws, argument @@#kwId
	) plus @@#keywordPattern
  ==> [:nodes | Array
   with: ((nodes collect: [:each | each at: 2]) join: '')
   with: (nodes collect: [:each | each at: 4]) ].

 binaryPattern := ws, binarySelector, ws, argument @@#binaryPattern
  ==> [:node | Array with: node second with: (Array with: node fourth)].

 unaryPattern := ws, unarySelector @@#unaryPattern
  ==> [:node | Array with: node second with: Array new].
 
 expressions := expression, ((ws, $., ws, expression) @@#anExpression
  ==> [:node | node fourth]) star @@#expressions
  ==> [:node | (Array with: node first) ,node second ].

 assignment := reference, ws, ':=', ws, expression @@#assignment
  ==> [:node | AssignmentNode new left: node first; right: (node at: 5)].

returnExpression := (self gc: $^) @@#caret
	, ws, expression ,annotation star
	, ws, $. asParser optional	@@#returnExpression
     ==> [:node | ReturnNode new
	addNode: ((node at:3) annotations: (node at: 4));
	yourself ].

 temps := self, $|, (ws, argument) star, ws, $| @@#temps
  ==> [:node | node second collect: [:each | each second ] ].

 blockParamList := (self ,$: ,ws ,argument ,ws) plus ,$| @@#blockParamList
  ==> [:node | node first collect: [:each | each third ] ].

 subexpression := (self gc: $() ,ws ,expression ,ws ,$) @@#subexpression
  ==> [:node | node third ].

 statements := (returnExpression @@#stat1 ==> [:node | Array with: node])
  / (expressions ,ws ,$. ,ws ,returnExpression @@#stat2 ==> [:node | node first add: (node at: 5); yourself ])
  / (expressions ,(self optional: $.) @@#stat3 ==> [:node | node first ]).

 sequence := temps optional @@#temps
	, ws, directive star
	, ws, statements optional
	, ws @@#sequence
  ==> [:node | ExtendedSequenceNode new
	temps: node first;
	directives: node third;
	nodes: (node at: 5);
	yourself ].

 block := (self gc: $[)
	,ws ,blockParamList optional
	,ws ,sequence optional
	,ws ,$] @@#block
  ==> [:node | BlockNode new
	parameters: node third;
	addNode: (node at: 5) asBlockSequenceNode ].

 operand := block / literal / reference / noReference / subexpression @@#operand.

 literal parser: symbol / number / string / character
	/ emptyArray / literalArray / hashedString @@#literalDelegate.

 unaryMessage := ws ,unarySelector ,(self ,$:) not @@#unaryMessage
  ==> [:node | SendNode new selector: node second ].

 unaryTail := PPDelegateParser new @@#unaryTailDelegate.
 unaryTail parser: (unaryMessage, unaryTail optional @@#unaryTailDelegate
  ==> [:node | node second isNil ifTrue: [ node first ]
	ifFalse: [ node second valueForReceiver: node first ] ]).

 unarySend := operand, unaryTail optional @@#unarySend
  ==> [:node | node second isNil ifTrue: [ node first ]
	ifFalse: [ node second valueForReceiver: node first ] ].

 binaryMessage := ws, binarySelector, ws, (unarySend / operand) @@#binaryMessage
  ==> [:node | SendNode new
	selector: node second;
	arguments: (Array with: node fourth) ].

 binaryTail := PPDelegateParser new @@#binaryTailDelegate.
 binaryTail parser: (binaryMessage, binaryTail optional
  ==> [:node | node second isNil ifTrue: [ node first ]
	ifFalse: [ node second valueForReceiver: node first ] ]).

 binarySend := unarySend, binaryTail optional @@#binarySend
  ==> [:node | node second isNil ifTrue: [ node first ]
	ifFalse: [ node second valueForReceiver: node first ] ].

 keywordPair := keyword, ws, binarySend @@#keywordPair.

 keywordMessage := (ws, keywordPair) plus @@#keywordMessage
  ==> [:nodes | SendNode new
	selector: ((nodes collect: [:each | each second first]) join: '');
	arguments: (nodes collect: [:each | each second third])].

 keywordSend := binarySend, keywordMessage @@#keywordSend
  ==> [:node | node second valueForReceiver: node first].

 message := binaryMessage / unaryMessage / keywordMessage @@#message.

 cascade := (keywordSend / binarySend @@#head)
	,(ws, $;, message) plus @@#cascade
  ==> [:node | node first cascadeNodeWithMessages: 
	(node second collect: [:each | each third ])].

 inline := self ,${
	,(stIdentifier optional ,string ,ws) plus
	,$} @@#inline
  ==> [:node | InlineNode sources: node second parser: ws ,sequence optional ].

 expression parser: assignment / cascade / keywordSend / binarySend / inline @@#expression.

^Array	with: ws
	with: keywordPattern / binaryPattern / unaryPattern @@#header
	with: sequence optional @@#body""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"parser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#parser
	__0__=smalltalk.newContext()
	def __blk1__(node):
		def __blk2__(_s8_rec):
			_s8_rec.selector_(node.first().second().first()) 
			_s8_rec.arguments_(node.first().second().second()) 
			_s8_rec.addNode_(node.first().fourth().shouldReturn()) 
			_s8_rec.source_(node.second()) 
			return _s8_rec.yourself() 
		return __blk2__(smalltalk.MethodNode.new()) 
	def __blk3__(nodes):
		return nodes.first() 
	__0__.parts=nil
	__0__.ws=nil
	__0__.header=nil
	__0__.body=nil
	__0__.method=nil
	__0__.parts=self.methodParserParts() 
	__0__.ws=__0__.parts.first() 
	__0__.header=__0__.parts.second() 
	__0__.body=__0__.parts.third() 
	__0__.method=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.ws,__0__.header),__0__.ws),__0__.body),__0__.ws)._at_at(smalltalk.String("impl")).withSource()._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
	self.gc() 
	return smalltalk.object_comma_(__0__.method,smalltalk.PPEOFParser.new())._at_at(smalltalk.String("method"))._eq_eq_gt(smalltalk.blk(__blk3__,1)) 
""","SmalltalkParser_parser")
,"parsers","""parser
	" Return the method parser. "

	| parts ws header body method |
	parts := self methodParserParts.
	ws := parts first.
	header := parts second.
	body := parts third.

	method := (ws ,header
		,ws ,body
		,ws @@#impl) withSource
	  ==> [:node | MethodNode new
		selector: node first second first;
		arguments: node first second second;
		addNode: node first fourth shouldReturn;
		source: node second;
		yourself ].
 
	self gc.
 	^method ,PPEOFParser new @@#method
	   ==> [:nodes | nodes first ]""",nil)
smalltalk.bind(smalltalk.SmalltalkParser,"methodHeaderParser",0
,smalltalk.__f__("""(self):
	#SmalltalkParser>>#methodHeaderParser
	__0__=smalltalk.newContext()
	def __blk1__(nodes):
		return nodes.second() 
	__0__.parts=nil
	__0__.ws=nil
	__0__.header=nil
	__0__.parts=self.methodParserParts() 
	__0__.ws=__0__.parts.first() 
	__0__.header=__0__.parts.second() 
	return smalltalk.object_comma_(__0__.ws,__0__.header)._at_at(smalltalk.String("methodHeader"))._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","SmalltalkParser_methodHeaderParser")
,"parsers","""methodHeaderParser
	" Return a parser for method header. "

	| parts ws header |
	parts := self methodParserParts.
	ws := parts first.
	header := parts second.
	^ws ,header @@#methodHeader
		==> [:nodes| nodes second ]""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#MethodReferences class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.newArray(["found:","found:pattern:in:","needsMethods","searchStarted","searchFinished"]),smalltalk.superReceiver(smalltalk.MethodReferences.__class__,self).constructEventsTriggered()) 
""","MethodReferences_class_constructEventsTriggered")
,"Tools-events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^#(	#found: #found:pattern:in:
		#needsMethods
		#searchStarted #searchFinished
	) , super constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"of:",0
,smalltalk.__f__("""(self,selector):
	#MethodReferences class>>#of:
	return self.new().referencesOf_(selector) 
""","MethodReferences_class_of_")
,"Tools-testing","""of: selector
	" Return the references to selector. "

	^self new referencesOf: selector""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"ofGlobal:",0
,smalltalk.__f__("""(self,globalName):
	#MethodReferences class>>#ofGlobal:
	return self.new().referencesOfGlobal_(globalName) 
""","MethodReferences_class_ofGlobal_")
,"Tools-testing","""ofGlobal: globalName
	" Return the references to global globalName. "

	^self new referencesOfGlobal: globalName""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"findClasses:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences class>>#findClasses:
	return self.new().findClasses_(what) 
""","MethodReferences_class_findClasses_")
,"Tools-testing","""findClasses: what
	" Find classes in the system matching what. "

	^self new findClasses: what""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"globals",0
,smalltalk.__f__("""(self):
	#MethodReferences class>>#globals
	__0__=smalltalk.newContext()
	def __blk1__(mth,mask,stream):
		__1__=smalltalk.newContext()
		def __blk2__():
			def __blk3__():
				return smalltalk.Array.new() 
			return __0__.result.at_ifAbsentPut_(__1__._8global,smalltalk.blk(__blk3__,0)).add_(mth) 
		__1__._8global=nil
		__1__._8global=smalltalk.SmalltalkParser.new().globalNameParser().parse_(stream) 
		return smalltalk.if_true_false_(__1__._8global.isParseFailure(),nil,smalltalk.blk(__blk2__,0)) 
	__0__.tool=nil
	__0__.result=nil
	__0__.tool=self.new() 
	__0__.result=smalltalk.PoolDictionary.new() 
	__0__.tool.when_do_(smalltalk.String("found:pattern:in:"),smalltalk.blk(__blk1__,3)) 
	__0__.tool.searchGlobalReferences() 
	return __0__.result 
""","MethodReferences_class_globals")
,"Tools-testing","""globals
	" Return the references to all global names. "

	| tool result |
	tool := self new.
	result := PoolDictionary new.
	tool when: #found:pattern:in: do: [:mth :mask :stream| | global |
		global := SmalltalkParser new globalNameParser parse: stream.
		global isParseFailure ifFalse: [
			(result at: global ifAbsentPut: [Array new]) add: mth
		].
	].
	tool searchGlobalReferences.
	^result""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"methodOverwrites",0
,smalltalk.__f__("""(self):
	#MethodReferences class>>#methodOverwrites
	return self.new().methodOverwrites() 
""","MethodReferences_class_methodOverwrites")
,"Tools-testing","""methodOverwrites
	" Find the methods that are implemented/overwritten by subclasses. "

	^self new methodOverwrites""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"variableOverwrites",0
,smalltalk.__f__("""(self):
	#MethodReferences class>>#variableOverwrites
	return self.new().variableOverwrites() 
""","MethodReferences_class_variableOverwrites")
,"Tools-testing","""variableOverwrites
	" Find the methods that has potential overwrite of variable names. "

	^self new variableOverwrites""",nil)
smalltalk.bind(smalltalk.MethodReferences.__class__,"findMessages:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences class>>#findMessages:
	return self.new().findMessages_(what) 
""","MethodReferences_class_findMessages_")
,"Tools-testing","""findMessages: what
	" Find messages in the system matching what. "

	^self new findMessages: what""",nil)
smalltalk.bind(smalltalk.MethodReferences,"initializeResults",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#initializeResults
	smalltalk.basic_at_put(self,"@results",smalltalk.Array.new()) 
	return self 
""","MethodReferences_initializeResults")
,"Tools-initialize","""initializeResults
	" Private - Initialize the results of the receiver. "

	results := Array new""",nil)
smalltalk.bind(smalltalk.MethodReferences,"reset",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#reset
	self.results_(nil) 
	return self 
""","MethodReferences_reset")
,"Tools-initialize","""reset
	" Reset the receiver. "

	self results: nil""",nil)
smalltalk.bind(smalltalk.MethodReferences,"rootClasses:",0
,smalltalk.__f__("""(self,array):
	#MethodReferences>>#rootClasses:
	smalltalk.basic_at_put(self,"@rootClasses",array) 
	return self 
""","MethodReferences_rootClasses_")
,"Tools-accessing","""rootClasses: array
	" Set the rootClasses of the receiver. "

	rootClasses := array""",nil)
smalltalk.bind(smalltalk.MethodReferences,"results",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#results
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@results",nil))):
		self.initializeResults() 
	 
	return getattr(self,"@results",nil) 
""","MethodReferences_results")
,"accessing","""results
	" Return the results of the receiver. "

	results isNil ifTrue: [ self initializeResults ].
	^results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"results:",0
,smalltalk.__f__("""(self,array):
	#MethodReferences>>#results:
	smalltalk.basic_at_put(self,"@results",array) 
	return self 
""","MethodReferences_results_")
,"Tools-accessing","""results: array
	" Set the results of the receiver. "

	results := array""",nil)
smalltalk.bind(smalltalk.MethodReferences,"rootClasses",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#rootClasses
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@rootClasses",nil))):
		return smalltalk.Smalltalk.rootClasses() 
	 
	return getattr(self,"@rootClasses",nil) 
""","MethodReferences_rootClasses")
,"Tools-accessing","""rootClasses
	" Return the rootClasses of the receiver. "

	rootClasses isNil ifTrue: [ ^Smalltalk rootClasses ].
	^rootClasses""",nil)
smalltalk.bind(smalltalk.MethodReferences,"allMethodsIn:",0
,smalltalk.__f__("""(self,aCollection):
	#MethodReferences>>#allMethodsIn:
	__0__=smalltalk.newContext()
	def __blk1__(root):
		def __blk2__(cls):
			def __blk3__(each):
				return __0__.result.add_(each) 
			def __blk4__(each):
				return __0__.result.add_(each) 
			cls.methodsDo_(smalltalk.blk(__blk3__,1)) 
			return (cls).__class__.methodsDo_(smalltalk.blk(__blk4__,1)) 
		return root.instanceClass().withAllSubclasses().do_(smalltalk.blk(__blk2__,1)) 
	__0__.result=nil
	__0__.result=smalltalk.Array.new() 
	self.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","MethodReferences_allMethodsIn_")
,"Tools-accessing","""allMethodsIn: aCollection
	" Return the methods defined by aCollection of classes. "

	| result |
	result := Array new.
	self rootClasses do: [:root|
		root instanceClass withAllSubclasses do: [:cls|
			cls methodsDo: [:each| result add: each ].
			cls class methodsDo: [:each| result add: each ].
		]
	].
	^result""",nil)
smalltalk.bind(smalltalk.MethodReferences,"allMethods",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#allMethods
	def __blk1__():
		return self.allMethodsIn_(self.rootClasses()) 
	return self.triggerEvent_ifNotHandled_(smalltalk.String("needsMethods"),smalltalk.blk(__blk1__,0)) 
""","MethodReferences_allMethods")
,"Tools-accessing","""allMethods
	" Return the methods to search the receiver. "

	^self	triggerEvent: #needsMethods
		ifNotHandled: [ self allMethodsIn: self rootClasses ]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"search:with:",0
,smalltalk.__f__("""(self,what,targetBlock):
	#MethodReferences>>#search:with:
	__0__=smalltalk.newContext()
	def __blk1__(aMethod):
		__1__=smalltalk.newContext()
		def __blk2__():
			return smalltalk.to_String(__1__.source).includes_(what) 
		def __blk3__():
			self.results().add_(aMethod) 
			self.triggerEvent_with_(smalltalk.String("found:"),aMethod) 
			if smalltalk.b(self.hasActionForEvent_(smalltalk.String("found:pattern:in:"))):
				__3__=smalltalk.newContext()
				def __blk4__():
					def __blk5__(_s8_rec):
						_s8_rec.upTo_(what) 
						return _s8_rec.atEnd() 
					return __blk5__(__3__.stream) 
				def __blk6__():
					return self.triggerEvent_withArguments_(smalltalk.String("found:pattern:in:"),__3__.args) 
				__3__.stream=nil
				__3__.args=nil
				__3__.stream=smalltalk.to_String(__1__.source).stream() 
				__3__.args=smalltalk.Array.with_with_with_(aMethod,what,__3__.stream) 
				smalltalk.whileNot_do_(smalltalk.blk(__blk4__,0),smalltalk.blk(__blk6__,0)) 
			 
			return smalltalk.true 
		def __blk7__():
			return smalltalk.false 
		__1__.source=nil
		__1__.source=targetBlock.value_(aMethod) 
		return smalltalk.if_true_false_(smalltalk.boolean_and_(smalltalk.notNil_(__1__.source),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk7__,0)) 
	__0__.atoms=nil
	__0__.atoms=self.allMethods() 
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	__0__.atoms=__0__.atoms.select_(smalltalk.blk(__blk1__,1)) 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return __0__.atoms 
""","MethodReferences_search_with_")
,"Tools-searching","""search: what with: targetBlock
	" Find what on target of selected methods. "

	| atoms |
	atoms := self allMethods.
	self triggerEvent: #searchStarted.
	atoms := atoms select: [:aMethod| | source |
		source := targetBlock value: aMethod.
		(source notNil and: [source toString includes: what]) ifTrue: [
			self results add: aMethod.
			self triggerEvent: #found: with: aMethod.
			(self hasActionForEvent: #found:pattern:in:) ifTrue: [ | stream args |
				stream := source toString stream.
				args := Array with: aMethod with: what with: stream.
				[ stream upTo: what; atEnd ] whileFalse: [
					self triggerEvent: #found:pattern:in: withArguments: args
				]
			].
			true
		] ifFalse: [ false ]
	].
	self triggerEvent: #searchFinished.
	^atoms""",nil)
smalltalk.bind(smalltalk.MethodReferences,"search:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences>>#search:
	def __blk1__(aMethod):
		return aMethod.compiledSource() 
	return self.search_with_(what,smalltalk.blk(__blk1__,1)) 
""","MethodReferences_search_")
,"Tools-searching","""search: what
	" Find references to what in selected methods.
	Note: search is realized on native source of native code of methods.
	"

	^self search: what with: [:aMethod| aMethod compiledSource ]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"searchSource:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences>>#searchSource:
	def __blk1__(aMethod):
		return aMethod.source() 
	return self.search_with_(what,smalltalk.blk(__blk1__,1)) 
""","MethodReferences_searchSource_")
,"Tools-searching","""searchSource: what
	" Find what in source of selected methods. "

	^self search: what with: [:aMethod| aMethod source ]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"inlines",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#inlines
	return self.searchSource_(smalltalk.object_comma_(smalltalk.String("{"),smalltalk.String("'"))) 
""","MethodReferences_inlines")
,"Tools-searching","""inlines
	" Find native inlines in selected methods. "

	^self searchSource: ${ ,$' """,nil)
smalltalk.bind(smalltalk.MethodReferences,"searchCategory:",0
,smalltalk.__f__("""(self,aName):
	#MethodReferences>>#searchCategory:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		self.results().add_(each) 
		return self.triggerEvent_with_(smalltalk.String("found:"),each) 
	__0__.found=nil
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	__0__.found=smalltalk.Exporter.new().matchCategory_from_(aName,self.rootClasses()) 
	__0__.found=smalltalk.object_comma_(__0__.found.first(),__0__.found.last()) 
	__0__.found.do_(smalltalk.blk(__blk1__,1)) 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return __0__.found 
""","MethodReferences_searchCategory_")
,"Tools-searching","""searchCategory: aName
	" Find (source) references to category starting from root classes. "

	| found |
	self triggerEvent: #searchStarted.
	found := Exporter new matchCategory: aName from: self rootClasses.
	found := found first , found last.
	found do: [:each|
			self results add: each.
			self triggerEvent: #found: with: each.
	].
	self triggerEvent: #searchFinished.
	^found""",nil)
smalltalk.bind(smalltalk.MethodReferences,"sendPatternsOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#sendPatternsOf:
	return smalltalk.Array.with_with_(self.normalSendPatternOf_(aSelector),self.superSendPatternOf_(aSelector)) 
""","MethodReferences_sendPatternsOf_")
,"Tools-patterns","""sendPatternsOf: aSelector
	" Private - Return the search patterns for references of aSelector. "

	^Array
		with: (self normalSendPatternOf: aSelector)
		with: (self superSendPatternOf: aSelector)""",nil)
smalltalk.bind(smalltalk.MethodReferences,"dot",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#dot
	return smalltalk.String(".") 
""","MethodReferences_dot")
,"Tools-patterns","""dot
	" Private - Return the message send pattern starter. "

	^{''js'"."'}""",nil)
smalltalk.bind(smalltalk.MethodReferences,"localDef",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#localDef
	return smalltalk.String(" ") 
""","MethodReferences_localDef")
,"Tools-patterns","""localDef
	" Private - Return the variable definition starter. "

	^{''js'"var "'}""",nil)
smalltalk.bind(smalltalk.MethodReferences,"normalSendPatternOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#normalSendPatternOf:
	return smalltalk.object_comma_(smalltalk.object_comma_(self.dot(),aSelector.asSelector()),smalltalk.String("(")) 
""","MethodReferences_normalSendPatternOf_")
,"Tools-patterns","""normalSendPatternOf: aSelector
	" Private - Return the search pattern for normal senders of aSelector. "

	^self dot ,aSelector asSelector ,$( """,nil)
smalltalk.bind(smalltalk.MethodReferences,"superJSSendPatternOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#superJSSendPatternOf:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('"'),aSelector.asSelector()),smalltalk.String('"')),smalltalk.String(").apply(self,")) 
""","MethodReferences_superJSSendPatternOf_")
,"Tools-patterns","""superJSSendPatternOf: aSelector
	" Private - Return the search pattern for senders (to super) of aSelector. "

	^$" ,aSelector asSelector ,$" ,').apply(self,'""",nil)
smalltalk.bind(smalltalk.MethodReferences,"superSendPatternOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#superSendPatternOf:
	return self.superPythonSendPatternOf_(aSelector) 
""","MethodReferences_superSendPatternOf_")
,"Tools-patterns","""superSendPatternOf: aSelector
	" Private - Return the search pattern for senders (to super) of aSelector. "

	^{''js'self.superJSSendPatternOf_(aSelector)'}""",nil)
smalltalk.bind(smalltalk.MethodReferences,"instVarPatternOf:",0
,smalltalk.__f__("""(self,instVarName):
	#MethodReferences>>#instVarPatternOf:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('self["@'),instVarName.asNativeName()),smalltalk.String('"]')) 
""","MethodReferences_instVarPatternOf_")
,"Tools-patterns","""instVarPatternOf: instVarName
	" Private - Return the search pattern for instance variable access. "

	^'self["@' ,instVarName asNativeName ,'"]'""",nil)
smalltalk.bind(smalltalk.MethodReferences,"globalPatternOf:",0
,smalltalk.__f__("""(self,globalName):
	#MethodReferences>>#globalPatternOf:
	return smalltalk.object_comma_(smalltalk.String("smalltalk."),globalName) 
""","MethodReferences_globalPatternOf_")
,"Tools-patterns","""globalPatternOf: globalName
	" Private - Return the search pattern for global variable access. "

	^'smalltalk.' ,globalName""",nil)
smalltalk.bind(smalltalk.MethodReferences,"types",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#types
	return smalltalk.newArray(["referencesOf:","referencesOfGlobal:","referencesOfClassVariable:","referencesOfInstanceVariable:","findClasses:","findMessages:","searchCategory:","search:","searchSource:","globalReferences","missingGlobals","inlines","methodOverwrites","variableOverwrites"]) 
""","MethodReferences_types")
,"Tools-types","""types
	" Private - Return the types of search implemented by the receiver. "

	^#(	#referencesOf: #referencesOfGlobal:
		#referencesOfClassVariable: 
		#referencesOfInstanceVariable:
		#findClasses: #findMessages:
		#searchCategory:
		#search: #searchSource:
		#globalReferences #missingGlobals #inlines
		#methodOverwrites #variableOverwrites
	)""",nil)
smalltalk.bind(smalltalk.MethodReferences,"search:type:",0
,smalltalk.__f__("""(self,aName,typeSelector):
	#MethodReferences>>#search:type:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.object_comma_(typeSelector.upTo_(smalltalk.String(":")),smalltalk.String(":")) 
	def __blk2__():
		return typeSelector.upTo_(smalltalk.String(" ")) 
	def __blk3__():
		return self.perform_with_(__0__.selector,aName.trimBlanks()) 
	__0__.selector=nil
	__0__.selector=smalltalk.if_true_false_(typeSelector.includes_(smalltalk.String(":")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	return smalltalk.if_true_false_(smalltalk.responds_to_(self,(__0__.selector)),smalltalk.blk(__blk3__,0),nil) 
""","MethodReferences_search_type_")
,"Tools-searching","""search: aName type: typeSelector
	" Return the result of searching for aName as a search of specified type (or nil). "

	| selector |
	selector := (typeSelector includes: $:)
	ifTrue: [ (typeSelector upTo: $:) ,$: ]
	ifFalse: [ typeSelector upTo: $  ].
	^(self respondsTo: selector) ifTrue: [
		self perform: selector with: aName trimBlanks
	]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"sendersOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#sendersOf:
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.addAll_(self.search_(each)) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	return self.sendPatternsOf_(aSelector).inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2)) 
""","MethodReferences_sendersOf_")
,"Tools-searching","""sendersOf: aSelector
	" Find the requested elements from root classes. "

	^(self sendPatternsOf: aSelector) inject: #() into: [:total :each|
		total addAll: (self search: each); yourself
	]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"referencesOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#referencesOf:
	def __blk1__(_s8_rec):
		_s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- Implementors of #"),aSelector),smalltalk.String(" ---"))) 
		_s8_rec.addAll_(self.implementorsOf_(aSelector)) 
		return _s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- Senders of #"),aSelector),smalltalk.String(" ---"))) 
	__blk1__(self.results()) 
	self.sendersOf_(aSelector) 
	return getattr(self,"@results",nil) 
""","MethodReferences_referencesOf_")
,"Tools-searching","""referencesOf: aSelector
	" Find the references to message (aSelector). "

	self results
		add: '--- Implementors of #' ,aSelector ,' ---';
		addAll: (self implementorsOf: aSelector);
		add: '--- Senders of #' ,aSelector ,' ---'.
	self sendersOf: aSelector.
	^results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"referencesOfInstanceVariable:",0
,smalltalk.__f__("""(self,instVarName):
	#MethodReferences>>#referencesOfInstanceVariable:
	return self.search_(self.instVarPatternOf_(instVarName)) 
""","MethodReferences_referencesOfInstanceVariable_")
,"Tools-searching","""referencesOfInstanceVariable: instVarName
	" Find the requested elements from root classes. "

	^self search: (self instVarPatternOf: instVarName)""",nil)
smalltalk.bind(smalltalk.MethodReferences,"settersOfInstanceVariable:",0
,smalltalk.__f__("""(self,instVarName):
	#MethodReferences>>#settersOfInstanceVariable:
	return self.search_(smalltalk.object_comma_(self.instVarPatternOf_(instVarName),smalltalk.String("="))) 
""","MethodReferences_settersOfInstanceVariable_")
,"Tools-searching","""settersOfInstanceVariable: instVarName
	" Find the requested elements from root classes. "

	^self search: (self instVarPatternOf: instVarName) ,'='""",nil)
smalltalk.bind(smalltalk.MethodReferences,"referencesOfGlobal:",0
,smalltalk.__f__("""(self,globalName):
	#MethodReferences>>#referencesOfGlobal:
	return self.search_(self.globalPatternOf_(globalName)) 
""","MethodReferences_referencesOfGlobal_")
,"Tools-searching","""referencesOfGlobal: globalName
	" Find the requested elements from root classes. "

	^self search: (self globalPatternOf: globalName)""",nil)
smalltalk.bind(smalltalk.MethodReferences,"searchGlobalReferences",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#searchGlobalReferences
	return self.search_(self.globalPatternOf_(smalltalk.String(""))) 
""","MethodReferences_searchGlobalReferences")
,"Tools-searching","""searchGlobalReferences
	" Find the requested elements from root classes. "

	^self search: (self globalPatternOf: '')""",nil)
smalltalk.bind(smalltalk.MethodReferences,"settersOfGlobalVariable:",0
,smalltalk.__f__("""(self,globalName):
	#MethodReferences>>#settersOfGlobalVariable:
	return self.search_(smalltalk.object_comma_(self.globalPatternOf_(globalName),smalltalk.String("="))) 
""","MethodReferences_settersOfGlobalVariable_")
,"Tools-searching","""settersOfGlobalVariable: globalName
	" Find the requested elements from root classes. "

	^self search: (self globalPatternOf: globalName) ,'='""",nil)
smalltalk.bind(smalltalk.MethodReferences,"referencesOfClassVariable:",0
,smalltalk.__f__("""(self,classVarName):
	#MethodReferences>>#referencesOfClassVariable:
	def __blk1__(_s8_rec):
		_s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- Getters of "),classVarName),smalltalk.String(" ---"))) 
		_s8_rec.addAll_(self.gettersOfClassVariable_(classVarName)) 
		_s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- Setters of "),classVarName),smalltalk.String(" ---"))) 
		_s8_rec.addAll_(self.settersOfClassVariable_(classVarName)) 
		return _s8_rec.yourself() 
	return __blk1__(self.results()) 
""","MethodReferences_referencesOfClassVariable_")
,"Tools-searching","""referencesOfClassVariable: classVarName
	" Find the requested elements from root classes. "

	^self results
		add: '--- Getters of ' ,classVarName ,' ---';
		addAll: (self gettersOfClassVariable: classVarName);
		add: '--- Setters of ' ,classVarName ,' ---';
		addAll: (self settersOfClassVariable: classVarName);
		yourself""",nil)
smalltalk.bind(smalltalk.MethodReferences,"gettersOfClassVariable:",0
,smalltalk.__f__("""(self,classVarName):
	#MethodReferences>>#gettersOfClassVariable:
	return self.search_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.dot(),smalltalk.String('classVariableAt_("')),classVarName),smalltalk.String('")'))) 
""","MethodReferences_gettersOfClassVariable_")
,"Tools-searching","""gettersOfClassVariable: classVarName
	" Find the requested elements from root classes. "

	^self search: self dot,'classVariableAt_("',classVarName,'")'""",nil)
smalltalk.bind(smalltalk.MethodReferences,"settersOfClassVariable:",0
,smalltalk.__f__("""(self,classVarName):
	#MethodReferences>>#settersOfClassVariable:
	return self.search_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(self.dot(),smalltalk.String('classVariableAt_put_("')),classVarName),smalltalk.String('",'))) 
""","MethodReferences_settersOfClassVariable_")
,"Tools-searching","""settersOfClassVariable: classVarName
	" Find the requested elements from root classes. "

	^self search: self dot,'classVariableAt_put_("',classVarName,'",'""",nil)
smalltalk.bind(smalltalk.MethodReferences,"globalReferences",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#globalReferences
	__0__=smalltalk.newContext()
	def __blk1__(aName):
		def __blk2__(_s8_rec):
			_s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- References to: "),aName),smalltalk.String(" ---"))) 
			return _s8_rec.addAll_(__0__.pool.at_(aName)) 
		return __blk2__(self.results()) 
	__0__.pool=nil
	__0__.pool=(self).__class__.globals() 
	__0__.pool.keys().sorted().do_(smalltalk.blk(__blk1__,1)) 
	return getattr(self,"@results",nil) 
""","MethodReferences_globalReferences")
,"Tools-searching","""globalReferences
	" Find the references to globals. "

	| pool |
	pool := self class globals.
	pool keys sorted do: [:aName|
		self results
			add: '--- References to: ',aName,' ---';
			addAll: (pool at: aName)
	].
	^results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"missingGlobals",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#missingGlobals
	__0__=smalltalk.newContext()
	def __blk1__(key):
		return smalltalk.Smalltalk.includesKey_(key) 
	def __blk2__(aName):
		def __blk3__(_s8_rec):
			_s8_rec.add_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("--- Missing global: "),aName),smalltalk.String(" ---"))) 
			return _s8_rec.addAll_(__0__.pool.at_(aName)) 
		return __blk3__(self.results()) 
	__0__.pool=nil
	__0__.pool=(self).__class__.globals() 
	__0__.pool.keys().sorted().reject_(smalltalk.blk(__blk1__,1)).do_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(self.results().isEmpty()):
		self.results().add_(smalltalk.String("--- All global references are bound to Smalltalk ---")) 
	 
	return getattr(self,"@results",nil) 
""","MethodReferences_missingGlobals")
,"Tools-searching","""missingGlobals
	" Find the references to missing globals. "

	| pool |
	pool := self class globals.
	(pool keys sorted
		reject: [:key| (Smalltalk includesKey: key) ])
		do: [:aName|
			self results
				add: '--- Missing global: ',aName,' ---';
				addAll: (pool at: aName)
		].
	self results isEmpty ifTrue: [
		self results add: '--- All global references are bound to Smalltalk ---'
	].
	^results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"implementorsOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#implementorsOf:
	return smalltalk.Smalltalk.current().implementorsOf_(aSelector) 
""","MethodReferences_implementorsOf_")
,"Tools-private","""implementorsOf: aSelector
	" Private - Return the implementors of aSelector. "

	^Smalltalk current implementorsOf: aSelector""",nil)
smalltalk.bind(smalltalk.MethodReferences,"compiledSourceStart",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#compiledSourceStart
	return smalltalk.String("(") 
""","MethodReferences_compiledSourceStart")
,"Tools-patterns","""compiledSourceStart
	" Private - Return the token for start of compiled code. "

	^{''js'"{"'}""",nil)
smalltalk.bind(smalltalk.MethodReferences,"messagesOf:",0
,smalltalk.__f__("""(self,aCompiledMethod):
	#MethodReferences>>#messagesOf:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.stream.atEnd() 
	def __blk2__():
		nil 
	def __blk3__(each):
		return each.isLiteral() 
	__0__.stream=nil
	__0__.selectors=nil
	__0__.string=nil
	__0__.stream=aCompiledMethod.compiledSource().stream() 
	__0__.stream.upTo_(self.compiledSourceStart()) 
	__0__.selectors=smalltalk.HashedSet.new() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk4__(_s8_rec):
			_s8_rec.upTo_(self.dot()) 
			return _s8_rec.upTo_(smalltalk.String("(")) 
		__0__.selectors.add_(__blk4__(__0__.stream).asArrayOfSubstringsSeparatedBy_(self.dot()).last().asStSelector()) 
	 
	__0__.selectors.remove_ifAbsent_(smalltalk.String(""),smalltalk.blk(__blk2__,0)) 
	return __0__.selectors.asArray().select_(smalltalk.blk(__blk3__,1)).sorted() 
""","MethodReferences_messagesOf_")
,"Tools-accessing","""messagesOf: aCompiledMethod
	" Return all the messages that can be sent during execution of aCompiledMethod. "

	| stream selectors string |
	stream := aCompiledMethod compiledSource stream.
	stream upTo: self compiledSourceStart.
	selectors := HashedSet new.
	[stream atEnd] whileFalse: [
		selectors add: ((
			stream upTo: self dot;upTo: $(
			) asArrayOfSubstringsSeparatedBy: self dot)
			last asStSelector
	].
	selectors remove: '' ifAbsent: [].
	^(selectors asArray select: [:each| each isLiteral ]) sorted""",nil)
smalltalk.bind(smalltalk.MethodReferences,"globalReferencesOf:",0
,smalltalk.__f__("""(self,aCompiledMethod):
	#MethodReferences>>#globalReferencesOf:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		def __blk2__():
			return smalltalk.Array.with_(aCompiledMethod) 
		def __blk3__(mth,mask,stream):
			__2__=smalltalk.newContext()
			def __blk4__():
				return __0__.result.add_(__2__._8global) 
			__2__._8global=nil
			__2__._8global=smalltalk.SmalltalkParser.new().globalNameParser().parse_(stream) 
			return smalltalk.if_true_false_(__2__._8global.isParseFailure(),nil,smalltalk.blk(__blk4__,0)) 
		_s8_rec.when_do_(smalltalk.String("needsMethods"),smalltalk.blk(__blk2__,0)) 
		_s8_rec.when_do_(smalltalk.String("found:pattern:in:"),smalltalk.blk(__blk3__,3)) 
		return _s8_rec.yourself() 
	__0__.result=nil
	__0__.result=smalltalk.HashedSet.new() 
	__blk1__(self) 
	self.searchGlobalReferences() 
	return __0__.result.asArray().sorted() 
""","MethodReferences_globalReferencesOf_")
,"Tools-accessing","""globalReferencesOf: aCompiledMethod
	" Return all the global reference names in aCompiledMethod. "

	| result |
	result := HashedSet new.
	self
		when: #needsMethods do: [ Array with: aCompiledMethod ];
		when: #found:pattern:in: do: [:mth :mask :stream| | global |
			global := SmalltalkParser new globalNameParser parse: stream.
			global isParseFailure ifFalse: [ result add: global ].
		];
		yourself.
	self searchGlobalReferences.
	^result asArray sorted""",nil)
smalltalk.bind(smalltalk.MethodReferences,"findClasses:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences>>#findClasses:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return smalltalk.asString_(each).asLowercase() 
	__0__.keys=nil
	__0__.system=nil
	if smalltalk.b(what.isString()):
		return self.findClasses_(what.trimBlanks().asArrayOfSubstrings()) 
	 
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	__0__.keys=what.collect_(smalltalk.blk(__blk1__,1)) 
	__0__.system=smalltalk.Smalltalk.current() 
	if smalltalk.b(__0__.keys.notEmpty()):
		def __blk2__(aClass):
			__2__=smalltalk.newContext()
			def __blk3__(one):
				return __2__.key.includes_(one) 
			def __blk4__():
				nil 
			def __blk5__():
				self.results().add_(aClass) 
				return self.triggerEvent_with_(smalltalk.String("found:"),aClass) 
			__2__.key=nil
			__2__.key=aClass.name().asLowercase() 
			return smalltalk.if_true_false_(smalltalk.notNil_(__0__.keys.detect_ifNone_(smalltalk.blk(__blk3__,1),smalltalk.blk(__blk4__,0))),smalltalk.blk(__blk5__,0),nil) 
		__0__.system.classes().do_(smalltalk.blk(__blk2__,1)) 
	 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return self.results() 
""","MethodReferences_findClasses_")
,"Tools-searching","""findClasses: what
	" Find classes matching what. "

	| keys system |
	what isString ifTrue: [
		^self findClasses: what trimBlanks asArrayOfSubstrings
	].
	self triggerEvent: #searchStarted.
	keys := what collect: [:each| each asString asLowercase ].
	system := Smalltalk current.
	keys notEmpty ifTrue: [
		system classes do: [:aClass| | key |
			key := aClass name asLowercase.
			(keys detect: [:one| key includes: one ] ifNone: []) notNil ifTrue: [
				self results add: aClass.
				self triggerEvent: #found: with: aClass.
			]
		].
	].
	self triggerEvent: #searchFinished.
	^self results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"methodOverwritesOf:",0
,smalltalk.__f__("""(self,aClass):
	#MethodReferences>>#methodOverwritesOf:
	__0__=smalltalk.newContext()
	def __blk1__(mth):
		__1__=smalltalk.newContext()
		def __blk2__(each):
			def __blk3__():
				return __0__.map.at_(__1__.selector).add_(each._gt_gt(__1__.selector)) 
			return smalltalk.if_true_false_(each.selectors().includes_(__1__.selector),smalltalk.blk(__blk3__,0),nil) 
		__1__.selector=nil
		__1__.selector=mth.selector() 
		__0__.map.at_put_(__1__.selector,smalltalk.Array.with_(mth)) 
		return __0__.subclasses.do_(smalltalk.blk(__blk2__,1)) 
	def __blk4__(each):
		def __blk5__(key,value):
			def __blk6__():
				return smalltalk.Array.new() 
			return __0__.map.at_ifAbsentPut_(key,smalltalk.blk(__blk6__,0)).addAll_(value) 
		return self.methodOverwritesOf_(each).keysAndValuesDo_(smalltalk.blk(__blk5__,2)) 
	def __blk7__(key):
		return __0__.map.at_(key).size()._lt_eq(smalltalk.Number(1)) 
	def __blk8__(key):
		return __0__.map.removeKey_(key) 
	__0__.map=nil
	__0__.subclasses=nil
	__0__.subclasses=aClass.allSubclasses() 
	__0__.map=smalltalk.PoolDictionary.new() 
	if smalltalk.b(__0__.subclasses.isEmpty()):
		return __0__.map 
	 
	aClass.methodsDo_(smalltalk.blk(__blk1__,1)) 
	__0__.subclasses.do_(smalltalk.blk(__blk4__,1)) 
	__0__.map.keys().asArray().select_(smalltalk.blk(__blk7__,1)).do_(smalltalk.blk(__blk8__,1)) 
	return __0__.map 
""","MethodReferences_methodOverwritesOf_")
,"Tools-private","""methodOverwritesOf: aClass
	" Private - Find the methods subimplemented by subclasses of aClass. "

	| map subclasses |
	subclasses := aClass allSubclasses.
	map := PoolDictionary new.
	subclasses isEmpty ifTrue: [ ^map ].
	aClass methodsDo: [:mth| | selector |
		selector := mth selector.
		map at: selector put: (Array with: mth).
		subclasses do: [:each|
			(each selectors includes: selector) ifTrue: [
				(map at: selector) add: each >> selector
			].
		].
	].
	subclasses do: [:each|
		(self methodOverwritesOf: each) keysAndValuesDo: [:key :value|
			(map at: key ifAbsentPut: [Array new]) addAll: value
		].
	].
	(map keys asArray
		select: [:key| (map at: key) size <= 1 ]
		) do: [:key| map removeKey: key ].
	^map""",nil)
smalltalk.bind(smalltalk.MethodReferences,"addMethodOverwrites:",0
,smalltalk.__f__("""(self,map):
	#MethodReferences>>#addMethodOverwrites:
	def __blk1__(assoc):
		def __blk2__(each):
			self.triggerEvent_with_(smalltalk.String("found:"),each) 
			return self.results().add_(each) 
		return assoc.value().do_(smalltalk.blk(__blk2__,1)) 
	map.associationsDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","MethodReferences_addMethodOverwrites_")
,"Tools-private","""addMethodOverwrites: map
	" Private - Register the methods overwrites in map. "

	map associationsDo: [:assoc|
		assoc value do: [:each|
			self triggerEvent: #found: with: each.
			self results add: each.
		]
	]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"methodOverwrites",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#methodOverwrites
	def __blk1__(aClass):
		self.addMethodOverwrites_(self.methodOverwritesOf_(aClass)) 
		return self.addMethodOverwrites_(self.methodOverwritesOf_((aClass).__class__)) 
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	smalltalk.Smalltalk.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return self.results() 
""","MethodReferences_methodOverwrites")
,"Tools-searching","""methodOverwrites
	" Find the methods that are implemented/overwritten by subclasses. "

	self triggerEvent: #searchStarted.
	Smalltalk rootClasses do: [:aClass|
		self addMethodOverwrites: (self methodOverwritesOf: aClass).
		self addMethodOverwrites: (self methodOverwritesOf: aClass class).
	].
	self triggerEvent: #searchFinished.
	^self results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"hasArgumentOverwrites:in:",0
,smalltalk.__f__("""(self,names,stream):
	_s8Ret_=smalltalk.newContext()
	try:
		#MethodReferences>>#hasArgumentOverwrites:in:
		__0__=smalltalk.newContext()
		def __blk1__(_s8_rec):
			_s8_rec.upTo_(smalltalk.String("(")) 
			return _s8_rec.upTo_(smalltalk.String(")")) 
		def __blk2__(each):
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			return smalltalk.if_true_false_(names.includes_(each),smalltalk.blk(__blk3__,0),nil) 
		__0__.args=nil
		__0__.args=__blk1__(stream).asArrayOfSubstringsSeparatedBy_(smalltalk.String(",")) 
		__0__.args.do_(smalltalk.blk(__blk2__,1)) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","MethodReferences_hasArgumentOverwrites_in_")
,"Tools-private","""hasArgumentOverwrites: names in: stream
	" Private - Return true if stream of code has argument name conflicts. "

	| args |
	args := (stream upTo: $(; upTo: $)) asArrayOfSubstringsSeparatedBy: $,.
	args do: [:each|
		(names includes: each) ifTrue: [ ^true ].
	].
	^false""",nil)
smalltalk.bind(smalltalk.MethodReferences,"hasLocalOverwrites:in:",0
,smalltalk.__f__("""(self,names,stream):
	_s8Ret_=smalltalk.newContext()
	try:
		#MethodReferences>>#hasLocalOverwrites:in:
		__0__=smalltalk.newContext()
		def __blk1__():
			return stream.atEnd() 
		__0__.candidate=nil
		while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
			def __blk2__(_s8_rec):
				_s8_rec.upTo_(self.localDef()) 
				return _s8_rec.upTo_(smalltalk.String("=")) 
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,smalltalk.true) 
			__0__.candidate=__blk2__(stream).trimBlanks() 
			smalltalk.if_true_false_(names.includes_(__0__.candidate),smalltalk.blk(__blk3__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,smalltalk.false) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","MethodReferences_hasLocalOverwrites_in_")
,"Tools-private","""hasLocalOverwrites: names in: stream
	" Private - Return true if stream of code has local name conflicts. "

	| candidate |
	[stream atEnd] whileFalse: [
		candidate := (stream upTo: self localDef; upTo: $=) trimBlanks.
		(names includes: candidate) ifTrue: [
			^true
		].
	].
	^false""",nil)
smalltalk.bind(smalltalk.MethodReferences,"addVariableOverwrites:in:",0
,smalltalk.__f__("""(self,names,mth):
	#MethodReferences>>#addVariableOverwrites:in:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.hasLocalOverwrites_in_(names,__0__.stream) 
	__0__.stream=nil
	__0__.stream=mth.compiledSource().stream() 
	if smalltalk.b(smalltalk.boolean_or_(self.hasArgumentOverwrites_in_(names,__0__.stream),smalltalk.blk(__blk1__,0))):
		self.triggerEvent_with_(smalltalk.String("found:"),mth) 
		self.results().add_(mth) 
	 
	return self 
""","MethodReferences_addVariableOverwrites_in_")
,"Tools-private","""addVariableOverwrites: names in: mth
	" Private - Register the methods that has name overwrites. "

	| stream |
	stream := mth compiledSource stream.
	((self hasArgumentOverwrites: names in: stream)
	or: [ self hasLocalOverwrites: names in: stream ])
	ifTrue: [
		self triggerEvent: #found: with: mth.
		self results add: mth.
	]""",nil)
smalltalk.bind(smalltalk.MethodReferences,"variableOverwrites",0
,smalltalk.__f__("""(self):
	#MethodReferences>>#variableOverwrites
	def __blk1__(aClass):
		__1__=smalltalk.newContext()
		def __blk2__(mth):
			return self.addVariableOverwrites_in_(__1__.names,mth) 
		def __blk3__(mth):
			return self.addVariableOverwrites_in_(__1__.names,mth) 
		__1__.names=nil
		__1__.names=aClass.allInstVarNames() 
		aClass.methodsDo_(smalltalk.blk(__blk2__,1)) 
		__1__.names=(aClass).__class__.allInstVarNames() 
		return (aClass).__class__.methodsDo_(smalltalk.blk(__blk3__,1)) 
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	smalltalk.Smalltalk.current().classes().do_(smalltalk.blk(__blk1__,1)) 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return self.results() 
""","MethodReferences_variableOverwrites")
,"Tools-searching","""variableOverwrites
	" Find the methods that has potential overwrite of variable names. "

	self triggerEvent: #searchStarted.
	Smalltalk current classes do: [:aClass| | names |
		names := aClass allInstVarNames.
		aClass methodsDo: [:mth|
			self addVariableOverwrites: names in: mth.
		].
		names := aClass class allInstVarNames.
		aClass class methodsDo: [:mth|
			self addVariableOverwrites: names in: mth.
		].
	].
	self triggerEvent: #searchFinished.
	^self results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"findMessages:",0
,smalltalk.__f__("""(self,what):
	#MethodReferences>>#findMessages:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return smalltalk.asString_(each) 
	__0__.keys=nil
	if smalltalk.b(what.isString()):
		return self.findMessages_(what.trimBlanks().asArrayOfSubstrings()) 
	 
	self.triggerEvent_(smalltalk.String("searchStarted")) 
	__0__.keys=what.collect_(smalltalk.blk(__blk1__,1)) 
	if smalltalk.b(__0__.keys.notEmpty()):
		__1__=smalltalk.newContext()
		def __blk2__(mth):
			__2__=smalltalk.newContext()
			def __blk3__(one):
				return __2__.current.includes_(one) 
			def __blk4__():
				nil 
			def __blk5__():
				self.results().add_(mth) 
				return self.triggerEvent_with_(smalltalk.String("found:"),mth) 
			__2__.current=nil
			__2__.current=mth.selector() 
			return smalltalk.if_true_false_(smalltalk.notNil_(__0__.keys.detect_ifNone_(smalltalk.blk(__blk3__,1),smalltalk.blk(__blk4__,0))),smalltalk.blk(__blk5__,0),nil) 
		__1__.all=nil
		__1__.collect=nil
		__1__.all=self.allMethods() 
		__1__.all.do_(smalltalk.blk(__blk2__,1)) 
	 
	self.triggerEvent_(smalltalk.String("searchFinished")) 
	return self.results() 
""","MethodReferences_findMessages_")
,"Tools-searching","""findMessages: what
	" Find messages matching what. "

	| keys |
	what isString ifTrue: [
		^self findMessages: what trimBlanks asArrayOfSubstrings
	].
	self triggerEvent: #searchStarted.
	keys := what collect: [:each| each asString ].
	keys notEmpty ifTrue: [ | all collect |
		all := self allMethods.
		all do: [:mth| | current |
			current := mth selector.
			(keys detect: [:one| current includes: one ] ifNone: []) notNil ifTrue: [
				self results add: mth.
				self triggerEvent: #found: with: mth.
			].
		].
	].
	self triggerEvent: #searchFinished.
	^self results""",nil)
smalltalk.bind(smalltalk.MethodReferences,"superPythonSendPatternOf:",0
,smalltalk.__f__("""(self,aSelector):
	#MethodReferences>>#superPythonSendPatternOf:
	__0__=smalltalk.newContext()
	__0__.encoder=nil
	__0__.encoder=smalltalk.PythonEncoder.new() 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(",self)."),__0__.encoder.asPrivateSelector_(aSelector)),smalltalk.String("(self")) 
""","MethodReferences_superPythonSendPatternOf_")
,"Tools-patterns","""superPythonSendPatternOf: aSelector
	" Private - Return the search pattern for senders (to super) of aSelector. "

	| encoder |
	encoder := PythonEncoder new.
	^',self).'
		,(encoder asPrivateSelector: aSelector)
		,'(self'""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#SystemManager class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.superReceiver(smalltalk.SystemManager.__class__,self).constructEventsTriggered(),smalltalk.newArray(["aboutToBind:to:","methodBound:to:","aboutToRemove:from:","methodRemoved:from:","aboutToChange:to:","aboutToCreateClass:with:","classChanged:","classShapeChanged:","object:at:notFoundIn:","log:","memoryWarning:"])) 
""","SystemManager_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^super constructEventsTriggered ,#(
		#aboutToBind:to:
		#methodBound:to:
		#aboutToRemove:from:
		#methodRemoved:from:
		#aboutToChange:to:
		#aboutToCreateClass:with:
		#classChanged:
		#classShapeChanged:
		#object:at:notFoundIn:
		#log:
		#memoryWarning:
	)""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"currentOrNil",0
,smalltalk.__f__("""(self):
	#SystemManager class>>#currentOrNil
	def __blk1__():
		return nil 
	return self.classVariableAt_ifAbsent_(smalltalk.String("Current"),smalltalk.blk(__blk1__,0)) 
""","SystemManager_class_currentOrNil")
,"singleton","""currentOrNil
	" Return the current instance of the receiver. "

	^self classVariableAt: #Current ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"current",0
,smalltalk.__f__("""(self):
	#SystemManager class>>#current
	if smalltalk.b(smalltalk.isNil_(smalltalk.SystemManager.classVariableAt_("Current"))):
		self.current_(self.new()) 
	 
	return smalltalk.SystemManager.classVariableAt_("Current") 
""","SystemManager_class_current")
,"singleton","""current
	" Return the current instance of the receiver. "

	Current isNil ifTrue: [ self current: self new ].
	^Current""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"current:",0
,smalltalk.__f__("""(self,aSystemManager):
	#SystemManager class>>#current:
	smalltalk.SystemManager.classVariableAt_put_("Current",aSystemManager) 
	aSystemManager.install() 
	return self 
""","SystemManager_class_current_")
,"singleton","""current: aSystemManager
	" Set the current instance of the receiver. "

	Current := aSystemManager.
	aSystemManager install.""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"log:",0
,smalltalk.__f__("""(self,aString):
	#SystemManager class>>#log:
	if smalltalk.b(smalltalk.notNil_(smalltalk.SystemManager.classVariableAt_("Current"))):
		smalltalk.SystemManager.classVariableAt_("Current").log_(aString) 
	 
	return self 
""","SystemManager_class_log_")
,"log","""log: aString
	" Log aString onto loggin stream. "

	Current notNil ifTrue: [ Current log: aString ]""",nil)
smalltalk.bind(smalltalk.SystemManager.__class__,"memoryWarning:",0
,smalltalk.__f__("""(self,anArgument):
	#SystemManager class>>#memoryWarning:
	if smalltalk.b(smalltalk.notNil_(smalltalk.SystemManager.classVariableAt_("Current"))):
		smalltalk.SystemManager.classVariableAt_("Current").memoryWarning_(anArgument) 
	 
	return self 
""","SystemManager_class_memoryWarning_")
,"memory","""memoryWarning: anArgument
	" Trigger a memory warning event. "

	Current notNil ifTrue: [ Current memoryWarning: anArgument ]""",nil)
smalltalk.bind(smalltalk.SystemManager,"install",0
,smalltalk.__f__("""(self):
	#SystemManager>>#install
	return self 
""","SystemManager_install")
,"install","""install
	" Private - Install the receiver as the source manager of the system.
	The default action is to do nothing.
	This method can be refined by subclasses.
	\"""",nil)
smalltalk.bind(smalltalk.SystemManager,"aboutToBind:to:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemManager>>#aboutToBind:to:
	return self.triggerEvent_with_with_(smalltalk.String("aboutToBind:to:"),aMethod,aClass) 
""","SystemManager_aboutToBind_to_")
,"tracking-methods","""aboutToBind: aMethod to: aClass
	" Private - The method will be bound to aClass. "

	^self triggerEvent: #aboutToBind:to: with: aMethod with: aClass """,nil)
smalltalk.bind(smalltalk.SystemManager,"methodBound:to:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemManager>>#methodBound:to:
	return self.triggerEvent_with_with_(smalltalk.String("methodBound:to:"),aMethod,aClass) 
""","SystemManager_methodBound_to_")
,"tracking-methods","""methodBound: aMethod to: aClass
	" Private - The method has been bound to aClass. "

	^self triggerEvent: #methodBound:to: with: aMethod with: aClass """,nil)
smalltalk.bind(smalltalk.SystemManager,"aboutToRemove:from:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemManager>>#aboutToRemove:from:
	return self.triggerEvent_with_with_(smalltalk.String("aboutToRemove:from:"),aMethod,aClass) 
""","SystemManager_aboutToRemove_from_")
,"tracking-methods","""aboutToRemove: aMethod from: aClass
	" Private - The method will be removed from aClass. "

	^self triggerEvent: #aboutToRemove:from: with: aMethod with: aClass """,nil)
smalltalk.bind(smalltalk.SystemManager,"methodRemoved:from:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemManager>>#methodRemoved:from:
	return self.triggerEvent_with_with_(smalltalk.String("methodRemoved:from:"),aMethod,aClass) 
""","SystemManager_methodRemoved_from_")
,"tracking-methods","""methodRemoved: aMethod from: aClass
	" Private - The method has been removed from aClass. "

	^self triggerEvent: #methodRemoved:from: with: aMethod with: aClass """,nil)
smalltalk.bind(smalltalk.SystemManager,"aboutToChange:superclass:iVarNames:category:",0
,smalltalk.__f__("""(self,aClass,superclass,iVarNames,category):
	#SystemManager>>#aboutToChange:superclass:iVarNames:category:
	return self.triggerEvent_with_with_(smalltalk.String("aboutToChange:to:"),aClass,smalltalk.Array.with_with_with_(superclass,iVarNames,category)) 
""","SystemManager_aboutToChange_superclass_iVarNames_category_")
,"tracking-classes","""aboutToChange: aClass superclass: superclass iVarNames: iVarNames category: category
	" Private - aClass is about to be changed. "

	^self	triggerEvent: #aboutToChange:to:
		with: aClass
		with: (Array with: superclass with: iVarNames with: category)""",nil)
smalltalk.bind(smalltalk.SystemManager,"aboutToCreateClass:superclass:iVarNames:category:",0
,smalltalk.__f__("""(self,globalName,superclass,iVarNames,category):
	#SystemManager>>#aboutToCreateClass:superclass:iVarNames:category:
	return self.triggerEvent_with_with_(smalltalk.String("aboutToCreateClass:with:"),globalName,smalltalk.Array.with_with_with_(superclass,iVarNames,category)) 
""","SystemManager_aboutToCreateClass_superclass_iVarNames_category_")
,"tracking-classes","""aboutToCreateClass: globalName superclass: superclass iVarNames: iVarNames category: category
	" Private - Attemp to create Class with name globalName. "

	^self	triggerEvent: #aboutToCreateClass:with:
		with: globalName
		with: (Array with: superclass with: iVarNames with: category)""",nil)
smalltalk.bind(smalltalk.SystemManager,"classChanged:",0
,smalltalk.__f__("""(self,aBehavior):
	#SystemManager>>#classChanged:
	return self.triggerEvent_with_(smalltalk.String("classChanged:"),aBehavior) 
""","SystemManager_classChanged_")
,"tracking-classes","""classChanged: aBehavior
	" Private - aBehavior has been changed. "

	^self triggerEvent: #classChanged: with: aBehavior """,nil)
smalltalk.bind(smalltalk.SystemManager,"classShapeChanged:",0
,smalltalk.__f__("""(self,aBehavior):
	#SystemManager>>#classShapeChanged:
	def __blk1__():
		return aBehavior.recompileAll() 
	return self.triggerEvent_with_ifNotHandled_(smalltalk.String("classShapeChanged:"),aBehavior,smalltalk.blk(__blk1__,0)) 
""","SystemManager_classShapeChanged_")
,"tracking-classes","""classShapeChanged: aBehavior
	" Private - aBehavior has changed shape. "

	^self	triggerEvent: #classShapeChanged:
		with: aBehavior
		ifNotHandled: [ aBehavior recompileAll ]""",nil)
smalltalk.bind(smalltalk.SystemManager,"log:",0
,smalltalk.__f__("""(self,aString):
	#SystemManager>>#log:
	return self.triggerEvent_with_(smalltalk.String("log:"),aString) 
""","SystemManager_log_")
,"log","""log: aString
	" Private - Log aString onto loggin device. "

	^self triggerEvent: #log: with: aString""",nil)
smalltalk.bind(smalltalk.SystemManager,"nextPutAll:",0
,smalltalk.__f__("""(self,aString):
	#SystemManager>>#nextPutAll:
	return self.log_(aString) 
""","SystemManager_nextPutAll_")
,"streaming","""nextPutAll: aString
	" Log aString when streaming. "

	^self log: aString""",nil)
smalltalk.bind(smalltalk.SystemManager,"cr",0
,smalltalk.__f__("""(self):
	#SystemManager>>#cr
	return self 
""","SystemManager_cr")
,"streaming","""cr
	" Ignore the output, we log as line oriented streaming service. \"""",nil)
smalltalk.bind(smalltalk.SystemManager,"memoryWarning:",0
,smalltalk.__f__("""(self,anArgument):
	#SystemManager>>#memoryWarning:
	return self.triggerEvent_with_(smalltalk.String("memoryWarning:"),anArgument) 
""","SystemManager_memoryWarning_")
,"memory","""memoryWarning: anArgument
	" Trigger a memory warning event.
	The execution environment can signal memory warning/low conditions, we trigger an event to be handled at application level.
	Note: It is frequent procedure to clean cached resources that can be reconstructed later, if required.
	"

	^self triggerEvent: #memoryWarning: with: anArgument""",nil)
smalltalk.bind(smalltalk.SystemManager,"object:at:notFoundIn:",0
,smalltalk.__f__("""(self,anObject,indexOrKey,aCollection):
	#SystemManager>>#object:at:notFoundIn:
	def __blk1__():
		def __blk2__():
			return anObject 
		def __blk3__():
			return indexOrKey 
		return self.print_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Object/key("),smalltalk.to_String(smalltalk.if_true_false_(smalltalk.isNil_(indexOrKey),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)))),smalltalk.String(") not found in ")),smalltalk.printString_(aCollection))) 
	return self.triggerEvent_withArguments_ifNotHandled_(smalltalk.String("object:at:notFoundIn:"),smalltalk.Array.with_with_with_(anObject,indexOrKey,aCollection),smalltalk.blk(__blk1__,0)) 
""","SystemManager_object_at_notFoundIn_")
,"failures","""object: anObject at: indexOrKey notFoundIn: aCollection
	" Trigger a missing object event. "

	^self triggerEvent: #object:at:notFoundIn:
		withArguments: (Array with: anObject with: indexOrKey with: aCollection)
		ifNotHandled: [
			self print: 'Object/key('
				,(indexOrKey isNil ifTrue: [anObject] ifFalse: [indexOrKey]) toString
				,') not found in ',aCollection printString
		]""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"classChanged:",0
,smalltalk.__f__("""(self,aBehavior):
	#SystemChangesManager>>#classChanged:
	return self.systemHasChanged_(smalltalk.Array.with_with_(smalltalk.String("classChanged:"),aBehavior)) 
""","SystemChangesManager_classChanged_")
,"tracking-classes","""classChanged: aBehavior
	" Private - aBehavior has been changed. "

	^self systemHasChanged: (Array with: #classChanged: with: aBehavior)""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"methodBound:to:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemChangesManager>>#methodBound:to:
	def __blk1__():
		return smalltalk.isObject_equalTo_(aMethod.selector(),smalltalk.String.doItSelector()) 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(aMethod),smalltalk.blk(__blk1__,0))):
		return self 
	 
	return self.systemHasChanged_(smalltalk.Array.with_with_with_(smalltalk.String("methodBound:to:"),aMethod,aClass)) 
""","SystemChangesManager_methodBound_to_")
,"tracking-methods","""methodBound: aMethod to: aClass
	" Private - The method has been bound to aClass. "

	(aMethod isNil or: [ aMethod selector = String doItSelector ]) ifTrue: [ ^self "ignored" ].
	^self systemHasChanged: (Array with: #methodBound:to: with: aMethod with: aClass)""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"methodRemoved:from:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#SystemChangesManager>>#methodRemoved:from:
	def __blk1__():
		return smalltalk.isObject_equalTo_(aMethod.selector(),smalltalk.String.doItSelector()) 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(aMethod),smalltalk.blk(__blk1__,0))):
		return self 
	 
	return self.systemHasChanged_(smalltalk.Array.with_with_with_(smalltalk.String("methodRemoved:from:"),aMethod,aClass)) 
""","SystemChangesManager_methodRemoved_from_")
,"tracking-methods","""methodRemoved: aMethod from: aClass
	" Private - The method has been removed from aClass. "

	(aMethod isNil or: [ aMethod selector = String doItSelector ]) ifTrue: [ ^self "ignored" ].
	^self systemHasChanged: (Array with: #methodRemoved:from: with: aMethod with: aClass)""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"memoryWarning:",0
,smalltalk.__f__("""(self,anArgument):
	#SystemChangesManager>>#memoryWarning:
	return self.systemHasChanged_(smalltalk.Array.with_with_(smalltalk.String("memoryWarning:"),anArgument)) 
""","SystemChangesManager_memoryWarning_")
,"tracking-methods","""memoryWarning: anArgument
	" Private - A memory warning event has been thrown. "

	^self systemHasChanged: (Array with: #memoryWarning: with: anArgument)""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"processSystemChanges:",0
,smalltalk.__f__("""(self,changes):
	#SystemChangesManager>>#processSystemChanges:
	self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("processSystemChanges:"),smalltalk.String(" ")),smalltalk.asString_(changes)),smalltalk.String(" MUST be implemented at ")),(self).__class__.name())) 
	return self 
""","SystemChangesManager_processSystemChanges_")
,"system changes","""processSystemChanges: changes
	" Private - Update reflecting system changes. "

	self note: #processSystemChanges:
		,' ', changes asString
		,' MUST be implemented at '
		,self class name""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"changesDo:",0
,smalltalk.__f__("""(self,aOneArgumentBlock):
	#SystemChangesManager>>#changesDo:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.changes.notEmpty() 
	__0__.changes=nil
	__0__.changes=getattr(self,"@systemChanges",nil) 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(__0__.changes),smalltalk.blk(__blk1__,0))):
		smalltalk.basic_at_put(self,"@systemChanges",nil) 
		aOneArgumentBlock.value_(__0__.changes) 
	 
	return self 
""","SystemChangesManager_changesDo_")
,"changes","""changesDo: aOneArgumentBlock
	" Private - Process the changes with aOneArgumentBlock. "
	
	| changes |
	changes := systemChanges.
	(changes notNil and: [changes notEmpty]) ifTrue: [
		systemChanges := nil.
		aOneArgumentBlock value: changes
	].""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"processTheChanges",0
,smalltalk.__f__("""(self):
	#SystemChangesManager>>#processTheChanges
	def __blk1__(changes):
		return self.processSystemChanges_(changes) 
	return self.changesDo_(smalltalk.blk(__blk1__,1)) 
""","SystemChangesManager_processTheChanges")
,"changes","""processTheChanges
	" Private - Process the changes. "
	
	^self changesDo: [:changes| self processSystemChanges: changes ]""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"processSystemChanges",0
,smalltalk.__f__("""(self):
	#SystemChangesManager>>#processSystemChanges
	def __blk1__():
		return self.processTheChanges() 
	smalltalk.blk(__blk1__,0).valueDeferred_(smalltalk.Number(750)) 
	return self 
""","SystemChangesManager_processSystemChanges")
,"system changes","""processSystemChanges
	" Private - The receiver has changes to be processed.
	The default action is to defer proccessing of the changes.
	This method can be overwritten/refined by subclasses to implement alternatives of change management.
	"
	
	[ self processTheChanges ] valueDeferred: 750.""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"systemHasChanged:",0
,smalltalk.__f__("""(self,aSystemChange):
	#SystemChangesManager>>#systemHasChanged:
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@systemChanges",nil))):
		return getattr(self,"@systemChanges",nil).add_(aSystemChange) 
	 
	smalltalk.basic_at_put(self,"@systemChanges",smalltalk.Array.with_(aSystemChange)) 
	self.processSystemChanges() 
	return self 
""","SystemChangesManager_systemHasChanged_")
,"system changes","""systemHasChanged: aSystemChange
	" Private - Signal a event of system change to be resolved in the future. "

	systemChanges notNil ifTrue: [
		^systemChanges add: aSystemChange
	].
	systemChanges := Array with: aSystemChange.
	self processSystemChanges.""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"bindSystemManager",0
,smalltalk.__f__("""(self):
	#SystemChangesManager>>#bindSystemManager
	def __blk1__(each):
		def __blk2__():
			return smalltalk.SystemManager.current().when_send_to_(each,each,self) 
		return smalltalk.if_true_false_(smalltalk.responds_to_(self,(each)),smalltalk.blk(__blk2__,0),nil) 
	smalltalk.SystemManager.eventsTriggered().copyWithout_(smalltalk.String("changed")).do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SystemChangesManager_bindSystemManager")
,"system changes","""bindSystemManager
	" Private - Set the receiver to start listening current system changes.
	Note: Only the events implemented by the receiver will be hooked.
	"

	(SystemManager eventsTriggered copyWithout: #changed) do: [:each|
		(self respondsTo: each) ifTrue: [
			SystemManager current when: each send: each to: self
		]
	]""",nil)
smalltalk.bind(smalltalk.SystemChangesManager,"unbindSystemManager",0
,smalltalk.__f__("""(self):
	#SystemChangesManager>>#unbindSystemManager
	__0__=smalltalk.newContext()
	__0__.aManager=nil
	__0__.aManager=smalltalk.SystemManager.currentOrNil() 
	if smalltalk.b(smalltalk.notNil_(__0__.aManager)):
		__0__.aManager.removeAllActionsWithReceiver_(self) 
	 
	return self 
""","SystemChangesManager_unbindSystemManager")
,"system changes","""unbindSystemManager
	" Private - rest the link from the receiver to system changes. "

	| aManager |
	aManager := SystemManager currentOrNil.
	aManager notNil ifTrue: [ aManager removeAllActionsWithReceiver: self ]""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"initializeCurrent",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#initializeCurrent
	smalltalk.basic_at_put(self,"@current",self.new()) 
	return self 
""","SystemServer_class_initializeCurrent")
,"initialize","""initializeCurrent
	" Private - Initialize the current of the receiver. "

	current := self new""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"current",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#current
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@current",nil))):
		self.initializeCurrent() 
	 
	return getattr(self,"@current",nil) 
""","SystemServer_class_current")
,"accessing","""current
	" Return the current of the receiver. "

	current isNil ifTrue: [ self initializeCurrent ].
	^current""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"current:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer class>>#current:
	smalltalk.basic_at_put(self,"@current",anObject) 
	return self 
""","SystemServer_class_current_")
,"accessing","""current: anObject
	" Set the current of the receiver. "

	current := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"initializeSilent",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#initializeSilent
	smalltalk.basic_at_put(self,"@silent",smalltalk.false) 
	return self 
""","SystemServer_class_initializeSilent")
,"initialize","""initializeSilent
	" Private - Initialize the silent of the receiver. "

	silent := false""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"silent",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#silent
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@silent",nil))):
		self.initializeSilent() 
	 
	return getattr(self,"@silent",nil) 
""","SystemServer_class_silent")
,"accessing","""silent
	" Return the silent of the receiver. "

	silent isNil ifTrue: [ self initializeSilent ].
	^silent""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"silent:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer class>>#silent:
	smalltalk.basic_at_put(self,"@silent",anObject) 
	return self 
""","SystemServer_class_silent_")
,"accessing","""silent: anObject
	" Set the silent of the receiver. "

	silent := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"initializePlatform",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#initializePlatform
	smalltalk.basic_at_put(self,"@platform",self.detectedPlatform()) 
	return self 
""","SystemServer_class_initializePlatform")
,"initialize","""initializePlatform
	" Private - Initialize the platform of the receiver. "

	platform := self detectedPlatform""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"platform",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#platform
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@platform",nil))):
		self.initializePlatform() 
	 
	return getattr(self,"@platform",nil) 
""","SystemServer_class_platform")
,"accessing","""platform
	" Return the platform of the receiver. "

	platform isNil ifTrue: [ self initializePlatform ].
	^platform""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"platform:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer class>>#platform:
	smalltalk.basic_at_put(self,"@platform",anObject) 
	return self 
""","SystemServer_class_platform_")
,"accessing","""platform: anObject
	" Set the platform of the receiver. "

	platform := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"initializePort",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#initializePort
	smalltalk.basic_at_put(self,"@port",smalltalk.Number(8088)) 
	return self 
""","SystemServer_class_initializePort")
,"initialize","""initializePort
	" Private - Initialize the port of the receiver. "

	port := 8088""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"port",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#port
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@port",nil))):
		self.initializePort() 
	 
	return getattr(self,"@port",nil) 
""","SystemServer_class_port")
,"accessing","""port
	" Return the port of the receiver. "

	port isNil ifTrue: [ self initializePort ].
	^port""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"port:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer class>>#port:
	smalltalk.basic_at_put(self,"@port",anObject) 
	return self 
""","SystemServer_class_port_")
,"accessing","""port: anObject
	" Set the port of the receiver. "

	port := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"detectedPlatform",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer class>>#detectedPlatform
		def __blk1__(tuple):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,tuple.last()) 
			return smalltalk.if_true_false_(smalltalk.Smalltalk.includesKey_(tuple.first()),smalltalk.blk(__blk2__,0),nil) 
		smalltalk.newArray([["NodeJS","node"],["GCDWebServer","gcd"],["Turbo","turbo"],["SimpleHTTPServer","luaSimple"]]).do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,self.nativePlatform()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_class_detectedPlatform")
,"platform","""detectedPlatform
	" Private - Returns the platform we are running (or nil).
	Note that the platform will be used to solve transport functionality and the associated messages MUST be implemented by the receiver.
	"

	#(	#(NodeJS node)
		#(GCDWebServer gcd)
		#(Turbo turbo)
		#(SimpleHTTPServer luaSimple)
	) do: [:tuple| (Smalltalk includesKey: tuple first) ifTrue: [ ^tuple last ] ].
	^self nativePlatform""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"nativePlatform",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#nativePlatform
	__0__=smalltalk.newContext()
	__0__.prefix=nil
	__0__.prefix=self.nativeLanguage() 
	if smalltalk.b(self.implements_(smalltalk.object_comma_(__0__.prefix,smalltalk.String("RequestBlock")))):
		return __0__.prefix 
	 
	__0__.prefix=smalltalk.object_comma_(__0__.prefix,smalltalk.String("Simple")) 
	if smalltalk.b(self.implements_(smalltalk.object_comma_(__0__.prefix,smalltalk.String("RequestBlock")))):
		return __0__.prefix 
	 
	return nil 
""","SystemServer_class_nativePlatform")
,"platform","""nativePlatform
	" Private - Returns the name of platform based on native language support (or nil).
	Note: detect implementor support prefixed by [nativeLanguage] or [nativeLanguage]Simple
	e.g. luaSimple* messages.
	"

	| prefix |
	prefix := self nativeLanguage.
	(self implements: prefix ,#RequestBlock) ifTrue: [ ^prefix ].
	prefix := prefix ,#Simple.
	(self implements: prefix ,#RequestBlock) ifTrue: [ ^prefix ].
	^nil""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"currentOrNil",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#currentOrNil
	return getattr(self,"@current",nil) 
""","SystemServer_class_currentOrNil")
,"singleton","""currentOrNil
	" Returns the current instance (or nil). "

	^current""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"start",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#start
	return self.current().start() 
""","SystemServer_class_start")
,"server","""start
	" Start the server. "

	^self current start""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"close",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#close
	def __blk1__():
		return getattr(self,"@current",nil).close() 
	return smalltalk.if_true_false_(smalltalk.notNil_(getattr(self,"@current",nil)),smalltalk.blk(__blk1__,0),nil) 
""","SystemServer_class_close")
,"server","""close
	" Close the current server. "

	^current notNil ifTrue: [ current close ]""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"stop",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#stop
	return self.close() 
""","SystemServer_class_stop")
,"server","""stop
	" Stop the current server. "

	^self close""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"restart",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#restart
	def __blk1__(_s8_rec):
		_s8_rec.close() 
		return _s8_rec.current_(nil) 
	__blk1__(self) 
	return self.start() 
""","SystemServer_class_restart")
,"server","""restart
	" Close the current the server and start a new. "

	self close; current: nil.
	^self start""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlSelectorsFor:",0
,smalltalk.__f__('''(self,className):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer class>>#htmlSelectorsFor:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.String("")) 
		def __blk2__(each):
			return __0__.stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<a href="),smalltalk.String("'")),smalltalk.String("/SystemServer/htmlFileOut:selector:side:/")),__0__.aClass.name()),smalltalk.String("/")),each),smalltalk.String("/class")),smalltalk.String("'")),smalltalk.String(">")),each),smalltalk.String("</a><BR>"))) 
		def __blk3__(each):
			return __0__.stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<a href="),smalltalk.String("'")),smalltalk.String("/SystemServer/htmlFileOut:selector:/")),__0__.aClass.name()),smalltalk.String("/")),each),smalltalk.String("'")),smalltalk.String(">")),each),smalltalk.String("</a><BR>"))) 
		__0__.stream=nil
		__0__.aClass=nil
		__0__.classDef=nil
		__0__.aClass=smalltalk.Smalltalk.at_ifAbsent_(className,smalltalk.blk(__blk1__,0)) 
		__0__.stream=smalltalk.String("").writeStream() 
		__0__.stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<BR><BR><a href="),smalltalk.String("'")),smalltalk.String("/SystemServer/htmlHierarchy")),smalltalk.String("'")),smalltalk.String("><< S8 Hierarchy</a><BR>"))) 
		__0__.classDef=smalltalk.Exporter.new().fileOutDefinitionOf_(__0__.aClass) 
		__0__.classDef=__0__.classDef.replace_with_(smalltalk.String("""\\\\r\\\\n"""),smalltalk.String("<BR>")) 
		__0__.classDef=__0__.classDef.replace_with_(smalltalk.String("""\\\\t"""),smalltalk.String("&nbsp;&nbsp;&nbsp;")) 
		__0__.stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<BR>"),__0__.classDef),smalltalk.String("<H4>")),className),smalltalk.String(" class methods</H4>"))) 
		(__0__.aClass).__class__.selectors().do_(smalltalk.blk(__blk2__,1)) 
		__0__.stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<H4>"),className),smalltalk.String(" instance methods</H4>"))) 
		__0__.aClass.selectors().do_(smalltalk.blk(__blk3__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.stream.contents()) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
''',"SystemServer_class_htmlSelectorsFor_")
,"html","""htmlSelectorsFor: className
	" Return an html fragment containing the selectors implemented by className. "

	| stream aClass classDef |
	aClass := Smalltalk at: className ifAbsent:[ ^'' ].
	stream := '' writeStream.	
	stream nextPutAll: '<BR><BR><a href=',$'
		,'/SystemServer/htmlHierarchy',$'
		,'><< S8 Hierarchy</a><BR>'.
	classDef := Exporter new fileOutDefinitionOf: aClass.
	classDef := classDef replace:'\\r\\n' with:'<BR>'.
	classDef := classDef replace:'\\t' with:'&nbsp;&nbsp;&nbsp;'.
	stream nextPutAll: '<BR>' ,classDef ,'<H4>' ,className ,' class methods</H4>'.
	aClass class selectors do: [:each| 
		stream nextPutAll: '<a href=',$'
			,'/SystemServer/htmlFileOut:selector:side:/', aClass name
			,'/',each,'/class', $', '>', each, '</a><BR>'
	].	
	stream nextPutAll: '<H4>', className,' instance methods</H4>'.
	aClass selectors do:[:each| 
		stream nextPutAll: '<a href=',$'
			,'/SystemServer/htmlFileOut:selector:/', aClass name
			,'/',each,$', '>', each, '</a><BR>'
	].
	^stream contents""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlFileOut:selector:side:",0
,smalltalk.__f__('''(self,className,selector,side):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer class>>#htmlFileOut:selector:side:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.String("")) 
		def __blk2__():
			return (__0__.aClass).__class__._gt_gt(selector) 
		def __blk3__():
			return __0__.aClass._gt_gt(selector) 
		__0__.stream=nil
		__0__.aClass=nil
		__0__.mth=nil
		__0__.source=nil
		__0__.aClass=smalltalk.Smalltalk.at_ifAbsent_(className,smalltalk.blk(__blk1__,0)) 
		__0__.mth=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(side,smalltalk.String("class")),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		__0__.source=smalltalk.Exporter.new().fileOutMethod_of_(__0__.mth,__0__.aClass) 
		__0__.source=__0__.source.replace_with_(smalltalk.String("""\\\\r\\\\n"""),smalltalk.String("<BR>")) 
		__0__.source=__0__.source.replace_with_(smalltalk.String("""\\\\t"""),smalltalk.String("&nbsp;&nbsp;&nbsp;")) 
		__0__.source=__0__.source.replace_with_(smalltalk.object_comma_(smalltalk.String("\\\\"),smalltalk.String('"')),smalltalk.String("&quot;")) 
		__0__.source=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<BR><BR><a href="),smalltalk.String("/SystemServer/htmlSelectorsFor:/")),className),smalltalk.String("><< ")),className),smalltalk.String(" methods</a><BR>")),__0__.source),smalltalk.String("<BR>")) 
		smalltalk.raise_result_(_s8Ret_,__0__.source) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
''',"SystemServer_class_htmlFileOut_selector_side_")
,"html","""htmlFileOut: className selector: selector side: side
	" Return an html fragment of selector source code. "

	| stream aClass mth source |
	aClass := Smalltalk at: className ifAbsent:[ ^'' ].
	mth := (side = #class) ifTrue:[ aClass class >> selector 
	] ifFalse: [ aClass >> selector ].
	source := Exporter new fileOutMethod: mth of: aClass.
	source := source replace:'\\r\\n' with:'<BR>'.
	source := source replace:'\\t' with:'&nbsp;&nbsp;&nbsp;'.
	source := source replace: $\\,$" with: '&quot;'.
	source := '<BR><BR><a href='
		,'/SystemServer/htmlSelectorsFor:/'
		,className ,'><< ' ,className
		,' methods</a><BR>',source
		,'<BR>'.
	^source""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlFileOut:selector:",0
,smalltalk.__f__("""(self,className,selector):
	#SystemServer class>>#htmlFileOut:selector:
	return self.htmlFileOut_selector_side_(className,selector,smalltalk.String("instance")) 
""","SystemServer_class_htmlFileOut_selector_")
,"html","""htmlFileOut: className selector: selector
	" Return an html fragment of selector source code. "

	^self htmlFileOut: className 
		selector: selector 
		side: #instance""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlHierarchy",0
,smalltalk.__f__("""(self):
	#SystemServer class>>#htmlHierarchy
	__0__=smalltalk.newContext()
	def __blk1__(cls):
		return self.htmlWalk_blanks_into_(cls,smalltalk.Number(0),__0__.stream) 
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	__0__.stream.nextPutAll_(smalltalk.String("<H2>S8 Hierarchy</H2>")) 
	smalltalk.Smalltalk.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.stream.contents() 
""","SystemServer_class_htmlHierarchy")
,"html","""htmlHierarchy
	" Returns the system hierarchy in html fasion. "

	| stream |
	stream := '' writeStream.
	stream nextPutAll:'<H2>S8 Hierarchy</H2>'.
	Smalltalk rootClasses do: [:cls|
		self htmlWalk: cls blanks: 0 into: stream
	].
	^stream contents""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlWalk:blanks:into:",0
,smalltalk.__f__("""(self,aClass,blanks,stream):
	#SystemServer class>>#htmlWalk:blanks:into:
	def __blk1__():
		return stream.nextPutAll_(smalltalk.String("&nbsp;&nbsp;")) 
	def __blk2__(cls):
		return self.htmlWalk_blanks_into_(cls,blanks._plus(smalltalk.Number(1)),stream) 
	stream.nextPutAll_(smalltalk.String("<BR>")) 
	smalltalk.times_repeat_(blanks,smalltalk.blk(__blk1__,0)) 
	stream.nextPutAll_(self.htmlDescriptionForClass_(aClass)) 
	aClass.subclasses().do_(smalltalk.blk(__blk2__,1)) 
	return self 
""","SystemServer_class_htmlWalk_blanks_into_")
,"html","""htmlWalk: aClass blanks: blanks into: stream
	" Private - Returns the description for hierarchy level @ blanks. "

	stream nextPutAll:'<BR>'. 
	blanks timesRepeat: [ stream nextPutAll: '&nbsp;&nbsp;' ].
	stream nextPutAll: (self htmlDescriptionForClass: aClass).
	aClass subclasses do: [:cls|
		self htmlWalk: cls blanks: blanks + 1 into: stream
	].""",nil)
smalltalk.bind(smalltalk.SystemServer.__class__,"htmlDescriptionForClass:",0
,smalltalk.__f__("""(self,aClass):
	#SystemServer class>>#htmlDescriptionForClass:
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<a href="),smalltalk.String("'")),smalltalk.String("/SystemServer/htmlSelectorsFor:/")),aClass.name()),smalltalk.String("'")),smalltalk.String(">")),aClass.name()),smalltalk.String("</a> [")),aClass.category()),smalltalk.String("]")) 
""","SystemServer_class_htmlDescriptionForClass_")
,"html","""htmlDescriptionForClass: aClass
	" Private - Returns the contents to show for aClass. "

	^'<a href=', $', '/SystemServer/htmlSelectorsFor:/', aClass name, $' ,$>, aClass name,'</a> [',aClass category, ']'""",nil)
smalltalk.bind(smalltalk.SystemServer,"initializePort",0
,smalltalk.__f__("""(self):
	#SystemServer>>#initializePort
	smalltalk.basic_at_put(self,"@port",(self).__class__.port()) 
	return self 
""","SystemServer_initializePort")
,"initialize","""initializePort
	" Private - Initialize the port of the receiver. "

	port := self class port""",nil)
smalltalk.bind(smalltalk.SystemServer,"port",0
,smalltalk.__f__("""(self):
	#SystemServer>>#port
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@port",nil))):
		self.initializePort() 
	 
	return getattr(self,"@port",nil) 
""","SystemServer_port")
,"accessing","""port
	" Return the port of the receiver. "

	port isNil ifTrue: [ self initializePort ].
	^port""",nil)
smalltalk.bind(smalltalk.SystemServer,"port:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer>>#port:
	smalltalk.basic_at_put(self,"@port",anObject) 
	return self 
""","SystemServer_port_")
,"accessing","""port: anObject
	" Set the port of the receiver. "

	port := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer,"initializeMethodReferences",0
,smalltalk.__f__("""(self):
	#SystemServer>>#initializeMethodReferences
	smalltalk.basic_at_put(self,"@methodReferences",smalltalk.Smalltalk.current().methodReferences()) 
	return self 
""","SystemServer_initializeMethodReferences")
,"initialize","""initializeMethodReferences
	" Private - Initialize the methodReferences of the receiver. "

	methodReferences := Smalltalk current methodReferences""",nil)
smalltalk.bind(smalltalk.SystemServer,"methodReferences",0
,smalltalk.__f__("""(self):
	#SystemServer>>#methodReferences
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@methodReferences",nil))):
		self.initializeMethodReferences() 
	 
	return getattr(self,"@methodReferences",nil) 
""","SystemServer_methodReferences")
,"accessing","""methodReferences
	" Return the methodReferences of the receiver. "

	methodReferences isNil ifTrue: [ self initializeMethodReferences ].
	^methodReferences""",nil)
smalltalk.bind(smalltalk.SystemServer,"methodReferences:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer>>#methodReferences:
	smalltalk.basic_at_put(self,"@methodReferences",anObject) 
	return self 
""","SystemServer_methodReferences_")
,"accessing","""methodReferences: anObject
	" Set the methodReferences of the receiver. "

	methodReferences := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer,"initializeCache",0
,smalltalk.__f__("""(self):
	#SystemServer>>#initializeCache
	smalltalk.basic_at_put(self,"@cache",smalltalk.PoolDictionary.new()) 
	return self 
""","SystemServer_initializeCache")
,"initialize","""initializeCache
	" Private - Initialize the cache of the receiver. "

	cache := PoolDictionary new""",nil)
smalltalk.bind(smalltalk.SystemServer,"cache",0
,smalltalk.__f__("""(self):
	#SystemServer>>#cache
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@cache",nil))):
		self.initializeCache() 
	 
	return getattr(self,"@cache",nil) 
""","SystemServer_cache")
,"accessing","""cache
	" Return the cache of the receiver. "

	cache isNil ifTrue: [ self initializeCache ].
	^cache""",nil)
smalltalk.bind(smalltalk.SystemServer,"cache:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer>>#cache:
	smalltalk.basic_at_put(self,"@cache",anObject) 
	return self 
""","SystemServer_cache_")
,"accessing","""cache: anObject
	" Set the cache of the receiver. "

	cache := anObject""",nil)
smalltalk.bind(smalltalk.SystemServer,"platformSend:withArguments:",0
,smalltalk.__f__("""(self,message,anArray):
	#SystemServer>>#platformSend:withArguments:
	__0__=smalltalk.newContext()
	__0__.token=nil
	__0__.msg=nil
	__0__.token=(self).__class__.platform() 
	if smalltalk.b(smalltalk.isNil_(__0__.token)):
		__0__.token=smalltalk.String("default") 
	 
	__0__.msg=smalltalk.object_comma_(__0__.token,message) 
	return self.perform_withArguments_(__0__.msg,anArray) 
""","SystemServer_platformSend_withArguments_")
,"platform","""platformSend: message withArguments: anArray
	" Private - Returns the result of sending message (platform dependent) to receiver.
	Trigger an error if the message is not implemented.
	"

	| token msg |
	token := self class platform.
	token isNil ifTrue: [ token := #default ].
	msg := token , message.
"	(self respondsTo: msg) ifFalse: [ ^self error: 'Missing server support for ' ,msg ]. "
	^self perform: msg withArguments: anArray""",nil)
smalltalk.bind(smalltalk.SystemServer,"isRunning",0
,smalltalk.__f__("""(self):
	#SystemServer>>#isRunning
	return smalltalk.notNil_(getattr(self,"@server",nil)) 
""","SystemServer_isRunning")
,"query","""isRunning
	" Returns true if the receiver is online. "

	^server notNil""",nil)
smalltalk.bind(smalltalk.SystemServer,"step",0
,smalltalk.__f__("""(self):
	#SystemServer>>#step
	def __blk1__():
		return getattr(self,"@server",nil).step() 
	return smalltalk.if_true_false_(self.isRunning(),smalltalk.blk(__blk1__,0),nil) 
""","SystemServer_step")
,"runnning","""step
	" Run a server step. "

	^self isRunning ifTrue: [ server step ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"listen",0
,smalltalk.__f__("""(self):
	#SystemServer>>#listen
	return getattr(self,"@server",nil).listen() 
""","SystemServer_listen")
,"runnning","""listen
	" Run a server step. "

	^server listen""",nil)
smalltalk.bind(smalltalk.SystemServer,"run",0
,smalltalk.__f__("""(self):
	#SystemServer>>#run
	def __blk1__():
		return self.isRunning() 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		self.listen() 
	 
	return self 
""","SystemServer_run")
,"runnning","""run
	" Run the receiver in a loop until stopped. "

	[self isRunning] whileTrue: [ self listen ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"online",0
,smalltalk.__f__("""(self):
	#SystemServer>>#online
	return smalltalk.notNil_(getattr(self,"@server",nil)) 
""","SystemServer_online")
,"server","""online
	" Returns true if the receiver is online. "

	^server notNil""",nil)
smalltalk.bind(smalltalk.SystemServer,"start",0
,smalltalk.__f__("""(self):
	#SystemServer>>#start
	return self.startServer() 
""","SystemServer_start")
,"server","""start
	" Start the receiver. "

	^self startServer""",nil)
smalltalk.bind(smalltalk.SystemServer,"close",0
,smalltalk.__f__("""(self):
	#SystemServer>>#close
	self.server_(nil) 
	return self 
""","SystemServer_close")
,"server","""close
	" Close the receiver. "

	self server: nil""",nil)
smalltalk.bind(smalltalk.SystemServer,"server:",0
,smalltalk.__f__("""(self,aServer):
	#SystemServer>>#server:
	if smalltalk.b(smalltalk.responds_to_(getattr(self,"@server",nil),(smalltalk.String("close")))):
		getattr(self,"@server",nil).close() 
	 
	smalltalk.basic_at_put(self,"@server",aServer) 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@server",nil))):
		self.unbindSystemManager() 
	else:
		self.bindSystemManager() 
	 
	return self 
""","SystemServer_server_")
,"private","""server: aServer
	" Private - Set the server of the receiver. "

	(server respondsTo: #close) ifTrue: [ server close ].
	server := aServer.
	server isNil
		ifTrue: [ self unbindSystemManager ]
		ifFalse: [ self bindSystemManager ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"startServer",0
,smalltalk.__f__("""(self):
	#SystemServer>>#startServer
	return self.startServerOn_(self.port()) 
""","SystemServer_startServer")
,"server","""startServer
	" Start the server. "

	^self startServerOn: self port""",nil)
smalltalk.bind(smalltalk.SystemServer,"startServerOn:",0
,smalltalk.__f__("""(self,aPort):
	#SystemServer>>#startServerOn:
	__0__=smalltalk.newContext()
	def __blk1__(req,resp):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<html><body><pre>"),__0__.query.value_value_(req,resp)),smalltalk.String("</pre></body></html>")) 
	__0__.query=nil
	__0__.query=self.systemRequestBlock() 
	if smalltalk.b(smalltalk.isNil_(__0__.query)):
		return smalltalk.false 
	 
	return self.startWith_on_(smalltalk.blk(__blk1__,2),aPort) 
""","SystemServer_startServerOn_")
,"server","""startServerOn: aPort
	" Start the server. "

	| query |
	query := self systemRequestBlock.
	query isNil ifTrue: [ ^false ].
	^self startWith: [:req :resp|
		'<html><body><pre>'
		,(query value: req value: resp)
		,'</pre></body></html>'.		
	] on: aPort""",nil)
smalltalk.bind(smalltalk.SystemServer,"startWith:on:",0
,smalltalk.__f__("""(self,processBlock,aPort):
	#SystemServer>>#startWith:on:
	return self.startBlock_port_(processBlock,aPort) 
""","SystemServer_startWith_on_")
,"server","""startWith: processBlock on: aPort
	
	^self	startBlock: processBlock 
		port: aPort""",nil)
smalltalk.bind(smalltalk.SystemServer,"startBlock:port:",0
,smalltalk.__f__("""(self,aBlock,aPort):
	#SystemServer>>#startBlock:port:
	self.server_(self.start_processBlock_port_(self,aBlock,aPort)) 
	return smalltalk.notNil_(getattr(self,"@server",nil)) 
""","SystemServer_startBlock_port_")
,"server","""startBlock: aBlock port: aPort
	" Private - Start the server. "

	self server: (self
		start: self
		processBlock: aBlock
		port: aPort).
	^server notNil""",nil)
smalltalk.bind(smalltalk.SystemServer,"start:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	#SystemServer>>#start:processBlock:port:
	return self.platformSend_withArguments_(smalltalk.String("Start:processBlock:port:"),smalltalk.Array.with_with_with_(aServer,aBlock,aPort)) 
""","SystemServer_start_processBlock_port_")
,"server","""start: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	^self	platformSend: #Start:processBlock:port:
		withArguments: (Array with: aServer with: aBlock with: aPort)""",nil)
smalltalk.bind(smalltalk.SystemServer,"systemRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#systemRequestBlock
	return self.platformSend_withArguments_(smalltalk.String("RequestBlock"),smalltalk.newArray([])) 
""","SystemServer_systemRequestBlock")
,"server","""systemRequestBlock
	" Private - Return the request processing block used for remote system tools.
	Note that the block is evaluated for each request and must return the code of the body of HTML formated result.
	"

	^self platformSend: #RequestBlock withArguments: #()""",nil)
smalltalk.bind(smalltalk.SystemServer,"jsonParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#jsonParse:
	return self.platformSend_withArguments_(smalltalk.String("Parse:"),smalltalk.Array.with_(string)) 
""","SystemServer_jsonParse_")
,"server","""jsonParse: string
	" Private - Return the result of parsing JSON string. "

	^self platformSend: #Parse: withArguments: (Array with: string)""",nil)
smalltalk.bind(smalltalk.SystemServer,"jsonStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#jsonStringify:
	return self.platformSend_withArguments_(smalltalk.String("Stringify:"),smalltalk.Array.with_(literal)) 
""","SystemServer_jsonStringify_")
,"server","""jsonStringify: literal
	" Private - Return the result of JSON string. "

	^self platformSend: #Stringify: withArguments: (Array with: literal)""",nil)
smalltalk.bind(smalltalk.SystemServer,"serverStartedAt:",0
,smalltalk.__f__("""(self,url):
	#SystemServer>>#serverStartedAt:
	__0__=smalltalk.newContext()
	__0__.string=nil
	__0__.string=smalltalk.object_comma_(smalltalk.String("Server started at "),url) 
	if smalltalk.b(smalltalk.responds_to_(self,(smalltalk.String("alert:")))):
		return self.alert_(__0__.string) 
	 
	return self.note_(__0__.string) 
""","SystemServer_serverStartedAt_")
,"ui","""serverStartedAt: url
	" Private - Show a notification to the user; the server has been started. "

	| string |
	string := 'Server started at ' ,url.
	(self respondsTo: #alert:) ifTrue: [ ^self alert: string ].
	^self note: string""",nil)
smalltalk.bind(smalltalk.SystemServer,"defaultRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#defaultRequestBlock
	return self.error_(smalltalk.String("Missing support for server request")) 
""","SystemServer_defaultRequestBlock")
,"defaults","""defaultRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self error: 'Missing support for server request'""",nil)
smalltalk.bind(smalltalk.SystemServer,"defaultStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	#SystemServer>>#defaultStart:processBlock:port:
	return self.error_(smalltalk.String("Missing support for server start")) 
""","SystemServer_defaultStart_processBlock_port_")
,"defaults","""defaultStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	^self error: 'Missing support for server start'""",nil)
smalltalk.bind(smalltalk.SystemServer,"defaultParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#defaultParse:
	return smalltalk.NativeHandle.support()._at(JSON.parse(string)) 
""","SystemServer_defaultParse_")
,"defaults","""defaultParse: string
	" Private - Return the result of parsing JSON string. "

	^NativeHandle support @ (#{JSON} #parse: string)""",nil)
smalltalk.bind(smalltalk.SystemServer,"defaultStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#defaultStringify:
	return JSON.stringify(literal) 
""","SystemServer_defaultStringify_")
,"defaults","""defaultStringify: literal
	" Private - Return the result of JSON string. "

	^#{JSON} #stringify: literal""",nil)
smalltalk.bind(smalltalk.SystemServer,"checkArrays:",0
,smalltalk.__f__("""(self,aHandle):
	#SystemServer>>#checkArrays:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.remaining.notEmpty() 
	__0__.remaining=nil
	__0__.remaining=smalltalk.Array.with_(aHandle) 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__1__=smalltalk.newContext()
		def __blk2__():
			def __blk3__():
				nil 
			def __blk4__():
				literal 
				return __0__.remaining.addAll_(__1__.literal) 
			def __blk5__():
				def __blk6__():
					def __blk7__(key,value):
						def __blk8__():
							nil 
						def __blk9__():
							value 
							return __0__.remaining.addAll_(value) 
						def __blk10__():
							return __0__.remaining.add_(value) 
						return smalltalk.if_true_false_(smalltalk.notNil_(smalltalk.basic_at_ifAbsent_(value,smalltalk.Number(1),smalltalk.blk(__blk8__,0))),smalltalk.blk(__blk9__,0),smalltalk.blk(__blk10__,0)) 
					return smalltalk.NativeHandle.support()._at(__1__.literal).propertiesDo_(smalltalk.blk(__blk7__,2)) 
				return smalltalk.if_true_false_(self.isObject_(__1__.literal),nil,smalltalk.blk(__blk6__,0)) 
			return smalltalk.if_true_false_(smalltalk.notNil_(smalltalk.basic_at_ifAbsent_(__1__.literal,smalltalk.Number(1),smalltalk.blk(__blk3__,0))),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		__1__.literal=nil
		__1__.literal=__0__.remaining.removeFirst()
		smalltalk.if_true_false_(smalltalk.notNil_((__1__.literal)),smalltalk.blk(__blk2__,0),nil) 
	 
	return self 
""","SystemServer_checkArrays_")
,"json","""checkArrays: aHandle
	" Private,Lua - Scan native handle values for arrayed contents recursivelly.
	Note that JSON data is hierarchical non-recursive structures we walk the structure descending recursivelly in the structure mutating array candidates.
	"

	| remaining |
	remaining := Array with: aHandle.
	[remaining notEmpty] whileTrue: [ | literal |
		(literal := remaining removeFirst) notNil ifTrue: [
			(literal basicAt: 1 ifAbsent: []) notNil "mutate to Array"
			ifTrue: [ {'literal' lua'smalltalk:newArray(literal)'}. remaining addAll: literal ]
			ifFalse: [ "walk normal object contents"
				(self isObject: literal) ifFalse: [
					NativeHandle support @ literal propertiesDo: [:key :value|
						(value basicAt: 1 ifAbsent: []) notNil ifTrue: [
							{'value' lua'smalltalk:newArray(value)'}. remaining addAll: value
						] ifFalse: [ remaining add: value ]
					]
				]
			]
		]
	].""",nil)
smalltalk.bind(smalltalk.SystemServer,"say:",0
,smalltalk.__f__("""(self,text):
	#SystemServer>>#say:
	if smalltalk.b((self).__class__.silent()):
		return self 
	 
	self.note_(text) 
	return self 
""","SystemServer_say_")
,"notification","""say: text
	" Show text to the user. "

	self class silent ifTrue: [ ^self ].
	self note: text""",nil)
smalltalk.bind(smalltalk.SystemServer,"getCommand:",0
,smalltalk.__f__("""(self,command):
	#SystemServer>>#getCommand:
	def __blk1__():
		return command.first().isEmpty() 
	def __blk2__():
		return smalltalk.responds_to_(self,(command.first())) 
	if smalltalk.b(smalltalk.boolean_or_(command.isEmpty(),smalltalk.blk(__blk1__,0))):
		return self.systemHomePage() 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(command.size(),smalltalk.Number(1)),smalltalk.blk(__blk2__,0))):
		return self.perform_(command.first()) 
	 
	return self.resultForCommand_(command.stream()) 
""","SystemServer_getCommand_")
,"private","""getCommand: command
	" Private - Return the result of evaluating the command. "

	(command isEmpty or: [command first isEmpty]) ifTrue:  [
		^self systemHomePage
	].
	(command size = 1 and: [ self respondsTo: command first ]) ifTrue: [
		^self perform: command first
	].
	^self resultForCommand: command stream""",nil)
smalltalk.bind(smalltalk.SystemServer,"postCommand:stream:",0
,smalltalk.__f__("""(self,command,stream):
	#SystemServer>>#postCommand:stream:
	def __blk1__():
		return command.first().isEmpty() 
	def __blk2__():
		return self.note_(stream.upToEnd()) 
	def __blk3__():
		command.add_(stream.upToEnd()) 
		return self.resultForCommand_(command.stream()) 
	stream.upTo_(smalltalk.String("=")) 
	return smalltalk.if_true_false_(smalltalk.boolean_or_(command.isEmpty(),smalltalk.blk(__blk1__,0)),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
""","SystemServer_postCommand_stream_")
,"private","""postCommand: command stream: stream
	" Private - Return the result of evaluating the command. "

	stream upTo: $=.
	^(command isEmpty or: [command first isEmpty])
	ifTrue:  [ self note: stream upToEnd ]
	ifFalse: [
		command add: stream upToEnd.
		self resultForCommand: command stream.
	]""",nil)
smalltalk.bind(smalltalk.SystemServer,"requestBlockFor:method:post:",0
,smalltalk.__f__("""(self,urlBlock,methodBlock,postBlock):
	#SystemServer>>#requestBlockFor:method:post:
	def __blk1__(arg1,arg2):
		__1__=smalltalk.newContext()
		def __blk2__():
			def __blk3__():
				return self.getCommand_(__1__.command) 
			def __blk4__():
				def __blk5__(stream):
					return self.postCommand_stream_(__1__.command,stream) 
				return postBlock.value_value_(arg1,smalltalk.blk(__blk5__,1)) 
			__1__.command=urlBlock.value_value_(arg1,arg2) 
			__1__.method=methodBlock.value_value_(arg1,arg2) 
			self.say_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(""),__1__.method),smalltalk.String(" ")),__1__.command)) 
			__1__.command=__1__.command.asArrayOfSubstringsSeparatedBy_(smalltalk.String("/")) 
			__1__.command.removeFirst() 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__1__.method,smalltalk.String("GET")),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
		__1__.command=nil
		__1__.method=nil
		return self.jsonValue_(smalltalk.blk(__blk2__,0)) 
	return smalltalk.blk(__blk1__,2) 
""","SystemServer_requestBlockFor_method_post_")
,"private","""requestBlockFor: urlBlock method: methodBlock post: postBlock
	" Private - Return the request processing block used for remote system tools. "

	^[:arg1 :arg2| | command method | self jsonValue: [
		command := urlBlock value: arg1 value: arg2.
		method := methodBlock value: arg1 value: arg2.
		self say: '' ,method ,' ' ,command.
		command := command asArrayOfSubstringsSeparatedBy: $/.
		command removeFirst.
		method = #GET ifTrue: [ self getCommand: command ]
		ifFalse: [
			postBlock value: arg1 value: [:stream|
				self postCommand: command stream: stream
			]
		]
	]]""",nil)
smalltalk.bind(smalltalk.SystemServer,"systemHomePage",0
,smalltalk.__f__("""(self):
	#SystemServer>>#systemHomePage
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("<h1>S8 System server</h1>"),smalltalk.String("Try commands like <a href=")),smalltalk.String("'")),smalltalk.String("/SystemServer/htmlHierarchy")),smalltalk.String("'")),smalltalk.String(">hierarchy</a>&nbsp;")),smalltalk.String("or more complex expressions: <a href=")),smalltalk.String("'")),smalltalk.String("/Object/htmlSelectors")),smalltalk.String("'")),smalltalk.String(">Object selectors</a>")) 
""","SystemServer_systemHomePage")
,"#commands","""systemHomePage
	" Private - Returns the contents for system home page. "

	^'<h1>S8 System server</h1>'
	,'Try commands like <a href=',$' ,'/SystemServer/htmlHierarchy', $', '>hierarchy</a>&nbsp;'
	,'or more complex expressions: <a href=', $', '/Object/htmlSelectors', $', '>Object selectors</a>'""",nil)
smalltalk.bind(smalltalk.SystemServer,"objectFromStream:",0
,smalltalk.__f__("""(self,stream):
	#SystemServer>>#objectFromStream:
	if not smalltalk.b(smalltalk.isObject_equalTo_(stream.next(),smalltalk.String("!"))):
		self.error_(smalltalk.String("Invalid code stream")) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(stream.peek(),smalltalk.String("@"))):
		stream.next() 
		return self.at_(stream.upToEnd()) 
	 
	return stream.fileIn() 
""","SystemServer_objectFromStream_")
,"private","""objectFromStream: stream
	" Private - Return the object received from client. "

	stream next = $! ifFalse: [ self error: 'Invalid code stream' ].
	stream peek = $@ ifTrue: [
		stream next.
		^self at: stream upToEnd
	].
	^stream fileIn""",nil)
smalltalk.bind(smalltalk.SystemServer,"objectsFromArguments:",0
,smalltalk.__f__("""(self,array):
	#SystemServer>>#objectsFromArguments:
	def __blk1__(each):
		def __blk2__():
			def __blk3__():
				return self.objectsFromArguments_(each) 
			def __blk4__():
				def __blk5__():
					return each.startsWith_(smalltalk.String("!")) 
				def __blk6__():
					return self.objectFromStream_(each.stream()) 
				def __blk7__():
					return each 
				return smalltalk.if_true_false_(smalltalk.boolean_and_(each.isString(),smalltalk.blk(__blk5__,0)),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk7__,0)) 
			return smalltalk.if_true_false_(each.isArray(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
		return smalltalk.if_true_false_(smalltalk.notNil_(each),smalltalk.blk(__blk2__,0),nil) 
	return array.collect_(smalltalk.blk(__blk1__,1)) 
""","SystemServer_objectsFromArguments_")
,"private","""objectsFromArguments: array
	" Private - Return the objects to use as arguments received from client. "

	^array collect: [:each|
		each notNil ifTrue: [
		each isArray ifTrue: [ self objectsFromArguments: each ]
		ifFalse: [ (each isString and: [ each startsWith: $! ])
		ifTrue: [ self objectFromStream: each stream ]
		ifFalse: [ each ]]]
	]""",nil)
smalltalk.bind(smalltalk.SystemServer,"perform:on:",0
,smalltalk.__f__("""(self,stream,receiver):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#perform:on:
		__0__=smalltalk.newContext()
		def __blk1__():
			return stream.atEnd() 
		__0__.result=nil
		__0__.result=receiver 
		while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
			__1__=smalltalk.newContext()
			def __blk2__():
				__2__=smalltalk.newContext()
				def __blk3__():
					return smalltalk.isObject_equalTo_(__1__.selector.last(),smalltalk.String("}")) 
				__2__.json=nil
				while not smalltalk.b(smalltalk.blk(__blk3__,0)()):
					if smalltalk.b(stream.atEnd()):
						smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.object_comma_(smalltalk.String("Corrupted message "),__1__.selector))) 
					 
					__1__.selector=smalltalk.object_comma_(smalltalk.object_comma_(__1__.selector,smalltalk.String("/")),stream.next()) 
				 
				__2__.json=self.jsonParse_(__1__.selector) 
				__1__.selector=__2__.json._at(smalltalk.String("selector")) 
				if smalltalk.b(smalltalk.isNil_(__1__.selector)):
					self.error_(smalltalk.String("Missing selector")) 
				 
				__0__.result=smalltalk.Message.receiver_selector_arguments_(__0__.result,smalltalk.to_String(__1__.selector),self.objectsFromArguments_(__2__.json._at(smalltalk.String("arguments")))).perform()
				return __0__.result 
			def __blk4__():
				__2__=smalltalk.newContext()
				def __blk5__(i):
					def __blk6__():
						return stream.next() 
					return smalltalk.if_true_false_(stream.atEnd(),nil,smalltalk.blk(__blk6__,0)) 
				__2__.args=nil
				__2__.argCount=nil
				__2__.argCount=__1__.selector.argumentCount() 
				__2__.args=smalltalk.Number(1).to_(__2__.argCount).collect_(smalltalk.blk(__blk5__,1)) 
				__0__.result=__0__.result.perform_withArguments_(__1__.selector,self.objectsFromArguments_(__2__.args))
				return __0__.result 
			__1__.selector=nil
			__1__.selector=stream.next() 
			if smalltalk.b(__1__.selector.isEmpty()):
				__1__.selector=smalltalk.String("/") 
			 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(__1__.selector.first(),smalltalk.String("{")),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk4__,0)) 
		 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_perform_on_")
,"private","""perform: stream on: receiver
	" Private - Returns the result of performing messages in stream on receiver. "

	| result |
	result := receiver.
	[stream atEnd] whileFalse: [ | selector |
		selector := stream next.
		selector isEmpty ifTrue: [ selector := $/ ].
		selector first = ${ ifTrue: [ | json |
			[selector last = $}] whileFalse: [
				stream atEnd ifTrue: [ ^self error: 'Corrupted message ' ,selector ].
				selector := selector ,$/ ,stream next.
			].
			json := self jsonParse: selector.
			selector := json @ #selector.
			selector isNil ifTrue: [ self error: 'Missing selector' ].
			result := (Message
				receiver: result selector: selector toString
				arguments: (self objectsFromArguments: json @ #arguments)
				) perform
		] ifFalse: [ | args argCount |
			argCount := selector argumentCount.
			args := (1 to: argCount) collect: [:i|
				stream atEnd ifFalse: [ stream next ]
			].
			result := result perform: selector withArguments:
				(self objectsFromArguments: args)
		]
	].
	^result""",nil)
smalltalk.bind(smalltalk.SystemServer,"evalNative:",0
,smalltalk.__f__("""(self,stream):
	#SystemServer>>#evalNative:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.isObject_equalTo_(__0__.lang,__0__.target.nativeLanguage())._8not() 
	__0__.source=nil
	__0__.lang=nil
	__0__.target=nil
	__0__.target=smalltalk.Smalltalk.current() 
	__0__.source=stream.next() 
	__0__.lang=stream.peek() 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(__0__.lang),smalltalk.blk(__blk1__,0))):
		return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid native language #"),__0__.lang),smalltalk.String(" must be #")),__0__.target.nativeLanguage())) 
	 
	return __0__.target.eval_(__0__.source) 
""","SystemServer_evalNative_")
,"commands","""evalNative: stream
	" Private - Returns the result of evaluating native command in stream. "

	| source lang target |
	target := Smalltalk current.
	source := stream next.
	lang := stream peek.
	(lang notNil and: [ lang ~= target nativeLanguage ]) ifTrue: [
		^self error:
			 'Invalid native language #' ,lang
			,' must be #' ,target nativeLanguage
	].
	^target eval: source""",nil)
smalltalk.bind(smalltalk.SystemServer,"at:put:",0
,smalltalk.__f__("""(self,key,anObject):
	#SystemServer>>#at:put:
	if smalltalk.b(smalltalk.isNil_(anObject)):
		def __blk1__():
			nil 
		return self.cache().removeKey_ifAbsent_(key,smalltalk.blk(__blk1__,0)) 
	 
	return self.cache().at_put_(key,anObject) 
""","SystemServer_at_put_")
,"cache","""at: key put: anObject
	" Register anObject in the cache. "

	anObject isNil ifTrue: [
		^self cache removeKey: key ifAbsent: []
	].
	^self cache at: key put: anObject""",nil)
smalltalk.bind(smalltalk.SystemServer,"at:",0
,smalltalk.__f__("""(self,key):
	#SystemServer>>#at:
	def __blk1__():
		return nil 
	return self.cache().at_ifAbsent_(key,smalltalk.blk(__blk1__,0)) 
""","SystemServer_at_")
,"cache","""at: key
	" Returns the registered object at key in the cache (or nil). "

	^self cache at: key ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"clearCache",0
,smalltalk.__f__("""(self):
	#SystemServer>>#clearCache
	__0__=smalltalk.newContext()
	__0__.persistent=nil
	__0__.persistent=self.at_(smalltalk.String("persistent")) 
	self.initializeCache() 
	if smalltalk.b(smalltalk.notNil_(__0__.persistent)):
		self.at_put_(smalltalk.String("persistent"),__0__.persistent) 
	 
	return self 
""","SystemServer_clearCache")
,"cache","""clearCache
	" Reset the cache.
	Note that #persistent pool is retained in the cache.
	"

	| persistent |
	persistent := self at: #persistent.
	self initializeCache.
	persistent notNil ifTrue: [ self at: #persistent put: persistent ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"cacheIt:to:",0
,smalltalk.__f__("""(self,smalltalkExpression,aReceiver):
	#SystemServer>>#cacheIt:to:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.at_put_(smalltalk.String("lastID"),__0__.id._plus(smalltalk.Number(1))) 
		return _s8_rec.at_put_(__0__.key,__0__.object) 
	__0__.object=nil
	__0__.id=nil
	__0__.key=nil
	__0__.object=smalltalk.Compiler.doIt_to_(smalltalkExpression,aReceiver) 
	__0__.id=self.at_(smalltalk.String("lastID")) 
	if smalltalk.b(smalltalk.isNil_(__0__.id)):
		__0__.id=smalltalk.Number(0) 
	 
	__0__.key=smalltalk.to_String(__0__.id) 
	__blk1__(self) 
	return __0__.key 
""","SystemServer_cacheIt_to_")
,"cache","""cacheIt: smalltalkExpression to: aReceiver
	" Returns the id of cached result of evaluating smalltalkExpression on aReceiver. "

	| object id key |
	object := Compiler
		doIt: smalltalkExpression
		to: aReceiver.
	id := self at: #lastID.
	id isNil ifTrue: [ id := 0 ].
	key := id toString.
	self
		at: #lastID put: id + 1;
		at: key put: object.
	^key""",nil)
smalltalk.bind(smalltalk.SystemServer,"@","_at"
,smalltalk.__f__("""(self,path):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#@
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,nil) 
		def __blk2__(each):
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,nil) 
			__0__.result=__0__.result._at(each) 
			return smalltalk.if_true_false_(smalltalk.isNil_(__0__.result),smalltalk.blk(__blk3__,0),nil) 
		__0__.result=nil
		if smalltalk.b(path.isEmpty()):
			smalltalk.raise_result_(_s8Ret_,self) 
		 
		if smalltalk.b(path.isString()):
			smalltalk.raise_result_(_s8Ret_,self._at(path.asArrayOfSubstringsSeparatedBy_(self.rootStart()))) 
		 
		if smalltalk.b(self.cache().includesKey_(path.first())):
			smalltalk.raise_result_(_s8Ret_,self.cache()._at(path)) 
		 
		__0__.result=smalltalk.Smalltalk.at_ifAbsent_(path.removeFirst(),smalltalk.blk(__blk1__,0)) 
		path.do_(smalltalk.blk(__blk2__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer__at")
,"cache","""@ path
	" Returns the object at path (or nil). "

	| result |
	path isEmpty ifTrue: [ ^self ].
	path isString ifTrue: [
		^self @ (path asArrayOfSubstringsSeparatedBy: self rootStart)
	].
	(self cache includesKey: path first) ifTrue: [ ^self cache @ path ].
	result := Smalltalk at: path removeFirst ifAbsent: [ ^nil ].
	path do: [:each|
		result := result @ each.
		result isNil ifTrue: [ ^nil ].
	].
	^result""",nil)
smalltalk.bind(smalltalk.SystemServer,"rootStart",0
,smalltalk.__f__("""(self):
	#SystemServer>>#rootStart
	return smalltalk.String("@") 
""","SystemServer_rootStart")
,"roots","""rootStart
	" Private - Returns the tag to start root "

	^$@""",nil)
smalltalk.bind(smalltalk.SystemServer,"root:stream:ifAbsent:",0
,smalltalk.__f__("""(self,command,stream,aBlock):
	#SystemServer>>#root:stream:ifAbsent:
	if smalltalk.b(command.isEmpty()):
		return self 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(command.first(),self.rootStart())):
		return self._at(command.copyFrom_to_(smalltalk.Number(2),command.size())) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(command,smalltalk.String("self"))):
		return self 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(command,smalltalk.String("smalltalk"))):
		return self.smalltalk() 
	 
	return smalltalk.Smalltalk.at_ifAbsent_(command,aBlock) 
""","SystemServer_root_stream_ifAbsent_")
,"roots","""root: command stream: stream ifAbsent: aBlock
	" Private - Returns the root of path in command stream (or the result of evaluating aBlock). "

	command isEmpty ifTrue: [ ^self ].
	command first = self rootStart ifTrue: [
		^self @ (command copyFrom: 2 to: command size)
	].
	command = #self ifTrue: [ ^self ].
	command = #smalltalk ifTrue: [ ^self smalltalk ].
	^Smalltalk at: command ifAbsent: aBlock""",nil)
smalltalk.bind(smalltalk.SystemServer,"resultForCommand:",0
,smalltalk.__f__("""(self,stream):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#resultForCommand:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,smalltalk.object_comma_(smalltalk.String("Unknown command "),__0__.command)) 
		__0__.command=nil
		__0__.origin=nil
		__0__.command=stream.next() 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.command,smalltalk.String("doIt"))):
			smalltalk.raise_result_(_s8Ret_,stream.next().doIt()) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.command,smalltalk.String("fileIn"))):
			smalltalk.raise_result_(_s8Ret_,stream.next().fileIn()) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.command,smalltalk.String("eval"))):
			smalltalk.raise_result_(_s8Ret_,self.evalNative_(stream)) 
		 
		if smalltalk.b(smalltalk.isObject_equalTo_(__0__.command,smalltalk.String("fileOut"))):
			smalltalk.raise_result_(_s8Ret_,stream.next().fileOut()) 
		 
		if smalltalk.b(smalltalk.newArray(["fileOut","category"]).includes_(__0__.command)):
			smalltalk.raise_result_(_s8Ret_,stream.next().fileOut()) 
		 
		__0__.origin=self.root_stream_ifAbsent_(__0__.command,stream,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,self.perform_on_(stream,__0__.origin)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_resultForCommand_")
,"commands","""resultForCommand: stream
	" Private - Return the result of processing the command in stream. "

	| command origin |
	command := stream next.
	command = #doIt		ifTrue: [ ^stream next doIt ].
	command = #fileIn		ifTrue: [ ^stream next fileIn ].
	command = #eval		ifTrue: [ ^self evalNative: stream ].
	command = #fileOut	ifTrue: [ ^stream next fileOut ].
	(#(fileOut category) includes: command) ifTrue: [ ^stream next fileOut ].
	origin := self root: command stream: stream ifAbsent: [
		^'Unknown command ',command
	].
	^self perform: stream on: origin""",nil)
smalltalk.bind(smalltalk.SystemServer,"categories",0
,smalltalk.__f__("""(self):
	#SystemServer>>#categories
	return smalltalk.printString_(smalltalk.Class.categories().sorted()) 
""","SystemServer_categories")
,"commands","""categories
	" Private - Returns the categories in the system. "

	^Class categories sorted printString""",nil)
smalltalk.bind(smalltalk.SystemServer,"classes",0
,smalltalk.__f__('''(self):
	#SystemServer>>#classes
	def __blk1__(total,cls):
		return smalltalk.object_comma_(smalltalk.object_comma_(total,smalltalk.String("""
	""")),self.shortDescriptionForClass_(cls)) 
	return smalltalk.Smalltalk.classes().inject_into_(smalltalk.String(""),smalltalk.blk(__blk1__,2)) 
''',"SystemServer_classes")
,"commands","""classes
	" Private - Returns the contents for this command. "

	^Smalltalk classes inject: '' into: [:total :cls|
		total,'
',(self shortDescriptionForClass: cls)
	]""",nil)
smalltalk.bind(smalltalk.SystemServer,"hierarchy",0
,smalltalk.__f__("""(self):
	#SystemServer>>#hierarchy
	__0__=smalltalk.newContext()
	def __blk1__(cls):
		return self.walk_blanks_into_(cls,smalltalk.Number(0),__0__.stream) 
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	smalltalk.Smalltalk.rootClasses().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.stream.contents() 
""","SystemServer_hierarchy")
,"commands","""hierarchy
	" Private - Returns the contents for this command. "

	| stream |
	stream := '' writeStream.
	Smalltalk rootClasses do: [:cls|
		self walk: cls blanks: 0 into: stream
	].
	^stream contents""",nil)
smalltalk.bind(smalltalk.SystemServer,"walk:blanks:into:",0
,smalltalk.__f__("""(self,aClass,blanks,stream):
	#SystemServer>>#walk:blanks:into:
	def __blk1__():
		return stream.nextPut_(smalltalk.String(" ")) 
	def __blk2__(_s8_rec):
		_s8_rec.nextPutAll_(self.shortDescriptionForClass_(aClass)) 
		return _s8_rec.cr() 
	def __blk3__(cls):
		return self.walk_blanks_into_(cls,blanks._plus(smalltalk.Number(1)),stream) 
	stream.cr() 
	smalltalk.times_repeat_(blanks,smalltalk.blk(__blk1__,0)) 
	__blk2__(stream) 
	aClass.subclasses().do_(smalltalk.blk(__blk3__,1)) 
	return self 
""","SystemServer_walk_blanks_into_")
,"commands","""walk: aClass blanks: blanks into: stream
	" Private - Returns the description for hierarchy level @ blanks. "

	stream cr. blanks timesRepeat: [ stream nextPut: $ ].
	stream nextPutAll: (self shortDescriptionForClass: aClass);cr.
	aClass subclasses do: [:cls|
		self walk: cls blanks: blanks + 1 into: stream
	].""",nil)
smalltalk.bind(smalltalk.SystemServer,"shortDescriptionForClass:",0
,smalltalk.__f__("""(self,aClass):
	#SystemServer>>#shortDescriptionForClass:
	return smalltalk.object_comma_(smalltalk.object_comma_(aClass.name(),smalltalk.String(" ")),aClass.category()) 
""","SystemServer_shortDescriptionForClass_")
,"private","""shortDescriptionForClass: aClass
	" Private - Returns the contents to show for aClass. "

	^aClass name,' ',aClass category""",nil)
smalltalk.bind(smalltalk.SystemServer,"jsonValue:",0
,smalltalk.__f__("""(self,aBlock):
	#SystemServer>>#jsonValue:
	__0__=smalltalk.newContext()
	def __blk1__():
		__1__=smalltalk.newContext()
		__1__.result=nil
		__1__.result=self.literalFor_(aBlock.evaluate()) 
		__0__.response=self.changesWith_(smalltalk.String("result")._minus_gt(__1__.result))
		return __0__.response 
	def __blk2__(ex):
		__0__.response=smalltalk.String("error")._minus_gt(ex) 
		return self.say_(smalltalk.String("error")._minus_gt(ex.description())) 
	def __blk3__():
		__0__.json=__0__.response.json() 
		return self.jsonStringify_(__0__.json) 
	def __blk4__(ignored):
		return smalltalk.to_String(__0__.json) 
	__0__.response=nil
	__0__.json=nil
	smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk2__,1)) 
	return smalltalk.blk(__blk3__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk4__,1)) 
""","SystemServer_jsonValue_")
,"output","""jsonValue: aBlock
	" Private - Returns a JSON package string with result of evaluating aBlock. "

	| response json |
	[ | result |
		result := self literalFor: aBlock evaluate.
		response := self changesWith: #result -> result
	] on: Exception do: [:ex|
		response := #error -> ex.
		self say: #error -> ex description
	].
	^[	json := response json.
		self jsonStringify: "response" json
	] on: Exception do: [:ignored| json toString ]""",nil)
smalltalk.bind(smalltalk.SystemServer,"escape",0
,smalltalk.__f__("""(self):
	#SystemServer>>#escape
	return smalltalk.String("!") 
""","SystemServer_escape")
,"output","""escape
	" Private - Returns the escape token. "

	^$! """,nil)
smalltalk.bind(smalltalk.SystemServer,"referenceTo:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer>>#referenceTo:
	if smalltalk.b(smalltalk.responds_to_(anObject,(smalltalk.String("systemServerReferenceIn:")))):
		return smalltalk.object_comma_(smalltalk.object_comma_(self.escape(),smalltalk.String("@")),smalltalk.to_String(anObject.systemServerReferenceIn_(self))) 
	 
	return smalltalk.printString_(anObject) 
""","SystemServer_referenceTo_")
,"output","""referenceTo: anObject
	" Private - Returns the reference to link anObject on the client side. "

	(anObject respondsTo: #systemServerReferenceIn:) ifTrue: [
		^self escape ,$@ ,(anObject systemServerReferenceIn: self) toString
	].
	^anObject printString""",nil)
smalltalk.bind(smalltalk.SystemServer,"literalFor:",0
,smalltalk.__f__("""(self,anObject):
	#SystemServer>>#literalFor:
	if smalltalk.b(smalltalk.isNil_(anObject)):
		return smalltalk.object_comma_(self.escape(),smalltalk.String("nil")) 
	 
	if smalltalk.b(self.isObject_(anObject)):
		def __blk1__():
			return anObject.isMemberOf_(smalltalk.Boolean) 
		def __blk2__():
			def __blk3__():
				return smalltalk.is_kindOf_(anObject,(smalltalk.CompiledMethod)) 
			return smalltalk.boolean_or_(anObject.isMetaclass(),smalltalk.blk(__blk3__,0)) 
		if smalltalk.b(smalltalk.boolean_or_(anObject.isNumber(),smalltalk.blk(__blk1__,0))):
			return smalltalk.object_comma_(self.escape(),anObject) 
		 
		if smalltalk.b(anObject.isString()):
			if smalltalk.b(anObject.startsWith_(self.escape())):
				return smalltalk.object_comma_(self.escape(),anObject) 
			 
			return anObject 
		 
		if smalltalk.b(anObject.isArray()):
			def __blk4__(each):
				return self.literalFor_(each) 
			return anObject.collect_(smalltalk.blk(__blk4__,1)) 
		 
		if smalltalk.b(smalltalk.boolean_or_(anObject.isClass(),smalltalk.blk(__blk2__,0))):
			return smalltalk.object_comma_(self.escape(),smalltalk.printString_(anObject)) 
		 
		return self.referenceTo_(anObject) 
	 
	return anObject 
""","SystemServer_literalFor_")
,"output","""literalFor: anObject
	" Private - Returns the literal to use as reference to anObject on client side. "

	anObject isNil ifTrue: [ ^self escape ,#nil ].
	(self isObject: anObject) ifTrue: [
		(anObject isNumber or: [ anObject isMemberOf: Boolean ]) ifTrue: [ ^self escape ,anObject ].
		anObject isString ifTrue: [
			(anObject startsWith: self escape) ifTrue: [ ^self escape ,anObject ].
			^anObject
		].
		anObject isArray ifTrue: [ ^anObject collect: [:each| self literalFor: each ] ].
		(anObject isClass or: [ anObject isMetaclass
		or: [anObject isKindOf: CompiledMethod]])
		ifTrue: [ ^self escape ,anObject printString ].
		^self referenceTo: anObject
	].
	^anObject""",nil)
smalltalk.bind(smalltalk.SystemServer,"changesWith:",0
,smalltalk.__f__("""(self,results):
	#SystemServer>>#changesWith:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.changes.isEmpty() 
	__0__.changes=nil
	__0__.changes=getattr(self,"@systemChanges",nil) 
	smalltalk.basic_at_put(self,"@systemChanges",nil) 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(__0__.changes),smalltalk.blk(__blk1__,0))):
		return results 
	 
	__0__.changes=self.literalFor_(__0__.changes) 
	return smalltalk.object_comma_(results,smalltalk.String("changes")._minus_gt(__0__.changes)) 
""","SystemServer_changesWith_")
,"output","""changesWith: results
	" Private - Returns the results with logged changes. "

	| changes |
	changes := systemChanges.
	systemChanges := nil.
	(changes isNil or: [changes isEmpty]) ifTrue: [ ^results ].
	changes := self literalFor: changes.
	^results ,(#changes -> changes)""",nil)
smalltalk.bind(smalltalk.SystemServer,"processSystemChanges",0
,smalltalk.__f__("""(self):
	#SystemServer>>#processSystemChanges
	return self 
""","SystemServer_processSystemChanges")
,"system changes","""processSystemChanges
	" Private - The receiver has changes to be processed.
	We do nothing, the changes will be sent to client(s?) on demmand.
	\"""",nil)
smalltalk.bind(smalltalk.SystemServer,"nodeStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#nodeStart:processBlock:port:
		__0__=smalltalk.newContext()
		def __blk1__():
			__0__.http=smalltalk.NodeJS.http()
			return __0__.http 
		def __blk2__(ignored):
			self.note_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" missing HTTP interface."))) 
			return smalltalk.raise_result_(_s8Ret_,nil) 
		def __blk3__(req,resp):
			__1__=smalltalk.newContext()
			def __blk4__(_s8_rec):
				_s8_rec.setHeader_value_(smalltalk.String("Access-Control-Allow-Origin"),smalltalk.String("*")) 
				_s8_rec.writeHead_(smalltalk.Number(200)) 
				return _s8_rec.end_(aBlock.value_value_(__1__.request,__1__.response)) 
			__1__.request=nil
			__1__.response=nil
			__1__.request=smalltalk.NodeIncomingMessage._at(req) 
			__1__.response=smalltalk.NodeHTTPServerResponse._at(resp) 
			return __blk4__(__1__.response) 
		def __blk5__():
			__0__.httpServer.listen_hostname_(aPort,nil.json()) 
			return self.serverStartedAt_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("http://"),__0__.localIP),smalltalk.String(":")),aPort)) 
		def __blk6__(ex):
			self.note_(smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" ")),smalltalk.to_String(ex))) 
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.localIP=nil
		__0__.http=nil
		__0__.httpServer=nil
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Error,smalltalk.blk(__blk2__,1)) 
		__0__.localIP=smalltalk.NodeJS.os().localIP() 
		if smalltalk.b(smalltalk.isNil_(__0__.localIP)):
			self.note_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" missing network connection. (localIP is nil, check network connection)"))) 
			smalltalk.raise_result_(_s8Ret_,nil) 
		 
		__0__.httpServer=__0__.http.createServer_(smalltalk.blk(__blk3__,2)) 
		smalltalk.blk(__blk5__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk6__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.httpServer) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_nodeStart_processBlock_port_")
,"node","""nodeStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	| localIP http httpServer |
	[ http := NodeJS http ] on: Error do: [:ignored|
		self note: self class name ,' missing HTTP interface.'.
		^nil
	].
	localIP := NodeJS os localIP.
	localIP isNil ifTrue: [
		self note: self class name ,' missing network connection. (localIP is nil, check network connection)'.
		^nil
	].
	httpServer := http createServer: [:req :resp| | request response |
		request  := NodeIncomingMessage @ req.
		response := NodeHTTPServerResponse @ resp.
		response 
			setHeader:'Access-Control-Allow-Origin' value:'*';
			writeHead: 200;
			end: (aBlock value: request value: response).
	].
	[	httpServer listen: aPort hostname: nil json.
		self serverStartedAt: 'http://' ,localIP ,':' ,aPort
	 ] on: Exception do: [:ex|
		self note: self class name ,' ' ,ex toString.
		^nil
	].
	^httpServer""",nil)
smalltalk.bind(smalltalk.SystemServer,"nodeRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#nodeRequestBlock
	def __blk1__(req):
		return req.url().asDecodedURI() 
	def __blk2__(req):
		return req.method() 
	def __blk3__(req,action):
		__1__=smalltalk.newContext()
		def __blk4__(_s8_rec):
			def __blk5__(data):
				__1__.body=smalltalk.object_comma_(__1__.body,data)
				return __1__.body 
			def __blk6__():
				return action.value_(__1__.body.asDecodedURI().stream()) 
			_s8_rec.on_do_(smalltalk.String("data"),smalltalk.blk(__blk5__,1)) 
			return _s8_rec.on_do_(smalltalk.String("end"),smalltalk.blk(__blk6__,0)) 
		__1__.body=nil
		__1__.body=smalltalk.String("") 
		__blk4__(req) 
		return smalltalk.String("ok") 
	return self.requestBlockFor_method_post_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,2)) 
""","SystemServer_nodeRequestBlock")
,"node","""nodeRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self
		requestBlockFor: [:req| req url asDecodedURI ]
		method: [:req| req method ]
		post: [:req :action| | body |
			body := ''.
			req
				on: #data do: [:data| body := body ,data ];
				on: #end do: [ action value: body asDecodedURI stream ].
			#ok
		] """,nil)
smalltalk.bind(smalltalk.SystemServer,"nodeParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#nodeParse:
	return self.defaultParse_(string) 
""","SystemServer_nodeParse_")
,"node","""nodeParse: string
	" Private - Return the result of parsing JSON string. "

	^self defaultParse: string""",nil)
smalltalk.bind(smalltalk.SystemServer,"nodeStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#nodeStringify:
	return self.defaultStringify_(literal) 
""","SystemServer_nodeStringify_")
,"node","""nodeStringify: literal
	" Private - Return the result of JSON string. "

	^self defaultStringify: literal""",nil)
smalltalk.bind(smalltalk.SystemServer,"gcdStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	#SystemServer>>#gcdStart:processBlock:port:
	__0__=smalltalk.newContext()
	__0__.instance=nil
	__0__.instance=smalltalk.GCDWebServer.startHTML_withPort_(aBlock,aPort) 
	return self 
""","SystemServer_gcdStart_processBlock_port_")
,"gcd","""gcdStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	| instance |
	instance := GCDWebServer startHTML: aBlock withPort: aPort.
	"self serverStartedAt: instance serverURL absoluteString" """,nil)
smalltalk.bind(smalltalk.SystemServer,"gcdRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#gcdRequestBlock
	def __blk1__(req):
		return req.path() 
	def __blk2__(req):
		return smalltalk.String("GET") 
	def __blk3__(req,action):
		__1__=smalltalk.newContext()
		def __blk4__(_s8_rec):
			def __blk5__(data):
				__1__.body=smalltalk.object_comma_(__1__.body,data)
				return __1__.body 
			def __blk6__():
				return action.value_(__1__.body.asDecodedURI().stream()) 
			_s8_rec.notImplementedYet_(smalltalk.object_comma_(smalltalk.String("gcdRequestBlock"),smalltalk.String(" (POST)"))) 
			_s8_rec.on_do_(smalltalk.String("data"),smalltalk.blk(__blk5__,1)) 
			return _s8_rec.on_do_(smalltalk.String("end"),smalltalk.blk(__blk6__,0)) 
		__1__.body=nil
		__1__.body=smalltalk.String("") 
		__blk4__(req) 
		return smalltalk.String("ok") 
	return self.requestBlockFor_method_post_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,2)) 
""","SystemServer_gcdRequestBlock")
,"gcd","""gcdRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self
		requestBlockFor: [:req| req path ]
		method: [:req| #GET ]
		post: [:req :action| | body |
			body := ''.
			req	notImplementedYet: #gcdRequestBlock ,' (POST)';
				on: #data do: [:data| body := body ,data ];
				on: #end do: [ action value: body asDecodedURI stream ].
			#ok
		]""",nil)
smalltalk.bind(smalltalk.SystemServer,"gcdParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#gcdParse:
	return self.defaultParse_(string) 
""","SystemServer_gcdParse_")
,"gcd","""gcdParse: string
	" Private - Return the result of parsing JSON string. "

	^self defaultParse: string""",nil)
smalltalk.bind(smalltalk.SystemServer,"gcdStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#gcdStringify:
	return self.defaultStringify_(literal) 
""","SystemServer_gcdStringify_")
,"gcd","""gcdStringify: literal
	" Private - Return the result of JSON string. "

	^self defaultStringify: literal""",nil)
smalltalk.bind(smalltalk.SystemServer,"turboStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#turboStart:processBlock:port:
		__0__=smalltalk.newContext()
		def __blk1__(hRequest):
			__1__=smalltalk.newContext()
			def __blk2__(_s8_rec):
				_s8_rec.add_value_(smalltalk.String("Content-Length"),smalltalk.object_comma_(smalltalk.String(""),__1__.msg.size())) 
				_s8_rec.add_value_(smalltalk.String("Connection"),smalltalk.String("Keep-Alive")) 
				_s8_rec.add_value_(smalltalk.String("Access-Control-Allow-Origin"),smalltalk.String("*")) 
				_s8_rec.setStatusCode_(smalltalk.Number(200)) 
				_s8_rec.setVersion_(smalltalk.String("HTTP/1.1")) 
				return _s8_rec.yourself() 
			def __blk3__(_s8_rec):
				_s8_rec.write_(__1__.buf) 
				return _s8_rec.finish() 
			__1__.hdr=nil
			__1__.request=nil
			__1__.msg=nil
			__1__.buf=nil
			__1__.crlf=nil
			__1__.crlf=smalltalk.String.crlf() 
			__1__.request=smalltalk.HTTPRequest._at(hRequest) 
			smalltalk.basic_at_put_(__1__.request,smalltalk.String("path"),__1__.request.path()) 
			__1__.msg=aBlock.value_(__1__.request) 
			__1__.hdr=smalltalk.HTTPHeaders.new() 
			__blk2__(__1__.hdr) 
			__1__.buf=smalltalk.object_comma_(smalltalk.object_comma_(__1__.hdr.stringifyAsResponse(),__1__.crlf),__1__.msg) 
			return __blk3__(__1__.request) 
		def __blk4__():
			__0__.http.listen_(aPort) 
			return self.serverStartedAt_(smalltalk.object_comma_(smalltalk.String("port "),aPort)) 
		def __blk5__(ex):
			self.note_(smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" ")),smalltalk.to_String(ex))) 
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.http=nil
		__0__.http=smalltalk.HTTPServer.new_(smalltalk.blk(__blk1__,1)) 
		smalltalk.blk(__blk4__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk5__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.http) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_turboStart_processBlock_port_")
,"turbo","""turboStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	| http |
	http := HTTPServer new: [:hRequest| | hdr request msg buf crlf |
		crlf := String crlf.
		request := HTTPRequest @ hRequest.
		request basicAt: #path put: request path.
		msg := aBlock value: request.
		hdr := HTTPHeaders new.
		hdr
			add: 'Content-Length' value: '',msg size;
			add: 'Connection' value: 'Keep-Alive';
			add: 'Access-Control-Allow-Origin' value: $*;
			setStatusCode: 200;
			setVersion: 'HTTP/1.1';
			yourself.
		buf := hdr stringifyAsResponse ,crlf ,msg.
		request write: buf; finish
	].
	[	http listen: aPort.
		self serverStartedAt: 'port ',aPort.
		"Ioloop instance start"
	 ] on: Exception do: [:ex|
		self note: self class name ,' ' ,ex toString.
		^nil
	].
	^http""",nil)
smalltalk.bind(smalltalk.SystemServer,"turboRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#turboRequestBlock
	def __blk1__(req):
		return smalltalk.Escape.new().unescape_(smalltalk.asObject_(req.path)) 
	def __blk2__(req):
		return smalltalk.String("GET") 
	def __blk3__(req,action):
		req.notImplementedYet_(smalltalk.object_comma_(smalltalk.String("gcdRequestBlock"),smalltalk.String(" (POST)"))) 
		return smalltalk.String("ok") 
	return self.requestBlockFor_method_post_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,1),smalltalk.blk(__blk3__,2)) 
""","SystemServer_turboRequestBlock")
,"turbo","""turboRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self
		requestBlockFor: [:req| Escape new unescape: req#path ]
		method: [:req| #GET ]
		post: [:req :action|
			req notImplementedYet: #gcdRequestBlock ,' (POST)'.
			#ok
		]""",nil)
smalltalk.bind(smalltalk.SystemServer,"turboParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#turboParse:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=smalltalk.NativeHandle.support()._at(smalltalk.Escape.new().jsonDecode_(string)) 
	if smalltalk.b(smalltalk.notNil_(__0__.result)):
		self.checkArrays_(__0__.result.handle()) 
	 
	return __0__.result 
""","SystemServer_turboParse_")
,"turbo","""turboParse: string
	" Private - Return the result of parsing JSON string. "

	| result |
	result := NativeHandle support @ (Escape new jsonDecode: string).
	result notNil ifTrue: [ self checkArrays: result handle ].
	^result""",nil)
smalltalk.bind(smalltalk.SystemServer,"turboStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#turboStringify:
	return smalltalk.Escape.new().jsonEncode_(smalltalk.NativeHandle.support()._at(literal)) 
""","SystemServer_turboStringify_")
,"turbo","""turboStringify: literal
	" Private - Return the result of JSON string. "

	^Escape new jsonEncode: NativeHandle support @ literal""",nil)
smalltalk.bind(smalltalk.SystemServer,"luaSimpleStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#luaSimpleStart:processBlock:port:
		__0__=smalltalk.newContext()
		def __blk1__():
			def __blk2__(_s8_rec):
				def __blk3__(uri,headers):
					return aBlock.value_value_(uri,headers) 
				_s8_rec.port_(aPort) 
				_s8_rec.when_do_(smalltalk.String("needsContents:with:"),smalltalk.blk(__blk3__,2)) 
				return _s8_rec.start() 
			__blk2__(__0__.http) 
			return self.serverStartedAt_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.to_String(__0__.http.host()),smalltalk.String(":")),__0__.http.port())) 
		def __blk4__(ex):
			self.note_(smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" ")),smalltalk.to_String(ex))) 
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.http=nil
		if not smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("Json"))):
			self.note_(smalltalk.String("Missing Json support (SimpleJson.st required)")) 
			smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.String("Missing Json support (SimpleJson.st required)"))) 
		 
		__0__.http=smalltalk.SimpleHTTPServer.new() 
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk4__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.http) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_luaSimpleStart_processBlock_port_")
,"luaSimple","""luaSimpleStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	| http |
	(Smalltalk includesKey: #Json) ifFalse: [
		self note: 'Missing Json support (SimpleJson.st required)'.
		^self error: 'Missing Json support (SimpleJson.st required)'
	].
	http := SimpleHTTPServer new.
	[  http	port: aPort;
		when: #needsContents:with: do: [:uri :headers|
			aBlock value: uri value: headers
		]; start.
	  self serverStartedAt: http host toString ,':' ,http port.
	 ] on: Exception do: [:ex|
		self note: self class name ,' ' ,ex toString.
		^nil
	].
	^http""",nil)
smalltalk.bind(smalltalk.SystemServer,"luaSimpleRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#luaSimpleRequestBlock
	def __blk1__(uri,headers):
		return uri.unescaped() 
	def __blk2__(uri,headers):
		return smalltalk.String("GET") 
	def __blk3__(req,action):
		req.notImplementedYet_(smalltalk.object_comma_(smalltalk.String("luaSimpleRequestBlock"),smalltalk.String(" (POST)"))) 
		return smalltalk.String("ok") 
	return self.requestBlockFor_method_post_(smalltalk.blk(__blk1__,2),smalltalk.blk(__blk2__,2),smalltalk.blk(__blk3__,2)) 
""","SystemServer_luaSimpleRequestBlock")
,"luaSimple","""luaSimpleRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self
		requestBlockFor: [:uri :headers| uri unescaped ]
		method: [:uri :headers| #GET ]
		post: [:req :action|
			req notImplementedYet: #luaSimpleRequestBlock ,' (POST)'.
			#ok
		]""",nil)
smalltalk.bind(smalltalk.SystemServer,"luaSimpleParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#luaSimpleParse:
	__0__=smalltalk.newContext()
	__0__.json=nil
	__0__.js=nil
	__0__.args=nil
	__0__.js=smalltalk.Json.parse_(string) 
	if smalltalk.b(smalltalk.isNil_(__0__.js)):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Broken Json :"),string)) 
	 
	__0__.args=__0__.js._at(smalltalk.String("arguments")) 
	args 
	__0__.json=smalltalk.object_comma_(smalltalk.String("selector")._minus_gt(smalltalk.to_String(__0__.js._at(smalltalk.String("selector")))),smalltalk.String("arguments")._minus_gt(__0__.args)).json() 
	return smalltalk.NativeHandle.support()._at(__0__.json) 
""","SystemServer_luaSimpleParse_")
,"luaSimple","""luaSimpleParse: string
	" Private - Return the result of parsing JSON string. "

	| json js args |
	js := Json parse: string.
	js isNil ifTrue: [ ^self error: 'Broken Json :',string ].
	args := js @ #arguments.
	{'args' lua'smalltalk:newArray(args)'}.
	json := ((#selector -> (js @ #selector) toString)
		,(#arguments -> args)) json.
	^NativeHandle support @ json""",nil)
smalltalk.bind(smalltalk.SystemServer,"luaSimpleStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#luaSimpleStringify:
	return smalltalk.Json.stringify_(smalltalk.NativeHandle.support()._at(literal)) 
""","SystemServer_luaSimpleStringify_")
,"luaSimple","""luaSimpleStringify: literal
	" Private - Return the result of JSON string. "

	^Json stringify: NativeHandle support @ literal""",nil)
smalltalk.bind(smalltalk.SystemServer,"pyStart:processBlock:port:",0
,smalltalk.__f__("""(self,aServer,aBlock,aPort):
	_s8Ret_=smalltalk.newContext()
	try:
		#SystemServer>>#pyStart:processBlock:port:
		__0__=smalltalk.newContext()
		def __blk1__():
			def __blk2__(_s8_rec):
				def __blk3__(uri,headers):
					return aBlock.value_value_(uri,headers) 
				_s8_rec.port_(aPort) 
				_s8_rec.when_do_(smalltalk.String("needsContents:with:"),smalltalk.blk(__blk3__,2)) 
				return _s8_rec.start() 
			__blk2__(__0__.http) 
			return self.serverStartedAt_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.to_String(__0__.http.host()),smalltalk.String(":")),__0__.http.port())) 
		def __blk4__(ex):
			self.note_(smalltalk.object_comma_(smalltalk.object_comma_((self).__class__.name(),smalltalk.String(" ")),smalltalk.to_String(ex))) 
			return smalltalk.raise_result_(_s8Ret_,nil) 
		__0__.http=nil
		if not smalltalk.b(smalltalk.Smalltalk.includesKey_(smalltalk.String("Json"))):
			self.note_(smalltalk.String("Missing Json support (SimpleJson.st required)")) 
			smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.String("Missing Json support (SimpleJson.st required)"))) 
		 
		__0__.http=smalltalk.TestServer.new() 
		smalltalk.blk(__blk1__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk4__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.http) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SystemServer_pyStart_processBlock_port_")
,"pyServer","""pyStart: aServer processBlock: aBlock port: aPort
	" Private - Start the server. "

	| http |
	(Smalltalk includesKey: #Json) ifFalse: [
		self note: 'Missing Json support (SimpleJson.st required)'.
		^self error: 'Missing Json support (SimpleJson.st required)'
	].
	http := TestServer new.
	[  http	port: aPort;
		when: #needsContents:with: do: [:uri :headers|
			aBlock value: uri value: headers
		]; start.
	  self serverStartedAt: http host toString ,':' ,http port.
	 ] on: Exception do: [:ex|
		self note: self class name ,' ' ,ex toString.
		^nil
	].
	^http""",nil)
smalltalk.bind(smalltalk.SystemServer,"pyRequestBlock",0
,smalltalk.__f__("""(self):
	#SystemServer>>#pyRequestBlock
	def __blk1__(uri,headers):
		return uri.unescaped() 
	def __blk2__(uri,headers):
		return smalltalk.String("GET") 
	def __blk3__(req,action):
		req.notImplementedYet_(smalltalk.object_comma_(smalltalk.String("pyRequestBlock"),smalltalk.String(" (POST)"))) 
		return smalltalk.String("ok") 
	return self.requestBlockFor_method_post_(smalltalk.blk(__blk1__,2),smalltalk.blk(__blk2__,2),smalltalk.blk(__blk3__,2)) 
""","SystemServer_pyRequestBlock")
,"pyServer","""pyRequestBlock
	" Private - Return the request processing block used for remote system tools. "

	^self
		requestBlockFor: [:uri :headers| uri unescaped ]
		method: [:uri :headers| #GET ]
		post: [:req :action|
			req notImplementedYet: #pyRequestBlock ,' (POST)'.
			#ok
		]""",nil)
smalltalk.bind(smalltalk.SystemServer,"pyParse:",0
,smalltalk.__f__("""(self,string):
	#SystemServer>>#pyParse:
	__0__=smalltalk.newContext()
	__0__.json=nil
	__0__.js=nil
	__0__.args=nil
	__0__.js=smalltalk.Json.parse_(string) 
	if smalltalk.b(smalltalk.isNil_(__0__.js)):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Broken Json :"),string)) 
	 
	__0__.args=__0__.js._at(smalltalk.String("arguments")) 
	__0__.json=smalltalk.object_comma_(smalltalk.String("selector")._minus_gt(smalltalk.to_String(__0__.js._at(smalltalk.String("selector")))),smalltalk.String("arguments")._minus_gt(__0__.args)).json() 
	return smalltalk.NativeHandle.support()._at(__0__.json) 
""","SystemServer_pyParse_")
,"pyServer","""pyParse: string
	" Private - Return the result of parsing JSON string. "

	| json js args |
	js := Json parse: string.
	js isNil ifTrue: [ ^self error: 'Broken Json :',string ].
	args := js @ #arguments.
	json := ((#selector -> (js @ #selector) toString)
		,(#arguments -> args)) json.
	^NativeHandle support @ json""",nil)
smalltalk.bind(smalltalk.SystemServer,"pyStringify:",0
,smalltalk.__f__("""(self,literal):
	#SystemServer>>#pyStringify:
	return smalltalk.Json.stringify_(smalltalk.NativeHandle.support()._at(literal)) 
""","SystemServer_pyStringify_")
,"pyServer","""pyStringify: literal
	" Private - Return the result of JSON string. "

	^Json stringify: NativeHandle support @ literal""",nil)
smalltalk.bind(smalltalk.TestServer.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#TestServer class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.newArray(["needsContents:with:"]),smalltalk.superReceiver(smalltalk.TestServer.__class__,self).constructEventsTriggered()) 
""","TestServer_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^#(	#needsContents:with:
	) ,super constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.TestServer,"initializeHost",0
,smalltalk.__f__("""(self):
	#TestServer>>#initializeHost
	smalltalk.basic_at_put(self,"@host",smalltalk.String("localhost")) 
	return self 
""","TestServer_initializeHost")
,"initialize","""initializeHost
	" Private - Initialize the host of the receiver. "

	host := #localhost""",nil)
smalltalk.bind(smalltalk.TestServer,"host",0
,smalltalk.__f__("""(self):
	#TestServer>>#host
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@host",nil))):
		self.initializeHost() 
	 
	return getattr(self,"@host",nil) 
""","TestServer_host")
,"accessing","""host
	" Return the host of the receiver. "

	host isNil ifTrue: [ self initializeHost ].
	^host""",nil)
smalltalk.bind(smalltalk.TestServer,"host:",0
,smalltalk.__f__("""(self,anObject):
	#TestServer>>#host:
	smalltalk.basic_at_put(self,"@host",anObject) 
	return self 
""","TestServer_host_")
,"accessing","""host: anObject
	" Set the host of the receiver. "

	host := anObject""",nil)
smalltalk.bind(smalltalk.TestServer,"initializePort",0
,smalltalk.__f__("""(self):
	#TestServer>>#initializePort
	smalltalk.basic_at_put(self,"@port",smalltalk.Number(8088)) 
	return self 
""","TestServer_initializePort")
,"initialize","""initializePort
	" Private - Initialize the port of the receiver. "

	port := 8088""",nil)
smalltalk.bind(smalltalk.TestServer,"port",0
,smalltalk.__f__("""(self):
	#TestServer>>#port
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@port",nil))):
		self.initializePort() 
	 
	return getattr(self,"@port",nil) 
""","TestServer_port")
,"accessing","""port
	" Return the port of the receiver. "

	port isNil ifTrue: [ self initializePort ].
	^port""",nil)
smalltalk.bind(smalltalk.TestServer,"port:",0
,smalltalk.__f__("""(self,anObject):
	#TestServer>>#port:
	smalltalk.basic_at_put(self,"@port",anObject) 
	return self 
""","TestServer_port_")
,"accessing","""port: anObject
	" Set the port of the receiver. "

	port := anObject""",nil)
smalltalk.bind(smalltalk.TestServer,"initializeServer",0
,smalltalk.__f__("""(self):
	#TestServer>>#initializeServer
	smalltalk.basic_at_put(self,"@server",self.defaultServer()) 
	return self 
""","TestServer_initializeServer")
,"initialize","""initializeServer
	" Private - Initialize the server of the receiver. "

	server := self defaultServer""",nil)
smalltalk.bind(smalltalk.TestServer,"server",0
,smalltalk.__f__("""(self):
	#TestServer>>#server
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@server",nil))):
		self.initializeServer() 
	 
	return getattr(self,"@server",nil) 
""","TestServer_server")
,"accessing","""server
	" Return the server of the receiver. "

	server isNil ifTrue: [ self initializeServer ].
	^server""",nil)
smalltalk.bind(smalltalk.TestServer,"server:",0
,smalltalk.__f__("""(self,anObject):
	#TestServer>>#server:
	smalltalk.basic_at_put(self,"@server",anObject) 
	return self 
""","TestServer_server_")
,"accessing","""server: anObject
	" Set the server of the receiver. "

	server := anObject""",nil)
smalltalk.bind(smalltalk.TestServer,"initializeRequestHandler",0
,smalltalk.__f__("""(self):
	#TestServer>>#initializeRequestHandler
	smalltalk.basic_at_put(self,"@requestHandler",self.defaultRequestHandler()) 
	return self 
""","TestServer_initializeRequestHandler")
,"initialize","""initializeRequestHandler
	" Private - Initialize the requestHandler of the receiver. "

	requestHandler := self defaultRequestHandler""",nil)
smalltalk.bind(smalltalk.TestServer,"requestHandler",0
,smalltalk.__f__("""(self):
	#TestServer>>#requestHandler
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@requestHandler",nil))):
		self.initializeRequestHandler() 
	 
	return getattr(self,"@requestHandler",nil) 
""","TestServer_requestHandler")
,"accessing","""requestHandler
	" Return the requestHandler of the receiver. "

	requestHandler isNil ifTrue: [ self initializeRequestHandler ].
	^requestHandler""",nil)
smalltalk.bind(smalltalk.TestServer,"requestHandler:",0
,smalltalk.__f__("""(self,anObject):
	#TestServer>>#requestHandler:
	smalltalk.basic_at_put(self,"@requestHandler",anObject) 
	return self 
""","TestServer_requestHandler_")
,"accessing","""requestHandler: anObject
	" Set the requestHandler of the receiver. "

	requestHandler := anObject""",nil)
smalltalk.bind(smalltalk.TestServer,"isRunning",0
,smalltalk.__f__("""(self):
	#TestServer>>#isRunning
	return smalltalk.notNil_(getattr(self,"@server",nil)) 
""","TestServer_isRunning")
,"query","""isRunning
	" Returns true if the receiver is runnning. "

	^server notNil""",nil)
smalltalk.bind(smalltalk.TestServer,"start",0
,smalltalk.__f__("""(self):
	#TestServer>>#start
	self.note_(smalltalk.String("Starting server, use <Ctrl-C> to finish execution")) 
	self.server().serve_forever() 
	return self 
""","TestServer_start")
,"running","""start
	" Start the receiver. "

	self note: 'Starting server, use <Ctrl-C> to finish execution'.
	self server #serve_forever""",nil)
smalltalk.bind(smalltalk.TestServer,"errorNotFound:",0
,smalltalk.__f__("""(self,hHandler):
	#TestServer>>#errorNotFound:
	hHandler.send_error(smalltalk.Number(404).asParameter()) 
	return self 
""","TestServer_errorNotFound_")
,"private","""errorNotFound: hHandler
	" Private - Send HTTP error not found. "

	hHandler #send_error: 404 asParameter """,nil)
smalltalk.bind(smalltalk.TestServer,"doGet:",0
,smalltalk.__f__("""(self,hHandler):
	#TestServer>>#doGet:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return smalltalk.String._at(each) 
	__0__.text=nil
	__0__.items=nil
	self.note_(smalltalk.object_comma_(smalltalk.String("Get request: "),smalltalk.asObject_(hHandler.path))) 
	__0__.items=smalltalk.Array._at(smalltalk.asObject_(hHandler.headers).items()).collect_(smalltalk.blk(__blk1__,1)) 
	__0__.text=self.triggerEvent_withArguments_(smalltalk.String("needsContents:with:"),smalltalk.Array.with_with_(smalltalk.String._at(smalltalk.asObject_(hHandler.path)),__0__.items)) 
	self.note_(smalltalk.object_comma_(smalltalk.String("About to write - "),__0__.text)) 
	if smalltalk.b(smalltalk.isNil_(__0__.text)):
		return self.errorNotFound_(hHandler) 
	 
	if True:
		__0__.text = smalltalk.handleOf_(__0__.text).encode("utf-8")
		hHandler.send_response(200)
		#hHandler.send_header("Content-Type","text/plain; charset=utf-8")
		hHandler.send_header("Content-Type","text/html; charset=utf-8")
		hHandler.send_header("Content-Length",str(len(__0__.text)))
		hHandler.send_header("Access-Control-Allow-Private-Network","true")
		hHandler.send_header("Access-Control-Allow-Origin","*")
		hHandler.end_headers()
		hHandler.wfile.write(__0__.text)
		 
	return self 
""","TestServer_doGet_")
,"http","""doGet: hHandler
	" Private - Proccess HTTP Get request. "

	| text items |
	self note: 'Get request: ' ,hHandler#path.
	items := Array @ hHandler#headers items
		collect: [:each| String @ each ].
	text := self
		triggerEvent: #needsContents:with:
		withArguments: (Array
			with: String @ hHandler#path
			with: items).
	self note: 'About to write - ' ,text.
	text isNil ifTrue: [ ^self errorNotFound: hHandler ].
	{''py'if True:
	__0__.text = smalltalk.handleOf_(__0__.text).encode("utf-8")
	hHandler.send_response(200)
	#hHandler.send_header("Content-Type","text/plain; charset=utf-8")
	hHandler.send_header("Content-Type","text/html; charset=utf-8")
	hHandler.send_header("Content-Length",str(len(__0__.text)))
	hHandler.send_header("Access-Control-Allow-Private-Network","true")
	hHandler.send_header("Access-Control-Allow-Origin","*")
	hHandler.end_headers()
	hHandler.wfile.write(__0__.text)
	'}""",nil)
smalltalk.bind(smalltalk.TestServer,"doPost:",0
,smalltalk.__f__("""(self,hHandler):
	#TestServer>>#doPost:
	self.note_(smalltalk.object_comma_(smalltalk.String("[NIY] Post request: "),smalltalk.asObject_(hHandler.path))) 
	self.errorNotFound_(hHandler) 
	return self 
""","TestServer_doPost_")
,"http","""doPost: hHandler
	" Private - Proccess HTTP Get request. "

	self note: '[NIY] Post request: ' ,hHandler#path.
	self errorNotFound: hHandler. """,nil)
smalltalk.bind(smalltalk.TestServer,"defaultServer",0
,smalltalk.__f__("""(self):
	#TestServer>>#defaultServer
	if True:
		from http.server import HTTPServer
		hostAddress = smalltalk.handleOf_(self.host()).encode("utf-8")
		portNumber = smalltalk.handleOf_(self.port())
		return HTTPServer((hostAddress,portNumber),self.requestHandler()) 
	return self 
""","TestServer_defaultServer")
,"defaults","""defaultServer
	" Returns the default server of the receiver. "

	{''py'if True:
	from http.server import HTTPServer
	hostAddress = smalltalk.handleOf_(self.host()).encode("utf-8")
	portNumber = smalltalk.handleOf_(self.port())
	return HTTPServer((hostAddress,portNumber),self.requestHandler())'}""",nil)
smalltalk.bind(smalltalk.TestServer,"defaultRequestHandler",0
,smalltalk.__f__("""(self):
	#TestServer>>#defaultRequestHandler
	if True:
		from http.server import BaseHTTPRequestHandler
		class requestHandler(BaseHTTPRequestHandler):
			def do_GET(aHandler):
				self.doGet_(aHandler)
			def do_POST(aHandler):
				self.doPost_(aHandler)
		return requestHandler 
	return self 
""","TestServer_defaultRequestHandler")
,"defaults","""defaultRequestHandler
	" Returns the default requestHandler of the receiver. "

	{''py'if True:
	from http.server import BaseHTTPRequestHandler
	class requestHandler(BaseHTTPRequestHandler):
		def do_GET(aHandler):
			self.doGet_(aHandler)
		def do_POST(aHandler):
			self.doPost_(aHandler)
	return requestHandler'}""",nil)
smalltalk.bind(smalltalk.CompilerNode.__class__,"with:",0
,smalltalk.__f__("""(self,aNode):
	#CompilerNode class>>#with:
	def __blk1__(_s8_rec):
		_s8_rec.addNode_(aNode) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","CompilerNode_class_with_")
,"instantiation","""with: aNode
	^self new
		addNode: aNode;
		yourself""",nil)
smalltalk.bind(smalltalk.CompilerNode,"nodes",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#nodes
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@nodes",nil))):
		smalltalk.basic_at_put(self,"@nodes",smalltalk.Array.new()) 
	 
	return getattr(self,"@nodes",nil) 
""","CompilerNode_nodes")
,"accessing","""nodes
	nodes isNil ifTrue: [ nodes := Array new ].
	^nodes""",nil)
smalltalk.bind(smalltalk.CompilerNode,"nodes:",0
,smalltalk.__f__("""(self,aCollection):
	#CompilerNode>>#nodes:
	smalltalk.basic_at_put(self,"@nodes",aCollection) 
	return self 
""","CompilerNode_nodes_")
,"accessing","""nodes: aCollection
	nodes := aCollection""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isEmpty",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isEmpty
	return smalltalk.isObject_equalTo_(getattr(self,"@nodes",nil).size(),smalltalk.Number(0)) 
""","CompilerNode_isEmpty")
,"testing","""isEmpty
	" Return true if the receiver is empty. "

	^nodes size = 0 """,nil)
smalltalk.bind(smalltalk.CompilerNode,"annotations",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#annotations
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@annotations",nil))):
		smalltalk.basic_at_put(self,"@annotations",smalltalk.Array.new()) 
	 
	return getattr(self,"@annotations",nil) 
""","CompilerNode_annotations")
,"accessing","""annotations
	annotations isNil ifTrue: [ annotations := Array new ].
	^annotations""",nil)
smalltalk.bind(smalltalk.CompilerNode,"annotations:",0
,smalltalk.__f__("""(self,aCollection):
	#CompilerNode>>#annotations:
	smalltalk.basic_at_put(self,"@annotations",aCollection) 
	return self 
""","CompilerNode_annotations_")
,"accessing","""annotations: aCollection
	annotations := aCollection""",nil)
smalltalk.bind(smalltalk.CompilerNode,"addNode:",0
,smalltalk.__f__("""(self,aNode):
	#CompilerNode>>#addNode:
	self.nodes().add_(aNode) 
	return self 
""","CompilerNode_addNode_")
,"accessing","""addNode: aNode
	" Add a Node to the nodes of the receiver.
	Return the receiver. "

	self nodes add: aNode""",nil)
smalltalk.bind(smalltalk.CompilerNode,"start",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#start
	return getattr(self,"@start",nil) 
""","CompilerNode_start")
,"accessing","""start
	^start""",nil)
smalltalk.bind(smalltalk.CompilerNode,"end",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#end
	return getattr(self,"@end",nil) 
""","CompilerNode_end")
,"accessing","""end
	^end""",nil)
smalltalk.bind(smalltalk.CompilerNode,"start:end:",0
,smalltalk.__f__("""(self,startOffset,endOffset):
	#CompilerNode>>#start:end:
	smalltalk.basic_at_put(self,"@start",startOffset) 
	smalltalk.basic_at_put(self,"@end",endOffset) 
	return self 
""","CompilerNode_start_end_")
,"accessing","""start: startOffset end: endOffset
	" Set the offsets of the receiver in source code. "

	start := startOffset.
	end := endOffset.""",nil)
smalltalk.bind(smalltalk.CompilerNode,"sourceRange",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#sourceRange
	return getattr(self,"@start",nil).to_(getattr(self,"@end",nil)) 
""","CompilerNode_sourceRange")
,"accessing","""sourceRange
	" Return the receiver's sourceRange. "

	^start to: end """,nil)
smalltalk.bind(smalltalk.CompilerNode,"client",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#client
	return getattr(self,"@client",nil) 
""","CompilerNode_client")
,"accessing","""client
	" Private - Return an object that require the result of evaluation of the receiver.
	Note that client can be:
		aNode that will demmand result on runtime
		nil in case of not known
		#none if granted that the result of evaluation of the receiver will be discarded/unused.
	"

	^client """,nil)
smalltalk.bind(smalltalk.CompilerNode,"client:",0
,smalltalk.__f__("""(self,anObject):
	#CompilerNode>>#client:
	smalltalk.basic_at_put(self,"@client",anObject) 
	return self 
""","CompilerNode_client_")
,"accessing","""client: anObject
	" Private - Set an object that require the result of evaluation of the receiver. "

	client := anObject """,nil)
smalltalk.bind(smalltalk.CompilerNode,"prepareIn:for:",0
,smalltalk.__f__("""(self,aNode,anEncoder):
	#CompilerNode>>#prepareIn:for:
	def __blk1__(each):
		return each.client_(smalltalk.String("none")) 
	if smalltalk.b(getattr(self,"@nodes",nil).size()._lt(smalltalk.Number(1))):
		return self 
	 
	getattr(self,"@nodes",nil).do_(smalltalk.blk(__blk1__,1)) 
	getattr(self,"@nodes",nil).last().client_(self) 
	return self 
""","CompilerNode_prepareIn_for_")
,"encoding","""prepareIn: aNode for: anEncoder
	" Prepare the receiver to be encoded by anEncoder in aNode. "

	nodes size < 1 ifTrue: [ ^self ].
	nodes do: [:each| each client: #none ].
	nodes last client: self""",nil)
smalltalk.bind(smalltalk.CompilerNode,"sourceRange:",0
,smalltalk.__f__("""(self,interval):
	#CompilerNode>>#sourceRange:
	self.start_end_(interval.start(),interval.end()) 
	return self 
""","CompilerNode_sourceRange_")
,"accessing","""sourceRange: interval
	" Set the source range of the receiver. "

	self start: interval start end: interval end """,nil)
smalltalk.bind(smalltalk.CompilerNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#CompilerNode>>#accept:
	aVisitor.visitNode_(self) 
	return self 
""","CompilerNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitNode: self""",nil)
smalltalk.bind(smalltalk.CompilerNode,"acceptMacroAssignment:with:",0
,smalltalk.__f__("""(self,anExpressionNode,aVisitor):
	#CompilerNode>>#acceptMacroAssignment:with:
	return aVisitor.visitMacroAssignment_to_(self,anExpressionNode) 
""","CompilerNode_acceptMacroAssignment_with_")
,"visiting","""acceptMacroAssignment: anExpressionNode with: aVisitor
	" Return true if the receiver can resolve assignment on aVisitor. "

	^aVisitor visitMacroAssignment: self to: anExpressionNode""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isSuper",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isSuper
	return smalltalk.false 
""","CompilerNode_isSuper")
,"testing","""isSuper
	" Return true if the receiver is super. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"hasNumber",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#hasNumber
	return smalltalk.false 
""","CompilerNode_hasNumber")
,"testing","""hasNumber
	" Return true if the receiver has a numeric literal value. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"hasString",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#hasString
	return smalltalk.false 
""","CompilerNode_hasString")
,"testing","""hasString
	" Return true if the receiver has a string literal value. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isAssignment",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isAssignment
	return smalltalk.false 
""","CompilerNode_isAssignment")
,"testing","""isAssignment
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isBlock",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isBlock
	return smalltalk.false 
""","CompilerNode_isBlock")
,"testing","""isBlock
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isCascade",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isCascade
	return smalltalk.false 
""","CompilerNode_isCascade")
,"testing","""isCascade
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isInline",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isInline
	return smalltalk.false 
""","CompilerNode_isInline")
,"testing","""isInline
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isReturn",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isReturn
	return smalltalk.false 
""","CompilerNode_isReturn")
,"testing","""isReturn
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isSend",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isSend
	return smalltalk.false 
""","CompilerNode_isSend")
,"testing","""isSend
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isSequence",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isSequence
	return smalltalk.false 
""","CompilerNode_isSequence")
,"testing","""isSequence
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isValue",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isValue
	return smalltalk.false 
""","CompilerNode_isValue")
,"testing","""isValue
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"isVariable",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#isVariable
	return smalltalk.false 
""","CompilerNode_isVariable")
,"testing","""isVariable
	" Return true if the receiver is of this type. "

	^false""",nil)
smalltalk.bind(smalltalk.CompilerNode,"bindings",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#bindings
	return smalltalk.newArray([]) 
""","CompilerNode_bindings")
,"bindings","""bindings
	" Return the bindings of the receiver. "

	^#()""",nil)
smalltalk.bind(smalltalk.CompilerNode,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#CompilerNode>>#do:
	self.do_in_(aBlock,nil) 
	return self 
""","CompilerNode_do_")
,"iteration","""do: aBlock
	" Evaluate aBlock for all contents of the receiver. "

	self do: aBlock in: nil """,nil)
smalltalk.bind(smalltalk.CompilerNode,"do:in:",0
,smalltalk.__f__("""(self,aBlock,aNode):
	#CompilerNode>>#do:in:
	aBlock.value_value_(self,aNode) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@nodes",nil))):
		def __blk1__(each):
			return each.do_in_(aBlock,self) 
		getattr(self,"@nodes",nil).do_(smalltalk.blk(__blk1__,1)) 
	 
	return self 
""","CompilerNode_do_in_")
,"iteration","""do: aBlock in: aNode
	" Evaluate aBlock for all contents of the receiver. "

	aBlock value: self value: aNode.
	nodes notNil ifTrue: [
		nodes do: [:each| each do: aBlock in: self ]
	] """,nil)
smalltalk.bind(smalltalk.CompilerNode,"with:except:do:",0
,smalltalk.__f__("""(self,testBlock,_8except,aBlock):
	#CompilerNode>>#with:except:do:
	if smalltalk.b(smalltalk.b_(_8except.evaluateWith_(self) is smalltalk.true)):
		return nil 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@nodes",nil))):
		def __blk1__(each):
			def __blk2__():
				return aBlock.value_value_(each,self) 
			def __blk3__():
				return each.with_except_do_(testBlock,_8except,aBlock) 
			return smalltalk.if_true_false_(testBlock.value_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		getattr(self,"@nodes",nil).do_(smalltalk.blk(__blk1__,1)) 
	 
	return self 
""","CompilerNode_with_except_do_")
,"iteration","""with: testBlock except: except do: aBlock
	" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. "

	(except evaluateWith: self) == true ifTrue: [ ^nil ].
	nodes notNil ifTrue: [
		nodes do: [:each|
			(testBlock value: each)
			ifTrue: [ aBlock value: each value: self ]
			ifFalse: [ each with: testBlock except: except do: aBlock ]
		]
	] """,nil)
smalltalk.bind(smalltalk.CompilerNode,"messageSendConnector",0
,smalltalk.__f__("""(self):
	#CompilerNode>>#messageSendConnector
	return smalltalk.String(".") 
""","CompilerNode_messageSendConnector")
,"accessing","""messageSendConnector
	" Return the connector used to encode message sent to the receiver (or nil). "

	^$. """,nil)
smalltalk.bind(smalltalk.MethodNode,"selector",0
,smalltalk.__f__("""(self):
	#MethodNode>>#selector
	return getattr(self,"@selector",nil) 
""","MethodNode_selector")
,"accessing","""selector
	^selector""",nil)
smalltalk.bind(smalltalk.MethodNode,"selector:",0
,smalltalk.__f__("""(self,aString):
	#MethodNode>>#selector:
	smalltalk.basic_at_put(self,"@selector",aString) 
	return self 
""","MethodNode_selector_")
,"accessing","""selector: aString
	selector := aString""",nil)
smalltalk.bind(smalltalk.MethodNode,"arguments",0
,smalltalk.__f__("""(self):
	#MethodNode>>#arguments
	def __blk1__():
		return smalltalk.newArray([]) 
	def __blk2__():
		return getattr(self,"@arguments",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@arguments",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","MethodNode_arguments")
,"accessing","""arguments
	^arguments isNil ifTrue: [ #() ] ifFalse: [ arguments ]""",nil)
smalltalk.bind(smalltalk.MethodNode,"arguments:",0
,smalltalk.__f__("""(self,aCollection):
	#MethodNode>>#arguments:
	smalltalk.basic_at_put(self,"@arguments",aCollection) 
	return self 
""","MethodNode_arguments_")
,"accessing","""arguments: aCollection
	arguments := aCollection""",nil)
smalltalk.bind(smalltalk.MethodNode,"argumentNames",0
,smalltalk.__f__("""(self):
	#MethodNode>>#argumentNames
	def __blk1__(each):
		def __blk2__():
			return each 
		def __blk3__():
			return each.value() 
		return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.arguments().collect_(smalltalk.blk(__blk1__,1)) 
""","MethodNode_argumentNames")
,"accessing","""argumentNames
	" Return the names of the arguments of the receiver. "

	^self arguments collect: [:each|
		each isString
		ifTrue: [each]
		ifFalse: [each value]
	]""",nil)
smalltalk.bind(smalltalk.MethodNode,"source",0
,smalltalk.__f__("""(self):
	#MethodNode>>#source
	return getattr(self,"@source",nil) 
""","MethodNode_source")
,"accessing","""source
	^source""",nil)
smalltalk.bind(smalltalk.MethodNode,"source:",0
,smalltalk.__f__("""(self,aString):
	#MethodNode>>#source:
	smalltalk.basic_at_put(self,"@source",aString) 
	return self 
""","MethodNode_source_")
,"accessing","""source: aString
	source := aString""",nil)
smalltalk.bind(smalltalk.MethodNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#MethodNode>>#accept:
	aVisitor.visitMethodNode_(self) 
	return self 
""","MethodNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitMethodNode: self""",nil)
smalltalk.bind(smalltalk.MethodNode,"validateArguments",0
,smalltalk.__f__("""(self):
	#MethodNode>>#validateArguments
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return each.validateNames_(__0__.names) 
	__0__.names=nil
	__0__.names=smalltalk.HashedSet.withAll_(self.argumentNames()) 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.names.size(),self.arguments().size())):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid argument names "),self.argumentNames().asLiteral())) 
	 
	self.nodes().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","MethodNode_validateArguments")
,"validation","""validateArguments
	" Ensure the nodes of the receiver can be emmited with the defined arguments. "

	| names |
	names := HashedSet withAll: self argumentNames.
	names size = self arguments size ifFalse: [
		^self error: 'Invalid argument names ' ,self argumentNames asLiteral
	].
	self nodes do: [:each| each validateNames: names ]""",nil)
smalltalk.bind(smalltalk.SendNode,"selector",0
,smalltalk.__f__("""(self):
	#SendNode>>#selector
	return getattr(self,"@selector",nil) 
""","SendNode_selector")
,"accessing","""selector
	^selector""",nil)
smalltalk.bind(smalltalk.SendNode,"selector:",0
,smalltalk.__f__("""(self,aString):
	#SendNode>>#selector:
	smalltalk.basic_at_put(self,"@selector",aString) 
	return self 
""","SendNode_selector_")
,"accessing","""selector: aString
	selector := aString""",nil)
smalltalk.bind(smalltalk.SendNode,"arguments",0
,smalltalk.__f__("""(self):
	#SendNode>>#arguments
	def __blk1__():
		return smalltalk.newArray([]) 
	def __blk2__():
		return getattr(self,"@arguments",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@arguments",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","SendNode_arguments")
,"accessing","""arguments
	^arguments isNil ifTrue: [ #() ] ifFalse: [ arguments ]""",nil)
smalltalk.bind(smalltalk.SendNode,"arguments:",0
,smalltalk.__f__("""(self,aCollection):
	#SendNode>>#arguments:
	smalltalk.basic_at_put(self,"@arguments",aCollection) 
	return self 
""","SendNode_arguments_")
,"accessing","""arguments: aCollection
	arguments := aCollection""",nil)
smalltalk.bind(smalltalk.SendNode,"receiver",0
,smalltalk.__f__("""(self):
	#SendNode>>#receiver
	return getattr(self,"@receiver",nil) 
""","SendNode_receiver")
,"accessing","""receiver
	^receiver""",nil)
smalltalk.bind(smalltalk.SendNode,"receiver:",0
,smalltalk.__f__("""(self,aNode):
	#SendNode>>#receiver:
	smalltalk.basic_at_put(self,"@receiver",aNode) 
	return self 
""","SendNode_receiver_")
,"accessing","""receiver: aNode
	receiver := aNode""",nil)
smalltalk.bind(smalltalk.SendNode,"valueForReceiver:",0
,smalltalk.__f__("""(self,anObject):
	#SendNode>>#valueForReceiver:
	def __blk1__(_s8_rec):
		def __blk2__():
			return anObject 
		def __blk3__():
			return self.receiver().valueForReceiver_(anObject) 
		_s8_rec.receiver_(smalltalk.if_true_false_(smalltalk.isNil_(self.receiver()),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))) 
		_s8_rec.selector_(self.selector()) 
		_s8_rec.arguments_(self.arguments()) 
		_s8_rec.start_end_(self.start(),self.end()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.SendNode.new()) 
""","SendNode_valueForReceiver_")
,"accessing","""valueForReceiver: anObject
	^SendNode new
	    receiver: (self receiver isNil ifTrue: [anObject]
		ifFalse: [self receiver valueForReceiver: anObject]);
	    selector: self selector;
	    arguments: self arguments;
	    start: self start end: self end;
	    yourself""",nil)
smalltalk.bind(smalltalk.SendNode,"cascadeNodeWithMessages:",0
,smalltalk.__f__("""(self,aCollection):
	#SendNode>>#cascadeNodeWithMessages:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.selector_(self.selector()) 
		_s8_rec.arguments_(self.arguments()) 
		_s8_rec.start_end_(self.start(),self.end()) 
		return _s8_rec.yourself() 
	def __blk2__(_s8_rec):
		_s8_rec.receiver_(self.receiver()) 
		_s8_rec.nodes_(__0__.sends) 
		_s8_rec.start_end_(__0__.sends.first().start(),__0__.sends.last().end()) 
		return _s8_rec.yourself() 
	__0__.first=nil
	__0__.sends=nil
	__0__.first=__blk1__(smalltalk.SendNode.new()) 
	__0__.sends=smalltalk.object_comma_(smalltalk.Array.with_(__0__.first),aCollection) 
	return __blk2__(smalltalk.CascadeNode.new()) 
""","SendNode_cascadeNodeWithMessages_")
,"accessing","""cascadeNodeWithMessages: aCollection
	| first sends |
	first := SendNode new
	    selector: self selector;
	    arguments: self arguments;
	    start: self start end: self end;
	    yourself.
	sends := (Array with: first), aCollection.
	^CascadeNode new
	    receiver: self receiver;
	    nodes: sends;
	    start: sends first start end: sends last end;
	    yourself""",nil)
smalltalk.bind(smalltalk.SendNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#SendNode>>#accept:
	aVisitor.visitSendNode_(self) 
	return self 
""","SendNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitSendNode: self""",nil)
smalltalk.bind(smalltalk.SendNode,"isSend",0
,smalltalk.__f__("""(self):
	#SendNode>>#isSend
	return smalltalk.true 
""","SendNode_isSend")
,"testing","""isSend
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.SendNode,"do:in:",0
,smalltalk.__f__("""(self,aBlock,aNode):
	#SendNode>>#do:in:
	def __blk1__(each):
		return each.do_in_(aBlock,self) 
	smalltalk.superReceiver(smalltalk.SendNode,self).do_in_(aBlock,aNode) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@receiver",nil))):
		getattr(self,"@receiver",nil).do_in_(aBlock,self) 
	 
	self.arguments().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SendNode_do_in_")
,"iteration","""do: aBlock in: aNode
	" Evaluate aBlock for all contents of the receiver. "

	super do: aBlock in: aNode.
	receiver notNil ifTrue: [ receiver do: aBlock in: self ].
	self arguments do: [:each| each do: aBlock in: self ].""",nil)
smalltalk.bind(smalltalk.SendNode,"with:except:do:",0
,smalltalk.__f__("""(self,testBlock,_8except,aBlock):
	#SendNode>>#with:except:do:
	def __blk1__(each):
		def __blk2__():
			return aBlock.value_value_(each,self) 
		def __blk3__():
			return each.with_except_do_(testBlock,_8except,aBlock) 
		return smalltalk.if_true_false_(testBlock.value_(each),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	if smalltalk.b(smalltalk.isNil_(smalltalk.superReceiver(smalltalk.SendNode,self).with_except_do_(testBlock,_8except,aBlock))):
		return nil 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@receiver",nil))):
		def __blk4__():
			return aBlock.value_value_(getattr(self,"@receiver",nil),self) 
		def __blk5__():
			return getattr(self,"@receiver",nil).with_except_do_(testBlock,_8except,aBlock) 
		smalltalk.if_true_false_(testBlock.value_(getattr(self,"@receiver",nil)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
	 
	self.arguments().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SendNode_with_except_do_")
,"iteration","""with: testBlock except: except do: aBlock
	" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. "

	(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].
	receiver notNil ifTrue: [
		(testBlock value: receiver)
		ifTrue: [ aBlock value: receiver value: self ]
		ifFalse: [ receiver with: testBlock except: except do: aBlock ]
	].
	self arguments do: [:each|
		(testBlock value: each)
		ifTrue: [ aBlock value: each value: self ]
		ifFalse: [ each with: testBlock except: except do: aBlock ]
	] """,nil)
smalltalk.bind(smalltalk.SendNode,"prepareIn:for:",0
,smalltalk.__f__("""(self,aNode,anEncoder):
	#SendNode>>#prepareIn:for:
	def __blk1__(each):
		return each.client_(self) 
	smalltalk.superReceiver(smalltalk.SendNode,self).prepareIn_for_(aNode,anEncoder) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@receiver",nil))):
		getattr(self,"@receiver",nil).client_(self) 
	 
	self.arguments().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","SendNode_prepareIn_for_")
,"encoding","""prepareIn: aNode for: anEncoder
	" Prepare the receiver to be encoded by anEncoder in aNode. "

	super prepareIn: aNode for: anEncoder.
	receiver notNil ifTrue: [ receiver client: self ].
	self arguments do: [:each| each client: self ] """,nil)
smalltalk.bind(smalltalk.CascadeNode,"receiver",0
,smalltalk.__f__("""(self):
	#CascadeNode>>#receiver
	return getattr(self,"@receiver",nil) 
""","CascadeNode_receiver")
,"accessing","""receiver
	^receiver""",nil)
smalltalk.bind(smalltalk.CascadeNode,"receiver:",0
,smalltalk.__f__("""(self,aNode):
	#CascadeNode>>#receiver:
	smalltalk.basic_at_put(self,"@receiver",aNode) 
	return self 
""","CascadeNode_receiver_")
,"accessing","""receiver: aNode
	receiver := aNode""",nil)
smalltalk.bind(smalltalk.CascadeNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#CascadeNode>>#accept:
	aVisitor.visitCascadeNode_(self) 
	return self 
""","CascadeNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitCascadeNode: self""",nil)
smalltalk.bind(smalltalk.CascadeNode,"isCascade",0
,smalltalk.__f__("""(self):
	#CascadeNode>>#isCascade
	return smalltalk.true 
""","CascadeNode_isCascade")
,"testing","""isCascade
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.CascadeNode,"do:in:",0
,smalltalk.__f__("""(self,aBlock,aNode):
	#CascadeNode>>#do:in:
	smalltalk.superReceiver(smalltalk.CascadeNode,self).do_in_(aBlock,aNode) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@receiver",nil))):
		getattr(self,"@receiver",nil).do_in_(aBlock,self) 
	 
	return self 
""","CascadeNode_do_in_")
,"iteration","""do: aBlock in: aNode
	" Evaluate aBlock for all contents of the receiver. "

	super do: aBlock in: aNode.
	receiver notNil ifTrue: [ receiver do: aBlock in: self ].""",nil)
smalltalk.bind(smalltalk.CascadeNode,"with:except:do:",0
,smalltalk.__f__("""(self,testBlock,_8except,aBlock):
	#CascadeNode>>#with:except:do:
	if smalltalk.b(smalltalk.isNil_(smalltalk.superReceiver(smalltalk.CascadeNode,self).with_except_do_(testBlock,_8except,aBlock))):
		return nil 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@receiver",nil))):
		def __blk1__():
			return aBlock.value_value_(getattr(self,"@receiver",nil),self) 
		def __blk2__():
			return getattr(self,"@receiver",nil).with_except_do_(testBlock,_8except,aBlock) 
		smalltalk.if_true_false_(testBlock.value_(getattr(self,"@receiver",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	 
	return self 
""","CascadeNode_with_except_do_")
,"iteration","""with: testBlock except: except do: aBlock
	" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. "

	(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].
	receiver notNil ifTrue: [
		(testBlock value: receiver)
		ifTrue: [ aBlock value: receiver value: self ]
		ifFalse: [ receiver with: testBlock except: except do: aBlock ]
	] """,nil)
smalltalk.bind(smalltalk.BlockNode,"parameterNames",0
,smalltalk.__f__("""(self):
	#BlockNode>>#parameterNames
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return each 
		def __blk3__():
			return each.value() 
		return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	__0__.result=nil
	__0__.result=self.parameters().collect_(smalltalk.blk(__blk1__,1)) 
	if not smalltalk.b(smalltalk.isObject_equalTo_(__0__.result.asSet().size(),__0__.result.size())):
		return self.error_(smalltalk.object_comma_(smalltalk.String("Invalid names "),__0__.result.asLiteral())) 
	 
	return __0__.result 
""","BlockNode_parameterNames")
,"accessing","""parameterNames
	" Return the names of the parameters of the receiver. "

	| result |
	result := self parameters collect: [:each|
		each isString
		ifTrue: [each]
		ifFalse: [each value]
	].
	result asSet size = result size ifFalse: [
		^self error: 'Invalid names ' ,result asLiteral
	].
	^result""",nil)
smalltalk.bind(smalltalk.BlockNode,"parameters",0
,smalltalk.__f__("""(self):
	#BlockNode>>#parameters
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@parameters",nil))):
		smalltalk.basic_at_put(self,"@parameters",smalltalk.Array.new()) 
	 
	return getattr(self,"@parameters",nil) 
""","BlockNode_parameters")
,"accessing","""parameters
	parameters isNil ifTrue: [ parameters := Array new ].
	^parameters""",nil)
smalltalk.bind(smalltalk.BlockNode,"parameters:",0
,smalltalk.__f__("""(self,aCollection):
	#BlockNode>>#parameters:
	smalltalk.basic_at_put(self,"@parameters",aCollection) 
	return self 
""","BlockNode_parameters_")
,"accessing","""parameters: aCollection
	parameters := aCollection""",nil)
smalltalk.bind(smalltalk.BlockNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#BlockNode>>#accept:
	aVisitor.visitBlockNode_(self) 
	return self 
""","BlockNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitBlockNode: self""",nil)
smalltalk.bind(smalltalk.BlockNode,"bindings",0
,smalltalk.__f__("""(self):
	#BlockNode>>#bindings
	return self.parameterNames() 
""","BlockNode_bindings")
,"bindings","""bindings
	" Return the bindings of the receiver. "

	^self parameterNames""",nil)
smalltalk.bind(smalltalk.BlockNode,"isBlock",0
,smalltalk.__f__("""(self):
	#BlockNode>>#isBlock
	return smalltalk.true 
""","BlockNode_isBlock")
,"testing","""isBlock
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.BlockNode,"do:in:",0
,smalltalk.__f__("""(self,aBlock,aNode):
	#BlockNode>>#do:in:
	def __blk1__(each):
		return each.do_in_(aBlock,self) 
	smalltalk.superReceiver(smalltalk.BlockNode,self).do_in_(aBlock,aNode) 
	self.parameters().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","BlockNode_do_in_")
,"iteration","""do: aBlock in: aNode
	" Evaluate aBlock for all contents of the receiver. "

	super do: aBlock in: aNode.
	self parameters do: [:each| each do: aBlock in: self ].""",nil)
smalltalk.bind(smalltalk.SequenceNode,"tempNames",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#tempNames
	def __blk1__(each):
		def __blk2__():
			return each 
		def __blk3__():
			return each.value() 
		return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
	return self.temps().collect_(smalltalk.blk(__blk1__,1)) 
""","SequenceNode_tempNames")
,"accessing","""tempNames
	" Return the names of the temps in the receiver. "

	^self temps collect: [:each|
		each isString
		ifTrue: [each]
		ifFalse: [each value]
	]""",nil)
smalltalk.bind(smalltalk.SequenceNode,"temps",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#temps
	def __blk1__():
		return smalltalk.newArray([]) 
	def __blk2__():
		return getattr(self,"@temps",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@temps",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","SequenceNode_temps")
,"accessing","""temps
	^temps isNil ifTrue: [ #() ] ifFalse: [ temps ]""",nil)
smalltalk.bind(smalltalk.SequenceNode,"temps:",0
,smalltalk.__f__("""(self,aCollection):
	#SequenceNode>>#temps:
	smalltalk.basic_at_put(self,"@temps",aCollection) 
	return self 
""","SequenceNode_temps_")
,"accessing","""temps: aCollection
	temps := aCollection""",nil)
smalltalk.bind(smalltalk.SequenceNode,"asBlockSequenceNode",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#asBlockSequenceNode
	def __blk1__(_s8_rec):
		_s8_rec.nodes_(self.nodes()) 
		_s8_rec.temps_(self.temps()) 
		_s8_rec.start_end_(self.start(),self.end()) 
		return _s8_rec.yourself() 
	return __blk1__(smalltalk.BlockSequenceNode.new()) 
""","SequenceNode_asBlockSequenceNode")
,"converting","""asBlockSequenceNode
	^BlockSequenceNode new
	    nodes: self nodes;
	    temps: self temps;
	    start: self start end: self end;
	    yourself""",nil)
smalltalk.bind(smalltalk.SequenceNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#SequenceNode>>#accept:
	aVisitor.visitSequenceNode_(self) 
	return self 
""","SequenceNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitSequenceNode: self""",nil)
smalltalk.bind(smalltalk.SequenceNode,"bindings",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#bindings
	return self.tempNames() 
""","SequenceNode_bindings")
,"bindings","""bindings
	" Return the bindings of the receiver. "

	^self tempNames""",nil)
smalltalk.bind(smalltalk.SequenceNode,"isSequence",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#isSequence
	return smalltalk.true 
""","SequenceNode_isSequence")
,"testing","""isSequence
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.SequenceNode,"shouldReturn",0
,smalltalk.__f__("""(self):
	#SequenceNode>>#shouldReturn
	def __blk1__():
		return self.nodes().last().isReturn() 
	if smalltalk.b(smalltalk.boolean_and_(self.nodes().notEmpty(),smalltalk.blk(__blk1__,0))):
		return self 
	 
	self.addNode_(smalltalk.ReturnNode.variable_at_(smalltalk.String("self"),self.end())) 
	return self 
""","SequenceNode_shouldReturn")
,"return","""shouldReturn
	" Ensure the receiver includes a return node. "

	(self nodes notEmpty and: [
		self nodes last isReturn
	]) ifTrue: [ ^self].

	self addNode: (ReturnNode variable: #self at: self end).""",nil)
smalltalk.bind(smalltalk.SequenceNode,"validateNames:",0
,smalltalk.__f__("""(self,names):
	_s8Ret_=smalltalk.newContext()
	try:
		#SequenceNode>>#validateNames:
		def __blk1__(temp):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Invalid temp ("),temp),smalltalk.String(")")))) 
			return smalltalk.if_true_false_(names.includes_(temp),smalltalk.blk(__blk2__,0),nil) 
		self.tempNames().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","SequenceNode_validateNames_")
,"validation","""validateNames: names
	" Validate the receiver can be emmited in a context with names. "

	self tempNames do: [:temp|
		(names includes: temp) ifTrue: [
			^self error: 'Invalid temp (',temp,')'
		].
	]""",nil)
smalltalk.bind(smalltalk.BlockSequenceNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#BlockSequenceNode>>#accept:
	aVisitor.visitBlockSequenceNode_(self) 
	return self 
""","BlockSequenceNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitBlockSequenceNode: self""",nil)
smalltalk.bind(smalltalk.ExtendedSequenceNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#ExtendedSequenceNode>>#accept:
	aVisitor.visitExtendedSequenceNode_(self) 
	return self 
""","ExtendedSequenceNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitExtendedSequenceNode: self""",nil)
smalltalk.bind(smalltalk.ExtendedSequenceNode,"directives",0
,smalltalk.__f__("""(self):
	#ExtendedSequenceNode>>#directives
	def __blk1__():
		return smalltalk.newArray([]) 
	def __blk2__():
		return getattr(self,"@directives",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@directives",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","ExtendedSequenceNode_directives")
,"accessing","""directives
	" Return the directives of the receiver. "

	^directives isNil
		ifTrue: [ #() ]
		ifFalse: [directives]""",nil)
smalltalk.bind(smalltalk.ExtendedSequenceNode,"directives:",0
,smalltalk.__f__("""(self,aCollection):
	#ExtendedSequenceNode>>#directives:
	smalltalk.basic_at_put(self,"@directives",aCollection) 
	return self 
""","ExtendedSequenceNode_directives_")
,"accessing","""directives: aCollection
	" Set the directives of the receiver. "

	directives := aCollection""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"left",0
,smalltalk.__f__("""(self):
	#AssignmentNode>>#left
	return getattr(self,"@left",nil) 
""","AssignmentNode_left")
,"accessing","""left
	^left""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"left:",0
,smalltalk.__f__("""(self,aNode):
	#AssignmentNode>>#left:
	smalltalk.basic_at_put(self,"@left",aNode) 
	return self 
""","AssignmentNode_left_")
,"accessing","""left: aNode
	left := aNode""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"right",0
,smalltalk.__f__("""(self):
	#AssignmentNode>>#right
	return getattr(self,"@right",nil) 
""","AssignmentNode_right")
,"accessing","""right
	^right""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"right:",0
,smalltalk.__f__("""(self,aNode):
	#AssignmentNode>>#right:
	smalltalk.basic_at_put(self,"@right",aNode) 
	return self 
""","AssignmentNode_right_")
,"accessing","""right: aNode
	right := aNode""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#AssignmentNode>>#accept:
	aVisitor.visitAssignmentNode_(self) 
	return self 
""","AssignmentNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitAssignmentNode: self""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"isAssignment",0
,smalltalk.__f__("""(self):
	#AssignmentNode>>#isAssignment
	return smalltalk.true 
""","AssignmentNode_isAssignment")
,"testing","""isAssignment
	" Return true if the receiver is an assignment node. "

	^true""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"do:in:",0
,smalltalk.__f__("""(self,aBlock,aNode):
	#AssignmentNode>>#do:in:
	smalltalk.superReceiver(smalltalk.AssignmentNode,self).do_in_(aBlock,aNode) 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@left",nil))):
		getattr(self,"@left",nil).do_in_(aBlock,self) 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@right",nil))):
		getattr(self,"@right",nil).do_in_(aBlock,self) 
	 
	return self 
""","AssignmentNode_do_in_")
,"iteration","""do: aBlock in: aNode
	" Evaluate aBlock for all contents of the receiver. "

	super do: aBlock in: aNode.
	left  notNil ifTrue: [ left  do: aBlock in: self ].
	right notNil ifTrue: [ right do: aBlock in: self ].""",nil)
smalltalk.bind(smalltalk.AssignmentNode,"with:except:do:",0
,smalltalk.__f__("""(self,testBlock,_8except,aBlock):
	#AssignmentNode>>#with:except:do:
	if smalltalk.b(smalltalk.isNil_(smalltalk.superReceiver(smalltalk.AssignmentNode,self).with_except_do_(testBlock,_8except,aBlock))):
		return nil 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@right",nil))):
		def __blk1__():
			return aBlock.value_value_(getattr(self,"@right",nil),self) 
		def __blk2__():
			return getattr(self,"@right",nil).with_except_do_(testBlock,_8except,aBlock) 
		smalltalk.if_true_false_(testBlock.value_(getattr(self,"@right",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
	 
	return self 
""","AssignmentNode_with_except_do_")
,"iteration","""with: testBlock except: except do: aBlock
	" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. "

	(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].
	right notNil ifTrue: [
		(testBlock value: right)
		ifTrue: [ aBlock value: right value: self ]
		ifFalse: [ right with: testBlock except: except do: aBlock ]
	] """,nil)
smalltalk.bind(smalltalk.AssignmentNode,"prepareIn:for:",0
,smalltalk.__f__("""(self,aNode,anEncoder):
	#AssignmentNode>>#prepareIn:for:
	smalltalk.superReceiver(smalltalk.AssignmentNode,self).prepareIn_for_(aNode,anEncoder) 
	getattr(self,"@right",nil).client_(self) 
	return self 
""","AssignmentNode_prepareIn_for_")
,"encoding","""prepareIn: aNode for: anEncoder
	" Prepare the receiver to be encoded by anEncoder in aNode. "

	super prepareIn: aNode for: anEncoder.
	right client: self""",nil)
smalltalk.bind(smalltalk.ReturnNode.__class__,"variable:at:",0
,smalltalk.__f__("""(self,aName,offset):
	#ReturnNode class>>#variable:at:
	def __blk1__(_s8_rec):
		def __blk2__(_s8_rec):
			_s8_rec.value_(aName) 
			_s8_rec.start_end_(offset,offset) 
			return _s8_rec.yourself() 
		_s8_rec.addNode_(__blk2__(smalltalk.VariableNode.new())) 
		_s8_rec.start_end_(offset,offset) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","ReturnNode_class_variable_at_")
,"instantiation","""variable: aName at: offset
	" Return an instance of the receiver. "

	^self new
		addNode: (VariableNode new
			value: aName;
			start: offset end: offset;
			yourself);
		start: offset end: offset;
		yourself""",nil)
smalltalk.bind(smalltalk.ReturnNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#ReturnNode>>#accept:
	aVisitor.visitReturnNode_(self) 
	return self 
""","ReturnNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitReturnNode: self""",nil)
smalltalk.bind(smalltalk.ReturnNode,"isReturn",0
,smalltalk.__f__("""(self):
	#ReturnNode>>#isReturn
	return smalltalk.true 
""","ReturnNode_isReturn")
,"testing","""isReturn
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.ValueNode.__class__,"with:",0
,smalltalk.__f__("""(self,aValue):
	#ValueNode class>>#with:
	return self.new().value_(aValue) 
""","ValueNode_class_with_")
,"instantiation","""with: aValue
	" Return an instance of the receiver. "

	^self new value: aValue""",nil)
smalltalk.bind(smalltalk.ValueNode,"value",0
,smalltalk.__f__("""(self):
	#ValueNode>>#value
	return getattr(self,"@value",nil) 
""","ValueNode_value")
,"accessing","""value
	^value""",nil)
smalltalk.bind(smalltalk.ValueNode,"value:",0
,smalltalk.__f__("""(self,anObject):
	#ValueNode>>#value:
	smalltalk.basic_at_put(self,"@value",anObject) 
	return self 
""","ValueNode_value_")
,"accessing","""value: anObject
	value := anObject""",nil)
smalltalk.bind(smalltalk.ValueNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#ValueNode>>#accept:
	aVisitor.visitValueNode_(self) 
	return self 
""","ValueNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitValueNode: self""",nil)
smalltalk.bind(smalltalk.ValueNode,"hasNumber",0
,smalltalk.__f__("""(self):
	#ValueNode>>#hasNumber
	return getattr(self,"@value",nil).isNumber() 
""","ValueNode_hasNumber")
,"testing","""hasNumber
	" Return true if the receiver has a numeric literal value. "

	^value isNumber""",nil)
smalltalk.bind(smalltalk.ValueNode,"hasString",0
,smalltalk.__f__("""(self):
	#ValueNode>>#hasString
	return getattr(self,"@value",nil).isString() 
""","ValueNode_hasString")
,"testing","""hasString
	" Return true if the receiver has a string literal value. "

	^value isString""",nil)
smalltalk.bind(smalltalk.ValueNode,"isValue",0
,smalltalk.__f__("""(self):
	#ValueNode>>#isValue
	return smalltalk.true 
""","ValueNode_isValue")
,"testing","""isValue
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.VariableNode,"localNameIn:",0
,smalltalk.__f__("""(self,aCompiler):
	#VariableNode>>#localNameIn:
	return aCompiler.localName_(self.value()) 
""","VariableNode_localNameIn_")
,"accessing","""localNameIn: aCompiler
	" Return the name of the receiver to be used by aCompiler locally. "

	^aCompiler localName: self value """,nil)
smalltalk.bind(smalltalk.VariableNode,"needsVerification",0
,smalltalk.__f__("""(self):
	#VariableNode>>#needsVerification
	return smalltalk.true 
""","VariableNode_needsVerification")
,"testing","""needsVerification
	" Return true if the receiver need verification. "

	^true""",nil)
smalltalk.bind(smalltalk.VariableNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#VariableNode>>#accept:
	aVisitor.visitVariableNode_(self) 
	return self 
""","VariableNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitVariableNode: self""",nil)
smalltalk.bind(smalltalk.VariableNode,"isSuper",0
,smalltalk.__f__("""(self):
	#VariableNode>>#isSuper
	return smalltalk.isObject_equalTo_(getattr(self,"@value",nil),smalltalk.String("super")) 
""","VariableNode_isSuper")
,"testing","""isSuper
	" Return true if the receiver is super. "

	^value = 'super'""",nil)
smalltalk.bind(smalltalk.VariableNode,"indices",0
,smalltalk.__f__("""(self):
	#VariableNode>>#indices
	def __blk1__():
		return smalltalk.Array.new() 
	def __blk2__():
		return getattr(self,"@indices",nil) 
	return smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@indices",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","VariableNode_indices")
,"accessing","""indices
	" Return the indexing references of the receiver. "

	^indices isNil ifTrue: [ Array new ] ifFalse: [ indices ]""",nil)
smalltalk.bind(smalltalk.VariableNode,"indexedAs:",0
,smalltalk.__f__("""(self,chain):
	#VariableNode>>#indexedAs:
	def __blk1__():
		return chain.second().notEmpty() 
	def __blk2__():
		def __blk3__(tuple):
			def __blk4__():
				return smalltalk.ValueNode.new().value_(tuple.second()) 
			def __blk5__():
				return tuple.second() 
			return smalltalk.if_true_false_(tuple.second().isString(),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		return chain.second().collect_(smalltalk.blk(__blk3__,1)) 
	smalltalk.basic_at_put(self,"@indices",smalltalk.if_true_false_(smalltalk.boolean_and_(chain.size()._gt(smalltalk.Number(1)),smalltalk.blk(__blk1__,0)),smalltalk.blk(__blk2__,0),nil)) 
	return self 
""","VariableNode_indexedAs_")
,"visiting","""indexedAs: chain
	" The receiver has indexing references defined by chain. "

	indices := (chain size > 1 and: [ chain second notEmpty ]) ifTrue: [
		chain second collect: [:tuple|
			tuple second isString
			ifTrue: [ ValueNode new value: tuple second ]
			ifFalse: [ tuple second ]
		]
	].
	^self""",nil)
smalltalk.bind(smalltalk.VariableNode,"isVariable",0
,smalltalk.__f__("""(self):
	#VariableNode>>#isVariable
	return smalltalk.true 
""","VariableNode_isVariable")
,"testing","""isVariable
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.GlobalReferenceNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#GlobalReferenceNode>>#accept:
	aVisitor.visitGlobalReferenceNode_(self) 
	return self 
""","GlobalReferenceNode_accept_")
,"visiting","""accept: aVisitor
	aVisitor visitGlobalReferenceNode: self""",nil)
smalltalk.bind(smalltalk.NoReceiverNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#NoReceiverNode>>#accept:
	return self 
""","NoReceiverNode_accept_")
,"visiting","accept: aVisitor",nil)
smalltalk.bind(smalltalk.NoReceiverNode,"messageSendConnector",0
,smalltalk.__f__("""(self):
	#NoReceiverNode>>#messageSendConnector
	return nil 
""","NoReceiverNode_messageSendConnector")
,"accessing","""messageSendConnector
	" Return the connector used to encode message sent to the receiver (or nil). "

	^nil """,nil)
smalltalk.bind(smalltalk.AlienNode,"localNameIn:",0
,smalltalk.__f__("""(self,aCompiler):
	#AlienNode>>#localNameIn:
	return self.value() 
""","AlienNode_localNameIn_")
,"accessing","""localNameIn: aCompiler
	" Return the name of the receiver to be used by aCompiler locally. "

	^self value """,nil)
smalltalk.bind(smalltalk.AlienNode,"needsVerification",0
,smalltalk.__f__("""(self):
	#AlienNode>>#needsVerification
	return smalltalk.false 
""","AlienNode_needsVerification")
,"testing","""needsVerification
	" Return true if the receiver need verification. "

	^false""",nil)
smalltalk.bind(smalltalk.InlineNode.__class__,"sources:parser:",0
,smalltalk.__f__("""(self,tuples,parser):
	#InlineNode class>>#sources:parser:
	return self.basicNew().initialize_parser_(tuples,parser) 
""","InlineNode_class_sources_parser_")
,"instantiation","""sources: tuples parser: parser
	^self basicNew
		initialize: tuples
		parser: parser """,nil)
smalltalk.bind(smalltalk.InlineNode,"initialize:parser:",0
,smalltalk.__f__("""(self,tuples,parser):
	#InlineNode>>#initialize:parser:
	smalltalk.basic_at_put(self,"@sources",tuples) 
	self.capture_with_(smalltalk.String("s8"),parser) 
	return self 
""","InlineNode_initialize_parser_")
,"initialize","""initialize: tuples parser: parser
	" Private - Initialize the receiver "

	sources := tuples.
	self capture: #s8 with: parser. """,nil)
smalltalk.bind(smalltalk.InlineNode,"sourceFor:in:",0
,smalltalk.__f__("""(self,lang,encoder):
	_s8Ret_=smalltalk.newContext()
	try:
		#InlineNode>>#sourceFor:in:
		__0__=smalltalk.newContext()
		def __blk1__(tuple):
			__1__=smalltalk.newContext()
			def __blk2__():
				__0__.default=__1__.code
				return __0__.default 
			__1__.code=nil
			__1__.code=tuple.second().value() 
			if smalltalk.b(smalltalk.isObject_equalTo_(tuple.first(),lang)):
				smalltalk.raise_result_(_s8Ret_,__1__.code) 
			 
			return smalltalk.if_true_false_(smalltalk.isNil_(tuple.first()),smalltalk.blk(__blk2__,0),nil) 
		__0__.default=nil
		getattr(self,"@sources",nil).do_(smalltalk.blk(__blk1__,1)) 
		if smalltalk.b(smalltalk.notNil_(encoder)):
			__1__=smalltalk.newContext()
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,__1__.result) 
			__1__.result=nil
			__1__.result=encoder.inline_source_(self,__0__.default) 
			smalltalk.if_true_false_(smalltalk.notNil_(__1__.result),smalltalk.blk(__blk3__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,__0__.default) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","InlineNode_sourceFor_in_")
,"accessing","""sourceFor: lang in: encoder
	" Return the native source code to inline (or nil). "

	| default |
	sources do: [:tuple| | code |
		code := tuple second value.
		tuple first = lang ifTrue: [ ^code ].
		tuple first isNil ifTrue: [ default := code ].
	].
	encoder notNil ifTrue: [ | result |
		result := encoder inline: self source: default.
		result notNil ifTrue: [ ^result ]
	].
	^default""",nil)
smalltalk.bind(smalltalk.InlineNode,"accept:",0
,smalltalk.__f__("""(self,aVisitor):
	#InlineNode>>#accept:
	return aVisitor.visitInlineNode_(self) 
""","InlineNode_accept_")
,"visiting","""accept: aVisitor
	^aVisitor visitInlineNode: self""",nil)
smalltalk.bind(smalltalk.InlineNode,"isInline",0
,smalltalk.__f__("""(self):
	#InlineNode>>#isInline
	return smalltalk.true 
""","InlineNode_isInline")
,"testing","""isInline
	" Return true if the receiver is of this type. "

	^true""",nil)
smalltalk.bind(smalltalk.InlineNode,"capture:with:",0
,smalltalk.__f__("""(self,lang,parser):
	#InlineNode>>#capture:with:
	def __blk1__(tuple):
		def __blk2__():
			return self.parse_at_with_(tuple.second().value(),tuple.second().start(),parser) 
		return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(tuple.first(),lang),smalltalk.blk(__blk2__,0),nil) 
	getattr(self,"@sources",nil).do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","InlineNode_capture_with_")
,"internal","""capture: lang with: parser
	" Private - Capture internal contents from sources. "

	sources do: [:tuple| tuple first = lang ifTrue: [
		self parse: tuple second value at: tuple second start with: parser	
	]]""",nil)
smalltalk.bind(smalltalk.InlineNode,"parse:at:with:",0
,smalltalk.__f__("""(self,code,offset,parser):
	#InlineNode>>#parse:at:with:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.stream.nextPut_(smalltalk.String(" ")) 
	def __blk2__(_s8_rec):
		_s8_rec.nextPutAll_(code) 
		return _s8_rec.position_(offset) 
	def __blk3__():
		return __0__.array.size()._gt(smalltalk.Number(1)) 
	__0__.stream=nil
	__0__.array=nil
	__0__.stream=smalltalk.String("").stream() 
	smalltalk.times_repeat_(offset,smalltalk.blk(__blk1__,0)) 
	__blk2__(__0__.stream) 
	__0__.array=smalltalk.object_comma_(parser,smalltalk.PPEOFParser.new()).parse_(__0__.stream) 
	if not smalltalk.b(smalltalk.boolean_and_(__0__.array.isArray(),smalltalk.blk(__blk3__,0))):
		self.error_(smalltalk.object_comma_(smalltalk.String("Invalid inline code "),smalltalk.asString_(code))) 
	 
	self.addNode_(__0__.array.second()) 
	return self 
""","InlineNode_parse_at_with_")
,"internal","""parse: code at: offset with: parser
	" Private - Parse internal contents from code using parser. "

	| stream array |
	stream := '' stream.
	offset timesRepeat: [ stream nextPut: $ ].
	stream nextPutAll: code; position: offset.
	array := parser ,PPEOFParser new parse: stream.
	(array isArray and: [array size > 1]) ifFalse: [
		self error: 'Invalid inline code ' ,code asString
	].
	self addNode: array second""",nil)
smalltalk.bind(smalltalk.DirectiveNode,"description",0
,smalltalk.__f__("""(self):
	#DirectiveNode>>#description
	return (self).__class__.name() 
""","DirectiveNode_description")
,"visiting","""description
	" Return the description of the receiver. "

	^self class name""",nil)
smalltalk.bind(smalltalk.DirectiveNode,"selector",0
,smalltalk.__f__("""(self):
	#DirectiveNode>>#selector
	return smalltalk.String("directive:arguments:").asSelector() 
""","DirectiveNode_selector")
,"visiting","""selector
	" Private - Return the internal selector used to execute directive. "

	^#directive:arguments: asSelector""",nil)
smalltalk.bind(smalltalk.DirectiveNode,"literal",0
,smalltalk.__f__("""(self):
	#DirectiveNode>>#literal
	return self.implementedBySubclass() 
""","DirectiveNode_literal")
,"visiting","""literal
	" Private - Return the literal to embedd in directive call. "

	^self implementedBySubclass""",nil)
smalltalk.bind(smalltalk.DirectiveNode,"asNative:for:on:",0
,smalltalk.__f__("""(self,selector,anEncoder,aStream):
	#DirectiveNode>>#asNative:for:on:
	__0__=smalltalk.newContext()
	__0__.call=nil
	__0__.call=anEncoder.sourceToDirectCall_with_(self.selector(),self.literal()) 
	return anEncoder.sourceToTry_(__0__.call) 
""","DirectiveNode_asNative_for_on_")
,"code generation","""asNative: selector for: anEncoder on: aStream
	" Return the native code to emmit the receiver. "

	| call |
	call := anEncoder
		sourceToDirectCall: self selector
		with: self literal.
	^anEncoder sourceToTry: call """,nil)
smalltalk.bind(smalltalk.JSDirectiveNode.__class__,"code:protected:",0
,smalltalk.__f__("""(self,aCode,useTry):
	#JSDirectiveNode class>>#code:protected:
	def __blk1__(_s8_rec):
		_s8_rec.code_(aCode) 
		_s8_rec.protected_(useTry) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","JSDirectiveNode_class_code_protected_")
,"instantiation","""code: aCode protected: useTry
	" Return an instance of the receiver. "

	^self new
		code: aCode;
		protected: useTry;
		yourself""",nil)
smalltalk.bind(smalltalk.JSDirectiveNode,"code:",0
,smalltalk.__f__("""(self,aCode):
	#JSDirectiveNode>>#code:
	smalltalk.basic_at_put(self,"@code",aCode) 
	return self 
""","JSDirectiveNode_code_")
,"accessing","""code: aCode
	" Set the code of the receiver. "

	code := aCode""",nil)
smalltalk.bind(smalltalk.JSDirectiveNode,"nativeCodeFor:",0
,smalltalk.__f__("""(self,anEncoder):
	#JSDirectiveNode>>#nativeCodeFor:
	if smalltalk.b(getattr(self,"@code",nil).isString()):
		return getattr(self,"@code",nil) 
	 
	return getattr(self,"@code",nil).evaluateWith_(anEncoder) 
""","JSDirectiveNode_nativeCodeFor_")
,"accessing","""nativeCodeFor: anEncoder
	" Private - Return the native code of the receiver. "

	code isString ifTrue: [ ^code ].
	^code evaluateWith: anEncoder """,nil)
smalltalk.bind(smalltalk.JSDirectiveNode,"protected:",0
,smalltalk.__f__("""(self,aBoolean):
	#JSDirectiveNode>>#protected:
	smalltalk.basic_at_put(self,"@protected",aBoolean) 
	return self 
""","JSDirectiveNode_protected_")
,"accessing","""protected: aBoolean
	" Set the receiver to use try/catch to handle failure. "

	protected := aBoolean""",nil)
smalltalk.bind(smalltalk.JSDirectiveNode,"asNative:for:on:",0
,smalltalk.__f__("""(self,selector,anEncoder,aStream):
	#JSDirectiveNode>>#asNative:for:on:
	__0__=smalltalk.newContext()
	__0__.string=nil
	__0__.string=self.nativeCodeFor_(anEncoder) 
	if smalltalk.b(smalltalk.b_(getattr(self,"@protected",nil) is smalltalk.true)):
		return anEncoder.sourceToTry_(__0__.string) 
	 
	return __0__.string 
""","JSDirectiveNode_asNative_for_on_")
,"code generation","""asNative: selector for: anEncoder on: aStream
	" Return the native code to emmit the receiver. "

	| string |
	string := self nativeCodeFor: anEncoder.
	protected == true ifTrue: [
		^anEncoder sourceToTry: string
	].
	^string """,nil)
smalltalk.bind(smalltalk.InlineOptimizationNode,"args",0
,smalltalk.__f__("""(self):
	#InlineOptimizationNode>>#args
	return getattr(self,"@args",nil) 
""","InlineOptimizationNode_args")
,"accessing","""args
	" Return the args of the receiver. "

	^args""",nil)
smalltalk.bind(smalltalk.InlineOptimizationNode,"args:",0
,smalltalk.__f__("""(self,anObject):
	#InlineOptimizationNode>>#args:
	smalltalk.basic_at_put(self,"@args",anObject) 
	return self 
""","InlineOptimizationNode_args_")
,"accessing","""args: anObject
	" Set the args of the receiver. "

	args := anObject""",nil)
smalltalk.bind(smalltalk.InlineOptimizationNode,"remove",0
,smalltalk.__f__("""(self):
	#InlineOptimizationNode>>#remove
	return getattr(self,"@remove",nil) 
""","InlineOptimizationNode_remove")
,"accessing","""remove
	" Return the remove of the receiver. "

	^remove""",nil)
smalltalk.bind(smalltalk.InlineOptimizationNode,"remove:",0
,smalltalk.__f__("""(self,anObject):
	#InlineOptimizationNode>>#remove:
	smalltalk.basic_at_put(self,"@remove",anObject) 
	return self 
""","InlineOptimizationNode_remove_")
,"accessing","""remove: anObject
	" Set the remove of the receiver. "

	remove := anObject""",nil)
smalltalk.bind(smalltalk.InlineOptimizationNode,"asNative:for:on:",0
,smalltalk.__f__("""(self,selector,anEncoder,aStream):
	#InlineOptimizationNode>>#asNative:for:on:
	if smalltalk.b(self.remove()):
		anEncoder.removeOptimizations_(getattr(self,"@args",nil)) 
	else:
		anEncoder.addOptimizations_(getattr(self,"@args",nil)) 
	 
	return nil 
""","InlineOptimizationNode_asNative_for_on_")
,"code generation","""asNative: selector for: anEncoder on: aStream
	" Return the native code to emmit the receiver. "

	self remove
		ifTrue: [ anEncoder removeOptimizations: args ]
		ifFalse: [ anEncoder addOptimizations: args ].
	^nil """,nil)
smalltalk.bind(smalltalk.PPFailure.__class__,"reason:at:",0
,smalltalk.__f__("""(self,aString,anInteger):
	#PPFailure class>>#reason:at:
	return self.new().reason_at_(aString,anInteger) 
""","PPFailure_class_reason_at_")
,"instantiation","""reason: aString at: anInteger
	" Return an instance of the receiver. "

	^self new reason: aString at: anInteger""",nil)
smalltalk.bind(smalltalk.PPFailure,"position",0
,smalltalk.__f__("""(self):
	#PPFailure>>#position
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@position",nil))):
		return smalltalk.Number(0) 
	 
	return getattr(self,"@position",nil) 
""","PPFailure_position")
,"accessing","""position
	" Return the position of the receiver. "

	position isNil ifTrue: [ ^0 ].
	^position""",nil)
smalltalk.bind(smalltalk.PPFailure,"position:",0
,smalltalk.__f__("""(self,aNumber):
	#PPFailure>>#position:
	smalltalk.basic_at_put(self,"@position",aNumber) 
	return self 
""","PPFailure_position_")
,"accessing","""position: aNumber
	" Set the position of the receiver. "

	position := aNumber""",nil)
smalltalk.bind(smalltalk.PPFailure,"toString",0
,smalltalk.__f__("""(self):
	#PPFailure>>#toString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Failure "),smalltalk.printString_(self.reason())),smalltalk.String("(@")),self.position()),smalltalk.String(")")) 
""","PPFailure_toString")
,"printing","""toString
	" Return the receiver converted to String. "

	^'Failure ',self reason printString ,'(@',self position,')'""",nil)
smalltalk.bind(smalltalk.PPFailure,"reason",0
,smalltalk.__f__("""(self):
	#PPFailure>>#reason
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@reason",nil))):
		return smalltalk.String.new() 
	 
	return getattr(self,"@reason",nil) 
""","PPFailure_reason")
,"accessing","""reason
	" Return the reason of the receiver. "

	reason isNil ifTrue: [ ^String new ].
	^reason""",nil)
smalltalk.bind(smalltalk.PPFailure,"reason:",0
,smalltalk.__f__("""(self,aString):
	#PPFailure>>#reason:
	smalltalk.basic_at_put(self,"@reason",smalltalk.object_comma_(smalltalk.String(""),aString)) 
	return self 
""","PPFailure_reason_")
,"accessing","""reason: aString
	" Set the reason of the receiver. "

	reason := '' ,aString""",nil)
smalltalk.bind(smalltalk.PPFailure,"reason:at:",0
,smalltalk.__f__("""(self,aString,anInteger):
	#PPFailure>>#reason:at:
	def __blk1__(_s8_rec):
		_s8_rec.reason_(aString) 
		return _s8_rec.position_(anInteger) 
	__blk1__(self) 
	return self 
""","PPFailure_reason_at_")
,"accessing","""reason: aString at: anInteger
	" Set the reason and position of the receiver. "

	self
		reason: aString; 
		position: anInteger""",nil)
smalltalk.bind(smalltalk.PPFailure,"isParseFailure",0
,smalltalk.__f__("""(self):
	#PPFailure>>#isParseFailure
	return smalltalk.true 
""","PPFailure_isParseFailure")
,"testing","""isParseFailure
	" Return true if the receiver is a parse failure. "

	^true""",nil)
smalltalk.bind(smalltalk.PPFailure,"accept:",0
,smalltalk.__f__("""(self,anEncoder):
	#PPFailure>>#accept:
	__0__=smalltalk.newContext()
	__0__.description=nil
	__0__.description=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("PPFailure: "),self.reason()),smalltalk.String(" at: ")),smalltalk.asString_(self.position())),smalltalk.String(" source: ")),anEncoder.stream().contents()) 
	self.print_(__0__.description) 
	self.error_(__0__.description) 
	return self 
""","PPFailure_accept_")
,"bug","""accept: anEncoder
	" Report compilation failure and error. "

	| description |
	description := 'PPFailure: ', self reason
		,' at: ' ,self position asString
		,' source: ' ,anEncoder stream contents.
	self print: description.
	self error: description""",nil)
smalltalk.bind(smalltalk.PPFailure,"__tostring",0
,smalltalk.__f__("""(self):
	#PPFailure>>#__tostring
	return smalltalk.to_String(self) 
""","PPFailure___tostring")
,"Python-printing","""__tostring
	" Return the printable representation of the receiver. "

	^self toString""",nil)
smalltalk.bind(smalltalk.PPParser.__class__,",","_comma"
,smalltalk.__f__("""(self,anObject):
	#PPParser class>>#,
	return anObject.asParser() 
""","PPParser_class__comma")
,"instantiation",""", anObject
	" Return the receiver composed with the argument. "

	^anObject asParser""",nil)
smalltalk.bind(smalltalk.PPParser.__class__,"optional:",0
,smalltalk.__f__("""(self,anObject):
	#PPParser class>>#optional:
	return smalltalk.object_comma_(self,anObject).optional() 
""","PPParser_class_optional_")
,"instantiation","""optional: anObject
	" Return an instance of the receiver to parse an optional element anObject. "

	^(self ,anObject) optional""",nil)
smalltalk.bind(smalltalk.PPParser.__class__,"debug:or:",0
,smalltalk.__f__("""(self,action,aBlock):
	#PPParser class>>#debug:or:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.result=aBlock.evaluate() 
		return smalltalk.false 
	__0__.show=nil
	__0__.result=nil
	__0__.show=smalltalk.basic_at_ifAbsent_(smalltalk.PPParser,smalltalk.String("debugOn"),smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.show,smalltalk.true)):
		__0__.result=action.evaluate() 
	 
	return __0__.result 
""","PPParser_class_debug_or_")
,"debug","""debug: action or: aBlock
	" Log evaluation of action if in debugging mode,
	 else returns the result of evaluation of aBlock.
	"

	| show result |
	show := PPParser basicAt: #debugOn ifAbsent:[ result := aBlock evaluate. false ].
	show = true ifTrue: [ result := action evaluate ].
	^result""",nil)
smalltalk.bind(smalltalk.PPParser.__class__,"debugWhile:",0
,smalltalk.__f__("""(self,aBlock):
	#PPParser class>>#debugWhile:
	def __blk1__():
		smalltalk.basic_at_put_(smalltalk.PPParser,smalltalk.String("debugOn"),smalltalk.true) 
		return aBlock.evaluate() 
	def __blk2__():
		return smalltalk.basic_at_put_(smalltalk.PPParser,smalltalk.String("debugOn"),smalltalk.false) 
	return smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
""","PPParser_class_debugWhile_")
,"debug","""debugWhile: aBlock
	^[	PPParser basicAt: #debugOn put: true.
		aBlock evaluate
	] ensure: [
		PPParser basicAt: #debugOn put: false
	]""",nil)
smalltalk.bind(smalltalk.PPParser,"set:start:end:",0
,smalltalk.__f__("""(self,anElement,start,end):
	#PPParser>>#set:start:end:
	if smalltalk.b(smalltalk.responds_to_(anElement,(smalltalk.String("start:end:")))):
		anElement.start_end_(start,end) 
	 
	return self 
""","PPParser_set_start_end_")
,"private","""set: anElement start: start end: end
	" Private - Set start&end source offest of anElement. "

	(anElement respondsTo: #start:end:) ifTrue: [
		anElement start: start end: end
	]""",nil)
smalltalk.bind(smalltalk.PPParser,"flatten",0
,smalltalk.__f__("""(self):
	#PPParser>>#flatten
	return smalltalk.PPFlattenParser.on_(self) 
""","PPParser_flatten")
,"operations","""flatten
	" Return a flattened version of the receiver. "

	^PPFlattenParser on: self""",nil)
smalltalk.bind(smalltalk.PPParser,"withSource",0
,smalltalk.__f__("""(self):
	#PPParser>>#withSource
	return smalltalk.PPSourceParser.on_(self) 
""","PPParser_withSource")
,"operations","""withSource
	" Return a source parser on the receiver. "

	^PPSourceParser on: self""",nil)
smalltalk.bind(smalltalk.PPParser,"==>","_eq_eq_gt"
,smalltalk.__f__("""(self,aBlock):
	#PPParser>>#==>
	return smalltalk.PPActionParser.on_block_(self,aBlock) 
""","PPParser__eq_eq_gt")
,"operations","""==> aBlock
	" Return an action parser on the receiver. "

	^PPActionParser on: self block: aBlock""",nil)
smalltalk.bind(smalltalk.PPParser,",","_comma"
,smalltalk.__f__("""(self,aParser):
	#PPParser>>#,
	return smalltalk.PPSequenceParser.with_with_(self,aParser) 
""","PPParser__comma")
,"operations",""", aParser
	" Return the receiver composed with the argument. "

	^PPSequenceParser with: self with: aParser""",nil)
smalltalk.bind(smalltalk.PPParser,"/","_slash"
,smalltalk.__f__("""(self,aParser):
	#PPParser>>#/
	return smalltalk.PPChoiceParser.with_with_(self,aParser) 
""","PPParser__slash")
,"operations","""/ aParser
	" Return a choice composite version of the receiver and aParser. "

	^PPChoiceParser with: self with: aParser""",nil)
smalltalk.bind(smalltalk.PPParser,"@","_at"
,smalltalk.__f__("""(self,tag):
	#PPParser>>#@
	def __blk1__(node):
		self.note_(smalltalk.object_comma_(smalltalk.object_comma_(tag,smalltalk.String("==>")),smalltalk.printString_(node))) 
		return node 
	smalltalk.basic_at_put_(self,smalltalk.String("debugTag"),tag) 
	return self._eq_eq_gt(smalltalk.blk(__blk1__,1)) 
""","PPParser__at")
,"debug","""@ tag
	" DEBUG - Return a notification wrapper of the receiver. "

	self basicAt: #debugTag put: tag.
	^self ==> [:node| self note: tag ,'==>',node printString. node ]""",nil)
smalltalk.bind(smalltalk.PPParser,"@@","_at_at"
,smalltalk.__f__("""(self,tag):
	#PPParser>>#@@
	smalltalk.basic_at_put_(self,smalltalk.String("debugTag"),tag) 
	return self 
""","PPParser__at_at")
,"debug","""@@ tag
	" DEBUG - Tag the receiver for debugging. "

	self basicAt: #debugTag put: tag""",nil)
smalltalk.bind(smalltalk.PPParser,"plus",0
,smalltalk.__f__("""(self):
	#PPParser>>#plus
	return smalltalk.PPRepeatingParser.on_min_(self,smalltalk.Number(1))._at_at(smalltalk.String("plus")) 
""","PPParser_plus")
,"operations","""plus
	" Return an iterative version of the receiver. "

	^(PPRepeatingParser on: self min: 1) @@#plus""",nil)
smalltalk.bind(smalltalk.PPParser,"star",0
,smalltalk.__f__("""(self):
	#PPParser>>#star
	return smalltalk.PPRepeatingParser.on_min_(self,smalltalk.Number(0))._at_at(smalltalk.String("star")) 
""","PPParser_star")
,"operations","""star
	" Return an iterative version of the receiver. "

	^(PPRepeatingParser on: self min: 0) @@#star""",nil)
smalltalk.bind(smalltalk.PPParser,"not","_8not"
,smalltalk.__f__("""(self):
	#PPParser>>#not
	return smalltalk.PPNotParser.on_(self)._at_at(smalltalk.String("not")) 
""","PPParser__8not")
,"operations","""not
	" Return the negation of the receiver. "

	^(PPNotParser on: self) @@#not""",nil)
smalltalk.bind(smalltalk.PPParser,"optional",0
,smalltalk.__f__("""(self):
	#PPParser>>#optional
	return self._slash(smalltalk.PPEpsilonParser.new())._at_at(smalltalk.String("opt")) 
""","PPParser_optional")
,"operations","""optional
	" Return an optional version of the receiver. "

	^self / PPEpsilonParser new @@#opt""",nil)
smalltalk.bind(smalltalk.PPParser,"isParseFailure:",0
,smalltalk.__f__("""(self,what):
	#PPParser>>#isParseFailure:
	return what.isParseFailure() 
""","PPParser_isParseFailure_")
,"test","""isParseFailure: what
	" Private - Return true if what is a parsing failure. "

	^what isParseFailure""",nil)
smalltalk.bind(smalltalk.PPParser,"valueToMemoize:start:",0
,smalltalk.__f__("""(self,aStream,start):
	#PPParser>>#valueToMemoize:start:
	__0__=smalltalk.newContext()
	__0__.end=nil
	__0__.node=nil
	__0__.node=self.parse_(aStream) 
	__0__.end=aStream.position() 
	self.set_start_end_(__0__.node,start,__0__.end) 
	return smalltalk.Array.with_with_(__0__.node,__0__.end) 
""","PPParser_valueToMemoize_start_")
,"memo","""valueToMemoize: aStream start: start
	" Private - Return the value to memoize as result of parsing en element in aStream. "

	| end node |
	node := self parse: aStream.
	end := aStream position.
	self set: node start: start end: end.
	^Array with: node with: end""",nil)
smalltalk.bind(smalltalk.PPParser,"memoizedParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPParser>>#memoizedParse:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.valueToMemoize_start_(aStream,__0__.start) 
	__0__.start=nil
	__0__.value=nil
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@memo",nil))):
		smalltalk.basic_at_put(self,"@memo",smalltalk.PoolDictionary.new()) 
	 
	__0__.start=aStream.position() 
	__0__.value=getattr(self,"@memo",nil).at_ifAbsentPut_(__0__.start,smalltalk.blk(__blk1__,0)) 
	aStream.position_(__0__.value.second()) 
	return __0__.value.first() 
""","PPParser_memoizedParse_")
,"memo","""memoizedParse: aStream
	" Private - Evaluate the receiver. "

	| start value |
	memo isNil ifTrue: [ memo := PoolDictionary new ].
	start := aStream position.
	value := memo at: start ifAbsentPut: [
		self valueToMemoize: aStream start: start
	].
	aStream position: value second.
	^value first""",nil)
smalltalk.bind(smalltalk.PPParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPParser>>#basicParse:
	self.subclassResponsibility_(smalltalk.String("basicParse:")) 
	return self 
""","PPParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	self subclassResponsibility: #basicParse:""",nil)
smalltalk.bind(smalltalk.PPParser,"parseLog:",0
,smalltalk.__f__("""(self,aStream):
	#PPParser>>#parseLog:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.old=nil
	__0__.old=aStream.position() 
	__0__.result=self.basicParse_(aStream) 
	if not smalltalk.b(self.isParseFailure_(__0__.result)):
		self.note_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),__0__.old),smalltalk.String("-")),aStream.position()),smalltalk.String("] ")),smalltalk.printString_(self))) 
	 
	return __0__.result 
""","PPParser_parseLog_")
,"parsing","""parseLog: aStream
	" Parse contents in aStream. "

	| result old |
	old := aStream position.
	result := self basicParse: aStream.
	(self isParseFailure: result) ifFalse: [
		self note: $[ ,old ,$- ,aStream position ,'] ' ,self printString
	].
	^result""",nil)
smalltalk.bind(smalltalk.PPParser,"parse:",0
,smalltalk.__f__("""(self,aStream):
	#PPParser>>#parse:
	return self.basicParse_(aStream) 
""","PPParser_parse_")
,"parsing","""parse: aStream
	" Parse contents in aStream. "

	^"PPParser
		debug: [self parseLog: aStream]
		or: ["self basicParse: aStream"]\"""",nil)
smalltalk.bind(smalltalk.PPParser,"parseAll:",0
,smalltalk.__f__("""(self,aStream):
	#PPParser>>#parseAll:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.error_(__0__.result.messageFor_(aStream.contents())) 
	def __blk2__():
		return __0__.result.first() 
	__0__.result=nil
	__0__.result=smalltalk.PPSequenceParser.with_with_(self,smalltalk.PPEOFParser.new()).memoizedParse_(aStream) 
	return smalltalk.if_true_false_(self.isParseFailure_(__0__.result),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","PPParser_parseAll_")
,"parsing","""parseAll: aStream
	" Parse contents in aStream. "

	| result |
	result := (PPSequenceParser
		with: self with: PPEOFParser new)
		memoizedParse: aStream.
	^(self isParseFailure: result)
	    ifTrue: [ self error: (result messageFor: aStream contents) ]
	    ifFalse: [ result first ]""",nil)
smalltalk.bind(smalltalk.PPParser,"asParser",0
,smalltalk.__f__("""(self):
	#PPParser>>#asParser
	return self 
""","PPParser_asParser")
,"converting","""asParser
	" Return a parser on the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.PPParser,"printStringDetail",0
,smalltalk.__f__("""(self):
	#PPParser>>#printStringDetail
	return smalltalk.String("") 
""","PPParser_printStringDetail")
,"printing","""printStringDetail
	" Private - Return a printable detail of the receiver. "

	^''""",nil)
smalltalk.bind(smalltalk.PPParser,"printString",0
,smalltalk.__f__("""(self):
	#PPParser>>#printString
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.printStringDetail() 
	def __blk2__():
		return smalltalk.object_comma_(smalltalk.String("@@"),__0__.tag) 
	__0__.tag=nil
	__0__.tag=smalltalk.basic_at_(self,smalltalk.String("debugTag")) 
	if smalltalk.b(smalltalk.notNil_(__0__.tag)):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("@@"),__0__.tag),smalltalk.String("@@")) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("a"),(self).__class__.name()),smalltalk.if_true_false_(smalltalk.isNil_(__0__.tag),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","PPParser_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	| tag |
	tag := self basicAt: #debugTag.
	tag notNil ifTrue: [ ^#@@ ,tag ,#@@ ]. "compact notation"

	^#a ,self class name ,(tag isNil
		ifTrue: [ self printStringDetail ]
		ifFalse: [ '@@',tag ])""",nil)
smalltalk.bind(smalltalk.PPEOFParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPEOFParser>>#basicParse:
	if smalltalk.b(aStream.atEnd()):
		return nil 
	 
	return smalltalk.PPFailure.reason_at_(smalltalk.String("EOF expected (or invalid character in input)"),aStream.position()) 
""","PPEOFParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	aStream atEnd ifTrue: [ ^nil ] .
	^PPFailure reason: 'EOF expected (or invalid character in input)' at: aStream position""",nil)
smalltalk.bind(smalltalk.PPAnyParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPAnyParser>>#basicParse:
	if not smalltalk.b(aStream.atEnd()):
		return aStream.next() 
	 
	return smalltalk.PPFailure.reason_at_(smalltalk.String("End of stream"),aStream.position()) 
""","PPAnyParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	aStream atEnd ifFalse: [ ^aStream next ].
	^PPFailure reason: 'End of stream' at: aStream position""",nil)
smalltalk.bind(smalltalk.PPEpsilonParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPEpsilonParser>>#basicParse:
	return nil 
""","PPEpsilonParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	^nil""",nil)
smalltalk.bind(smalltalk.PPStringParser,"string",0
,smalltalk.__f__("""(self):
	#PPStringParser>>#string
	return getattr(self,"@string",nil) 
""","PPStringParser_string")
,"accessing","""string
	" Return the string of the receiver. "

	^string""",nil)
smalltalk.bind(smalltalk.PPStringParser,"string:",0
,smalltalk.__f__("""(self,aString):
	#PPStringParser>>#string:
	smalltalk.basic_at_put(self,"@string",aString) 
	return self 
""","PPStringParser_string_")
,"accessing","""string: aString
	" Set the string of the receiver. "

	string := aString""",nil)
smalltalk.bind(smalltalk.PPStringParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPStringParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.back=nil
	__0__.reason=nil
	if smalltalk.b(getattr(self,"@string",nil).isEmpty()):
		return getattr(self,"@string",nil) 
	 
	__0__.back=aStream.position() 
	if smalltalk.b(aStream.peekForAll_(getattr(self,"@string",nil))):
		return getattr(self,"@string",nil) 
	 
	__0__.reason=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Expecting "),smalltalk.printString_(getattr(self,"@string",nil))),smalltalk.String(" at ")),smalltalk.printString_(__0__.back)),smalltalk.String(" read ")),smalltalk.printString_(aStream.next_(getattr(self,"@string",nil).size()))) 
	aStream.position_(__0__.back) 
	return smalltalk.PPFailure.reason_at_(__0__.reason,__0__.back) 
""","PPStringParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| back reason |
	string isEmpty ifTrue: [ ^string ].
	back := aStream position.
	(aStream peekForAll: string) ifTrue: [ ^string ].
	reason := 'Expecting ', string printString
		,' at ',back printString
		,' read ',(aStream next: string size) printString.
	aStream position: back.
	^PPFailure reason: reason at: back""",nil)
smalltalk.bind(smalltalk.PPStringParser,"printStringDetail",0
,smalltalk.__f__("""(self):
	#PPStringParser>>#printStringDetail
	return smalltalk.printString_(getattr(self,"@string",nil)) 
""","PPStringParser_printStringDetail")
,"printing","""printStringDetail
	" Private - Return a printable detail of the receiver. "

	^string printString""",nil)
smalltalk.bind(smalltalk.PPStStringParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	_s8Ret_=smalltalk.newContext()
	try:
		#PPStStringParser>>#basicParse:
		__0__=smalltalk.newContext()
		def __blk1__():
			__0__.result=smalltalk.object_comma_(__0__.result,aStream.upTo_(smalltalk.String("'"))) 
			return aStream.atEnd() 
		__0__.position=nil
		__0__.result=nil
		__0__.position=aStream.position() 
		__0__.result=smalltalk.String("") 
		while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
			if not smalltalk.b(smalltalk.isObject_equalTo_(aStream.peek(),smalltalk.String("'"))):
				return __0__.result 
			 
			__0__.result=smalltalk.object_comma_(__0__.result,aStream.next()) 
		 
		if smalltalk.b(aStream.position()._gt(__0__.position)):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,__0__.result) 
			aStream.position_(aStream.position()._minus(smalltalk.Number(1))) 
			smalltalk.if_true_false_(smalltalk.isObject_equalTo_(aStream.next(),smalltalk.String("'")),smalltalk.blk(__blk2__,0),nil) 
		 
		aStream.position_(__0__.position) 
		smalltalk.raise_result_(_s8Ret_,smalltalk.PPFailure.reason_at_(smalltalk.String("Unfinished String"),__0__.position)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PPStStringParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| position result |
	position := aStream position.
	result := ''.
	[ result := result , (aStream upTo: $').
	  aStream atEnd ] whileFalse: [
		aStream peek = $' ifFalse: [ ^result ].
		result := result ,aStream next.
	].
	aStream position > position ifTrue: [
		aStream position: aStream position - 1.
		aStream next = $' ifTrue: [ ^result ].
	].
	aStream position: position.
	^PPFailure reason: 'Unfinished String' at: position""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"separator",0
,smalltalk.__f__("""(self):
	#PPCharacterParser class>>#separator
	return self.new().separator() 
""","PPCharacterParser_class_separator")
,"constants","""separator
	" Return the parser for separator. "

	^self new separator""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"inOBSOLETE:",0
,smalltalk.__f__("""(self,aCollection):
	#PPCharacterParser class>>#inOBSOLETE:
	def __blk1__(c):
		return aCollection.includes_(c) 
	return self.for_doing_(smalltalk.asString_(aCollection),smalltalk.blk(__blk1__,1)) 
""","PPCharacterParser_class_inOBSOLETE_")
,"constants","""inOBSOLETE: aCollection
	" Return the parser for input matching any element in aCollection. "

	^self	for: aCollection asString
		doing: [:c| aCollection includes: c ]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"in:",0
,smalltalk.__f__("""(self,aCollection):
	#PPCharacterParser class>>#in:
	__0__=smalltalk.newContext()
	def __blk1__(c):
		return aCollection.includes_(c) 
	__0__.tag=nil
	__0__.tag=smalltalk.asString_(aCollection) 
	if smalltalk.b(smalltalk.isObject_equalTo_(aCollection.size(),smalltalk.Number(1))):
		def __blk2__(c):
			return smalltalk.isObject_equalTo_(__0__.tag,c) 
		__0__.tag=aCollection.first() 
		return self.for_doing_(smalltalk.asString_(__0__.tag),smalltalk.blk(__blk2__,1)) 
	 
	return self.for_doing_(__0__.tag,smalltalk.blk(__blk1__,1)) 
""","PPCharacterParser_class_in_")
,"constants","""in: aCollection
	" Return the parser for input matching any element in aCollection. "

	| tag |
	tag := aCollection asString.
	aCollection size = 1 ifTrue: [
		tag := aCollection first.
		^self for: tag asString doing: [:c| tag = c ]
	].
	^self for: tag doing: [:c| aCollection includes: c ]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"notIn:",0
,smalltalk.__f__("""(self,aCollection):
	#PPCharacterParser class>>#notIn:
	__0__=smalltalk.newContext()
	def __blk1__(c):
		return smalltalk.booleanNot_(aCollection.includes_(c)) 
	__0__.tag=nil
	__0__.tag=smalltalk.asString_(aCollection) 
	if smalltalk.b(smalltalk.isObject_equalTo_(aCollection.size(),smalltalk.Number(1))):
		def __blk2__(c):
			return smalltalk.isObject_equalTo_(__0__.tag,c)._8not() 
		__0__.tag=aCollection.first() 
		return self.for_doing_(smalltalk.asString_(__0__.tag),smalltalk.blk(__blk2__,1)) 
	 
	return self.for_doing_(__0__.tag,smalltalk.blk(__blk1__,1)) 
""","PPCharacterParser_class_notIn_")
,"constants","""notIn: aCollection
	" Return the parser for input matching any element in aCollection. "

	| tag |
	tag := aCollection asString.
	aCollection size = 1 ifTrue: [
		tag := aCollection first.
		^self for: tag asString doing: [:c| tag ~= c ]
	].
	^self for: tag doing: [:c| (aCollection includes: c) not ]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"between:and:",0
,smalltalk.__f__("""(self,start,end):
	#PPCharacterParser class>>#between:and:
	def __blk1__(c):
		return c.between_and_(start,end) 
	return self.for_doing_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(""),start),smalltalk.String("-")),end),smalltalk.blk(__blk1__,1)) 
""","PPCharacterParser_class_between_and_")
,"constants","""between: start and: end
	" Return the parser for input between start and end. "

	^self	for: '',start,'-',end
		doing: [:c| c between: start and: end ]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"for:doing:",0
,smalltalk.__f__("""(self,label,aBlock):
	#PPCharacterParser class>>#for:doing:
	return self.new().do_for_(aBlock,label) 
""","PPCharacterParser_class_for_doing_")
,"constants","""for: label doing: aBlock
	" Return a parser that evaluates aBlock to match label. "

	^self new do: aBlock for: label""",nil)
smalltalk.bind(smalltalk.PPCharacterParser.__class__,"regExpCache",0
,smalltalk.__f__("""(self):
	#PPCharacterParser class>>#regExpCache
	if smalltalk.b(smalltalk.isNil_(smalltalk.PPCharacterParser.classVariableAt_("RegExpCache"))):
		smalltalk.PPCharacterParser.classVariableAt_put_("RegExpCache",smalltalk.PoolDictionary.new()) 
	 
	return smalltalk.PPCharacterParser.classVariableAt_("RegExpCache") 
""","PPCharacterParser_class_regExpCache")
,"constants","""regExpCache
	" Private - Return the regexp cache. "

	RegExpCache isNil ifTrue: [
		RegExpCache := PoolDictionary new
	].
	^RegExpCache""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"do:for:",0
,smalltalk.__f__("""(self,aBlock,aString):
	#PPCharacterParser>>#do:for:
	smalltalk.basic_at_put(self,"@theString",aString) 
	smalltalk.basic_at_put(self,"@regexp",aBlock) 
	return self 
""","PPCharacterParser_do_for_")
,"accessing","""do: aBlock for: aString
	" Set the receiver to match aString using aBlock. "

	theString := aString.
	regexp := aBlock""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"string:",0
,smalltalk.__f__("""(self,aString):
	#PPCharacterParser>>#string:
	def __blk1__():
		return smalltalk.RegularExpression.fromString_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),aString),smalltalk.String("]"))) 
	smalltalk.basic_at_put(self,"@theString",aString) 
	smalltalk.basic_at_put(self,"@regexp",(self).__class__.regExpCache().at_ifAbsentPut_(aString,smalltalk.blk(__blk1__,0))) 
	return self 
""","PPCharacterParser_string_")
,"accessing","""string: aString
	" Set the string of the receiver. "

	theString := aString.
	regexp := self class regExpCache at: aString ifAbsentPut: [
		RegularExpression fromString: '[', aString, ']'
	]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"match:",0
,smalltalk.__f__("""(self,aString):
	#PPCharacterParser>>#match:
	if smalltalk.b(smalltalk.isNil_(aString)):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@regexp",nil))):
		return aString.isSeparator() 
	 
	if smalltalk.b(getattr(self,"@regexp",nil).isValuable()):
		return getattr(self,"@regexp",nil).value_(aString) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(getattr(self,"@theString",nil),aString)):
		return smalltalk.true 
	 
	return aString.match_(getattr(self,"@regexp",nil)) 
""","PPCharacterParser_match_")
,"private","""match: aString
	" Private - Match the receiver to string. "

	aString isNil ifTrue: [ ^false ].
	regexp isNil ifTrue: [ ^aString isSeparator ].
	regexp isValuable ifTrue: [ ^regexp value: aString ].
	theString = aString ifTrue: [ ^true ].
	^aString match: regexp""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"matchFailureReason",0
,smalltalk.__f__("""(self):
	#PPCharacterParser>>#matchFailureReason
	def __blk1__():
		return smalltalk.String("separator") 
	def __blk2__():
		return smalltalk.printString_(getattr(self,"@theString",nil)) 
	return smalltalk.object_comma_(smalltalk.String("Could not match "),smalltalk.if_true_false_(smalltalk.isNil_(getattr(self,"@theString",nil)),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0))) 
""","PPCharacterParser_matchFailureReason")
,"accessing","""matchFailureReason
	" Private - Return the reason for mismatch. "

	^'Could not match ' ,(theString isNil
		ifTrue: [#separator]
		ifFalse: [theString printString])""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPCharacterParser>>#basicParse:
	def __blk1__():
		return aStream.next() 
	def __blk2__():
		return smalltalk.PPFailure.reason_at_(self.matchFailureReason(),aStream.position()) 
	return smalltalk.if_true_false_(self.match_(aStream.peek()),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","PPCharacterParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	^(self match: aStream peek)
	 ifTrue:  [ aStream next ]
	 ifFalse: [ PPFailure
		reason: self matchFailureReason
		at: aStream position
	]""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"separator",0
,smalltalk.__f__("""(self):
	#PPCharacterParser>>#separator
	smalltalk.basic_at_put(self,"@theString",smalltalk.basic_at_put(self,"@regexp",nil)) 
	self._at_at(smalltalk.String("separator")) 
	return self 
""","PPCharacterParser_separator")
,"separator","""separator
	" Set the receiver to parse separator. "

	theString := regexp := nil.
	self @@#separator""",nil)
smalltalk.bind(smalltalk.PPCharacterParser,"printStringDetail",0
,smalltalk.__f__("""(self):
	#PPCharacterParser>>#printStringDetail
	if smalltalk.b(getattr(self,"@theString",nil).isCharacter()):
		if smalltalk.b(getattr(self,"@theString",nil).between_and_(smalltalk.String("0"),smalltalk.String("z"))):
			return smalltalk.object_comma_(smalltalk.String("$"),getattr(self,"@theString",nil)) 
		 
		return smalltalk.object_comma_(smalltalk.String("#"),getattr(self,"@theString",nil).asciiValue()) 
	 
	return smalltalk.printString_(getattr(self,"@theString",nil)) 
""","PPCharacterParser_printStringDetail")
,"printing","""printStringDetail
	" Private - Return a printable detail of the receiver. "

	theString isCharacter ifTrue: [
		(theString between: $0 and: $z) ifTrue: [
			^$$ ,theString
		].
		^$# ,theString asciiValue
	].
	^theString printString""",nil)
smalltalk.bind(smalltalk.PPListParser.__class__,"withAll:",0
,smalltalk.__f__("""(self,aCollection):
	#PPListParser class>>#withAll:
	def __blk1__(_s8_rec):
		_s8_rec.parsers_(aCollection) 
		return _s8_rec.yourself() 
	return __blk1__(self.basicNew()) 
""","PPListParser_class_withAll_")
,"instantiation","""withAll: aCollection
	" Return an instance of the receiver. "

	    ^self basicNew
		parsers: aCollection;
		yourself""",nil)
smalltalk.bind(smalltalk.PPListParser.__class__,"with:with:",0
,smalltalk.__f__("""(self,aParser,anotherParser):
	#PPListParser class>>#with:with:
	return self.withAll_(smalltalk.Array.with_with_(aParser,anotherParser)) 
""","PPListParser_class_with_with_")
,"instantiation","""with: aParser with: anotherParser
	" Return an instance of the receiver. "

	^self withAll: (Array with: aParser with: anotherParser)""",nil)
smalltalk.bind(smalltalk.PPListParser,"parsers",0
,smalltalk.__f__("""(self):
	#PPListParser>>#parsers
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@parsers",nil))):
		return smalltalk.newArray([]) 
	 
	return getattr(self,"@parsers",nil) 
""","PPListParser_parsers")
,"accessing","""parsers
	" Return the parsers of the receiver. "

	parsers isNil ifTrue: [ ^#() ].
	^parsers""",nil)
smalltalk.bind(smalltalk.PPListParser,"parsers:",0
,smalltalk.__f__("""(self,aCollection):
	#PPListParser>>#parsers:
	def __blk1__(each):
		return each.asParser() 
	smalltalk.basic_at_put(self,"@parsers",aCollection.collect_(smalltalk.blk(__blk1__,1))) 
	return self 
""","PPListParser_parsers_")
,"accessing","""parsers: aCollection
	" Set the parsers of the receiver. "

	parsers := aCollection collect: [:each| each asParser ]""",nil)
smalltalk.bind(smalltalk.PPListParser,"copyWith:",0
,smalltalk.__f__("""(self,aParser):
	#PPListParser>>#copyWith:
	return (self).__class__.withAll_(self.parsers().copyWith_(aParser)) 
""","PPListParser_copyWith_")
,"copying","""copyWith: aParser
	" Return a copy of the receiver with aParser. "

	^self class withAll: (self parsers copyWith: aParser)""",nil)
smalltalk.bind(smalltalk.PPListParser,"op",0
,smalltalk.__f__("""(self):
	#PPListParser>>#op
	return smalltalk.String("+") 
""","PPListParser_op")
,"printing","""op
	" Private - Return the operator of the receiver. "

	^$+""",nil)
smalltalk.bind(smalltalk.PPListParser,"printString",0
,smalltalk.__f__("""(self):
	#PPListParser>>#printString
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.stream.nextPutAll_(smalltalk.printString_(each)) 
	def __blk2__():
		return __0__.stream.nextPutAll_(self.op()) 
	__0__.stream=nil
	if smalltalk.b(smalltalk.notNil_(smalltalk.basic_at_(self,smalltalk.String("debugTag")))):
		return smalltalk.superReceiver(smalltalk.PPListParser,self).printString() 
	 
	__0__.stream=smalltalk.String("{").writeStream() 
	self.parsers().do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	return __0__.stream.contents() 
""","PPListParser_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	| stream |
	(self basicAt: #debugTag) notNil ifTrue: [ ^super printString ].
	stream := ${ writeStream.
	self parsers
		do: [:each| stream nextPutAll: each printString ]
		separatedBy: [stream nextPutAll: self op].
	^stream contents """,nil)
smalltalk.bind(smalltalk.PPSequenceParser,",","_comma"
,smalltalk.__f__("""(self,aRule):
	#PPSequenceParser>>#,
	return self.copyWith_(aRule) 
""","PPSequenceParser__comma")
,"copying",""", aRule
	" Return the receiver composed with the argument. "

	^self copyWith: aRule""",nil)
smalltalk.bind(smalltalk.PPSequenceParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	_s8Ret_=smalltalk.newContext()
	try:
		#PPSequenceParser>>#basicParse:
		__0__=smalltalk.newContext()
		def __blk1__(each):
			def __blk2__():
				aStream.position_(__0__.start) 
				return smalltalk.raise_result_(_s8Ret_,__0__.element) 
			__0__.element=each.memoizedParse_(aStream) 
			__0__.result.add_(__0__.element) 
			return smalltalk.if_true_false_(self.isParseFailure_(__0__.element),smalltalk.blk(__blk2__,0),nil) 
		__0__.start=nil
		__0__.result=nil
		__0__.element=nil
		__0__.result=smalltalk.newArray([]) 
		__0__.start=aStream.position() 
		self.parsers().do_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,__0__.result) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","PPSequenceParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| start result element |
	result := #().
	start := aStream position.
	self parsers do: [:each |
		element := each memoizedParse: aStream.
		result add: element.
		(self isParseFailure: element) ifTrue: [
			aStream position: start.
			^element
		]
	].
	^result""",nil)
smalltalk.bind(smalltalk.PPSequenceParser,"op",0
,smalltalk.__f__("""(self):
	#PPSequenceParser>>#op
	return smalltalk.String(",") 
""","PPSequenceParser_op")
,"printing","""op
	" Private - Return the operator of the receiver. "

	^$,""",nil)
smalltalk.bind(smalltalk.PPChoiceParser,"/","_slash"
,smalltalk.__f__("""(self,aRule):
	#PPChoiceParser>>#/
	return self.copyWith_(aRule) 
""","PPChoiceParser__slash")
,"copying","""/ aRule
	" Return the receiver composed with aRule. "

	^self copyWith: aRule""",nil)
smalltalk.bind(smalltalk.PPChoiceParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPChoiceParser>>#basicParse:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		__0__.result=each.memoizedParse_(aStream) 
		return smalltalk.booleanNot_(self.isParseFailure_(__0__.result)) 
	def __blk2__():
		nil 
	__0__.result=nil
	self.parsers().detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	return __0__.result 
""","PPChoiceParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| result |
	self parsers detect: [:each |
		result := each memoizedParse: aStream.
		(self isParseFailure: result) not
	] ifNone: [].
	^result""",nil)
smalltalk.bind(smalltalk.PPChoiceParser,"op",0
,smalltalk.__f__("""(self):
	#PPChoiceParser>>#op
	return smalltalk.String("/") 
""","PPChoiceParser_op")
,"printing","""op
	" Private - Return the operator of the receiver. "

	^$/""",nil)
smalltalk.bind(smalltalk.PPDelegateParser.__class__,"on:",0
,smalltalk.__f__("""(self,aParser):
	#PPDelegateParser class>>#on:
	def __blk1__(_s8_rec):
		_s8_rec.parser_(aParser) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","PPDelegateParser_class_on_")
,"instantiation","""on: aParser
	" Return an instance of the receiver. "

	    ^self new
		parser: aParser;
		yourself""",nil)
smalltalk.bind(smalltalk.PPDelegateParser,"parser",0
,smalltalk.__f__("""(self):
	#PPDelegateParser>>#parser
	return getattr(self,"@parser",nil) 
""","PPDelegateParser_parser")
,"accessing","""parser
	" Return the parser of the receiver. "

	^parser""",nil)
smalltalk.bind(smalltalk.PPDelegateParser,"parser:",0
,smalltalk.__f__("""(self,aParser):
	#PPDelegateParser>>#parser:
	smalltalk.basic_at_put(self,"@parser",aParser) 
	return self 
""","PPDelegateParser_parser_")
,"accessing","""parser: aParser
	" Set the parser of the receiver. "

	parser := aParser""",nil)
smalltalk.bind(smalltalk.PPDelegateParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPDelegateParser>>#basicParse:
	return self.parser().memoizedParse_(aStream) 
""","PPDelegateParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	^self parser memoizedParse: aStream""",nil)
smalltalk.bind(smalltalk.PPDelegateParser,"printStringDetail",0
,smalltalk.__f__("""(self):
	#PPDelegateParser>>#printStringDetail
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("["),smalltalk.printString_(getattr(self,"@parser",nil))),smalltalk.String("]")) 
""","PPDelegateParser_printStringDetail")
,"printing","""printStringDetail
	" Private - Return a printable detail of the receiver. "

	^'[' ,parser printString ,']'""",nil)
smalltalk.bind(smalltalk.PPAndParser,"opParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPAndParser>>#opParse:
	__0__=smalltalk.newContext()
	__0__.element=nil
	__0__.position=nil
	__0__.position=aStream.position() 
	__0__.element=self.parser().memoizedParse_(aStream) 
	aStream.position_(__0__.position) 
	return __0__.element 
""","PPAndParser_opParse_")
,"parsing","""opParse: aStream
	" Parse contents in aStream. "

	| element position |
	position := aStream position.
	element := self parser memoizedParse: aStream.
	aStream position: position.
	^element""",nil)
smalltalk.bind(smalltalk.PPAndParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPAndParser>>#basicParse:
	return self.opParse_(aStream) 
""","PPAndParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	^self opParse: aStream""",nil)
smalltalk.bind(smalltalk.PPNotParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPNotParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.element=nil
	__0__.element=self.opParse_(aStream) 
	if smalltalk.b(self.isParseFailure_(__0__.element)):
		return nil 
	 
	return smalltalk.PPFailure.reason_at_(__0__.element,aStream.position()) 
""","PPNotParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| element |
	element := self opParse: aStream.
	(self isParseFailure: element) ifTrue: [ ^nil ].
	^PPFailure reason: element at: aStream position""",nil)
smalltalk.bind(smalltalk.PPActionParser.__class__,"on:block:",0
,smalltalk.__f__("""(self,aParser,aBlock):
	#PPActionParser class>>#on:block:
	def __blk1__(_s8_rec):
		_s8_rec.parser_(aParser) 
		_s8_rec.block_(aBlock) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","PPActionParser_class_on_block_")
,"instantiation","""on: aParser block: aBlock
	" Return an instance of the receiver. "

	^self new
		parser: aParser;
		block: aBlock;
		yourself""",nil)
smalltalk.bind(smalltalk.PPActionParser,"block",0
,smalltalk.__f__("""(self):
	#PPActionParser>>#block
	return getattr(self,"@block",nil) 
""","PPActionParser_block")
,"accessing","""block
	" Return the block of the receiver. "

	^block""",nil)
smalltalk.bind(smalltalk.PPActionParser,"block:",0
,smalltalk.__f__("""(self,aBlock):
	#PPActionParser>>#block:
	smalltalk.basic_at_put(self,"@block",aBlock) 
	return self 
""","PPActionParser_block_")
,"accessing","""block: aBlock
	" Set the block of the receiver. "

	block := aBlock""",nil)
smalltalk.bind(smalltalk.PPActionParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPActionParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.element=nil
	__0__.element=self.parser().memoizedParse_(aStream) 
	if smalltalk.b(self.isParseFailure_(__0__.element)):
		return __0__.element 
	 
	return self.block().value_(__0__.element) 
""","PPActionParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| element |
	element := self parser memoizedParse: aStream.
	(self isParseFailure: element) ifTrue: [ ^element ].
	^self block value: element""",nil)
smalltalk.bind(smalltalk.PPActionParser,"printString",0
,smalltalk.__f__("""(self):
	#PPActionParser>>#printString
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("{"),smalltalk.printString_(getattr(self,"@parser",nil))),smalltalk.String("}")) 
""","PPActionParser_printString")
,"printing","""printString
	" Return a printable representation of the receiver. "

	^${ ,parser printString ,$} """,nil)
smalltalk.bind(smalltalk.PPFlattenParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPFlattenParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.start=nil
	__0__.element=nil
	__0__.start=aStream.position() 
	__0__.element=self.parser().memoizedParse_(aStream) 
	if smalltalk.b(self.isParseFailure_(__0__.element)):
		return __0__.element 
	 
	return aStream.collection().copyFrom_to_(__0__.start._plus(smalltalk.Number(1)),aStream.position()) 
""","PPFlattenParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| start element |
	start := aStream position.
	element := self parser memoizedParse: aStream.
	(self isParseFailure: element) ifTrue: [ ^element ].
	^aStream collection 
		copyFrom: start + 1 
		to: aStream position""",nil)
smalltalk.bind(smalltalk.PPSourceParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPSourceParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.start=nil
	__0__.element=nil
	__0__.result=nil
	__0__.start=aStream.position() 
	__0__.element=self.parser().memoizedParse_(aStream) 
	if smalltalk.b(self.isParseFailure_(__0__.element)):
		return __0__.element 
	 
	__0__.result=aStream.collection().copyFrom_to_(__0__.start._plus(smalltalk.Number(1)),aStream.position()) 
	return smalltalk.Array.with_with_(__0__.element,__0__.result) 
""","PPSourceParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| start element result |
	start := aStream position.
	element := self parser memoizedParse: aStream.
	(self isParseFailure: element) ifTrue: [ ^element ].
	result := aStream collection
		copyFrom: start + 1
		to: aStream position.
	^Array with: element with: result""",nil)
smalltalk.bind(smalltalk.PPRepeatingParser.__class__,"on:min:",0
,smalltalk.__f__("""(self,aParser,aNumber):
	#PPRepeatingParser class>>#on:min:
	def __blk1__(_s8_rec):
		_s8_rec.parser_(aParser) 
		_s8_rec.min_(aNumber) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","PPRepeatingParser_class_on_min_")
,"instantiation","""on: aParser min: aNumber
	" Return an instance of the receiver. "

	^self new
		parser: aParser;
		min: aNumber;
		yourself""",nil)
smalltalk.bind(smalltalk.PPRepeatingParser,"min",0
,smalltalk.__f__("""(self):
	#PPRepeatingParser>>#min
	return getattr(self,"@min",nil) 
""","PPRepeatingParser_min")
,"accessing","""min
	" Return the min of the receiver. "

	^min""",nil)
smalltalk.bind(smalltalk.PPRepeatingParser,"min:",0
,smalltalk.__f__("""(self,aNumber):
	#PPRepeatingParser>>#min:
	smalltalk.basic_at_put(self,"@min",aNumber) 
	return self 
""","PPRepeatingParser_min_")
,"accessing","""min: aNumber
	" Set the min of the receiver. "

	min := aNumber""",nil)
smalltalk.bind(smalltalk.PPRepeatingParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPRepeatingParser>>#basicParse:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return smalltalk.isNil_(__0__.failure) 
		return smalltalk.boolean_and_(__0__.result.size()._lt(self.min()),smalltalk.blk(__blk2__,0)) 
	def __blk3__():
		return smalltalk.isNil_(__0__.failure) 
	__0__.start=nil
	__0__.element=nil
	__0__.result=nil
	__0__.failure=nil
	__0__.start=aStream.position() 
	__0__.result=smalltalk.Array.new() 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk4__():
			return __0__.result.addLast_(__0__.element) 
		def __blk5__():
			aStream.position_(__0__.start) 
			__0__.failure=__0__.element
			return __0__.failure 
		__0__.element=self.parser().memoizedParse_(aStream) 
		smalltalk.if_true_false_(self.isParseFailure_(__0__.element),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk4__,0)) 
	 
	if smalltalk.b(smalltalk.notNil_(__0__.failure)):
		return __0__.failure 
	 
	while smalltalk.b(smalltalk.blk(__blk3__,0)()):
		def __blk6__():
			__0__.failure=__0__.element
			return __0__.failure 
		def __blk7__():
			return __0__.result.addLast_(__0__.element) 
		__0__.element=self.parser().memoizedParse_(aStream) 
		smalltalk.if_true_false_(self.isParseFailure_(__0__.element),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk7__,0)) 
	 
	return __0__.result 
""","PPRepeatingParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| start element result failure |
	start := aStream position.
	result := Array new.
	[ (result size < self min) and: [ failure isNil ]
	] whileTrue: [
	    element := self parser memoizedParse: aStream.
	    (self isParseFailure: element)
		ifFalse: [ result addLast: element ]
		ifTrue: [ aStream position: start.
			  failure := element ]
	].
	failure notNil ifTrue: [ ^failure ].
	[failure isNil] whileTrue: [
		element := self parser memoizedParse: aStream.
	 	(self isParseFailure: element)
			ifTrue: [ failure := element ]
			ifFalse: [ result addLast: element ]
	].
	^result""",nil)
smalltalk.bind(smalltalk.PPRepeatingParser,"printStringDetail",0
,smalltalk.__f__("""(self):
	#PPRepeatingParser>>#printStringDetail
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("[min="),getattr(self,"@min",nil)),smalltalk.String("]")) 
""","PPRepeatingParser_printStringDetail")
,"printing","""printStringDetail
	" Private - Return a printable detail of the receiver. "

	^'[min=' ,min ,']'""",nil)
smalltalk.bind(smalltalk.PPInlineParser.__class__,"upTo:",0
,smalltalk.__f__("""(self,aString):
	#PPInlineParser class>>#upTo:
	def __blk1__(_s8_rec):
		_s8_rec.terminator_(aString) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","PPInlineParser_class_upTo_")
,"instantiation","""upTo: aString
	" Return an instance of the receiver. "

	^self new terminator: aString; yourself""",nil)
smalltalk.bind(smalltalk.PPInlineParser,"terminator:",0
,smalltalk.__f__("""(self,aString):
	#PPInlineParser>>#terminator:
	smalltalk.basic_at_put(self,"@terminator",aString) 
	return self 
""","PPInlineParser_terminator_")
,"accessing","""terminator: aString
	" Set terminator of the receiver. "

	terminator := aString""",nil)
smalltalk.bind(smalltalk.PPInlineParser,"basicParse:",0
,smalltalk.__f__("""(self,aStream):
	#PPInlineParser>>#basicParse:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.result=aStream.upTo_(getattr(self,"@terminator",nil)) 
	if not smalltalk.b(aStream.atEnd()):
		return __0__.result 
	 
	return smalltalk.PPFailure.reason_at_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Missing inline terminator ("),getattr(self,"@terminator",nil)),smalltalk.String(")")),aStream.position()) 
""","PPInlineParser_basicParse_")
,"parsing","""basicParse: aStream
	" Private - Parse contents in aStream. "

	| result |
	result := aStream upTo: terminator.
	aStream atEnd ifFalse: [ ^result ].
	^PPFailure
		reason: 'Missing inline terminator (',terminator,')'
		at: aStream position""",nil)
smalltalk.bind(smalltalk.FileInReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#FileInReader>>#scanFrom:
	return self.subclassResponsibility_(smalltalk.String("scanFrom:")) 
""","FileInReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" FileIn - Return the result of evaluating the next chunk of data from aStream.
	The method must be implemented by chunk readers to support custom fileIn features.
	"

	^self subclassResponsibility: #scanFrom:""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"doing:until:",0
,smalltalk.__f__("""(self,aBlock,terminationBlock):
	#ChunkReader class>>#doing:until:
	def __blk1__(_s8_rec):
		_s8_rec.actionBlock_(aBlock) 
		_s8_rec.terminationBlock_(terminationBlock) 
		return _s8_rec.yourself() 
	return __blk1__(self.new()) 
""","ChunkReader_class_doing_until_")
,"instantiation","""doing: aBlock until: terminationBlock
	" Return an instance of the receiver. "

	^self new
		actionBlock: aBlock;
		terminationBlock: terminationBlock;
		yourself""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"doing:",0
,smalltalk.__f__("""(self,aBlock):
	#ChunkReader class>>#doing:
	def __blk1__():
		return smalltalk.true 
	return self.doing_until_(aBlock,smalltalk.blk(__blk1__,0)) 
""","ChunkReader_class_doing_")
,"instantiation","""doing: aBlock
	" Return an instance of the receiver. "

	^self doing: aBlock until: [ true ]""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"until:",0
,smalltalk.__f__("""(self,terminationBlock):
	#ChunkReader class>>#until:
	return self.doing_until_(nil,terminationBlock) 
""","ChunkReader_class_until_")
,"instantiation","""until: terminationBlock
	" Return an instance of the receiver. "

	^self doing: nil until: terminationBlock""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"ignore",0
,smalltalk.__f__("""(self):
	#ChunkReader class>>#ignore
	return self.new() 
""","ChunkReader_class_ignore")
,"instantiation","""ignore
	" Return an instance of the receiver.
	The returned reader will ignore/absorb next chunk.
	"

	^self new""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"javascriptChunk",0
,smalltalk.__f__("""(self):
	#ChunkReader class>>#javascriptChunk
	return self.nativeChunk() 
""","ChunkReader_class_javascriptChunk")
,"instantiation","""javascriptChunk
	" Obsolete - use #nativeChunk "

	^self nativeChunk """,nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"javascript",0
,smalltalk.__f__("""(self):
	#ChunkReader class>>#javascript
	return self.native() 
""","ChunkReader_class_javascript")
,"instantiation","""javascript
	" Obsolete - use #native "

	^self native """,nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"nativeChunk",0
,smalltalk.__f__("""(self):
	#ChunkReader class>>#nativeChunk
	def __blk1__(aStream):
		return smalltalk.Smalltalk.current().eval_(aStream.nextChunk()) 
	return self.doing_(smalltalk.blk(__blk1__,1)) 
""","ChunkReader_class_nativeChunk")
,"instantiation","""nativeChunk
	" Return an instance of the receiver.
	The returned reader will evaluate next chunk as native code (in global context).
	"

	^self doing: [:aStream| Smalltalk current eval: aStream nextChunk ]""",nil)
smalltalk.bind(smalltalk.ChunkReader.__class__,"native",0
,smalltalk.__f__("""(self):
	#ChunkReader class>>#native
	def __blk1__(aStream):
		return smalltalk.Smalltalk.current().eval_(aStream.upToEnd()) 
	return self.doing_(smalltalk.blk(__blk1__,1)) 
""","ChunkReader_class_native")
,"instantiation","""native
	" Return an instance of the receiver.
	The returned reader will evaluate following contents as native code (in global context).
	The stream will be consumed up to end.
	"

	^self doing: [:aStream| Smalltalk current eval: aStream upToEnd ]""",nil)
smalltalk.bind(smalltalk.ChunkReader,"actionBlock",0
,smalltalk.__f__("""(self):
	#ChunkReader>>#actionBlock
	return getattr(self,"@actionBlock",nil) 
""","ChunkReader_actionBlock")
,"accessing","""actionBlock
	" Return the actionBlock of the receiver. "

	^actionBlock""",nil)
smalltalk.bind(smalltalk.ChunkReader,"actionBlock:",0
,smalltalk.__f__("""(self,aBlock):
	#ChunkReader>>#actionBlock:
	smalltalk.basic_at_put(self,"@actionBlock",aBlock) 
	return self 
""","ChunkReader_actionBlock_")
,"accessing","""actionBlock: aBlock
	" Set the actionBlock of the receiver. "

	actionBlock := aBlock""",nil)
smalltalk.bind(smalltalk.ChunkReader,"terminationBlock",0
,smalltalk.__f__("""(self):
	#ChunkReader>>#terminationBlock
	return getattr(self,"@terminationBlock",nil) 
""","ChunkReader_terminationBlock")
,"accessing","""terminationBlock
	" Return the terminationBlock of the receiver. "

	^terminationBlock""",nil)
smalltalk.bind(smalltalk.ChunkReader,"terminationBlock:",0
,smalltalk.__f__("""(self,aBlock):
	#ChunkReader>>#terminationBlock:
	smalltalk.basic_at_put(self,"@terminationBlock",aBlock) 
	return self 
""","ChunkReader_terminationBlock_")
,"accessing","""terminationBlock: aBlock
	" Set the terminationBlock of the receiver. "

	terminationBlock := aBlock""",nil)
smalltalk.bind(smalltalk.ChunkReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	_s8Ret_=smalltalk.newContext()
	try:
		#ChunkReader>>#scanFrom:
		__0__=smalltalk.newContext()
		def __blk1__():
			return smalltalk.b_(smalltalk.true is self.terminationBlock().value()) 
		__0__.chunk=nil
		if smalltalk.b(smalltalk.isNil_(self.actionBlock())):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,nil) 
			__0__.chunk=aStream.nextChunk() 
			smalltalk.if_true_false_(__0__.chunk.isEmpty(),smalltalk.blk(__blk2__,0),nil) 
		else:
			self.actionBlock().value_(aStream) 
		 
		if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(self.terminationBlock()),smalltalk.blk(__blk1__,0))):
			smalltalk.raise_result_(_s8Ret_,nil) 
		 
		smalltalk.raise_result_(_s8Ret_,self) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","ChunkReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" Scan the next chunk of data from aStream. "

	| chunk |
	self actionBlock isNil ifTrue: [
		chunk := aStream nextChunk.
		chunk isEmpty ifTrue: [ ^nil ].
	] ifFalse: [ self actionBlock value: aStream ].
	(self terminationBlock isNil
		or: [ true == self terminationBlock value ])
		ifTrue: [ ^nil ].
	^self""",nil)
smalltalk.bind(smalltalk.ClassCategoryReader,"class:category:",0
,smalltalk.__f__("""(self,aClass,aString):
	#ClassCategoryReader>>#class:category:
	smalltalk.basic_at_put(self,"@class",aClass) 
	smalltalk.basic_at_put(self,"@category",aString) 
	return self 
""","ClassCategoryReader_class_category_")
,"accessing","""class: aClass category: aString
	" Private - Set the class and category of the receiver. "

	class := aClass.
	category := aString""",nil)
smalltalk.bind(smalltalk.ClassCategoryReader,"class:category:stamp:",0
,smalltalk.__f__("""(self,aClass,aString,aStamp):
	#ClassCategoryReader>>#class:category:stamp:
	self.class_category_(aClass,aString) 
	smalltalk.basic_at_put(self,"@stamp",aStamp) 
	return self 
""","ClassCategoryReader_class_category_stamp_")
,"accessing","""class: aClass category: aString stamp: aStamp
	" Private - Set the class and category of the receiver. "

	self class: aClass category: aString.
	stamp := aStamp""",nil)
smalltalk.bind(smalltalk.ClassCategoryReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#ClassCategoryReader>>#scanFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			return self.compileMethod_(__0__.chunk) 
		return smalltalk.if_true_false_(__0__.chunk.isEmpty(),nil,smalltalk.blk(__blk2__,0)) 
	__0__.chunk=nil
	__0__.chunk=aStream.nextChunk() 
	return smalltalk.blk(__blk1__,0).logEvaluate_(__0__.chunk) 
""","ClassCategoryReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" Scan the next chunk of data from aStream. "

	| chunk |
	chunk := aStream nextChunk.
	^[ chunk isEmpty ifFalse: [ self compileMethod: chunk ]
	] logEvaluate: chunk""",nil)
smalltalk.bind(smalltalk.ClassCategoryReader,"compileMethod:",0
,smalltalk.__f__("""(self,aString):
	#ClassCategoryReader>>#compileMethod:
	__0__=smalltalk.newContext()
	__0__.aMethod=nil
	__0__.aMethod=getattr(self,"@class",nil).compiler().compile_forClass_category_(aString,getattr(self,"@class",nil),getattr(self,"@category",nil)) 
	if smalltalk.b(getattr(self,"@stamp",nil).size()._gt(smalltalk.Number(0))):
		__0__.aMethod.stamp_(getattr(self,"@stamp",nil)) 
	 
	return self 
""","ClassCategoryReader_compileMethod_")
,"private","""compileMethod: aString
	" Compile aString as a method source. "

	| aMethod |
	aMethod := class compiler
		compile: aString
		forClass: class
		category: category.
	stamp size > 0 ifTrue: [ aMethod stamp: stamp ] """,nil)
smalltalk.bind(smalltalk.ClassCommentReader,"class:",0
,smalltalk.__f__("""(self,aClass):
	#ClassCommentReader>>#class:
	smalltalk.basic_at_put(self,"@class",aClass) 
	return self 
""","ClassCommentReader_class_")
,"accessing","""class: aClass
	" Set the destination class of the receiver. "

	class := aClass""",nil)
smalltalk.bind(smalltalk.ClassCommentReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#ClassCommentReader>>#scanFrom:
	self.comment_(aStream.nextChunk()) 
	return nil 
""","ClassCommentReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" FileIn - Parse next chunk in aStream as a comment for target class. "

	self comment: aStream nextChunk.
	^nil""",nil)
smalltalk.bind(smalltalk.ClassCommentReader,"comment:",0
,smalltalk.__f__("""(self,aString):
	#ClassCommentReader>>#comment:
	def __blk1__():
		return aString 
	getattr(self,"@class",nil).comment_(smalltalk.if_true_false_(aString.isEmpty(),nil,smalltalk.blk(__blk1__,0))) 
	return self 
""","ClassCommentReader_comment_")
,"private","""comment: aString
	" Set the comment of target class. "

	class comment: (aString isEmpty ifFalse: [ aString ])""",nil)
smalltalk.bind(smalltalk.SkipFileInReader.__class__,"upTo:",0
,smalltalk.__f__("""(self,aToken):
	#SkipFileInReader class>>#upTo:
	return self.new().limit_(aToken) 
""","SkipFileInReader_class_upTo_")
,"instantiation","""upTo: aToken
	" Return an instance of the receiver. "

	^self new limit: aToken""",nil)
smalltalk.bind(smalltalk.SkipFileInReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#SkipFileInReader>>#scanFrom:
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@limit",nil))):
		aStream.setToEnd() 
	else:
		aStream.skipTo_(getattr(self,"@limit",nil)) 
	 
	return nil 
""","SkipFileInReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" Consume/Ignore contents in aStream. "

	limit isNil
		ifTrue: [ aStream setToEnd ]
		ifFalse: [ aStream skipTo: limit ].
	^nil""",nil)
smalltalk.bind(smalltalk.SkipFileInReader,"limit:",0
,smalltalk.__f__("""(self,aToken):
	#SkipFileInReader>>#limit:
	smalltalk.basic_at_put(self,"@limit",aToken) 
	return self 
""","SkipFileInReader_limit_")
,"accessing","""limit: aToken
	" Set the token limit. "

	limit := aToken""",nil)
smalltalk.bind(smalltalk.AssociationsReader,"keyFrom:",0
,smalltalk.__f__("""(self,aStream):
	#AssociationsReader>>#keyFrom:
	if smalltalk.b(smalltalk.isObject_equalTo_(aStream.peek(),smalltalk.String("#"))):
		def __blk1__(_s8_rec):
			_s8_rec.next() 
			return _s8_rec.upTo_(smalltalk.String(" ")) 
		return __blk1__(aStream).asSymbol() 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(aStream.peek(),smalltalk.String("'"))):
		def __blk2__(_s8_rec):
			_s8_rec.next() 
			return _s8_rec.upTo_(smalltalk.String("'")) 
		return __blk2__(aStream) 
	 
	return aStream.upTo_(smalltalk.String(" ")) 
""","AssociationsReader_keyFrom_")
,"reading","""keyFrom: aStream
	" Private - Return the name of the current binding in aStream. "

	aStream peek = $# ifTrue: [ ^(aStream next; upTo: $ ) asSymbol ].
	aStream peek = $' ifTrue: [ ^aStream next; upTo: $' ].
	^aStream upTo: $ """,nil)
smalltalk.bind(smalltalk.AssociationsReader,"valueFrom:",0
,smalltalk.__f__("""(self,aStream):
	#AssociationsReader>>#valueFrom:
	return self.compilerSupport().evaluate_(aStream.upToEnd()) 
""","AssociationsReader_valueFrom_")
,"reading","""valueFrom: aStream
	" Private - Return the value of the current binding in aStream. "

	^self compilerSupport evaluate: aStream upToEnd """,nil)
smalltalk.bind(smalltalk.AssociationsReader,"compilerSupport",0
,smalltalk.__f__("""(self):
	#AssociationsReader>>#compilerSupport
	return self.smalltalk().compilerSupport() 
""","AssociationsReader_compilerSupport")
,"evaluating","""compilerSupport
	" Private - Return compiler in use to get values from stream. "

	^self smalltalk compilerSupport""",nil)
smalltalk.bind(smalltalk.AssociationsReader,"bind:",0
,smalltalk.__f__("""(self,tuples):
	#AssociationsReader>>#bind:
	return self.subclassResponsibility_(smalltalk.String("bind:")) 
""","AssociationsReader_bind_")
,"binding","""bind: tuples
	" Private - Bind the filedIn tuples to target.
	Must return the result of the fileIn/binding process.
	"

	^self subclassResponsibility: #bind: """,nil)
smalltalk.bind(smalltalk.AssociationsReader,"scanFrom:",0
,smalltalk.__f__("""(self,aStream):
	#AssociationsReader>>#scanFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__():
			__0__.chunk=aStream.nextChunk().trimBlanks() 
			return __0__.chunk.notEmpty() 
		return smalltalk.boolean_and_(smalltalk.booleanNot_(aStream.atEnd()),smalltalk.blk(__blk2__,0)) 
	__0__.chunk=nil
	__0__.tuples=nil
	__0__.tuples=smalltalk.Array.new() 
	while smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__0__.chunk=__0__.chunk.stream() 
		__0__.tuples.add_(smalltalk.Array.with_with_(self.keyFrom_(__0__.chunk),self.valueFrom_(__0__.chunk))) 
	 
	return self.bind_(__0__.tuples) 
""","AssociationsReader_scanFrom_")
,"fileIn","""scanFrom: aStream
	" Consume chunks in aStream until empty chunk.
	The chunks are considered associative bindings with the syntax:
		<key> <expression>
	Where
		key is the keyword of the binding (name, string or symbol).
		expression is a valid smalltalk expression that will be evaluated to generate the value of the binding.
	"

	| chunk tuples |
	tuples := Array new.
	[ aStream atEnd not and: [
	  chunk := aStream nextChunk trimBlanks.
	  chunk notEmpty ]] whileTrue: [
	  chunk := chunk stream.
	  tuples add: (Array
		with: (self keyFrom: chunk)
		with: (self valueFrom: chunk)).
	].
	^self bind: tuples""",nil)
smalltalk.bind(smalltalk.PoolDictionaryReader,"scope:",0
,smalltalk.__f__("""(self,aScope):
	#PoolDictionaryReader>>#scope:
	smalltalk.basic_at_put(self,"@scope",aScope) 
	return self 
""","PoolDictionaryReader_scope_")
,"accessing","""scope: aScope
	" Set the scope of the receiver. "

	scope := aScope""",nil)
smalltalk.bind(smalltalk.PoolDictionaryReader,"bind:",0
,smalltalk.__f__("""(self,tuples):
	#PoolDictionaryReader>>#bind:
	def __blk1__(each):
		return getattr(self,"@scope",nil).at_put_(each.first(),each.last()) 
	if smalltalk.b(getattr(self,"@scope",nil).isString()):
		return smalltalk.Smalltalk.definePool_with_(getattr(self,"@scope",nil),tuples) 
	 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@scope",nil))):
		smalltalk.basic_at_put(self,"@scope",smalltalk.PoolDictionary.new()) 
	 
	tuples.do_(smalltalk.blk(__blk1__,1)) 
	return getattr(self,"@scope",nil) 
""","PoolDictionaryReader_bind_")
,"binding","""bind: tuples
	" Private - Bind the filedIn tuples to target.
	Must return the result of the fileIn/binding process.
	"

	scope isString ifTrue: [
		^Smalltalk definePool: scope with: tuples
	].
	scope isNil ifTrue: [ scope := PoolDictionary new ].
	tuples do: [:each| scope at: each first put: each last ].
	^scope""",nil)
smalltalk.bind(smalltalk.PoolDictionaryReader,"valueFrom:",0
,smalltalk.__f__("""(self,aStream):
	#PoolDictionaryReader>>#valueFrom:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.word.isEmpty() 
	__0__.code=nil
	__0__.result=nil
	__0__.word=nil
	__0__.code=aStream.upToEnd() 
	__0__.word=__0__.code.trimBlanks() 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isObject_equalTo_(__0__.word,smalltalk.String("nil")),smalltalk.blk(__blk1__,0))):
		return nil 
	 
	__0__.result=__0__.word.asNumber() 
	if smalltalk.b(__0__.result.isNumber()):
		return __0__.result 
	 
	return smalltalk.superReceiver(smalltalk.PoolDictionaryReader,self).valueFrom_(__0__.code.stream()) 
""","PoolDictionaryReader_valueFrom_")
,"reading","""valueFrom: aStream
	" Private - Return the value of the current binding in aStream. "

	| code result word |
	code := aStream upToEnd.
	word := code trimBlanks.
	(word = #nil or: [ word isEmpty ]) ifTrue: [ ^nil ].
	result := word asNumber.
	result isNumber ifTrue: [ ^result ].
	^super valueFrom: code stream """,nil)
smalltalk.bind(smalltalk.NativeReader,"bind:",0
,smalltalk.__f__("""(self,tuples):
	#NativeReader>>#bind:
	def __blk1__(each):
		return smalltalk.basic_at_put_(getattr(self,"@object",nil),each.first(),each.last()) 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@object",nil))):
		self.initializeObject() 
	 
	tuples.do_(smalltalk.blk(__blk1__,1)) 
	return getattr(self,"@object",nil) 
""","NativeReader_bind_")
,"binding","""bind: tuples
	" Private - Bind the filedIn tuples to target.
	Must return the result of the fileIn/binding process.
	"

	object isNil ifTrue: [ self initializeObject ].
	tuples do: [:each| object basicAt: each first put: each last ].
	^object""",nil)
smalltalk.bind(smalltalk.NativeReader,"object:",0
,smalltalk.__f__("""(self,anObject):
	#NativeReader>>#object:
	smalltalk.basic_at_put(self,"@object",anObject) 
	return self 
""","NativeReader_object_")
,"accessing","""object: anObject
	" Set the object where the bindings will be stored. "

	object := anObject""",nil)
smalltalk.bind(smalltalk.NativeReader,"initializeObject",0
,smalltalk.__f__("""(self):
	#NativeReader>>#initializeObject
	smalltalk.basic_at_put(self,"@object",smalltalk.newHash()) 
	return self 
""","NativeReader_initializeObject")
,"initialize","""initializeObject
	" Private - Initialize the object where the bindings will be stored. "

	object := {''js'{}'}""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"fileOutCategories:",0
,smalltalk.__f__("""(self,categories):
	#Exporter class>>#fileOutCategories:
	return self.new().fileOutCategories_(categories) 
""","Exporter_class_fileOutCategories_")
,"fileOut","""fileOutCategories: categories
	" Return the result of fileOut all the classes in categories. "

	^self new fileOutCategories: categories""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"fileOutCategory:",0
,smalltalk.__f__("""(self,aString):
	#Exporter class>>#fileOutCategory:
	return self.new().fileOutCategory_(aString) 
""","Exporter_class_fileOutCategory_")
,"fileOut","""fileOutCategory: aString
	" Return the result of fileOut all the classes in category aString. "

	^self new fileOutCategory: aString""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"fileOutAll:",0
,smalltalk.__f__("""(self,elements):
	#Exporter class>>#fileOutAll:
	return self.new().fileOutAll_(elements) 
""","Exporter_class_fileOutAll_")
,"fileOut","""fileOutAll: elements
	" Return the result of fileOut elements (classes, methods and/or categories). "

	^self new fileOutAll: elements""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"fileOutAll",0
,smalltalk.__f__("""(self):
	#Exporter class>>#fileOutAll
	return self.fileOutAll_(self.allClasses()) 
""","Exporter_class_fileOutAll")
,"fileOut","""fileOutAll
	" Return the result of fileOut of all classes in the system. "

	^self fileOutAll: self allClasses""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"fileOut:",0
,smalltalk.__f__("""(self,spec):
	#Exporter class>>#fileOut:
	__0__=smalltalk.newContext()
	__0__.aName=nil
	if smalltalk.b(smalltalk.isNil_(spec)):
		return smalltalk.String("") 
	 
	if not smalltalk.b(spec.isString()):
		if smalltalk.b(smalltalk.is_kindOf_(spec,(smalltalk.Behavior))):
			return self.new().fileOut_(spec) 
		 
		return spec.asArray().fileOut() 
	 
	if smalltalk.b(spec.includes_(smalltalk.String(","))):
		return self.fileOut_(spec.asArrayOfSubstringsSeparatedBy_(smalltalk.String(","))) 
	 
	if smalltalk.b(spec.includes_(smalltalk.String(" "))):
		return self.fileOut_(spec.asArrayOfSubstringsSeparatedBy_(smalltalk.String(" "))) 
	 
	__0__.aName=spec.trimBlanks() 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(__0__.aName)):
		return self.fileOut_(smalltalk.Smalltalk.at_(__0__.aName)) 
	 
	return self.fileOutCategories_(__0__.aName) 
""","Exporter_class_fileOut_")
,"fileOut","""fileOut: spec
	" Return the result of fileOut of literals in spec. "

	| aName |
	spec isNil ifTrue: [ ^'' ].
	spec isString ifFalse: [
		(spec isKindOf: Behavior) ifTrue: [ ^self new fileOut: spec ].
		^spec asArray fileOut
	].
	(spec includes: $,) ifTrue: [ ^self fileOut: (spec asArrayOfSubstringsSeparatedBy: $,) ].
	(spec includes: $ ) ifTrue: [ ^self fileOut: (spec asArrayOfSubstringsSeparatedBy: $ ) ].
	aName := spec trimBlanks.
	(Smalltalk includesKey: aName) ifTrue: [ ^self fileOut: (Smalltalk at: aName)].
	^self fileOutCategories: aName""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"exportCategories:",0
,smalltalk.__f__("""(self,categories):
	#Exporter class>>#exportCategories:
	return self.new().exportCategories_(categories) 
""","Exporter_class_exportCategories_")
,"export","""exportCategories: categories
	" Return the result of exporting all the classes in categories. "

	^self new exportCategories: categories""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"exportCategory:",0
,smalltalk.__f__("""(self,aString):
	#Exporter class>>#exportCategory:
	return self.new().exportCategory_(aString) 
""","Exporter_class_exportCategory_")
,"export","""exportCategory: aString
	" Return the result of exporting all the classes in category aString. "

	^self new exportCategory: aString""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"export:",0
,smalltalk.__f__("""(self,spec):
	#Exporter class>>#export:
	__0__=smalltalk.newContext()
	__0__.aName=nil
	if smalltalk.b(smalltalk.isNil_(spec)):
		return smalltalk.String("") 
	 
	if not smalltalk.b(spec.isString()):
		if smalltalk.b(smalltalk.is_kindOf_(spec,(smalltalk.Behavior))):
			return self.new().export_(spec) 
		 
		return spec.asArray().export() 
	 
	if smalltalk.b(spec.includes_(smalltalk.String(","))):
		return self.export_(spec.asArrayOfSubstringsSeparatedBy_(smalltalk.String(","))) 
	 
	if smalltalk.b(spec.includes_(smalltalk.String(" "))):
		return self.export_(spec.asArrayOfSubstringsSeparatedBy_(smalltalk.String(" "))) 
	 
	__0__.aName=spec.trimBlanks() 
	if smalltalk.b(smalltalk.Smalltalk.includesKey_(__0__.aName)):
		return self.export_(smalltalk.Smalltalk.at_(__0__.aName)) 
	 
	return self.exportCategories_(__0__.aName) 
""","Exporter_class_export_")
,"export","""export: spec
	" Return the result of exporting literals in spec. "

	| aName |
	spec isNil ifTrue: [ ^'' ].
	spec isString ifFalse: [
		(spec isKindOf: Behavior) ifTrue: [ ^self new export: spec ].
		^spec asArray export
	].
	(spec includes: $,) ifTrue: [ ^self export: (spec asArrayOfSubstringsSeparatedBy: $,) ].
	(spec includes: $ ) ifTrue: [ ^self export: (spec asArrayOfSubstringsSeparatedBy: $ ) ].
	aName := spec trimBlanks.
	(Smalltalk includesKey: aName) ifTrue: [ ^self export: (Smalltalk at: aName)].
	^self exportCategories: aName""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"exportAll",0
,smalltalk.__f__("""(self):
	#Exporter class>>#exportAll
	return self.new().exportAll() 
""","Exporter_class_exportAll")
,"export","""exportAll
	" Return the result of exporting all classes in the system. "

	^self new exportAll""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"exportAll:",0
,smalltalk.__f__("""(self,elements):
	#Exporter class>>#exportAll:
	return self.new().exportAll_(elements) 
""","Exporter_class_exportAll_")
,"export","""exportAll: elements
	" Return the result of exporting all elements (classes, methods and/or categories). "

	^self new exportAll: elements""",nil)
smalltalk.bind(smalltalk.Exporter.__class__,"allClasses",0
,smalltalk.__f__("""(self):
	#Exporter class>>#allClasses
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.addAll_(each.withAllSubclasses()) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	return smalltalk.Smalltalk.rootClasses().inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2)) 
""","Exporter_class_allClasses")
,"accessing","""allClasses
	" Private - Return all the classes in the system (in fileIn order). "

	^Smalltalk rootClasses inject: #() into: [:total :each|
		total addAll: each withAllSubclasses; yourself
	]""",nil)
smalltalk.bind(smalltalk.Exporter,"encoder:",0
,smalltalk.__f__("""(self,aS8Encoder):
	#Exporter>>#encoder:
	smalltalk.basic_at_put(self,"@encoder",aS8Encoder) 
	return self 
""","Exporter_encoder_")
,"accessing","""encoder: aS8Encoder
	" Set the encoder of the receiver. "

	encoder := aS8Encoder""",nil)
smalltalk.bind(smalltalk.Exporter,"setEncoderFor:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#setEncoderFor:
	self.encoder_(aClass.compiler().encoder()) 
	return self 
""","Exporter_setEncoderFor_")
,"accessing","""setEncoderFor: aClass
	" Set the encoder of the receiver to emmit code for aClass. "

	self encoder: aClass compiler encoder""",nil)
smalltalk.bind(smalltalk.Exporter,"encoderFor:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#encoderFor:
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@encoder",nil))):
		self.setEncoderFor_(aClass) 
	 
	return getattr(self,"@encoder",nil) 
""","Exporter_encoderFor_")
,"accessing","""encoderFor: aClass
	" Return the encoder of the receiver.
	If the encoder is nil, use the default encoder for aClass.
	"

	encoder isNil ifTrue: [ self setEncoderFor: aClass ].
	^encoder""",nil)
smalltalk.bind(smalltalk.Exporter,"encoder",0
,smalltalk.__f__("""(self):
	#Exporter>>#encoder
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@encoder",nil))):
		self.setEncoderFor_(smalltalk.Object) 
	 
	return getattr(self,"@encoder",nil) 
""","Exporter_encoder")
,"accessing","""encoder
	" Return the encoder of the receiver. "

	encoder isNil ifTrue: [ self setEncoderFor: Object ].
	^encoder""",nil)
smalltalk.bind(smalltalk.Exporter,"allClasses",0
,smalltalk.__f__("""(self):
	#Exporter>>#allClasses
	return (self).__class__.allClasses() 
""","Exporter_allClasses")
,"accessing","""allClasses
	" Private - Return all the classes in the system (in fileIn order). "

	^self class allClasses""",nil)
smalltalk.bind(smalltalk.Exporter,"matchCategory:",0
,smalltalk.__f__("""(self,aString):
	#Exporter>>#matchCategory:
	return self.matchCategory_from_(aString,smalltalk.Smalltalk.rootClasses()) 
""","Exporter_matchCategory_")
,"categories","""matchCategory: aString
	" Return the result of filtering all the classes (and orphan methods) in category aString. "

	^self matchCategory: aString from: Smalltalk rootClasses""",nil)
smalltalk.bind(smalltalk.Exporter,"matchCategory:from:",0
,smalltalk.__f__("""(self,aString,rootClasses):
	#Exporter>>#matchCategory:from:
	__0__=smalltalk.newContext()
	def __blk1__():
		def __blk2__(each):
			return smalltalk.isObject_equalTo_(smalltalk.asString_(each.category()),aString) 
		return smalltalk.blk(__blk2__,1) 
	def __blk3__():
		def __blk4__(each):
			return smalltalk.isObject_equalTo_(smalltalk.asString_(each.category()).upTo_(smalltalk.String("-")),aString) 
		return smalltalk.blk(__blk4__,1) 
	def __blk5__(root):
		def __blk6__(each):
			def __blk7__():
				return __0__.selected 
			def __blk8__():
				return __0__.rejected 
			return smalltalk.if_true_false_(__0__.selection.value_(each),smalltalk.blk(__blk7__,0),smalltalk.blk(__blk8__,0)).add_(each) 
		return root.instanceClass().withAllSubclasses().do_(smalltalk.blk(__blk6__,1)) 
	def __blk9__(cls):
		def __blk10__(aMethod):
			def __blk11__():
				return __0__.orphanMethods.add_(aMethod) 
			return smalltalk.if_true_false_(__0__.selection.value_(aMethod),smalltalk.blk(__blk11__,0),nil) 
		return cls.methodsDo_(smalltalk.blk(__blk10__,1)) 
	def __blk12__(each):
		def __blk13__(_s8_rec):
			_s8_rec.value_(each) 
			return _s8_rec.value_((each).__class__) 
		return __blk13__(__0__.fileOutMethods) 
	__0__.selection=nil
	__0__.selected=nil
	__0__.rejected=nil
	__0__.orphanMethods=nil
	__0__.fileOutMethods=nil
	__0__.selected=smalltalk.Array.new() 
	__0__.rejected=smalltalk.Array.new() 
	__0__.orphanMethods=smalltalk.Array.new() 
	__0__.selection=smalltalk.if_true_false_(aString.includes_(smalltalk.String("-")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk3__,0)) 
	rootClasses.do_(smalltalk.blk(__blk5__,1)) 
	__0__.fileOutMethods=smalltalk.blk(__blk9__,1) 
	__0__.rejected.do_(smalltalk.blk(__blk12__,1)) 
	return smalltalk.Array.with_with_with_(__0__.selected,__0__.rejected,__0__.orphanMethods) 
""","Exporter_matchCategory_from_")
,"categories","""matchCategory: aString from: rootClasses
	" Return the result of filtering all the classes (and orphan methods) in category aString. "

	| selection selected rejected orphanMethods fileOutMethods |
	selected := Array new.
	rejected := Array new.
	orphanMethods := Array new.
	selection := (aString includes: $-)
		ifTrue: [ [:each| each category asString = aString ] ]
		ifFalse: [ [:each| (each category asString upTo: $-) = aString ] ].
	rootClasses do: [:root|
		root instanceClass withAllSubclasses do: [:each|
			((selection value: each)
				ifTrue: [ selected ] ifFalse: [ rejected ])
				add: each
		]
	].
	fileOutMethods := [:cls|
		cls methodsDo: [:aMethod |
			(selection value: aMethod) ifTrue: [ orphanMethods add: aMethod ]
		].
	].
	rejected do: [:each| fileOutMethods value: each; value: each class ].
	^Array with: selected with: rejected with: orphanMethods""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutCategories:",0
,smalltalk.__f__("""(self,categories):
	#Exporter>>#fileOutCategories:
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.add_(self.fileOutCategory_(each)) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	if smalltalk.b(categories.isString()):
		return self.fileOutCategories_(categories.asArrayOfSubstrings()) 
	 
	return categories.asArray().inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2)).join_(smalltalk.String("")) 
""","Exporter_fileOutCategories_")
,"fileOut","""fileOutCategories: categories
	" Return the result of fileOut all the classes in categories. "

	categories isString ifTrue: [ ^self fileOutCategories: categories asArrayOfSubstrings ].
	^(categories asArray inject: #() into: [:total :each|
		total add: (self fileOutCategory: each); yourself
	]) join: ''""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutCategory:",0
,smalltalk.__f__("""(self,aString):
	#Exporter>>#fileOutCategory:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.match=nil
	__0__.stream=smalltalk.String("").writeStream() 
	__0__.match=self.matchCategory_(aString) 
	self.fileOutAll_on_(__0__.match.first(),__0__.stream) 
	self.fileOutMethods_on_(__0__.match.last(),__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOutCategory_")
,"fileOut","""fileOutCategory: aString
	" Return the result of fileOut all the classes in category aString. "

	| stream match |
	stream := '' writeStream.
	match := self matchCategory: aString.
	self fileOutAll: match first on: stream.
	self fileOutMethods: match last on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOut:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#fileOut:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.fileOut_on_(aClass,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOut_")
,"fileOut","""fileOut: aClass
	" Return fileOut definition and code of a class. "

	| stream |
	stream := '' writeStream.
	self fileOut: aClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutClass:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#fileOutClass:
	return self.fileOut_(aClass) 
""","Exporter_fileOutClass_")
,"fileOut","""fileOutClass: aClass
	" Return fileOut definition and code of a class. "

	^self fileOut: aClass""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutAll:",0
,smalltalk.__f__("""(self,elements):
	#Exporter>>#fileOutAll:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.fileOutAll_on_(elements,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOutAll_")
,"fileOut","""fileOutAll: elements
	" Return fileOut definition and code of elements (classes, methods and/or categories). "

	| stream |
	stream := '' writeStream.
	self fileOutAll: elements on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethod:of:",0
,smalltalk.__f__("""(self,aMethod,aClass):
	#Exporter>>#fileOutMethod:of:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.fileOutMethod_of_on_(aMethod,aClass,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOutMethod_of_")
,"fileOut","""fileOutMethod: aMethod of: aClass
	" Return fileOut method of a class. "

	| stream |
	stream := '' writeStream.
	self fileOutMethod: aMethod of: aClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutAllMethodsOf:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#fileOutAllMethodsOf:on:
	self.fileOutMethodsOf_on_((aClass).__class__,stream) 
	self.fileOutMethodsOf_on_(aClass,stream) 
	return self 
""","Exporter_fileOutAllMethodsOf_on_")
,"fileOut","""fileOutAllMethodsOf: aClass on: stream
	" FileOut all methods of aClass (and metaclass) onto stream. "

	self fileOutMethodsOf: aClass class on: stream.
	self fileOutMethodsOf: aClass on: stream.""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutAll:on:",0
,smalltalk.__f__("""(self,elements,stream):
	#Exporter>>#fileOutAll:on:
	def __blk1__(each):
		def __blk2__():
			return self.fileOutDefinitionOfClass_on_(each,stream) 
		return smalltalk.if_true_false_(smalltalk.is_kindOf_(each,(smalltalk.Behavior)),smalltalk.blk(__blk2__,0),nil) 
	def __blk3__(each):
		def __blk4__():
			return self.fileOutAllMethodsOf_on_(each,stream) 
		def __blk5__():
			def __blk6__():
				def __blk7__(_s8_rec):
					_s8_rec.nextPutAll_(self.fileOutCategory_(each)) 
					return _s8_rec.cr() 
				return __blk7__(stream) 
			def __blk8__():
				return self.fileOutMethod_of_on_(each,each.classField(),stream) 
			return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk8__,0)) 
		return smalltalk.if_true_false_(smalltalk.is_kindOf_(each,(smalltalk.Behavior)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
	if smalltalk.b(elements.isString()):
		return self.fileOutAll_on_(elements.asArrayOfSubstrings(),stream) 
	 
	elements.do_(smalltalk.blk(__blk1__,1)) 
	stream.cr() 
	elements.do_(smalltalk.blk(__blk3__,1)) 
	return self 
""","Exporter_fileOutAll_on_")
,"fileOut","""fileOutAll: elements on: stream
	" FileOut definition and code of elements (classes, methods and/or categories) onto stream. "

	elements isString ifTrue: [ ^self fileOutAll: elements asArrayOfSubstrings on: stream ].
	elements do: [:each|
		(each isKindOf: Behavior) ifTrue: [
			self fileOutDefinitionOfClass: each on: stream
		].
	].	stream cr.
	elements do: [:each|
		(each isKindOf: Behavior) ifTrue: [
			self fileOutAllMethodsOf: each on: stream
		] ifFalse: [
			each isString
			ifTrue: [ stream nextPutAll: (self fileOutCategory: each);cr ]
			ifFalse: [ self fileOutMethod: each of: each classField on: stream ]
		]
	].""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutDefinitionOfClass:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#fileOutDefinitionOfClass:on:
	self.fileOutDefinitionOf_on_(aClass,stream) 
	self.fileOutDefinitionOf_on_((aClass).__class__,stream) 
	return self 
""","Exporter_fileOutDefinitionOfClass_on_")
,"fileOut","""fileOutDefinitionOfClass: aClass on: stream
	" FileOut definition of aClass (and metaclass) onto stream. "

	self fileOutDefinitionOf: aClass on: stream.
	self fileOutDefinitionOf: aClass class on: stream""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutDefinitionOf:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#fileOutDefinitionOf:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.fileOutDefinitionOfClass_on_(aClass.instanceClass(),__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOutDefinitionOf_")
,"fileOut","""fileOutDefinitionOf: aClass
	" Return the definition of a class. "

	| stream |
	stream := '' writeStream.
	self fileOutDefinitionOfClass: aClass instanceClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOut:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#fileOut:on:
	self.fileOutAll_on_(smalltalk.Array.with_(aClass),stream) 
	return self 
""","Exporter_fileOut_on_")
,"fileOut","""fileOut: aClass on: stream
	" FileOut definition and code of a class onto stream. "

	self fileOutAll: (Array with: aClass) on: stream.""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#fileOutDefinitionOf:on:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.asString_(aClass.superclass())) 
		_s8_rec.cr() 
		_s8_rec.tab() 
		return _s8_rec.nextPutAll_(smalltalk.String("subclass: #")) 
	def __blk2__(_s8_rec):
		_s8_rec.cr() 
		_s8_rec.tab() 
		_s8_rec.nextPutAll_(smalltalk.String("category: ")) 
		return _s8_rec.nextPutAll_(aClass.category().asLiteral()) 
	def __blk3__(_s8_rec):
		_s8_rec.nextChunkPut_(smalltalk.String("")) 
		return _s8_rec.cr() 
	def __blk4__():
		return aClass.comment().notEmpty() 
	if smalltalk.b(aClass.isMetaclass()):
		if smalltalk.b(self.fileOutStrings_of_on_(smalltalk.String("instanceVariableNames"),aClass,stream)):
			def __blk5__(_s8_rec):
				_s8_rec.nextChunkPut_(smalltalk.String("")) 
				return _s8_rec.cr() 
			__blk5__(stream) 
		 
		if smalltalk.b(self.fileOutArray_of_on_(smalltalk.String("propertyNames"),aClass,stream)):
			def __blk6__(_s8_rec):
				_s8_rec.nextChunkPut_(smalltalk.String("")) 
				return _s8_rec.cr() 
			__blk6__(stream) 
		 
		return self 
	 
	__blk1__(stream) 
	if not smalltalk.b(self.fileOutStrings_of_on_(smalltalk.String("instanceVariableNames"),aClass,stream)):
		def __blk7__(_s8_rec):
			_s8_rec.nextPutAll_(self.globalNameFor_(aClass)) 
			_s8_rec.cr() 
			_s8_rec.tab() 
			_s8_rec.nextPutAll_(smalltalk.String("instanceVariableNames: ")) 
			return _s8_rec.nextPutAll_(smalltalk.printString_(smalltalk.String(""))) 
		__blk7__(stream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.classVariables())):
		def __blk8__(_s8_rec):
			_s8_rec.cr() 
			_s8_rec.tab() 
			_s8_rec.nextPutAll_(smalltalk.String("classVariableNames: ")) 
			return _s8_rec.nextPutAll_(smalltalk.printString_(aClass.classVariablesString())) 
		__blk8__(stream) 
	 
	if smalltalk.b(smalltalk.notNil_(aClass.poolDictionaries())):
		def __blk9__(_s8_rec):
			_s8_rec.cr() 
			_s8_rec.tab() 
			_s8_rec.nextPutAll_(smalltalk.String("poolDictionaries: ")) 
			return _s8_rec.nextPutAll_(smalltalk.printString_(aClass.poolDictionariesString())) 
		__blk9__(stream) 
	 
	__blk2__(stream) 
	__blk3__(stream) 
	if smalltalk.b(self.fileOutArray_of_on_(smalltalk.String("propertyNames"),aClass,stream)):
		def __blk10__(_s8_rec):
			_s8_rec.nextChunkPut_(smalltalk.String("")) 
			return _s8_rec.cr() 
		__blk10__(stream) 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(aClass.comment()),smalltalk.blk(__blk4__,0))):
		def __blk11__(_s8_rec):
			_s8_rec.nextChunkPut_(smalltalk.String("")) 
			return _s8_rec.cr() 
		stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(self.globalNameFor_(aClass),smalltalk.String(" comment: ")),smalltalk.printString_(aClass.comment()))) 
		__blk11__(stream) 
	 
	return self 
""","Exporter_fileOutDefinitionOf_on_")
,"fileOut","""fileOutDefinitionOf: aClass on: stream
	" FileOut definition of a class onto stream. "

	aClass isMetaclass ifTrue: [
		(self fileOutStrings: #instanceVariableNames of: aClass on: stream) ifTrue: [
			stream nextChunkPut: '';cr.
		].
		(self fileOutArray: #propertyNames of: aClass on: stream) ifTrue: [
			stream nextChunkPut: '';cr.
		].
		^self
	].

	stream
		nextPutAll: aClass superclass asString; cr;tab;
		nextPutAll: 'subclass: #'.
	(self fileOutStrings: #instanceVariableNames of: aClass on: stream) ifFalse: [
		stream
			nextPutAll: (self globalNameFor: aClass); cr;tab;
			nextPutAll: 'instanceVariableNames: ';
			nextPutAll: '' printString
	].
	aClass classVariables notNil ifTrue: [
	    stream	 cr;tab;
		nextPutAll: 'classVariableNames: ';
		nextPutAll: aClass classVariablesString printString
	].
	aClass poolDictionaries notNil ifTrue: [
	    stream	 cr;tab;
		nextPutAll: 'poolDictionaries: ';
		nextPutAll: aClass poolDictionariesString printString
	].
	stream cr;tab;
		nextPutAll: 'category: ';
		nextPutAll: aClass category asLiteral.
	stream nextChunkPut: '';cr.
	(self fileOutArray: #propertyNames of: aClass on: stream) ifTrue: [
		stream nextChunkPut: '';cr.
	].
	(aClass comment notNil and: [aClass comment notEmpty]) ifTrue: [
		stream nextPutAll: (self globalNameFor: aClass),' comment: ', aClass comment printString.
		stream nextChunkPut: '';cr.
	].""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutStrings:of:on:",0
,smalltalk.__f__("""(self,selector,aClass,stream):
	#Exporter>>#fileOutStrings:of:on:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.globalNameFor_(aClass)) 
		_s8_rec.cr() 
		_s8_rec.tab() 
		return _s8_rec.nextPutAll_(smalltalk.object_comma_(selector,smalltalk.String(": '"))) 
	def __blk2__(each):
		return stream.nextPutAll_(smalltalk.object_comma_(smalltalk.String(" "),each)) 
	__0__.strings=nil
	__0__.strings=aClass.perform_(selector) 
	if smalltalk.b(__0__.strings.isEmpty()):
		return smalltalk.false 
	 
	__blk1__(stream) 
	__0__.strings.do_(smalltalk.blk(__blk2__,1)) 
	stream.nextPutAll_(smalltalk.String(" '")) 
	return smalltalk.true 
""","Exporter_fileOutStrings_of_on_")
,"fileOut","""fileOutStrings: selector of: aClass on: stream
	" Private - FileOut selector strings of a class onto stream.
	Return true if code has been filedOut.
	"

	| strings |
	strings := aClass perform: selector.
	strings isEmpty ifTrue: [ ^false ].
	stream
		nextPutAll: (self globalNameFor: aClass); cr;tab;
		nextPutAll: selector,': '''.
	strings do: [:each| stream nextPutAll: ' ',each ].
	stream nextPutAll: ' '''.
	^true""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutArray:of:on:",0
,smalltalk.__f__("""(self,selector,aClass,stream):
	#Exporter>>#fileOutArray:of:on:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(self.globalNameFor_(aClass)) 
		return _s8_rec.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(" "),selector),smalltalk.String(": ")),__0__.strings.asLiteral())) 
	__0__.strings=nil
	__0__.strings=aClass.perform_(selector) 
	if smalltalk.b(__0__.strings.isEmpty()):
		return smalltalk.false 
	 
	__blk1__(stream) 
	return smalltalk.true 
""","Exporter_fileOutArray_of_on_")
,"fileOut","""fileOutArray: selector of: aClass on: stream
	" Private - FileOut selector arrayed strings of a class onto stream.
	Return true if code has been filedOut.
	"

	| strings |
	strings := aClass perform: selector.
	strings isEmpty ifTrue: [ ^false ].
	stream
		nextPutAll: (self globalNameFor: aClass);
		nextPutAll: ' ',selector,': ', strings asLiteral.
	^true""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethodsOf:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#fileOutMethodsOf:on:
	__0__=smalltalk.newContext()
	__0__.selectors=nil
	__0__.selectors=aClass.selectors() 
	if smalltalk.b(__0__.selectors.isEmpty()):
		return self 
	 
	stream.cr() 
	self.fileOutSelectors_of_on_(__0__.selectors,aClass,stream) 
	return self 
""","Exporter_fileOutMethodsOf_on_")
,"fileOut","""fileOutMethodsOf: aClass on: stream
	" FileOut methods of a class onto stream. "

	| selectors |
	selectors := aClass selectors.
	selectors isEmpty ifTrue: [ ^self ].
	stream cr.
	self
		fileOutSelectors: selectors
		of: aClass on: stream""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutClusters",0
,smalltalk.__f__("""(self):
	#Exporter>>#fileOutClusters
	def __blk1__(key):
		return smalltalk.Smalltalk.includesKey_(key) 
	def __blk2__(each):
		return smalltalk.Smalltalk.at_(each).default() 
	return smalltalk.newArray(["APIBuilder"]).select_(smalltalk.blk(__blk1__,1)).collect_(smalltalk.blk(__blk2__,1)) 
""","Exporter_fileOutClusters")
,"private","""fileOutClusters
	" Private - Return the fileOut chustering dumpers of the receiver.
	A fileOutCluster is an object that potentially dump clustered actions for selectors implemented by aClass.
	The fileOut write (smalltalk)code for multiple selectors removing them from selectors collection.
	Note: the selectors collection is modified during fileOut.
	The default answer is an empty collection of custed or a collection with default APIBuilder.
	This method can be refined by the subclasses.
	"

	^(#( #APIBuilder )
		select: [:key| Smalltalk includesKey: key ])
		collect: [:each| (Smalltalk at: each) default ]""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutSelectors:of:on:",0
,smalltalk.__f__("""(self,selectors,aClass,stream):
	#Exporter>>#fileOutSelectors:of:on:
	def __blk1__(each):
		return each.fileOut_selectors_of_on_(self,selectors,aClass,stream) 
	def __blk2__(each):
		return aClass.compiledMethodAt_(each) 
	self.fileOutClusters().do_(smalltalk.blk(__blk1__,1)) 
	self.fileOutMethods_on_(selectors.collect_(smalltalk.blk(__blk2__,1)),stream) 
	return self 
""","Exporter_fileOutSelectors_of_on_")
,"fileOut","""fileOutSelectors: selectors of: aClass on: stream
	" FileOut methods implementing selectors of a class onto stream. "

	self fileOutClusters do: [:each|
		each
			fileOut: self selectors: selectors
			of: aClass on: stream
	].
	self	fileOutMethods: (selectors collect: [:each|
			aClass compiledMethodAt: each ])
		on: stream""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethods:on:",0
,smalltalk.__f__("""(self,array,stream):
	#Exporter>>#fileOutMethods:on:
	__0__=smalltalk.newContext()
	def __blk1__(a,b):
		def __blk2__():
			def __blk3__():
				return a.selector()._lt(b.selector()) 
			return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(a.category(),b.category()),smalltalk.blk(__blk3__,0)) 
		return smalltalk.boolean_or_(a.category()._lt(b.category()),smalltalk.blk(__blk2__,0)) 
	def __blk4__(each):
		return self.fileOutMethod_of_on_(each,each.classField(),stream) 
	__0__.sorted=nil
	__0__.sorted=array.sorted_(smalltalk.blk(__blk1__,2)) 
	__0__.sorted.do_(smalltalk.blk(__blk4__,1)) 
	return self 
""","Exporter_fileOutMethods_on_")
,"fileOut","""fileOutMethods: array on: stream
	" FileOut array of methods of a class onto stream. "

	| sorted |
	sorted := array sorted: [:a :b|
		a category < b category
		or: [ a category = b category
		and: [ a selector < b selector ]]
	].

	sorted do: [:each|
		self	fileOutMethod: each
			of: each classField on: stream
	].""",nil)
smalltalk.bind(smalltalk.Exporter,"isASymbol:",0
,smalltalk.__f__("""(self,aString):
	#Exporter>>#isASymbol:
	return smalltalk.isNil_(smalltalk.RegularExpression.fromString_(smalltalk.String("[^a-zA-Z0-9_:]")).exec_(aString)) 
""","Exporter_isASymbol_")
,"private","""isASymbol: aString
	" Private - Return true if aString can be output with symbol notation. "

	^((RegularExpression fromString: '[^a-zA-Z0-9_:]') exec: aString) isNil""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethod:on:",0
,smalltalk.__f__("""(self,aMethod,aStream):
	#Exporter>>#fileOutMethod:on:
	return self.fileOutMethod_of_on_(aMethod,aMethod.classField(),aStream) 
""","Exporter_fileOutMethod_on_")
,"fileOut","""fileOutMethod: aMethod on: aStream
	" Return the fileOut of aMethod. "

	^self
		fileOutMethod: aMethod
		of: aMethod classField
		on: aStream""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#Exporter>>#fileOutMethod:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.fileOutMethod_on_(aMethod,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_fileOutMethod_")
,"fileOut","""fileOutMethod: aMethod
	" Return the fileOut of aMethod. "

	| stream |
	stream := '' writeStream.
	self fileOutMethod: aMethod on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"fileOutMethod:of:on:",0
,smalltalk.__f__("""(self,aMethod,aClass,stream):
	#Exporter>>#fileOutMethod:of:on:
	def __blk1__(_s8_rec):
		def __blk2__():
			return smalltalk.object_comma_(smalltalk.String(" stamp: "),aMethod.stamp().asLiteral()) 
		_s8_rec.cr() 
		_s8_rec.nextChunkPut_(nil) 
		_s8_rec.nextChunkPut_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String(" "),self.globalNameFor_(aClass)),smalltalk.String(" methodsFor: ")),aMethod.category().asLiteral()),smalltalk.if_true_false_(aMethod.stamp().size()._gt(smalltalk.Number(0)),smalltalk.blk(__blk2__,0),nil)),smalltalk.String(" "))) 
		_s8_rec.cr() 
		_s8_rec.nextChunkPut_(aMethod.source()) 
		_s8_rec.nextChunkPut_(smalltalk.String(" ")) 
		return _s8_rec.cr() 
	__blk1__(stream) 
	return self 
""","Exporter_fileOutMethod_of_on_")
,"fileOut","""fileOutMethod: aMethod of: aClass on: stream
	" FileOut method of a class onto stream. "

	stream	cr; nextChunkPut: nil;
		nextChunkPut: ' '
			,(self globalNameFor: aClass)
			,' methodsFor: ' ,aMethod category asLiteral
			,(aMethod stamp size > 0 ifTrue: [ ' stamp: ' , aMethod stamp asLiteral ] )
			,' '; cr;
		nextChunkPut: aMethod source;
		nextChunkPut: ' '; cr""",nil)
smalltalk.bind(smalltalk.Exporter,"exportCategory:",0
,smalltalk.__f__("""(self,aString):
	#Exporter>>#exportCategory:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return __0__.stream.nextPutAll_(self.export_(each)) 
	def __blk2__(aMethod):
		return self.export_method_on_(aMethod.classField(),aMethod,__0__.stream) 
	__0__.stream=nil
	__0__.match=nil
	__0__.stream=smalltalk.String("").writeStream() 
	__0__.match=self.matchCategory_(aString) 
	__0__.match.first().do_(smalltalk.blk(__blk1__,1)) 
	__0__.match.last().do_(smalltalk.blk(__blk2__,1)) 
	return __0__.stream.contents() 
""","Exporter_exportCategory_")
,"export","""exportCategory: aString
	" Return the result of exporting all the classes in category aString. "

	| stream match |
	stream := '' writeStream.
	match := self matchCategory: aString.
	match first do: [:each| stream nextPutAll: (self export: each) ].
	match last do: [:aMethod |
		self export: aMethod classField method: aMethod on: stream
	].
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportCategories:",0
,smalltalk.__f__("""(self,categories):
	#Exporter>>#exportCategories:
	def __blk1__(total,each):
		def __blk2__(_s8_rec):
			_s8_rec.add_(self.exportCategory_(each)) 
			return _s8_rec.yourself() 
		return __blk2__(total) 
	if smalltalk.b(categories.isString()):
		return self.exportCategories_(categories.asArrayOfSubstrings()) 
	 
	return categories.asArray().inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk1__,2)).join_(smalltalk.String("")) 
""","Exporter_exportCategories_")
,"export","""exportCategories: categories
	" Return the result of exporting all the classes in categories. "

	categories isString ifTrue: [ ^self exportCategories: categories asArrayOfSubstrings ].
	^(categories asArray inject: #() into: [:total :each|
		total add: (self exportCategory: each); yourself
	]) join: ''""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllMethodsOf:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#exportAllMethodsOf:on:
	self.exportMethodsOf_on_((aClass).__class__,stream) 
	self.exportMethodsOf_on_(aClass,stream) 
	return self 
""","Exporter_exportAllMethodsOf_on_")
,"export","""exportAllMethodsOf: aClass on: stream
	" Export all methods of a class (and metaclass) onto stream. "

	self exportMethodsOf: aClass class on: stream.
	self exportMethodsOf: aClass on: stream.""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllMethodsOn:",0
,smalltalk.__f__("""(self,stream):
	#Exporter>>#exportAllMethodsOn:
	def __blk1__(aClass):
		return self.exportAllMethodsOf_on_(aClass,stream) 
	self.allClasses().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Exporter_exportAllMethodsOn_")
,"export","""exportAllMethodsOn: stream
	" Export all methods in the system onto stream. "

	self allClasses do: [:aClass|
		self exportAllMethodsOf: aClass on: stream
	]""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllMethods",0
,smalltalk.__f__("""(self):
	#Exporter>>#exportAllMethods
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.exportAllMethodsOn_(__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportAllMethods")
,"export","""exportAllMethods
	" Return the result of exporting all methods in the system. "

	| stream |
	stream := '' writeStream.
	self exportAllMethodsOn: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllDefinitionsOn:",0
,smalltalk.__f__("""(self,stream):
	#Exporter>>#exportAllDefinitionsOn:
	def __blk1__(aClass):
		return self.exportDefinitionOfClass_on_(aClass,stream) 
	self.allClasses().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Exporter_exportAllDefinitionsOn_")
,"export","""exportAllDefinitionsOn: stream
	" Export all class definitions in the system onto stream. "

	self allClasses do: [:aClass|
		self exportDefinitionOfClass: aClass on: stream
	]""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllDefinitions",0
,smalltalk.__f__("""(self):
	#Exporter>>#exportAllDefinitions
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.exportAllDefinitionsOn_(__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportAllDefinitions")
,"export","""exportAllDefinitions
	" Return the result of exporting all class definitions in the system. "

	| stream |
	stream := '' writeStream.
	self exportAllDefinitionsOn: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportDefinitionOfClass:on:",0
,smalltalk.__f__("""(self,aClass,stream):
	#Exporter>>#exportDefinitionOfClass:on:
	self.exportDefinitionOf_on_(aClass,stream) 
	self.exportMetaDefinitionOf_on_(aClass,stream) 
	return self 
""","Exporter_exportDefinitionOfClass_on_")
,"export","""exportDefinitionOfClass: aClass on: stream
	" Export definition of aClass (and metaclass) onto stream. "

	self exportDefinitionOf: aClass on: stream.
	self exportMetaDefinitionOf: aClass on: stream.""",nil)
smalltalk.bind(smalltalk.Exporter,"export:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#export:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String("").writeStream() 
	self.exportDefinitionOfClass_on_(aClass,__0__.stream) 
	self.exportAllMethodsOf_on_(aClass,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_export_")
,"export","""export: aClass
	" Return the result of exporting definition and source code of a class. "

	| stream |
	stream := '' writeStream.
	self exportDefinitionOfClass: aClass on: stream.
	self exportAllMethodsOf: aClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportNew:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#exportNew:
	return self.exportDefinitionOf_(aClass) 
""","Exporter_exportNew_")
,"export","""exportNew: aClass
	" Return the result of exporting definition of aClass. "

	^self exportDefinitionOf: aClass""",nil)
smalltalk.bind(smalltalk.Exporter,"exportDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#Exporter>>#exportDefinitionOf:on:
	return self.encoderFor_(aClass).exportDefinitionOf_on_(aClass,aStream) 
""","Exporter_exportDefinitionOf_on_")
,"private","""exportDefinitionOf: aClass on: aStream
	" Export definition of aClass onto aStream. "

	^(self encoderFor: aClass) exportDefinitionOf: aClass on: aStream""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMetaDefinitionOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#Exporter>>#exportMetaDefinitionOf:on:
	return self.encoderFor_(aClass).exportMetaDefinitionOf_on_(aClass,aStream) 
""","Exporter_exportMetaDefinitionOf_on_")
,"private","""exportMetaDefinitionOf: aClass on: aStream
	" Export class side definition of aClass onto aStream. "

	^(self encoderFor: aClass) exportMetaDefinitionOf: aClass on: aStream""",nil)
smalltalk.bind(smalltalk.Exporter,"smalltalkNameFor:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#smalltalkNameFor:
	return self.encoderFor_(aClass).smalltalkNameFor_(aClass) 
""","Exporter_smalltalkNameFor_")
,"private","""smalltalkNameFor: aClass
	" Private - Return the native reference expression of aClass (or nil). "

	^(self encoderFor: aClass) smalltalkNameFor: aClass""",nil)
smalltalk.bind(smalltalk.Exporter,"globalNameFor:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#globalNameFor:
	def __blk1__():
		return smalltalk.String("nil") 
	def __blk2__():
		return aClass.name() 
	return smalltalk.if_true_false_(smalltalk.isNil_(aClass),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","Exporter_globalNameFor_")
,"private","""globalNameFor: aClass
	" Private - Return the smalltalk name of aClass (or nil). "

	^aClass isNil ifTrue: [ #nil ] ifFalse: [ aClass name ]""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAll",0
,smalltalk.__f__("""(self):
	#Exporter>>#exportAll
	return self.exportClasses_(self.allClasses()) 
""","Exporter_exportAll")
,"export","""exportAll
	" Return the result of exporting all classes in the system. "

	^self exportClasses: self allClasses""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAllCategories",0
,smalltalk.__f__("""(self):
	#Exporter>>#exportAllCategories
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return __0__.categories.add_(each.category()) 
		return smalltalk.if_true_false_(__0__.categories.includes_(each.category()),nil,smalltalk.blk(__blk2__,0)) 
	def __blk3__(total,each):
		def __blk4__(_s8_rec):
			_s8_rec.add_(self.exportCategory_(each)) 
			return _s8_rec.yourself() 
		return __blk4__(total) 
	__0__.categories=nil
	__0__.categories=smalltalk.Array.new() 
	self.allClasses().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.categories.inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk3__,2)).join_(smalltalk.String("")) 
""","Exporter_exportAllCategories")
,"export","""exportAllCategories
	" Return the result of exporting all categories in the system. "

	| categories |
	categories := Array new.
	self allClasses do: [:each |
		(categories includes: each category) ifFalse: [
			categories add: each category
		]
	].
	^(categories inject: #() into: [:total :each | total add: (self exportCategory: each); yourself ]) join: ''""",nil)
smalltalk.bind(smalltalk.Exporter,"exportDefinitionOf:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#exportDefinitionOf:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportDefinitionOf_on_(aClass,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportDefinitionOf_")
,"export","""exportDefinitionOf: aClass
	" Return the result of exporting definition of aClass. "

	| stream |
	stream := String new writeStream.
	self exportDefinitionOf: aClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMetaDefinitionOf:",0
,smalltalk.__f__("""(self,aClass):
	#Exporter>>#exportMetaDefinitionOf:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportMetaDefinitionOf_on_(aClass,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportMetaDefinitionOf_")
,"export","""exportMetaDefinitionOf: aClass
	" Return the result of exporting class side definition of aClass. "

	| stream |
	stream := String new writeStream.
	self exportMetaDefinitionOf: aClass on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportClasses:on:",0
,smalltalk.__f__("""(self,classes,stream):
	#Exporter>>#exportClasses:on:
	return self.exportAll_on_(classes,stream) 
""","Exporter_exportClasses_on_")
,"export","""exportClasses: classes on: stream
	" Return the result of exporting class definitions onto stream. "

	^self exportAll: classes on: stream""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAll:on:",0
,smalltalk.__f__("""(self,elements,stream):
	#Exporter>>#exportAll:on:
	def __blk1__(each):
		def __blk2__():
			return self.exportDefinitionOfClass_on_(each,stream) 
		return smalltalk.if_true_false_(smalltalk.is_kindOf_(each,(smalltalk.Behavior)),smalltalk.blk(__blk2__,0),nil) 
	def __blk3__(each):
		def __blk4__():
			return self.exportAllMethodsOf_on_(each,stream) 
		def __blk5__():
			def __blk6__():
				def __blk7__(_s8_rec):
					_s8_rec.nextPutAll_(self.exportCategory_(each)) 
					return _s8_rec.cr() 
				return __blk7__(stream) 
			def __blk8__():
				return self.exportMethod_on_(each,stream) 
			return smalltalk.if_true_false_(each.isString(),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk8__,0)) 
		return smalltalk.if_true_false_(smalltalk.is_kindOf_(each,(smalltalk.Behavior)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
	if smalltalk.b(elements.isString()):
		return self.exportAll_on_(elements.asArrayOfSubstrings(),stream) 
	 
	elements.do_(smalltalk.blk(__blk1__,1)) 
	stream.cr() 
	elements.do_(smalltalk.blk(__blk3__,1)) 
	return self 
""","Exporter_exportAll_on_")
,"export","""exportAll: elements on: stream
	" Return the result of exporting elements (classes, methods and/or categories) onto stream. "

	elements isString ifTrue: [ ^self exportAll: elements asArrayOfSubstrings on: stream ].
	elements do: [:each|
		(each isKindOf: Behavior) ifTrue: [
			self exportDefinitionOfClass: each on: stream
		].
	].
	stream cr.
	elements do: [:each|
		(each isKindOf: Behavior) ifTrue: [
			self exportAllMethodsOf: each on: stream
		] ifFalse: [
			each isString
			ifTrue: [ stream nextPutAll: (self exportCategory: each);cr ]
			ifFalse: [ self exportMethod: each on: stream ]
		]
	].""",nil)
smalltalk.bind(smalltalk.Exporter,"exportAll:",0
,smalltalk.__f__("""(self,elements):
	#Exporter>>#exportAll:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportAll_on_(elements,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportAll_")
,"export","""exportAll: elements
	" Return the result of exporting elements (classes, methods and/or categories). "

	| stream |
	stream := String new writeStream.
	self exportAll: elements on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportClasses:",0
,smalltalk.__f__("""(self,classes):
	#Exporter>>#exportClasses:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportClasses_on_(classes,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportClasses_")
,"export","""exportClasses: classes
	" Return the result of exporting classes. "

	| stream |
	stream := String new writeStream.
	self exportClasses: classes on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportObject:on:",0
,smalltalk.__f__("""(self,anObject,stream):
	#Exporter>>#exportObject:on:
	stream.nextPutAll_(anObject.asNative()) 
	return self 
""","Exporter_exportObject_on_")
,"export","""exportObject: anObject on: stream
	" Export a (native)literal representation of anObject onto stream. "

	stream nextPutAll: anObject asNative""",nil)
smalltalk.bind(smalltalk.Exporter,"exportObject:",0
,smalltalk.__f__("""(self,anObject):
	#Exporter>>#exportObject:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportObject_on_(anObject,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportObject_")
,"export","""exportObject: anObject
	" Return the result of exporting a literal representation of anObject. "

	| stream |
	stream := String new writeStream.
	self exportObject: anObject on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"export:method:",0
,smalltalk.__f__("""(self,aClass,aMethod):
	#Exporter>>#export:method:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.export_method_on_(aClass,aMethod,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_export_method_")
,"export","""export: aClass method: aMethod
	" Return the result of exporting aClass method. "

	| stream |
	stream := String new writeStream.
	self export: aClass method: aMethod on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMethod:",0
,smalltalk.__f__("""(self,aMethod):
	#Exporter>>#exportMethod:
	return self.export_method_(aMethod.classField(),aMethod) 
""","Exporter_exportMethod_")
,"export","""exportMethod: aMethod
	" Return the result of exporting aMethod. "

	^self export: aMethod classField method: aMethod""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMethod:on:",0
,smalltalk.__f__("""(self,aMethod,aStream):
	#Exporter>>#exportMethod:on:
	return self.export_method_on_(aMethod.classField(),aMethod,aStream) 
""","Exporter_exportMethod_on_")
,"export","""exportMethod: aMethod on: aStream
	" Return the result of exporting aMethod on stream. "

"	(aMethod respondsTo: #classField) ifFalse: [ ^self note: 'Warning: broken method ',aMethod ].
"	^self export: aMethod classField method: aMethod on: aStream""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMethods:on:",0
,smalltalk.__f__("""(self,aCollection,aStream):
	#Exporter>>#exportMethods:on:
	def __blk1__(each):
		return self.exportMethod_on_(each,aStream) 
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Exporter_exportMethods_on_")
,"export","""exportMethods: aCollection on: aStream
	" Return the result of exporting aCollection of methods on stream. "

	aCollection do: [:each| self exportMethod: each on: aStream ]""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMethods:",0
,smalltalk.__f__("""(self,aCollection):
	#Exporter>>#exportMethods:
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.exportMethods_on_(aCollection,__0__.stream) 
	return __0__.stream.contents() 
""","Exporter_exportMethods_")
,"Tools-export","""exportMethods: aCollection
	" Return the result of exporting aCollection of methods. "

	| stream |
	stream := String new writeStream.
	self exportMethods: aCollection on: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Exporter,"exportMethodsOf:on:",0
,smalltalk.__f__("""(self,aClass,aStream):
	#Exporter>>#exportMethodsOf:on:
	def __blk1__(each):
		return self.export_method_on_(aClass,each,aStream) 
	aClass.methodsDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Exporter_exportMethodsOf_on_")
,"Tools-private","""exportMethodsOf: aClass on: aStream
	" Export methods of aClass onto aStream. "

	aClass methodsDo: [:each|
		self export: aClass method: each on: aStream
	]""",nil)
smalltalk.bind(smalltalk.Exporter,"export:method:on:",0
,smalltalk.__f__("""(self,aClass,aMethod,aStream):
	#Exporter>>#export:method:on:
	if smalltalk.b(smalltalk.responds_to_(aMethod,(smalltalk.String("exportFor:on:")))):
		return aMethod.exportFor_on_(self,aStream) 
	 
	return self.encoderFor_(aClass).export_method_on_(aClass,aMethod,aStream) 
""","Exporter_export_method_on_")
,"Tools-export","""export: aClass method: aMethod on: aStream
	" Export a method definition of aClass onto aStream. "

	(aMethod respondsTo: #exportFor:on:) ifTrue: [ ^aMethod exportFor: self on: aStream ].
	^(self encoderFor: aClass) export: aClass method: aMethod on: aStream""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"default",0
,smalltalk.__f__("""(self):
	#APIBuilder class>>#default
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@default",nil))):
		smalltalk.basic_at_put(self,"@default",self.new()) 
	 
	return getattr(self,"@default",nil) 
""","APIBuilder_class_default")
,"accessing","""default
	" Return the default instance of the receiver. "

	default isNil ifTrue: [ default := self new ].
	^default""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"saveBuilders",0
,smalltalk.__f__("""(self):
	#APIBuilder class>>#saveBuilders
	return smalltalk.b_(getattr(self,"@saveBuilders",nil) is smalltalk.true) 
""","APIBuilder_class_saveBuilders")
,"accessing","""saveBuilders
	" Return true if the receiver is set to save builders in snapshot. "

	^saveBuilders == true""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"saveBuilders:",0
,smalltalk.__f__("""(self,aBoolean):
	#APIBuilder class>>#saveBuilders:
	smalltalk.basic_at_put(self,"@saveBuilders",aBoolean) 
	return self 
""","APIBuilder_class_saveBuilders_")
,"accessing","""saveBuilders: aBoolean
	" Set to true if the receiver save builders in snapshot. "

	saveBuilders := aBoolean""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"build:doing:",0
,smalltalk.__f__("""(self,token,aBlock):
	#APIBuilder class>>#build:doing:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.result=aBlock.value() 
		__0__.success=smalltalk.true
		return __0__.success 
	def __blk2__():
		return __0__.builder.close_success_(token,__0__.success) 
	__0__.builder=nil
	__0__.result=nil
	__0__.success=nil
	__0__.builder=self.default() 
	__0__.builder.open_(token) 
	__0__.success=smalltalk.false 
	smalltalk.blk(__blk1__,0).ensure_(smalltalk.blk(__blk2__,0)) 
	return __0__.result 
""","APIBuilder_class_build_doing_")
,"building","""build: token doing: aBlock
	" Process a (build...: spec) definition marking methods generated while evaluating aBlock.
	Return the result of evaluating aBlock. "

	| builder result success |
	builder := self default.
	builder open: token.
	success := false.
	[	result := aBlock value.
		success := true.
	] ensure: [ builder close: token success: success ].
	^result""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"register:",0
,smalltalk.__f__("""(self,aMethod):
	#APIBuilder class>>#register:
	def __blk1__():
		return getattr(self,"@default",nil).register_(aMethod) 
	return smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@default",nil)),smalltalk.blk(__blk1__,0)) 
""","APIBuilder_class_register_")
,"building","""register: aMethod
	" Register aMethod as related to current builder. "

	^default notNil and: [ default register: aMethod ]""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"imageSaved:on:",0
,smalltalk.__f__("""(self,snapshot,stream):
	#APIBuilder class>>#imageSaved:on:
	__0__=smalltalk.newContext()
	def __blk1__():
		__0__.code=self.codeForBuilders()
		return (__0__.code).notEmpty() 
	__0__.code=nil
	if smalltalk.b(smalltalk.boolean_and_(self.saveBuilders(),smalltalk.blk(__blk1__,0))):
		def __blk2__(_s8_rec):
			_s8_rec.cr() 
			return _s8_rec.nextPutAll_(__0__.code) 
		__blk2__(stream) 
	 
	return smalltalk.superReceiver(smalltalk.APIBuilder.__class__,self).imageSaved_on_(snapshot,stream) 
""","APIBuilder_class_imageSaved_on_")
,"snapshot","""imageSaved: snapshot on: stream
	" Private - A system snapshot has been taken, the receiver can restore state. "

	| code |
	(self saveBuilders and: [
		(code := self codeForBuilders) notEmpty ])
		ifTrue: [ stream cr;nextPutAll: code ].
	^super imageSaved: snapshot on: stream""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"codeForBuilders",0
,smalltalk.__f__("""(self):
	#APIBuilder class>>#codeForBuilders
	return self.codeFor_(smalltalk.Smalltalk.classes()) 
""","APIBuilder_class_codeForBuilders")
,"code","""codeForBuilders
	" Return the (native) code to export the builders of the system. "

	^self codeFor: Smalltalk classes""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"codeFor:",0
,smalltalk.__f__('''(self,classes):
	#APIBuilder class>>#codeFor:
	__0__=smalltalk.newContext()
	__0__.builders=nil
	__0__.builders=self.buildersFor_(classes) 
	if smalltalk.b(__0__.builders.isEmpty()):
		return smalltalk.String("") 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk."),self.name()),smalltalk.String(""".builders_(
	""")),smalltalk.Exporter.new().exportObject_(__0__.builders)),smalltalk.String("""
	);""")) 
''',"APIBuilder_class_codeFor_")
,"code","""codeFor: classes
	" Return the (native) code to export the builders defined by a collection of classes. "

	| builders |
	builders := self buildersFor: classes.
	builders isEmpty ifTrue: [ ^'' ].
	^'smalltalk.', self name ,'.builders_(
'	,(Exporter new exportObject: builders) ,'
);'""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"buildersFor:",0
,smalltalk.__f__("""(self,classes):
	#APIBuilder class>>#buildersFor:
	def __blk1__(cls):
		return smalltalk.Array.with_with_with_(cls.name(),self.buildersIn_((cls).__class__),self.buildersIn_(cls)) 
	def __blk2__(tuple):
		def __blk3__():
			return tuple.third().isEmpty() 
		return smalltalk.boolean_and_(tuple.second().isEmpty(),smalltalk.blk(__blk3__,0)) 
	return classes.collect_(smalltalk.blk(__blk1__,1)).reject_(smalltalk.blk(__blk2__,1)) 
""","APIBuilder_class_buildersFor_")
,"private","""buildersFor: classes
	" Private - Return the builders defined by a collection of classes.
	#( className #(--classbuilders--) #(--instanceBuilders---))
	"

	^(classes collect: [:cls|
		Array
			with: cls name
			with: (self buildersIn: cls class)
			with: (self buildersIn: cls)
	]) reject: [:tuple|
		tuple second isEmpty and: [tuple third isEmpty]
	]""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"builders",0
,smalltalk.__f__("""(self):
	#APIBuilder class>>#builders
	return self.buildersFor_(smalltalk.Smalltalk.classes()) 
""","APIBuilder_class_builders")
,"private","""builders
	" Private - Return the builders defined in this system. "

	^self buildersFor: Smalltalk classes""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"buildersIn:",0
,smalltalk.__f__("""(self,aClass):
	#APIBuilder class>>#buildersIn:
	__0__=smalltalk.newContext()
	def __blk1__(mth):
		__1__=smalltalk.newContext()
		def __blk2__():
			def __blk3__(tuple):
				return smalltalk.isObject_equalTo_(tuple.first(),__1__.assoc) 
			def __blk4__():
				return __0__.map.add_(smalltalk.Array.with_with_(__1__.assoc,smalltalk.Array.new())) 
			return __0__.map.detect_ifNone_(smalltalk.blk(__blk3__,1),smalltalk.blk(__blk4__,0)).second().add_(mth.selector()) 
		__1__.assoc=nil
		__1__.assoc=mth.builder() 
		return smalltalk.if_true_false_(smalltalk.notNil_(__1__.assoc),smalltalk.blk(__blk2__,0),nil) 
	def __blk5__(tuple):
		return smalltalk.Array.with_with_with_(tuple.first().key(),tuple.first().value(),tuple.last()) 
	__0__.map=nil
	__0__.map=smalltalk.Array.new() 
	aClass.methodsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.map.collect_(smalltalk.blk(__blk5__,1)) 
""","APIBuilder_class_buildersIn_")
,"private","""buildersIn: aClass
	" Private - Return the builders used in aClass.
	#( builderType builderSpec #( selectors ) )
	"

	| map |
	map := Array new.
	aClass methodsDo: [:mth| | assoc |
		assoc := mth builder.
		assoc notNil ifTrue: [
			(map	detect: [:tuple| tuple first = assoc ]
				ifNone: [ map add: (Array with: assoc with: Array new) ])
				second add: mth selector
		]
	].
	^map collect: [:tuple| Array
		with: tuple first key
		with: tuple first value
		with: tuple last
	]""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"builders:",0
,smalltalk.__f__("""(self,spec):
	#APIBuilder class>>#builders:
	def __blk1__(builder):
		__1__=smalltalk.newContext()
		def __blk2__():
			nil 
		def __blk3__():
			self.setBuilders_in_(builder.second(),(__1__.cls).__class__) 
			return self.setBuilders_in_(builder.third(),__1__.cls) 
		__1__.cls=nil
		__1__.cls=smalltalk.Smalltalk.at_ifAbsent_(builder.first(),smalltalk.blk(__blk2__,0)) 
		return smalltalk.if_true_false_(smalltalk.notNil_(__1__.cls),smalltalk.blk(__blk3__,0),nil) 
	spec.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","APIBuilder_class_builders_")
,"private","""builders: spec
	" Private - Set the builders on this system according to bindings defined in spec.
	Note that missing bindings will be ignored and no check is done to ensure the bindings are in sync with target.
	"

	spec do: [:builder| | cls |
		cls := Smalltalk at: builder first ifAbsent: [].
		cls notNil ifTrue: [
			self setBuilders: builder second in: cls class.
			self setBuilders: builder third in: cls.
		].
	]""",nil)
smalltalk.bind(smalltalk.APIBuilder.__class__,"setBuilders:in:",0
,smalltalk.__f__("""(self,array,aClass):
	#APIBuilder class>>#setBuilders:in:
	__0__=smalltalk.newContext()
	def __blk1__(map):
		def __blk2__(selector):
			__2__=smalltalk.newContext()
			def __blk3__():
				return __2__.mth.builder_(__0__.builder) 
			__2__.mth=nil
			__2__.mth=aClass.compiledMethodAt_(selector) 
			return smalltalk.if_true_false_(smalltalk.notNil_(__2__.mth),smalltalk.blk(__blk3__,0),nil) 
		__0__.builder=smalltalk.Association.key_value_(map.first(),map.second()) 
		return map.last().do_(smalltalk.blk(__blk2__,1)) 
	__0__.builder=nil
	array.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","APIBuilder_class_setBuilders_in_")
,"private","""setBuilders: array in: aClass
	" Private - Set the builders in array on aClass. "

	| builder |
	array do: [:map|
		builder := Association key: map first value: map second.
		map last do: [:selector| | mth |
			mth := aClass compiledMethodAt: selector.
			mth notNil ifTrue: [ mth builder: builder ].
		]
	]""",nil)
smalltalk.bind(smalltalk.APIBuilder,"register:",0
,smalltalk.__f__("""(self,aMethod):
	#APIBuilder>>#register:
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@token",nil))):
		return smalltalk.false 
	 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@bound",nil))):
		smalltalk.basic_at_put(self,"@bound",smalltalk.Array.new()) 
	 
	getattr(self,"@bound",nil).add_(aMethod) 
	return smalltalk.true 
""","APIBuilder_register_")
,"private","""register: aMethod
	" Private - Register aMethod as related to the receiver. "

	token isNil ifTrue: [ ^false ].
	bound isNil ifTrue: [ bound := Array new ].
	bound add: aMethod.
	^true""",nil)
smalltalk.bind(smalltalk.APIBuilder,"open:",0
,smalltalk.__f__("""(self,spec):
	#APIBuilder>>#open:
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@parents",nil))):
		smalltalk.basic_at_put(self,"@parents",smalltalk.Array.new()) 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@token",nil))):
		getattr(self,"@parents",nil).addLast_(getattr(self,"@token",nil)) 
	 
	smalltalk.basic_at_put(self,"@token",spec) 
	return self 
""","APIBuilder_open_")
,"private","""open: spec
	" Private - The spec will be generated.
	Prepare the receiver to track generated methods while building spec.
	"

	parents isNil ifTrue: [ parents := Array new ].
	token notNil ifTrue: [ parents addLast: token ].
	token := spec.""",nil)
smalltalk.bind(smalltalk.APIBuilder,"close:success:",0
,smalltalk.__f__("""(self,spec,success):
	#APIBuilder>>#close:success:
	def __blk1__():
		return getattr(self,"@parents",nil).notEmpty() 
	if not smalltalk.b(smalltalk.isObject_equalTo_(getattr(self,"@token",nil),spec)):
		return self.error_(smalltalk.String("Builders out of sync.")) 
	 
	if smalltalk.b(smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@parents",nil)),smalltalk.blk(__blk1__,0))):
		smalltalk.basic_at_put(self,"@token",getattr(self,"@parents",nil).removeLast()) 
		return success 
	 
	if smalltalk.b(smalltalk.notNil_(getattr(self,"@bound",nil))):
		def __blk2__(each):
			return self.mark_(each) 
		getattr(self,"@bound",nil).do_(smalltalk.blk(__blk2__,1)) 
		smalltalk.basic_at_put(self,"@token",smalltalk.basic_at_put(self,"@parents",smalltalk.basic_at_put(self,"@bound",nil))) 
	 
	return success 
""","APIBuilder_close_success_")
,"private","""close: spec success: success
	" Private - The spec has been implemented, backtrack to parent or mark collected methods. "

	token = spec ifFalse: [ ^self error: 'Builders out of sync.' ].
	(parents notNil and: [ parents notEmpty ]) ifTrue: [
		token := parents removeLast.
		^success
	].
	bound notNil ifTrue: [
		bound do: [:each| self mark: each ].
		token := parents := bound := nil.
	].
	^success""",nil)
smalltalk.bind(smalltalk.APIBuilder,"mark:",0
,smalltalk.__f__("""(self,aMethod):
	#APIBuilder>>#mark:
	aMethod.builder_(getattr(self,"@token",nil)) 
	return self 
""","APIBuilder_mark_")
,"private","""mark: aMethod
	" Private - Mark aMethod as dependent of current token. "

	aMethod builder: token""",nil)
smalltalk.bind(smalltalk.APIBuilder,"fileOut:selectors:of:on:",0
,smalltalk.__f__("""(self,exporter,selectors,aClass,stream):
	#APIBuilder>>#fileOut:selectors:of:on:
	__0__=smalltalk.newContext()
	def __blk1__(selector):
		__1__=smalltalk.newContext()
		def __blk2__():
			__0__.specs.add_(__1__.assoc) 
			return selectors.remove_(selector) 
		__1__.assoc=nil
		__1__.assoc=aClass.compiledMethodAt_(selector).builder() 
		return smalltalk.if_true_false_(smalltalk.notNil_(__1__.assoc),smalltalk.blk(__blk2__,0),nil) 
	def __blk3__(a,b):
		return a.key()._lt_eq(b.key()) 
	def __blk4__(assoc):
		def __blk5__(_s8_rec):
			_s8_rec.nextChunkPut_(smalltalk.String(" ")) 
			return _s8_rec.cr() 
		stream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(aClass.name(),smalltalk.String(" build")),assoc.key())) 
		if smalltalk.b(assoc.value().notEmpty()):
			stream.nextPut_(smalltalk.String(":")) 
			self.fileOutSpec_on_(assoc.value(),stream) 
		 
		return __blk5__(stream) 
	__0__.specs=nil
	__0__.specs=smalltalk.Set.new() 
	selectors.copy().do_(smalltalk.blk(__blk1__,1)) 
	__0__.specs.asArray().sorted_(smalltalk.blk(__blk3__,2)).do_(smalltalk.blk(__blk4__,1)) 
	return self 
""","APIBuilder_fileOut_selectors_of_on_")
,"fileOut","""fileOut: exporter selectors: selectors of: aClass on: stream
	" Fileout clustered sources for selectors onto stream.
	Note: Remove the clustered message selectors from selectors collection while fileOut.
	"

	| specs |
	specs := Set new.
	selectors copy do: [:selector| | assoc |
		assoc := (aClass compiledMethodAt: selector) builder.
		assoc notNil ifTrue: [
			specs add: assoc.
			selectors remove: selector.
		]
	].
	(specs asArray sorted: [:a :b| a key <= b key ]) do: [:assoc|
		stream nextPutAll: aClass name ,' build' ,assoc key.
		assoc value notEmpty ifTrue: [
			stream nextPut: $:.
			self fileOutSpec: assoc value on: stream
		].
		stream nextChunkPut: $ ;cr
	].""",nil)
smalltalk.bind(smalltalk.APIBuilder,"fileOutSpec:on:",0
,smalltalk.__f__("""(self,array,stream):
	#APIBuilder>>#fileOutSpec:on:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String(" #(")) 
		return _s8_rec.cr() 
	def __blk2__(each):
		def __blk3__(_s8_rec):
			_s8_rec.tab() 
			_s8_rec.nextPutAll_(each.asLiteral()) 
			return _s8_rec.cr() 
		return __blk3__(stream) 
	__blk1__(stream) 
	array.do_(smalltalk.blk(__blk2__,1)) 
	stream.nextPut_(smalltalk.String(")")) 
	return self 
""","APIBuilder_fileOutSpec_on_")
,"fileOut","""fileOutSpec: array on: stream
	" Private - Fileout API spec in array onto stream. "

	stream nextPutAll: ' #(';cr.
	array do: [:each| stream tab; nextPutAll: each asLiteral;cr ].
	stream nextPut: $).""",nil)
smalltalk.bind(smalltalk.Snapshot.__class__,"contents",0
,smalltalk.__f__("""(self):
	#Snapshot class>>#contents
	return self.new().contents() 
""","Snapshot_class_contents")
,"accessing","""contents
	" Return a snapshot of current system contents. "

	^self new contents""",nil)
smalltalk.bind(smalltalk.Snapshot.__class__,"outputToFile:",0
,smalltalk.__f__("""(self,fileName):
	#Snapshot class>>#outputToFile:
	def __blk1__(each):
		return each.removeFromSystem() 
	smalltalk.String.doItSelector().implementors().do_(smalltalk.blk(__blk1__,1)) 
	self.contents().outputToFile_(fileName) 
	return self 
""","Snapshot_class_outputToFile_")
,"saveImage","""outputToFile: fileName
	" Save a complete system snapshot in a file at fileName. "

	String doItSelector implementors do: [:each| each removeFromSystem ].
	self contents outputToFile: fileName""",nil)
smalltalk.bind(smalltalk.Snapshot,"contents",0
,smalltalk.__f__("""(self):
	#Snapshot>>#contents
	__0__=smalltalk.newContext()
	__0__.stream=nil
	__0__.stream=smalltalk.String.new().writeStream() 
	self.saveImageOn_(__0__.stream) 
	return __0__.stream.contents() 
""","Snapshot_contents")
,"accessing","""contents
	" Return a snapshot of current system contents. "

	| stream |
	stream := String new writeStream.
	self saveImageOn: stream.
	^stream contents""",nil)
smalltalk.bind(smalltalk.Snapshot,"saveImageOn:",0
,smalltalk.__f__("""(self,stream):
	#Snapshot>>#saveImageOn:
	return self.saveImage_on_(self.smalltalk(),stream) 
""","Snapshot_saveImageOn_")
,"saveImage","""saveImageOn: stream
	" Save the current system contents onto stream. "

	^self saveImage: self smalltalk on: stream""",nil)
smalltalk.bind(smalltalk.Snapshot,"saveImage:on:",0
,smalltalk.__f__("""(self,aSmalltalk,stream):
	#Snapshot>>#saveImage:on:
	def __blk1__(_s8_rec):
		_s8_rec.writeLicense_on_(aSmalltalk,stream) 
		_s8_rec.writeBootOn_(stream) 
		_s8_rec.writePrologueOn_(stream) 
		_s8_rec.writeImageContents_on_(aSmalltalk,stream) 
		_s8_rec.writeEpilogueOn_(stream) 
		return _s8_rec.yourself() 
	__blk1__(self) 
	return self 
""","Snapshot_saveImage_on_")
,"saveImage","""saveImage: aSmalltalk on: stream
	" Save aSmalltalk system contents onto stream. "

	self
		writeLicense: aSmalltalk on: stream;
		writeBootOn: stream;
		writePrologueOn: stream;
		writeImageContents: aSmalltalk on: stream;
		writeEpilogueOn: stream;
		yourself""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeLicense:on:",0
,smalltalk.__f__("""(self,aSmalltalk,aStream):
	#Snapshot>>#writeLicense:on:
	def __blk1__(_s8_rec):
		_s8_rec.nextPutAll_(aSmalltalk.licenseTerms().asComment()) 
		return _s8_rec.cr() 
	__blk1__(aStream) 
	return self 
""","Snapshot_writeLicense_on_")
,"writing","""writeLicense: aSmalltalk on: aStream
	" Private - Write the license terms onto aStream. "

	aStream nextPutAll: aSmalltalk licenseTerms asComment; cr""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeJSBootOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeJSBootOn:
	self.writeGlobals_on_(smalltalk.newArray(["StObject","StBehavior","StClass","StMetaclass","StMethod","StUndefinedObject"]),aStream) 
	self.writeNilDefinitionOn_(aStream) 
	self.writeGlobals_on_(smalltalk.newArray(["StSystemDictionary"]),aStream) 
	self.writeSystemDefinitionOn_(aStream) 
	self.write_mappingsOn_(smalltalk.String("Kernel"),aStream) 
	return self 
""","Snapshot_writeJSBootOn_")
,"javascript","""writeJSBootOn: aStream
	" Private - Write the (javascript) boot section of the image onto aStream. "

	self writeGlobals: #(
		#StObject #StBehavior #StClass #StMetaclass
		#StMethod
		#StUndefinedObject
		) on: aStream.
	self writeNilDefinitionOn: aStream.
	self writeGlobals: #( #StSystemDictionary ) on: aStream.
	self writeSystemDefinitionOn: aStream.
	self write: #Kernel mappingsOn: aStream.""",nil)
smalltalk.bind(smalltalk.Snapshot,"bootHeader",0
,smalltalk.__f__("""(self):
	#Snapshot>>#bootHeader
	return smalltalk.String("") 
""","Snapshot_bootHeader")
,"encoding","""bootHeader
	" Private - Return the header for boot contents. "

	^{''js'""'}""",nil)
smalltalk.bind(smalltalk.Snapshot,"bootFooter",0
,smalltalk.__f__("""(self):
	#Snapshot>>#bootFooter
	return smalltalk.String("") 
""","Snapshot_bootFooter")
,"encoding","""bootFooter
	" Private - Return the footer for boot contents. "

	^{''js'""'}""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeBootOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeBootOn:
	__0__=smalltalk.newContext()
	def __blk1__():
		__1__=smalltalk.newContext()
		__1__.text=nil
		__1__.text=smalltalk.object_comma_(smalltalk.object_comma_(self.bootHeader(),__0__.boot),self.bootFooter()) 
		self.write_on_(__1__.text,aStream) 
		return __1__.text 
	def __blk2__():
		nil 
	__0__.boot=nil
	__0__.bootName=nil
	__0__.save=nil
	__0__.save=smalltalk.blk(__blk1__,0) 
	__0__.bootName=smalltalk.object_comma_(smalltalk.String("S8_Boot_"),smalltalk.String.nativeFileExtension()) 
	__0__.boot=smalltalk.Smalltalk.at_ifAbsent_(__0__.bootName,smalltalk.blk(__blk2__,0)) 
	if smalltalk.b(smalltalk.notNil_(__0__.boot)):
		return __0__.save.value() 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.nativeLanguage(),smalltalk.String("js"))):
		return self.writeJSBootOn_(aStream) 
	 
	__0__.boot=read(smalltalk.object_comma_(smalltalk.String("s8/start/boot."),smalltalk.String.nativeFileExtension())) 
	if smalltalk.b(smalltalk.notNil_(__0__.boot)):
		return smalltalk.Smalltalk.at_put_(__0__.bootName,__0__.save.value()) 
	 
	return self.error_(smalltalk.String("Missing boot resource")) 
""","Snapshot_writeBootOn_")
,"writing","""writeBootOn: aStream
	" Private - Write the boot section of the image onto aStream. "

	| boot bootName save |
	save := [ | text |
		text := self bootHeader ,boot ,self bootFooter.
		self write: text on: aStream.
		text
	].
	bootName := 'S8_Boot_' ,String nativeFileExtension.
	boot := Smalltalk at: bootName ifAbsent: [].
	boot notNil ifTrue: [ ^save value ].
	self nativeLanguage = #js ifTrue: [
		^self writeJSBootOn: aStream
	].
	boot := # #read: 's8/start/boot.' ,String nativeFileExtension.
	boot notNil ifTrue: [ ^Smalltalk at: bootName put: save value ].
	^self error: 'Missing boot resource'""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeJSPrologueOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeJSPrologueOn:
	__0__=smalltalk.newContext()
	__0__.defaultImageName=nil
	__0__.defaultImageName=smalltalk.object_comma_(smalltalk.String("s8.image."),smalltalk.String.nativeFileExtension()) 
	self.write_on_(smalltalk.String('smalltalk.$state = "initialize"'),aStream) 
	self.writeGlobals_on_(smalltalk.newArray(["smalltalk.st","smalltalk.doIt","fileIn","fileInJS","doit","exportCategory","saveImage","saveImageAs"]),aStream) 
	aStream.cr() 
	return self 
""","Snapshot_writeJSPrologueOn_")
,"javascript","""writeJSPrologueOn: aStream
	" Private - Write the (javascript) prologue section of the image onto aStream. "

	| defaultImageName|
	defaultImageName := 's8.image.' ,String nativeFileExtension.
	self write: 'smalltalk.$state = "initialize"' on: aStream.
	self writeGlobals: #(
		'smalltalk.st' 'smalltalk.doIt'
		#fileIn #fileInJS
		#doit #exportCategory
		#saveImage #saveImageAs
		) on: aStream.
	aStream cr.""",nil)
smalltalk.bind(smalltalk.Snapshot,"writePrologueOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writePrologueOn:
	aStream.cr() 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.nativeLanguage(),smalltalk.String("js"))):
		self.writeJSPrologueOn_(aStream) 
	 
	return self 
""","Snapshot_writePrologueOn_")
,"writing","""writePrologueOn: aStream
	" Private - Write the prologue section of the image onto aStream. "

	aStream cr.
	self nativeLanguage = #js ifTrue: [
		self writeJSPrologueOn: aStream
	].""",nil)
smalltalk.bind(smalltalk.Snapshot,"launchExpression",0
,smalltalk.__f__("""(self):
	#Snapshot>>#launchExpression
	return smalltalk.String("smalltalk.launchImage()") 
""","Snapshot_launchExpression")
,"encoding","""launchExpression
	" Private - Return the native launch expression. "

	^{''js'"smalltalk.launchImage()"'}""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeEpilogueOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeEpilogueOn:
	__0__=smalltalk.newContext()
	__0__.launch=nil
	__0__.launch=self.launchExpression() 
	if smalltalk.b(smalltalk.notNil_(__0__.launch)):
		self.write_on_(__0__.launch,aStream) 
	 
	return self 
""","Snapshot_writeEpilogueOn_")
,"writing","""writeEpilogueOn: aStream
	" Private - Write the epilogue section of the image onto aStream. "

	| launch |
	launch := self launchExpression.
	launch notNil ifTrue: [ self write: launch on: aStream ].""",nil)
smalltalk.bind(smalltalk.Snapshot,"write:on:",0
,smalltalk.__f__("""(self,aString,aStream):
	#Snapshot>>#write:on:
	def __blk1__(_s8_rec):
		_s8_rec.cr() 
		return _s8_rec.nextPutAll_(aString) 
	__blk1__(aStream) 
	return self 
""","Snapshot_write_on_")
,"writing","""write: aString on: aStream
	" Private - Write aString onto aStream. "

	aStream cr; nextPutAll: aString""",nil)
smalltalk.bind(smalltalk.Snapshot,"globalNotFound:",0
,smalltalk.__f__("""(self,aGlobal):
	#Snapshot>>#globalNotFound:
	return self.error_(smalltalk.object_comma_(smalltalk.String("Global not found: "),aGlobal)) 
""","Snapshot_globalNotFound_")
,"error","""globalNotFound: aGlobal
	" Private - A global at native level has not been found. "

	^self error: 'Global not found: ',aGlobal""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeGlobals:on:",0
,smalltalk.__f__("""(self,globals,aStream):
	#Snapshot>>#writeGlobals:on:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			def __blk3__():
				return each 
			def __blk4__():
				return smalltalk.object_comma_(smalltalk.String("var "),each) 
			__0__.varName=smalltalk.if_true_false_(each.includes_(smalltalk.String(".")),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
			return self.write_on_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.varName,smalltalk.String(" = ")),smalltalk.to_String(__0__.object)),aStream) 
		__0__.object=smalltalk.Smalltalk.current().eval_(each) 
		if smalltalk.b(smalltalk.isNil_(__0__.object)):
			__0__.object=self.globalNotFound_(each) 
		 
		return smalltalk.if_true_false_(smalltalk.notNil_(__0__.object),smalltalk.blk(__blk2__,0),nil) 
	__0__.object=nil
	__0__.varName=nil
	globals.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Snapshot_writeGlobals_on_")
,"writing","""writeGlobals: globals on: aStream
	" Private - Write the prologue section of the image onto aStream. "

	| object varName |
	globals do: [:each|
		object := Smalltalk current eval: each.
		object isNil ifTrue: [ object := self globalNotFound: each ].
		object notNil ifTrue: [
			varName := (each includes: $.) ifTrue: [ each ] ifFalse: [ 'var ',each ].
			self write: varName,' = ', object toString on: aStream.
		]
	]""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeNilDefinitionOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeNilDefinitionOn:
	__0__=smalltalk.newContext()
	__0__.sample=nil
	__0__.sample=nil 
	self.write_on_(smalltalk.String("var nil = new StUndefinedObject()"),aStream) 
	self.write_on_(smalltalk.object_comma_(smalltalk.String("nil.toString = "),smalltalk.to_String(smalltalk.asObject_(__0__.sample.toString))),aStream) 
	self.write_on_(smalltalk.object_comma_(smalltalk.String("nil.isNil_ = "),smalltalk.to_String(smalltalk.asObject_(__0__.sample[smalltalk.handleOf(smalltalk.String("isNil_"))]))),aStream) 
	self.write_on_(smalltalk.object_comma_(smalltalk.String("nil.is_eqeq_ = "),smalltalk.to_String(smalltalk.asObject_(__0__.sample[smalltalk.handleOf(smalltalk.String("is_eqeq_"))]))),aStream) 
	return self 
""","Snapshot_writeNilDefinitionOn_")
,"javascript","""writeNilDefinitionOn: aStream
	" Private - Write the definition of nil object onto aStream. "

	| sample |
	sample := nil.
	self write: 'var nil = new StUndefinedObject()' on: aStream.
	self write: 'nil.toString = ', sample#toString toString on: aStream.
	self write: 'nil.isNil_ = ', sample#isNil_ toString on: aStream.
	self write: 'nil.is_eqeq_ = ', sample#is_eqeq_ toString on: aStream.""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeSystemDefinitionOn:",0
,smalltalk.__f__("""(self,aStream):
	#Snapshot>>#writeSystemDefinitionOn:
	self.write_on_(smalltalk.String("var smalltalk = new StSystemDictionary()"),aStream) 
	self.write_on_(smalltalk.String('smalltalk.toString = function() { return "smalltalk" }'),aStream) 
	self.write_on_(smalltalk.String('smalltalk.$state = "booting"'),aStream) 
	self.write_on_(smalltalk.String("smalltalk.OverwriteMethods = smalltalk.OverwriteMethods || true"),aStream) 
	self.write_on_(smalltalk.String("smalltalk.DumpOverwritenMethods = smalltalk.DumpOverwritenMethods || false"),aStream) 
	return self 
""","Snapshot_writeSystemDefinitionOn_")
,"javascript","""writeSystemDefinitionOn: aStream
	" Private - Write the definition of smalltalk object onto aStream. "

	self write: 'var smalltalk = new StSystemDictionary()' on: aStream.
	self write: 'smalltalk.toString = function() { return "smalltalk" }' on: aStream.
	self write: 'smalltalk.$state = "booting"' on: aStream.
	self write: 'smalltalk.OverwriteMethods = smalltalk.OverwriteMethods || true' on: aStream.
	self write: 'smalltalk.DumpOverwritenMethods = smalltalk.DumpOverwritenMethods || false' on: aStream.""",nil)
smalltalk.bind(smalltalk.Snapshot,"write:mappingsOn:",0
,smalltalk.__f__("""(self,aCategory,aStream):
	#Snapshot>>#write:mappingsOn:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return smalltalk.notNil_(each.constructorName()) 
		return smalltalk.boolean_and_(smalltalk.isObject_equalTo_(each.category(),aCategory),smalltalk.blk(__blk2__,0)) 
	def __blk3__(aClass):
		def __blk4__():
			return __0__.done.includes_(aClass) 
		def __blk5__():
			def __blk6__():
				return smalltalk.String("undefined") 
			def __blk7__():
				return aClass.constructorName() 
			__0__.register.value_(aClass.superclass()) 
			__0__.row=smalltalk.Array.with_(aClass.name()) 
			__0__.row.add_(smalltalk.if_true_false_(smalltalk.isNil_(aClass.constructorName()),smalltalk.blk(__blk6__,0),smalltalk.blk(__blk7__,0))) 
			if smalltalk.b(smalltalk.notNil_(aClass.superclass())):
				__0__.row.add_(aClass.superclass().name()) 
			 
			__0__.mappings.add_(__0__.row) 
			return __0__.done.add_(aClass) 
		return smalltalk.if_true_false_(smalltalk.boolean_or_(smalltalk.isNil_(aClass),smalltalk.blk(__blk4__,0)),nil,smalltalk.blk(__blk5__,0)) 
	__0__.mapped=nil
	__0__.mappings=nil
	__0__.done=nil
	__0__.register=nil
	__0__.row=nil
	__0__.mapped=smalltalk.Smalltalk.current().classes().select_(smalltalk.blk(__blk1__,1)) 
	__0__.mappings=smalltalk.Array.new() 
	__0__.done=smalltalk.Array.new() 
	__0__.register=smalltalk.blk(__blk3__,1) 
	__0__.mapped.do_(__0__.register) 
	return self.write_mappings_on_(aCategory,__0__.mappings,aStream) 
""","Snapshot_write_mappingsOn_")
,"writing","""write: aCategory mappingsOn: aStream
	" Private - Write the mappings for system classes in aCategory onto aStream. "

	| mapped mappings done register row |
	mapped := Smalltalk current classes select: [:each|
		each category = aCategory
		and: [ each constructorName notNil ]
		].
	mappings := Array new.
	done := Array new.
	register := [:aClass|
		(aClass isNil or: [ done includes: aClass ]) ifFalse: [
			register value: aClass superclass.
			row := Array with: aClass name.
			row add: (aClass constructorName isNil
				ifTrue: [ #undefined ]
				ifFalse: [ aClass constructorName ]).
			aClass superclass notNil ifTrue: [
				row add: aClass superclass name.
			].
			mappings add: row.
			done add: aClass.
		].
	].
	mapped do: register.
	^self write: aCategory mappings: mappings on: aStream""",nil)
smalltalk.bind(smalltalk.Snapshot,"write:mappings:on:",0
,smalltalk.__f__("""(self,category,mappings,aStream):
	#Snapshot>>#write:mappings:on:
	__0__=smalltalk.newContext()
	def __blk1__(tuple):
		def __blk2__():
			return smalltalk.String("") 
		def __blk3__():
			return smalltalk.object_comma_(smalltalk.String(",smalltalk."),tuple.last()) 
		__0__.className=tuple.first() 
		__0__.fn=tuple.at_(smalltalk.Number(2)) 
		__0__.superclass=smalltalk.if_true_false_(smalltalk.isObject_equalTo_(tuple.size(),smalltalk.Number(2)),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)) 
		return self.write_on_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("smalltalk.mapClassName("),smalltalk.printString_(__0__.className)),smalltalk.String(",")),smalltalk.printString_(category)),smalltalk.String(",")),smalltalk.asString_(__0__.fn)),__0__.superclass),smalltalk.String(")")),aStream) 
	__0__.className=nil
	__0__.fn=nil
	__0__.superclass=nil
	mappings.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Snapshot_write_mappings_on_")
,"writing","""write: category mappings: mappings on: aStream
	" Private - Write the mappings onto aStream. "

	| className fn superclass |
	mappings do: [:tuple|
		className := tuple first.
		fn := tuple at: 2.
		superclass := tuple size = 2 ifTrue: [ '' ]
			ifFalse: [ ',smalltalk.',tuple last ]. 
		self write: 'smalltalk.mapClassName('
			,className printString, ','
			,category printString, ','
			,fn asString ,superclass
			,')' on: aStream.
	]""",nil)
smalltalk.bind(smalltalk.Snapshot,"writeImageContents:on:",0
,smalltalk.__f__("""(self,aSmalltalk,aStream):
	#Snapshot>>#writeImageContents:on:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		return each.aboutToSaveImage_on_(self,aStream) 
	def __blk2__(each):
		return smalltalk.notNil_(each) 
	def __blk3__(each):
		return each.imageSaved_on_(self,aStream) 
	__0__.exporter=nil
	__0__.globals=nil
	__0__.classes=nil
	aStream.cr() 
	__0__.exporter=self.exporterFor_(aSmalltalk) 
	__0__.globals=self.globalsIn_(aSmalltalk) 
	__0__.classes=self.classesToExportFrom_with_(aSmalltalk,__0__.exporter).collect_(smalltalk.blk(__blk1__,1)).select_(smalltalk.blk(__blk2__,1)) 
	__0__.exporter.exportClasses_on_(__0__.classes,aStream) 
	self.exportGlobals_with_on_(__0__.globals,__0__.exporter,aStream) 
	__0__.classes.do_(smalltalk.blk(__blk3__,1)) 
	return self 
""","Snapshot_writeImageContents_on_")
,"writing","""writeImageContents: aSmalltalk on: aStream
	" Private - Write the image section of aSmalltalk system onto aStream. "

	| exporter globals classes |
	aStream cr.
	exporter := self exporterFor: aSmalltalk.
	globals := self globalsIn: aSmalltalk.
	classes := ((self classesToExportFrom: aSmalltalk with: exporter)
		collect: [:each| each aboutToSaveImage: self on: aStream ])
		select: [:each| each notNil ].
"	self exportGlobalNames: globals keys sorted in: aSmalltalk on: aStream.
"	exporter exportClasses: classes on: aStream.
	self exportGlobals: globals with: exporter on: aStream.
	classes do: [:each| each imageSaved: self on: aStream ].""",nil)
smalltalk.bind(smalltalk.Snapshot,"exporterFor:",0
,smalltalk.__f__("""(self,aSmalltalk):
	#Snapshot>>#exporterFor:
	return smalltalk.Exporter.new() 
""","Snapshot_exporterFor_")
,"exporting","""exporterFor: aSmalltalk
	" Private - Return the exporter to use to write contents of aSmalltalk system. "

	^Exporter new""",nil)
smalltalk.bind(smalltalk.Snapshot,"globalsIn:",0
,smalltalk.__f__("""(self,aSmalltalk):
	#Snapshot>>#globalsIn:
	__0__=smalltalk.newContext()
	def __blk1__(key):
		return __0__.result.at_put_(key,smalltalk.basic_at_(aSmalltalk,key)) 
	__0__.result=nil
	__0__.result=smalltalk.PoolDictionary.new() 
	aSmalltalk.globalsDo_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","Snapshot_globalsIn_")
,"exporting","""globalsIn: aSmalltalk
	" Private - Return the globals defined in aSmalltalk system. "

	| result |
	result := PoolDictionary new.
	aSmalltalk globalsDo: [:key| result at: key put: (aSmalltalk basicAt: key) ].
	^result""",nil)
smalltalk.bind(smalltalk.Snapshot,"classesToExportFrom:with:",0
,smalltalk.__f__("""(self,aSmalltalk,exporter):
	#Snapshot>>#classesToExportFrom:with:
	def __blk1__(each):
		return smalltalk.isNil_(each.superclass()) 
	def __blk2__(total,each):
		total.addAll_(each.withAllSubclasses()) 
		return total 
	return aSmalltalk.classes().select_(smalltalk.blk(__blk1__,1)).inject_into_(smalltalk.newArray([]),smalltalk.blk(__blk2__,2)) 
""","Snapshot_classesToExportFrom_with_")
,"exporting","""classesToExportFrom: aSmalltalk with: exporter
	" Private - Return the classes to export from aSmalltalk system. "

	^(aSmalltalk classes
		select: [:each| each superclass isNil ])
		inject: #() into: [:total :each| total addAll: each withAllSubclasses. total ]""",nil)
smalltalk.bind(smalltalk.Snapshot,"exportGlobalNames:in:on:",0
,smalltalk.__f__("""(self,names,aSmalltalk,aStream):
	#Snapshot>>#exportGlobalNames:in:on:
	def __blk1__(key):
		return aStream.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk["'),key),smalltalk.String('"]'))) 
	def __blk2__():
		return aStream.nextPutAll_(smalltalk.String(" , ")) 
	def __blk3__(_s8_rec):
		_s8_rec.nextPutAll_(smalltalk.String("=nil")) 
		return _s8_rec.cr() 
	names.do_separatedBy_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
	__blk3__(aStream) 
	return self 
""","Snapshot_exportGlobalNames_in_on_")
,"exporting","""exportGlobalNames: names in: aSmalltalk on: aStream
	" Private - Export global names in aSmalltalk system. "

	names
		do: [:key| aStream nextPutAll: 'smalltalk["',key,'"]' ]
		separatedBy: [ aStream nextPutAll: ' , ' ].
	aStream nextPutAll: '=nil'; cr.""",nil)
smalltalk.bind(smalltalk.Snapshot,"exportGlobals:with:on:",0
,smalltalk.__f__("""(self,globals,exporter,aStream):
	#Snapshot>>#exportGlobals:with:on:
	def __blk1__(binding):
		return self.write_on_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String('smalltalk["'),binding.key()),smalltalk.String('"]=')),exporter.exportObject_(binding.value())),aStream) 
	globals.associationsDo_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Snapshot_exportGlobals_with_on_")
,"exporting","""exportGlobals: globals with: exporter on: aStream
	" Private - Export global objects onto aStream. "

	globals associationsDo: [:binding|
		self write: 'smalltalk["',binding key,'"]='
			,(exporter exportObject: binding value)
			on: aStream
	]""",nil)
smalltalk.bind(smalltalk.Transcript.__class__,"current",0
,smalltalk.__f__("""(self):
	#Transcript class>>#current
	if smalltalk.b(smalltalk.isNil_(smalltalk.Transcript.classVariableAt_("Current"))):
		self.current_(self.new()) 
	 
	return smalltalk.Transcript.classVariableAt_("Current") 
""","Transcript_class_current")
,"singleton","""current
	" Return the current instance of the receiver. "

	Current isNil ifTrue: [ self current: self new ].
	^Current""",nil)
smalltalk.bind(smalltalk.Transcript.__class__,"current:",0
,smalltalk.__f__("""(self,aTranscript):
	#Transcript class>>#current:
	smalltalk.Transcript.classVariableAt_put_("Current",aTranscript) 
	return self 
""","Transcript_class_current_")
,"singleton","""current: aTranscript
	" Set the current instance of the receiver. "

	Current := aTranscript""",nil)
smalltalk.bind(smalltalk.Transcript.__class__,"cr",0
,smalltalk.__f__("""(self):
	#Transcript class>>#cr
	return self.current().cr() 
""","Transcript_class_cr")
,"io","""cr
	" Output a line break onto the current instance. "

	^self current cr""",nil)
smalltalk.bind(smalltalk.Transcript.__class__,"nextPutAll:",0
,smalltalk.__f__("""(self,aString):
	#Transcript class>>#nextPutAll:
	return self.current().nextPutAll_(aString) 
""","Transcript_class_nextPutAll_")
,"io","""nextPutAll: aString
	" Output aString onto the current instance. "

	^self current nextPutAll: aString""",nil)
smalltalk.bind(smalltalk.Transcript.__class__,"show:",0
,smalltalk.__f__("""(self,aString):
	#Transcript class>>#show:
	return self.current().show_(aString) 
""","Transcript_class_show_")
,"io","""show: aString
	" Output aString onto the current instance (ensure result is shown). "

	^self current show: aString""",nil)
smalltalk.bind(smalltalk.Transcript,"initializeStreams",0
,smalltalk.__f__("""(self):
	#Transcript>>#initializeStreams
	smalltalk.basic_at_put(self,"@streams",smalltalk.Array.new()) 
	return self 
""","Transcript_initializeStreams")
,"initialize","""initializeStreams
	" Private - Initialize the streams of the receiver. "

	streams := Array new""",nil)
smalltalk.bind(smalltalk.Transcript,"streams",0
,smalltalk.__f__("""(self):
	#Transcript>>#streams
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@streams",nil))):
		self.initializeStreams() 
	 
	return getattr(self,"@streams",nil) 
""","Transcript_streams")
,"accessing","""streams
	" Return the streams of the receiver. "

	streams isNil ifTrue: [ self initializeStreams ].
	^streams""",nil)
smalltalk.bind(smalltalk.Transcript,"streams:",0
,smalltalk.__f__("""(self,anObject):
	#Transcript>>#streams:
	smalltalk.basic_at_put(self,"@streams",anObject) 
	return self 
""","Transcript_streams_")
,"accessing","""streams: anObject
	" Set the streams of the receiver. "

	streams := anObject""",nil)
smalltalk.bind(smalltalk.Transcript,"cr",0
,smalltalk.__f__("""(self):
	#Transcript>>#cr
	def __blk1__(each):
		return each.cr() 
	self.streams().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Transcript_cr")
,"io","""cr
	" Output a line break onto the receiver. "

	self streams do: [:each| each cr ]""",nil)
smalltalk.bind(smalltalk.Transcript,"nextPutAll:",0
,smalltalk.__f__("""(self,aString):
	#Transcript>>#nextPutAll:
	def __blk1__(each):
		return each.nextPutAll_(smalltalk.asString_(aString)) 
	self.streams().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Transcript_nextPutAll_")
,"io","""nextPutAll: aString
	" Output aString onto the receiver. "

	self streams do: [:each| each nextPutAll: aString asString ]""",nil)
smalltalk.bind(smalltalk.Transcript,"show:",0
,smalltalk.__f__("""(self,aString):
	#Transcript>>#show:
	self.nextPutAll_(aString) 
	return self 
""","Transcript_show_")
,"io","""show: aString
	" Output aString onto the receiver (ensure result is shown). "

	self nextPutAll: aString""",nil)
smalltalk.bind(smalltalk.Transcript,"flush",0
,smalltalk.__f__("""(self):
	#Transcript>>#flush
	def __blk1__(each):
		def __blk2__():
			return each.flush() 
		return smalltalk.if_true_false_(smalltalk.responds_to_(each,(smalltalk.String("flush"))),smalltalk.blk(__blk2__,0),nil) 
	self.streams().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","Transcript_flush")
,"io","""flush
	" Flush the receiver. "

	self streams do: [:each|
		(each respondsTo: #flush) ifTrue: [ each flush ]
	]""",nil)
smalltalk.bind(smalltalk.Transcript,"inUse",0
,smalltalk.__f__("""(self):
	#Transcript>>#inUse
	def __blk1__():
		return getattr(self,"@streams",nil).notEmpty() 
	return smalltalk.boolean_and_(smalltalk.notNil_(getattr(self,"@streams",nil)),smalltalk.blk(__blk1__,0)) 
""","Transcript_inUse")
,"query","""inUse
	" Return true if the receiver is in use. "

	^streams notNil and: [streams notEmpty]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"undefined",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#undefined
	return None 
""","NativeObject_class_undefined")
,"constants","""undefined
	" Private - Return the native representation for undefined. "

	^{''js'undefined'}""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"nativeNameFromSelector:",0
,smalltalk.__f__("""(self,aSymbol):
	#NativeObject class>>#nativeNameFromSelector:
	return aSymbol 
""","NativeObject_class_nativeNameFromSelector_")
,"builders","""nativeNameFromSelector: aSymbol
	" Private - Return the property name for selector aSymbol. "

	^aSymbol""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildGetterCode:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildGetterCode:
	if smalltalk.b(self.instanceVariableNames().includes_(aSelector)):
		return smalltalk.superReceiver(smalltalk.NativeObject.__class__,self).buildGetterCode_(aSelector) 
	 
	return smalltalk.object_comma_(smalltalk.String("^self handle basicAt: "),self.nativeNameFromSelector_(aSelector).asLiteral()) 
""","NativeObject_class_buildGetterCode_")
,"builders-private","""buildGetterCode: aSelector
	" Private - Return source code to get aSelector. "

	(self instanceVariableNames includes: aSelector) ifTrue: [
		^super buildGetterCode: aSelector
	].
	^'^self handle basicAt: '
		,(self nativeNameFromSelector: aSelector) asLiteral""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildGetter:",0
,smalltalk.__f__("""(self,spec):
	#NativeObject class>>#buildGetter:
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(spec.second(),smalltalk.String("initialize")) 
		return smalltalk.boolean_and_(spec.isArray(),smalltalk.blk(__blk2__,0)) 
	if smalltalk.b(smalltalk.boolean_or_(spec.isString(),smalltalk.blk(__blk1__,0))):
		return smalltalk.superReceiver(smalltalk.NativeObject.__class__,self).buildGetter_(spec) 
	 
	return self.buildTypedGetter_(spec) 
""","NativeObject_class_buildGetter_")
,"builders","""buildGetter: spec
	" Build method for getter. "

	(spec isString or: [
		spec isArray and: [
		spec second = #initialize ]]) ifTrue: [
		^super buildGetter: spec
	].
	^self buildTypedGetter: spec""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildSetterCode:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildSetterCode:
	if smalltalk.b(self.instanceVariableNames().includes_(aSelector)):
		return smalltalk.superReceiver(smalltalk.NativeObject.__class__,self).buildSetterCode_(aSelector) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("self handle basicAt: "),self.nativeNameFromSelector_(aSelector).asLiteral()),smalltalk.String(" put: anObject")) 
""","NativeObject_class_buildSetterCode_")
,"builders-private","""buildSetterCode: aSelector
	" Private - Return source code to set aSelector. "

	(self instanceVariableNames includes: aSelector) ifTrue: [
		^super buildSetterCode: aSelector
	].
	^'self handle basicAt: '
		,(self nativeNameFromSelector: aSelector) asLiteral
		, ' put: anObject'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildSetter:",0
,smalltalk.__f__("""(self,spec):
	#NativeObject class>>#buildSetter:
	def __blk1__():
		def __blk2__():
			return smalltalk.isObject_equalTo_(spec.second(),smalltalk.String("initialize")) 
		return smalltalk.boolean_and_(spec.isArray(),smalltalk.blk(__blk2__,0)) 
	if smalltalk.b(smalltalk.boolean_or_(spec.isString(),smalltalk.blk(__blk1__,0))):
		return smalltalk.superReceiver(smalltalk.NativeObject.__class__,self).buildSetter_(spec) 
	 
	return self.buildTypedSetter_(spec) 
""","NativeObject_class_buildSetter_")
,"builders","""buildSetter: spec
	" Private - Return source code for setter. "

	(spec isString or: [
		spec isArray and: [
		spec second = #initialize ]]) ifTrue: [
		^super buildSetter: spec
	].
	^self buildTypedSetter: spec""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildTypedGetter:",0
,smalltalk.__f__("""(self,tuple):
	#NativeObject class>>#buildTypedGetter:
	def __blk1__():
		return self.implement_comment_as_category_(self.stMessageHeader_(tuple.first()),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),tuple.first()),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^"),self.apiPrologueFor_(tuple.last())),smalltalk.String("self handle basicAt: ")),self.nativeNameFromSelector_(tuple.first()).asLiteral()),smalltalk.String(")")),smalltalk.String("accessing")) 
	if smalltalk.b(tuple.isString()):
		return self.buildGetter_(tuple) 
	 
	return self.build_doing_(smalltalk.String("TypedGetter")._minus_gt(tuple),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildTypedGetter_")
,"builders","""buildTypedGetter: tuple
	" Build (instance) method to get property from spec array. "

	tuple isString ifTrue: [ ^self buildGetter: tuple ].
	^self build: #TypedGetter -> tuple doing: [
		self
			implement: (self stMessageHeader: tuple first)
			comment: 'Return the ' ,tuple first ,' of the receiver.'
			as: '^'	,(self apiPrologueFor: tuple last)
				,'self handle basicAt: '
				,(self nativeNameFromSelector: tuple first) asLiteral
				,')'
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildTypedSetter:",0
,smalltalk.__f__("""(self,tuple):
	#NativeObject class>>#buildTypedSetter:
	def __blk1__():
		return self.implement_comment_as_category_(self.stMessageHeader_(smalltalk.object_comma_(tuple.first(),smalltalk.String(": anObject"))),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Set the "),tuple.first()),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("self handle basicAt: "),self.nativeNameFromSelector_(tuple.first()).asLiteral()),smalltalk.String(" put: anObject handle")),smalltalk.String("accessing")) 
	if smalltalk.b(tuple.isString()):
		return self.buildSetter_(tuple) 
	 
	return self.build_doing_(smalltalk.String("TypedSetter")._minus_gt(tuple),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildTypedSetter_")
,"builders","""buildTypedSetter: tuple
	" Build (instance) method to set property to spec array. "

	tuple isString ifTrue: [ ^self buildSetter: tuple ].
	^self build: #TypedSetter -> tuple doing: [
		self
			implement: (self stMessageHeader: tuple first , ': anObject')
			comment: 'Set the ' ,tuple first ,' of the receiver.'
			as: 'self handle basicAt: '
				,(self nativeNameFromSelector: tuple first) asLiteral
				,' put: anObject handle'
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildTypedGetters:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildTypedGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildTypedGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	return self.build_doing_(smalltalk.String("TypedGetters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildTypedGetters_")
,"builders","""buildTypedGetters: specs
	" Build (instance) methods to get properties. "

	^self build: #TypedGetters -> specs doing: [
		specs compose: [:each| self buildTypedGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildTypedAccessors:",0
,smalltalk.__f__("""(self,tuples):
	#NativeObject class>>#buildTypedAccessors:
	def __blk1__():
		def __blk2__(each):
			return smalltalk.object_comma_(self.buildTypedGetter_(each),self.buildTypedSetter_(each)) 
		return tuples.compose_(smalltalk.blk(__blk2__,1)) 
	return self.build_doing_(smalltalk.String("TypedAccessors")._minus_gt(tuples),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildTypedAccessors_")
,"builders","""buildTypedAccessors: tuples
	" Build (instance) methods to get/set property from/to tuples. "
	
	^self build: #TypedAccessors -> tuples doing: [
		tuples compose: [:each|
			(self buildTypedGetter: each)
			,(self buildTypedSetter: each)
		]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFastGetter:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildFastGetter:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.implement_comment_as_category_(self.stMessageHeader_(aSelector),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^"),__0__.type),smalltalk.String("handle#")),__0__.jsName),smalltalk.String("accessing")) 
	__0__.type=nil
	__0__.jsName=nil
	if smalltalk.b(aSelector.isString()):
		__0__.type=smalltalk.String("") 
		__0__.jsName=self.nativeNameFromSelector_(aSelector) 
	else:
		__0__.type=aSelector.last() 
		__0__.jsName=self.nativeNameFromSelector_(aSelector.first()) 
	 
	return self.build_doing_(smalltalk.String("FastGetter")._minus_gt(aSelector),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildFastGetter_")
,"builders","""buildFastGetter: aSelector
	" Build (instance) method to get native property. "

	| type jsName |
	aSelector isString
		ifTrue: [ type := ''. jsName := self nativeNameFromSelector: aSelector ]
		ifFalse: [ type := aSelector last. jsName := self nativeNameFromSelector: aSelector first ].
	^self build: #FastGetter -> aSelector doing: [
		self
			implement: (self stMessageHeader: aSelector)
			comment: 'Return the ' ,aSelector ,' of the receiver.'
			as: '^' ,type ,'handle#' ,jsName category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFastSetter:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildFastSetter:
	__0__=smalltalk.newContext()
	def __blk1__():
		return self.implement_comment_as_category_(smalltalk.object_comma_(self.stMessageHeader_(aSelector),smalltalk.String(": anObject")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Set the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("handle#"),__0__.jsName),smalltalk.String(" := anObject")),smalltalk.String("accessing")) 
	__0__.jsName=nil
	if smalltalk.b(aSelector.isString()):
		__0__.jsName=self.nativeNameFromSelector_(aSelector) 
	else:
		__0__.jsName=self.nativeNameFromSelector_(aSelector.first()) 
	 
	return self.build_doing_(smalltalk.String("FastSetter")._minus_gt(aSelector),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildFastSetter_")
,"builders","""buildFastSetter: aSelector
	" Build (instance) method to set native property. "

	| jsName |
	aSelector isString
		ifTrue: [ jsName := self nativeNameFromSelector: aSelector ]
		ifFalse: [ jsName := self nativeNameFromSelector: aSelector first ].
	^self build: #FastSetter -> aSelector doing: [
		self
			implement: (self stMessageHeader: aSelector) ,': anObject'
			comment: 'Set the ' ,aSelector ,' of the receiver.'
			as: 'handle#' ,jsName ,' := anObject' category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFastAccessor:",0
,smalltalk.__f__("""(self,accessor):
	#NativeObject class>>#buildFastAccessor:
	if smalltalk.b(accessor.isString()):
		def __blk1__():
			return smalltalk.object_comma_(self.buildFastGetter_(accessor),self.buildFastSetter_(accessor)) 
		return self.build_doing_(smalltalk.String("FastAccessor")._minus_gt(accessor),smalltalk.blk(__blk1__,0)) 
	 
	return self.error_(smalltalk.String("Invalid (Fast)accessors.")) 
""","NativeObject_class_buildFastAccessor_")
,"builders","""buildFastAccessor: accessor
	" Build (instance) method to access native property. "

	accessor isString ifTrue: [
		^self build: #FastAccessor -> accessor doing: [
			(self buildFastGetter: accessor)
			,(self buildFastSetter: accessor)
		]
	].
	^self error: 'Invalid (Fast)accessors.'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFastGetters:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildFastGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildFastGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildFastGetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("FastGetters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildFastGetters_")
,"builders","""buildFastGetters: specs
	" Build methods to get properties. "

	specs isString ifTrue: [ ^self buildFastGetters: specs asArrayOfSubstrings ].
	^self build: #FastGetters -> specs doing: [
		specs compose: [:each| self buildFastGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFastAccessors:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildFastAccessors:
	def __blk1__():
		def __blk2__(each):
			return self.buildFastAccessor_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildFastAccessors_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("FastAccessors")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildFastAccessors_")
,"builders","""buildFastAccessors: specs
	" Build methods to access properties. "

	specs isString ifTrue: [ ^self buildFastAccessors: specs asArrayOfSubstrings ].
	^self build: #FastAccessors -> specs doing: [
		specs compose: [:each| self buildFastAccessor: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"codeToNumber",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#codeToNumber
	return " " 
""","NativeObject_class_codeToNumber")
,"constants","""codeToNumber
	" Private - Return the code to transform value to a number. "

	^{''js'" || 0"'}""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"handleAt:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#handleAt:
	return smalltalk.object_comma_(smalltalk.String("handle#"),self.nativeNameFromSelector_(aSelector)) 
""","NativeObject_class_handleAt_")
,"constants","""handleAt: aSelector
	" Private - Return the code for accessing instance handle. "

	^'handle#' ,(self nativeNameFromSelector: aSelector)""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildNumberGetter:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildNumberGetter:
	def __blk1__():
		return self.implement_comment_as_category_(self.stMessageHeader_(aSelector),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^"),self.handleAt_(aSelector)),self.codeToNumber()),smalltalk.String("accessing")) 
	return self.build_doing_(smalltalk.String("NumberGetter")._minus_gt(aSelector),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildNumberGetter_")
,"builders","""buildNumberGetter: aSelector
	" Build (instance) method to get native property. "

	^self build: #NumberGetter -> aSelector doing: [
		self
			implement: (self stMessageHeader: aSelector)
			comment: 'Return the ' ,aSelector ,' of the receiver.'
			as: $^ ,(self handleAt: aSelector) ,self codeToNumber
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildNumberAccessor:",0
,smalltalk.__f__("""(self,accessor):
	#NativeObject class>>#buildNumberAccessor:
	if smalltalk.b(accessor.isString()):
		def __blk1__():
			return smalltalk.object_comma_(self.buildNumberGetter_(accessor),self.buildSetter_(accessor)) 
		return self.build_doing_(smalltalk.String("NumberAccessor")._minus_gt(accessor),smalltalk.blk(__blk1__,0)) 
	 
	return self.error_(smalltalk.String("Invalid (Number)accessors.")) 
""","NativeObject_class_buildNumberAccessor_")
,"builders","""buildNumberAccessor: accessor
	" Build (instance) method to access native property. "

	accessor isString ifTrue: [
		^self build: #NumberAccessor -> accessor doing: [
			(self buildNumberGetter: accessor)
			,(self buildSetter: accessor)
		]
	].
	^self error: 'Invalid (Number)accessors.'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildNumberGetters:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildNumberGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildNumberGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildNumberGetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("NumberGetters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildNumberGetters_")
,"builders","""buildNumberGetters: specs
	" Build methods to get properties. "

	specs isString ifTrue: [ ^self buildNumberGetters: specs asArrayOfSubstrings ].
	^self build: #NumberGetters -> specs doing: [
		specs compose: [:each| self buildNumberGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildNumberAccessors:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildNumberAccessors:
	def __blk1__():
		def __blk2__(each):
			return self.buildNumberAccessor_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildNumberAccessors_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("NumberAccessors")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildNumberAccessors_")
,"builders","""buildNumberAccessors: specs
	" Build methods to access properties. "

	specs isString ifTrue: [ ^self buildNumberAccessors: specs asArrayOfSubstrings ].
	^self build: #NumberAccessors -> specs doing: [
		specs compose: [:each| self buildNumberAccessor: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildBooleanGetter:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildBooleanGetter:
	def __blk1__():
		return self.implement_comment_as_category_(self.stMessageHeader_(aSelector),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.String("^true == "),self.handleAt_(aSelector)),smalltalk.String("accessing")) 
	return self.build_doing_(smalltalk.String("BooleanGetter")._minus_gt(aSelector),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildBooleanGetter_")
,"builders","""buildBooleanGetter: aSelector
	" Build (instance) method to get native property. "

	^self build: #BooleanGetter -> aSelector doing: [
		self
			implement: (self stMessageHeader: aSelector)
			comment: 'Return the ' ,aSelector ,' of the receiver.'
			as: '^true == ' ,(self handleAt: aSelector)
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildBooleanAccessor:",0
,smalltalk.__f__("""(self,accessor):
	#NativeObject class>>#buildBooleanAccessor:
	if smalltalk.b(accessor.isString()):
		def __blk1__():
			return smalltalk.object_comma_(self.buildBooleanGetter_(accessor),self.buildSetter_(accessor)) 
		return self.build_doing_(smalltalk.String("BooleanAccessor")._minus_gt(accessor),smalltalk.blk(__blk1__,0)) 
	 
	return self.error_(smalltalk.String("Invalid (Boolean)accessors.")) 
""","NativeObject_class_buildBooleanAccessor_")
,"builders","""buildBooleanAccessor: accessor
	" Build (instance) method to access native property. "

	accessor isString ifTrue: [
		^self build: #BooleanAccessor -> accessor doing: [
			(self buildBooleanGetter: accessor)
			,(self buildSetter: accessor)
		]
	].
	^self error: 'Invalid (Boolean)accessors.'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildBooleanGetters:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildBooleanGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildBooleanGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildBooleanGetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("BooleanGetters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildBooleanGetters_")
,"builders","""buildBooleanGetters: specs
	" Build methods to get properties. "

	specs isString ifTrue: [ ^self buildBooleanGetters: specs asArrayOfSubstrings ].
	^self build: #BooleanGetters -> specs doing: [
		specs compose: [:each| self buildBooleanGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildBooleanAccessors:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildBooleanAccessors:
	def __blk1__():
		def __blk2__(each):
			return self.buildBooleanAccessor_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildBooleanAccessors_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("BooleanAccessors")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildBooleanAccessors_")
,"builders","""buildBooleanAccessors: specs
	" Build methods to access properties. "

	specs isString ifTrue: [ ^self buildBooleanAccessors: specs asArrayOfSubstrings ].
	^self build: #BooleanAccessors -> specs doing: [
		specs compose: [:each| self buildBooleanAccessor: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildIsBooleanGetter:",0
,smalltalk.__f__("""(self,aSelector):
	#NativeObject class>>#buildIsBooleanGetter:
	def __blk1__():
		__1__=smalltalk.newContext()
		__1__.isSelector=nil
		__1__.isSelector=smalltalk.object_comma_(smalltalk.String("is"),aSelector.asGlobalName()) 
		return self.implement_comment_as_category_(self.stMessageHeader_(__1__.isSelector),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Return the "),aSelector),smalltalk.String(" of the receiver.")),smalltalk.object_comma_(smalltalk.String("^true == handle#"),self.nativeNameFromSelector_(__1__.isSelector)),smalltalk.String("accessing")) 
	return self.build_doing_(smalltalk.String("IsBooleanGetter")._minus_gt(aSelector),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildIsBooleanGetter_")
,"builders","""buildIsBooleanGetter: aSelector
	" Build (instance) method to get native property. "

	^self build: #IsBooleanGetter -> aSelector doing: [ | isSelector |
		isSelector :=  #is ,aSelector asGlobalName.
		self
			implement: (self stMessageHeader: isSelector)
			comment: 'Return the ' ,aSelector ,' of the receiver.'
			as: '^true == handle#' ,(self nativeNameFromSelector: isSelector)
			category: #accessing
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildIsBooleanAccessor:",0
,smalltalk.__f__("""(self,accessor):
	#NativeObject class>>#buildIsBooleanAccessor:
	if smalltalk.b(accessor.isString()):
		def __blk1__():
			return smalltalk.object_comma_(self.buildIsBooleanGetter_(accessor),self.buildSetter_(accessor)) 
		return self.build_doing_(smalltalk.String("IsBooleanAccessor")._minus_gt(accessor),smalltalk.blk(__blk1__,0)) 
	 
	return self.error_(smalltalk.String("Invalid (IsBoolean)accessors.")) 
""","NativeObject_class_buildIsBooleanAccessor_")
,"builders","""buildIsBooleanAccessor: accessor
	" Build (instance) method to access native property. "

	accessor isString ifTrue: [
		^self build: #IsBooleanAccessor -> accessor doing: [
			(self buildIsBooleanGetter: accessor)
			,(self buildSetter: accessor)
		]
	].
	^self error: 'Invalid (IsBoolean)accessors.'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildIsBooleanGetters:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildIsBooleanGetters:
	def __blk1__():
		def __blk2__(each):
			return self.buildIsBooleanGetter_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildIsBooleanGetters_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("IsBooleanGetters")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildIsBooleanGetters_")
,"builders","""buildIsBooleanGetters: specs
	" Build methods to get properties. "

	specs isString ifTrue: [ ^self buildIsBooleanGetters: specs asArrayOfSubstrings ].
	^self build: #IsBooleanGetters -> specs doing: [
		specs compose: [:each| self buildIsBooleanGetter: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildIsBooleanAccessors:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildIsBooleanAccessors:
	def __blk1__():
		def __blk2__(each):
			return self.buildIsBooleanAccessor_(each) 
		return specs.compose_(smalltalk.blk(__blk2__,1)) 
	if smalltalk.b(specs.isString()):
		return self.buildIsBooleanAccessors_(specs.asArrayOfSubstrings()) 
	 
	return self.build_doing_(smalltalk.String("IsBooleanAccessors")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
""","NativeObject_class_buildIsBooleanAccessors_")
,"builders","""buildIsBooleanAccessors: specs
	" Build methods to access properties. "

	specs isString ifTrue: [ ^self buildIsBooleanAccessors: specs asArrayOfSubstrings ].
	^self build: #IsBooleanAccessors -> specs doing: [
		specs compose: [:each| self buildIsBooleanAccessor: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildSubclasses:",0
,smalltalk.__f__("""(self,aCollection):
	#NativeObject class>>#buildSubclasses:
	__0__=smalltalk.newContext()
	def __blk1__(tuple):
		def __blk2__():
			return self.buildSubclass_arguments_typed_(tuple,smalltalk.newArray([]),smalltalk.newArray([])) 
		def __blk3__():
			def __blk4__():
				return self.buildSubclass_arguments_typed_(tuple.first(),tuple.second(),smalltalk.newArray([])) 
			def __blk5__():
				return self.buildSubclass_arguments_typed_(tuple.first(),tuple.second(),tuple.last()) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(tuple.size(),smalltalk.Number(2)),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		__0__.result=smalltalk.if_true_false_(tuple.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0))
		return __0__.result 
	__0__.result=nil
	aCollection.do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","NativeObject_class_buildSubclasses_")
,"builder","""buildSubclasses: aCollection
	" Private - Build aCollection of subclasses of the receiver as wrappers to the library.
	Return the last class created (or nil).
	"
 
	| result |
	aCollection do: [:tuple|
		result := tuple isString
		ifTrue: [ self buildSubclass: tuple arguments: #() typed: #() ]
		ifFalse: [
			tuple size = 2
			ifTrue: [ self buildSubclass: tuple first arguments: tuple second typed: #() ]
			ifFalse: [ self buildSubclass: tuple first arguments: tuple second typed: tuple last ]
		 ]
	].
	^result""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildHierarchy:",0
,smalltalk.__f__("""(self,aCollection):
	#NativeObject class>>#buildHierarchy:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.stream.atEnd() 
	__0__.stream=nil
	__0__.aClass=nil
	__0__.stream=aCollection.stream() 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		def __blk2__():
			return __0__.aClass.buildHierarchy_(__0__.stream.next()) 
		__0__.aClass=self.buildSubclasses_(smalltalk.Array.with_(__0__.stream.next())) 
		smalltalk.if_true_false_(__0__.stream.peek().isArray(),smalltalk.blk(__blk2__,0),nil) 
	 
	return self 
""","NativeObject_class_buildHierarchy_")
,"builder","""buildHierarchy: aCollection
	" Private - Build aCollection of subclasses of the receiver as wrappers to the library. "
 
	| stream aClass |
	stream := aCollection stream.
	[ stream atEnd ] whileFalse: [
		aClass := self buildSubclasses: (Array with: stream next).
		stream peek isArray ifTrue: [
			aClass buildHierarchy: stream next
		].
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildSubclass:arguments:typed:",0
,smalltalk.__f__("""(self,globalClassName,argList,typedArguments):
	#NativeObject class>>#buildSubclass:arguments:typed:
	__0__=smalltalk.newContext()
	__0__.cls=nil
	__0__.clsName=nil
	__0__.clsName=smalltalk.object_comma_(globalClassName.first().asUppercase(),globalClassName.copyFrom_to_(smalltalk.Number(2),globalClassName.size())) 
	__0__.clsName=smalltalk.object_comma_(self.classToken(),__0__.clsName) 
	self.subclass_instanceVariableNames_category_(__0__.clsName,smalltalk.String(""),self.category()) 
	return smalltalk.Smalltalk.at_(__0__.clsName) 
""","NativeObject_class_buildSubclass_arguments_typed_")
,"builder","""buildSubclass: globalClassName arguments: argList typed: typedArguments
	" Private - Build a subclass of the receiver implementing a wrapper to the library.
	Note: argList and typed arguments are ignored; see subclasses to find concrete implementors.
	Return the created class.
	"

	| cls clsName |
	clsName := globalClassName first asUppercase
			,(globalClassName copyFrom: 2 to: globalClassName size).
	clsName := self classToken ,clsName.
	self
		subclass: clsName
		instanceVariableNames: ''
		category: self category.
	^Smalltalk at: clsName""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"classToken",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#classToken
	return smalltalk.String("") 
""","NativeObject_class_classToken")
,"builder","""classToken
	" Private - Return the classToken to prepend/tag the receiver.
	The default answer is empty.
	The subclasses can subclass to build tagged subclasses.
	"

	^''""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"classToken:",0
,smalltalk.__f__("""(self,aToken):
	#NativeObject class>>#classToken:
	return self.buildClassToken_(aToken) 
""","NativeObject_class_classToken_")
,"builder","""classToken: aToken
	" Private - Generate code to return the classToken of the receiver. "

	^self buildClassToken: aToken""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildClassToken:",0
,smalltalk.__f__("""(self,aToken):
	#NativeObject class>>#buildClassToken:
	def __blk1__():
		return self.implement_comment_as_category_(smalltalk.String("classToken"),smalltalk.String("Private - Return the classToken to prepend/tag the receiver."),smalltalk.object_comma_(smalltalk.String("^"),aToken.asLiteral()),smalltalk.String("builder")) 
	self.build_doing_(smalltalk.String("ClassToken")._minus_gt(aToken),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildClassToken_")
,"builder","""buildClassToken: aToken
	" Generate code to return the classToken of the receiver. "

	self build: #ClassToken -> aToken doing: [
		self
			implement: #classToken
			comment: 'Private - Return the classToken to prepend/tag the receiver.'
			as: $^ ,aToken asLiteral
			category: #builder
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFunctions:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildFunctions:
	def __blk1__():
		def __blk2__(spec):
			return self.buildFunction_(spec) 
		return specs.do_(smalltalk.blk(__blk2__,1)) 
	self.build_doing_(smalltalk.String("Functions")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildFunctions_")
,"builders","""buildFunctions: specs
	" Generate code from specs as functions implemented by instance handle. "

	self build: #Functions -> specs doing: [
		specs do: [:spec| self buildFunction: spec ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiPrologueFor:",0
,smalltalk.__f__("""(self,aReturnType):
	#NativeObject class>>#apiPrologueFor:
	if smalltalk.b(aReturnType.isEmpty()):
		return smalltalk.String("self ignoreReturn: (") 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(aReturnType.last(),smalltalk.String("("))):
		return aReturnType 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(aReturnType.last(),smalltalk.String("+"))):
		return self.apiPrologueFor_(smalltalk.object_comma_(aReturnType.upTo_(smalltalk.String("+")),smalltalk.String("[]"))) 
	 
	if smalltalk.b(aReturnType.includes_(smalltalk.String("["))):
		return self.apiPrologueForArray_(aReturnType) 
	 
	if smalltalk.b(aReturnType.includes_(smalltalk.String("<"))):
		return self.apiPrologueForTuple_(aReturnType) 
	 
	return smalltalk.object_comma_(self.apiWrapperFor_(aReturnType),smalltalk.String(" @ (")) 
""","NativeObject_class_apiPrologueFor_")
,"builders","""apiPrologueFor: aReturnType
	" Private - Return the prologue to use to wrap a return.
	aReturnType can be:
		- empty string to ignore api return value (will return the receiver)
		- suffixed by [...] or + to return an arrayed result
		- suffixed by type spec GlobalName
		- smalltalk code ending with (
		- a global name understanding #@
	"

	aReturnType isEmpty ifTrue: [ ^'self ignoreReturn: (' ].
	aReturnType last = $( ifTrue: [ ^aReturnType ].
	aReturnType last = $+ ifTrue: [
		^self apiPrologueFor: (aReturnType upTo: $+) ,'[]'
	].
	(aReturnType includes: $[) ifTrue: [
		^self apiPrologueForArray: aReturnType
	].
	(aReturnType includes: $<) ifTrue: [
		^self apiPrologueForTuple: aReturnType
	].

	^(self apiWrapperFor: aReturnType) ,' @ ('""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiPrologueForArray:",0
,smalltalk.__f__("""(self,aReturnType):
	#NativeObject class>>#apiPrologueForArray:
	__0__=smalltalk.newContext()
	__0__.type=nil
	__0__.stream=nil
	__0__.kind=nil
	__0__.stream=aReturnType.stream() 
	__0__.type=self.apiWrapperFor_(__0__.stream.upTo_(smalltalk.String("["))) 
	__0__.kind=__0__.stream.upTo_(smalltalk.String("]")) 
	if not smalltalk.b(__0__.stream.atEnd()):
		return self.error_(smalltalk.String("Invalid brackets for array")) 
	 
	if smalltalk.b(__0__.kind.isEmpty()):
		return smalltalk.object_comma_(__0__.type,smalltalk.String(" withAll: (")) 
	 
	if not smalltalk.b(__0__.kind.includes_(smalltalk.String(","))):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.type,smalltalk.String(" of: ")),self.apiWrapperFor_(__0__.kind)),smalltalk.String(" withAll: (")) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.type,smalltalk.String(" of: ")),smalltalk.printString_(__0__.kind)),smalltalk.String(" withAll: (")) 
""","NativeObject_class_apiPrologueForArray_")
,"builders","""apiPrologueForArray: aReturnType
	" Private - Return the prologue to use to wrap an arrayed return.
	The returned code will be like:
		GlobalName withAll: (
		GlobalName of: ElementClass withAll: (
		GlobalName of: 'Type1,Type2,Type3' withAll: (
	"

	| type stream kind |
	stream := aReturnType stream.
	type := self apiWrapperFor: (stream upTo: $[).
	kind := stream upTo: $].
	stream atEnd ifFalse: [ ^self error: 'Invalid brackets for array' ].
	kind isEmpty ifTrue: [ ^type ,' withAll: ('].
	(kind includes: $,) ifFalse: [
		^type ,' of: ' ,(self apiWrapperFor: kind) ,' withAll: ('
	].	
	^type ,' of: ' ,kind printString ,' withAll: ('""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiPrologueForTuple:",0
,smalltalk.__f__("""(self,aReturnType):
	#NativeObject class>>#apiPrologueForTuple:
	__0__=smalltalk.newContext()
	__0__.type=nil
	__0__.stream=nil
	__0__.kind=nil
	__0__.stream=aReturnType.stream() 
	__0__.type=self.apiWrapperFor_(__0__.stream.upTo_(smalltalk.String("<"))) 
	__0__.kind=__0__.stream.upTo_(smalltalk.String(">")) 
	if not smalltalk.b(__0__.stream.atEnd()):
		return self.error_(smalltalk.String("Invalid code for typle")) 
	 
	if smalltalk.b(__0__.kind.isEmpty()):
		return self.error_(smalltalk.String("Empty types for tuple")) 
	 
	if not smalltalk.b(__0__.kind.includes_(smalltalk.String(","))):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.type,smalltalk.String(" of: ")),self.apiWrapperFor_(__0__.kind)),smalltalk.String(" with: (")) 
	 
	return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.type,smalltalk.String(" of: ")),smalltalk.printString_(__0__.kind)),smalltalk.String(" with: (")) 
""","NativeObject_class_apiPrologueForTuple_")
,"builders","""apiPrologueForTuple: aReturnType
	" Private - Return the prologue to use to wrap a tuple return.
	The returned code will be like:
		GlobalName of: 'Type1,Type2,Type3' with: (
	"

	| type stream kind |
	stream := aReturnType stream.
	type := self apiWrapperFor: (stream upTo: $<).
	kind := stream upTo: $>.
	stream atEnd ifFalse: [ ^self error: 'Invalid code for typle' ].
	kind isEmpty ifTrue:  [ ^self error: 'Empty types for tuple' ].
	(kind includes: $,) ifFalse: [
		^type ,' of: ' ,(self apiWrapperFor: kind) ,' with: ('
	].	
	^type ,' of: ' ,kind printString ,' with: ('""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiWrapperFor:",0
,smalltalk.__f__("""(self,aName):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeObject class>>#apiWrapperFor:
		def __blk1__():
			return smalltalk.raise_result_(_s8Ret_,self.defaultAPIWrapperFor_(aName)) 
		smalltalk.Smalltalk.at_ifAbsent_(aName,smalltalk.blk(__blk1__,0)) 
		smalltalk.raise_result_(_s8Ret_,aName) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeObject_class_apiWrapperFor_")
,"builders","""apiWrapperFor: aName
	" Private - Return the name to use to wrap API structures of type aName. "

	Smalltalk at: aName ifAbsent: [ ^self defaultAPIWrapperFor: aName ].
	^aName""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"defaultAPIWrapperFor:",0
,smalltalk.__f__("""(self,aName):
	#NativeObject class>>#defaultAPIWrapperFor:
	return aName 
""","NativeObject_class_defaultAPIWrapperFor_")
,"builders","""defaultAPIWrapperFor: aName
	" Private - Return the default name to use to wrap API structures of type aName.
	Default implementation will defer lookup upto runtime.
	"

	^aName""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFunction:",0
,smalltalk.__f__("""(self,spec):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeObject class>>#buildFunction:
		if smalltalk.b(spec.isArray()):
			def __blk1__():
				return spec.last().isString() 
			def __blk2__():
				return spec.last().isString() 
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,self.buildFunction_prologue_epilogue_(spec.first(),self.apiPrologueFor_(spec.second()),smalltalk.String(")"))) 
			if smalltalk.b(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(spec.size(),smalltalk.Number(3)),smalltalk.blk(__blk1__,0))):
				smalltalk.raise_result_(_s8Ret_,self.buildFunction_(smalltalk.Array.with_with_(smalltalk.Array.with_with_(spec.first(),spec.second()),spec.last()))) 
			 
			smalltalk.if_true_false_(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(spec.size(),smalltalk.Number(2)),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,self.buildFunction_prologue_epilogue_(spec,smalltalk.String(""),smalltalk.String(""))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeObject_class_buildFunction_")
,"builders","""buildFunction: spec
	" Private - Generate code from spec as functions on instance handle.
	spec can be:
		aSymbol (e.g. any smalltalk message selector)
		#( selector #ReturnType )
		#( selector #( argumentNames ) #ReturnType )
		#( #( selector #( argumentNames ) ) #ReturnType )
		#( selector #( argumentNames ) )
	argumentNames must match selector pattern
	if argumentNames is not given, it will be computed from selector pattern
	The function will return the result of calling the handle, wrapped to a ReturnType
	See implementation of #apiPrologueFor: for documentation on #ReturnType
	"

	spec isArray ifTrue: [
	    (spec size = 3 and: [spec last isString]) ifTrue: [ "#( selector #( argumentNames ) #ReturnType )"
		^self buildFunction: (Array
			with: (Array with: spec first with: spec second)
			with: spec last)
	    ]. 
	    (spec size = 2 and: [spec last isString]) ifTrue: [ "#( selector #ReturnType )"
		^self
			buildFunction: spec first
			prologue: (self apiPrologueFor: spec second)
			epilogue: ')'
	    ]. 
	].
	^self buildFunction: spec prologue: '' epilogue: ''""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFunction:prologue:epilogue:",0
,smalltalk.__f__("""(self,spec,prologue,epilogue):
	#NativeObject class>>#buildFunction:prologue:epilogue:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return smalltalk.object_comma_(smalltalk.String("arg"),smalltalk.asString_(i)) 
	__0__.args=nil
	if smalltalk.b(spec.isArray()):
		return self.buildFunction_arguments_prologue_epilogue_(spec.first(),spec.last(),prologue,epilogue) 
	 
	__0__.args=smalltalk.Number(1).to_(spec.occurrencesOf_(smalltalk.String(":"))).collect_(smalltalk.blk(__blk1__,1)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.args.size(),smalltalk.Number(1))):
		__0__.args=smalltalk.newArray(["anObject"]) 
	 
	return self.buildFunction_arguments_prologue_epilogue_(spec,__0__.args,prologue,epilogue) 
""","NativeObject_class_buildFunction_prologue_epilogue_")
,"builders","""buildFunction: spec prologue: prologue epilogue: epilogue 
	" Private - Generate code for spec to apply on instance handle. "

	| args |
	spec isArray ifTrue: [ "#( selector #(argumentNames) )"
		^self	buildFunction: spec first
			arguments: spec last
			prologue: prologue epilogue: epilogue
	].
	args :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].
	args size = 1 ifTrue: [ args := #( #anObject ) ].
	^self
		buildFunction: spec arguments: args
		prologue: prologue epilogue: epilogue  """,nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiSelector:forArguments:",0
,smalltalk.__f__("""(self,callName,args):
	#NativeObject class>>#apiSelector:forArguments:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		__1__=smalltalk.newContext()
		__1__.argName=nil
		__1__.argName=args.at_(i) 
		if smalltalk.b(__1__.argName.isArray()):
			__1__.argName=__1__.argName.first() 
		 
		return __0__.parts.add_(__1__.argName) 
	def __blk2__(total,part):
		return smalltalk.object_comma_(smalltalk.object_comma_(total,part),smalltalk.String(":")) 
	__0__.parts=nil
	if smalltalk.b(args.isEmpty()):
		return callName 
	 
	__0__.parts=callName.asArrayOfSubstringsSeparatedBy_(smalltalk.String(":")) 
	if smalltalk.b(__0__.parts.last().isEmpty()):
		__0__.parts.removeLast() 
	 
	__0__.parts.size()._plus(smalltalk.Number(1)).to_do_(args.size(),smalltalk.blk(__blk1__,1)) 
	return __0__.parts.inject_into_(smalltalk.String(""),smalltalk.blk(__blk2__,2)) 
""","NativeObject_class_apiSelector_forArguments_")
,"builders","""apiSelector: callName forArguments: args
	" Private - Return the api selector to implement a native call with arguments. "

	| parts |
	args isEmpty ifTrue: [ ^callName ].
	parts := callName asArrayOfSubstringsSeparatedBy: $:.
	parts last isEmpty ifTrue: [ parts removeLast ].
	parts size + 1 to: args size do: [:i| | argName |
		argName := args at: i.
		argName isArray ifTrue: [ argName := argName first ].
		parts add: argName
	].
	^parts inject: '' into: [:total :part| total ,part ,$: ]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiArgumentsFrom:",0
,smalltalk.__f__("""(self,array):
	#NativeObject class>>#apiArgumentsFrom:
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return smalltalk.isObject_equalTo_(each.first(),__0__.tag) 
		def __blk3__():
			__2__=smalltalk.newContext()
			def __blk4__():
				return smalltalk.Array.with_with_(__2__.varName.copyFrom_to_(smalltalk.Number(1),__2__.varName.size()._minus(smalltalk.Number(1))),smalltalk.String("handles")) 
			def __blk5__():
				return smalltalk.Array.with_with_(__2__.varName,smalltalk.String("json")) 
			__2__.varName=nil
			__2__.varName=each.copyFrom_to_(smalltalk.Number(2),each.size()) 
			return smalltalk.if_true_false_(smalltalk.isObject_equalTo_(each.last(),__0__.tag),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
		def __blk6__():
			return each 
		return smalltalk.if_true_false_(smalltalk.boolean_and_(each.isString(),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk6__,0)) 
	__0__.tag=nil
	__0__.tag=smalltalk.String("_") 
	return array.collect_(smalltalk.blk(__blk1__,1)) 
""","NativeObject_class_apiArgumentsFrom_")
,"builders","""apiArgumentsFrom: array
	" Private - Return the arguments for API call. "

	| tag |
	tag := $_.
	^array collect: [:each|
		(each isString and: [ each first = tag ]) ifTrue: [ | varName |
			varName := each copyFrom: 2 to: each size.
			each last = tag
			ifTrue: [ Array with: (varName copyFrom: 1 to: varName size - 1) with: #handles ]
			ifFalse: [ Array with: varName with: #json ]
		] ifFalse: [ each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiSelectorAndFunctionName:forArguments:",0
,smalltalk.__f__("""(self,callName,args):
	#NativeObject class>>#apiSelectorAndFunctionName:forArguments:
	__0__=smalltalk.newContext()
	def __blk1__():
		return callName.isArray() 
	def __blk2__():
		return self.apiMessage_for_(callName,args) 
	def __blk3__():
		return self.apiMessage_for_(callName.first(),args) 
	def __blk4__():
		return callName 
	def __blk5__():
		return callName.last() 
	__0__.msgSelector=nil
	__0__.apiSelector=nil
	if not smalltalk.b(smalltalk.boolean_or_(callName.isString(),smalltalk.blk(__blk1__,0))):
		return self.error_(smalltalk.String("CallName must be aString or anArray")) 
	 
	__0__.msgSelector=self.apiSelector_forArguments_(smalltalk.if_true_false_(callName.isString(),smalltalk.blk(__blk2__,0),smalltalk.blk(__blk3__,0)),args) 
	__0__.apiSelector=self.apiSelector_forArguments_(smalltalk.if_true_false_(callName.isString(),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)),args) 
	return smalltalk.Array.with_with_(__0__.msgSelector,__0__.apiSelector) 
""","NativeObject_class_apiSelectorAndFunctionName_forArguments_")
,"builders","""apiSelectorAndFunctionName: callName forArguments: args
	" Private - Return the selector and api call to implement a native call with arguments. "

	| msgSelector apiSelector |
	(callName isString or: [callName isArray]) ifFalse: [
		^self error: 'CallName must be aString or anArray'
	].
	msgSelector := self apiSelector: (callName isString
		ifTrue: [ self apiMessage: callName for: args ]
		ifFalse: [ self apiMessage: callName first for: args ]) forArguments: args.
	apiSelector := self apiSelector: (callName isString
		ifTrue: [ callName ] ifFalse: [ callName last ]) forArguments: args.

	^Array with: msgSelector with: apiSelector""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiMessage:for:",0
,smalltalk.__f__("""(self,callName,args):
	#NativeObject class>>#apiMessage:for:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result 
	def __blk2__():
		return __0__.result.asLocalName() 
	__0__.result=nil
	__0__.result=callName 
	if smalltalk.b(smalltalk.isObject_equalTo_(self.nativeLanguage(),smalltalk.String("lua"))):
		def __blk3__():
			__0__.result=callName.copyFrom_to_(smalltalk.Number(2),callName.size())
			return __0__.result 
		smalltalk.if_true_false_(callName.startsWith_(smalltalk.String("_")),smalltalk.blk(__blk3__,0),nil) 
	 
	return smalltalk.if_true_false_(__0__.result.includes_(smalltalk.String(":")),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","NativeObject_class_apiMessage_for_")
,"builders","""apiMessage: callName for: args
	" Private - Return the message to implement for calling function callName.
	The default action use the callName as local name.
	It can be refined by subclasses to edit the name for better smalltalk looking of the message.
	"

	| result |
	result := callName.
	self nativeLanguage = #lua ifTrue: [
		(callName startsWith: $_) ifTrue: [ result := callName copyFrom: 2 to: callName size ].
	].
	^(result includes: $:) ifTrue: [ result ] ifFalse: [ result asLocalName ]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"apiEncode:call:arguments:on:header:",0
,smalltalk.__f__("""(self,delegate,aSelector,array,code,header):
	#NativeObject class>>#apiEncode:call:arguments:on:header:
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.argStream.atEnd() 
	__0__.pair=nil
	__0__.args=nil
	__0__.msgStream=nil
	__0__.apiStream=nil
	__0__.argStream=nil
	__0__.msg=nil
	__0__.args=self.apiArgumentsFrom_(array) 
	__0__.pair=self.apiSelectorAndFunctionName_forArguments_(aSelector,__0__.args) 
	__0__.msgStream=__0__.pair.first().stream() 
	__0__.apiStream=__0__.pair.last().stream() 
	__0__.argStream=__0__.args.stream() 
	code.nextPutAll_(delegate) 
	code.nextPut_(__0__.apiStream.next()) 
	header.nextPut_(__0__.msgStream.next()) 
	while not smalltalk.b(smalltalk.blk(__blk1__,0)()):
		__1__=smalltalk.newContext()
		__1__.param=nil
		__1__.expr=nil
		if smalltalk.b(__0__.argStream.peek().isString()):
			__1__.param=__0__.argStream.next() 
			__1__.expr=__1__.param 
		else:
			__1__.param=__0__.argStream.peek().first() 
			__1__.expr=smalltalk.object_comma_(smalltalk.object_comma_(__1__.param,smalltalk.String(" ")),__0__.argStream.next().last()) 
		 
		code.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.apiStream.upTo_(smalltalk.String(":")),smalltalk.String(": ")),__1__.expr),smalltalk.String(" "))) 
		header.nextPutAll_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(__0__.msgStream.upTo_(smalltalk.String(":")),smalltalk.String(": ")),__1__.param),smalltalk.String(" "))) 
	 
	code.nextPutAll_(__0__.apiStream.upToEnd()) 
	header.nextPutAll_(__0__.msgStream.upToEnd()) 
	return self 
""","NativeObject_class_apiEncode_call_arguments_on_header_")
,"builders","""apiEncode: delegate
	call: aSelector arguments: array
	on: code header: header
	" Private - Generate code to call function onto code&header streams. "

	| pair args msgStream apiStream argStream msg |
	args := self apiArgumentsFrom: array.
	pair := self apiSelectorAndFunctionName: aSelector forArguments: args.
	msgStream := pair first stream.
	apiStream := pair last stream.
	argStream := args stream.

	code	nextPutAll: delegate.
	code	nextPut: apiStream next.
	header	nextPut: msgStream next.

	[ argStream atEnd ] whileFalse: [ | param expr |
		argStream peek isString
		ifTrue: [ param := argStream next. expr := param ]
		ifFalse: [ param := argStream peek first. expr := param ,' ' ,argStream next last. ].
		code   nextPutAll: (apiStream upTo: $:) ,': ' ,expr ,' '.
		header nextPutAll: (msgStream upTo: $:) ,': ' ,param ,' '.
	].

	code   nextPutAll: apiStream upToEnd.
	header nextPutAll: msgStream upToEnd.""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"codeForInstanceReceiver",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#codeForInstanceReceiver
	return smalltalk.String("self handle #") 
""","NativeObject_class_codeForInstanceReceiver")
,"private","""codeForInstanceReceiver
	" Private - Return the code for the receiver of instance function call.
	Default answer asumes a wrapper calling with syntax sugar.
	This method can be refined to adapt to custom platform calls.
	"

	^'self handle #'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildFunction:arguments:prologue:epilogue:",0
,smalltalk.__f__("""(self,spec,args,prologue,epilogue):
	#NativeObject class>>#buildFunction:arguments:prologue:epilogue:
	__0__=smalltalk.newContext()
	def __blk1__(_s8_rec):
		_s8_rec.apiEncode_call_arguments_on_header_(self.codeForInstanceReceiver(),spec,args,__0__.code,__0__.header) 
		return _s8_rec.implement_comment_as_category_(self.stMessageHeader_(__0__.header.contents()),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Delegate "),spec),smalltalk.String(" to handle.")),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^"),prologue),__0__.code.contents()),epilogue),smalltalk.String("wrappers")) 
	__0__.header=nil
	__0__.code=nil
	__0__.header=smalltalk.String("").writeStream() 
	__0__.code=smalltalk.String("").writeStream() 
	__blk1__(self) 
	return self 
""","NativeObject_class_buildFunction_arguments_prologue_epilogue_")
,"builders","""buildFunction: spec arguments: args prologue: prologue epilogue: epilogue 
	" Private - Generate code to delegate message on instance handle. "

	| header code |
	header := '' writeStream. code := '' writeStream.
	self
	  apiEncode: self codeForInstanceReceiver
		call: spec arguments: args
		on: code header: header;
	  implement: (self stMessageHeader: header contents)
		comment: 'Delegate ' ,spec ,' to handle.'
		as: '^'	, prologue
			, code contents
			, epilogue
		category: #wrappers""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"codeForStaticReceiver",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#codeForStaticReceiver
	return smalltalk.String("self nativeClass handle #") 
""","NativeObject_class_codeForStaticReceiver")
,"private","""codeForStaticReceiver
	" Private - Return the code for the receiver of static function call.
	Default answer asumes a nativeClass wrapper calling with syntax sugar.
	This method can be refined to adapt to custom platform calls.
	"

	^'self nativeClass handle #'""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"nativeClass",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#nativeClass
	return self.implementedBySubclass_(smalltalk.String("nativeClass")) 
""","NativeObject_class_nativeClass")
,"private","""nativeClass
	" Private - Return the wrapper for native binding of the receiver. "

	^self implementedBySubclass: #nativeClass""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildStaticFunctions:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildStaticFunctions:
	def __blk1__():
		def __blk2__(each):
			return self.buildStaticFunction_(each) 
		return specs.do_(smalltalk.blk(__blk2__,1)) 
	self.build_doing_(smalltalk.String("StaticFunctions")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildStaticFunctions_")
,"builders","""buildStaticFunctions: specs
	" Generate code from specs as functions implemented implemented by native class. "

	self build: #StaticFunctions -> specs doing: [
		specs do: [:each| self buildStaticFunction: each ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildStaticFunction:",0
,smalltalk.__f__("""(self,spec):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeObject class>>#buildStaticFunction:
		if smalltalk.b(spec.isArray()):
			def __blk1__():
				return spec.last().isString() 
			def __blk2__():
				return spec.last().isString() 
			def __blk3__():
				return smalltalk.raise_result_(_s8Ret_,self.buildStaticFunction_prologue_epilogue_(spec.first(),self.apiPrologueFor_(spec.second()),smalltalk.String(")"))) 
			if smalltalk.b(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(spec.size(),smalltalk.Number(3)),smalltalk.blk(__blk1__,0))):
				smalltalk.raise_result_(_s8Ret_,self.buildStaticFunction_(smalltalk.Array.with_with_(smalltalk.Array.with_with_(spec.first(),spec.second()),spec.last()))) 
			 
			smalltalk.if_true_false_(smalltalk.boolean_and_(smalltalk.isObject_equalTo_(spec.size(),smalltalk.Number(2)),smalltalk.blk(__blk2__,0)),smalltalk.blk(__blk3__,0),nil) 
		 
		smalltalk.raise_result_(_s8Ret_,self.buildStaticFunction_prologue_epilogue_(spec,smalltalk.String(""),smalltalk.String(""))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeObject_class_buildStaticFunction_")
,"builders","""buildStaticFunction: spec
	" Private - Generate code to delegate message implemented as functions on native class. "

	spec isArray ifTrue: [
	    (spec size = 3 and: [spec last isString]) ifTrue: [ "#( selector #( argumentNames ) #RETURNClass )"
		^self buildStaticFunction: (Array
			with: (Array with: spec first with: spec second)
			with: spec last)
	    ]. 
	    (spec size = 2 and: [spec last isString]) ifTrue: [ "#( selector #RETURNClass )"
		^self
			buildStaticFunction: spec first
			prologue: (self apiPrologueFor: spec second)
			epilogue: ')'
	    ]. 
	].
	^self buildStaticFunction: spec prologue: '' epilogue: ''""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildStaticFunction:prologue:epilogue:",0
,smalltalk.__f__("""(self,spec,prologue,epilogue):
	#NativeObject class>>#buildStaticFunction:prologue:epilogue:
	__0__=smalltalk.newContext()
	def __blk1__(i):
		return smalltalk.object_comma_(smalltalk.String("arg"),smalltalk.asString_(i)) 
	__0__.args=nil
	if smalltalk.b(spec.isArray()):
		return self.buildStaticFunction_arguments_prologue_epilogue_(spec.first(),spec.last(),prologue,epilogue) 
	 
	__0__.args=smalltalk.Number(1).to_(spec.occurrencesOf_(smalltalk.String(":"))).collect_(smalltalk.blk(__blk1__,1)) 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.args.size(),smalltalk.Number(1))):
		__0__.args=smalltalk.newArray(["anObject"]) 
	 
	return self.buildStaticFunction_arguments_prologue_epilogue_(spec,__0__.args,prologue,epilogue) 
""","NativeObject_class_buildStaticFunction_prologue_epilogue_")
,"builders","""buildStaticFunction: spec prologue: prologue epilogue: epilogue 
	" Private - Generate code to delegate message on native class. "

	| args |
	spec isArray ifTrue: [ "#( selector #(argumentNames) )"
		^self	buildStaticFunction: spec first
			arguments: spec last
			prologue: prologue epilogue: epilogue
	].
	args :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].
	args size = 1 ifTrue: [ args := #( #anObject ) ].
	^self
		buildStaticFunction: spec arguments: args
		prologue: prologue epilogue: epilogue """,nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildStaticFunction:arguments:prologue:epilogue:",0
,smalltalk.__f__("""(self,spec,args,prologue,epilogue):
	#NativeObject class>>#buildStaticFunction:arguments:prologue:epilogue:
	__0__=smalltalk.newContext()
	__0__.header=nil
	__0__.code=nil
	__0__.header=smalltalk.String("").writeStream() 
	__0__.code=smalltalk.String("").writeStream() 
	self.apiEncode_call_arguments_on_header_(self.codeForStaticReceiver(),spec,args,__0__.code,__0__.header) 
	(self).__class__.implement_comment_as_category_(self.stMessageHeader_(__0__.header.contents()),smalltalk.String("Delegated to native class."),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^"),prologue),__0__.code.contents()),epilogue),smalltalk.String("wrappers")) 
	return self 
""","NativeObject_class_buildStaticFunction_arguments_prologue_epilogue_")
,"builders","""buildStaticFunction: spec arguments: args prologue: prologue epilogue: epilogue 
	" Private - Generate code to delegate message on native class. "

	| header code |
	header := '' writeStream. code := '' writeStream.
	self
	  apiEncode: self codeForStaticReceiver
		call: spec arguments: args
		on: code header: header.
	self class
		implement: (self stMessageHeader: header contents)
		  comment: 'Delegated to native class.'
		  as: '^'
			, prologue
			, code contents
			, epilogue
		  category: #wrappers""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"@","_at"
,smalltalk.__f__("""(self,handle):
	#NativeObject class>>#@
	return self.basicNew().handle_(handle) 
""","NativeObject_class__at")
,"instantiation","""@ handle
	" Return an instance of the receiver. "

	^self basicNew handle: handle""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"empty",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#empty
	return self._at(smalltalk.Object.new().json()) 
""","NativeObject_class_empty")
,"instantiation","""empty
	" Return an empty instance of the receiver. "

	^self @ Object new json""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"for:",0
,smalltalk.__f__("""(self,handle):
	#NativeObject class>>#for:
	return self.basicNew().handle_(handle) 
""","NativeObject_class_for_")
,"instantiation","""for: handle
	" Return an instance of the receiver. "

	^self basicNew handle: handle""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"withAll:",0
,smalltalk.__f__("""(self,handles):
	#NativeObject class>>#withAll:
	def __blk1__(each):
		return self._at(each) 
	return smalltalk.Array._at(handles).collect_(smalltalk.blk(__blk1__,1)) 
""","NativeObject_class_withAll_")
,"instantiation","""withAll: handles
	" Return a collection of instance of the receiver with handles. "

	^Array @ handles collect: [:each| self @ each ]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"of:withAll:",0
,smalltalk.__f__("""(self,aType,handles):
	#NativeObject class>>#of:withAll:
	return self.withAll_(smalltalk.Array._at(handles)) 
""","NativeObject_class_of_withAll_")
,"instantiation","""of: aType withAll: handles
	" Return an instance of the receiver wrapping handles with a type (or nil).
	Default implementation ignore the type.
	This method can be refined by subclasses to support typed wrappers.
	aType can be a class for type of elements or aString of comma separated type names.
	"

	^self withAll: Array @ handles""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"of:with:",0
,smalltalk.__f__("""(self,aType,aHandle):
	#NativeObject class>>#of:with:
	if smalltalk.b(smalltalk.isNil_(aHandle)):
		return nil 
	 
	return self.basicOf_with_(aType,aHandle) 
""","NativeObject_class_of_with_")
,"instantiation","""of: aType with: aHandle
	" Return an instance of the receiver wrapping aHandle with a type (or nil). "

	aHandle isNil ifTrue: [ ^nil ].
	^self basicOf: aType with: aHandle""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"basicOf:with:",0
,smalltalk.__f__("""(self,aType,aHandle):
	#NativeObject class>>#basicOf:with:
	return self.implementedBySubclass_(smalltalk.String("basicOf:with:")) 
""","NativeObject_class_basicOf_with_")
,"instantiation","""basicOf: aType with: aHandle
	" Private - Return an instance of the receiver wrapping aHandle with a type.
	aType can be a class for type of element or aString of comma separated type names.
	"

	^self implementedBySubclass: #basicOf:with:""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"html5Events",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#html5Events
	return smalltalk.newArray([]) 
""","NativeObject_class_html5Events")
,"events","""html5Events
	" Private - Return the html5 events+notifications managed by instances of the receiver.
	Default answer is empty, this method can be refined by subclasses to handle html5 events.
	"
	^#()""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"localEvents",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#localEvents
	return smalltalk.newArray([]) 
""","NativeObject_class_localEvents")
,"events","""localEvents
	" Private - Return the smalltalk events managed by instances of the receiver. "

	^#()""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"constructEventsTriggered",0
,smalltalk.__f__("""(self):
	#NativeObject class>>#constructEventsTriggered
	return smalltalk.object_comma_(smalltalk.object_comma_(self.html5Events(),self.localEvents()),smalltalk.superReceiver(smalltalk.NativeObject.__class__,self).constructEventsTriggered()) 
""","NativeObject_class_constructEventsTriggered")
,"events","""constructEventsTriggered
	" Private - Return the events managed by instances of the receiver. "

	^self html5Events
	,self localEvents
	,super constructEventsTriggered""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildHTML5Events:",0
,smalltalk.__f__("""(self,selectors):
	#NativeObject class>>#buildHTML5Events:
	def __blk1__():
		def __blk2__(total,each):
			return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(total,smalltalk.String("#")),each),smalltalk.String(" ")) 
		def __blk3__(each):
			return self.selectorForHTML5Event_(each) 
		(self).__class__.implement_comment_as_category_(smalltalk.String("html5Events"),smalltalk.String("Private - Return the html5 events managed by instances of the receiver."),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("^#( "),selectors.inject_into_(smalltalk.String(""),smalltalk.blk(__blk2__,2))),smalltalk.String(") , super html5Events")),smalltalk.String("events")) 
		return self.buildGetters_(selectors.collect_(smalltalk.blk(__blk3__,1))) 
	self.build_doing_(smalltalk.String("HTML5Events")._minus_gt(selectors),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildHTML5Events_")
,"builder","""buildHTML5Events: selectors
	" Private - Generate code to route events to handle. "

	self build: #HTML5Events -> selectors doing: [
		self class
			implement: #html5Events
			comment: 'Private - Return the html5 events managed by instances of the receiver.'
			as: '^#( ' ,(selectors inject: '' into: [:total :each|
				total ,'#',each ,' '
				]),') , super html5Events'
			category: #events.
		self buildGetters: (selectors collect: [:each|
			self selectorForHTML5Event: each
		]).
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"selectorForEvent:",0
,smalltalk.__f__("""(self,selector):
	#NativeObject class>>#selectorForEvent:
	def __blk1__():
		return self.selectorForHTML5Event_(selector) 
	if smalltalk.b(self.localEvents().includes_(selector)):
		return nil 
	 
	return smalltalk.if_true_false_(self.html5Events().includes_(selector),smalltalk.blk(__blk1__,0),nil) 
""","NativeObject_class_selectorForEvent_")
,"events","""selectorForEvent: selector
	" Private - Return the on... selector to use to register binding to selector. "

	(self localEvents includes: selector) ifTrue: [ ^nil ].
	^(self html5Events includes: selector) ifTrue: [
		self selectorForHTML5Event: selector
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"selectorForHTML5Event:",0
,smalltalk.__f__("""(self,selector):
	#NativeObject class>>#selectorForHTML5Event:
	return smalltalk.object_comma_(smalltalk.String("on"),selector.upTo_(smalltalk.String(":")).asSmalltalkName_(smalltalk.true)) 
""","NativeObject_class_selectorForHTML5Event_")
,"events","""selectorForHTML5Event: selector
	" Private - Return the on... selector to use to register binding to selector. "

	^#on , ((selector upTo: $:) asSmalltalkName: true)""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildPythonFunctions:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildPythonFunctions:
	def __blk1__():
		__1__=smalltalk.newContext()
		def __blk2__(spec):
			def __blk3__():
				return smalltalk.object_comma_(smalltalk.String("_"),spec) 
			def __blk4__():
				__3__=smalltalk.newContext()
				def __blk5__():
					return smalltalk.object_comma_(smalltalk.String("_"),spec.first()) 
				def __blk6__():
					def __blk7__(_s8_rec):
						_s8_rec.at_put_(smalltalk.Number(1),smalltalk.object_comma_(smalltalk.String("_"),spec.first().first())) 
						return _s8_rec.yourself() 
					return __blk7__(spec.first().copy()) 
				__3__.selector=nil
				__3__.selector=smalltalk.if_true_false_(spec.first().isString(),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
				return smalltalk.object_comma_(smalltalk.Array.with_(__3__.selector),spec.copyFrom_to_(smalltalk.Number(2),spec.size())) 
			return smalltalk.if_true_false_(spec.isString(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
		def __blk8__(spec):
			return self.buildFunction_(spec) 
		__1__.tuples=nil
		__1__.tuples=specs.collect_(smalltalk.blk(__blk2__,1)) 
		return __1__.tuples.do_(smalltalk.blk(__blk8__,1)) 
	self.build_doing_(smalltalk.String("PythonFunctions")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildPythonFunctions_")
,"Python-builders","""buildPythonFunctions: specs
	" Generate code from specs as raw functions implemented by instance handle. "

	self build: #PythonFunctions -> specs doing: [ | tuples |
		tuples := specs collect: [:spec|
			spec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |
				selector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [
					spec first copy at: 1 put: ($_ ,spec first first); yourself
				].
				(Array with: selector), (spec copyFrom: 2 to: spec size)
			]
		].
		tuples do: [:spec| self buildFunction: spec ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildPythonStaticFunctions:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildPythonStaticFunctions:
	def __blk1__():
		__1__=smalltalk.newContext()
		def __blk2__(spec):
			def __blk3__():
				return smalltalk.object_comma_(smalltalk.String("_"),spec) 
			def __blk4__():
				__3__=smalltalk.newContext()
				def __blk5__():
					return smalltalk.object_comma_(smalltalk.String("_"),spec.first()) 
				def __blk6__():
					def __blk7__(_s8_rec):
						_s8_rec.at_put_(smalltalk.Number(1),smalltalk.object_comma_(smalltalk.String("_"),spec.first().first())) 
						return _s8_rec.yourself() 
					return __blk7__(spec.first().copy()) 
				__3__.selector=nil
				__3__.selector=smalltalk.if_true_false_(spec.first().isString(),smalltalk.blk(__blk5__,0),smalltalk.blk(__blk6__,0)) 
				return smalltalk.object_comma_(smalltalk.Array.with_(__3__.selector),spec.copyFrom_to_(smalltalk.Number(2),spec.size())) 
			return smalltalk.if_true_false_(spec.isString(),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk4__,0)) 
		def __blk8__(spec):
			return self.buildStaticFunction_(spec) 
		__1__.tuples=nil
		__1__.tuples=specs.collect_(smalltalk.blk(__blk2__,1)) 
		return __1__.tuples.do_(smalltalk.blk(__blk8__,1)) 
	self.build_doing_(smalltalk.String("PythonStaticFunctions")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildPythonStaticFunctions_")
,"Python-builders","""buildPythonStaticFunctions: specs
	" Generate code from specs as raw functions implemented by class handle. "

	self build: #PythonStaticFunctions -> specs doing: [ | tuples |
		tuples := specs collect: [:spec|
			spec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |
				selector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [
					spec first copy at: 1 put: ($_ ,spec first first); yourself
				].
				(Array with: selector), (spec copyFrom: 2 to: spec size)
			]
		].
		tuples do: [:spec| self buildStaticFunction: spec ]
	]""",nil)
smalltalk.bind(smalltalk.NativeObject.__class__,"buildMethods:",0
,smalltalk.__f__("""(self,specs):
	#NativeObject class>>#buildMethods:
	def __blk1__():
		return self.buildFunctions_(specs) 
	self.build_doing_(smalltalk.String("Methods")._minus_gt(specs),smalltalk.blk(__blk1__,0)) 
	return self 
""","NativeObject_class_buildMethods_")
,"Python-builders","""buildMethods: specs
	" Generate code from specs as OO methods implemented by instance handle. "

	self build: #Methods -> specs doing: [
		self buildFunctions: specs
	]""",nil)
smalltalk.bind(smalltalk.NativeObject,"ignoreReturn:",0
,smalltalk.__f__("""(self,value):
	#NativeObject>>#ignoreReturn:
	return self 
""","NativeObject_ignoreReturn_")
,"api","""ignoreReturn: value
	" Private - Ignore the argument value.
	Return the receiver. \"""",nil)
smalltalk.bind(smalltalk.NativeObject,"@@","_at_at"
,smalltalk.__f__("""(self,path):
	#NativeObject>>#@@
	def __blk1__(h,each):
		def __blk2__():
			return smalltalk.basic_at_(h,each) 
		return smalltalk.if_true_false_(smalltalk.notNil_(h),smalltalk.blk(__blk2__,0),nil) 
	return path.asArrayOfSubstringsSeparatedBy_(smalltalk.String(".")).inject_into_(self.handle(),smalltalk.blk(__blk1__,2)) 
""","NativeObject__at_at")
,"accessing","""@@ path
	" Return the property at path of the receiver (or nil). "

	^(path asArrayOfSubstringsSeparatedBy: $.)
		inject: self handle into: [:h :each|
			h notNil ifTrue: [ h basicAt: each ]
		]""",nil)
smalltalk.bind(smalltalk.NativeObject,"<@","_lt_at"
,smalltalk.__f__("""(self,path):
	#NativeObject>>#<@
	return smalltalk.NativeHandle.support()._at(self._at_at(path)) 
""","NativeObject__lt_at")
,"accessing","""<@ path
	" Return the native property at path of the receiver (or nil). "

	^NativeHandle support @ (self @@ path)""",nil)
smalltalk.bind(smalltalk.NativeObject,"as:",0
,smalltalk.__f__("""(self,aNativeObjectClass):
	#NativeObject>>#as:
	__0__=smalltalk.newContext()
	__0__.result=nil
	if smalltalk.b(smalltalk.is_kindOf_(self,(aNativeObjectClass))):
		return self 
	 
	__0__.result=aNativeObjectClass._at(self.handle()) 
	if smalltalk.b(smalltalk.b_(__0__.result is self)):
		return self 
	 
	__0__.result.copyPropertiesFrom_(self) 
	return __0__.result 
""","NativeObject_as_")
,"converting","""as: aNativeObjectClass
	" Return the receiver casted to aNativeObjectClass. "

	| result |
	(self isKindOf: aNativeObjectClass) ifTrue: [ ^self ].
	result := aNativeObjectClass @ self handle.
	result == self ifTrue: [ ^self ].
	result copyPropertiesFrom: self.
	^result""",nil)
smalltalk.bind(smalltalk.NativeObject,"handle",0
,smalltalk.__f__("""(self):
	#NativeObject>>#handle
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@handle",nil))):
		self.initializeHandle() 
	 
	return getattr(self,"@handle",nil) 
""","NativeObject_handle")
,"accessing","""handle
	" Return the native handle. "

	handle isNil ifTrue: [ self initializeHandle ].
	^handle""",nil)
smalltalk.bind(smalltalk.NativeObject,"handleOrNil",0
,smalltalk.__f__("""(self):
	#NativeObject>>#handleOrNil
	return getattr(self,"@handle",nil) 
""","NativeObject_handleOrNil")
,"private","""handleOrNil
	" Return the native handle (or nil). "

	^handle""",nil)
smalltalk.bind(smalltalk.NativeObject,"=","_eq"
,smalltalk.__f__("""(self,anObject):
	#NativeObject>>#=
	def __blk1__():
		return smalltalk.b_(getattr(self,"@handle",nil) is anObject.handleOrNil()) 
	if smalltalk.b(smalltalk.b_(self is anObject)):
		return smalltalk.true 
	 
	if not smalltalk.b(self.isObject_(anObject)):
		return smalltalk.false 
	 
	return smalltalk.boolean_and_(smalltalk.responds_to_(anObject,(smalltalk.String("handleOrNil"))),smalltalk.blk(__blk1__,0)) 
""","NativeObject__eq")
,"testing","""= anObject

	self == anObject ifTrue: [ ^true ].
	(self isObject: anObject) ifFalse: [ ^false ].
	^(anObject respondsTo: #handleOrNil) and: [
		handle == anObject handleOrNil
	] """,nil)
smalltalk.bind(smalltalk.NativeObject,"handle:",0
,smalltalk.__f__("""(self,anAlien):
	#NativeObject>>#handle:
	smalltalk.basic_at_put(self,"@handle",anAlien) 
	if smalltalk.b(smalltalk.isNil_(getattr(self,"@handle",nil))):
		return nil 
	 
	return self 
""","NativeObject_handle_")
,"accessing","""handle: anAlien
	" Set the native handle to a potentialy native(non-S8) object.
	Return the receiver, or nil if the receiver is void.
	"

	handle := anAlien.
	handle isNil ifTrue: [ ^nil ].""",nil)
smalltalk.bind(smalltalk.NativeObject,"jsonHiddenNames",0
,smalltalk.__f__("""(self):
	#NativeObject>>#jsonHiddenNames
	return smalltalk.newArray(["handle"]) 
""","NativeObject_jsonHiddenNames")
,"converting","""jsonHiddenNames
	" Private - Return the names of the instance variables to skip when mapping the receiver to JSON structure. "

	^#( #handle )""",nil)
smalltalk.bind(smalltalk.NativeObject,"basicJson",0
,smalltalk.__f__("""(self):
	#NativeObject>>#basicJson
	return smalltalk.superReceiver(smalltalk.NativeObject,self).json() 
""","NativeObject_basicJson")
,"converting","""basicJson
	" Convert the receiver to JSON structure. "

	^super json""",nil)
smalltalk.bind(smalltalk.NativeObject,"json",0
,smalltalk.__f__("""(self):
	#NativeObject>>#json
	return self.handle() 
""","NativeObject_json")
,"converting","""json
	" Convert the receiver to JSON structure. "

	^self handle""",nil)
smalltalk.bind(smalltalk.NativeObject,"jsObject",0
,smalltalk.__f__("""(self):
	#NativeObject>>#jsObject
	return self.invalidMessage_(smalltalk.String("jsObject")) 
""","NativeObject_jsObject")
,"private","""jsObject
	" Private - Return the (native)Object. "

	^{''js'Object'}""",nil)
smalltalk.bind(smalltalk.NativeObject,"ownPropertyNames",0
,smalltalk.__f__("""(self):
	#NativeObject>>#ownPropertyNames
	keys=self.handle().keys()
	if True:
		return smalltalk.Array(list(keys))
	 
	return self 
""","NativeObject_ownPropertyNames")
,"accessing","""ownPropertyNames
	" Return the owned property names of the receiver. "

	{''js'return Object.getOwnPropertyNames(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.NativeObject,"@","_at"
,smalltalk.__f__("""(self,propertyName):
	#NativeObject>>#@
	return smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(propertyName)]) 
""","NativeObject__at")
,"accessing","""@ propertyName
	" Return the property at propertyName of the receiver. "

	^handle[propertyName]""",nil)
smalltalk.bind(smalltalk.NativeObject,"handleAt:",0
,smalltalk.__f__("""(self,propertyName):
	#NativeObject>>#handleAt:
	return smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(propertyName)]) 
""","NativeObject_handleAt_")
,"accessing","""handleAt: propertyName
	" Return the property at propertyName of the receiver. "

	^handle[propertyName]""",nil)
smalltalk.bind(smalltalk.NativeObject,"handleAt:put:",0
,smalltalk.__f__("""(self,propertyName,anObject):
	#NativeObject>>#handleAt:put:
	smalltalk.basic_at_put(self,"@handle",anObject)
	return getattr(self,"@handle",nil)[smalltalk.handleOf(propertyName)] 
""","NativeObject_handleAt_put_")
,"accessing","""handleAt: propertyName put: anObject
	" Set the property at propertyName of the receiver. "

	^handle[propertyName] := anObject""",nil)
smalltalk.bind(smalltalk.NativeObject,"initializeHandle",0
,smalltalk.__f__("""(self):
	#NativeObject>>#initializeHandle
	return self.error_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("Missing "),(self).__class__.name()),smalltalk.String(">>#initializeHandle"))) 
""","NativeObject_initializeHandle")
,"initialize","""initializeHandle
	" Private - Initialize the native handle.
	This method must be implemented by subclasses.
	"

	^self error: 'Missing '
		,self class name
		,'>>#initializeHandle'""",nil)
smalltalk.bind(smalltalk.NativeObject,"releaseHandle",0
,smalltalk.__f__("""(self):
	#NativeObject>>#releaseHandle
	smalltalk.basic_at_put(self,"@handle",nil) 
	return self 
""","NativeObject_releaseHandle")
,"release","""releaseHandle
	" Private - Release the native handle.
	The default implementation clear handle.
	This method can be refined by subclasses to free external resources.
	"

	handle := nil""",nil)
smalltalk.bind(smalltalk.NativeObject,"release",0
,smalltalk.__f__("""(self):
	#NativeObject>>#release
	self.releaseHandle() 
	return smalltalk.superReceiver(smalltalk.NativeObject,self).release() 
""","NativeObject_release")
,"release","""release
	" Private - Release the receiver. "

	self releaseHandle.
	^super release""",nil)
smalltalk.bind(smalltalk.NativeObject,"copyPropertiesFrom:",0
,smalltalk.__f__("""(self,aNativeObject):
	#NativeObject>>#copyPropertiesFrom:
	def __blk1__(key):
		return smalltalk.basic_at_put_(self,key,smalltalk.basic_at_(aNativeObject,key)) 
	aNativeObject.ownPropertyNames().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","NativeObject_copyPropertiesFrom_")
,"copying","""copyPropertiesFrom: aNativeObject
	" Private - Copy receiver's properties from aNativeObject. "

	aNativeObject ownPropertyNames do: [:key|
		self basicAt: key put: (aNativeObject basicAt: key)
	]""",nil)
smalltalk.bind(smalltalk.NativeObject,"shallowCopy",0
,smalltalk.__f__("""(self):
	#NativeObject>>#shallowCopy
	return self 
""","NativeObject_shallowCopy")
,"copying","""shallowCopy
	" Return a shallow copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.NativeObject,"deepCopy",0
,smalltalk.__f__("""(self):
	#NativeObject>>#deepCopy
	return self 
""","NativeObject_deepCopy")
,"copying","""deepCopy
	" Return a deep copy of the receiver. "

	^self""",nil)
smalltalk.bind(smalltalk.NativeObject,"closureForEvent:",0
,smalltalk.__f__("""(self,selector):
	#NativeObject>>#closureForEvent:
	__0__=smalltalk.newContext()
	__0__.argumentCount=nil
	__0__.argumentCount=selector.argumentCount() 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.argumentCount,smalltalk.Number(0))):
		def __blk1__():
			return self.triggerEvent_(selector) 
		return smalltalk.blk(__blk1__,0) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.argumentCount,smalltalk.Number(1))):
		def __blk2__(arg1):
			return self.triggerEvent_with_(selector,arg1) 
		return smalltalk.blk(__blk2__,1) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.argumentCount,smalltalk.Number(2))):
		def __blk3__(arg1,arg2):
			return self.triggerEvent_with_with_(selector,arg1,arg2) 
		return smalltalk.blk(__blk3__,2) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.argumentCount,smalltalk.Number(3))):
		def __blk4__(arg1,arg2,arg3):
			return self.triggerEvent_withArguments_(selector,smalltalk.Array.with_with_with_(arg1,arg2,arg3)) 
		return smalltalk.blk(__blk4__,3) 
	 
	if smalltalk.b(smalltalk.isObject_equalTo_(__0__.argumentCount,smalltalk.Number(4))):
		def __blk5__(arg1,arg2,arg3,arg4):
			return self.triggerEvent_withArguments_(selector,smalltalk.Array.with_with_with_with_(arg1,arg2,arg3,arg4)) 
		return smalltalk.blk(__blk5__,4) 
	 
	return self.error_(smalltalk.String("Invalid argument count")) 
""","NativeObject_closureForEvent_")
,"events","""closureForEvent: selector
	" Private - Return the closure to handle event selector. "

	| argumentCount |
	argumentCount := selector argumentCount.
	argumentCount = 0 ifTrue: [ ^[ self triggerEvent: selector ] ].
	argumentCount = 1 ifTrue: [ ^[:arg1| self triggerEvent: selector with: arg1 ] ].
	argumentCount = 2 ifTrue: [ ^[:arg1 :arg2| self triggerEvent: selector with: arg1 with: arg2 ] ].
	argumentCount = 3 ifTrue: [ ^[:arg1 :arg2 :arg3| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3) ] ].
	argumentCount = 4 ifTrue: [ ^[:arg1 :arg2 :arg3 :arg4| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3 with: arg4) ] ].
	^self error: 'Invalid argument count'""",nil)
smalltalk.bind(smalltalk.NativeObject,"when:evaluate:",0
,smalltalk.__f__("""(self,selector,anAction):
	#NativeObject>>#when:evaluate:
	__0__=smalltalk.newContext()
	def __blk1__():
		return nil 
	__0__.result=nil
	__0__.needsRegistration=nil
	__0__.needsRegistration=smalltalk.isNil_(self.eventTable().at_ifAbsent_(selector,smalltalk.blk(__blk1__,0))) 
	__0__.result=smalltalk.superReceiver(smalltalk.NativeObject,self).when_evaluate_(selector,anAction) 
	if smalltalk.b(__0__.needsRegistration):
		self.registerEvent_doing_(selector,self.closureForEvent_(selector)) 
	 
	return __0__.result 
""","NativeObject_when_evaluate_")
,"events","""when: selector evaluate: anAction
	" Register anAction to the be evaluated when the receiver triggers the event. "

	| result needsRegistration |
	needsRegistration := (self eventTable at: selector ifAbsent: [nil]) isNil.
	result := super when: selector evaluate: anAction.
	needsRegistration ifTrue: [
		self	registerEvent: selector
			doing: (self closureForEvent: selector).
	].
	^result""",nil)
smalltalk.bind(smalltalk.NativeObject,"registerEvent:doing:",0
,smalltalk.__f__("""(self,selector,closure):
	#NativeObject>>#registerEvent:doing:
	__0__=smalltalk.newContext()
	__0__.onSelector=nil
	__0__.onSelector=(self).__class__.selectorForEvent_(selector) 
	if smalltalk.b(smalltalk.isNil_(__0__.onSelector)):
		return self 
	 
	return self.bindEvent_doing_(__0__.onSelector,closure) 
""","NativeObject_registerEvent_doing_")
,"events","""registerEvent: selector doing: closure
	" Private - Register basic event handler. "

	| onSelector |
	onSelector := self class selectorForEvent: selector.
	onSelector isNil ifTrue: [ ^self ]. "local/smalltalk event"
	^self bindEvent: onSelector doing: closure""",nil)
smalltalk.bind(smalltalk.NativeObject,"bindEvent:doing:",0
,smalltalk.__f__("""(self,onSelector,closure):
	#NativeObject>>#bindEvent:doing:
	__0__=smalltalk.newContext()
	__0__.native=nil
	__0__.native=self.handle() 
	if smalltalk.b(smalltalk.isNil_(smalltalk.asObject_(__0__.native[smalltalk.handleOf(onSelector)]))):
		__0__.native[smalltalk.handleOf(onSelector)]=closure 
	else:
		smalltalk.asObject_(__0__.native[smalltalk.handleOf(onSelector)]).addListener(closure.json()) 
	 
	return self 
""","NativeObject_bindEvent_doing_")
,"events","""bindEvent: onSelector doing: closure
	" Private - Bind the event handler. "

	| native |
	native := self handle.
	native[onSelector] isNil ifTrue: [
		native[onSelector] := closure
	] ifFalse: [
		native[onSelector] #addListener: closure json
	]""",nil)
smalltalk.bind(smalltalk.NativeObject,"description",0
,smalltalk.__f__("""(self):
	#NativeObject>>#description
	return self.asNativeHandle().description() 
""","NativeObject_description")
,"debugging","""description
	" Return a string description from receiver's properties. "

	^self asNativeHandle description""",nil)
smalltalk.bind(smalltalk.NativeObject,"asDictionary",0
,smalltalk.__f__("""(self):
	#NativeObject>>#asDictionary
	__0__=smalltalk.newContext()
	def __blk1__(key):
		return __0__.result.at_put_(key,smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(key)])) 
	__0__.result=nil
	__0__.result=smalltalk.PoolDictionary.new() 
	self.ownPropertyNames().do_(smalltalk.blk(__blk1__,1)) 
	return __0__.result 
""","NativeObject_asDictionary")
,"converting","""asDictionary
	" Convert the receiver to a(Pool)Dictionary. "

	| result |
	result := PoolDictionary new.
	self ownPropertyNames do: [:key| result at: key put: handle[key] ].
	^result""",nil)
smalltalk.bind(smalltalk.NativeObject,"asNativeHandle",0
,smalltalk.__f__("""(self):
	#NativeObject>>#asNativeHandle
	return smalltalk.NativeHandle.support()._at(self.handle()) 
""","NativeObject_asNativeHandle")
,"converting","""asNativeHandle
	" Convert the receiver to NativeHandle instance (for reflection). "

	^NativeHandle support @ self handle""",nil)
smalltalk.bind(smalltalk.NativeObject,"asJS",0
,smalltalk.__f__("""(self):
	#NativeObject>>#asJS
	return smalltalk.NativeHandle.support()._at(self.handle()) 
""","NativeObject_asJS")
,"converting","""asJS
	" Convert the receiver to JS instance (for reflection). "

	^NativeHandle support @ self handle""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,language):
	#NativeHandle class>>#supportsLanguage:
	return smalltalk.false 
""","NativeHandle_class_supportsLanguage_")
,"instantiation","""supportsLanguage: language
	" Private - Return true if instances of the receiver implement native wrappers for language.
	Returns false. This method may be refined by subclasses. "

	^false""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"support",0
,smalltalk.__f__("""(self):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeHandle class>>#support
		__0__=smalltalk.newContext()
		def __blk1__(cls):
			def __blk2__():
				return smalltalk.raise_result_(_s8Ret_,cls) 
			return smalltalk.if_true_false_(cls.supportsLanguage_(__0__.lang),smalltalk.blk(__blk2__,0),nil) 
		__0__.lang=nil
		__0__.lang=self.nativeLanguage() 
		smalltalk.NativeHandle.allSubclassesDo_(smalltalk.blk(__blk1__,1)) 
		smalltalk.raise_result_(_s8Ret_,self.error_(smalltalk.String("Native handle support missing"))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeHandle_class_support")
,"instantiation","""support
	" Private - Return the support for hosting execution environment. "

	| lang |
	lang := self nativeLanguage.
	NativeHandle allSubclassesDo: [:cls|
		(cls supportsLanguage: lang) ifTrue: [
			^cls
		].
	].
	^self error: 'Native handle support missing'""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"@>","_at_gt"
,smalltalk.__f__("""(self,nativeObject):
	#NativeHandle class>>#@>
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result.description() 
	def __blk2__():
		return smalltalk.String("nil") 
	__0__.result=nil
	__0__.result=self._at(nativeObject) 
	return smalltalk.if_true_false_(smalltalk.notNil_(__0__.result),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","NativeHandle_class__at_gt")
,"converting","""@> nativeObject
	" Return the description of nativeObject. "

	| result |
	result := self @ nativeObject.
	^result notNil
		ifTrue: [ result description ]
		ifFalse: [ #nil ]""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"@","_at"
,smalltalk.__f__("""(self,nativeObject):
	#NativeHandle class>>#@
	def __blk1__():
		return nativeObject.isString() 
	if smalltalk.b(smalltalk.boolean_and_(self.isObject_(nativeObject),smalltalk.blk(__blk1__,0))):
		def __blk2__():
			nil 
		return smalltalk.superReceiver(smalltalk.NativeHandle.__class__,self)._at(smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(nativeObject,smalltalk.blk(__blk2__,0))) 
	 
	return smalltalk.superReceiver(smalltalk.NativeHandle.__class__,self)._at(nativeObject) 
""","NativeHandle_class__at")
,"instantiation","""@ nativeObject
	" Return an instance of the receiver. "

	((self isObject: nativeObject) and: [ nativeObject isString ]) ifTrue: [
		^super @ (Smalltalk nativeObjectAt: nativeObject ifAbsent: [])
	].
	^super @ nativeObject""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"chunks",0
,smalltalk.__f__("""(self):
	#NativeHandle class>>#chunks
	return smalltalk.NativeReader.new() 
""","NativeHandle_class_chunks")
,"utilities","""chunks
	" Return a NativeReader to fileIn properties in new native object. "

	^NativeReader new""",nil)
smalltalk.bind(smalltalk.NativeHandle.__class__,"@>>","_at_gt_gt"
,smalltalk.__f__("""(self,nativeObject):
	#NativeHandle class>>#@>>
	__0__=smalltalk.newContext()
	def __blk1__():
		return __0__.result.description_(smalltalk.Number(5)) 
	def __blk2__():
		return smalltalk.String("nil") 
	__0__.result=nil
	__0__.result=self._at(nativeObject) 
	return smalltalk.if_true_false_(smalltalk.notNil_(__0__.result),smalltalk.blk(__blk1__,0),smalltalk.blk(__blk2__,0)) 
""","NativeHandle_class__at_gt_gt")
,"converting","""@>> nativeObject
	" Return the description of nativeObject. "

	| result |
	result := self @ nativeObject.
	^result notNil
		ifTrue: [ result description: 5 ]
		ifFalse: [ #nil ]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"keys",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#keys
	return self.propertyNames().sorted() 
""","NativeHandle_keys")
,"accessing","""keys
	" Return the sorted property names of the receiver. "

	^self propertyNames sorted""",nil)
smalltalk.bind(smalltalk.NativeHandle,"properties",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#properties
	def __blk1__(each):
		return smalltalk.Array.with_with_(each,smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(each)])) 
	return self.keys().collect_(smalltalk.blk(__blk1__,1)) 
""","NativeHandle_properties")
,"accessing","""properties
	" Return an array with property name and values. "

	^self keys collect: [:each|
		Array with: each with: handle[each]
	]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"propertiesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#NativeHandle>>#propertiesDo:
	def __blk1__(each):
		return aBlock.value_value_(each,smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(each)])) 
	self.propertyNames().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","NativeHandle_propertiesDo_")
,"iterating","""propertiesDo: aBlock
	" Evaluate aTwoArgumentBlock with each property (name & value) of the receiver. "

	self propertyNames do: [:each| aBlock value: each value: handle[each] ]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"description:",0
,smalltalk.__f__('''(self,level):
	#NativeHandle>>#description:
	__0__=smalltalk.newContext()
	def __blk1__(h):
		def __blk2__():
			def __blk3__():
				def __blk4__():
					return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("("),smalltalk.to_String(h).upTo_(smalltalk.String("{"))),smalltalk.String("{...})")) 
				def __blk5__():
					return smalltalk.printString_(h) 
				return smalltalk.if_true_false_(smalltalk.b_(self.typeOf_(h) is smalltalk.String("function")),smalltalk.blk(__blk4__,0),smalltalk.blk(__blk5__,0)) 
			def __blk6__():
				def __blk7__():
					def __blk8__():
						return (self).__class__._at(h).description_(level._minus(smalltalk.Number(1))) 
					def __blk9__():
						return self.toString_(h) 
					return smalltalk.if_true_false_(level._gt(smalltalk.Number(1)),smalltalk.blk(__blk8__,0),smalltalk.blk(__blk9__,0)) 
				def __blk10__(err):
					return smalltalk.String("???") 
				return smalltalk.blk(__blk7__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk10__,1)) 
			return smalltalk.if_true_false_(self.isObject_(h),smalltalk.blk(__blk3__,0),smalltalk.blk(__blk6__,0)) 
		return smalltalk.if_true_false_(smalltalk.isNil_(h),nil,smalltalk.blk(__blk2__,0)) 
	def __blk11__(key):
		__1__=smalltalk.newContext()
		def __blk12__():
			__1__.value=smalltalk.basic_at_(getattr(self,"@handle",nil),key)
			return __1__.value 
		def __blk13__(ex):
			__1__.value=smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("ERROR ACCESSING["),key),smalltalk.String("] ")),ex.description())
			return __1__.value 
		__1__.value=nil
		smalltalk.blk(__blk12__,0).on_do_(smalltalk.Exception,smalltalk.blk(__blk13__,1)) 
		return __1__.value 
	def __blk14__(total,each):
		return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(total,__0__.cr),each),smalltalk.String(": ")),__0__.text.value_(__0__.data.value_(each))),smalltalk.String(";")) 
	__0__.text=nil
	__0__.data=nil
	__0__.cr=nil
	__0__.text=smalltalk.blk(__blk1__,1) 
	__0__.data=smalltalk.blk(__blk11__,1) 
	__0__.cr=smalltalk.String("""
	""") 
	return smalltalk.object_comma_(smalltalk.object_comma_(self.propertyNames().sorted().inject_into_(smalltalk.String("{"),smalltalk.blk(__blk14__,2)),__0__.cr),smalltalk.String("}")) 
''',"NativeHandle_description_")
,"debugging","""description: level
	" Return the description of the receiver. "

	| text data cr | 
	text := [:h|
		h isNil ifFalse: [
			(self isObject: h) ifTrue: [
				(self typeOf: h) == #function
				ifTrue: [ $( ,(h toString upTo: ${) ,'{...})' ]
				ifFalse: [ h printString ]
			] ifFalse: [
				[ level > 1
					ifTrue: [ (self class @ h) description: level - 1 ]
					ifFalse: [ self toString: h ]
				] on: Exception do: [:err| '???' ]
			]
		]
	].
	data := [:key| | value |
		[ value := handle basicAt: key ] on: Exception do: [:ex|
			value := 'ERROR ACCESSING[',key,'] ' ,ex description
		]. value
	].
	cr := '
'.	^(self propertyNames sorted
		inject: ${ into: [:total :each| total ,cr
 			,each ,': '
			,(text value: (data value:each))
			,';' ]
		)	,cr ,$}""",nil)
smalltalk.bind(smalltalk.NativeHandle,"description",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#description
	return self.description_(smalltalk.Number(1)) 
""","NativeHandle_description")
,"debugging","""description
	" Return the description of the receiver. "

	^self description: 1""",nil)
smalltalk.bind(smalltalk.NativeHandle,"functionNames",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#functionNames
	def __blk1__(each):
		return smalltalk.b_(self.typeOf_(smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(each)])) is smalltalk.String("function")) 
	return self.propertyNames().select_(smalltalk.blk(__blk1__,1)) 
""","NativeHandle_functionNames")
,"accessing","""functionNames
	" Return the names of property of the receiver of type function. "

	^self propertyNames select: [:each| (self typeOf: handle[each]) == #function ]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"functions",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#functions
	def __blk1__(each):
		return smalltalk.Array.with_with_(each,smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(each)])) 
	return self.functionNames().collect_(smalltalk.blk(__blk1__,1)) 
""","NativeHandle_functions")
,"accessing","""functions
	" Return the functions of the receiver as a collection of tuples #(functionName aClosure). "

	^self functionNames collect: [:each| Array with: each with: handle[each] ]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"ownFunctionNames",0
,smalltalk.__f__("""(self):
	#NativeHandle>>#ownFunctionNames
	def __blk1__(each):
		return smalltalk.b_(self.typeOf_(smalltalk.asObject_(getattr(self,"@handle",nil)[smalltalk.handleOf(each)])) is smalltalk.String("function")) 
	return self.ownPropertyNames().select_(smalltalk.blk(__blk1__,1)) 
""","NativeHandle_ownFunctionNames")
,"accessing","""ownFunctionNames
	" Return the names of functions owned/implemented by the receiver. "

	^self ownPropertyNames select: [:each| (self typeOf: handle[each]) == #function ]""",nil)
smalltalk.bind(smalltalk.NativeHandle,"hasOwnProperty:",0
,smalltalk.__f__("""(self,aName):
	#NativeHandle>>#hasOwnProperty:
	return smalltalk.true if hasattr(getattr(self,"@handle"),aName) else smalltalk.false 
""","NativeHandle_hasOwnProperty_")
,"testing","""hasOwnProperty: aName
	" Return true if receiver own a property named aName. "

	^{''js'Object.prototype.hasOwnProperty.call(self["@handle"],aName)'}""",nil)
smalltalk.bind(smalltalk.NativeHandle,"delete:",0
,smalltalk.__f__("""(self,aName):
	#NativeHandle>>#delete:
	delattr(getattr(self,"@handle"),aName) 
	return self 
""","NativeHandle_delete_")
,"actions","""delete: aName
	" Delete the property named aName in the receiver. "

	{''js'delete self["@handle"][aName]'}""",nil)
smalltalk.bind(smalltalk.JS.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,language):
	#JS class>>#supportsLanguage:
	return smalltalk.isObject_equalTo_(language,smalltalk.String("js")) 
""","JS_class_supportsLanguage_")
,"instantiation","""supportsLanguage: language
	" Private - Return true if instances of the receiver implement native wrappers for language. "

	^language = #js""",nil)
smalltalk.bind(smalltalk.JS,"propertyNames",0
,smalltalk.__f__("""(self):
	#JS>>#propertyNames
	self.invalidMessage_(smalltalk.String("propertyNames")) 
	return self 
""","JS_propertyNames")
,"accessing","""propertyNames
	" Return the property names of the receiver. "

	{''js'return Object.keys(self.handle())'}""",nil)
smalltalk.bind(smalltalk.JS,"prototype",0
,smalltalk.__f__("""(self):
	#JS>>#prototype
	self.invalidMessage_(smalltalk.String("prototype")) 
	return self 
""","JS_prototype")
,"accessing","""prototype
	" Return the prototype of the receiver. "

	{''js'return smalltalk.JS._at(Object.getPrototypeOf(self["@handle"]))'}""",nil)
smalltalk.bind(smalltalk.JS,"functionNamesAndArguments",0
,smalltalk.__f__("""(self):
	#JS>>#functionNamesAndArguments
	__0__=smalltalk.newContext()
	def __blk1__(source):
		def __blk2__(_s8_rec):
			_s8_rec.upTo_(smalltalk.String("(")) 
			return _s8_rec.upTo_(smalltalk.String(")")) 
		def __blk3__(arg):
			return arg.trimBlanks() 
		return __blk2__(source).asArrayOfSubstringsSeparatedBy_(smalltalk.String(",")).collect_(smalltalk.blk(__blk3__,1)) 
	def __blk4__(tuple):
		return smalltalk.Array.with_with_(tuple.first(),__0__.argList.value_(smalltalk.to_String(tuple.last()).stream())) 
	__0__.argList=nil
	__0__.argList=smalltalk.blk(__blk1__,1) 
	return self.functions().collect_(smalltalk.blk(__blk4__,1)) 
""","JS_functionNamesAndArguments")
,"accessing","""functionNamesAndArguments
	" Return the functions of the receiver as a collection of tuples #(functionName argumentsArray). "

	| argList |
	argList := [:source|
		((source upTo: $(; upTo: $)) asArrayOfSubstringsSeparatedBy: $,)
			collect: [:arg| arg trimBlanks ]
	].
	^self functions collect: [:tuple| Array with: tuple first with: (argList value: tuple last toString stream) ]""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:enumerable:configurable:",0
,smalltalk.__f__("""(self,aName,aValue,writable,enumerable,configurable):
	#JS>>#defineProperty:value:writable:enumerable:configurable:
	return self.defineProperty_as_(aName,smalltalk.Array.with_with_with_with_(smalltalk.Array.with_with_(smalltalk.String("value"),aValue),smalltalk.Array.with_with_(smalltalk.String("writable"),writable),smalltalk.Array.with_with_(smalltalk.String("enumerable"),enumerable),smalltalk.Array.with_with_(smalltalk.String("configurable"),configurable))) 
""","JS_defineProperty_value_writable_enumerable_configurable_")
,"properties","""defineProperty: aName
	value: aValue
	writable: writable
	enumerable: enumerable
	configurable: configurable
	" Define the property named aName in the receiver. "

	^self defineProperty: aName as: ( Array
		with: (Array with: #value with: aValue)
		with: (Array with: #writable with: writable)
		with: (Array with: #enumerable with: enumerable)
		with: (Array with: #configurable with: configurable)
	)""",nil)
smalltalk.bind(smalltalk.JS,"defineAccessor:get:set:enumerable:configurable:",0
,smalltalk.__f__("""(self,aName,aBlock,oneArgumentBlock,enumerable,configurable):
	#JS>>#defineAccessor:get:set:enumerable:configurable:
	return self.defineProperty_as_(aName,smalltalk.Array.with_with_with_with_(smalltalk.Array.with_with_(smalltalk.String("get"),aBlock),smalltalk.Array.with_with_(smalltalk.String("set"),oneArgumentBlock),smalltalk.Array.with_with_(smalltalk.String("enumerable"),enumerable),smalltalk.Array.with_with_(smalltalk.String("configurable"),configurable))) 
""","JS_defineAccessor_get_set_enumerable_configurable_")
,"properties","""defineAccessor: aName
	get: aBlock
	set: oneArgumentBlock
	enumerable: enumerable
	configurable: configurable
	" Define the Accessor property named aName in the receiver. "

	^self defineProperty: aName as: ( Array
		with: (Array with: #get with: aBlock)
		with: (Array with: #set with: oneArgumentBlock)
		with: (Array with: #enumerable with: enumerable)
		with: (Array with: #configurable with: configurable)
	)""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:enumerable:",0
,smalltalk.__f__("""(self,aName,aValue,writable,enumerable):
	#JS>>#defineProperty:value:writable:enumerable:
	return self.defineProperty_as_(aName,smalltalk.Array.with_with_with_(smalltalk.Array.with_with_(smalltalk.String("value"),aValue),smalltalk.Array.with_with_(smalltalk.String("writable"),writable),smalltalk.Array.with_with_(smalltalk.String("enumerable"),enumerable))) 
""","JS_defineProperty_value_writable_enumerable_")
,"properties","""defineProperty: aName
	value: aValue
	writable: writable
	enumerable: enumerable
	" Define the property named aName in the receiver. "

	^self defineProperty: aName as: ( Array
		with: (Array with: #value with: aValue)
		with: (Array with: #writable with: writable)
		with: (Array with: #enumerable with: enumerable)
	)""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:value:writable:",0
,smalltalk.__f__("""(self,aName,aValue,writable):
	#JS>>#defineProperty:value:writable:
	return self.defineProperty_as_(aName,smalltalk.Array.with_with_(smalltalk.Array.with_with_(smalltalk.String("value"),aValue),smalltalk.Array.with_with_(smalltalk.String("writable"),writable))) 
""","JS_defineProperty_value_writable_")
,"properties","""defineProperty: aName
	value: aValue
	writable: writable
	" Define the property named aName in the receiver. "

	^self defineProperty: aName as: ( Array
		with: (Array with: #value with: aValue)
		with: (Array with: #writable with: writable)
	)""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:value:",0
,smalltalk.__f__("""(self,aName,aValue):
	#JS>>#defineProperty:value:
	return self.defineProperty_as_(aName,smalltalk.Array.with_(smalltalk.Array.with_with_(smalltalk.String("value"),aValue))) 
""","JS_defineProperty_value_")
,"properties","""defineProperty: aName value: aValue
	" Define the property named aName in the receiver. "

	^self defineProperty: aName as: ( Array
		with: (Array with: #value with: aValue)
	)""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:",0
,smalltalk.__f__("""(self,aName):
	#JS>>#defineProperty:
	return self.defineProperty_as_(aName,smalltalk.Object.new()) 
""","JS_defineProperty_")
,"properties","""defineProperty: aName
	" Define the property named aName in the receiver. "

	^self defineProperty: aName as: Object new""",nil)
smalltalk.bind(smalltalk.JS,"defineProperty:as:",0
,smalltalk.__f__("""(self,aName,descriptor):
	#JS>>#defineProperty:as:
	if smalltalk.b(descriptor.isArray()):
		def __blk1__(result,tuple):
			if smalltalk.b(smalltalk.notNil_(tuple.last())):
				smalltalk.basic_at_put_(result,tuple.first(),tuple.last()) 
			 
			return result 
		return self.defineProperty_as_(aName,descriptor.inject_into_(smalltalk.Object.new(),smalltalk.blk(__blk1__,2))) 
	 
	self.invalidMessage_(smalltalk.String("defineProperty:as:")) 
	return self 
""","JS_defineProperty_as_")
,"properties","""defineProperty: aName as: descriptor
	" Define the property named aName in the receiver. "

	descriptor isArray ifTrue: [
		^self defineProperty: aName as: (descriptor
			inject: Object new into: [:result :tuple|
				tuple last notNil ifTrue: [
					result basicAt: tuple first put: tuple last
				].
				result
			])
	].

	{''js'return Object.defineProperty(self["@handle"],aName,descriptor)'}""",nil)
smalltalk.bind(smalltalk.JS,"defineProperties:",0
,smalltalk.__f__("""(self,descriptors):
	#JS>>#defineProperties:
	self.invalidMessage_(smalltalk.String("defineProperties:")) 
	return self 
""","JS_defineProperties_")
,"properties","""defineProperties: descriptors
	" Define the properties in the receiver. "

	{''js'return Object.defineProperties(self["@handle"],descriptors)'}""",nil)
smalltalk.bind(smalltalk.JS,"preventExtensions",0
,smalltalk.__f__("""(self):
	#JS>>#preventExtensions
	self.invalidMessage_(smalltalk.String("preventExtensions")) 
	return self 
""","JS_preventExtensions")
,"actions","""preventExtensions
	" Set the receiver as non-extensible. "

	{''js'return Object.preventExtensions(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"freeze",0
,smalltalk.__f__("""(self):
	#JS>>#freeze
	self.invalidMessage_(smalltalk.String("freeze")) 
	return self 
""","JS_freeze")
,"actions","""freeze
	" Prevents the modification of existing property attributes and values, and prevents the addition of new properties. "

	{''js'return Object.freeze(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"seal",0
,smalltalk.__f__("""(self):
	#JS>>#seal
	self.invalidMessage_(smalltalk.String("seal")) 
	return self 
""","JS_seal")
,"actions","""seal
	" Prevents the modification of attributes of existing properties, and prevents the addition of new properties. "

	{''js'return Object.seal(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"isExtensible",0
,smalltalk.__f__("""(self):
	#JS>>#isExtensible
	self.invalidMessage_(smalltalk.String("isExtensible")) 
	return self 
""","JS_isExtensible")
,"testing","""isExtensible
	" Return true if the receiver is extensible. "

	{''js'return Object.isExtensible(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"isFrozen",0
,smalltalk.__f__("""(self):
	#JS>>#isFrozen
	self.invalidMessage_(smalltalk.String("isFrozen")) 
	return self 
""","JS_isFrozen")
,"testing","""isFrozen
	" Return true if the receiver is frozen. "

	{''js'return Object.isFrozen(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"isSealed",0
,smalltalk.__f__("""(self):
	#JS>>#isSealed
	self.invalidMessage_(smalltalk.String("isSealed")) 
	return self 
""","JS_isSealed")
,"testing","""isSealed
	" Return true if the receiver is sealed. "

	{''js'return Object.isSealed(self["@handle"])'}""",nil)
smalltalk.bind(smalltalk.JS,"create:with:",0
,smalltalk.__f__("""(self,prototype,descriptors):
	#JS>>#create:with:
	self.invalidMessage_(smalltalk.String("create:with:")) 
	return self 
""","JS_create_with_")
,"creation","""create: prototype with: descriptors
	" Return a JS object that has been created with the specified prototype, and that optionally contains specified properties. "

	{''js'return smalltalk.JS._at(Object.create(prototype,descriptors))'}""",nil)
smalltalk.bind(smalltalk.JS,"createWith:",0
,smalltalk.__f__("""(self,descriptors):
	#JS>>#createWith:
	return self.create_with_(getattr(self,"@handle",nil),descriptors) 
""","JS_createWith_")
,"creation","""createWith: descriptors
	" Return a JS object that has been created with the handle prototype, and that optionally contains specified properties. "

	^self create: handle with: descriptors""",nil)
smalltalk.bind(smalltalk.Python.__class__,"supportsLanguage:",0
,smalltalk.__f__("""(self,language):
	#Python class>>#supportsLanguage:
	return smalltalk.isObject_equalTo_(language,smalltalk.String("py")) 
""","Python_class_supportsLanguage_")
,"instantiation","""supportsLanguage: language
	" Private - Return true if instances of the receiver implement native wrappers for language. "

	^language = #py""",nil)
smalltalk.bind(smalltalk.Python.__class__,"global","_8global"
,smalltalk.__f__("""(self):
	#Python class>>#global
	return self._at(smalltalk.Smalltalk._8global()) 
""","Python_class__8global")
,"accessing","""global
	" Return an instance wrapping global. "

	^self @ Smalltalk global""",nil)
smalltalk.bind(smalltalk.Python.__class__,"version",0
,smalltalk.__f__("""(self):
	#Python class>>#version
	return self._8global()._at(smalltalk.String("_VERSION")) 
""","Python_class_version")
,"accessing","""version
	" Return the host version. "

	^self global @ #_VERSION""",nil)
smalltalk.bind(smalltalk.Python.__class__,"arg",0
,smalltalk.__f__("""(self):
	#Python class>>#arg
	return smalltalk.Array._at(self._8global()._at(smalltalk.String("arg"))) 
""","Python_class_arg")
,"accessing","""arg
	" Return the main arguments (anArray of strings). "

	^Array @ (self global @ #arg)""",nil)
smalltalk.bind(smalltalk.Python.__class__,"require:",0
,smalltalk.__f__("""(self,aName):
	#Python class>>#require:
	return self._at(require(aName)) 
""","Python_class_require_")
,"modules","""require: aName
	" Return an instance of the receiver obtained from loading module aName. (or nil) "

	^self @ (# #require: aName)""",nil)
smalltalk.bind(smalltalk.Python,"propertyNames",0
,smalltalk.__f__("""(self):
	#Python>>#propertyNames
	return self.ownPropertyNames() 
""","Python_propertyNames")
,"accessing","""propertyNames
	" Return the property names of the receiver. "

	^self ownPropertyNames""",nil)
smalltalk.bind(smalltalk.Python,"do:",0
,smalltalk.__f__("""(self,aBlock):
	#Python>>#do:
	for item in self.handle():
		aBlock(item)
	 
	return self 
""","Python_do_")
,"iteration","""do: aBlock
	" Evaluates aBlock on each element of the receiver. "

{'' js'	self.invalidMessage_("do:")'
py'	for item in self.handle():%>%aBlock(item)%<%'}.""",nil)
smalltalk.bind(smalltalk.Python,"pairsDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Python>>#pairsDo:
	h = self.handle()
	for k in dir(h):
		aBlock(k,getattr(h,k))
	 
	return self 
""","Python_pairsDo_")
,"iteration","""pairsDo: aBlock
	" Evaluates aBlock on each key/value pair of the receiver. "

{'' js'	self.invalidMessage_("pairsDo:")'
py'	h = self.handle()%cr%for k in dir(h):%>%aBlock(k,getattr(h,k))%<%'}.""",nil)
smalltalk.bind(smalltalk.Python,"keysDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Python>>#keysDo:
	for k in dir(self.handle()):
		aBlock(smalltalk.String(k))
	 
	return self 
""","Python_keysDo_")
,"iteration","""keysDo: aBlock
	" Evaluates aBlock on each key of the receiver. "

{'' js'	self.invalidMessage_("keysDo:")'
py'	for k in dir(self.handle()):%>%aBlock(%String%(k))%<%'}.""",nil)
smalltalk.bind(smalltalk.Python,"valuesDo:",0
,smalltalk.__f__("""(self,aBlock):
	#Python>>#valuesDo:
	h = self.handle()
	for k in dir(h):
		aBlock(getattr(h,k))
	 
	return self 
""","Python_valuesDo_")
,"iteration","""valuesDo: aBlock
	" Evaluates aBlock on each value of the receiver. "

{'' js'	self.invalidMessage_("valuesDo:")'
py'	h = self.handle()%cr%for k in dir(h):%>%aBlock(getattr(h,k))%<%'}.""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"globalName",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#globalName
	return self.subclassResponsibility_(smalltalk.String("globalName")) 
""","NativeLibraryObject_class_globalName")
,"private","""globalName
	" Private - Return the name of the global to detect/access the library of the receiver. "

	^self subclassResponsibility: #globalName""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"topGlobal",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#topGlobal
	def __blk1__():
		return self.error_(smalltalk.String("Missing window support")) 
	return smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(smalltalk.String("window"),smalltalk.blk(__blk1__,0)) 
""","NativeLibraryObject_class_topGlobal")
,"private","""topGlobal
	" Private - Return the object to access the global during detection stage.
	The default implementation return window global (present when running in a web browser).
	This method must be refined by the subclasses requiring other root dependences.
	Can return nil to do not check dependents.
	"

	^Smalltalk nativeObjectAt: #window ifAbsent: [ self error: 'Missing window support' ].""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"requiredFeatures",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#requiredFeatures
	return smalltalk.newArray([]) 
""","NativeLibraryObject_class_requiredFeatures")
,"private","""requiredFeatures
	" Private - Return the names of the required properties/features to execute the receiver.
	The default implementation do not check dependents.
	This method can be refined by subclasses to ensure features to run the receiver are present in this system.
	"

	^#()""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"classNamed:",0
,smalltalk.__f__("""(self,className):
	#NativeLibraryObject class>>#classNamed:
	__0__=smalltalk.newContext()
	__0__.library=nil
	__0__.library=self.library() 
	return smalltalk.asObject_(__0__.library[smalltalk.handleOf(className)]) 
""","NativeLibraryObject_class_classNamed_")
,"private","""classNamed: className
	" Private - Return the class named className in the receiver's library.
	The default implementation get the class from library.
	Subclasses can refine to obtain classes from anywhere
		e.g. global scope with: ^self global: className.
	"

	| library |
	library := self library.
	^library[className]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"sourceCode",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#sourceCode
	return self.subclassResponsibility_(smalltalk.String("sourceCode")) 
""","NativeLibraryObject_class_sourceCode")
,"private","""sourceCode
	" Private - Return the (native) source code of the library as a String.
	This method can be implemented by subclasses loading sources from external media or simply returning aString embedded in this method.
	A reference/link to source origin is appreciated by users.
	CAUTION: S8 is MIT, so you MUST embedd here MIT compatible sources.
	"

	^self subclassResponsibility: #sourceCode""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryBound:",0
,smalltalk.__f__("""(self,aClassName):
	#NativeLibraryObject class>>#libraryBound:
	def __blk1__(each):
		return each.libraryBound_(aClassName) 
	self.bindingListeners().do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","NativeLibraryObject_class_libraryBound_")
,"binding","""libraryBound: aClassName
	" Private - The library of aClassName has just been bound to this system. "

	self bindingListeners do: [:each| each libraryBound: aClassName ]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"bindingListeners",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#bindingListeners
	if smalltalk.b(smalltalk.isNil_(smalltalk.NativeLibraryObject.classVariableAt_("BindingListeners"))):
		smalltalk.NativeLibraryObject.classVariableAt_put_("BindingListeners",smalltalk.Array.new()) 
	 
	return smalltalk.NativeLibraryObject.classVariableAt_("BindingListeners") 
""","NativeLibraryObject_class_bindingListeners")
,"binding","""bindingListeners
	" Private - Return the collection of listeners to library binding notifications of this system. "

	BindingListeners isNil ifTrue: [ BindingListeners := Array new ].
	^BindingListeners""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"globalName:",0
,smalltalk.__f__("""(self,aName):
	#NativeLibraryObject class>>#globalName:
	return (self).__class__.implement_comment_as_category_(smalltalk.String("globalName"),smalltalk.String("Private - Return the name of the global to detect/access the library of the receiver."),smalltalk.object_comma_(smalltalk.String("^"),smalltalk.printString_(aName)),smalltalk.String("private")) 
""","NativeLibraryObject_class_globalName_")
,"builder","""globalName: aName
	" Generate code to return the name of the global to detect/access the library of the receiver. "

	^self class
		implement: #globalName
		comment: 'Private - Return the name of the global to detect/access the library of the receiver.'
		as: '^' ,aName printString
		category: #private""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryURL:",0
,smalltalk.__f__("""(self,anURL):
	#NativeLibraryObject class>>#libraryURL:
	return (self).__class__.implement_comment_as_category_(smalltalk.String("libraryURL"),smalltalk.String("Private - Return the URL to use when loading library of the receiver."),smalltalk.object_comma_(smalltalk.String("^"),smalltalk.printString_(anURL)),smalltalk.String("private")) 
""","NativeLibraryObject_class_libraryURL_")
,"builder","""libraryURL: anURL
	" Generate the method to return libraryURL. "

	^self class
		implement: #libraryURL
		comment: 'Private - Return the URL to use when loading library of the receiver.'
		as: '^' ,anURL printString
		category: #private""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"globalClassNameFrom:",0
,smalltalk.__f__("""(self,globalClassName):
	#NativeLibraryObject class>>#globalClassNameFrom:
	return globalClassName 
""","NativeLibraryObject_class_globalClassNameFrom_")
,"private","""globalClassNameFrom: globalClassName
	" Private - Return the global class name for global globalClassName.
	It must return the (global) name of the constructor used to instantiate instance handles.
	The default action is to return the globalClassName.
	This method can be refined by subclasses to adapt name to (case sensitive) library constructor names.
	"

	^globalClassName""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"selectorForConstantNamed:",0
,smalltalk.__f__("""(self,aName):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeLibraryObject class>>#selectorForConstantNamed:
		def __blk1__(c):
			return c.isLowercase() 
		def __blk2__():
			return smalltalk.raise_result_(_s8Ret_,aName.asLowercase().asSmalltalkName_(smalltalk.false)) 
		aName.detect_ifNone_(smalltalk.blk(__blk1__,1),smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,aName.asSmalltalkName_(smalltalk.false)) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeLibraryObject_class_selectorForConstantNamed_")
,"builder","""selectorForConstantNamed: aName
	" Private - Return the selector to use for constant aName. "

	aName detect: [:c| c isLowercase ] ifNone: [
		^aName asLowercase asSmalltalkName: false
	].
	^aName asSmalltalkName: false""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"constants:",0
,smalltalk.__f__("""(self,names):
	#NativeLibraryObject class>>#constants:
	def __blk1__(each):
		return (self).__class__.implement_comment_as_category_(self.selectorForConstantNamed_(each),smalltalk.object_comma_(smalltalk.String("Return the value of "),each),smalltalk.object_comma_(smalltalk.String("^self library basicAt: #"),each),smalltalk.String("accessing")) 
	names.do_(smalltalk.blk(__blk1__,1)) 
	return self 
""","NativeLibraryObject_class_constants_")
,"builder","""constants: names
	" Private - Build methods to access library globals. "

	names do: [:each|
		self class
			implement: (self selectorForConstantNamed: each)
			comment: 'Return the value of ',each
			as: '^self library basicAt: #',each
			category: #accessing
	].""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"buildSubclass:arguments:typed:",0
,smalltalk.__f__("""(self,globalClassName,argList,typedArguments):
	#NativeLibraryObject class>>#buildSubclass:arguments:typed:
	__0__=smalltalk.newContext()
	def __blk1__():
		return smalltalk.isObject_equalTo_(argList,smalltalk.String("nil")) 
	__0__.cls=nil
	__0__.clsName=nil
	__0__.clsName=smalltalk.object_comma_(globalClassName.first().asUppercase(),globalClassName.copyFrom_to_(smalltalk.Number(2),globalClassName.size())) 
	__0__.clsName=smalltalk.object_comma_(self.classToken(),__0__.clsName) 
	self.subclass_instanceVariableNames_category_(__0__.clsName,smalltalk.String(""),self.category()) 
	if smalltalk.b(smalltalk.boolean_or_(smalltalk.isNil_(argList),smalltalk.blk(__blk1__,0))):
		return self 
	 
	__0__.cls=smalltalk.Smalltalk.at_(__0__.clsName) 
	(__0__.cls).__class__.implement_comment_as_category_(smalltalk.String("globalClassName"),smalltalk.String("Private - Return the internal class name."),smalltalk.object_comma_(smalltalk.String("^self globalClassNameFrom: #"),globalClassName),smalltalk.String("private")) 
	if smalltalk.b(argList.isEmpty()):
		__0__.cls.implement_comment_as_category_(smalltalk.String("initializeHandle"),smalltalk.String("Private - Initialize the receiver's handle."),smalltalk.String("self handle: (self newHandleOf: self class globalClassName)"),smalltalk.String("initialize")) 
	else:
		__1__=smalltalk.newContext()
		def __blk2__(total,each):
			return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(total,each),smalltalk.String(": ")),each),smalltalk.String(" ")) 
		def __blk3__(total,each):
			def __blk4__():
				return typedArguments.includes_(each) 
			if smalltalk.b(smalltalk.boolean_or_(smalltalk.isObject_equalTo_(typedArguments,smalltalk.String("all")),smalltalk.blk(__blk4__,0))):
				__1__.current=smalltalk.String(" handle ") 
			else:
				__1__.current=smalltalk.String(" ") 
			 
			return smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.object_comma_(total,smalltalk.String("with: ")),each),__1__.current) 
		__1__.selector=nil
		__1__.args=nil
		__1__.current=nil
		__1__.selector=argList.inject_into_(smalltalk.String(""),smalltalk.blk(__blk2__,2)) 
		__1__.args=argList.inject_into_(smalltalk.String(""),smalltalk.blk(__blk3__,2)) 
		(__0__.cls).__class__.implement_comment_as_category_(__1__.selector,smalltalk.String("Return an instance of the receiver."),smalltalk.object_comma_(smalltalk.String("^self basicNew "),__1__.selector),smalltalk.String("instantiation")) 
		__0__.cls.implement_comment_as_category_(__1__.selector,smalltalk.String("Private - Initialize the receiver."),smalltalk.object_comma_(smalltalk.object_comma_(smalltalk.String("self handle: (self newHandleOf: self class globalClassName "),__1__.args),smalltalk.String(")")),smalltalk.String("initialize")) 
	 
	return self 
""","NativeLibraryObject_class_buildSubclass_arguments_typed_")
,"builder","""buildSubclass: globalClassName arguments: argList typed: typedArguments
	" Private - Build a subclass of the receiver implementing a wrapper to the library. "

	| cls clsName |
	clsName := globalClassName first asUppercase
			,(globalClassName copyFrom: 2 to: globalClassName size).
	clsName := self classToken ,clsName.
	self
		subclass: clsName
		instanceVariableNames: ''
		category: self category.
	(argList isNil or: [ argList = #nil ]) ifTrue: [ ^self ].

	cls := Smalltalk at: clsName.
	cls class
		implement: #globalClassName
		comment: 'Private - Return the internal class name.'
		as: '^self globalClassNameFrom: #' ,globalClassName
		category: #private.
	argList isEmpty ifTrue: [
		cls
			implement: #initializeHandle
			comment: 'Private - Initialize the receiver''s handle.'
			as: 'self handle: (self newHandleOf: self class globalClassName)'
			category: #initialize.
	] ifFalse: [ | selector args current |
		selector := argList inject: '' into: [:total :each| total ,each,': ',each,' ' ].
		args := argList inject: '' into: [:total :each|
			(typedArguments = #all
			  or: [ typedArguments includes: each ])
			  ifTrue: [ current := ' handle ' ]
			  ifFalse: [ current := ' ' ].
			total ,'with: ',each, current
		].
		cls class
			implement: selector
			comment: 'Return an instance of the receiver.'
			as: '^self basicNew ',selector
			category: #instantiation.
		cls
			implement: selector
			comment: 'Private - Initialize the receiver.'
			as: 'self handle: (self newHandleOf: self class globalClassName ' ,args ,')'
			category: #initialize.
	].""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"global:",0
,smalltalk.__f__("""(self,globalName):
	#NativeLibraryObject class>>#global:
	__0__=smalltalk.newContext()
	def __blk1__():
		return nil 
	def __blk2__():
		return nil 
	__0__.result=nil
	__0__.result=smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(globalName,smalltalk.blk(__blk1__,0)) 
	if smalltalk.b(smalltalk.notNil_(__0__.result)):
		return __0__.result 
	 
	if not smalltalk.b(self.isValid()):
		return nil 
	 
	self.libraryLoaded_(self.loadLibrary()) 
	return smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(globalName,smalltalk.blk(__blk2__,0)) 
""","NativeLibraryObject_class_global_")
,"accessing","""global: globalName
	" Private - Return the native library global object (or nil). "

	| result |
	result := Smalltalk nativeObjectAt: globalName ifAbsent: [ nil ].
	result notNil ifTrue: [ ^result ].
	self isValid ifFalse: [ ^nil ].
	self libraryLoaded: self loadLibrary.
	^Smalltalk nativeObjectAt: globalName ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"library",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#library
	return self.global_(self.globalName()) 
""","NativeLibraryObject_class_library")
,"validation","""library
	" Check support to run this framework and try to load the library implementation.
	Return the native library object if success.
	"

	^self global: self globalName""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryOrNil",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#libraryOrNil
	def __blk1__():
		return nil 
	return smalltalk.Smalltalk.nativeObjectAt_ifAbsent_(self.globalName(),smalltalk.blk(__blk1__,0)) 
""","NativeLibraryObject_class_libraryOrNil")
,"validation","""libraryOrNil
	" Quick Check - Return true if the library is already bound. "

	^Smalltalk nativeObjectAt: self globalName ifAbsent: [ nil ]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"nativeClass",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#nativeClass
	return smalltalk.NativeHandle._at(self.library()) 
""","NativeLibraryObject_class_nativeClass")
,"private","""nativeClass
	" Private - Return the wrapper for native binding of the receiver.
	The default result is a NativeHandle instance wrapping the receiver's library,
	 so static(class side) builders generate bindings accessing receiver's library.
	"

	^NativeHandle @ self library""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryURLs",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#libraryURLs
	def __blk1__(each):
		return smalltalk.notNil_(each) 
	return smalltalk.Array.with_(self.libraryURL()).select_(smalltalk.blk(__blk1__,1)) 
""","NativeLibraryObject_class_libraryURLs")
,"private","""libraryURLs
	" Private - Return a collection of URL to load library of the receiver.
	Return an empty collection, the subclasses can complement addresses to load library from external resources.
	"

	^(Array with: self libraryURL) select: [:each| each notNil ]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryURL",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#libraryURL
	return nil 
""","NativeLibraryObject_class_libraryURL")
,"private","""libraryURL
	" Private - Return the URL to use when loading library of the receiver.
	Default implementation do not provide support to load library.
	"

	^nil""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"basicLoad:",0
,smalltalk.__f__("""(self,url):
	#NativeLibraryObject class>>#basicLoad:
	require(url) 
	return self 
""","NativeLibraryObject_class_basicLoad_")
,"loading","""basicLoad: url
	" Private - Try to load the library at url. "

	{''js'load(url)'}""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"onLoad:",0
,smalltalk.__f__("""(self,aBlock):
	_s8Ret_=smalltalk.newContext()
	try:
		#NativeLibraryObject class>>#onLoad:
		__0__=smalltalk.newContext()
		def __blk1__():
			smalltalk.NativeLibraryObject.libraryBound_(self.name()) 
			return aBlock.value_(self.library()) 
		def __blk2__():
			def __blk3__(each):
				return self.basicLoad_(each) 
			self.libraryURLs().do_(smalltalk.blk(__blk3__,1)) 
			return smalltalk.raise_result_(_s8Ret_,__0__.success.value()) 
		def __blk4__():
			return __0__.success.value() 
		__0__.dom=nil
		__0__.success=nil
		if smalltalk.b(smalltalk.notNil_(self.libraryOrNil())):
			smalltalk.raise_result_(_s8Ret_,aBlock.value_(self.library())) 
		 
		__0__.success=smalltalk.blk(__blk1__,0) 
		__0__.dom=smalltalk.Smalltalk.at_ifAbsent_(smalltalk.String("DOM"),smalltalk.blk(__blk2__,0)) 
		smalltalk.raise_result_(_s8Ret_,__0__.dom.document().loadAll_onLoad_(self.libraryURLs(),smalltalk.blk(__blk4__,0))) 
	except Exception as __ex:
		if smalltalk.exception_at(__ex,_s8Ret_):
			return smalltalk.exceptionResult_(__ex)
		raise __ex
	
""","NativeLibraryObject_class_onLoad_")
,"private","""onLoad: aBlock
	" Private - Load the library of the receiver and evaluates aBlock. "

	| dom success |
	self libraryOrNil notNil ifTrue: [ ^aBlock value: self library ].
	success := [
		NativeLibraryObject libraryBound: self name.
		aBlock value: self library
	].
	dom := Smalltalk at: #DOM ifAbsent: [
		self libraryURLs do: [:each| self basicLoad: each ].
		^success value
	].
	^dom document
		loadAll: self libraryURLs
		onLoad: [ success value ]""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"loadLibrary",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#loadLibrary
	if smalltalk.b(self.libraryURLs().notEmpty()):
		def __blk1__(ignored):
			nil 
		return self.onLoad_(smalltalk.blk(__blk1__,1)) 
	 
	return smalltalk.Smalltalk.current().eval_as_(self.sourceCode(),smalltalk.Array.with_with_(smalltalk.String("loadLibrary"),self.name())) 
""","NativeLibraryObject_class_loadLibrary")
,"private","""loadLibrary
	" Private - Load the library of the receiver.
	Default implementation load the library from remote URL or sourceCode.
	"

	self libraryURLs notEmpty ifTrue: [ ^self onLoad: [:ignored| ] ].
	^Smalltalk current
		eval: self sourceCode
		as: (Array with: #loadLibrary with: self name)""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"libraryLoaded:",0
,smalltalk.__f__("""(self,loadResult):
	#NativeLibraryObject class>>#libraryLoaded:
	return self 
""","NativeLibraryObject_class_libraryLoaded_")
,"private","""libraryLoaded: loadResult
	" Private - The library of the receiver has been loaded.
	Default implementation do nothing.
	This method can be refined by subclasses to perform postLoading actions.
	The loadResult argument is the result of the just evaluated load process.
	\"""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject.__class__,"isValid",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject class>>#isValid
	__0__=smalltalk.newContext()
	def __blk1__(each):
		def __blk2__():
			return self.error_(smalltalk.object_comma_(smalltalk.String("Missing support for "),each)) 
		return smalltalk.if_true_false_(smalltalk.isNil_(smalltalk.asObject_(__0__._8global[smalltalk.handleOf(each)])),smalltalk.blk(__blk2__,0),nil) 
	__0__._8global=nil
	__0__._8global=self.topGlobal() 
	if smalltalk.b(smalltalk.isNil_(__0__._8global)):
		return smalltalk.true 
	 
	self.requiredFeatures().do_(smalltalk.blk(__blk1__,1)) 
	return smalltalk.true 
""","NativeLibraryObject_class_isValid")
,"validation","""isValid
	" Return true if the receiver is valid in this (browser) context.
	Generate error if the minimum support to run the library is not available.
	"

	| global |
	global := self topGlobal.
	global isNil ifTrue: [ ^true ]. "always valid"
	self requiredFeatures do: [:each|
	  global[each] isNil ifTrue: [
	    self error: 'Missing support for ',each
	  ].
	].
	^true""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"library",0
,smalltalk.__f__("""(self):
	#NativeLibraryObject>>#library
	return (self).__class__.library() 
""","NativeLibraryObject_library")
,"private","""library
	" Private - Return the library of the receiver. "

	^self class library""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"classNamed:",0
,smalltalk.__f__("""(self,className):
	#NativeLibraryObject>>#classNamed:
	return (self).__class__.classNamed_(className) 
""","NativeLibraryObject_classNamed_")
,"private","""classNamed: className
	" Private - Return the class named className in the receiver's library. "

	^self class classNamed: className""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:",0
,smalltalk.__f__("""(self,className):
	#NativeLibraryObject>>#newHandleOf:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor() 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_")
,"private","""newHandleOf: className
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor()'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:",0
,smalltalk.__f__("""(self,className,arg1):
	#NativeLibraryObject>>#newHandleOf:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_")
,"private","""newHandleOf: className with: arg1
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2):
	#NativeLibraryObject>>#newHandleOf:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3):
	#NativeLibraryObject>>#newHandleOf:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3,arg4):
	#NativeLibraryObject>>#newHandleOf:with:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3,arg4) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3,arg4)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3,arg4,arg5):
	#NativeLibraryObject>>#newHandleOf:with:with:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3,arg4,arg5) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3,arg4,arg5,arg6):
	#NativeLibraryObject>>#newHandleOf:with:with:with:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7):
	#NativeLibraryObject>>#newHandleOf:with:with:with:with:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_with_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)'}.
	^result""",nil)
smalltalk.bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:with:",0
,smalltalk.__f__("""(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8):
	#NativeLibraryObject>>#newHandleOf:with:with:with:with:with:with:with:with:
	__0__=smalltalk.newContext()
	__0__.result=nil
	__0__.aConstructor=nil
	__0__.aConstructor=self.classNamed_(className) 
	result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8) 
	return __0__.result 
""","NativeLibraryObject_newHandleOf_with_with_with_with_with_with_with_with_")
,"private","""newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8
	" Private - Return a new instance of the class named className in the receiver's library. "

	| result aConstructor |
	aConstructor := self classNamed: className.
	{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)'}.
	^result""",nil)
smalltalk.bind(smalltalk.Json.__class__,"parse:",0
,smalltalk.__f__("""(self,string):
	#Json class>>#parse:
	return self.new().decode_(string) 
""","Json_class_parse_")
,"converting","""parse: string
	^self new decode: string""",nil)
smalltalk.bind(smalltalk.Json.__class__,"stringify:",0
,smalltalk.__f__("""(self,aNative):
	#Json class>>#stringify:
	return self.new().encode_(aNative) 
""","Json_class_stringify_")
,"converting","""stringify: aNative
	^self new encode: aNative""",nil)
smalltalk.bind(smalltalk.Json,"decode:",0
,smalltalk.__f__("""(self,string):
	#Json>>#decode:
	if True:
		import json
		s = smalltalk.handleOf(string)
		h = json.loads(s)
		return smalltalk.PoolDictionary._at_at(h) 
	return self.notImplementedYet_(smalltalk.String("decode:")) 
""","Json_decode_")
,"converting","""decode: string

	"self note: 'Json decoding ' ,string."
	{''py'if True:
	import json
	s = smalltalk.handleOf(string)
	h = json.loads(s)
	return smalltalk.PoolDictionary._at_at(h)'}.
	^self notImplementedYet: #decode: """,nil)
smalltalk.bind(smalltalk.Json,"encode:",0
,smalltalk.__f__("""(self,aNative):
	#Json>>#encode:
	if True:
		import json
		h = aNative.handle()
		return json.dumps(h) 
	return self.notImplementedYet_(smalltalk.String("encode:")) 
""","Json_encode_")
,"converting","""encode: aNative

	"self note: 'Json encoding ' ,aNative."
	{''py'if True:
	import json
	h = aNative.handle()
	return json.dumps(h)'}.
	^self notImplementedYet: #encode: """,nil)
